angular.module("accountController", ["ionic", "services", "tools"]).controller("AccountMainCtrl", ["$scope", "Tools", "ServerConfig", "$window", "wechatShare", "ServerType", function(exports, _, dataAndEvents, ignoreMethodDoesntExist, deepDataAndEvents, textAlt) {
  /** @type {boolean} */
  exports.isEx = false;
  if (textAlt.isEX()) {
    /** @type {boolean} */
    exports.isEx = true;
  }
  /**
   * @return {undefined}
   */
  exports.updateApp = function() {
    window.plugins.updateApp.getCurrentVerInfo(function(fmt) {
      console.log(fmt);
      window.plugins.updateApp.getServerVerInfo(function(body) {
        console.log(body);
        if (_.versionCompare(body, fmt, true) > 0) {
          window.plugins.updateApp.checkAndUpdate(dataAndEvents.versionServer);
        } else {
          _.appHotUpdate(true);
        }
      }, function() {
        _.toastShow("服务器获取数据出现异常！");
      }, dataAndEvents.versionServer);
    });
  };
  /**
   * @return {undefined}
   */
  exports.gotoAppStore = function() {
    if (window.cordova) {
      if (window.cordova.plugins) {
        _.showConfirm("跳转到App Store给我们鼓励吗?", function(dataAndEvents) {
          if (2 === dataAndEvents) {
            exports.openLink("itms-apps://itunes.apple.com/cn/app/xxxxxxxxxxxxxxxxxxx/id0000000000000");
          }
        }, "给个好评", ["忽略", "值得鼓励"]);
      }
    }
  };
  /**
   * @return {undefined}
   */
  exports.shareApp = function() {
    deepDataAndEvents.shareUrlToSession("http://app.xinbafar.com.cn:8080/business/m/index.html", "辛巴手机版，把生意装进手机里！", "永久免费，手机、平板、电脑全平台支持，生意高效运转，彻底告别糊涂账！", null);
  };
}]).controller("FeedbackCtrl", ["$scope", "$state", "Tools", "lbSpinnerDialog", "psisServices", function(options, $state, domAttr, loading, args) {
  options.feedbackData = {};
  /**
   * @return {?}
   */
  options.saveFeedback = function() {
    return options.feedbackData.KEY290 ? (loading.show(true), void args.postEncode("/KEY256", options.feedbackData).success(function(r) {
      if (1 === r.statusCode) {
        domAttr.toastShow("意见反馈成功，谢谢您,我们会继续努力！");
        options.goBack();
      } else {
        domAttr.toastShow("意见反馈异常！");
      }
    }).finally(function() {
      loading.hide();
    })) : void domAttr.toastShow("请输入您的意见！", "short", "center");
  };
  /**
   * @return {undefined}
   */
  options.goToList = function() {
    $state.go("eventmenu.KEY224");
  };
}]).controller("FeedbackListCtrl", ["$scope", "$state", "Tools", "lbSpinnerDialog", "psisServices", "lbScrollDelegate", function(self, dataAndEvents, deepDataAndEvents, loading, $document, parent) {
  self.queryCondition = {
    page : 1
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    loading.show(true);
    self.queryCondition.page++;
    $document.postEncode("/KEY257", self.queryCondition).success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("feedbackListCtrlScroll");
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    loading.show(true);
    $document.postEncode("/KEY257", self.queryCondition).success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("feedbackListCtrlScroll");
      loading.hide();
    });
  };
  self.$on("$ionicView.loaded", function() {
    self.getList();
  });
}]).controller("MyAccountCtrl", ["$scope", "$rootScope", "$state", "psisServices", "lbSpinnerDialog", "ServerConfig", "$timeout", "$window", "$ionicModal", "lbScrollDelegate", "$cordovaFile", "Tools", "VaApplyItem", function($scope, deepDataAndEvents, $state, $http, loading, textAlt, keepData, $window, $modal, zoomTarget, opt_attributes, dataAndEvents, ignoreMethodDoesntExist) {
  $modal.fromTemplateUrl("logoImage.html", function($location) {
    /** @type {number} */
    $scope.logoImageModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @param {Object} e
   * @return {?}
   */
  $scope.showLogo = function(e) {
    return e && e.stopPropagation(), deepDataAndEvents.getAppAccResource(deepDataAndEvents.AuthorityConstant.APP_ASSOCIATOR) ? (zoomTarget.zoomTo("logoImageScroll", 1, false, 0, 0), $scope.logoImageModal.show()) : window.cordova && (window.cordova.plugins && dataAndEvents.showConfirm("开通会员(Vip)即拥有更多的展示公司Logo特权", function(dataAndEvents) {
      if (2 == dataAndEvents) {
        $scope.openLinkInIframe(ignoreMethodDoesntExist.getVaItem[3].title, ignoreMethodDoesntExist.getVaItem[3].htmlName);
      }
    }, "会员(Vip)特权", ["取消", "了解更多"])), false;
  };
  $scope.$on("$destroy", function() {
    $scope.logoImageModal.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.gotoCompanyConfig = function() {
    if ($scope.GetOperatorEventLimit("KEY161")) {
      $state.go("eventmenu.companyConfig", {
        pageType : "company"
      });
    } else {
      dataAndEvents.toastShow("没有修改公司信息的权限");
    }
  };
  $scope.gestureConfig = {
    isEnable : void 0 !== $window.localStorage.isEnableGesturePwd ? "true" == $window.localStorage.isEnableGesturePwd : false
  };
  /**
   * @return {undefined}
   */
  $scope.openGesturePwd = function() {
    if ($scope.gestureConfig.isEnable) {
      $state.go("KEY236", {
        type : "set"
      });
    } else {
      $state.go("KEY236", {
        type : "clear"
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.resetGesturePwd = function() {
    $state.go("KEY236", {
      type : "reset"
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    loading.show();
    $http.post("/KEY234").success(function(data) {
      $scope.KEY196 = data.object;
    }).finally(function() {
      loading.hide();
    });
  });
}]).controller("AccountDetailCtrl", ["$scope", "$state", "psisServices", "lbSpinnerDialog", "$ionicPopup", "$window", "Tools", function($scope, dataAndEvents, $http, loading, _, deepDataAndEvents, self) {
  /**
   * @return {?}
   */
  $scope.updateAccountDetail = function() {
    /** @type {RegExp} */
    var cx = /^[0-9a-zA-Z]*$/g;
    /** @type {RegExp} */
    var rchecked = /^[a-z0-9!#$%&'*+\/=?^_`{|}~.-]+@[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$/i;
    return $scope.KEY196.userName ? cx.test($scope.KEY196.userName) ? (loading.show(true), void $http.get("/KEY235?userId=" + $scope.KEY196.id + "&value=" + $scope.KEY196.userName).success(function(e) {
      if (loading.hide(), 0 == e.isValid) {
        if (window.cordova && window.cordova.plugins) {
          self.showAlert("帐号已被使用");
        } else {
          _.alert({
            template : "<div class='tc'>帐号已被使用</div>",
            okText : "确认"
          });
        }
        /** @type {string} */
        $scope.KEY196.userName = "";
      } else {
        if (!$scope.KEY196.realName) {
          return window.cordova && window.cordova.plugins ? self.showAlert("需要填写姓名") : _.alert({
            template : "<div class='tc'>需要填写姓名</div>",
            okText : "确认"
          }), false;
        }
        if (void 0 != $scope.KEY196.email && ("" != $scope.KEY196.email && !rchecked.test($scope.KEY196.email))) {
          return window.cordova && window.cordova.plugins ? self.showAlert("邮箱格式不正确") : _.alert({
            template : "<div class='tc'>邮箱格式不正确</div>",
            okText : "确认"
          }), false;
        }
        loading.show();
        $http.post("/KEY236", $scope.KEY196).success(function(res) {
          return loading.hide(), 1 != res.statusCode ? (window.cordova && window.cordova.plugins ? self.showAlert(res.content) : _.alert({
            template : "<div class='tc'>" + res.content + "</div>",
            okText : "确认"
          }), false) : void(window.cordova && window.cordova.plugins ? self.showAlert("保存成功", function() {
            $scope.KEY196.optimisticLockVersion = res.object.optimisticLockVersion;
            $scope.goBack();
          }) : _.alert({
            template : "<div class='tc'>保存成功</div>",
            okText : "确认"
          }).then(function() {
            $scope.KEY196.optimisticLockVersion = res.object.optimisticLockVersion;
            $scope.goBack();
          }));
        }).error(function() {
          loading.hide();
        });
      }
    }).error(function() {
      loading.hide();
    })) : (window.cordova && window.cordova.plugins ? self.showAlert("帐号必须由字母或数字组成") : _.alert({
      template : "<div class='tc'>帐号必须由字母或数字组成</div>",
      okText : "确认"
    }), false) : (window.cordova && window.cordova.plugins ? self.showAlert("请填写帐号") : _.alert({
      template : "<div class='tc'>请填写帐号</div>",
      okText : "确认"
    }), false);
  };
  $scope.$on("$ionicView.loaded", function() {
    loading.show();
    $http.post("/KEY234").success(function(data) {
      $scope.KEY196 = data.object;
    }).finally(function() {
      loading.hide();
    });
  });
}]).controller("PasswordModifyCtrl", ["$scope", "psisServices", "lbSpinnerDialog", "$ionicPopup", "md5", "$window", "Tools", function($scope, dataAndEvents, loading, _, md5, model, self) {
  $scope.pwd = {};
  /**
   * @return {?}
   */
  $scope.savePassword = function() {
    if ($scope.pwd.password.length < 6) {
      return window.cordova && window.cordova.plugins ? self.showAlert("请输入至少六位的密码长度") : _.alert({
        template : "<div class='tc'>请输入至少六位的密码长度</div>",
        okText : "确定"
      }), false;
    }
    if ($scope.pwd.password !== $scope.pwd.passwordComfirm) {
      return window.cordova && window.cordova.plugins ? self.showAlert("两次填写的密码不一致") : _.alert({
        template : "<div class='tc'>两次填写的密码不一致</div>",
        okText : "确定"
      }), false;
    }
    loading.show(true);
    var pss = md5.createHash($scope.pwd.oldPassword.toString()).toUpperCase();
    dataAndEvents.postEncode("/KEY237", {
      password : pss
    }).success(function(r) {
      if (1 != r.statusCode) {
        return window.cordova && window.cordova.plugins ? self.showAlert("当前密码输入错误") : _.alert({
          template : "<div class='tc'>当前密码输入错误</div>",
          okText : "确定"
        }), false;
      }
      var password = md5.createHash($scope.pwd.password.toString()).toUpperCase();
      dataAndEvents.postEncode("/KEY238", {
        newPass : password
      }).success(function(r) {
        if (1 == r.statusCode) {
          if (window.cordova && window.cordova.plugins) {
            self.showAlert("密码修改成功", function() {
              model.localStorage.password = password;
              $scope.goBack();
            });
          } else {
            _.alert({
              template : "<div class='tc'>密码修改成功</div>",
              okText : "确定"
            }).then(function() {
              model.localStorage.password = password;
              $scope.goBack();
            });
          }
        } else {
          if (window.cordova && window.cordova.plugins) {
            self.showAlert(r.content);
          } else {
            _.alert({
              template : "<div class='tc'>" + r.content + "</div>",
              okText : "确定"
            });
          }
        }
      });
    }).finally(function() {
      loading.hide();
    });
  };
}]).controller("AboutCtrl", ["$scope", "wechatShare", "Tools", function($scope, dataAndEvents, auth) {
  /**
   * @return {undefined}
   */
  $scope.shareApp = function() {
    dataAndEvents.shareUrlToSession("http://app.xinbafar.com.cn:8080/business/m/index.html", "辛巴手机版，把生意装进手机里！", "永久免费，手机、平板、电脑全平台支持，生意高效运转，彻底告别糊涂账！", null);
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.aboutConfig = auth.isEmpty($scope.commonConfig) || auth.isEmpty($scope.commonConfig.aboutConfig) ? {
      qq : {
        key : "客服QQ",
        name : "29290028",
        value : "https://wpa.qq.com/msgrd?v=3&uin=29290028&site=qq&menu=yes"
      },
      email : {
        key : "客服邮箱",
        name : "kf@www.xinbafar.com.cn",
        value : "mailto:kf@www.xinbafar.com.cn"
      },
      tel : {
        key : "客服电话",
        name : "028-85243072",
        value : "tel:028-85243072"
      },
      website : {
        name : "www.xinbafar.com.cn",
        value : "http://www.xinbafar.com.cn/"
      },
      consultant : {
        key : "使用顾问",
        name : "400-600-0280"
      }
    } : $scope.commonConfig.aboutConfig;
    /** @type {Array} */
    $scope.aboutConfigList = [];
    var i;
    for (i in $scope.aboutConfig) {
      if ("function" != typeof $scope.aboutConfig[i]) {
        if ($scope.aboutConfig[i].key) {
          if ("XinBaSoft" == $scope.aboutConfig[i].value) {
            delete $scope.aboutConfig[i].value;
          }
          $scope.aboutConfigList.push($scope.aboutConfig[i]);
        }
      }
    }
  });
}]).controller("AccountMessageMainCtrl", ["$scope", "psisServices", "$state", function($scope, dataAndEvents, $state) {
  /** @type {Array} */
  $scope.items = [];
  /** @type {boolean} */
  $scope.isLoading = true;
  /**
   * @return {?}
   */
  var $http = function() {
    return dataAndEvents.postEncode("/KEY389", {});
  };
  /**
   * @return {undefined}
   */
  var query = function() {
    $http().success(function(data) {
      $scope.items = data.object;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    $http().success(function(data) {
      $scope.items = data.object;
      $scope.$broadcast("scroll.refreshComplete");
    });
  };
  /**
   * @param {?} e
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  $scope.openList = function(e, dataAndEvents) {
    $state.go("eventmenu.KEY191", {
      msgTypeId : e,
      msgTypeName : dataAndEvents
    });
  };
  query();
}]).controller("AccountMessageCtrl", ["$scope", "psisServices", "lbScrollDelegate", "$state", "$ionicModal", "$stateParams", "Tools", function($scope, $http, parent, self, $modal, dataAndEvents) {
  var msgTypeId = dataAndEvents.msgTypeId ? dataAndEvents.msgTypeId : "1";
  $scope.msgTypeName = dataAndEvents.msgTypeName ? dataAndEvents.msgTypeName : "系统消息";
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.modalObject = {};
  /**
   * @return {?}
   */
  var callback = function() {
    var data = {
      page : page,
      msgTypeId : msgTypeId
    };
    return $http.postEncode("/KEY365", data);
  };
  /**
   * @return {undefined}
   */
  var setup = function() {
    /** @type {number} */
    page = 1;
    callback().success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("messageListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  $modal.fromTemplateUrl("messageContentShow.html", function($location) {
    /** @type {number} */
    $scope.messageContentShow = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.messageContentShow.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    page++;
    callback().success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("messageListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    page = 1;
    callback().success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @param {?} i
   * @param {?} opt_fromIndex
   * @return {undefined}
   */
  $scope.clickList = function(i, opt_fromIndex) {
    if (1 !== $scope.items[i].isRead && $http.post("/admin/system/message/updateMsgRead.ac?id=" + $scope.items[i].id).success(function() {
      /** @type {number} */
      $scope.items[i].isRead = 1;
      $scope.getUnreadMsgCount();
    }), $scope.items[i].msgUrl && "tmsOrder" === $scope.items[i].msgUrl) {
      self.go("eventmenu.KEY211", {
        ordersSn : $scope.items[i].msgKeyword
      });
    } else {
      if ($scope.items[i].msgUrl && "modal" === $scope.items[i].msgUrl) {
        $scope.modalObject = $scope.items[i];
        $scope.messageContentShow.show();
      } else {
        if ($scope.items[i].msgUrl && "3rdurl" === $scope.items[i].msgUrl) {
          $scope.openLink($scope.items[i].msgKeyword, true);
        } else {
          if ($scope.items[i].msgUrl && "inAppUrl" === $scope.items[i].msgUrl) {
            var fromIndex = $scope.items[i].urlTitle ? $scope.items[i].urlTitle : opt_fromIndex;
            $scope.openLinkInIframe(fromIndex, $scope.items[i].msgKeyword);
          } else {
            if ($scope.items[i].msgUrl && ("openAppView" === $scope.items[i].msgUrl && $scope.items[i].msgKeyword)) {
              if ($scope.items[i].msgKeyword.indexOf("param") > 0) {
                /** @type {*} */
                var data = JSON.parse($scope.items[i].msgKeyword);
                self.go(data.state, data.param);
              } else {
                self.go($scope.items[i].msgKeyword);
              }
            }
          }
        }
      }
    }
  };
  setup();
}]).controller("BluetoothPrintListCtrl", ["$scope", "Tools", "psisServices", "ServerConfig", "lruPersistCache", "OrderType", "$filter", "$ionicPopup", "$ionicPopover", "lbSpinnerDialog", "$timeout", "BluetoothPrintService", "$ionicModal", "$window", "$state", "commonDataInterface", "$stateParams", "$rootScope", "PrintType", function(self, jQuery, deepDataAndEvents, context, $templateCache, types, ignoreMethodDoesntExist, view, FB, loading, $sanitize, p,
$modal, $window, $state, dataAndEvents, data, mod, item) {
  self.printType = data.printType ? data.printType : item.printTicket;
  self.printTypeList = item;
  self.isClientExpress = data.isClientExpress;
  self.printObject = data.printObject;
  self.printQRcodeObj = {
    gap : 3,
    times : 1,
    qrCodeType : "normal"
  };
  /** @type {Array} */
  self.checkColumns = [];
  /**
   * @param {string} fn
   * @return {undefined}
   */
  var token = function(fn) {
    if (fn) {
      jQuery.toastShow(fn);
    }
  };
  /**
   * @param {(Object|string)} element
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openPrintSetting = function(element, expectedNumberOfNonCommentArgs) {
    if (element == item.printQRCode) {
      self.printSettingForQRcodeModal.show(expectedNumberOfNonCommentArgs);
    } else {
      self.otherOperationPopover.show(expectedNumberOfNonCommentArgs);
    }
  };
  if (window.plugins) {
    if (window.plugins.bluetoothPrinter) {
      /**
       * @param {?} theTitle
       * @return {undefined}
       */
      window.plugins.bluetoothPrinter.unbondDeviceslist = function(theTitle) {
        $sanitize(function() {
          self.unbondBluetoothDevices = theTitle;
        });
      };
      /**
       * @return {undefined}
       */
      window.plugins.bluetoothPrinter.bondDeviceslist = function() {
        self.list();
      };
    }
  }
  FB.fromTemplateUrl("otherOperation.html", {
    scope : self
  }).then(function(theTitle) {
    self.otherOperationPopover = theTitle;
  });
  /**
   * @return {undefined}
   */
  self.gotoPrintSetting = function() {
    if ($templateCache.get("bluePrintType") == types.logisticsOrder || $templateCache.get("bluePrintType") == types.ehsopLogisticsOrder) {
      $state.go("eventmenu.KEY002", {
        typeId : $templateCache.get("bluePrintType")
      });
    } else {
      $state.go("eventmenu.KEY110", {
        typeId : $templateCache.get("bluePrintType")
      });
    }
  };
  /**
   * @param {string} key
   * @return {undefined}
   */
  var init = function(key) {
    switch(self.printSize = $window.localStorage["PrintSize" + key], self.printSize) {
      case "58mm":
        /** @type {string} */
        self.printSizeCss = "page58";
        break;
      case "80mm":
        /** @type {string} */
        self.printSizeCss = "page80";
        break;
      case "110mm":
        /** @type {string} */
        self.printSizeCss = "page110";
        break;
      case "ep-basic":
        /** @type {string} */
        self.printSizeCss = "page-epBasic";
        break;
      default:
        /** @type {string} */
        self.printSizeCss = "page80";
    }
  };
  /**
   * @return {undefined}
   */
  self.printPreview = function() {
    /**
     * @param {string} input
     * @param {Object} d
     * @return {undefined}
     */
    function render(input, d) {
      init(input);
      d.title = "page-epBasic" == self.printSizeCss ? d.title.replace(/\n/g, "<br>").replace(/\s/g, "") : d.title.replace(/\n/g, "<br>").replace(/\s/g, "&nbsp;&nbsp;");
      d.content = d.content.replace(/\n/g, "<br>").replace(/\s/g, "&nbsp;&nbsp;").replace(/-----/g, "------");
      d.total = d.total.replace(/\n/g, "<br>").replace(/\s/g, "&nbsp;");
      d.footer = d.footer.replace(/\n/g, "<br>").replace(/\s/g, "&nbsp;&nbsp;").replace(/-----/g, "------");
      /** @type {Object} */
      self.printData = d;
      self.printPreviewModal.show();
      loading.hide();
    }
    /** @type {boolean} */
    self.isEorder = false;
    loading.show();
    var done = $templateCache.get("bluePrintSN");
    var i = $templateCache.get("bluePrintType");
    var type = self.mainCompany.comName;
    if (i == types.logisticsOrder && (type = self.mainCompany), self.isClientExpress) {
      var data = {
        title : "\n",
        content : "",
        total : "",
        footer : "",
        qrCode : {
          text : "",
          slogan : "",
          enable : false
        },
        printTpl : "ep-basic"
      };
      data.content = p.getLogisticsPrintData(self.printObject.printType, self.printObject.senderName, self.printObject.senderPhone, self.printObject.senderAddress, self.printObject.receiverName, self.printObject.receiverPhone, self.printObject.receiverAddress, self.printObject.remark, self.printObject.isPrintRemark, self.printObject.isPrintDate, self.printObject.footerText);
      render(i, data);
    } else {
      p.getPrintData(type, done, i).then(function(res) {
        if (i == types.ehsopLogisticsOrder) {
          i = types.logisticsOrder;
        }
        if ($templateCache.get("bluePrintType") == types.logisticsOrder || $templateCache.get("bluePrintType") == types.ehsopLogisticsOrder) {
          render(i, res[0]);
        } else {
          render(i, res);
        }
      }, function() {
        loading.hide();
        jQuery.toastShow("获取打印数据异常！");
      });
    }
  };
  $modal.fromTemplateUrl("html/PSystemSetup/KEY042.html", function(theTitle) {
    /** @type {number} */
    self.printPreviewModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PSystemSetup/KEY317.html", function(theTitle) {
    /** @type {number} */
    self.printSettingForQRcodeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.printPreviewModal.remove();
    if (self.printSettingForQRcodeModal) {
      self.printSettingForQRcodeModal.remove();
    }
    if (window.plugins) {
      if (window.plugins.bluetoothPrinter) {
        window.plugins.bluetoothPrinter.unbondDeviceslist = angular.noop;
        window.plugins.bluetoothPrinter.bondDeviceslist = angular.noop;
      }
    }
  });
  /**
   * @param {string} v12
   * @param {Array} deepDataAndEvents
   * @return {undefined}
   */
  self.expressPrint = function(v12, deepDataAndEvents) {
    var fileName = $templateCache.get("bluePrintType");
    window.plugins.bluetoothPrinter.open(function() {
      /** @type {number} */
      $window.localStorage.isBLEPrinted = 1;
      window.plugins.bluetoothPrinter.printExpressArray(function(speed) {
        if (speed) {
          jQuery.toastShow(speed);
        }
        self.goBack();
      }, function(speed) {
        if (speed) {
          jQuery.toastShow(speed);
        }
      }, deepDataAndEvents, $window.localStorage["PrintTimes" + fileName]);
      if (void 0 == $window.localStorage["bluePrinter" + fileName] || $window.localStorage["bluePrinter" + fileName] != v12) {
        /** @type {string} */
        $window.localStorage["bluePrinter" + fileName] = v12;
      }
    }, function() {
      view.alert({
        title : "设备连接失败",
        template : "1.若打印设备被占用，请稍候再试<br>2.若打印设备未占用，请重启打印设备",
        okText : "确定"
      });
    }, v12);
  };
  /**
   * @param {Function} b
   * @return {undefined}
   */
  self.connect = function(b) {
    if (self.isEorder = false, self.printType == item.printLabel) {
      p.connectBluetoothForBarCode(b, data.labelSetting, data.labelArray, data.printTimes, self.printType, true);
    } else {
      if (self.isClientExpress) {
        var msg = {
          title : "\n",
          content : "",
          total : "",
          footer : "",
          qrCode : {
            text : "",
            slogan : "",
            enable : false
          },
          printTpl : "ep-basic"
        };
        msg.content = p.getLogisticsPrintData(self.printObject.printType, self.printObject.senderName, self.printObject.senderPhone, self.printObject.senderAddress, self.printObject.receiverName, self.printObject.receiverPhone, self.printObject.receiverAddress, self.printObject.remark, self.printObject.isPrintRemark, self.printObject.isPrintDate, self.printObject.footerText);
        self.expressPrint(b, [msg]);
      } else {
        if (self.printType == item.printQRCode) {
          if (data.labelArray.length > 0) {
            if ("normal" == self.printQRcodeObj.qrCodeType) {
              /** @type {number} */
              self.printQRcodeObj.width = 40;
              /** @type {number} */
              self.printQRcodeObj.height = 50;
            } else {
              self.printQRcodeObj.width = self.printQRcodeObj.width > 0 ? self.printQRcodeObj.width : 40;
              self.printQRcodeObj.height = self.printQRcodeObj.height > 0 ? self.printQRcodeObj.height : 50;
            }
          }
          self.printQRcodeObj.gap = self.printQRcodeObj.gap > 0 ? self.printQRcodeObj.gap : 3;
          var typePattern = self.goodsQRCodeConfiguration(data.labelArray);
          p.connectBluetoothForBarCode(b, self.printQRcodeObj, typePattern, self.printQRcodeObj.times, self.printType, true);
        } else {
          var label = self.mainCompany.comName;
          if ($templateCache.get("bluePrintType") == types.logisticsOrder || $templateCache.get("bluePrintType") == types.ehsopLogisticsOrder) {
            label = self.mainCompany;
            p.connectBluetoothForExpress(b, label, $templateCache.get("bluePrintSN"), $templateCache.get("bluePrintType"), true);
          } else {
            p.connectBluetooth(b, label, $templateCache.get("bluePrintSN"), $templateCache.get("bluePrintType"), true);
          }
        }
      }
    }
  };
  /**
   * @param {?} s
   * @return {undefined}
   */
  self.pair = function(s) {
    window.plugins.bluetoothPrinter.connect(angular.noop, token, s);
  };
  /**
   * @return {undefined}
   */
  self.list = function() {
    /** @type {Array} */
    self.items = [];
    if (window.plugins) {
      if (window.plugins.bluetoothPrinter) {
        loading.show();
        window.plugins.bluetoothPrinter.list(function(data) {
          self.items = data;
          loading.hide();
        }, function(speed) {
          jQuery.toastShow(speed);
          loading.hide();
        });
      }
    }
  };
  /**
   * @param {Array} codeSegments
   * @return {?}
   */
  self.goodsQRCodeConfiguration = function(codeSegments) {
    /** @type {Array} */
    var suites = [];
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      var suite = {};
      if (self.checkColumns.indexOf("goodsName") > -1) {
        suite.title = codeSegments[i].goodsName;
      }
      if (self.checkColumns.indexOf("goodsSn") > -1) {
        suite.str1 = codeSegments[i].goodsSn;
      }
      if (self.checkColumns.indexOf("price") > -1) {
        suite.str2 = codeSegments[i].goodsPrice;
      }
      suite.goodsUrl = codeSegments[i].goodsUrl;
      suites.push(suite);
    }
    return suites;
  };
  self.$on("$ionicView.beforeEnter", function() {
    if (self.printType == item.printQRCode) {
      dataAndEvents.getUserConfig("qrCodePrintSetting").then(function(res) {
        if (1 == res.statusCode && (res.object && res.object.configValue)) {
          /** @type {*} */
          var message = JSON.parse(res.object.configValue);
          self.printQRcodeObj = message.printObj;
          self.printQRcodeObj.gap = message.printObj && message.printObj.gap ? message.printObj.gap : 3;
          self.checkColumns = message.checkColumns;
        } else {
          /** @type {Array} */
          self.checkColumns = ["goodsName", "goodsSn", "price"];
        }
      });
    }
  });
  self.$on("$ionicView.loaded", function() {
    self.list();
    if (!(self.printType == item.printLabel)) {
      if (!$window.localStorage.PrintQRCode) {
        dataAndEvents.getUserConfig("QRCodeForShop").then(function(res) {
          if (1 == res.statusCode) {
            if (res.object) {
              $window.localStorage.PrintQRCode = res.object.configValue;
            } else {
              if (self.GetOperatorEventLimit("KEY261")) {
                var path = context.tmsServer.replace(/cid/, mod.mainCompany.id);
                if (context.currentServer === context.exServer) {
                  path = path.replace(/www/, "ex");
                } else {
                  if (context.currentServer.indexOf("dev") >= 0) {
                    path = path.replace(/www/, "dev");
                  }
                }
                var obj = {
                  text : path,
                  slogan : "扫一扫关注店铺",
                  enable : false
                };
                /** @type {string} */
                $window.localStorage.PrintQRCode = JSON.stringify(obj);
              } else {
                /** @type {string} */
                $window.localStorage.PrintQRCode = JSON.stringify({
                  text : "",
                  slogan : "",
                  enable : false
                });
              }
            }
          }
        });
      }
    }
  });
}]).controller("CompanyConfigCtrl", ["$scope", "psisServices", "lbSpinnerDialog", "$ionicPopup", "$rootScope", "Tools", "ServerConfig", "$state", "$stateParams", "CameraService", "$ionicActionSheet", "$cordovaFile", "VaApplyItem", "BusinessConstant", "$ionicPopover", "$q", function(self, res, loading, _, doc, dojo, this$static, r, obj, dataAndEvents, dialog, exports, ignoreMethodDoesntExist, deepDataAndEvents, FB, $q) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = res.httpCacheGet.get(res.httpCacheGet.ac.ALLACCOUNT);
    var getPromise3 = res.httpCacheGet.get(res.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @return {undefined}
   */
  function init() {
    fetch().then(function(packs) {
      self.allAccounts = packs[0].data.rows;
      /** @type {number} */
      var i = 0;
      for (;i < self.allAccounts.length;i++) {
        if (self.allAccounts[i].id == self.companyConfig.onlineReceiptDefaultAccount) {
          self.onlineReceiptDefaultAccountName = self.allAccounts[i].name;
        } else {
          if (self.onlineReceiptDefaultAccountName) {
            break;
          }
        }
      }
      /** @type {Array} */
      self.allConditionAccountItems = [];
      dojo.union(self.allConditionAccountItems, packs[1].data.rows);
      self.allAccountItems = packs[1].data.rows;
      /** @type {number} */
      i = 0;
      for (;i < self.allAccountItems.length;i++) {
        if (self.allAccountItems[i].id == self.companyConfig.onlineReceiptDefaultAccountItem) {
          self.onlineReceiptDefaultAccountItemName = self.allAccountItems[i].name;
        } else {
          if (self.onlineReceiptDefaultAccountItemName) {
            break;
          }
        }
      }
      /** @type {number} */
      i = 0;
      for (;i < self.allAccountItems.length;i++) {
        if (0 == self.allAccountItems[i].isEnable || (1 == self.allAccountItems[i].id || (10 == self.allAccountItems[i].id || 5 == self.allAccountItems[i].id))) {
          self.allAccountItems.splice(i, 1);
          i--;
        }
      }
    });
  }
  /** @type {string} */
  self.viewTitle = "系统参数";
  self.company = {};
  self.companyConfig = {};
  self.pageType = obj.pageType;
  if ("company" == self.pageType) {
    /** @type {string} */
    self.viewTitle = "公司信息";
  }
  /**
   * @param {Object} map
   * @return {undefined}
   */
  self.selectAccount = function(map) {
    self.onlineReceiptDefaultAccountName = map.name;
    self.companyConfig.onlineReceiptDefaultAccount = map.id;
  };
  /**
   * @param {Object} map
   * @return {undefined}
   */
  self.selectAccountItem = function(map) {
    self.onlineReceiptDefaultAccountItemName = map.name;
    self.companyConfig.onlineReceiptDefaultAccountItem = map.id;
  };
  /**
   * @param {string} fileName
   * @return {undefined}
   */
  var uploadPhoto = function(fileName) {
    loading.show(true);
    var options = new FileUploadOptions;
    /** @type {string} */
    options.fileKey = "file";
    options.fileName = fileName.substr(fileName.lastIndexOf("/") + 1) + ".jpg";
    /** @type {string} */
    options.mimeType = "image/jpeg";
    /** @type {boolean} */
    options.chunkedMode = false;
    exports.uploadFile(this$static.currentServer + "/admin/file/img/uploadLogo.ac?module=companyLogo", fileName, options).then(function(data) {
      loading.hide();
      var res = angular.fromJson(data.response);
      if (1 === res.statusCode) {
        console.log(res);
        dojo.toastShow("Logo上传成功！");
        if (res.object) {
          if (res.object.logo) {
            doc.mainCompany.logo = res.object.logo;
          }
        }
      } else {
        dojo.toastShow("Logo上传失败！");
      }
    }, function(err) {
      loading.hide();
      dojo.toastShow(413 === err.http_status ? "不能上传超过2M的Logo！" : "Logo上传失败！");
    }, function() {
    });
  };
  /**
   * @param {Object} event
   * @return {?}
   */
  self.choosePhoto = function(event) {
    return event && event.stopPropagation(), doc.getAppAccResource(doc.AuthorityConstant.APP_ASSOCIATOR) ? dialog.show({
      buttons : [{
        text : '<i class="icon ion-camera assertive"></i> 拍 照'
      }, {
        text : '<i class="icon ion-images assertive"></i> 从相册中选择'
      }],
      /**
       * @param {?} clicked
       * @return {?}
       */
      buttonClicked : function(clicked) {
        switch(clicked) {
          case 0:
            dataAndEvents.startCamera(true).then(uploadPhoto);
            break;
          case 1:
            dataAndEvents.openCameraRoll(true).then(uploadPhoto);
        }
        return true;
      }
    }) : window.cordova && (window.cordova.plugins && dojo.showConfirm("开通会员(Vip)即拥有更多的展示公司Logo特权", function(dataAndEvents) {
      if (2 == dataAndEvents) {
        self.openLinkInIframe(ignoreMethodDoesntExist.getVaItem[3].title, ignoreMethodDoesntExist.getVaItem[3].htmlName);
      }
    }, "会员(Vip)特权", ["取消", "了解更多"])), false;
  };
  self.$watch("[companyConfig.goodsSngenneratorSetting, companyConfig.customerPointSetting]", function(dataAndEvents, deepDataAndEvents) {
    if (0 == deepDataAndEvents[0]) {
      if (1 == dataAndEvents[0]) {
        if (0 == self.getAppAccResource(3)) {
          doc.getAppAuthority(3);
          /** @type {boolean} */
          self.companyConfig.goodsSngenneratorSetting = false;
        }
      }
    }
    if (0 == deepDataAndEvents[1]) {
      if (1 == dataAndEvents[1]) {
        if (0 == self.getAppAccResource(5)) {
          doc.getAppAuthority(5);
          /** @type {boolean} */
          self.companyConfig.customerPointSetting = false;
        } else {
          self.saveCompanyConfig(true);
        }
      }
    }
  }, true);
  /**
   * @param {string} encoding
   * @return {undefined}
   */
  self.goState = function(encoding) {
    var enc = encoding ? encoding : "eventmenu.KEY195";
    r.go(enc);
  };
  /** @type {Array} */
  self.companyConfig.wechatPriceOptions = [{
    value : "1",
    title : "零售价"
  }, {
    value : "2",
    title : "批发价"
  }];
  self.companyConfig.currencySymbolOptions = dojo.isEmpty(self.commonConfig) || dojo.isEmpty(self.commonConfig.currencySymbolOptions) ? [{
    value : "￥",
    title : "人民币(￥)"
  }, {
    value : " ",
    title : "不显示"
  }] : self.commonConfig.currencySymbolOptions;
  FB.fromTemplateUrl("KEY119.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY119 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideAccountItemPopover = function() {
    self.KEY119.hide();
  };
  FB.fromTemplateUrl("KEY190.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY190 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideAccountPopover = function() {
    self.KEY190.hide();
  };
  self.$on("$destroy", function() {
    self.KEY119.remove();
    self.KEY190.remove();
  });
  /**
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  self.saveCompanyConfig = function(dataAndEvents) {
    /** @type {RegExp} */
    var rhtml = /^[a-zA-Z0-9]*$/;
    /** @type {RegExp} */
    var m1 = /^[1-9]{1}[0-9]*$/;
    var value = self.company;
    if (!(self.company.comName && self.company.comName.length > 0)) {
      return dojo.toastShow("公司名称不能为空！", "short", "center"), void console.log("公司名称不能为空！");
    }
    if (!self.companyConfig.warnNumberLow && (null !== self.companyConfig.warnNumberLow && 0 != self.companyConfig.warnNumberLow)) {
      return dojo.toastShow("库存预警下限为不小于0的正整数！", "short", "center"), void console.log("库存预警下限为不小于0的正整数！");
    }
    if (!self.companyConfig.warnNumberTop && (null !== self.companyConfig.warnNumberTop && 0 != self.companyConfig.warnNumberTop)) {
      return dojo.toastShow("库存预警上限为不大于100000的正整数！", "short", "center"), void console.log("库存预警上限为不大于100000的正整数！");
    }
    if (null !== self.companyConfig.warnNumberLow && (null !== self.companyConfig.warnNumberTop && ("" !== self.companyConfig.warnNumberLow && ("" !== self.companyConfig.warnNumberTop && self.companyConfig.warnNumberLow >= self.companyConfig.warnNumberTop))) || 0 === self.companyConfig.warnNumberLow && 0 === self.companyConfig.warnNumberTop) {
      return dojo.toastShow("库存预警上限必须大于下限！", "short", "center"), void console.log("库存预警上限必须大于下限！");
    }
    if (!rhtml.test(self.goodsSngenneratorValue.prefix)) {
      return dojo.toastShow("前缀必须由字母或数字组成！", "short", "center"), void console.log("前缀必须由字母或数字组成！");
    }
    if (!m1.test(self.goodsSngenneratorValue.length) || self.goodsSngenneratorValue.length > 128) {
      return dojo.toastShow("数字长度必须是小于等于128的正整数！", "short", "center"), void console.log("数字长度必须是小于等于128的正整数！");
    }
    if (!value.comName) {
      /** @type {string} */
      value.comName = "";
    }
    /** @type {number} */
    self.goodsSngenneratorValue.enable = 1 == self.companyConfig.goodsSngenneratorSetting ? 1 : 2;
    /** @type {Array} */
    var old_val = [{
      configKey : "warnNumberTop",
      configValue : self.companyConfig.warnNumberTop
    }, {
      configKey : "warnNumberLow",
      configValue : self.companyConfig.warnNumberLow
    }, {
      configKey : "wechatShopDefaultPriceType",
      configValue : self.companyConfig.wechatShopDefaultPriceType
    }, {
      configKey : "saleNegativeStore",
      configValue : 1 == self.companyConfig.saleNegativeStoreSetting ? 1 : 2
    }, {
      configKey : "goodsSngennerator",
      configValue : JSON.stringify(self.goodsSngenneratorValue)
    }, {
      configKey : "customerPoint",
      configValue : 1 == self.companyConfig.customerPointSetting ? 1 : 2
    }, {
      configKey : "currencySymbol",
      configValue : self.companyConfig.currencySymbol
    }, {
      configKey : "onlineReceiptDefaultAccount",
      configValue : self.companyConfig.onlineReceiptDefaultAccount
    }, {
      configKey : "onlineReceiptDefaultAccountItem",
      configValue : self.companyConfig.onlineReceiptDefaultAccountItem
    }];
    loading.show(true);
    res.postEncode("/KEY230", {
      company : angular.toJson(value),
      companyConfig : angular.toJson(old_val)
    }).success(function(config) {
      /**
       * @return {undefined}
       */
      var resolve = function() {
        doc.mainCompany = config.object.company;
        self.company.optimisticLockVersion = config.object.company.optimisticLockVersion;
        var results = dojo.fnCheckGtoreQty(config.object.companyConfigList, "configKey", "customerPoint");
        this$static.companyConfigData.customerPoint = results && results.configValue ? results.configValue : deepDataAndEvents.CUSTOMERPOINT.OFF;
        var panel = dojo.fnCheckGtoreQty(config.object.companyConfigList, "configKey", "currencySymbol");
        if (panel && panel.configValue) {
          self.companyConfig.currencySymbol = panel.configValue;
          doc.currencySymbol = panel.configValue;
          this$static.currencySymbol = panel.configValue;
        } else {
          /** @type {string} */
          self.companyConfig.currencySymbol = "￥";
          /** @type {string} */
          doc.currencySymbol = "￥";
          /** @type {string} */
          this$static.currencySymbol = "￥";
        }
        var instance = dojo.fnCheckGtoreQty(config.object.companyConfigList, "configKey", "onlineReceiptDefaultAccount");
        this$static.companyConfigData.onlineReceiptDefaultAccount = instance && instance.configValue ? instance.configValue : null;
        var ex = dojo.fnCheckGtoreQty(config.object.companyConfigList, "configKey", "onlineReceiptDefaultAccountItem");
        this$static.companyConfigData.onlineReceiptDefaultAccountItem = ex && ex.configValue ? ex.configValue : null;
        var opts = dojo.fnCheckGtoreQty(config.object.companyConfigList, "configKey", "saleNegativeStore");
        this$static.companyConfigData.saleNegativeStore = opts && opts.configValue ? opts.configValue : 1;
        var warnNumberTop = dojo.fnCheckGtoreQty(config.object.companyConfigList, "configKey", "warnNumberTop");
        if (warnNumberTop) {
          if (warnNumberTop.configValue) {
            this$static.companyConfigData.warnNumberTop = warnNumberTop.configValue;
          }
        }
        var warnNumberLow = dojo.fnCheckGtoreQty(config.object.companyConfigList, "configKey", "warnNumberLow");
        if (warnNumberLow) {
          if (warnNumberLow.configValue) {
            this$static.companyConfigData.warnNumberLow = warnNumberLow.configValue;
          }
        }
        var field;
        var data = dojo.fnCheckGtoreQty(config.object.companyConfigList, "configKey", "goodsSngennerator");
        /** @type {*} */
        field = data && data.configValue ? JSON.parse(data.configValue) : {
          enable : 2
        };
        /** @type {boolean} */
        this$static.companyConfigData.goodsSngenneratorOn = 1 == field.enable;
        if (!dataAndEvents) {
          self.goBack();
        }
      };
      return 1 != config.statusCode ? (window.cordova && window.cordova.plugins ? dojo.showAlert("修改失败", null, "提示") : _.alert({
        template : "<div class='tc'>" + config.content + "</div>",
        okText : "确定"
      }), false) : void(dataAndEvents ? resolve() : window.cordova && window.cordova.plugins ? dojo.showAlert("修改成功", resolve, "提示") : _.alert({
        template : "<div class='tc'>修改成功</div>",
        okText : "确认"
      }).then(resolve));
    }).error(function() {
      if (window.cordova && window.cordova.plugins) {
        dojo.showAlert("修改失败", null, "提示");
      } else {
        _.alert({
          template : "<div class='tc'>修改失败</div>",
          okText : "确定"
        });
      }
    }).finally(function() {
      loading.hide();
    });
  };
  self.$on("$ionicView.loaded", function() {
    loading.show();
    res.post("/KEY229").success(function(body) {
      if (body.object.company) {
        self.company = body.object.company;
        var options = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "warnNumberTop");
        /** @type {(number|string)} */
        self.companyConfig.warnNumberTop = options && options.configValue ? parseInt(options.configValue) : "";
        var properties = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "warnNumberLow");
        /** @type {(number|string)} */
        self.companyConfig.warnNumberLow = properties && properties.configValue ? parseInt(properties.configValue) : "";
        var panel = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "currencySymbol");
        if (panel && panel.configValue) {
          self.companyConfig.currencySymbol = panel.configValue;
          doc.currencySymbol = panel.configValue;
          this$static.currencySymbol = panel.configValue;
        } else {
          /** @type {string} */
          self.companyConfig.currencySymbol = "￥";
          /** @type {string} */
          doc.currencySymbol = "￥";
          /** @type {string} */
          this$static.currencySymbol = "￥";
        }
        var pos = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "wechatShopDefaultPriceType");
        self.companyConfig.wechatShopDefaultPriceType = pos ? pos.configValue : "";
        var saleNegativeStoreSetting = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "saleNegativeStore");
        /** @type {boolean} */
        self.companyConfig.saleNegativeStoreSetting = saleNegativeStoreSetting ? 1 == saleNegativeStoreSetting.configValue : true;
        var selector = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "customerPoint");
        /** @type {boolean} */
        self.companyConfig.customerPointSetting = selector && selector.configValue ? 1 == selector.configValue && 1 == self.getAppAccResource(5) : false;
        var opts = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "onlineReceiptDefaultAccount");
        self.companyConfig.onlineReceiptDefaultAccount = opts && opts.configValue ? opts.configValue : null;
        var config = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "onlineReceiptDefaultAccountItem");
        self.companyConfig.onlineReceiptDefaultAccountItem = config && config.configValue ? config.configValue : null;
        var data = dojo.fnCheckGtoreQty(body.object.companyConfigList, "configKey", "goodsSngennerator");
        /** @type {*} */
        self.goodsSngenneratorValue = data && data.configValue ? JSON.parse(data.configValue) : {
          enable : 2,
          length : 5,
          prefix : ""
        };
        init();
        /** @type {boolean} */
        self.companyConfig.goodsSngenneratorSetting = 1 == self.goodsSngenneratorValue.enable && 1 == self.getAppAccResource(3);
      }
    }).finally(function() {
      loading.hide();
    });
  });
}]).controller("UserManListCtrl", ["$scope", "psisServices", "lbSpinnerDialog", "$ionicModal", "$state", "lbScrollDelegate", "$ionicPopup", "$stateParams", "lruPersistCache", "$ionicPopover", "Tools", function($scope, data_user, dataAndEvents, $modal, $state, parent, _, $routeParams, $templateCache, FB, dojo) {
  /** @type {Array} */
  $scope.items = [];
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.queryCondition = {};
  /** @type {boolean} */
  $scope.queryCondition.settingT = true;
  $scope.queryCondition.storeId = $routeParams.storeId ? $routeParams.storeId : "";
  FB.fromTemplateUrl("comStorePopover.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.comStorePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openComStorePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.comStorePopover.show(expectedNumberOfNonCommentArgs);
  };
  $scope.$on("$destroy", function() {
    $scope.comStorePopover.remove();
    $scope.userQueryModal.remove();
  });
  $scope.$watch("[queryCondition.storeId, checklist.needRefresh]", function(dataAndEvents, deepDataAndEvents) {
    if (dataAndEvents[0] != deepDataAndEvents[0]) {
      $scope.getList();
    }
    if (1 == $scope.checklist.needRefresh) {
      /** @type {boolean} */
      $scope.checklist.needRefresh = false;
      /** @type {Array} */
      $scope.checklist.selectedUsers = [];
      /** @type {string} */
      $scope.checklist.usersString = "";
      /** @type {string} */
      $scope.checklist.usersNameString = "";
      $scope.getList();
    }
  }, true);
  $modal.fromTemplateUrl("userQuery.html", function($location) {
    $scope.userQueryModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  if (!$scope.checklist) {
    $scope.checklist = {};
  }
  /** @type {Array} */
  $scope.checklist.selectedUsers = [];
  /** @type {number} */
  $scope.checklist.selectedUsers.length = 0;
  /**
   * @param {Element} instance
   * @return {undefined}
   */
  $scope.selectRole = function(instance) {
    var key = dojo.fnCheckGtoreQty($scope.checklist.selectedUsers, "id", instance.id);
    if (key) {
      var camelKey = $scope.checklist.selectedUsers.indexOf(key);
      $scope.checklist.selectedUsers.splice(camelKey, 1);
    } else {
      $scope.checklist.selectedUsers.push({
        id : instance.id,
        realName : instance.realName
      });
    }
  };
  /**
   * @param {?} name
   * @return {?}
   */
  var Step = function(name) {
    return data_user.postEncode("/KEY240", name);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    /** @type {number} */
    $scope.queryCondition.status = $scope.queryCondition.settingT ? 1 : 0;
    /** @type {number} */
    $scope.queryCondition.pageNo = 1;
    Step($scope.queryCondition).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("userListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    /** @type {number} */
    $scope.queryCondition.status = $scope.queryCondition.settingT ? 1 : 0;
    $scope.queryCondition.pageNo++;
    Step($scope.queryCondition).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("userListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    if ($state.includes("eventmenu.KEY253")) {
      $scope.queryCondition = {};
      $scope.queryCondition.storeId = $routeParams.storeId ? $routeParams.storeId : "";
    }
    if ($scope.checklist) {
      /** @type {Array} */
      $scope.checklist.selectedUsers = [];
      /** @type {string} */
      $scope.checklist.usersString = "";
      /** @type {string} */
      $scope.checklist.usersNameString = "";
    }
    /** @type {boolean} */
    $scope.queryCondition.settingT = true;
    /** @type {number} */
    $scope.queryCondition.status = $scope.queryCondition.settingT ? 1 : 0;
    /** @type {number} */
    $scope.queryCondition.pageNo = 1;
    Step($scope.queryCondition).success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @param {number} userId
   * @return {undefined}
   */
  $scope.getUserInfo = function(userId) {
    $state.go("eventmenu.KEY252", {
      userId : userId
    });
  };
  /**
   * @param {string} b
   * @return {undefined}
   */
  $scope.phoneCall = function(b) {
    if (b) {
      /** @type {string} */
      document.location.href = "tel:" + b;
    } else {
      _.alert({
        template : "<div class='tc'>该员工没有记录电话号码</div>",
        okText : "确定"
      });
    }
  };
  /**
   * @param {string} b
   * @return {undefined}
   */
  $scope.smsSend = function(b) {
    if (b) {
      /** @type {string} */
      document.location.href = "sms:" + b;
    } else {
      _.alert({
        template : "<div class='tc'>该员工没有记录电话号码</div>",
        okText : "确定"
      });
    }
  };
  /**
   * @return {undefined}
   */
  var onComplete = function() {
    data_user.get("/KEY175").success(function($location) {
      $scope.allComStore = $location;
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("userManListRefresh")) {
      if ($templateCache.get("userManListRefresh") === true) {
        $scope.getList();
        onComplete();
        $templateCache.put("userManListRefresh", false);
      }
    }
  });
  onComplete();
  $scope.getList();
}]).controller("UserManEditCtrl", ["$scope", "psisServices", "lbSpinnerDialog", "$stateParams", "md5", "$ionicPopup", "$ionicModal", "lruPersistCache", "$ionicPopover", "Tools", "$interval", "$rootScope", function($scope, t, loading, data, bucket, view, $modal, $templateCache, deepDataAndEvents, app, me, dataAndEvents) {
  var userId = data.userId;
  /** @type {string} */
  $scope.editOrAdd = userId ? "edit" : "add";
  $scope.viewTitle = userId ? $scope.NameConstant.KEY252 : $scope.NameConstant.USERMANADD;
  $scope.user = {};
  $scope.passwordObject = {};
  $scope.user = {
    status : 1,
    roles : []
  };
  $scope.checklist = {};
  /** @type {Array} */
  $scope.checklist.userRoles = [];
  /** @type {number} */
  $scope.checklist.userRoles.length = 0;
  $scope.company = {};
  /** @type {Array} */
  $scope.company.userStoreItem = [];
  $scope.company.storeUser = {};
  $scope.storeUserConfig = {
    viewOtherComStore : null,
    editOtherComStore : null
  };
  $modal.fromTemplateUrl("html/PShopBaseInfo/KEY077.html", function($location) {
    $scope.comStoreModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.comStoreModal.remove();
  });
  $modal.fromTemplateUrl("updateCellPhone.html", function($location) {
    /** @type {number} */
    $scope.updateCellPhoneModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.openUpdateCellPhoneModal = function() {
    $scope.refreshValidateCodeImg();
    $scope.updateCellPhoneModal.show();
  };
  $scope.$on("$destroy", function() {
    $scope.comStoreModal.remove();
    $scope.updateCellPhoneModal.remove();
  });
  /**
   * @param {Element} object
   * @return {undefined}
   */
  $scope.selectComStore = function(object) {
    if (null == $scope.company.storeUser || null == $scope.company.storeUser.storeId) {
      $scope.company.storeUser = {};
    }
    $scope.company.storeUser.storeId = $scope.company.storeUser.storeId == object.id ? null : object.id;
    $scope.comStoreModal.hide();
  };
  /**
   * @param {?} m
   * @return {?}
   */
  $scope.filterRole = function(m) {
    return!(4 == m.roleId);
  };
  /**
   * @return {undefined}
   */
  $scope.loadRoleList = function() {
    t.post("/KEY239").success(function(data) {
      $scope.roles = data.rows;
    });
  };
  /**
   * @return {?}
   */
  var onerror = function() {
    return void 0 == $scope.passwordObject.passwordInput || "" == $scope.passwordObject.passwordInput ? ($scope.showMessage("密码不能为空"), false) : $scope.passwordObject.passwordInput.length < 6 ? ($scope.showMessage("请输入至少六位的密码长度"), false) : $scope.passwordObject.passwordInput !== $scope.passwordObject.pwConfirm ? ($scope.showMessage("两次填写的密码不一致"),
    false) : true;
  };
  /**
   * @return {undefined}
   */
  $scope.saveUserMan = function() {
    /** @type {RegExp} */
    var rhtml = /^[a-zA-Z0-9]*$/;
    /** @type {RegExp} */
    var reWhitespace = /^[0-9]{11}$/;
    /** @type {RegExp} */
    var rchecked = /^[a-z0-9!#$%&'*+\/=?^_`{|}~.-]+@[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$/i;
    /** @type {number} */
    $scope.user.status = 1 == $scope.user.settingT ? 1 : 0;
    if ($scope.storeUserConfig.viewOtherComStore && $scope.storeUserConfig.editOtherComStore) {
      /** @type {number} */
      $scope.company.storeUser.viewOtherComStore = 3;
    } else {
      if ($scope.storeUserConfig.viewOtherComStore && !$scope.storeUserConfig.editOtherComStore) {
        /** @type {number} */
        $scope.company.storeUser.viewOtherComStore = 1;
      } else {
        if (!$scope.storeUserConfig.viewOtherComStore) {
          if (!$scope.storeUserConfig.editOtherComStore) {
            /** @type {number} */
            $scope.company.storeUser.viewOtherComStore = 2;
          }
        }
      }
    }
    if ($scope.user.userName) {
      if (!rhtml.test($scope.user.userName) || reWhitespace.test($scope.user.userName)) {
        $scope.showMessage("员工帐号必须由字母或数字组成且不可为11位手机号");
      } else {
        loading.show(true);
        t.get("/KEY235?value=" + $scope.user.userName).success(function(e) {
          if (0 == e.isValid) {
            $scope.showMessage("员工帐号已被使用");
            /** @type {string} */
            $scope.user.userName = "";
          } else {
            if ($scope.user.realName) {
              if (onerror()) {
                if (void 0 == $scope.user.email || ("" == $scope.user.email || rchecked.test($scope.user.email))) {
                  $scope.user.password = $scope.passwordObject.passwordInput ? bucket.createHash($scope.passwordObject.passwordInput).toUpperCase() : void 0;
                  t.postArrParamEncode("/KEY243", {
                    user : angular.toJson($scope.user),
                    roles : $scope.checklist.userRoles,
                    storeUserJson : angular.toJson($scope.company.storeUser)
                  }).success(function(r) {
                    if (1 == r.statusCode) {
                      if (window.cordova && window.cordova.plugins) {
                        app.showAlert("", function() {
                          return $templateCache.put("userManListRefresh", true), $scope.goBack(), true;
                        }, "操作成功", "确定");
                      } else {
                        view.alert({
                          template : "<div class='tc'>操作成功</div>",
                          okText : "确定"
                        }).then(function() {
                          return $templateCache.put("userManListRefresh", true), $scope.goBack(), true;
                        });
                      }
                    } else {
                      $scope.showMessage("操作失败");
                    }
                  });
                } else {
                  $scope.showMessage("邮箱验证不正确");
                }
              }
            } else {
              $scope.showMessage("姓名不能为空");
            }
          }
        }).finally(function() {
          loading.hide();
        });
      }
    } else {
      $scope.showMessage("员工帐号不能为空");
    }
  };
  /**
   * @param {string} userId
   * @return {undefined}
   */
  $scope.deleteUser = function(userId) {
    var promise = view.confirm({
      template : "<div class='tc'>您确认要删除该员工?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        t.postEncode("/KEY244", {
          id : userId
        }).success(function(r) {
          if (1 == r.statusCode) {
            if (window.cordova && window.cordova.plugins) {
              app.showAlert("", function() {
                $templateCache.put("userManListRefresh", true);
                $scope.goBack();
              }, "删除成功", "确定");
            } else {
              view.alert({
                template : "<div class='tc'>删除成功</div>",
                okText : "确定"
              }).then(function() {
                $templateCache.put("userManListRefresh", true);
                $scope.goBack();
              });
            }
          } else {
            if (0 == r.statusCode) {
              $scope.showMessage("删除失败，不能删除已被使用的用户！");
            }
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.updateUserMan = function() {
    /** @type {RegExp} */
    var rhtml = /^[a-zA-Z0-9]*$/;
    /** @type {RegExp} */
    var reWhitespace = /^[0-9]{11}$/;
    /** @type {RegExp} */
    var rchecked = /^[a-z0-9!#$%&'*+\/=?^_`{|}~.-]+@[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$/i;
    /** @type {number} */
    $scope.user.status = 1 == $scope.user.settingT ? 1 : 0;
    if ($scope.storeUserConfig.viewOtherComStore && $scope.storeUserConfig.editOtherComStore) {
      /** @type {number} */
      $scope.company.storeUser.viewOtherComStore = 3;
    } else {
      if ($scope.storeUserConfig.viewOtherComStore && !$scope.storeUserConfig.editOtherComStore) {
        /** @type {number} */
        $scope.company.storeUser.viewOtherComStore = 1;
      } else {
        if (!$scope.storeUserConfig.viewOtherComStore) {
          if (!$scope.storeUserConfig.editOtherComStore) {
            /** @type {number} */
            $scope.company.storeUser.viewOtherComStore = 2;
          }
        }
      }
    }
    if ($scope.user.userName) {
      if (!rhtml.test($scope.user.userName) || reWhitespace.test($scope.user.userName)) {
        $scope.showMessage("员工帐号必须由字母或数字组成且不可为11位手机号");
      } else {
        loading.show(true);
        t.get("/KEY235?userId=" + $scope.user.id + "&value=" + $scope.user.userName).success(function(e) {
          if (0 == e.isValid) {
            $scope.showMessage("员工帐号已被使用");
            /** @type {string} */
            $scope.user.userName = "";
          } else {
            if ($scope.user.realName) {
              if (void 0 == $scope.user.email || ("" == $scope.user.email || rchecked.test($scope.user.email))) {
                t.postArrParamEncode("/KEY242", {
                  user : angular.toJson($scope.user),
                  roles : $scope.checklist.userRoles,
                  storeUserJson : angular.toJson($scope.company.storeUser)
                }).success(function(res) {
                  return 1 != res.statusCode ? ($scope.showMessage("保存失败"), false) : void(window.cordova && window.cordova.plugins ? app.showAlert("", function() {
                    $templateCache.put("userManListRefresh", true);
                    dataAndEvents.refreshAccRecource();
                    t.httpCacheGet.remove(t.httpCacheGet.ac.KEY177);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.STOREHOUSEAVAILABLE);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.ALLACCOUNT);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.COMPANYUSERBYCOMSTORE);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.COMPANYUSERBYPARAM);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.COMPANYUSERBYCASHIER);
                    $scope.company.storeUser = res.object.storeUser;
                    $scope.user.optimisticLockVersion = res.object.user.optimisticLockVersion;
                    $scope.goBack();
                  }, "保存成功", "确定") : view.alert({
                    template : "<div class='tc'>保存成功</div>",
                    okText : "确定"
                  }).then(function() {
                    $templateCache.put("userManListRefresh", true);
                    dataAndEvents.refreshAccRecource();
                    t.httpCacheGet.remove(t.httpCacheGet.ac.KEY177);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.STOREHOUSEAVAILABLE);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.ALLACCOUNT);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.COMPANYUSERBYCOMSTORE);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.COMPANYUSERBYPARAM);
                    t.httpCacheGet.remove(t.httpCacheGet.ac.COMPANYUSERBYCASHIER);
                    $scope.company.storeUser = res.object.storeUser;
                    $scope.user.optimisticLockVersion = res.object.user.optimisticLockVersion;
                    $scope.goBack();
                  }));
                });
              } else {
                $scope.showMessage("邮箱格式不正确");
              }
            } else {
              $scope.showMessage("姓名不能为空");
            }
          }
        }).finally(function() {
          loading.hide();
        });
      }
    } else {
      $scope.showMessage("员工帐号不能为空");
    }
  };
  /**
   * @return {undefined}
   */
  $scope.resetPass = function() {
    /**
     * @param {?} value
     * @return {undefined}
     */
    function update(value) {
      /** @type {RegExp} */
      var rchecked = /^[\S]{6,20}$/;
      if (rchecked.test(value)) {
        t.postEncode("/KEY443", {
          userId : $scope.user.id,
          newPass : bucket.createHash(value).toUpperCase()
        }).success(function(file) {
          app.toastShow(file.content);
        });
      } else {
        $scope.showMessage("密码必须为6到20位非空字符");
      }
    }
    /** @type {string} */
    $scope.user.reSetPass = "";
    view.show({
      cssClass : "lb-KEY291-popup",
      template : '<input type="password" class="tc" ng-model="user.reSetPass" autofocus="true" placeholder="请输入新密码">',
      title : "重置密码",
      scope : $scope,
      buttons : [{
        text : "取消",
        /**
         * @return {undefined}
         */
        onTap : function() {
        }
      }, {
        text : "确认",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          update($scope.user.reSetPass);
        }
      }]
    });
  };
  $scope.validatePhone = {
    smsType : 1
  };
  /** @type {string} */
  $scope.getMessageText = "获取短信验证码";
  /** @type {boolean} */
  $scope.showSMSCodeValidate = false;
  /** @type {boolean} */
  $scope.disableMsgBtn = false;
  $scope.cellphoneObj = {};
  /** @type {number} */
  $scope.sesconds = 60;
  var val;
  /**
   * @return {?}
   */
  $scope.cellphoneValidate = function() {
    return app.isValidCellPhoneNo($scope.cellphoneObj.cellphone);
  };
  /**
   * @return {?}
   */
  $scope.validateInput = function() {
    return $scope.cellphoneValidate();
  };
  /**
   * @param {?} event
   * @return {?}
   */
  $scope.getValidateSMS = function(event) {
    if (event.stopPropagation() && event.preventDefault(), !$scope.validateInput()) {
      return app.toastShow("请输入11位手机号！"), $scope.refreshValidateCodeImg(), false;
    }
    if (!$scope.cellphoneObj.verifyCode) {
      return app.toastShow("请输入图片验证码！"), false;
    }
    loading.show();
    var attributes = {
      cellphone : $scope.cellphoneObj.cellphone,
      verifyCode : $scope.cellphoneObj.verifyCode
    };
    t.postEncode("/KEY394", attributes).success(function(result) {
      loading.hide();
      if (1 == result.statusCode) {
        /** @type {string} */
        $scope.getMessageText = "60秒后重新获取";
        /** @type {boolean} */
        $scope.showSMSCodeValidate = true;
        /** @type {boolean} */
        $scope.disableMsgBtn = true;
        val = me(function() {
          if ($scope.sesconds > 0) {
            $scope.sesconds--;
            /** @type {string} */
            $scope.getMessageText = $scope.sesconds + "秒后重新获取";
          } else {
            if (angular.isDefined(val)) {
              me.cancel(val);
              val = void 0;
            }
            /** @type {number} */
            $scope.sesconds = 60;
            /** @type {boolean} */
            $scope.disableMsgBtn = false;
            /** @type {string} */
            $scope.getMessageText = "获取短信验证码";
          }
        }, 1E3);
      } else {
        if (2 == result.statusCode) {
          $scope.refreshValidateCodeImg();
          /** @type {string} */
          $scope.getMessageText = "获取短信验证码";
          /** @type {boolean} */
          $scope.disableMsgBtn = false;
          app.toastShow(result.content);
        } else {
          if (3 == result.statusCode) {
            $scope.phoneErrTxt = result.content;
            $scope.refreshValidateCodeImg();
            if (window.cordova && window.cordova.plugins) {
              app.showAlert($scope.phoneErrTxt, function() {
                /** @type {boolean} */
                $scope.disableMsgBtn = false;
              }, "出错了");
            } else {
              view.alert({
                template : "<div class='tc'>" + $scope.phoneErrTxt + "</div>",
                okText : "确定"
              }).then(function() {
                /** @type {boolean} */
                $scope.disableMsgBtn = false;
              });
            }
          }
        }
      }
    }).error(function() {
      loading.hide();
      /** @type {boolean} */
      $scope.disableMsgBtn = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.updateCellPhone = function() {
    loading.show(true);
    t.postEncode("/KEY428", {
      userId : $scope.user.id,
      smsCode : $scope.cellphoneObj.smsCode
    }).success(function(data) {
      if (loading.hide(), 1 == data.statusCode) {
        app.showAlert(data.content, null);
        $scope.updateCellPhoneModal.hide();
        $scope.cellphoneObj = {};
        $scope.refreshValidateCodeImg();
        var settingT = $scope.user.settingT;
        $scope.user = data.object;
        $scope.user.settingT = settingT;
      } else {
        if (2 == data.statusCode) {
          app.toastShow(data.content);
          $scope.refreshValidateCodeImg();
          /** @type {string} */
          $scope.cellphoneObj.smsCode = "";
          /** @type {boolean} */
          $scope.verifySmsCodeError = true;
        } else {
          app.toastShow(data.content);
        }
      }
    }).error(function(status, dataAndEvents) {
      loading.hide();
      if (0 != dataAndEvents) {
        app.toastShow("error:" + status);
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.refreshValidateCodeImg = function() {
    $scope.validateCodeImgUrl = $scope.getValidateCodeImgUrl();
  };
  /**
   * @param {number} key
   * @return {undefined}
   */
  $scope.selectRole = function(key) {
    if (4 != key) {
      var camelKey = $scope.checklist.userRoles.indexOf(key);
      if (camelKey > -1) {
        $scope.checklist.userRoles.splice(camelKey, 1);
      } else {
        $scope.checklist.userRoles.push(key);
      }
    }
  };
  if (userId) {
    loading.show();
    t.get("/KEY241?id=" + data.userId).success(function(data) {
      if ($scope.user = data.user, $scope.company.storeUser = data.storeUser ? data.storeUser : {}, $scope.checklist.userRoles.length = 0, 0 != data.userRoles.length) {
        /** @type {number} */
        var i = 0;
        for (;i < data.userRoles.length;i++) {
          $scope.checklist.userRoles.push(data.userRoles[i].roleId);
        }
      }
      switch($scope.user.settingT = 1 == $scope.user.status, $scope.company.storeUser.viewOtherComStore) {
        case 1:
          /** @type {boolean} */
          $scope.storeUserConfig.viewOtherComStore = true;
          /** @type {boolean} */
          $scope.storeUserConfig.editOtherComStore = false;
          break;
        case 2:
          /** @type {boolean} */
          $scope.storeUserConfig.viewOtherComStore = false;
          /** @type {boolean} */
          $scope.storeUserConfig.editOtherComStore = false;
          break;
        case 3:
          /** @type {boolean} */
          $scope.storeUserConfig.viewOtherComStore = true;
          /** @type {boolean} */
          $scope.storeUserConfig.editOtherComStore = true;
      }
    }).finally(function() {
      loading.hide();
    });
  }
  $scope.loadRoleList();
  /** @type {boolean} */
  $scope.user.settingT = true;
  $scope.$watch("storeUserConfig.editOtherComStore", function() {
    if ($scope.storeUserConfig.editOtherComStore) {
      /** @type {boolean} */
      $scope.storeUserConfig.viewOtherComStore = true;
    }
  });
  $scope.$watch("storeUserConfig.viewOtherComStore", function() {
    if (!$scope.storeUserConfig.viewOtherComStore) {
      /** @type {boolean} */
      $scope.storeUserConfig.editOtherComStore = false;
    }
  });
}]).controller("ComStoreCtrl", ["$scope", "psisServices", "$ionicPopup", "Tools", "$ionicPopover", "$ionicModal", "lbSpinnerDialog", "$state", "lruPersistCache", "lbScrollDelegate", function($scope, db, _, app, dataAndEvents, $modal, loading, $state, $templateCache, parent) {
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.queryCondition = {};
  /** @type {string} */
  $scope.comStoreEditModalTitle = "";
  $modal.fromTemplateUrl("html/PShopBaseInfo/KEY232.html", function($location) {
    /** @type {number} */
    $scope.comStoreEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.comStoreEditModal.remove();
  });
  /**
   * @param {Element} ignores
   * @return {undefined}
   */
  $scope.goToUserList = function(ignores) {
    if (ignores) {
      $state.go("eventmenu.KEY253", {
        storeId : ignores.id
      });
    } else {
      $state.go("eventmenu.KEY253", {
        storeId : null
      });
    }
  };
  /**
   * @param {string} dataAndEvents
   * @param {Object} $location
   * @param {?} newVal
   * @return {undefined}
   */
  $scope.openComStore = function(dataAndEvents, $location, newVal) {
    if ("insert" === dataAndEvents) {
      /** @type {string} */
      $scope.comStoreEditModalTitle = "新增部门";
      $scope.KEY232 = {
        showOrder : 100
      };
      /** @type {boolean} */
      $scope.isEditType = false;
    } else {
      if ("update" === dataAndEvents) {
        /** @type {string} */
        $scope.comStoreEditModalTitle = "编辑部门";
        /** @type {Object} */
        $scope.KEY232 = $location;
        /** @type {boolean} */
        $scope.isEditType = true;
      }
    }
    $scope.comStoreIndex = newVal;
    $scope.comStoreEditModal.show();
  };
  /**
   * @return {?}
   */
  var detect = function() {
    /** @type {RegExp} */
    var rhtml = /^[0-9-]*$/;
    return rhtml.test($scope.KEY232.phone) || ("" == $scope.KEY232.phone || void 0 == $scope.KEY232.phone);
  };
  /**
   * @return {?}
   */
  $scope.saveComStore = function() {
    if (!$scope.KEY232.storeName) {
      return app.toastShow("请填写名称！", "short", "center"), console.log("请填写名称！"), false;
    }
    if (!$scope.KEY232.showOrder) {
      return app.toastShow("排序值须为正整数", "short", "center"), console.log("排序值须为正整数"), false;
    }
    if (!detect()) {
      return app.toastShow("电话必须是数字或-", "short", "center"), console.log("电话必须是数字或-"), false;
    }
    /** @type {boolean} */
    var o = !$scope.KEY232.id;
    var config = {
      storeName : $scope.KEY232.storeName
    };
    if (!o) {
      config.storeId = $scope.KEY232.id;
    }
    db.postEncode("/KEY177", config).success(function(e) {
      if (e.isValid) {
        db.postEncode("/KEY178", {
          strComStoreVO : angular.toJson($scope.KEY232)
        }).success(function(self) {
          if (1 == self.statusCode) {
            app.toastShow("保存成功！");
            $scope.getList();
            var header = {
              id : self.object.id,
              storeName : self.object.storeName
            };
            if ("function" == typeof $scope.selectComStore) {
              $scope.selectComStore(header, true);
            }
            app.union($scope.KEY232, self.object);
            $scope.comStoreEditModal.hide();
            db.httpCacheGet.remove(db.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
            db.httpCacheGet.remove(db.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
            $templateCache.put("userManListRefresh", true);
            $templateCache.put("storeListRefresh", true);
            $templateCache.put("refreshAccountList", true);
          } else {
            app.toastShow("保存失败！");
          }
        });
      } else {
        app.toastShow("部门已存在！", "short", "center");
        console.log("部门已存在！");
      }
    });
  };
  /**
   * @param {Object} opts
   * @return {?}
   */
  $scope.deleteComStore = function(opts) {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除" + opts.storeName + "?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        db.post("/KEY179?id=" + opts.id).success(function(file) {
          app.toastShow(file.content);
          $scope.getList();
          $templateCache.put("userManListRefresh", true);
          if ($scope.company.storeUser) {
            if ($scope.company.storeUser.storeId == opts.id) {
              $scope.company.storeUser = {};
              /** @type {string} */
              $scope.company.storeUser.storeId = "";
            }
          }
          db.httpCacheGet.remove(db.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
          db.httpCacheGet.remove(db.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
        });
      }
    }), true;
  };
  /**
   * @param {?} name
   * @return {?}
   */
  var Step = function(name) {
    return db.postEncode("/KEY176", name);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show();
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step($scope.queryCondition).success(function(results) {
      if (null == $scope.company) {
        $scope.company = {};
      }
      $scope.company.userStoreItem = results.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = results.page < results.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.scrollTop("comStoreCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    Step($scope.queryCondition).success(function(options) {
      $scope.company.userStoreItem = $scope.company.userStoreItem.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("comStoreCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    $scope.queryCondition = {};
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step($scope.queryCondition).success(function(results) {
      $scope.company.userStoreItem = results.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = results.page < results.total;
    });
  };
  $scope.getList();
}]).controller("FindPasswordCtrl", ["$scope", "$rootScope", "$state", "psisServices", "$interval", "Tools", "$ionicPopup", "lbSpinnerDialog", "$ionicModal", "BusinessConstant", function($scope, dataAndEvents, app, $rootScope, result, _, view, loading, $modal, data) {
  $scope.validatePhone = {};
  /** @type {string} */
  $scope.getMessageText = "获取短信验证码";
  /** @type {number} */
  $scope.sesconds = 60;
  /** @type {boolean} */
  $scope.disableMsgBtn = false;
  /** @type {boolean} */
  $scope.showSMSCodeValidate = false;
  var val;
  $scope.internationalCodes = data.INTERNATIONALCODES;
  $scope.obj = {};
  $scope.obj.areaCode = $scope.internationalCodes[0].code;
  $modal.fromTemplateUrl("html/PSystemSetup/KEY127.html", function($location) {
    $scope.internationalCodeModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.openInternationalCodeModal = function() {
    $scope.internationalCodeModal.show();
  };
  $scope.$on("$destroy", function() {
    $scope.internationalCodeModal.remove();
  });
  /**
   * @return {?}
   */
  $scope.cellphoneValidate = function() {
    return _.isValidCellPhoneNo($scope.validatePhone.cellphone, $scope.validatePhone.pre);
  };
  /**
   * @return {?}
   */
  $scope.getSubmitCellphone = function() {
    if ("" == $scope.validatePhone.pre || void 0 == $scope.validatePhone.pre) {
      return $scope.validatePhone.cellphone;
    }
    var frag = $scope.validatePhone.cellphone;
    return "0" == frag.substr(0, 1) && (frag = frag.substr(1)), frag = $scope.validatePhone.pre + frag;
  };
  /**
   * @return {?}
   */
  $scope.validateInput = function() {
    return!$scope.cellphoneValidate() || $scope.disableMsgBtn;
  };
  /**
   * @return {undefined}
   */
  $scope.getValidateSMS = function() {
    /** @type {string} */
    $scope.validatePhone.verifyCode = "idjisfjw";
    var options = {};
    _.union(options, $scope.validatePhone);
    options.cellphone = $scope.getSubmitCellphone();
    /** @type {boolean} */
    $scope.disableMsgBtn = true;
    $rootScope.postEncode("/KEY448", options).success(function(r) {
      if (1 == r.statusCode) {
        /** @type {string} */
        $scope.getMessageText = "60秒后重新获取";
        /** @type {boolean} */
        $scope.showSMSCodeValidate = true;
        val = result(function() {
          if ($scope.sesconds > 0) {
            $scope.sesconds--;
            /** @type {string} */
            $scope.getMessageText = $scope.sesconds + "秒后重新获取";
          } else {
            if (angular.isDefined(val)) {
              result.cancel(val);
              val = void 0;
            }
            /** @type {number} */
            $scope.sesconds = 60;
            /** @type {string} */
            $scope.getMessageText = "获取短信验证码";
            /** @type {boolean} */
            $scope.disableMsgBtn = false;
          }
        }, 1E3);
      } else {
        if (3 == r.statusCode) {
          view.alert({
            template : "<div class='tc'>该手机号尚未注册过，请先注册</div>",
            okText : "确定"
          }).then(function() {
            /** @type {boolean} */
            $scope.disableMsgBtn = false;
            $scope.viewReplace();
            if ($scope.validatePhone.pre && null != $scope.validatePhone.pre) {
              app.go("register", {
                phonePre : {
                  pre : $scope.validatePhone.pre,
                  areaCode : $scope.obj.areaCode
                }
              });
            } else {
              app.go("register");
            }
          });
        }
      }
    }).error(function() {
      /** @type {boolean} */
      $scope.disableMsgBtn = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.gotoSignIn = function() {
    if (window.cordova && (window.cordova.plugins && window.cordova.plugins.Keyboard)) {
      cordova.plugins.Keyboard.close();
      window.setTimeout(function() {
        $scope.goBack();
      }, 500);
    } else {
      $scope.goBack();
    }
  };
  /**
   * @return {undefined}
   */
  $scope.validateSmsCode = function() {
    loading.show();
    $rootScope.postEncode("/KEY447", $scope.validatePhone).success(function(r) {
      if (1 == r.statusCode) {
        app.go("KEY206");
      } else {
        if (2 == r.statusCode) {
          _.toastShow("验证码不正确，请重新输入");
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
}]).controller("ResetPasswordCtrl", ["$scope", "$rootScope", "$state", "psisServices", "$ionicPopup", "md5", "$window", "lbSpinnerDialog", function(files, dataAndEvents, app, res, _, md5, options, loading) {
  files.userAndCom = {};
  /**
   * @return {?}
   */
  files.save = function() {
    return files.userAndCom.newPass.length < 6 ? (_.alert({
      template : "<div class='tc'>请输入至少六位的密码长度</div>",
      okText : "确定"
    }), false) : files.userAndCom.newPass !== files.userAndCom.password2 ? (_.alert({
      template : "<div class='tc'>两次填写的密码不一致</div>",
      okText : "确定"
    }), false) : (loading.show(), files.userAndCom.password2 = "", files.userAndCom.newPass = files.userAndCom.newPass ? md5.createHash(files.userAndCom.newPass).toUpperCase() : void 0, void res.postEncode("/KEY449", files.userAndCom).success(function(res) {
      if (1 == res.statusCode) {
        _.alert({
          template : "<div class='tc'>重置密码成功</div>",
          okText : "确定"
        }).then(function() {
          options.localStorage.KEY293 = res.object.cellphone;
          /** @type {string} */
          options.localStorage.password = "";
          app.go("signin");
        });
      } else {
        _.alert({
          template : "<div class='tc'>重置密码失败</div>",
          okText : "确定"
        });
      }
    }).finally(function() {
      loading.hide();
    }));
  };
}]).controller("PrintSettingCtrl", ["$scope", "$rootScope", "$state", "psisServices", "$ionicPopup", "lbSpinnerDialog", "BluetoothPrintService", "OrderType", "Tools", "commonDataInterface", "ServerConfig", "$window", function(self, mod, $state, result, ignoreMethodDoesntExist, loading, textAlt, Hammer, dataAndEvents, deepDataAndEvents, context, $window) {
  /** @type {Array} */
  self.items = [];
  /** @type {boolean} */
  self.noListItems = false;
  /**
   * @return {undefined}
   */
  self.getList = function() {
    loading.show();
    result.httpCacheGet.get("/KEY118?templateKey=mobilePrintTemplate.ConfigList").success(function(res) {
      /** @type {*} */
      self.items = null == res.object ? [] : eval(res.object);
      if (0 === self.items.length) {
        /** @type {boolean} */
        self.noListItems = true;
      }
    }).error(function() {
      dataAndEvents.toastShow("获取数据过程中出错！");
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {Function} type
   * @return {undefined}
   */
  self.goDetail = function(type) {
    if (type == Hammer.logisticsOrder) {
      $state.go("eventmenu.KEY002", {
        /** @type {Function} */
        typeId : type
      });
    } else {
      $state.go("eventmenu.KEY110", {
        /** @type {Function} */
        typeId : type
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.KEY205 = function() {
    $state.go("eventmenu.KEY205");
  };
  self.$on("$ionicView.loaded", function() {
    self.getList();
    deepDataAndEvents.getUserConfig("QRCodeForShop").then(function(res) {
      if (1 == res.statusCode) {
        if (res.object) {
          $window.localStorage.PrintQRCode = res.object.configValue;
        } else {
          if (self.GetOperatorEventLimit("KEY261")) {
            var path = context.tmsServer.replace(/cid/, mod.mainCompany.id);
            if (context.currentServer === context.exServer) {
              path = path.replace(/www/, "ex");
            } else {
              if (context.currentServer.indexOf("dev") >= 0) {
                path = path.replace(/www/, "dev");
              }
            }
            var obj = {
              text : path,
              slogan : "扫一扫关注店铺",
              enable : false
            };
            /** @type {string} */
            $window.localStorage.PrintQRCode = JSON.stringify(obj);
          } else {
            /** @type {string} */
            $window.localStorage.PrintQRCode = JSON.stringify({
              text : "",
              slogan : "",
              enable : false
            });
          }
        }
      }
    });
  });
}]).controller("PrintSettingDetailCtrl", ["$scope", "$rootScope", "$state", "$stateParams", "psisServices", "$ionicPopup", "$window", "lbSpinnerDialog", "OrderType", "Tools", "$q", "ServerConfig", function(self, ignoreMethodDoesntExist, textAlt, photo, db, keepData, $window, loading, typeId, dataAndEvents, $q, deepDataAndEvents) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = db.httpCacheGet.get("/KEY118?templateKey=mobilePrintTemplate." + self.KEY221.typeId);
    var getPromise3 = db.get("/KEY119?orderType=" + self.KEY221.typeId);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  self.KEY221 = {};
  self.KEY221.typeId = photo.typeId;
  /** @type {boolean} */
  self.sizeHorizenAble = self.KEY221.typeId >= 1 && self.KEY221.typeId <= 5;
  self.titleName = typeId.typeName[self.KEY221.typeId];
  /** @type {boolean} */
  self.KEY221.autoPrinted = void 0 !== $window.localStorage["QSAutoPrinted" + self.KEY221.typeId] ? "true" == $window.localStorage["QSAutoPrinted" + self.KEY221.typeId] : false;
  /** @type {string} */
  self.KEY221.printType = "goodsGroupPrint";
  /** @type {Array} */
  self.KEY221.printTypesOptions = [{
    value : "goodsGroupPrint",
    title : "按商品汇总明细"
  }, {
    value : "goodsDetailPrint",
    title : "按单品明细"
  }];
  if (self.sizeHorizenAble) {
    self.KEY221.printTypesOptions.push({
      value : "sizeHorizonPrint",
      title : "尺码横向排列"
    });
  }
  /** @type {string} */
  self.KEY221.printSize = "80mm";
  /** @type {Array} */
  self.KEY221.printTimesOptions = [{
    value : 1,
    title : "1份"
  }, {
    value : 2,
    title : "2份"
  }, {
    value : 3,
    title : "3份"
  }, {
    value : 4,
    title : "4份"
  }, {
    value : 5,
    title : "5份"
  }];
  /** @type {Array} */
  self.KEY221.printSizesOptions = [{
    value : "58mm",
    title : "58mm"
  }, {
    value : "80mm",
    title : "80mm"
  }, {
    value : "110mm",
    title : "110mm"
  }, {
    value : "ep-basic",
    title : "针式基础模板"
  }];
  /** @type {Array} */
  self.KEY221.halvingTypeOptions = [{
    title : "二等分",
    value : "halving"
  }, {
    title : "三等分",
    value : "trisection"
  }, {
    title : "全等分",
    value : "all"
  }];
  /** @type {number} */
  self.KEY221.printTimes = 1;
  /** @type {Array} */
  self.columnList = [];
  /** @type {Array} */
  self.checkColumns = [];
  self.$on("$ionicView.loaded", function() {
    loading.show();
    fetch().then(function(packs) {
      if (self.columnList = eval(packs[0].data.object), null == self.columnList && (self.KEY221.typeId == typeId.fastReceiptOrder && (self.columnList = [{
        name : "clientName",
        cnName : "客户名称"
      }, {
        name : "receiptSn",
        cnName : "收款单号"
      }, {
        name : "payType",
        cnName : "收款类型"
      }, {
        name : "accountItemName",
        cnName : "账目类型"
      }, {
        name : "amount",
        cnName : "本次收款"
      }, {
        name : "createTime",
        cnName : "收款日期"
      }, {
        name : "accountName",
        cnName : "结算账户"
      }, {
        name : "remark",
        cnName : "备注"
      }, {
        name : "printTime",
        cnName : "打印时间"
      }])), packs[1].data.object) {
        self.KEY221.id = packs[1].data.object.id;
        self.KEY221.printType = packs[1].data.object.printType ? packs[1].data.object.printType : "goodsGroupPrint";
        self.KEY221.printSize = packs[1].data.object.templateType;
        if (self.KEY221.printSize.indexOf("ep-basic") > -1) {
          self.KEY221.halvingType = self.KEY221.printSize.substr(9);
          /** @type {string} */
          self.KEY221.printSize = "ep-basic";
        }
        self.KEY221.headerText = packs[1].data.object.headerText;
        self.KEY221.footerText = packs[1].data.object.footerText;
        self.checkColumns = null != packs[1].data.object.selectColumnNames && "" != packs[1].data.object.selectColumnNames ? packs[1].data.object.selectColumnNames.split(",") : [];
        self.KEY221.optimisticLockVersion = packs[1].data.object.optimisticLockVersion;
        self.KEY221.printTimes = null == packs[1].data.object.printTimes ? 1 : packs[1].data.object.printTimes;
        $window.localStorage["PrintTimes" + self.KEY221.typeId] = self.KEY221.printTimes;
      } else {
        if (null != self.columnList) {
          /** @type {number} */
          var a = 0;
          for (;a < self.columnList.length;a++) {
            if ("discount" != self.columnList[a].name) {
              if ("discountAmount" != self.columnList[a].name) {
                if ("clientScore" != self.columnList[a].name) {
                  self.checkColumns.push(self.columnList[a].name);
                }
              }
            }
          }
        }
        /** @type {string} */
        self.KEY221.footerText = "辛巴手机版" + (ionic.Platform.isAndroid() ? "Android版" : "iOS版") + "  V" + deepDataAndEvents.innerAppVersion;
      }
      self.KEY221.halvingType = "trisection" == self.KEY221.halvingType || "all" == self.KEY221.halvingType ? self.KEY221.halvingType : "halving";
      loading.hide();
    }, function() {
      dataAndEvents.toastShow("获取数据过程中出错！");
      loading.hide();
    });
  });
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectColumn = function(key) {
    var camelKey = self.checkColumns.indexOf(key);
    if (camelKey > -1) {
      self.checkColumns.splice(camelKey, 1);
    } else {
      self.checkColumns.push(key);
    }
  };
  /**
   * @return {undefined}
   */
  self.saveSetting = function() {
    loading.show(true);
    self.KEY221.halvingType = "trisection" == self.KEY221.halvingType || "all" == self.KEY221.halvingType ? self.KEY221.halvingType : "halving";
    var templateType = "ep-basic" == self.KEY221.printSize ? "ep-basic " + self.KEY221.halvingType : self.KEY221.printSize;
    var user = {
      id : self.KEY221.id,
      orderType : self.KEY221.typeId,
      templateType : templateType,
      templateName : self.titleName,
      selectColumnNames : self.checkColumns.toString(),
      headerText : self.KEY221.headerText,
      footerText : self.KEY221.footerText,
      optimisticLockVersion : self.KEY221.optimisticLockVersion,
      printTimes : self.KEY221.printTimes
    };
    if (21 != self.KEY221.typeId) {
      user.printType = self.KEY221.printType;
    }
    db.post("/KEY120", user).success(function(res) {
      if (1 == res.statusCode) {
        dataAndEvents.toastShow("保存成功！");
        self.KEY221.id = res.object.id;
        self.KEY221.optimisticLockVersion = res.object.optimisticLockVersion;
        $window.localStorage["QSAutoPrinted" + self.KEY221.typeId] = self.KEY221.autoPrinted;
        $window.localStorage["PrintTimes" + self.KEY221.typeId] = null == res.object.printTimes ? self.KEY221.printTimes : res.object.printTimes;
        self.goBack();
      } else {
        dataAndEvents.toastShow("保存过程中出错！");
      }
    }).finally(function() {
      loading.hide();
      db.httpCacheGet.remove("/KEY119?orderType=" + self.KEY221.typeId);
    });
  };
}]).controller("PrintSettingDetailForExpressCtrl", ["$scope", "$rootScope", "$state", "$stateParams", "psisServices", "$ionicPopup", "$window", "lbSpinnerDialog", "OrderType", "Tools", "$q", "ServerConfig", function(self, ignoreMethodDoesntExist, textAlt, photo, db, keepData, $window, loading, o, dataAndEvents, $q, deepDataAndEvents) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = db.httpCacheGet.get("/KEY118?templateKey=mobilePrintTemplate." + self.KEY221.typeId);
    var getPromise3 = db.get("/KEY119?orderType=" + self.KEY221.typeId);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  if (self.KEY221 = {}, self.printTypeId = o.ehsopLogisticsOrder, self.KEY221.typeId = photo.typeId, self.titleName = o.typeName[self.KEY221.typeId], self.KEY221.typeId == o.ehsopLogisticsOrder && (self.KEY221.typeId = o.logisticsOrder), self.KEY221.printType = "ZTO", self.KEY221.printTypesOptions = [{
    value : "ZTO",
    title : "中通"
  }, {
    value : "YTO",
    title : "圆通"
  }, {
    value : "STO",
    title : "申通"
  }, {
    value : "BEST",
    title : "百世汇通"
  }, {
    value : "YUNDA",
    title : "韵达"
  }, {
    value : "SF",
    title : "顺丰"
  }, {
    value : "EMS",
    title : "EMS"
  }, {
    value : "DIY",
    title : "自定义"
  }], deepDataAndEvents.commonConfig && (deepDataAndEvents.commonConfig.expressModel && deepDataAndEvents.commonConfig.expressModel.length > 0)) {
    var codeSegments = deepDataAndEvents.commonConfig.expressModel;
    /** @type {Array} */
    self.KEY221.printTypesOptions = [];
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      self.KEY221.printTypesOptions.push("Default" != codeSegments[i].key ? {
        value : codeSegments[i].key,
        title : codeSegments[i].name
      } : {
        value : "DIY",
        title : "自定义"
      });
    }
  }
  /** @type {string} */
  self.KEY221.printSize = "ep-basic";
  /** @type {Array} */
  self.KEY221.printTimesOptions = [{
    value : 1,
    title : "1份"
  }, {
    value : 2,
    title : "2份"
  }, {
    value : 3,
    title : "3份"
  }, {
    value : 4,
    title : "4份"
  }, {
    value : 5,
    title : "5份"
  }];
  var footerText = {
    senderNameX : 3,
    senderNameY : 5,
    senderNameW : 25,
    senderAddressX : 3,
    senderAddressY : 7,
    senderAddressW : 35,
    senderPhoneX : 3,
    senderPhoneY : 12,
    senderPhoneW : 12,
    receiverNameX : 53,
    receiverNameY : 5,
    receiverNameW : 25,
    receiverAddressX : 53,
    receiverAddressY : 7,
    receiverAddressW : 35,
    receiverPhoneX : 53,
    receiverPhoneY : 12,
    receiverPhoneW : 12
  };
  /** @type {number} */
  self.KEY221.printTimes = 1;
  /** @type {Array} */
  self.columnList = [];
  /** @type {Array} */
  self.checkColumns = [];
  loading.show();
  self.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      if (self.columnList = eval(packs[0].data.object), packs[1].data.object) {
        self.KEY221.id = packs[1].data.object.id;
        self.KEY221.printType = packs[1].data.object.printType ? packs[1].data.object.printType : "ZTO";
        try {
          /** @type {*} */
          self.KEY221.headerText = packs[1].data.object.headerText ? JSON.parse(packs[1].data.object.headerText) : {};
        } catch (e) {
          self.KEY221.headerText = {};
        }
        try {
          /** @type {*} */
          self.KEY221.footerText = packs[1].data.object.footerText ? JSON.parse(packs[1].data.object.footerText) : footerText;
        } catch (e) {
          self.KEY221.footerText = footerText;
        }
        self.checkColumns = null != packs[1].data.object.selectColumnNames && "" != packs[1].data.object.selectColumnNames ? packs[1].data.object.selectColumnNames.split(",") : [];
        self.KEY221.optimisticLockVersion = packs[1].data.object.optimisticLockVersion;
        self.KEY221.printTimes = null == packs[1].data.object.printTimes ? 1 : packs[1].data.object.printTimes;
        $window.localStorage["PrintTimes" + self.KEY221.typeId] = self.KEY221.printTimes;
      } else {
        if (self.KEY221.headerText = {}, self.KEY221.footerText = footerText, null != self.columnList) {
          /** @type {number} */
          var a = 0;
          for (;a < self.columnList.length;a++) {
            self.checkColumns.push(self.columnList[a].name);
          }
        }
      }
      loading.hide();
    }, function() {
      dataAndEvents.toastShow("获取数据过程中出错！");
      loading.hide();
    });
  });
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectColumn = function(key) {
    var camelKey = self.checkColumns.indexOf(key);
    if (camelKey > -1) {
      self.checkColumns.splice(camelKey, 1);
    } else {
      self.checkColumns.push(key);
    }
  };
  /**
   * @return {undefined}
   */
  self.saveSetting = function() {
    loading.show();
    var user = {
      id : self.KEY221.id,
      orderType : self.KEY221.typeId,
      templateType : self.KEY221.printSize,
      templateName : self.titleName,
      printType : self.KEY221.printType,
      selectColumnNames : self.checkColumns.toString(),
      headerText : JSON.stringify(self.KEY221.headerText),
      footerText : JSON.stringify(self.KEY221.footerText),
      optimisticLockVersion : self.KEY221.optimisticLockVersion,
      printTimes : self.KEY221.printTimes
    };
    db.post("/KEY120", user).success(function(res) {
      if (1 == res.statusCode) {
        dataAndEvents.toastShow("保存成功！");
        self.KEY221.id = res.object.id;
        self.KEY221.optimisticLockVersion = res.object.optimisticLockVersion;
        $window.localStorage["PrintTimes" + self.KEY221.typeId] = null == res.object.printTimes ? self.KEY221.printTimes : res.object.printTimes;
      } else {
        dataAndEvents.toastShow("保存过程中出错！");
      }
    }).finally(function() {
      loading.hide();
      db.httpCacheGet.remove("/KEY119?orderType=" + self.KEY221.typeId);
    });
  };
}]).controller("RecommendCtrl", ["$scope", "$state", "$stateParams", "psisServices", "$window", "lbSpinnerDialog", "Tools", "wechatShare", "$q", "$http", "ServerConfig", "$ionicActionSheet", "$ionicModal", "$sce", "qqShare", "lbScrollDelegate", "HandleMessageService", "$ionicPopup", "ServerType", function($scope, ignoreMethodDoesntExist, textAlt, newCanvas, keepData, loading, dataAndEvents, test, $q, $templateCache, current, opt_attributes, $modal, $sce,
assert, widget, socket, _, deepDataAndEvents) {
  /**
   * @return {?}
   */
  function load() {
    var imageDfd = $q.defer();
    return $templateCache.get(w + "/download/data/wechatShare.json?random=" + dataAndEvents.getTimeStamp()).success(function(image) {
      imageDfd.resolve(image);
    }).error(function() {
      console.error("从服务器获取微信分享注册有奖信息异常！");
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /** @type {number} */
  var page = 1;
  var w = current.currentServer.replace("/is", "").replace("ex.", "www.").replace("web.", "www.");
  /** @type {string} */
  $scope.currentUrl = w + "/isAppHtml/m/shareIntro.html?random=" + dataAndEvents.getTimeStamp() + "&userId=" + $scope.mainUserConfig.userId + "&cid=" + $scope.mainUserConfig.cid + "&userName=" + encodeURIComponent($scope.mainCompany.comName);
  $scope.currentUrl = $sce.trustAsResourceUrl($scope.currentUrl);
  /**
   * @param {Object} event
   * @return {undefined}
   */
  var completed = function(event) {
    socket.handleMessage(event, $scope);
  };
  window.addEventListener("message", completed, false);
  $scope.$on("$destroy", function() {
    window.removeEventListener("message", completed, false);
  });
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  $scope.share = function(opt_attributes) {
    var file = $scope.logPath;
    loading.show();
    load().then(function(section) {
      var form = section.shareRegister.shareUrl + "?inviteCode=" + $scope.mainUserConfig.userId.toString(16);
      if ("Timeline" == opt_attributes) {
        file += "Timeline";
        test.shareUrlToTimeline(form, section.shareRegister.title, section.shareRegister.description, section.shareRegister.imgUrl);
      } else {
        if ("friend" == opt_attributes) {
          file += "friend";
          test.shareUrlToSession(form, section.shareRegister.title, section.shareRegister.description, section.shareRegister.imgUrl);
        } else {
          if ("qq" == opt_attributes) {
            file += "qq";
            assert.shareUrlToQq(form, section.shareRegister.title, section.shareRegister.description, section.shareRegister.imgUrl);
          } else {
            if ("qz" == opt_attributes) {
              file += "qz";
              /** @type {Array} */
              var progressValues = [];
              progressValues.push(section.shareRegister.imgUrl);
              assert.shareUrlToQz(form, section.shareRegister.title, section.shareRegister.description, progressValues);
            }
          }
        }
      }
      $.get(file);
      loading.hide();
    }, function() {
      loading.hide();
      dataAndEvents.toastShow("分享过程中遇到错误");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.goShare = function() {
    if (deepDataAndEvents.isEX()) {
      var promise = _.confirm({
        template : "<div class='tc'>当前为体验帐号，您分享邀请好友后将不会获得奖励，建议您登录自己帐号进行分享邀请。是否继续用体验帐号分享？</div>",
        cancelText : "取消",
        okText : "确认"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          $scope.openShareModal();
        }
      });
    } else {
      $scope.openShareModal();
    }
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY040.html", function($location) {
    $scope.KEY263 = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.openShareModal = function() {
    $.get($scope.logPath + "mainShare");
    $scope.KEY263.show();
  };
  $modal.fromTemplateUrl("invitePersonList.html", function($location) {
    $scope.invitePersonListModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.KEY263.remove();
    $scope.invitePersonListModal.remove();
  });
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return newCanvas.postEncode("/KEY401", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page
    }).success(function(options) {
      $scope.itemList = $scope.itemList.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      widget.resize("invitePersonListCtrlScroll");
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    loading.show();
    createDom({
      page : page
    }).success(function(results) {
      if (results.records) {
        $scope.invitePersonNum = results.records;
        $scope.itemList = results.rows;
        /** @type {boolean} */
        $scope.loadMoreBtn = results.page < results.total;
      } else {
        /** @type {number} */
        $scope.invitePersonNum = 0;
      }
    }).finally(function() {
      loading.hide();
    });
  });
}]).controller("QRCodeSettingCtrl", ["$scope", "$rootScope", "$state", "psisServices", "$ionicPopup", "lbSpinnerDialog", "Tools", "commonDataInterface", "ServerConfig", "ServerType", "$window", "$cordovaBarcodeScanner", function(e, mod, ignoreMethodDoesntExist, textAlt, keepData, loading, model, dataAndEvents, context, deepDataAndEvents, $window, Hogan) {
  e.isUserAccAvailable = e.GetOperatorEventLimit("KEY261");
  e.qrCode = {
    text : "",
    slogan : "",
    enable : false
  };
  /**
   * @return {?}
   */
  e.save = function() {
    return e.qrCode.text ? (loading.show(), void dataAndEvents.saveOrUpdateUserConfig("QRCodeForShop", JSON.stringify(e.qrCode)).then(function(res) {
      loading.hide();
      if (1 == res.statusCode) {
        if (res.object) {
          $window.localStorage.PrintQRCode = res.object.configValue;
        }
        model.toastShow("保存成功");
      } else {
        model.toastShow(res.content);
      }
    }, function() {
      loading.hide();
      model.toastShow("服务器获取数据出现异常！");
    })) : (model.toastShow("请输入或者扫码录入二维码"), false);
  };
  /**
   * @return {undefined}
   */
  e.scanCode = function() {
    Hogan.scan().then(function(data) {
      return data.cancelled ? false : void(e.qrCode.text = data.text);
    }, function(err) {
      console.error("Scanning failed: " + err);
      model.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @param {string} href
   * @return {undefined}
   */
  e.gotoXiaohuobao = function(href) {
    e.openLink(href, 1);
  };
  e.$on("$ionicView.loaded", function() {
    loading.show();
    dataAndEvents.getUserConfig("QRCodeForShop").then(function(res) {
      if (loading.hide(), 1 == res.statusCode) {
        if (res.object) {
          e.qrCode = angular.fromJson(res.object.configValue);
        } else {
          if (e.GetOperatorEventLimit("KEY261")) {
            var path = context.tmsServer.replace(/cid/, mod.mainCompany.id);
            if (deepDataAndEvents.isEX()) {
              path = path.replace(/www/, "ex");
            } else {
              if (context.currentServer.indexOf("dev") >= 0) {
                path = path.replace(/www/, "dev");
              }
            }
            e.qrCode = {
              text : path,
              slogan : "扫一扫关注店铺",
              enable : false
            };
          }
        }
        /** @type {string} */
        $window.localStorage.PrintQRCode = JSON.stringify(e.qrCode);
      } else {
        model.toastShow(res.content);
      }
    }, function() {
      loading.hide();
      model.toastShow("服务器获取数据出现异常！");
    });
  });
}]).controller("ResetSystemCtrl", ["$scope", "$state", "Tools", "lbSpinnerDialog", "psisServices", "lbScrollDelegate", "$ionicPopup", "$interval", function($scope, $state, self, loading, $http, dataAndEvents, view, $) {
  $scope.deleteItem = {
    businessRecord : true
  };
  $scope.validatePhone = {
    smsType : 1
  };
  /** @type {string} */
  $scope.getMessageText = "获取短信验证码";
  /** @type {boolean} */
  $scope.showSMSCodeValidate = false;
  /** @type {boolean} */
  $scope.disableMsgBtn = false;
  /** @type {number} */
  $scope.sesconds = 60;
  var val;
  $scope.$on("$ionicView.loaded", function() {
    loading.show();
    $http.post("/KEY234").success(function(data) {
      $scope.KEY196 = data.object;
    }).finally(function() {
      loading.hide();
    });
  });
  /**
   * @return {undefined}
   */
  $scope.confirmDel = function() {
    /** @type {string} */
    var MSG_CLOSURE_CUSTOM_COLOR_BUTTON = "同意辛巴软件对因我决定而清除的数据[无法恢复]不负责任，请输入“确认清除”表示您已确认！";
    if ($scope.deleteItem.goodsDelConfirm) {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="text" ng-model="deleteItem.confirmInput" class="tc" style="border:1px solid #FFC107" placeholder="输入“确认清除”" autofocus="true">',
        title : MSG_CLOSURE_CUSTOM_COLOR_BUTTON,
        scope : $scope,
        buttons : [{
          text : "取消",
          /**
           * @return {undefined}
           */
          onTap : function() {
            /** @type {boolean} */
            $scope.deleteItem.goodsDelConfirm = false;
          }
        }, {
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            if ("确认清除" !== $scope.deleteItem.confirmInput) {
              /** @type {boolean} */
              $scope.deleteItem.goodsDelConfirm = false;
              self.toastShow("输入错误，请重新选择！");
            }
            /** @type {string} */
            $scope.deleteItem.confirmInput = "";
          }
        }]
      });
    }
  };
  /**
   * @param {?} event
   * @return {?}
   */
  $scope.getValidateSMS = function(event) {
    if (!$scope.deleteItem.goodsDelConfirm) {
      return self.toastShow("请选择带红色星号的选项！"), false;
    }
    var cellphone = $scope.KEY196.cellphone;
    /** @type {string} */
    var l = "验证码将发送至号码";
    var promise = view.confirm({
      template : "<div class='tc'>" + l + "<br>" + cellphone + "</div>",
      cancelText : "取消",
      okText : "好"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        init();
      }
    });
    /**
     * @return {undefined}
     */
    var init = function() {
      loading.show();
      if (event.stopPropagation()) {
        event.preventDefault();
      }
      var dataToSave = {};
      dataToSave.regesterCellphone = $scope.KEY196.cellphone;
      $http.postEncode("/KEY419", dataToSave).success(function(r) {
        loading.hide();
        if (1 == r.statusCode) {
          /** @type {string} */
          $scope.getMessageText = "60秒后重新获取";
          /** @type {boolean} */
          $scope.showSMSCodeValidate = true;
          /** @type {boolean} */
          $scope.disableMsgBtn = true;
          val = $(function() {
            if ($scope.sesconds > 0) {
              $scope.sesconds--;
              /** @type {string} */
              $scope.getMessageText = $scope.sesconds + "秒后重新获取";
            } else {
              if (angular.isDefined(val)) {
                $.cancel(val);
                val = void 0;
              }
              /** @type {number} */
              $scope.sesconds = 60;
              /** @type {boolean} */
              $scope.disableMsgBtn = false;
              /** @type {string} */
              $scope.getMessageText = "获取短信验证码";
            }
          }, 1E3);
        } else {
          if (3 == r.statusCode) {
            /** @type {string} */
            $scope.phoneErrTxt = "注册人手机号错误，只有注册人本人才能使用系统重置功能.";
            view.alert({
              template : "<div class='tc'>" + $scope.phoneErrTxt + "</div>",
              okText : "确定"
            }).then(function() {
              /** @type {boolean} */
              $scope.disableMsgBtn = false;
            });
          }
        }
      }).error(function() {
        loading.hide();
        /** @type {boolean} */
        $scope.disableMsgBtn = false;
      });
    };
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  $scope.resetConfig = function(event) {
    var promise = view.confirm({
      template : "<div class='tc'>每天最多能重置系统3次，<br>清除的数据将无法恢复！<br>确认是否清除？</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        event.stopPropagation();
        $scope.deleteItem.smsCode = self.padLeft($scope.validatePhone.smsCode, 4);
        loading.show(true);
        $http.postEncode("/KEY423", $scope.deleteItem).success(function(r) {
          if (1 == r.statusCode) {
            view.alert({
              template : "<div class='tc'>系统重置成功！将返回到首页</div>",
              okText : "确定"
            }).then(function() {
              $state.go("eventmenu.main");
            });
          } else {
            if (0 == r.statusCode) {
              self.toastShow(r.content);
            }
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
}]).controller("PersonSettingCtrl", ["$scope", "$rootScope", "$state", "ServerConfig", "$window", "commonDataInterface", "lbSpinnerDialog", "Tools", "BusinessConstant", function($scope, ignoreMethodDoesntExist, textAlt, obj, $window, dataAndEvents, loading, $, deepDataAndEvents) {
  $scope.configList = {
    isSendStatisticMsg : false
  };
  /**
   * @return {undefined}
   */
  $scope.saveSetting = function() {
    loading.show();
    dataAndEvents.saveOrUpdateUserConfig("isSendStatisticMsg", $scope.configList.isSendStatisticMsg).then(function(data) {
      if (1 == data.statusCode) {
        $scope.msgConfig = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "isSendStatisticMsg");
        if ($scope.msgConfig) {
          $.union($scope.msgConfig, data.object);
        } else {
          obj.userConfigData.push(data.object);
        }
        $.toastShow("保存成功");
      } else {
        $.toastShow(data.content);
      }
      loading.hide();
    }, function() {
      loading.hide();
      $.toastShow("服务器获取数据出现异常！");
    });
    var generatedColumn = {
      zeroPaid : 1 == $scope.businessConfigSetting.zeroPaid ? 1 : 2,
      defaultLastPrice : 1 == $scope.businessConfigSetting.defaultLastPrice ? 1 : 2
    };
    loading.show(true);
    dataAndEvents.saveOrUpdateUserConfig("businessConfig", JSON.stringify(generatedColumn), 3).then(function(event) {
      $scope.businessConfig = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "businessConfig");
      if ($scope.businessConfig) {
        $.union($scope.businessConfig, event.object);
      } else {
        obj.userConfigData.push(event.object);
      }
      /** @type {*} */
      $scope.businessConfigValue = JSON.parse(event.object.configValue);
      $window.localStorage.allowEditGoodImg = $scope.sysConfig.allowEditGoodImg;
      loading.hide();
    }, function() {
      loading.hide();
      $.toastShow("服务器获取数据出现异常！");
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    /** @type {boolean} */
    $scope.sysConfig.allowEditGoodImg = "true" == $window.localStorage.allowEditGoodImg;
    $scope.msgConfig = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "isSendStatisticMsg");
    if ($scope.msgConfig) {
      if ("true" == $scope.msgConfig.configValue) {
        /** @type {boolean} */
        $scope.configList.isSendStatisticMsg = true;
      }
    }
    $scope.userConfigData = obj.userConfigData;
    $scope.businessConfig = $.fnCheckGtoreQty($scope.userConfigData, "configKey", "businessConfig");
    /** @type {*} */
    $scope.businessConfigValue = $scope.businessConfig && $scope.businessConfig.configValue ? JSON.parse($scope.businessConfig.configValue) : {
      zeroPaid : deepDataAndEvents.ZEROPAID.ON,
      defaultLastPrice : 2
    };
    $scope.businessConfigSetting = {
      zeroPaid : $scope.businessConfigValue.zeroPaid == deepDataAndEvents.ZEROPAID.ON,
      defaultLastPrice : 1 == $scope.businessConfigValue.defaultLastPrice
    };
  });
}]).controller("TradeListCtrl", ["$scope", "$state", "Tools", "ServerConfig", "psisServices", "lbScrollDelegate", "lbSpinnerDialog", function(self, ignoreMethodDoesntExist, textAlt, dataAndEvents, deepDataAndEvents, parent, loading) {
  /** @type {string} */
  self.viewTitle = "交易记录";
  self.queryCondition = {
    page : 1
  };
  /**
   * @return {?}
   */
  var Step = function() {
    return self.viewTitle = "交易记录", deepDataAndEvents.fullPathPostEncode(dataAndEvents.mgrServer + "/KEY194?page=" + self.queryCondition.page);
  };
  /**
   * @return {?}
   */
  var $http = function() {
    return self.viewTitle = "充值记录", deepDataAndEvents.fullPathPostEncode(dataAndEvents.mgrServer + "/KEY197?page=" + self.queryCondition.page);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    loading.show();
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      loading.hide();
      parent.scrollTop("TradeListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getRechargeList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    loading.show();
    $http().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      loading.hide();
      parent.scrollTop("TradeListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    if (1 === self.queryCondition.state) {
      $http().success(function(options) {
        self.items = self.items.concat(options.rows);
        /** @type {boolean} */
        self.loadMoreBtn = options.page < options.total;
      }).finally(function() {
        parent.resize("TradeListCtrlScroll");
      });
    } else {
      Step().success(function(options) {
        self.items = self.items.concat(options.rows);
        /** @type {boolean} */
        self.loadMoreBtn = options.page < options.total;
      }).finally(function() {
        parent.resize("TradeListCtrlScroll");
      });
    }
  };
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  self.getTradeItem = function(dataAndEvents) {
    return "recharge" == dataAndEvents ? "充值" : "consume" == dataAndEvents ? "消费" : "其它";
  };
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  self.getPayType = function(dataAndEvents) {
    return "alipayDirect" == dataAndEvents ? "支付宝" : "voucher" == dataAndEvents ? "代金券" : "KEY293" == dataAndEvents ? "账户余额" : "其它";
  };
  /**
   * @return {undefined}
   */
  self.gotoReCharge = function() {
    self.openLinkInIframe("账户充值", dataAndEvents.mgrServer + "/trade/rechargePageOnMobile.ac?clientType=app");
  };
  self.$on("$ionicView.loaded", function() {
    self.getList();
  });
}]).controller("BulletinListCtrl", ["$scope", "$state", "Tools", "lbSpinnerDialog", "psisServices", "lbScrollDelegate", "lruPersistCache", function($scope, $state, dataAndEvents, loading, $cookieStore, parent, $templateCache) {
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.queryCondition = {
    page : 1
  };
  /**
   * @return {?}
   */
  var Step = function() {
    return $cookieStore.postEncode("/KEY370", $scope.queryCondition);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show(true);
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step().success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.scrollTop("bulletinListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    Step().success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("bulletinListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step().success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
      $scope.$broadcast("scroll.refreshComplete");
    });
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  $scope.goToBulletin = function(term) {
    $state.go("eventmenu.KEY228", {
      id : term
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
  });
  $scope.$on("$ionicView.afterEnter", function() {
    if ($templateCache.get("bulletinListRefresh")) {
      if ($templateCache.get("bulletinListRefresh") === true) {
        $scope.getList();
        $templateCache.put("bulletinListRefresh", false);
      }
    }
  });
}]).controller("BulletinEditCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "$timeout", "lruPersistCache", "$ionicActionSheet", "CameraService", "ServerConfig", "$cordovaFile", "lbScrollDelegate", "$state", function(self, ignores, assert, dojo, deepDataAndEvents, $modal, ignoreMethodDoesntExist, _, loading, textAlt, $templateCache, $, item, dataAndEvents, exports,
_this, $state) {
  /** @type {boolean} */
  self.isLoading = true;
  self.bulletin = {
    pageFormat : 1,
    imgIds : []
  };
  self.bulletinInfo = {
    imgList : [],
    imgHistoryList : [],
    imgHistoryListPage : 1,
    isExist : false
  };
  /** @type {number} */
  self.BulletinImgMaxLength = 5;
  self.isUserAccAvailable = self.GetOperatorEventLimit("KEY175");
  /** @type {boolean} */
  self.isShow = true;
  /**
   * @param {string} deepDataAndEvents
   * @return {?}
   */
  self.saveBulletin = function(deepDataAndEvents) {
    if (!self.bulletinInfo.isSaving) {
      if (!self.bulletin.name) {
        return void dojo.toastShow("请填写标题！", "short");
      }
      if ("publish" == deepDataAndEvents) {
        /** @type {string} */
        var simple = "您确认要发布该公告？";
        if (window.cordova && window.cordova.plugins) {
          dojo.showConfirm(simple, function(dataAndEvents) {
            if (2 == dataAndEvents) {
              send(deepDataAndEvents);
            }
          }, null, ["取消", "确认"]);
        } else {
          var promise = _.confirm({
            template : "<div class='tc'>" + simple + "</div>",
            cancelText : "取消",
            okText : "确认"
          });
          promise.then(function(dataAndEvents) {
            if (dataAndEvents) {
              send(deepDataAndEvents);
            }
          });
        }
      } else {
        /** @type {boolean} */
        self.bulletinInfo.isSaving = true;
        send(deepDataAndEvents);
      }
    }
  };
  /**
   * @param {string} deepDataAndEvents
   * @return {undefined}
   */
  var send = function(deepDataAndEvents) {
    /** @type {string} */
    var url = "/KEY341";
    /** @type {string} */
    var speed = "保存成功";
    if ("publish" == deepDataAndEvents) {
      /** @type {string} */
      url = "/KEY400";
      /** @type {string} */
      speed = "发布成功";
    }
    /** @type {Array} */
    var eventPath = [];
    /** @type {number} */
    var conditionIndex = 0;
    for (;conditionIndex < self.bulletinInfo.imgList.length;conditionIndex++) {
      eventPath.push(self.bulletinInfo.imgList[conditionIndex].imgId);
    }
    self.bulletin = $.extend(self.bulletin, {
      imgIds : eventPath
    });
    loading.show(true);
    assert.post(url, self.bulletin).success(function(res) {
      if (1 == res.statusCode) {
        self.bulletin = res.object;
        if ("publish" == deepDataAndEvents) {
          /** @type {boolean} */
          self.isShow = false;
        } else {
          /** @type {boolean} */
          self.bulletinInfo.isSaving = false;
        }
        dojo.toastShow(speed);
      } else {
        _.alert({
          template : "<div class='tc'>" + res.content + "</div>",
          okText : "确定"
        });
      }
    }).finally(function() {
      $templateCache.put("bulletinListRefresh", true);
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  var init = function() {
    loading.show(true);
    assert.post("/admin/system/bulletin/bulletinInnerDelete.ac?id=" + self.bulletin.id).success(function() {
      if (window.cordova && window.cordova.plugins) {
        dojo.showAlert("", function() {
          self.goBack();
        }, "删除成功", null);
      } else {
        _.alert({
          template : "<div class='tc'>删除成功</div>",
          okText : "确定"
        }).then(function() {
          self.goBack();
        });
      }
    }).finally(function() {
      $templateCache.put("bulletinListRefresh", true);
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.showActionsheet = function() {
    var scope = {
      buttons : []
    };
    scope.buttons.push({
      text : '<i class="icon ion-plus assertive"></i> 新 增'
    });
    scope.buttons.push({
      text : '<i class="icon ion-ios-trash-outline assertive"></i> 删 除'
    });
    /**
     * @param {number} index
     * @return {?}
     */
    scope.buttonClicked = function(index) {
      if (scope.buttons[index].text.indexOf("新 增") > -1) {
        self.createBulletin();
      } else {
        if (scope.buttons[index].text.indexOf("删 除") > -1) {
          /** @type {string} */
          var simple = "您确认要删除该公告？";
          if (window.cordova && window.cordova.plugins) {
            dojo.showConfirm(simple, function(dataAndEvents) {
              if (2 == dataAndEvents) {
                init();
              }
            }, null, ["取消", "删除"]);
          } else {
            var promise = _.confirm({
              template : "<div class='tc'>" + simple + "</div>",
              cancelText : "取消",
              okText : "确认"
            });
            promise.then(function(dataAndEvents) {
              if (dataAndEvents) {
                init();
              }
            });
          }
        }
      }
      return true;
    };
    $.show(scope);
  };
  /**
   * @return {undefined}
   */
  self.createBulletin = function() {
    self.viewReplace();
    $state.go("eventmenu.KEY228", {
      id : null
    }, {
      reload : true
    });
  };
  $modal.fromTemplateUrl("bulletinImages.html", function(theTitle) {
    /** @type {number} */
    self.bulletinImagesModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("bulletinImgHistory.html", function(theTitle) {
    /** @type {number} */
    self.bulletinImgHistoryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @param {?} b
   * @return {undefined}
   */
  self.showBulletinImage = function(b) {
    if (!angular.equals(self.bulletinInfo.image, self.bulletinInfo.imgList[b].url)) {
      self.bulletinInfo.image = self.bulletinInfo.imgList[b].url;
      _this.zoomTo("bulletinImagesScroll", 1, false, 0, 0);
    }
    self.bulletinImagesModal.show();
  };
  /**
   * @return {?}
   */
  var $http = function() {
    return assert.post("/KEY114?moduleFlag=bulletinInnerAlbum&page=" + self.bulletinInfo.imgHistoryListPage);
  };
  /**
   * @param {Array} arr
   * @return {undefined}
   */
  var exists = function(arr) {
    /** @type {number} */
    var i = 0;
    for (;i < arr.length;i++) {
      /** @type {number} */
      arr[i].sel = dojo.fnCheckGtoreQty(self.bulletinInfo.imgList, "imgId", arr[i].id) ? 1 : 0;
    }
  };
  /**
   * @param {string} fileName
   * @return {undefined}
   */
  var parse = function(fileName) {
    loading.show(true);
    var options = new FileUploadOptions;
    /** @type {string} */
    options.fileKey = "file";
    options.fileName = fileName.substr(fileName.lastIndexOf("/") + 1) + ".jpg";
    /** @type {string} */
    options.mimeType = "image/jpeg";
    options.params = {
      module : "bulletinInnerAlbum",
      bulletinId : self.bulletin.id
    };
    /** @type {boolean} */
    options.chunkedMode = false;
    exports.uploadFile(dataAndEvents.currentServer + "/KEY388", fileName, options).then(function(data) {
      loading.hide();
      var res = angular.fromJson(data.response);
      if (1 === res.statusCode) {
        self.bulletinInfo.imgList.push({
          name : res.object.name,
          url : res.object.url,
          imgId : res.object.id,
          id : res.object.albumId
        });
        dojo.toastShow("图片上传成功！");
      } else {
        dojo.toastShow("图片上传失败！");
      }
      item.cleanup().then(function() {
        console.log("CameraService cleanup successfully");
      });
    }, function(err) {
      loading.hide();
      dojo.toastShow(413 === err.http_status ? "不能上传超过2M的图片！" : "图片上传失败！");
      item.cleanup().then(function() {
        console.log("CameraService cleanup successfully");
      });
    }, function() {
    });
  };
  /**
   * @return {undefined}
   */
  self.choosePhoto = function() {
    $.show({
      buttons : [{
        text : '<i class="icon ion-camera assertive"></i> 拍 照'
      }, {
        text : '<i class="icon ion-images assertive"></i> 从相册中选择'
      }],
      /**
       * @param {?} clicked
       * @return {?}
       */
      buttonClicked : function(clicked) {
        switch(clicked) {
          case 0:
            item.startCamera(self.platformIsAndroid ? self.sysConfig.allowEditGoodImg : true).then(parse);
            break;
          case 1:
            item.openCameraRoll(self.platformIsAndroid ? self.sysConfig.allowEditGoodImg : true).then(parse);
        }
        return true;
      }
    });
  };
  /**
   * @param {Element} n
   * @return {undefined}
   */
  self.delRelImg = function(n) {
    if (-1 === n.id || 0 === self.state) {
      dojo.removeByKey(self.bulletinInfo.imgList, "imgId", n.imgId);
    } else {
      loading.show();
      assert.post("/admin/system/bulletin/deleteImgRelate.ac?albumId=" + n.id).success(function(r) {
        if (1 === r.statusCode) {
          dojo.removeByKey(self.bulletinInfo.imgList, "imgId", n.imgId);
        }
      }).finally(function() {
        loading.hide();
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.loadBulletinImgHistory = function() {
    self.bulletinImgHistoryModal.show();
    /** @type {boolean} */
    self.bulletinImgHistoryLoading = true;
    $http().success(function(results) {
      self.bulletinInfo.imgHistoryList = results.rows;
      /** @type {boolean} */
      self.loadMoreHisImgBtn = results.page < results.total;
    }).finally(function() {
      exists(self.bulletinInfo.imgHistoryList);
      /** @type {boolean} */
      self.bulletinImgHistoryLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  self.getMoreImgHistory = function() {
    /** @type {boolean} */
    self.bulletinImgHistoryLoading = true;
    self.bulletinInfo.imgHistoryListPage++;
    $http().success(function(options) {
      exists(options.rows);
      self.bulletinInfo.imgHistoryList = self.bulletinInfo.imgHistoryList.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreHisImgBtn = options.page < options.total;
    }).finally(function() {
      _this.resize("imgHistoryListCtrlScroll");
      /** @type {boolean} */
      self.bulletinImgHistoryLoading = false;
    });
  };
  /**
   * @param {string} dataAndEvents
   * @param {string} data
   * @return {undefined}
   */
  self.selBulletinImgHis = function(dataAndEvents, data) {
    /** @type {number} */
    var i = 0;
    for (;i < self.bulletinInfo.imgHistoryList.length;i++) {
      if (self.bulletinInfo.imgHistoryList[i].id === data) {
        if (self.bulletinInfo.imgHistoryList[i].sel = !self.bulletinInfo.imgHistoryList[i].sel, self.bulletinInfo.imgHistoryList[i].sel) {
          if (void 0 == dojo.fnCheckGtoreQty(self.bulletinInfo.imgList, "imgId", data) && self.bulletinInfo.imgList.length < self.BulletinImgMaxLength) {
            if (dataAndEvents) {
              loading.show();
              assert.post("/admin/system/bulletin/relateAlbum.ac?bulletinId=" + dataAndEvents + "&imgId=" + data).success(function(mod) {
                self.bulletinInfo.imgList.push({
                  name : self.bulletinInfo.imgHistoryList[i].name,
                  url : self.bulletinInfo.imgHistoryList[i].url,
                  imgId : self.bulletinInfo.imgHistoryList[i].id,
                  id : mod.object.id
                });
              }).finally(function() {
                loading.hide();
              });
            } else {
              self.bulletinInfo.imgList.push({
                name : self.bulletinInfo.imgHistoryList[i].name,
                url : self.bulletinInfo.imgHistoryList[i].url,
                imgId : self.bulletinInfo.imgHistoryList[i].id,
                id : -1
              });
            }
          } else {
            /** @type {number} */
            self.bulletinInfo.imgHistoryList[i].sel = 0;
          }
        } else {
          var d = dojo.fnCheckGtoreQty(self.bulletinInfo.imgList, "imgId", data);
          self.delRelImg(d);
        }
        break;
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.doneSelBulletinImgHis = function() {
    self.bulletinImgHistoryModal.hide();
  };
  self.$on("$destroy", function() {
    self.bulletinImagesModal.remove();
    self.bulletinImgHistoryModal.remove();
  });
  /** @type {boolean} */
  self.enableDelImgHis = true;
  /**
   * @param {Element} n
   * @return {undefined}
   */
  self.delImgHis = function(n) {
    var promise = _.confirm({
      template : "<div class='tc'>已被商品相册引用的图片将无法删除，删除图片后商品描述、系统公告等文本中引用该图片的地方将无法正确显示图片，是否确认删除？</div>",
      cancelText : "取消",
      okText : "确认删除"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        assert.post("/KEY117?imgId=" + n.id).success(function(res) {
          if (1 === res.statusCode) {
            dojo.toastShow("删除成功！");
            dojo.removeByKey(self.bulletinInfo.imgHistoryList, "id", n.id);
          } else {
            dojo.toastShow(res.content);
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  self.$on("$ionicView.loaded", function() {
    if (ignores.id) {
      loading.show();
      assert.post("/admin/system/bulletin/bulletinInnerGet.ac?id=" + ignores.id).success(function($scope) {
        if ($scope.object.bulletin) {
          self.bulletin = $scope.object.bulletin;
          self.isShow = self.isUserAccAvailable && 0 == self.bulletin.isPublished;
          self.bulletinInfo.imgList = $scope.object.images;
          self.bulletin.imgIds = dojo.objectArrayToIdString(self.bulletinInfo.imgList, "imgId", ",");
          /** @type {boolean} */
          self.bulletinInfo.isExist = true;
        } else {
          /** @type {boolean} */
          self.bulletinInfo.isExist = false;
        }
      }).finally(function() {
        loading.hide();
        /** @type {boolean} */
        self.isLoading = false;
      });
    } else {
      /** @type {boolean} */
      self.isLoading = false;
      /** @type {boolean} */
      self.bulletinInfo.isExist = true;
    }
  });
}]).controller("PubroleListCtrl", ["$scope", "$rootScope", "$timeout", "$state", "psisServices", "lbScrollDelegate", "$ionicPopup", "$ionicPopover", "$ionicModal", "lbSpinnerDialog", "$q", "Tools", "lruPersistCache", "$cordovaDatePicker", "$stateParams", function($scope, dataAndEvents, deepDataAndEvents, $state, newCanvas, parent, ignoreMethodDoesntExist, textAlt, keepData, loading, opt_attributes, matcherFunction, $templateCache) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return newCanvas.postEncode("/KEY429", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var run = function() {
    /** @type {number} */
    page = 1;
    loading.show();
    createDom({
      page : page
    }).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("pubroleListCtrlScroll");
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("pubroleListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    page = 1;
    createDom({
      page : page
    }).success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  $scope.goPubroleEdit = function(term) {
    $state.go("eventmenu.KEY242", {
      id : term
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshRoleList")) {
      run();
      $templateCache.put("refreshRoleList", false);
    }
  });
  $scope.$on("$ionicView.loaded", function() {
    run();
  });
}]).controller("PubroleEditCtrl", ["$scope", "$state", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "ServerConfig", "lruPersistCache", "lbScrollDelegate", "$cordovaDatePicker", "$rootScope", function($scope, deepDataAndEvents, $routeParams, result, response, FB, ignoreMethodDoesntExist, $q, _, loading, textAlt, $templateCache, parent, keepData, dataAndEvents) {
  /**
   * @param {Object} saveData
   * @param {string} name
   * @return {?}
   */
  function it(saveData, name) {
    /** @type {Array} */
    var spec = [];
    for (num in saveData) {
      spec.push(saveData[num][name]);
    }
    return spec;
  }
  /**
   * @param {Object} args
   * @param {string} key
   * @param {string} collection
   * @return {undefined}
   */
  function callback(args, key, collection) {
    for (obj in args) {
      if (args[obj] instanceof Array && callback(args[obj], key, collection), args[obj] instanceof Object) {
        if (void 0 != args[obj][key]) {
          /** @type {boolean} */
          args[obj][key].checked = false;
          /** @type {boolean} */
          args[obj][key].show = false;
          var elt = args[obj][key].id;
          if (-1 != collection.indexOf(elt)) {
            /** @type {boolean} */
            args[obj][key].checked = true;
          }
        }
        callback(args[obj], key, collection);
      }
    }
  }
  /**
   * @param {Object} args
   * @param {boolean} key
   * @return {undefined}
   */
  function get(args, key) {
    for (obj in args) {
      if (args[obj] instanceof Array) {
        get(args[obj], key);
      }
      if (args[obj] instanceof Object) {
        if (void 0 != args[obj].pTableVO) {
          if (key) {
            /** @type {boolean} */
            args[obj].pTableVO.checked = true;
            /** @type {boolean} */
            args[obj].pTableVO.show = true;
          } else {
            /** @type {boolean} */
            args[obj].pTableVO.checked = false;
          }
        }
        get(args[obj], key);
      }
    }
  }
  /**
   * @param {?} progress
   * @param {?} args
   * @param {?} partials
   * @return {undefined}
   */
  function render(progress, args, partials) {
    for (obj in args) {
      if (args[obj].pTableVO.id === partials) {
        /** @type {boolean} */
        args[obj].pTableVO.checked = true;
        /** @type {boolean} */
        args[obj].pTableVO.show = true;
        render(progress, progress, args[obj].pTableVO.pid);
      } else {
        render(progress, args[obj].lstSubHierarchyVO, partials);
      }
    }
  }
  /**
   * @param {Object} args
   * @return {undefined}
   */
  function exec(args) {
    for (obj in args) {
      if (args[obj] instanceof Array) {
        exec(args[obj]);
      }
      if (args[obj] instanceof Object) {
        if (void 0 != args[obj].pTableVO) {
          if (args[obj].pTableVO.checked) {
            $scope.reoleIds.push(args[obj].pTableVO.id);
          }
        }
        exec(args[obj]);
      }
    }
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = result.httpCacheGet.get(result.httpCacheGet.ac.RESOURCEHIERARCHY);
    return $q.all([request1]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  $scope.roleId = $routeParams.id;
  $scope.foo = {
    roleResources : []
  };
  /** @type {Array} */
  $scope.reoleIds = [];
  /** @type {number} */
  $scope.state = 0;
  /** @type {Array} */
  $scope.foo.roleResources = $scope.foo.roleResources.concat(0, 97, 98, 99);
  /** @type {number} */
  $scope.foo.roleResources.length = 4;
  /**
   * @param {string} l
   * @return {?}
   */
  var makeArray = function(l) {
    return result.postEncode("/KEY450?id=" + l);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show();
    makeArray($scope.roleId).success(function(data) {
      /** @type {number} */
      $scope.state = 1;
      $scope.role = data.role;
      /** @type {number} */
      $scope.foo.roleResources.length = 0;
      if (0 != data.roleResources.length) {
        $scope.foo.roleResources = it(data.roleResources, "resourceId");
        parent.scrollTop("roleResourcescroll");
      }
    }).finally(function() {
      callback($scope.resources, "pTableVO", $scope.foo.roleResources);
      loading.hide();
    });
  };
  /**
   * @param {?} data
   * @param {string} isXML
   * @return {undefined}
   */
  $scope.getSubResource = function(data, isXML) {
    $scope.reId = data;
    /** @type {Array} */
    $scope.subResources = [];
    /** @type {number} */
    var idx = 0;
    var cnl = $scope.resources.length;
    for (;cnl > idx;idx++) {
      if ($scope.resources[idx].pTableVO.id == data) {
        $scope.subResources = $scope.resources[idx].lstSubHierarchyVO;
      }
    }
    $scope.scrollTop(isXML);
  };
  /**
   * @param {?} event
   * @param {?} api
   * @return {undefined}
   */
  $scope.toggleLstSub = function(event, api) {
    if (event) {
      event.stopPropagation();
    }
    /** @type {boolean} */
    api.pTableVO.show = !api.pTableVO.show;
  };
  /**
   * @param {?} api
   * @return {?}
   */
  $scope.lstSubIsShown = function(api) {
    return api.pTableVO.show;
  };
  FB.fromTemplateUrl("copyOperation.html", {
    scope : $scope
  }).then(function($location) {
    $scope.copyOperationPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openCopyOperationPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.copyOperationPopover.show(expectedNumberOfNonCommentArgs);
  };
  $scope.$on("$destroy", function() {
    $scope.copyOperationPopover.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.addEmptyForm = function() {
    /** @type {number} */
    $scope.state = 0;
    $scope.role = {};
    /** @type {string} */
    $scope.roleId = "";
    /** @type {number} */
    $scope.foo.roleResources.length = 0;
    $scope.foo.roleResources = $scope.foo.roleResources.concat(0, 97, 98, 99);
    callback($scope.resources, "pTableVO", $scope.foo.roleResources);
  };
  /**
   * @param {string} value
   * @return {undefined}
   */
  $scope.scrollTop = function(value) {
    if (value) {
      value.stopPropagation();
    }
    parent.scrollTop("resourceScroll");
  };
  /**
   * @param {Object} item
   * @param {?} event
   * @return {undefined}
   */
  $scope.clickResource = function(item, event) {
    if (event) {
      event.stopPropagation();
    }
    /** @type {boolean} */
    var camelKey = false;
    if (item.pTableVO.checked) {
      /** @type {boolean} */
      camelKey = true;
      get(item, camelKey);
      render($scope.resources, $scope.resources, item.pTableVO.id);
    } else {
      get(item, camelKey);
    }
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return $scope.roleId ? result.postArrParamEncode("/KEY436", opt_attributes) : result.postArrParamEncode("/KEY437", opt_attributes);
  };
  /**
   * @return {?}
   */
  $scope.saveRole = function() {
    exec($scope.resources);
    var attributes = {
      role : angular.toJson($scope.role),
      resources : $scope.reoleIds
    };
    return $scope.role.roleName ? (loading.show(), void createDom(attributes).success(function(r) {
      if (1 == r.statusCode) {
        response.toastShow("保存成功!");
        $templateCache.put("refreshRoleList", true);
        dataAndEvents.refreshAccRecource();
        $scope.goBack();
      } else {
        response.toastShow(r.content);
      }
    }).finally(function() {
      loading.hide();
    })) : (response.toastShow("名称不能为空!"), false);
  };
  /**
   * @param {string} l
   * @return {undefined}
   */
  $scope.copyRoleNew = function(l) {
    loading.show();
    result.postEncode("/KEY450?id=" + l).success(function(param) {
      $scope.proccessResultAsNew(param);
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {Object} data
   * @return {undefined}
   */
  $scope.proccessResultAsNew = function(data) {
    $scope.role = data.role;
    /** @type {string} */
    $scope.role.roleName = $scope.role.roleName + "_复制";
    /** @type {null} */
    $scope.roleId = null;
    delete $scope.role.roleId;
    delete $scope.role.cid;
    /** @type {number} */
    $scope.foo.roleResources.length = 0;
    if (0 != data.roleResources.length) {
      $scope.foo.roleResources = it(data.roleResources, "resourceId");
    }
  };
  /**
   * @return {undefined}
   */
  $scope.delRole = function() {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除该角色?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        result.post("/KEY467?id=" + $scope.roleId).success(function(r) {
          if (1 == r.statusCode) {
            _.alert({
              template : "<div class='tc'>删除成功</div>",
              okText : "确定"
            }).then(function() {
              $templateCache.put("refreshRoleList", true);
              $scope.goBack();
            });
          } else {
            _.alert({
              template : "<div class='tc'>删除失败，不能删除已被使用的角色!</div>",
              okText : "确定"
            });
          }
        }).finally(function() {
          loading.hide();
        });
      } else {
        console.log("取消");
      }
    });
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  $scope.scrollContent = function(event) {
    if (event) {
      event.stopPropagation();
    }
    parent.resize("resourceScroll");
  };
  $scope.$on("$ionicView.loaded", function() {
    loading.show();
    fetch().then(function(packs) {
      $scope.resources = packs[0].data;
      $scope.perfaceResource = $scope.resources[0].lstSubHierarchyVO;
      if ($scope.roleId) {
        $scope.getList();
      } else {
        $scope.addEmptyForm();
      }
      loading.hide();
    }, function() {
      loading.hide();
    });
  });
}]).controller("printQRCodeCtrl", ["$scope", "Tools", "psisServices", "ServerConfig", "lruPersistCache", "OrderType", "$filter", "$ionicPopup", "$ionicPopover", "lbSpinnerDialog", "$timeout", "BluetoothPrintService", "$ionicModal", "$window", "$state", "commonDataInterface", "$stateParams", "$rootScope", "PrintType", function(that, dataAndEvents, ignoreMethodDoesntExist, textAlt, keepData, opt_attributes, matcherFunction, execResult, opt_keys, positionError, oFunctionBody, _$timeout_, failing_message,
nextStack, noCorrect, deepDataAndEvents) {
  /** @type {Array} */
  that.columnList = [{
    text : "名称",
    val : "goodsName"
  }, {
    text : "货号",
    val : "goodsSn"
  }, {
    text : "售价",
    val : "price"
  }];
  /**
   * @param {string} key
   * @return {undefined}
   */
  that.selectColumn = function(key) {
    var camelKey = that.checkColumns.indexOf(key);
    if (camelKey > -1) {
      that.checkColumns.splice(camelKey, 1);
    } else {
      that.checkColumns.push(key);
    }
  };
  /**
   * @return {?}
   */
  that.goodsQRcodePrintSetting = function() {
    return that.printQRcodeObj.gap > 0 ? that.printQRcodeObj.times ? "diy" != that.printQRcodeObj.qrCodeType || that.printQRcodeObj.width >= 5 && that.printQRcodeObj.width <= 110 ? "diy" != that.printQRcodeObj.qrCodeType || that.printQRcodeObj.height >= 5 && that.printQRcodeObj.height <= 150 ? (that.printSettingForQRcodeModal.hide(), void that.saveConfig()) : (dataAndEvents.toastShow("标签高度度需要大于等于5小于等于150的整数"),
    false) : (dataAndEvents.toastShow("标签宽度需要大于等于5小于等于110的整数"), false) : (dataAndEvents.toastShow("请检查打印份数"), false) : (dataAndEvents.toastShow("请检查标签间隙"), false);
  };
  /**
   * @return {undefined}
   */
  that.saveConfig = function() {
    var generatedColumn = {
      printObj : that.printQRcodeObj,
      checkColumns : that.checkColumns
    };
    deepDataAndEvents.saveOrUpdateUserConfig("qrCodePrintSetting", JSON.stringify(generatedColumn), 2).then(function() {
      dataAndEvents.toastShow("保存成功！");
    }, function() {
      console.log("服务器获取数据出现异常！");
      dataAndEvents.toastShow("服务器获取数据出现异常！");
    });
  };
}]);
