angular.module("businessCommunityController", ["ionic", "services", "tools"]).controller("BusinessCommunityMainCtrl", ["$scope", "Tools", "ServerConfig", "BCSlideData", "$templateCache", "$state", "psisServices", "lbSpinnerDialog", "lbScrollDelegate", function(self, deepDataAndEvents, dataAndEvents, defer, $templateCache, target, ret, loading, widget) {
  /** @type {Array} */
  self.items = [];
  /** @type {Array} */
  self.buttonArr = [];
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  self.getListPictureUrl = function(dataAndEvents) {
    return dataAndEvents ? dataAndEvents : "img/detailpic_no.png";
  };
  /**
   * @param {Object} data
   * @return {undefined}
   */
  self.goAction = function(data) {
    if (data.openLink) {
      if (data.isInApp) {
        self.openLink(data.link, true);
      } else {
        self.openLink(data.link);
      }
    } else {
      if (data.openInApp) {
        if (data.param) {
          target.go(data.link, data.param);
        } else {
          target.go(data.link);
        }
      } else {
        if (data.method) {
          try {
            eval(data.method);
          } catch (fmt) {
            console.error(fmt);
          }
        }
      }
    }
  };
  /**
   * @param {(number|string)} x
   * @return {undefined}
   */
  self.goInformation = function(x) {
    target.go("eventmenu.KEY306", {
      item : x
    });
  };
  /** @type {boolean} */
  self.isHasAd = false;
  /**
   * @param {boolean} byte_value
   * @return {undefined}
   */
  var put = function(byte_value) {
    if (!$templateCache.get("businessCommunityAD.html") || byte_value) {
      defer.then(function(assertions) {
        /** @type {string} */
        var template = "<ion-slide-box delegate-handle='main-slide-box' does-continue='true' auto-play='true' show-pager='false' class='lb-KEY305-slider-slide'>";
        if (assertions) {
          if (assertions.length > 0) {
            /** @type {boolean} */
            self.isHasAd = true;
          }
        }
        assertions.forEach(function(req) {
          /** @type {string} */
          var optsData = "";
          if (optsData = req.openInApp ? "openLink('" + (req.link ? req.link : "") + "',true)" : "openLink('" + (req.link ? req.link : "") + "')", req.isInApp) {
            /** @type {string} */
            var messageFormat = JSON.stringify(req.param);
            if (messageFormat) {
              /** @type {string} */
              messageFormat = messageFormat.replace(/\"/g, "'");
            }
            /** @type {string} */
            optsData = "gotoAppFunc('" + (req.link ? req.link : "") + "'," + messageFormat + ")";
          }
          template += "<ion-slide><img ng-src='" + dataAndEvents.imgServer + req.url + "?random=" + deepDataAndEvents.getTimeStamp() + "' width='100%' height='100%' on-tap=\"" + optsData + '"></ion-slide>';
        });
        template += "</ion-slide-box>";
        $templateCache.put("businessCommunityAD.html", template);
        /** @type {string} */
        self.businessCommunityAD = "businessCommunityAD.html";
      });
    } else {
      /** @type {string} */
      self.businessCommunityAD = "businessCommunityAD.html";
    }
  };
  /**
   * @return {?}
   */
  var getEncodedLen = function() {
    /** @type {string} */
    var rreturn = dataAndEvents.mmsServer + "/KEY412";
    return ret.fullPathPostEncode(rreturn);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    loading.show();
    getEncodedLen().success(function(r) {
      self.items = r.rows;
    }).finally(function() {
      loading.hide();
      widget.resize("businessCommunityMainScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getItemList = function() {
    loading.show();
    ret.fullPathPostEncode(dataAndEvents.mmsServer + "/KEY364").success(function(theTitle) {
      /** @type {Array} */
      self.buttonArr = theTitle;
    }).finally(function() {
      loading.hide();
    });
  };
  self.$on("$ionicView.afterEnter", function() {
    put();
    self.getList();
    self.getItemList();
  });
  self.$on("$ionicView.beforeLeave", function() {
    /** @type {string} */
    self.businessCommunityAD = "";
  });
}]).controller("InformationDetailCtrl", ["$scope", "$stateParams", "wechatShare", "qqShare", "$ionicModal", "ServerConfig", function(options, ev, self, _, $modal, dataAndEvents) {
  var item = ev.item;
  /** @type {string} */
  options.viewTitle = "生意圈";
  options.title = item.title;
  var content = item.content;
  /** @type {(HTMLElement|null)} */
  var elem = document.getElementById("KEY306");
  elem.innerHTML = content;
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  options.getListPictureUrl = function(dataAndEvents) {
    return dataAndEvents ? dataAndEvents : "img/detailpic_no.png";
  };
  /** @type {string} */
  var android = options.platformIsAndroid ? "android" : "ios";
  /** @type {string} */
  var queueHooks = "&userid=" + options.mainUserConfig.userId + "&cid=" + options.mainUserConfig.cid + "&client=isapp&agent=" + android + "&topic=informationShare&log=";
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  options.share = function(opt_attributes) {
    /** @type {string} */
    var key = "https://xinba-log.log.aliyuncs.com/logstores/log_store_tracking/track?APIVersion=0.6.0" + queueHooks;
    var pdataCur = options.getListPictureUrl(item.summaryPicUrl);
    /** @type {string} */
    var form = dataAndEvents.mmsServer + "/information/detail-" + item.id + ".html";
    if ("Timeline" == opt_attributes) {
      key += "Timeline";
      self.shareUrlToTimeline(form, item.title, item.summary, pdataCur);
    } else {
      if ("friend" == opt_attributes) {
        key += "friend";
        self.shareUrlToSession(form, item.title, item.summary, pdataCur);
      } else {
        if ("qq" == opt_attributes) {
          key += "qq";
          _.shareUrlToQq(form, item.title, item.summary, pdataCur);
        } else {
          if ("qz" == opt_attributes) {
            key += "qz";
            /** @type {Array} */
            var progressValues = [];
            progressValues.push(pdataCur);
            _.shareUrlToQz(form, item.title, item.summary, progressValues);
          }
        }
      }
    }
    $.get(key);
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY040.html", function(uri) {
    options.KEY263 = uri;
  }, {
    scope : options,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  options.openShareModal = function() {
    $.get(options.logPath + "mainShare");
    options.KEY263.show();
  };
}]);
