angular.module("clientController", ["ionic", "services", "tools"]).controller("ClientListCtrl", ["$scope", "$timeout", "$state", "psisServices", "lbScrollDelegate", "$ionicPopup", "$ionicPopover", "$ionicModal", "lbSpinnerDialog", "$q", "Tools", "lruPersistCache", "$cordovaDatePicker", "BluetoothPrintService", "$stateParams", function($scope, $sanitize, $state, that, parent, view, FB, $modal, loading, $q, UnitTools, $templateCache,
scope, jsPDFAPI, binder) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var getPromise3 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  /** @type {string} */
  $scope.searchKey = "";
  /** @type {number} */
  $scope.clientSum = 0;
  /** @type {string} */
  $scope.focused = "centered";
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.queryCondition = {
    clientItem : "",
    area : ""
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return that.postEncode("/KEY024", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var setup = function() {
    /** @type {number} */
    page = 1;
    createDom({
      page : page,
      clientName : $scope.searchKey,
      cellphone : $scope.searchKey,
      clientNamePy : $scope.searchKey,
      clientItem : $scope.queryCondition.clientItem,
      area : $scope.queryCondition.area
    }).success(function(data) {
      $scope.items = data.rows;
      $scope.clientSum = data.records;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("clientListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page,
      clientName : $scope.searchKey,
      cellphone : $scope.searchKey,
      clientNamePy : $scope.searchKey,
      clientItem : $scope.queryCondition.clientItem,
      area : $scope.queryCondition.area
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("clientListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {string} */
    $scope.searchKey = "";
    document.getElementById("searchInput").blur();
    /** @type {string} */
    $scope.focused = "centered";
    /** @type {number} */
    page = 1;
    createDom({
      page : page,
      clientName : $scope.searchKey,
      cellphone : $scope.searchKey,
      clientNamePy : $scope.searchKey,
      clientItem : $scope.queryCondition.clientItem,
      area : $scope.queryCondition.area
    }).success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  $scope.goClientEdit = function(term) {
    $state.go("eventmenu.KEY231", {
      id : term
    });
  };
  /**
   * @return {undefined}
   */
  $scope.goCompanyConfig = function() {
    $state.go("eventmenu.companyConfig");
  };
  /**
   * @return {undefined}
   */
  $scope.searchClient = function() {
    setup();
  };
  var throttledUpdate = ionic.debounce($scope.searchClient, 500);
  /**
   * @return {undefined}
   */
  $scope.searchClientByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  $scope.focus = function() {
    document.getElementById("searchInput").focus();
  };
  /**
   * @return {undefined}
   */
  $scope.clearSearch = function() {
    /** @type {string} */
    $scope.searchKey = "";
    /** @type {string} */
    $scope.focused = "centered";
    $scope.searchClient();
  };
  /**
   * @param {string} b
   * @return {undefined}
   */
  $scope.phoneCall = function(b) {
    if (b) {
      /** @type {string} */
      document.location.href = "tel:" + b;
    } else {
      view.alert({
        template : "<div class='tc'>该客户没有记录电话号码</div>",
        okText : "确定"
      });
    }
  };
  /**
   * @param {string} b
   * @return {undefined}
   */
  $scope.smsSend = function(b) {
    if (b) {
      /** @type {string} */
      document.location.href = "sms:" + b;
    } else {
      view.alert({
        template : "<div class='tc'>该客户没有记录电话号码</div>",
        okText : "确定"
      });
    }
  };
  FB.fromTemplateUrl("contactOperation.html", {
    scope : $scope
  }).then(function($location) {
    $scope.contactOperationPopover = $location;
  });
  /**
   * @param {string} paramType
   * @return {undefined}
   */
  $scope.goToPickContact = function(paramType) {
    $state.go("eventmenu.KEY168", {
      type : paramType
    });
  };
  FB.fromTemplateUrl("clientOperation.html", {
    scope : $scope
  }).then(function($location) {
    $scope.clientOperationPopover = $location;
  });
  $modal.fromTemplateUrl("clientItem.html", function($location) {
    $scope.clientItemModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("clientFilter.html", function($location) {
    $scope.clientFilterModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("clientTypePopover.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.clientTypePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openClientTypePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.clientTypePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideClientTypePopover = function() {
    $scope.clientTypePopover.hide();
  };
  $scope.$on("$destroy", function() {
    $scope.clientFilterModal.remove();
    $scope.clientTypePopover.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.getAllClientTypeItems = function() {
    that.httpCacheGet.get(that.httpCacheGet.ac.ALLCLIENTITEMS).success(function($location) {
      $scope.arrClientItem = $location;
    });
  };
  /**
   * @param {Function} newVal
   * @return {undefined}
   */
  $scope.selectClientItem = function(newVal) {
    /** @type {Function} */
    $scope.clienTypeItem = newVal;
    $scope.queryCondition.clientItem = newVal.id;
  };
  /**
   * @return {undefined}
   */
  $scope.doClientFilter = function() {
    setup();
    $scope.clientFilterModal.hide();
  };
  /**
   * @return {undefined}
   */
  $scope.clearFilter = function() {
    /** @type {string} */
    $scope.queryCondition.area = "";
  };
  /**
   * @return {undefined}
   */
  $scope.clearClienType = function() {
    $scope.clienTypeItem = {};
    /** @type {string} */
    $scope.queryCondition.clientItem = "";
    $scope.doClientFilter();
  };
  $scope.record = {
    client : {},
    clientBanlance : 0,
    receiptAmount : 0
  };
  /** @type {boolean} */
  $scope.isGetOtherData = false;
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY121.html", function($location) {
    $scope.clientReceiptEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY190 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY119 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  $scope.$on("$destroy", function() {
    $scope.clientReceiptEditModal.remove();
    $scope.KEY190.remove();
    $scope.KEY119.remove();
    $scope.contactOperationPopover.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.setCreateTime = function() {
    scope.show({
      date : new Date($scope.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.record.createTime = date1.getTime();
      }
    });
  };
  /**
   * @param {?} v
   * @return {?}
   */
  $scope.fixedInputNumber = function(v) {
    /** @type {RegExp} */
    return UnitTools.getValidNum(v);
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  $scope.getValidNum = function(deepDataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents);
  };
  /**
   * @param {?} actualObject
   * @return {undefined}
   */
  $scope.setDiscountAmount = function(actualObject) {
    var object = actualObject;
    /** @type {string} */
    var x = "请输入本次收款优惠金额";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            $scope.record.discountAmount = res.input1 >= 0 ? $scope.getValidNum(res.input1) : object;
          });
        }
      }, "优惠金额", ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="record.discountAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.record.discountAmount = $scope.getValidNum($scope.record.discountAmount);
          }
        }]
      });
    }
  };
  /**
   * @return {?}
   */
  $scope.confirmReceipt = function() {
    if (0 == $scope.fixedInputNumber($scope.record.receiptAmount) && 0 == $scope.getValidNum($scope.record.discountAmount)) {
      return view.alert({
        template : "<div class='tc'>本次收款和优惠金额不能同时为0</div>",
        okText : "确定"
      }), false;
    }
    if (!(0 == $scope.fixedInputNumber($scope.record.realAmount) || $scope.record.KEY293 && ($scope.record.KEY293.id && ($scope.record.accountItem && $scope.record.accountItem.id)))) {
      return view.alert({
        template : "<div class='tc'>请选择账户和账目类型！</div>",
        okText : "确定"
      }), false;
    }
    if ($scope.record.createTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date($scope.record.createTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      $scope.record.createTime = midnight.getTime();
    }
    loading.show();
    that.post("/KEY013", {
      oppositeSideId : $scope.record.client.val,
      realAmount : $scope.fixedInputNumber($scope.record.receiptAmount),
      discountAmount : $scope.getValidNum($scope.record.discountAmount),
      accountId : $scope.record.KEY293.id,
      businessItem : $scope.record.accountItem.id,
      createTime : $scope.record.createTime,
      remark : $scope.record.remark
    }).success(function(res) {
      if (1 == res.statusCode) {
        UnitTools.toastShow("成功收了一笔！");
        $scope.record.clientBanlance = res.object.banlance;
        jsPDFAPI.autoPrint($scope.mainCompany.comName, res.object.businessSn, jsPDFAPI.orderType.receiptOrder);
        /** @type {number} */
        $scope.record.receiptAmount = 0;
        /** @type {string} */
        $scope.record.discountAmount = "";
        /** @type {string} */
        $scope.record.remark = "";
        $scope.clientReceiptEditModal.hide();
      } else {
        UnitTools.toastShow(res.content);
      }
    }).finally(function() {
      setup();
      loading.hide();
    });
  };
  /**
   * @param {Element} item
   * @return {undefined}
   */
  $scope.KEY121 = function(item) {
    loading.show();
    $scope.clientReceiptEditModal.show();
    /** @type {number} */
    $scope.record.receiptAmount = 0;
    $scope.record.client.text = item.clientName;
    $scope.record.client.val = item.id;
    $scope.record.clientBanlance = item.balance;
    /** @type {number} */
    $scope.record.createTime = (new Date).getTime();
    if (0 == $scope.isGetOtherData) {
      fetch().then(function(packs) {
        $scope.allAccounts = packs[0].data.rows;
        $scope.record.KEY293 = $scope.allAccounts[0];
        $scope.allAccountItems = packs[1].data.rows;
        /** @type {number} */
        var i = 0;
        for (;i < $scope.allAccountItems.length;i++) {
          if (0 == $scope.allAccountItems[i].isEnable || (1 == $scope.allAccountItems[i].id || (10 == $scope.allAccountItems[i].id || 5 == $scope.allAccountItems[i].id))) {
            $scope.allAccountItems.splice(i, 1);
            i--;
          }
        }
        $scope.record.accountItem = $scope.allAccountItems[0];
        loading.hide();
      });
      /** @type {boolean} */
      $scope.isGetOtherData = true;
    } else {
      loading.hide();
    }
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshClientList")) {
      setup();
      $templateCache.put("refreshClientList", false);
    }
  });
  $scope.$on("modal.hidden", function() {
    if ($templateCache.get("refreshClientItemFlag") === true) {
      $scope.getAllClientTypeItems();
      $templateCache.put("refreshClientItemFlag", false);
    }
  });
  $scope.$on("$ionicView.loaded", function() {
    $scope.getAllClientTypeItems();
    setup();
    if (binder.binding) {
      $sanitize(function() {
        UnitTools.toastShow("选择客户，在详细信息页进行绑定帐号", "long");
      }, 800);
    }
  });
}]).controller("ClientDetailCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "ServerConfig", "lruPersistCache", "lbScrollDelegate", "$cordovaDatePicker", "$state", "BluetoothPrintService", "VaApplyItem", "$http", "BusinessConstant", "commonDataInterface", function(self, depMap, that, UnitTools, FB, $modal, $q, view, loading, obj, $templateCache,
deepDataAndEvents, $scope, $state, jsPDFAPI, dataAndEvents, $injector, message, res) {
  /**
   * @return {undefined}
   */
  function save() {
    loading.show();
    /** @type {string} */
    var __workspace = "sms:" + self.cellphoneObj.cellphone + (self.platformIsIOS ? "&body=" : "?body=");
    /** @type {string} */
    var filepath = "我在用辛巴手机版，手机管店方便好用又免费，推荐你一起使用。";
    that.post("/KEY440").success(function(r) {
      if (1 === r.statusCode) {
        $injector.get("https://api.t.sina.com.cn/short_url/shorten.json?source=1603536394&url_long=" + r.backUrl).success(function(newlines) {
          if (newlines && newlines.length > 0) {
            var href = newlines[0].url_short;
            /** @type {string} */
            document.location.href = __workspace + filepath + href;
          } else {
            UnitTools.toastShow("获取短链接出错");
          }
        }).error(function() {
          UnitTools.toastShow("获取短链接出错");
        });
      } else {
        UnitTools.toastShow("获取推荐码链接失败");
      }
      loading.hide();
    }).error(function() {
      UnitTools.toastShow("获取推荐码链接失败");
      loading.hide();
    });
  }
  /**
   * @return {?}
   */
  function update() {
    if (0 == self.fixedInputNumber(self.record.receiptAmount) && 0 == self.getValidNum(self.record.discountAmount)) {
      /** @type {string} */
      var scope = "本次收款和优惠金额不能同时为0";
      return self.isDeposit && (scope = "充值和赠送金额不能同时为0"), view.alert({
        template : "<div class='tc'>" + scope + "</div>",
        okText : "确定"
      }), false;
    }
    if (!(0 == self.fixedInputNumber(self.record.realAmount) || self.record.KEY293 && (self.record.KEY293.id && (self.record.accountItem && self.record.accountItem.id)))) {
      return view.alert({
        template : "<div class='tc'>请选择账户和账目类型！</div>",
        okText : "确定"
      }), false;
    }
    if (self.isDeposit && (self.record.accountItem.id = 6), self.record.createTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date(self.record.createTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      self.record.createTime = midnight.getTime();
    }
    loading.show();
    that.post("/KEY013", {
      oppositeSideId : self.record.client.val,
      realAmount : self.payOrCharge ? -self.getValidNum(self.record.receiptAmount) : self.getValidNum(self.record.receiptAmount),
      discountAmount : self.getValidNum(self.record.discountAmount),
      accountId : self.record.KEY293.id,
      businessItem : self.record.accountItem.id,
      createTime : self.record.createTime,
      remark : self.record.remark
    }).success(function(res) {
      if (1 == res.statusCode) {
        UnitTools.toastShow(self.isDeposit ? "充值成功！" : "成功收了一笔！");
        self.client.balance = res.object.banlance;
        self.client.balance = null == self.client.balance ? 0 : self.client.balance;
        self.record.clientBanlance = self.client.balance;
        self.isDeposit = self.getAppAccResource(5) && (self.customerPointOn && self.client.balance <= 0);
        /** @type {string} */
        self.receiptContent = self.isDeposit ? "充值" : "收款";
        /** @type {string} */
        self.balanceContent = self.client.balance < 0 || 0 == self.client.balance && (self.getAppAccResource(5) && self.customerPointOn) ? "当前余额" : "总欠款";
        $templateCache.put("refreshClientList", true);
        jsPDFAPI.autoPrint(self.mainCompany.comName, res.object.businessSn, jsPDFAPI.orderType.receiptOrder);
        /** @type {number} */
        self.record.receiptAmount = 0;
        /** @type {string} */
        self.record.discountAmount = "";
        /** @type {string} */
        self.record.remark = "";
        if (self.depositModal && self.depositModal.isShown()) {
          self.depositModal.hide();
        } else {
          self.clientReceiptEditModal.hide();
        }
      } else {
        UnitTools.toastShow(res.content);
      }
    }).finally(function() {
      loading.hide();
    });
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var getPromise3 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @return {?}
   */
  function resolve() {
    var imageDfd = $q.defer();
    var request1 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLCLIENTITEMS);
    var getPromise3 = that.httpCacheGet.get(that.httpCacheGet.ac.AllArea);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  var id = depMap.id;
  self.validatePhone = {};
  /** @type {Array} */
  var key = [];
  self.viewTitle = self.NameConstant.KEY268;
  /** @type {number} */
  self.state = 0;
  self.client = {};
  self.initDebtObject = {
    initDebtAmount : "",
    initDebtTime : (new Date).getTime(),
    initDebtRemark : ""
  };
  self.KEY231 = {};
  self.KEY231.accountItem = UnitTools.fnCheckGtoreQty(obj.userConfigData, "configKey", "KEY265.accountItem");
  if (self.KEY231.accountItem) {
    if (self.KEY231.accountItem.configValue) {
      /** @type {*} */
      self.KEY231.accountItemValue = JSON.parse(self.KEY231.accountItem.configValue);
    }
  }
  /** @type {boolean} */
  self.customerPointOn = obj.companyConfigData.customerPoint ? obj.companyConfigData.customerPoint == message.CUSTOMERPOINT.ON : false;
  /**
   * @return {undefined}
   */
  self.goClientEdit = function() {
    $state.go("eventmenu.KEY268", {
      id : self.client.id
    });
  };
  /**
   * @return {undefined}
   */
  self.showClientAccRecord = function() {
    $state.go("eventmenu.KEY151", {
      oppositeSideId : id,
      clientName : self.client.clientName,
      clientBanlance : self.client.balance
    });
  };
  /** @type {boolean} */
  self.client.statusSetting = true;
  self.clientsInfo = {
    clientItem : {},
    province : {},
    city : {},
    country : {}
  };
  self.clientConfig = {
    moreItem : 0
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY190 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY119 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY230.html", function(theTitle) {
    /** @type {number} */
    self.KEY230 = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.goClientBuyRecord = function() {
    $state.go("eventmenu.KEY144", {
      client : {
        val : self.client.id,
        text : self.client.clientName
      }
    });
  };
  /**
   * @param {Object} event
   * @return {undefined}
   */
  self.openBindingModal = function(event) {
    if (event && event.stopPropagation(), self.cellphoneObj.cellphone = self.cellphoneObj.cellphone ? self.cellphoneObj.cellphone : self.clientChain.clientCellphone ? self.clientChain.clientCellphone : self.client.cellphone || "", self.cellphoneObj.cellphone && 0 == self.cellphoneObj.cellphone.indexOf(0)) {
      /** @type {number} */
      var i = 0;
      for (;i < self.internationalCodes.length;i++) {
        if (self.internationalCodes[i].val.length > 0 && 0 == self.cellphoneObj.cellphone.indexOf(self.internationalCodes[i].val)) {
          self.cellphoneObj.cellphone = self.cellphoneObj.cellphone.substr(self.internationalCodes[i].val.length, self.cellphoneObj.cellphone.length);
          self.obj.areaCode = self.internationalCodes[i].code;
          break;
        }
      }
    }
    self.refreshValidateCodeImg();
    /** @type {string} */
    self.cellphoneObj.verifyCode = "";
    self.KEY230.show();
  };
  /**
   * @param {string} err
   * @param {?} event
   * @return {undefined}
   */
  self.callUp = function(err, event) {
    if (event) {
      event.stopPropagation();
    }
    if (err) {
      self.openLink("tel:" + err);
    } else {
      0;
    }
  };
  self.internationalCodes = message.INTERNATIONALCODES;
  self.obj = {};
  self.obj.areaCode = self.internationalCodes[0].code;
  $modal.fromTemplateUrl("html/PSystemSetup/KEY127.html", function(theTitle) {
    self.internationalCodeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.openInternationalCodeModal = function() {
    self.internationalCodeModal.show();
  };
  self.$on("$destroy", function() {
    self.internationalCodeModal.remove();
  });
  /**
   * @return {undefined}
   */
  self.refreshValidateCodeImg = function() {
    self.validateCodeImgUrl = self.getValidateCodeImgUrl();
  };
  /**
   * @return {?}
   */
  self.getSubmitCellphone = function() {
    if ("" == self.validatePhone.pre || void 0 == self.validatePhone.pre) {
      return self.cellphoneObj.cellphone;
    }
    var frag = self.cellphoneObj.cellphone;
    return "0" == frag.substr(0, 1) && (frag = frag.substr(1)), frag = self.validatePhone.pre + frag;
  };
  self.cellphoneObj = {};
  /**
   * @return {?}
   */
  self.saveClientChain = function() {
    return UnitTools.isValidCellPhoneNo(self.cellphoneObj.cellphone, self.validatePhone.pre) ? (loading.show(), void that.post("/admin/inner/clientChain/saveClientChain.ac?captcha=" + self.cellphoneObj.verifyCode, {
      clientId : self.client.id,
      clientCellphone : self.getSubmitCellphone()
    }).success(function(res) {
      if (1 == res.statusCode) {
        UnitTools.toastShow(res.content);
        self.KEY230.hide();
        self.getClientChain();
      } else {
        if ("绑定的手机号错误！" == res.content) {
          /** @type {string} */
          var simple = "客户尚未注册辛巴手机版，是否立刻推荐客户下载使用？";
          if (window.cordova && window.cordova.plugins) {
            UnitTools.showConfirm(simple, function(dataAndEvents) {
              if (2 == dataAndEvents) {
                save();
              }
            }, "推荐客户用辛巴", ["取消", "确定"]);
          } else {
            var promise = view.confirm({
              template : "<div class='tc'>" + simple + "</div>",
              cancelText : "取消",
              okText : "确定"
            });
            promise.then(function(dataAndEvents) {
              if (dataAndEvents) {
                save();
              }
            });
          }
        } else {
          UnitTools.toastShow(res.content);
        }
        console.log(res.content);
        self.refreshValidateCodeImg();
        /** @type {string} */
        self.cellphoneObj.verifyCode = "";
      }
    }).finally(function() {
      loading.hide();
    })) : void UnitTools.toastShow("手机号不正确");
  };
  /**
   * @return {undefined}
   */
  self.getClientChain = function() {
    /** @type {string} */
    self.bindingStatusContent = "未绑定客户的辛巴帐号";
    /** @type {string} */
    self.bindingButtonConten = "绑定";
    that.post("/KEY033?clientId=" + self.client.id).success(function(res) {
      if (1 == res.statusCode) {
        self.clientChain = res.object ? res.object : {};
        if (self.clientChain.clientCellphone) {
          self.bindingStatusContent = self.clientChain.clientCellphone;
          self.bindingStatusContent += 1 == self.clientChain.granted ? "[已授权]" : "[未授权]";
          /** @type {string} */
          self.bindingButtonConten = "更改";
        }
      } else {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.deleteClientChain = function() {
    loading.show(true);
    that.post("/admin/inner/clientChain/deleteClientChain.ac?chainId=" + self.clientChain.id).success(function(res) {
      if (1 == res.statusCode) {
        self.getClientChain();
        UnitTools.toastShow("解绑成功");
      } else {
        UnitTools.toastShow(res.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {Element} client
   * @param {?} event
   * @return {undefined}
   */
  self.gotoClientStore = function(client, event) {
    if (event) {
      event.stopPropagation();
    }
    if (1 === self.clientChain.granted) {
      $state.go("eventmenu.KEY235", {
        clientId : client.id,
        clientName : client.clientName
      });
    } else {
      UnitTools.toastShow("请先绑定授权账号");
    }
  };
  self.$on("$destroy", function() {
    self.KEY190.remove();
    self.KEY119.remove();
    if (self.clientReceiptEditModal) {
      self.clientReceiptEditModal.remove();
    }
    if (self.depositModal) {
      self.depositModal.remove();
    }
    self.KEY230.remove();
  });
  /**
   * @return {undefined}
   */
  self.setCreateTime = function() {
    $scope.show({
      date : new Date(self.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.record.createTime = date1.getTime();
      }
    });
  };
  self.$watch("[record.accountItem]", function(results, f) {
    if (results[0] && (f[0] && (results[0].id != f[0].id && (f[0].id > 0 && 6 != results[0].id)))) {
      var msg = {
        val : self.record.accountItem.id,
        id : self.record.accountItem.id,
        text : self.record.accountItem.name,
        name : self.record.accountItem.name
      };
      res.saveOrUpdateUserConfig("KEY265.accountItem", JSON.stringify(msg), 3).then(function(event) {
        self.KEY231.accountItem = UnitTools.fnCheckGtoreQty(obj.userConfigData, "configKey", "KEY265.accountItem");
        if (self.KEY231.accountItem) {
          UnitTools.union(self.KEY231.accountItem, event.object);
        } else {
          obj.userConfigData.push(event.object);
        }
        /** @type {*} */
        self.KEY231.accountItemValue = JSON.parse(event.object.configValue);
      }, function() {
        UnitTools.toastShow("服务器获取数据出现异常！");
      });
    }
  }, true);
  /**
   * @param {?} v
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  self.fixedInputNumber = function(v, dataAndEvents) {
    /** @type {RegExp} */
    return UnitTools.getValidNum(v, dataAndEvents);
  };
  /**
   * @param {?} qualifier
   * @return {?}
   */
  self.isNum = function(qualifier) {
    /** @type {RegExp} */
    var isSimple = /^-?\d+(\.\d+)?$/;
    return isSimple.test(qualifier);
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  self.getValidNum = function(deepDataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents);
  };
  /**
   * @return {undefined}
   */
  self.goVaApply = function() {
    self.openLinkInIframe(dataAndEvents.getVaItem[5].title, dataAndEvents.getVaItem[5].htmlName);
  };
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY192.html", function(theTitle) {
    self.clientDebtEditModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  var score;
  /**
   * @return {?}
   */
  self.editClientScore = function() {
    if (!self.GetOperatorEventLimit("KEY170")) {
      return void self.showMessage("无客户积分管理权限");
    }
    score = self.client.score ? self.client.score : 0;
    /** @type {string} */
    var x = "当前积分为 " + score + " ，请输入新的积分";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(result) {
        if (2 == result.buttonIndex) {
          self.$apply(function() {
            return result.input1 >= 0 && /^[0-9]+$/.test(result.input1) ? (self.client.score = result.input1, void self.saveClient()) : (UnitTools.toastShow("请输入非负整数!"), false);
          });
        }
      }, "调整客户积分", ["取消", "确认"], score ? score.toString() : 0);
    } else {
      self.obj = {
        score : score
      };
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="obj.score" autofocus="true">',
        title : x,
        scope : self,
        buttons : [{
          text : "取消"
        }, {
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            if (/^[0-9]+$/.test(self.obj.score)) {
              self.client.score = self.obj.score;
              self.saveClient();
            } else {
              UnitTools.toastShow("请输入非负整数!");
            }
          }
        }]
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.confirmClientDebt = function() {
    if (self.GetOperatorEventLimit("KEY103") || UnitTools.dateFormat(new Date(self.initDebtObject.initDebtTime), "yyyy-MM-dd") == UnitTools.dateFormat(new Date, "yyyy-MM-dd")) {
      self.saveClient();
      self.clientDebtEditModal.hide();
    } else {
      if (window.cordova && window.cordova.plugins) {
        UnitTools.showAlert("您不具备数据补录权限,无法调整今日之前的欠款", function() {
          self.clientDebtEditModal.hide();
        }, null, "确定");
      } else {
        var promise = view.confirm({
          template : "<div class='tc'>您不具备数据补录权限,无法调整今日之前的欠款</div>",
          cancelText : "取消",
          okText : "确定"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            self.clientDebtEditModal.hide();
          }
        });
      }
      that.post("/KEY032?id=" + id).success(function(message) {
        self.client = message.objClient;
        self.client.balance = null == self.client.balance ? 0 : self.client.balance;
        self.isDeposit = self.getAppAccResource(5) && (self.customerPointOn && self.client.balance <= 0);
        /** @type {string} */
        self.receiptContent = self.isDeposit ? "充值" : "收款";
        /** @type {string} */
        self.balanceContent = self.client.balance < 0 || 0 == self.client.balance && (self.getAppAccResource(5) && self.customerPointOn) ? "当前余额" : "总欠款";
        self.initDebtObject.initDebtAmount = self.client.initDebtAmount;
        self.initDebtObject.initDebtTime = self.client.initDebtTime ? self.client.initDebtTime : (new Date).getTime();
        self.initDebtObject.initDebtRemark = self.client.initDebtRemark ? self.client.initDebtRemark : "";
      });
    }
  };
  /**
   * @return {?}
   */
  self.saveClient = function() {
    var attributes = {};
    if (self.initDebtObject.initDebtAmount < -9.999999999E7 || self.initDebtObject.initDebtAmount > 9.999999999E7) {
      return view.alert({
        template : "<div class='tc'>输入金额超出范围</div>",
        okText : "确定"
      }), false;
    }
    if (self.GetOperatorEventLimit("KEY042") && (self.initDebtObject.initDebtAmount && "" != self.initDebtObject.initDebtAmount || 0 === self.initDebtObject.initDebtAmount)) {
      if (!self.isNum(self.initDebtObject.initDebtAmount) && 0 != self.initDebtObject.initDebtAmount) {
        return UnitTools.toastShow("请输入正确的期初欠款金额"), false;
      }
      self.initDebtObject.initDebtAmount = self.fixedInputNumber(self.initDebtObject.initDebtAmount, true);
      attributes = {
        clientVO : angular.toJson(self.client),
        score : self.fixedInputNumber(self.client.score),
        initDebtAmount : angular.toJson(self.initDebtObject.initDebtAmount),
        initDebtTime : UnitTools.dateFormat(new Date(self.initDebtObject.initDebtTime), "yyyy-MM-dd hh:mm:ss.S"),
        initDebtRemark : self.initDebtObject.initDebtRemark
      };
    } else {
      /** @type {string} */
      self.initDebtObject.initDebtAmount = "";
      attributes = {
        clientVO : angular.toJson(self.client),
        score : self.fixedInputNumber(self.client.score)
      };
    }
    if (self.initDebtObject.initDebtTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date(self.initDebtObject.initDebtTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      self.initDebtObject.initDebtTime = midnight.getTime();
    }
    loading.show(true);
    that.postEncode("/KEY034", attributes).success(function(event) {
      if (1 == event.statusCode) {
        UnitTools.union(self.client, event.objClient);
        self.client.balance = null == self.client.balance ? 0 : self.client.balance;
        self.isDeposit = self.getAppAccResource(5) && (self.customerPointOn && self.client.balance <= 0);
        /** @type {string} */
        self.receiptContent = self.isDeposit ? "充值" : "收款";
        /** @type {string} */
        self.balanceContent = self.client.balance < 0 || 0 == self.client.balance && (self.getAppAccResource(5) && self.customerPointOn) ? "当前余额" : "总欠款";
        UnitTools.toastShow("操作成功");
        $templateCache.put("refreshClientList", true);
      } else {
        self.client.score = score;
        view.alert({
          template : "<div class='tc'>" + event.content + "</div>",
          okText : "确定"
        });
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.setInitDebtTime = function() {
    if (window.cordova) {
      $scope.show({
        date : new Date(self.initDebtObject.initDebtTime),
        mode : "date",
        doneButtonLabel : "确定",
        cancelButtonLabel : "取消",
        minDate : (new Date).setDate((new Date).getDate() - 90),
        maxDate : (new Date).setDate((new Date).getDate())
      }).then(function(date1) {
        if (!isNaN(date1.getTime())) {
          self.initDebtObject.initDebtTime = date1.getTime();
        }
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.KEY122 = function() {
    $state.go("eventmenu.KEY122", {
      clientId : id
    });
  };
  /**
   * @return {undefined}
   */
  self.KEY080 = function() {
    $state.go("eventmenu.KEY080", {
      oppositeSideId : id,
      clientName : self.client.clientName,
      clientBanlance : self.client.balance
    });
  };
  /** @type {boolean} */
  self.isGetOtherData = false;
  self.record = {
    client : {}
  };
  /**
   * @return {undefined}
   */
  self.depositOrReceipt = function() {
    loading.show();
    if (self.isDeposit) {
      if (self.depositModal) {
        self.depositModal.show();
      } else {
        $modal.fromTemplateUrl("html/PClientBaseInfo/KEY043.html", function(theTitle) {
          self.depositModal = theTitle;
          self.depositModal.show();
        }, {
          scope : self,
          animation : "slide-in-up",
          focusFirstInput : false
        });
      }
    } else {
      if (self.clientReceiptEditModal) {
        self.clientReceiptEditModal.show();
      } else {
        $modal.fromTemplateUrl("html/PClientBaseInfo/KEY121.html", function(theTitle) {
          self.clientReceiptEditModal = theTitle;
          self.clientReceiptEditModal.show();
        }, {
          scope : self,
          animation : "slide-in-up",
          focusFirstInput : false
        });
      }
    }
    /** @type {number} */
    self.record.receiptAmount = 0;
    self.record.client.text = self.client.clientName;
    self.record.client.val = self.client.id;
    self.record.clientBanlance = self.client.balance;
    /** @type {number} */
    self.record.createTime = (new Date).getTime();
    if (0 == self.isGetOtherData) {
      fetch().then(function(packs) {
        self.allAccounts = packs[0].data.rows;
        self.record.KEY293 = self.allAccounts[0];
        self.allAccountItems = packs[1].data.rows;
        /** @type {number} */
        var i = 0;
        for (;i < self.allAccountItems.length;i++) {
          if (0 == self.allAccountItems[i].isEnable || (1 == self.allAccountItems[i].id || (10 == self.allAccountItems[i].id || 5 == self.allAccountItems[i].id))) {
            self.allAccountItems.splice(i, 1);
            i--;
          }
        }
        if (self.record.accountItem = self.allAccountItems[0], self.KEY231.accountItemValue) {
          /** @type {number} */
          i = 0;
          var l = self.allAccountItems.length;
          for (;l > i;i++) {
            if (self.KEY231.accountItemValue.id == self.allAccountItems[i].id) {
              self.record.accountItem = self.allAccountItems[i];
              break;
            }
          }
        }
        loading.hide();
      });
      /** @type {boolean} */
      self.isGetOtherData = true;
    } else {
      loading.hide();
    }
  };
  /**
   * @return {undefined}
   */
  self.changeCharge = function() {
    /** @type {string} */
    var simple = "确认更改收款/退款";
    /** @type {string} */
    simple = 1 == self.payOrCharge ? "切换后填写的金额为【本次收款】" : "切换后填写的金额为【本次退款】";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showConfirm(simple, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          self.$apply(function() {
            /** @type {number} */
            self.payOrCharge = 1 == self.payOrCharge ? 0 : 1;
          });
        }
      }, "收款/退款切换", ["取消", "切换"]);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : "<div>" + simple + "</div>",
        title : "收款/退款切换",
        scope : self,
        buttons : [{
          text : "确认",
          /**
           * @return {undefined}
           */
          onTap : function() {
            /** @type {number} */
            self.payOrCharge = 1 == self.payOrCharge ? 0 : 1;
          }
        }, {
          text : "取消",
          type : "button-assertive"
        }]
      });
    }
  };
  /**
   * @param {boolean} actualObject
   * @return {undefined}
   */
  self.setRechargeAmount = function(actualObject) {
    /** @type {boolean} */
    var object = actualObject;
    /** @type {string} */
    var x = self.record.clientBanlance ? self.record.clientBanlance < 0 ? "当前客户余额 " + Math.abs(self.record.clientBanlance) : "当前客户欠款 " + self.record.clientBanlance.toFixed(2) : "当前客户欠款 0.00";
    /** @type {string} */
    var after = self.payOrCharge ? "请输入本次退款金额" : "请输入本次收款金额";
    if (self.isDeposit) {
      /** @type {string} */
      x = "请输入本次充值的金额";
      /** @type {string} */
      after = "充值金额";
    }
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(results) {
        if (2 == results.buttonIndex) {
          self.$apply(function() {
            self.record.receiptAmount = results.input1 >= 0 ? self.getValidNum(results.input1) : object;
          });
        }
      }, after, ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="record.receiptAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : self,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            self.record.receiptAmount = self.getValidNum(self.record.receiptAmount);
          }
        }]
      });
    }
  };
  /**
   * @param {?} actualObject
   * @return {undefined}
   */
  self.setDiscountAmount = function(actualObject) {
    var object = actualObject;
    /** @type {string} */
    var x = self.isDeposit ? "请输入本次充值赠送金额" : "请输入本次收款优惠金额";
    /** @type {string} */
    var after = self.isDeposit ? "赠送金额" : "优惠金额";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(results) {
        if (2 == results.buttonIndex) {
          self.$apply(function() {
            self.record.discountAmount = results.input1 >= 0 ? self.getValidNum(results.input1) : object;
          });
        }
      }, after, ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="record.discountAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : self,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            self.record.discountAmount = self.getValidNum(self.record.discountAmount);
          }
        }]
      });
    }
  };
  var throttledUpdate = ionic.debounce(update, 500, true);
  /**
   * @return {undefined}
   */
  self.confirmReceiptAction = function() {
    throttledUpdate();
  };
  self.$on("$ionicView.afterEnter", function() {
    return 1 == $templateCache.get("isDeleteClient") ? (self.viewReplace(), $state.go("eventmenu.KEY269"), $templateCache.put("isDeleteClient", false), false) : (loading.show(), void resolve().then(function(packs) {
      self.arrClientItem = packs[0].data;
      key = packs[1].data;
      self.provinceItems = UnitTools.getObjectList(key, "pid", 0);
      /** @type {Array} */
      self.cityItems = [];
      /** @type {Array} */
      self.countryItems = [];
      if (id) {
        /** @type {number} */
        self.state = 1;
        that.post("/KEY032?id=" + id).success(function(message) {
          self.client = message.objClient;
          self.client.balance = null == self.client.balance ? 0 : self.client.balance;
          self.isDeposit = self.getAppAccResource(5) && (self.customerPointOn && self.client.balance <= 0);
          /** @type {string} */
          self.receiptContent = self.isDeposit ? "充值" : "收款";
          /** @type {string} */
          self.balanceContent = self.client.balance < 0 || 0 == self.client.balance && (self.getAppAccResource(5) && self.customerPointOn) ? "当前余额" : "总欠款";
          self.initDebtObject.initDebtAmount = self.client.initDebtAmount;
          self.initDebtObject.initDebtTime = self.client.initDebtTime ? self.client.initDebtTime : (new Date).getTime();
          self.initDebtObject.initDebtRemark = self.client.initDebtRemark ? self.client.initDebtRemark : "";
          /** @type {number} */
          var b = 0;
          var a = self.arrClientItem.length;
          for (;a > b;b++) {
            if (message.objClient.clientItem == self.arrClientItem[b].id) {
              self.clientsInfo.clientItem = self.arrClientItem[b];
              break;
            }
          }
          if (self.getClientChain(), self.addressInfo = "", self.client.provinceId && (self.clientsInfo.province = UnitTools.fnCheckGtoreQty(self.provinceItems, "id", self.client.provinceId), self.addressInfo += self.clientsInfo.province.areaName, self.client.cityId)) {
            var node = UnitTools.getObjectList(key, "pid", self.clientsInfo.province.id);
            if (self.clientsInfo.city = UnitTools.fnCheckGtoreQty(node, "id", self.client.cityId), self.addressInfo += self.clientsInfo.city.areaName, self.client.countyId) {
              var camelKey = UnitTools.getObjectList(key, "pid", self.clientsInfo.city.id);
              self.clientsInfo.country = UnitTools.fnCheckGtoreQty(camelKey, "id", self.client.countyId);
              self.addressInfo += self.clientsInfo.country.areaName;
            }
          }
          if (self.client.address) {
            self.addressInfo += self.client.address;
          }
        }).finally(function() {
          loading.hide();
        });
      }
    }, function() {
      loading.hide();
    }));
  });
}]).controller("ClientEditCtrl", ["$scope", "$state", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "ServerConfig", "lruPersistCache", "lbScrollDelegate", "BusinessConstant", function(self, ignoreMethodDoesntExist, map, $, dojo, textAlt, $modal, $q, _, loading, dataAndEvents, app, widget, deepDataAndEvents) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = $.httpCacheGet.get($.httpCacheGet.ac.ALLCLIENTITEMS);
    var getPromise3 = $.httpCacheGet.get($.httpCacheGet.ac.AllArea);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  var id = map.id;
  /** @type {Array} */
  var key = [];
  if (self.viewTitle = id ? self.NameConstant.KEY268 : self.NameConstant.CLIENTADD, self.state = map.id > 0 ? 1 : 0, self.client = {}, self.focusGoodsInput = false, self.client.statusSetting = true, self.clientsInfo = {
    clientItem : {},
    province : {},
    city : {},
    country : {}
  }, self.clientConfig = {
    moreItem : 0
  }, self.customerPointOn = dataAndEvents.companyConfigData.customerPoint ? dataAndEvents.companyConfigData.customerPoint == deepDataAndEvents.CUSTOMERPOINT.ON : false, map.name) {
    var name = map.name;
    /** @type {RegExp} */
    var rparentsprev = /^[0-9+]*$/;
    if (rparentsprev.test(name)) {
      self.client.cellphone = name;
    } else {
      self.client.clientName = name;
    }
  }
  /**
   * @return {undefined}
   */
  self.getMoreItem = function() {
    /** @type {number} */
    self.clientConfig.moreItem = 1;
    widget.resize("clientEditCtrlScroll");
  };
  $modal.fromTemplateUrl("clientItem.html", function(theTitle) {
    self.clientItemModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.showDiscountAlert = function() {
    if (window.cordova && window.cordova.plugins) {
      dojo.showAlert("该客户折扣根据客户积分折扣规则变动，不允许更改", function() {
      }, null, "确定");
    } else {
      _.alert({
        template : "<div class='tc'>该客户折扣根据客户积分折扣规则变动，不允许更改</div>",
        okText : "确定"
      });
    }
  };
  $modal.fromTemplateUrl("provinceSelect.html", function(theTitle) {
    self.provinceSelectModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("citySelect.html", function(theTitle) {
    self.citySelectModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("countrySelect.html", function(theTitle) {
    self.countrySelectModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.clientItemModal.remove();
    self.provinceSelectModal.remove();
    self.citySelectModal.remove();
    self.countrySelectModal.remove();
  });
  /**
   * @return {?}
   */
  self.discountCheck = function() {
    /** @type {RegExp} */
    var rhtml = /^\d{0,5}\.?[0-9]{0,2}$/;
    return rhtml.test(self.client.discount) && (self.client.discount >= 1 && self.client.discount <= 1E4) ? true : void 0;
  };
  /**
   * @return {?}
   */
  var parseOptions = function() {
    /** @type {RegExp} */
    var rhtml = /^[0-9-]*$/;
    return rhtml.test(self.client.phone) || ("" == self.client.phone || void 0 == self.client.phone) ? true : void 0;
  };
  /**
   * @return {?}
   */
  var test = function() {
    /** @type {RegExp} */
    var rhtml = /^[0-9+]*$/;
    return rhtml.test(self.client.cellphone) || ("" == self.client.cellphone || void 0 == self.client.cellphone) ? true : void 0;
  };
  /**
   * @return {?}
   */
  var activate = function() {
    /** @type {RegExp} */
    var rchecked = /^[a-z0-9!#$%&'*+\/=?^_`{|}~.-]+@[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$/i;
    return "" == self.client.email || (void 0 == self.client.email || rchecked.test(self.client.email)) ? true : void 0;
  };
  /**
   * @param {?} qualifier
   * @return {?}
   */
  self.isNum = function(qualifier) {
    /** @type {RegExp} */
    var isSimple = /^-?\d+(\.\d+)?$/;
    return isSimple.test(qualifier);
  };
  /**
   * @return {?}
   */
  self.saveClient = function() {
    var tasks;
    if (id) {
      if (tasks = "/KEY034", !self.GetOperatorEventLimit("KEY209")) {
        return dojo.toastShow("权限不足，请联系贵公司负责人授权!"), false;
      }
    } else {
      if (tasks = "/KEY034", !self.GetOperatorEventLimit("KEY227")) {
        return dojo.toastShow("权限不足，请联系贵公司负责人授权!"), false;
      }
    }
    var attributes = {};
    return self.client.clientName ? self.client.discount && self.discountCheck() ? self.client.showOrder ? parseOptions() ? test() ? activate() ? self.client.bankAccountId && 0 == self.isNum(self.client.bankAccountId) ? (_.alert({
      template : "<div class='tc'>银行账号请输入纯数字</div>",
      okText : "确定"
    }), false) : (self.client.clientItem = self.clientsInfo.clientItem.id ? self.clientsInfo.clientItem.id : "", self.client.provinceId = self.clientsInfo.province ? self.clientsInfo.province.id : "", self.client.cityId = self.clientsInfo.city ? self.clientsInfo.city.id : "", self.client.countyId = self.clientsInfo.country ? self.clientsInfo.country.id : "", self.client.status = 1 == self.client.statusSetting ?
    1 : 0, attributes = {
      clientVO : angular.toJson(self.client)
    }, loading.show(true), void $.postEncode(tasks, attributes).success(function(event) {
      if (1 == event.statusCode) {
        /**
         * @return {undefined}
         */
        var init = function() {
          dojo.union(self.client, event.objClient);
          /** @type {number} */
          self.state = 1;
          self.viewTitle = self.NameConstant.KEY268;
          if (app.get("needToAddClientFlag") === true) {
            app.put("addClientFlag", true);
            app.put("newClientObj", self.client);
            self.goBack();
          } else {
            self.goBack();
          }
        };
        _.alert({
          template : "<div class='tc'>保存客户成功</div>",
          okText : "确定"
        }).then(init);
        app.put("refreshClientList", true);
      } else {
        _.alert(2 == event.statusCode ? {
          template : "<div class='tc'>客户名称不能重复</div>",
          okText : "确定"
        } : {
          template : "<div class='tc'>" + event.content + "</div>",
          okText : "确定"
        });
      }
    }).finally(function() {
      loading.hide();
    })) : (dojo.toastShow("邮箱格式不正确", "short", "center"), console.log("邮箱格式不正确"), false) : (dojo.toastShow("手机必须是数字或+", "short", "center"), console.log("手机必须是数字或+"), false) : (dojo.toastShow("电话必须是数字或-", "short", "center"), console.log("电话必须是数字或-"),
    false) : (dojo.toastShow("请在排序栏输入整数", "short", "center"), console.log("请在排序栏输入整数"), false) : (dojo.toastShow("折扣必须是1至10000的两位小数", "short", "center"), console.log("折扣必须是1至10000的两位小数"), false) : (dojo.toastShow("需要填写名称", "short", "center"), console.log("需要填写名称"),
    false);
  };
  /**
   * @return {undefined}
   */
  self.deleteClient = function() {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除该客户?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        $.post("/KEY035?id=" + self.client.id).success(function(r) {
          if (1 == r.statusCode) {
            _.alert({
              template : "<div class='tc'>删除成功</div>",
              okText : "确定"
            }).then(function() {
              app.put("isDeleteClient", true);
              self.goBack();
              app.put("refreshClientList", true);
            });
          } else {
            _.alert({
              template : "<div class='tc'>删除失败，不能删除已发生业务来往的客户</div>",
              okText : "确定"
            });
          }
        }).finally(function() {
          loading.hide();
        });
      } else {
        console.log("取消");
      }
    });
  };
  self.$on("$ionicView.afterEnter", function() {
    loading.show();
    fetch().then(function(packs) {
      self.arrClientItem = packs[0].data;
      key = packs[1].data;
      self.provinceItems = dojo.getObjectList(key, "pid", 0);
      /** @type {Array} */
      self.cityItems = [];
      /** @type {Array} */
      self.countryItems = [];
      if (id) {
        /** @type {number} */
        self.clientConfig.moreItem = 1;
        /** @type {number} */
        self.state = 1;
        $.post("/KEY032?id=" + id).success(function(results) {
          self.client = results.objClient;
          self.matchDiscount = results.matchDiscount;
          /** @type {boolean} */
          self.client.status = self.client.statusSetting = 1 == results.objClient.status ? true : false;
          /** @type {number} */
          var b = 0;
          var a = self.arrClientItem.length;
          for (;a > b;b++) {
            if (results.objClient.clientItem == self.arrClientItem[b].id) {
              self.clientsInfo.clientItem = self.arrClientItem[b];
              break;
            }
          }
          if (self.client.provinceId && (self.clientsInfo.province = dojo.fnCheckGtoreQty(self.provinceItems, "id", self.client.provinceId), self.client.cityId)) {
            var node = dojo.getObjectList(key, "pid", self.clientsInfo.province.id);
            if (self.clientsInfo.city = dojo.fnCheckGtoreQty(node, "id", self.client.cityId), self.client.countyId) {
              var camelKey = dojo.getObjectList(key, "pid", self.clientsInfo.city.id);
              self.clientsInfo.country = dojo.fnCheckGtoreQty(camelKey, "id", self.client.countyId);
            }
          }
        }).finally(function() {
          loading.hide();
        });
      } else {
        /** @type {boolean} */
        self.focusGoodsInput = true;
        /** @type {number} */
        self.client.showOrder = 100;
        /** @type {number} */
        self.client.discount = 100;
        loading.hide();
      }
    }, function() {
      loading.hide();
    }).then(function() {
      self.$watch("clientsInfo.province", function() {
        if (dojo.isEmpty(self.clientsInfo.province)) {
          /** @type {Array} */
          self.cityItems = [];
          /** @type {Array} */
          self.countryItems = [];
        } else {
          self.cityItems = dojo.getObjectList(key, "pid", self.clientsInfo.province.id);
          /** @type {Array} */
          self.countryItems = [];
        }
      });
      self.$watch("clientsInfo.city", function() {
        self.countryItems = dojo.isEmpty(self.clientsInfo.city) ? [] : dojo.getObjectList(key, "pid", self.clientsInfo.city.id);
      });
    });
  });
}]).controller("ClientMultiSelectCtrl", ["$scope", "psisServices", "lbSpinnerDialog", "$ionicModal", "$state", "lbScrollDelegate", "$ionicPopup", "$stateParams", "lruPersistCache", "$ionicPopover", "Tools", function($scope, topic, poster, $modal, dataAndEvents, parent, deepDataAndEvents, ignoreMethodDoesntExist, $templateCache, FB, jQuery) {
  /**
   * @param {?} a
   * @return {?}
   */
  function objEquiv(a) {
    /** @type {number} */
    var i = 0;
    for (;i < $scope.recentSmClientPhones.length;i++) {
      if ($scope.recentSmClientPhones[i].targetCellphone == a) {
        return true;
      }
    }
    return false;
  }
  /** @type {Array} */
  $scope.items = [];
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.queryCondition = {
    page : 1,
    clientItem : "",
    area : ""
  };
  /** @type {string} */
  $scope.searchKey = "";
  $scope.filterObj = {
    filterCellphone : true,
    isFilterPhone : true,
    isFilterRecentPhone : false,
    filterRecentPhoneDays : 1
  };
  /** @type {boolean} */
  $scope.selectObj.isSelectAll = true;
  /** @type {Array} */
  $scope.recentSmClientPhones = [];
  $modal.fromTemplateUrl("clientFilter.html", function($location) {
    $scope.clientFilterModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("clientTypePopover.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.clientTypePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openClientTypePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.clientTypePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideClientTypePopover = function() {
    $scope.clientTypePopover.hide();
  };
  $scope.$on("$destroy", function() {
    $scope.clientFilterModal.remove();
    $scope.clientTypePopover.remove();
  });
  ionic.debounce($scope.getList, 500);
  /**
   * @return {undefined}
   */
  $scope.searchClientByKeyword = function() {
    $scope.getList();
  };
  if (!$scope.checklist) {
    $scope.checklist = {};
  }
  /** @type {Array} */
  $scope.checklist.selectedClients = [];
  /** @type {number} */
  $scope.checklist.selectedClients.length = 0;
  /**
   * @param {Element} elem
   * @return {?}
   */
  $scope.getIndexOfSelectClient = function(elem) {
    /** @type {number} */
    var declarationError = -1;
    /** @type {number} */
    var e = 0;
    for (;e < $scope.checklist.selectedClients.length;e++) {
      if ($scope.checklist.selectedClients[e].id == elem.id) {
        /** @type {number} */
        declarationError = e;
        break;
      }
    }
    return declarationError;
  };
  /**
   * @param {Element} fn
   * @return {undefined}
   */
  $scope.selectClients = function(fn) {
    var fnIndex = $scope.getIndexOfSelectClient(fn);
    if (fnIndex > -1) {
      $scope.checklist.selectedClients.splice(fnIndex, 1);
    } else {
      $scope.checklist.selectedClients.push(fn);
    }
  };
  /**
   * @return {undefined}
   */
  $scope.selectAll = function() {
    /** @type {Array} */
    $scope.checklist.selectedClients = [];
    /** @type {number} */
    var i = 0;
    for (;i < $scope.items.length;i++) {
      if ($scope.filterClient($scope.items[i])) {
        $scope.selectClients($scope.items[i]);
      }
    }
  };
  /**
   * @return {undefined}
   */
  $scope.deleteAll = function() {
    /** @type {Array} */
    $scope.checklist.selectedClients = [];
  };
  /**
   * @param {Function} newVal
   * @return {undefined}
   */
  $scope.selectClientItem = function(newVal) {
    /** @type {Function} */
    $scope.clienTypeItem = newVal;
    $scope.queryCondition.clientItem = newVal.id;
  };
  /**
   * @param {?} option
   * @return {?}
   */
  $scope.filterClient = function(option) {
    return(!$scope.filterObj.isFilterPhone || option.cellphone && (option.cellphone.length > 0 && jQuery.isValidCellPhoneNo(option.cellphone))) && !objEquiv(option.cellphone);
  };
  /**
   * @param {boolean} val
   * @param {number} dataAndEvents
   * @return {?}
   */
  $scope.getPositiveInt = function(val, dataAndEvents) {
    return jQuery.getPositiveInt(val, dataAndEvents);
  };
  /**
   * @return {undefined}
   */
  $scope.getRecentSmClientPhone = function() {
    if ($scope.filterObj.isFilterRecentPhone && $scope.filterObj.filterRecentPhoneDays > 0) {
      topic.postEncode("/KEY395", {
        dayNum : $scope.getPositiveInt($scope.filterObj.filterRecentPhoneDays, 1),
        page : 1
      }).success(function(result) {
        if (result) {
          if (1 == result.statusCode) {
            if (result.object) {
              if (result.object.list) {
                $scope.recentSmClientPhones = result.object.list;
              }
            }
          }
        }
      }).finally(function() {
        poster.hide();
      });
    } else {
      /** @type {Array} */
      $scope.recentSmClientPhones = [];
    }
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var Step = function(opt_attributes) {
    return topic.postEncode("/KEY340", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    Step({
      maxPageSize : 500,
      page : $scope.queryCondition.page,
      clientName : $scope.searchKey,
      cellphone : $scope.searchKey,
      clientNamePy : $scope.searchKey,
      clientItem : $scope.queryCondition.clientItem,
      area : $scope.queryCondition.area
    }).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("clientListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    Step({
      maxPageSize : 500,
      page : ++$scope.queryCondition.page,
      clientName : $scope.searchKey,
      cellphone : $scope.searchKey,
      clientNamePy : $scope.searchKey,
      clientItem : $scope.queryCondition.clientItem,
      area : $scope.queryCondition.area
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("clientListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    if ($scope.checklist) {
      /** @type {Array} */
      $scope.checklist.selectedClients = [];
      /** @type {boolean} */
      $scope.selectObj.isSelectAll = true;
    }
    $scope.queryCondition = {
      page : 1,
      clientItem : "",
      area : ""
    };
    $scope.clienTypeItem = {};
    Step({
      maxPageSize : 500,
      page : $scope.queryCondition.page,
      clientName : $scope.searchKey,
      cellphone : $scope.searchKey,
      clientNamePy : $scope.searchKey,
      clientItem : $scope.queryCondition.clientItem,
      area : $scope.queryCondition.area
    }).success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.clearSearch = function() {
    /** @type {string} */
    $scope.searchKey = "";
    /** @type {string} */
    $scope.focused = "centered";
    $scope.getList();
  };
  /**
   * @return {undefined}
   */
  $scope.clearCondition = function() {
    $scope.clienTypeItem = {};
    /** @type {string} */
    $scope.queryCondition.clientItem = "";
    /** @type {string} */
    $scope.queryCondition.area = "";
  };
  /**
   * @return {undefined}
   */
  $scope.getAllClientTypeItems = function() {
    topic.httpCacheGet.get(topic.httpCacheGet.ac.ALLCLIENTITEMS).success(function($location) {
      $scope.arrClientItem = $location;
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("clientListRefresh")) {
      if ($templateCache.get("clientListRefresh") === true) {
        $scope.getList();
        $templateCache.put("clientListRefresh", false);
      }
    }
  });
  $scope.getList();
  $scope.getAllClientTypeItems();
}]).controller("ClientItemCtrl", ["$scope", "psisServices", "$ionicPopup", "Tools", "$ionicPopover", "$ionicModal", "lbSpinnerDialog", "$state", function(self, doc, _, dojo, dataAndEvents, $modal, loading, $state) {
  /** @type {string} */
  self.clientItemEditModalTitle = "";
  self.setting = {};
  /** @type {boolean} */
  self.setting.priceStatus = false;
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY193.html", function(theTitle) {
    /** @type {number} */
    self.clientItemEditModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.clientItemEditModal.remove();
  });
  /**
   * @param {string} dataAndEvents
   * @param {(Object|string)} theTitle
   * @param {?} user
   * @return {undefined}
   */
  self.openClientItem = function(dataAndEvents, theTitle, user) {
    if ("insert" === dataAndEvents) {
      /** @type {string} */
      self.clientItemEditModalTitle = "新增客户类型";
      self.KEY193 = {
        isShow : 1,
        showOrder : 100
      };
      /** @type {boolean} */
      self.isEditType = false;
    } else {
      if ("update" === dataAndEvents) {
        /** @type {string} */
        self.clientItemEditModalTitle = "编辑客户类型";
        /** @type {(Object|string)} */
        self.KEY193 = theTitle;
        /** @type {boolean} */
        self.setting.priceStatus = 1 == theTitle.priceStatus;
        /** @type {boolean} */
        self.isEditType = true;
      }
    }
    self.clientItemIndex = user;
    self.clientItemEditModal.show();
  };
  /**
   * @param {?} mod
   * @param {Object} act
   * @return {undefined}
   */
  self.selectClientType = function(mod, act) {
    mod.clientItem = mod.clientItem.id == act.id ? {} : act;
    self.clientItemModal.hide();
  };
  /**
   * @return {?}
   */
  self.saveClientItem = function() {
    if (!self.KEY193.name) {
      return dojo.toastShow("请填写名称！", "short", "center"), void console.log("请填写名称！");
    }
    /** @type {number} */
    self.KEY193.priceStatus = self.setting.priceStatus ? 1 : 0;
    /** @type {boolean} */
    var n = !self.KEY193.id;
    var player = {
      newName : self.KEY193.name
    };
    if (!n) {
      player.clientItemId = self.KEY193.id;
    }
    doc.postEncode("/KEY037", player).success(function(e) {
      if (e.isValid) {
        doc.post("/KEY038", self.KEY193).success(function(event) {
          if (1 == event.statusCode) {
            dojo.toastShow("保存成功！");
            doc.httpCacheGet.remove(doc.httpCacheGet.ac.ALLCLIENTITEMS);
            lruPersistCache.put("refreshClientItemFlag", true);
            dojo.union(self.KEY193, event.object);
            if (n) {
              if ($state.includes("eventmenu.KEY291")) {
                event.object.setting = {
                  priceStatus : 1 == event.object.priceStatus
                };
                doc.get("/KEY069?priceEnable=true").success(function(obj) {
                  buildJSON(obj);
                });
              }
              self.arrClientItem.push(event.object);
            }
            self.clientItemEditModal.hide();
          } else {
            dojo.toastShow("保存失败！");
          }
        });
      } else {
        dojo.toastShow("客户类型已存在！", "short", "center");
        console.log("客户类型已存在！");
      }
    });
  };
  /**
   * @param {Object} expected
   * @param {?} r2
   * @return {?}
   */
  self.deleteClientItem = function(expected, r2) {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除" + expected.name + "?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        doc.post("/KEY039?id=" + expected.id).success(function(r) {
          if (1 == r.statusCode) {
            dojo.toastShow("删除成功！");
            doc.httpCacheGet.remove(doc.httpCacheGet.ac.ALLCLIENTITEMS);
            lruPersistCache.put("refreshClientItemFlag", true);
            self.arrClientItem.splice(r2, 1);
            if (self.clientsInfo) {
              if (angular.equals(self.clientsInfo.clientItem, expected)) {
                self.clientsInfo.clientItem = {};
              }
            }
          } else {
            dojo.toastShow("删除失败，不能删除已被使用的类型！");
          }
        });
      }
    }), true;
  };
  /**
   * @return {undefined}
   */
  self.savePriceStatus = function() {
    /** @type {Array} */
    var items = [];
    /** @type {number} */
    var i = 0;
    for (;i < self.arrClientItem.length;i++) {
      items.push({
        id : self.arrClientItem[i].id,
        priceStatus : 1 == self.arrClientItem[i].setting.priceStatus ? 1 : 0
      });
    }
    loading.show(true);
    doc.postEncode("/KEY078", {
      clientItems : angular.toJson(items)
    }).success(function(r) {
      if (1 == r.statusCode) {
        doc.get("/KEY069?priceEnable=true").success(function(obj) {
          buildJSON(obj);
          getObject();
        });
        doc.httpCacheGet.remove(doc.httpCacheGet.ac.ALLCLIENTITEMS);
      }
      init();
    }).finally(function() {
      dojo.keyboardHide();
      loading.hide();
    });
  };
  var value;
  /**
   * @return {undefined}
   */
  self.returnOldArrClientItem = function() {
    self.arrClientItem = dojo.union(value);
  };
  /**
   * @param {?} activeXObj
   * @return {undefined}
   */
  var buildJSON = function(activeXObj) {
    var asserterNames = self.goodsInfo.clientItemPrice;
    self.goodsInfo.clientItemPrice = activeXObj;
    asserterNames.forEach(function(item) {
      var result = dojo.fnCheckGtoreQty(self.goodsInfo.clientItemPrice, "id", item.id);
      if (result) {
        result.price = item.price;
      }
    });
  };
  /**
   * @return {undefined}
   */
  var getObject = function() {
    /** @type {number} */
    var i = 0;
    for (;i < self.goodsInfo.clientItemPrice.length;i++) {
      var temp = dojo.fnCheckGtoreQty(self.goodsClientItemPriceList, "clientItemId", self.goodsInfo.clientItemPrice[i].id);
      if (temp) {
        if (null == self.goodsInfo.clientItemPrice[i].price) {
          self.goodsInfo.clientItemPrice[i].price = temp.price;
        }
      }
    }
  };
  /**
   * @return {undefined}
   */
  var init = function() {
    doc.httpCacheGet.get(doc.httpCacheGet.ac.ALLCLIENTITEMS).success(function(codeSegments) {
      /** @type {Array} */
      self.arrClientItem = codeSegments;
      /** @type {number} */
      var i = 0;
      for (;i < codeSegments.length;i++) {
        self.arrClientItem[i].setting = {
          priceStatus : 1 == codeSegments[i].priceStatus
        };
      }
      value = dojo.union(self.arrClientItem);
    });
  };
  init();
}]).controller("PickFromContactCtrl", ["$scope", "$timeout", "psisServices", "Tools", "lbScrollDelegate", "$state", "$stateParams", "$ionicPopup", "ContactsService", "lbSpinnerDialog", "lruPersistCache", function(self, ignoreMethodDoesntExist, dataAndEvents, deepDataAndEvents, textAlt, $state, event, _, rule, loading, $templateCache) {
  var type = event.type;
  /** @type {Array} */
  self.contacts = [];
  /** @type {Array} */
  self.items = [];
  self.searchObj = {
    searchKey : ""
  };
  /** @type {string} */
  self.focused = "centered";
  loading.show();
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.searchObj.searchKey = "";
  };
  /**
   * @param {Object} $
   * @return {?}
   */
  self.filterName = function($) {
    return self.searchObj.searchKey.length > 0 ? $.name.indexOf(self.searchObj.searchKey) > -1 || 0 == $.mobile.indexOf(self.searchObj.searchKey) : true;
  };
  /**
   * @param {Function} name
   * @return {undefined}
   */
  self.findContact = function(name) {
    rule.find(name).then(function(contacts) {
      /** @type {Array} */
      var data = [];
      if (self.platformIsIOS) {
        /** @type {number} */
        var i = 0;
        for (;i < contacts.length;i++) {
          if (contacts[i].name.formatted) {
            data.push({
              name : contacts[i].name.formatted,
              mobile : contacts[i].phoneNumbers ? contacts[i].phoneNumbers[0].value.replace(/[ ,\-]/g, "") : ""
            });
          }
        }
      } else {
        /** @type {number} */
        i = 0;
        for (;i < contacts.length;i++) {
          if (contacts[i].displayName) {
            data.push({
              name : contacts[i].displayName,
              mobile : contacts[i].phoneNumbers ? contacts[i].phoneNumbers[0].value.replace(/[ ,\-]/g, "") : ""
            });
          }
        }
      }
      /** @type {Array} */
      self.contacts = data;
    });
    /** @type {Array} */
    self.selectedItems = [];
    loading.hide();
  };
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectContact = function(key) {
    var camelKey = self.selectedItems.indexOf(key);
    if (0 > camelKey) {
      self.selectedItems.push(key);
    } else {
      self.selectedItems.splice(camelKey, 1);
    }
  };
  /**
   * @return {undefined}
   */
  self.save = function() {
    var promise = _.confirm({
      template : "<div class='tc'>确认要从通讯录导入 " + self.selectedItems.length + " 个联系人?</div>",
      cancelText : "取消",
      okText : "确认导入"
    });
    /** @type {string} */
    self.focused = "centered";
    deepDataAndEvents.keyboardHide();
    promise.then(function(deepDataAndEvents) {
      if (deepDataAndEvents) {
        loading.show(true);
        /** @type {Array} */
        var new_val = [];
        if ("client" === type) {
          /** @type {number} */
          var a = 0;
          for (;a < self.selectedItems.length;a++) {
            new_val.push({
              clientName : self.selectedItems[a].name,
              cellphone : self.selectedItems[a].mobile,
              discount : 100,
              showOrder : 100
            });
          }
          dataAndEvents.postEncode("/KEY036", {
            clientVOList : angular.toJson(new_val)
          }).success(function(res) {
            if (1 == res.statusCode) {
              _.alert({
                template : "<div class='tc'>成功导入 " + res.object + " 名联系人</div>",
                okText : "确认"
              }).then(function() {
                self.viewReplace();
                $templateCache.put("refreshClientList", true);
                $state.go("eventmenu.KEY269");
              });
            } else {
              _.alert({
                template : "<div class='tc'>" + res.content + "</div>",
                okText : "确认"
              }).then(function() {
                self.clearSearch();
                /** @type {Array} */
                self.selectedItems = [];
              });
            }
          }).finally(function() {
            loading.hide();
          });
        } else {
          if ("KEY282" === type) {
            /** @type {number} */
            a = 0;
            for (;a < self.selectedItems.length;a++) {
              new_val.push({
                supplierName : self.selectedItems[a].name,
                cellphone : self.selectedItems[a].mobile,
                discount : 100,
                showOrder : 100
              });
            }
            dataAndEvents.postEncode("/KEY188", {
              supplierVOList : angular.toJson(new_val)
            }).success(function(res) {
              if (1 == res.statusCode) {
                _.alert({
                  template : "<div class='tc'>成功导入 " + res.object + " 名联系人</div>",
                  okText : "确认"
                }).then(function() {
                  self.viewReplace();
                  $templateCache.put("refreshSupplierList", true);
                  $state.go("eventmenu.KEY209");
                });
              } else {
                _.alert({
                  template : "<div class='tc'>" + res.content + "</div>",
                  okText : "确认"
                }).then(function() {
                  self.clearSearch();
                  /** @type {Array} */
                  self.selectedItems = [];
                });
              }
            }).finally(function() {
              loading.hide();
            });
          }
        }
      }
    });
  };
  self.findContact();
}]).controller("ClientDebtCtrl", ["$scope", "$state", "lbSpinnerDialog", "psisServices", "$ionicModal", "$ionicPopover", "lbScrollDelegate", "lruPersistCache", "Tools", "$cordovaDatePicker", function(self, $state, poster, request, $modal, FB, parent, $templateCache, UnitTools, $scope) {
  /**
   * @param {number} options
   * @return {undefined}
   */
  function run(options) {
    if (options > 0) {
      request.post("/KEY032?id=" + options).success(function(dataAndEvents) {
        if (null != dataAndEvents.objClient) {
          self.initDebtObject.initDebtAmount = dataAndEvents.objClient.initDebtAmount;
          self.initDebtObject.initDebtTime = dataAndEvents.objClient.initDebtTime ? dataAndEvents.objClient.initDebtTime : (new Date).getTime();
          self.initDebtObject.initDebtRemark = dataAndEvents.objClient.initDebtRemark;
        }
      });
    }
  }
  /** @type {Array} */
  self.items = [];
  /** @type {string} */
  self.focused = "centered";
  /** @type {boolean} */
  self.isLoading = true;
  self.queryCondition = {
    sord : "desc",
    sidx : "balance",
    clientName : "",
    balanceFrom : "",
    balanceTo : ""
  };
  /** @type {boolean} */
  self.isClientDebt = true;
  self.initDebtObject = {
    client : {},
    initDebtAmount : "",
    initDebtTime : (new Date).getTime(),
    initDebtRemark : ""
  };
  $modal.fromTemplateUrl("clientFilter.html", function(theTitle) {
    self.clientFilterModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("clientTypePopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.clientTypePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openClientTypePopover = function(expectedNumberOfNonCommentArgs) {
    self.clientTypePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideClientTypePopover = function() {
    self.clientTypePopover.hide();
  };
  FB.fromTemplateUrl("clientDebtOperation.html", {
    scope : self
  }).then(function(theTitle) {
    self.clientDeptOperationPopover = theTitle;
  });
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY192.html", function(theTitle) {
    self.clientDebtEditModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.confirmClientDebt = function() {
    self.clientDebtEditModal.hide();
    self.updateClientDebt();
  };
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY216.html", function(theTitle) {
    self.clientModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  /**
   * @return {undefined}
   */
  self.clientModalOpen = function() {
    self.clientModal.show().then(function() {
      UnitTools.keyboardShow();
    });
  };
  /**
   * @return {undefined}
   */
  self.clearClienType = function() {
    self.clienTypeItem = {};
    /** @type {string} */
    self.queryCondition.clientItem = "";
    self.getList();
  };
  self.$on("$destroy", function() {
    self.clientFilterModal.remove();
    self.clientTypePopover.remove();
    self.clientDeptOperationPopover.remove();
    self.clientDebtEditModal.remove();
    self.clientModal.remove();
  });
  self.$watch("[initDebtObject.client]", function(a) {
    run(a[0].val);
  }, true);
  /**
   * @return {undefined}
   */
  self.setInitDebtTime = function() {
    if (window.cordova) {
      $scope.show({
        date : new Date(self.initDebtObject.initDebtTime),
        mode : "date",
        doneButtonLabel : "确定",
        cancelButtonLabel : "取消",
        minDate : (new Date).setDate((new Date).getDate() - 90),
        maxDate : (new Date).setDate((new Date).getDate())
      }).then(function(date1) {
        if (!isNaN(date1.getTime())) {
          self.initDebtObject.initDebtTime = date1.getTime();
        }
      });
    }
  };
  /**
   * @param {?} v
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  self.fixedInputNumber = function(v, dataAndEvents) {
    /** @type {RegExp} */
    return UnitTools.getValidNum(v, dataAndEvents);
  };
  /**
   * @param {Element} client
   * @return {undefined}
   */
  self.showClientAccRecord = function(client) {
    $state.go("eventmenu.KEY151", {
      oppositeSideId : client.id,
      clientName : client.clientName,
      clientBanlance : client.balance
    });
  };
  /**
   * @return {undefined}
   */
  self.goToClientMGMT = function() {
    if (self.GetOperatorEventLimit("KEY247")) {
      $state.go("eventmenu.KEY269");
    }
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.queryCondition.clientName = "";
    /** @type {string} */
    self.focused = "centered";
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.clearFilter = function() {
    /** @type {string} */
    self.queryCondition.balanceFrom = "";
    /** @type {string} */
    self.queryCondition.balanceTo = "";
    /** @type {boolean} */
    self.queryCondition.showDebtClient = false;
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var Step = function(opt_attributes) {
    return request.postEncode("/KEY025", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    self.queryCondition.cellphone = self.queryCondition.clientName;
    self.queryCondition.clientNamePy = self.queryCondition.clientName;
    if (!self.queryCondition.balanceFrom) {
      if (!(0 === self.queryCondition.balanceFrom)) {
        delete self.queryCondition.balanceFrom;
      }
    }
    if (!self.queryCondition.balanceTo) {
      if (!(0 === self.queryCondition.balanceTo)) {
        delete self.queryCondition.balanceTo;
      }
    }
    Step(self.queryCondition).success(function(data) {
      self.totalBalance = data.totalBalance;
      self.items = data.objListContainerVO.rows;
      if (1 == self.items.length) {
        self.initDebtObject.client = {
          val : self.items[0].id,
          text : self.items[0].clientName
        };
      }
      /** @type {boolean} */
      self.loadMoreBtn = data.objListContainerVO.page < data.objListContainerVO.total;
    }).finally(function() {
      parent.scrollTop("clientDebtCtrlScroll");
      /** @type {boolean} */
      self.isLoading = false;
      poster.hide();
    });
    self.getClientSituation();
  };
  var throttledUpdate = ionic.debounce(self.getList, 500);
  /**
   * @return {undefined}
   */
  self.getListByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    self.queryCondition.cellphone = self.queryCondition.clientName;
    self.queryCondition.clientNamePy = self.queryCondition.clientName;
    if (!self.queryCondition.balanceFrom) {
      if (!(0 === self.queryCondition.balanceFrom)) {
        delete self.queryCondition.balanceFrom;
      }
    }
    if (!self.queryCondition.balanceTo) {
      if (!(0 === self.queryCondition.balanceTo)) {
        delete self.queryCondition.balanceTo;
      }
    }
    Step(self.queryCondition).success(function(response) {
      self.items = self.items.concat(response.objListContainerVO.rows);
      /** @type {boolean} */
      self.loadMoreBtn = response.objListContainerVO.page < response.objListContainerVO.total;
    }).finally(function() {
      parent.resize("clientDebtCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.doRefresh = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    self.queryCondition.cellphone = self.queryCondition.clientName;
    self.queryCondition.clientNamePy = self.queryCondition.clientName;
    Step(self.queryCondition).success(function(data) {
      self.totalBalance = data.totalBalance;
      self.items = data.objListContainerVO.rows;
      self.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      self.loadMoreBtn = data.objListContainerVO.page < data.objListContainerVO.total;
    });
    self.getClientSituation();
  };
  /**
   * @param {?} qualifier
   * @return {?}
   */
  self.isNum = function(qualifier) {
    /** @type {RegExp} */
    var isSimple = /^-?\d+(\.\d+)?$/;
    return isSimple.test(qualifier);
  };
  /**
   * @return {?}
   */
  self.updateClientDebt = function() {
    if (!(self.initDebtObject.client && self.initDebtObject.client.val > 0)) {
      return UnitTools.toastShow("请选择客户"), false;
    }
    if (!self.isNum(self.initDebtObject.initDebtAmount)) {
      return UnitTools.toastShow("请输入正确的期初欠款金额"), false;
    }
    if (self.initDebtObject.initDebtTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date(self.initDebtObject.initDebtTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      self.initDebtObject.initDebtTime = midnight.getTime();
    }
    request.postEncode("/KEY319", {
      clientId : self.initDebtObject.client.val,
      initDebtAmount : angular.toJson(self.fixedInputNumber(self.initDebtObject.initDebtAmount)),
      initDebtTime : UnitTools.dateFormat(new Date(self.initDebtObject.initDebtTime), "yyyy-MM-dd hh:mm:ss.S"),
      initDebtRemark : self.initDebtObject.initDebtRemark ? self.initDebtObject.initDebtRemark : ""
    }).success(function(result) {
      if (1 == result.statusCode) {
        UnitTools.toastShow("期初欠款修改成功");
        self.getList();
      } else {
        UnitTools.toastShow(result.content);
        run(self.initDebtObject.client.val);
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.getAllClientTypeItems = function() {
    request.httpCacheGet.get(request.httpCacheGet.ac.ALLCLIENTITEMS).success(function(theTitle) {
      self.clientTypeItems = theTitle;
    });
  };
  /**
   * @return {undefined}
   */
  self.getClientSituation = function() {
    request.postEncode("/KEY026", self.queryCondition).success(function(theTitle) {
      self.clientSituation = theTitle;
    });
  };
  /**
   * @param {Function} orig
   * @return {undefined}
   */
  self.selectClientItem = function(orig) {
    /** @type {Function} */
    self.clienTypeItem = orig;
    self.queryCondition.clientItem = orig.id;
  };
  self.$on("$ionicView.afterEnter", function() {
    if (1 == $templateCache.get("clientDebtListRefresh")) {
      self.getList();
      $templateCache.put("clientDebtListRefresh", false);
    }
  });
  self.$on("$ionicView.loaded", function() {
    self.getAllClientTypeItems();
    self.getList();
  });
}]).controller("ClientDebtDetailCtrl", ["$scope", "$state", "lbSpinnerDialog", "psisServices", "$ionicModal", "$ionicPopover", "pageDetail", "$stateParams", "Tools", "$q", "lruPersistCache", "$cordovaDatePicker", "$ionicPopup", "wechatShare", "OrderType", "BluetoothPrintService", "ServerConfig", "BusinessConstant", "commonDataInterface", function($scope, $state, loading, that, $modal, FB, angular, data, UnitTools, $q, $templateCache,
scope, view, dataAndEvents, deepDataAndEvents, jsPDFAPI, obj, ignoreMethodDoesntExist, res) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var getPromise3 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @return {?}
   */
  function update() {
    if (0 == $scope.fixedInputNumber($scope.record.receiptAmount) && 0 == $scope.fixedInputNumber($scope.record.discountAmount)) {
      /** @type {string} */
      var isDeposit = "本次收款和优惠金额不能同时为0";
      return $scope.isDeposit && (isDeposit = "充值和赠送金额不能同时为0"), view.alert({
        template : "<div class='tc'>" + isDeposit + "</div>",
        okText : "确定"
      }), false;
    }
    if (!(0 == $scope.fixedInputNumber($scope.record.realAmount) || $scope.record.KEY293 && ($scope.record.KEY293.id && ($scope.record.accountItem && $scope.record.accountItem.id)))) {
      return view.alert({
        template : "<div class='tc'>请选择账户和账目类型！</div>",
        okText : "确定"
      }), false;
    }
    if ($scope.record.clientBanlance - $scope.record.receiptAmount > 9.999999999E7 || $scope.record.clientBanlance - $scope.record.receiptAmount < -9.999999999E7) {
      return view.alert({
        template : "<div class='tc'>输入金额超出限制</div>",
        okText : "确定"
      }), false;
    }
    if ($scope.isDeposit && ($scope.record.accountItem.id = 6), $scope.record.createTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date($scope.record.createTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      $scope.record.createTime = midnight.getTime();
    }
    loading.show();
    that.post("/KEY013", {
      oppositeSideId : $scope.record.client.val,
      realAmount : $scope.payOrCharge ? -$scope.getValidNum($scope.record.receiptAmount) : $scope.getValidNum($scope.record.receiptAmount),
      discountAmount : $scope.getValidNum($scope.record.discountAmount),
      accountId : $scope.record.KEY293.id,
      businessItem : $scope.record.accountItem.id,
      createTime : $scope.record.createTime,
      remark : $scope.record.remark
    }).success(function(res) {
      if (1 == res.statusCode) {
        UnitTools.toastShow($scope.isDeposit ? "充值成功！" : "成功收了一笔！");
        $scope.record.clientBanlance = null == res.object.banlance ? 0 : res.object.banlance;
        /** @type {boolean} */
        $scope.isDeposit = false;
        /** @type {string} */
        $scope.receiptContent = $scope.isDeposit ? "充值" : "收款";
        /** @type {string} */
        $scope.balanceContent = $scope.record.clientBanlance < 0 || 0 == $scope.record.clientBanlance && ($scope.getAppAccResource(5) && $scope.customerPointOn) ? "当前余额：" : "总欠款：";
        jsPDFAPI.autoPrint($scope.mainCompany.comName, res.object.businessSn, jsPDFAPI.orderType.receiptOrder);
        /** @type {number} */
        $scope.record.receiptAmount = 0;
        /** @type {string} */
        $scope.record.discountAmount = "";
        /** @type {string} */
        $scope.record.remark = "";
        $templateCache.put("clientDebtListRefresh", true);
        $templateCache.put("refreshClientList", true);
        if ($scope.depositModal && $scope.depositModal.isShown()) {
          $scope.depositModal.hide();
        } else {
          $scope.clientReceiptEditModal.hide();
        }
      } else {
        UnitTools.toastShow(res.content);
      }
    }).finally(function() {
      $scope.getList();
      loading.hide();
    });
  }
  $scope.clientName = data.clientName;
  /** @type {Date} */
  var expected = new Date;
  var createTimeBegin = (new Date).setMonth(expected.getMonth() - 1);
  $scope.recordCondition = {
    createTimeBegin : createTimeBegin,
    createTimeEnd : expected.getTime(),
    oppositeSideId : data.oppositeSideId,
    showDebtOrders : "",
    sidx : "createTime",
    sord : "desc"
  };
  $scope.KEY265 = {};
  $scope.KEY265.accountItem = UnitTools.fnCheckGtoreQty(obj.userConfigData, "configKey", "KEY265.accountItem");
  if ($scope.KEY265.accountItem) {
    if ($scope.KEY265.accountItem.configValue) {
      /** @type {*} */
      $scope.KEY265.accountItemValue = JSON.parse($scope.KEY265.accountItem.configValue);
    }
  }
  $scope.record = {
    client : {
      text : $scope.clientName,
      val : data.oppositeSideId
    },
    clientBanlance : data.clientBanlance
  };
  /** @type {boolean} */
  $scope.customerPointOn = obj.companyConfigData.customerPoint ? obj.companyConfigData.customerPoint == ignoreMethodDoesntExist.CUSTOMERPOINT.ON : false;
  $scope.record.clientBanlance = null == $scope.record.clientBanlance ? 0 : $scope.record.clientBanlance;
  /** @type {boolean} */
  $scope.isDeposit = false;
  /** @type {string} */
  $scope.receiptContent = $scope.isDeposit ? "充值" : "收款";
  /** @type {string} */
  $scope.balanceContent = $scope.record.clientBanlance < 0 || 0 == $scope.record.clientBanlance && ($scope.getAppAccResource(5) && $scope.customerPointOn) ? "当前余额：" : "总欠款：";
  $modal.fromTemplateUrl("clientAccRecordFilter.html", function($location) {
    $scope.clientAccRecordModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY121.html", function($location) {
    $scope.clientReceiptEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up",
    focusFirstInput : false
  });
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY190 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY119 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  $scope.$on("$destroy", function() {
    $scope.clientReceiptEditModal.remove();
    $scope.KEY190.remove();
    $scope.KEY119.remove();
    $scope.clientDeptOperationPopover.remove();
    if ($scope.depositModal) {
      $scope.depositModal.remove();
    }
  });
  /**
   * @param {string} slide
   * @return {?}
   */
  $scope.getOrderType = function(slide) {
    return angular.getOrderType(slide);
  };
  /**
   * @param {Element} res
   * @return {?}
   */
  $scope.getOrderTypeCss = function(res) {
    return res ? res.businessSn && res.businessSn.indexOf("SK") > -1 ? "lb-color-box-4" : res.needAmount - res.realAmount == 0 ? "lb-color-box-userDefined" : "lb-color-box-5" : void 0;
  };
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  $scope.getPayType = function(dataAndEvents) {
    return "cash" == dataAndEvents ? "[现金收款]" : "alipayBarPay" == dataAndEvents ? "[支付宝收款]" : "wxpayScanPay" == dataAndEvents ? "[微信收款]" : "wxpayPub" == dataAndEvents ? "[微信在线收款]" : null;
  };
  FB.fromTemplateUrl("clientDebtOperation.html", {
    scope : $scope
  }).then(function($location) {
    $scope.clientDeptOperationPopover = $location;
  });
  /**
   * @return {undefined}
   */
  $scope.share = function() {
    dataAndEvents.shareClientDebtUrl($scope.recordCondition.createTimeBegin, $scope.recordCondition.createTimeEnd, $scope.record.client.val, deepDataAndEvents.clientDebtBilling);
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTime = function() {
    scope.show({
      date : new Date($scope.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.record.createTime = date1.getTime();
      }
    });
  };
  $scope.$watch("[record.accountItem]", function(results, f) {
    if (results[0] && (f[0] && (results[0].id != f[0].id && (f[0].id > 0 && 6 != results[0].id)))) {
      var msg = {
        val : $scope.record.accountItem.id,
        id : $scope.record.accountItem.id,
        text : $scope.record.accountItem.name,
        name : $scope.record.accountItem.name
      };
      res.saveOrUpdateUserConfig("KEY265.accountItem", JSON.stringify(msg), 3).then(function(node) {
        $scope.KEY265.accountItem = UnitTools.fnCheckGtoreQty(obj.userConfigData, "configKey", "KEY265.accountItem");
        if ($scope.KEY265.accountItem) {
          UnitTools.union($scope.KEY265.accountItem, node.object);
        } else {
          obj.userConfigData.push(node.object);
        }
        /** @type {*} */
        $scope.KEY265.accountItemValue = JSON.parse(node.object.configValue);
      }, function() {
        UnitTools.toastShow("服务器获取数据出现异常！");
      });
    }
  }, true);
  /**
   * @return {undefined}
   */
  $scope.KEY121 = function() {
    loading.show();
    if ($scope.isDeposit) {
      if ($scope.depositModal) {
        $scope.depositModal.show();
      } else {
        $modal.fromTemplateUrl("html/PClientBaseInfo/KEY043.html", function($location) {
          $scope.depositModal = $location;
          $scope.depositModal.show();
        }, {
          scope : $scope,
          animation : "slide-in-up",
          focusFirstInput : true
        });
      }
    } else {
      $scope.clientReceiptEditModal.show();
    }
    /** @type {number} */
    $scope.record.createTime = (new Date).getTime();
    if ($scope.isGetAcountInfoData) {
      loading.hide();
    } else {
      fetch().then(function(packs) {
        $scope.allAccounts = packs[0].data.rows;
        $scope.record.KEY293 = $scope.allAccounts[0];
        $scope.allAccountItems = packs[1].data.rows;
        /** @type {number} */
        var i = 0;
        for (;i < $scope.allAccountItems.length;i++) {
          if (0 == $scope.allAccountItems[i].isEnable || (1 == $scope.allAccountItems[i].id || (10 == $scope.allAccountItems[i].id || 5 == $scope.allAccountItems[i].id))) {
            $scope.allAccountItems.splice(i, 1);
            i--;
          }
        }
        if ($scope.record.accountItem = $scope.allAccountItems[0], $scope.KEY265.accountItemValue) {
          /** @type {number} */
          i = 0;
          var l = $scope.allAccountItems.length;
          for (;l > i;i++) {
            if ($scope.KEY265.accountItemValue.id == $scope.allAccountItems[i].id) {
              $scope.record.accountItem = $scope.allAccountItems[i];
              break;
            }
          }
        }
        loading.hide();
      });
      /** @type {boolean} */
      $scope.isGetAcountInfoData = true;
    }
  };
  /**
   * @param {?} v
   * @return {?}
   */
  $scope.fixedInputNumber = function(v) {
    /** @type {RegExp} */
    return UnitTools.getValidNum(v);
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  $scope.getValidNum = function(deepDataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents);
  };
  /**
   * @return {undefined}
   */
  $scope.changeCharge = function() {
    /** @type {string} */
    var errorMessage = "确认更改收款/退款";
    /** @type {string} */
    errorMessage = 1 == $scope.payOrCharge ? "切换后填写的金额为【本次收款】" : "切换后填写的金额为【本次退款】";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showConfirm(errorMessage, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          $scope.$apply(function() {
            /** @type {number} */
            $scope.payOrCharge = 1 == $scope.payOrCharge ? 0 : 1;
          });
        }
      }, "收款/退款切换", ["取消", "切换"]);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : "<div>" + errorMessage + "</div>",
        title : "收款/退款切换",
        scope : $scope,
        buttons : [{
          text : "确认",
          /**
           * @return {undefined}
           */
          onTap : function() {
            /** @type {number} */
            $scope.payOrCharge = 1 == $scope.payOrCharge ? 0 : 1;
          }
        }, {
          text : "取消",
          type : "button-assertive"
        }]
      });
    }
  };
  /**
   * @param {boolean} actualObject
   * @return {undefined}
   */
  $scope.setRechargeAmount = function(actualObject) {
    /** @type {boolean} */
    var object = actualObject;
    /** @type {string} */
    var x = $scope.record.clientBanlance ? $scope.record.clientBanlance < 0 ? "当前客户余额 " + Math.abs($scope.record.clientBanlance) : "当前客户欠款 " + $scope.record.clientBanlance.toFixed(2) : "当前客户欠款 0.00";
    /** @type {string} */
    var fd = $scope.payOrCharge ? "请输入本次退款金额" : "请输入本次收款金额";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            $scope.record.receiptAmount = res.input1 >= 0 ? $scope.getValidNum(res.input1) : object;
          });
        }
      }, fd, ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="record.receiptAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.record.receiptAmount = $scope.getValidNum($scope.record.receiptAmount);
          }
        }]
      });
    }
  };
  /**
   * @param {?} actualObject
   * @return {undefined}
   */
  $scope.setDiscountAmount = function(actualObject) {
    var object = actualObject;
    /** @type {string} */
    var x = $scope.isDeposit ? "请输入本次充值赠送金额" : "请输入本次收款优惠金额";
    /** @type {string} */
    var fd = $scope.isDeposit ? "赠送金额" : "优惠金额";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            $scope.record.discountAmount = res.input1 >= 0 ? $scope.getValidNum(res.input1) : object;
          });
        }
      }, fd, ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="record.discountAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.record.discountAmount = $scope.getValidNum($scope.record.discountAmount);
          }
        }]
      });
    }
  };
  var throttledUpdate = ionic.debounce(update, 500, true);
  /**
   * @return {undefined}
   */
  $scope.confirmReceiptAction = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show();
    that.post("/KEY027", {
      oppositeSideId : $scope.recordCondition.oppositeSideId,
      businessSn : $scope.recordCondition.businessSn,
      showDebtOrders : $scope.recordCondition.showDebtOrders,
      createTimeBegin : UnitTools.getDayBegin($scope.recordCondition.createTimeBegin),
      createTimeEnd : UnitTools.getOffsetDayBegin($scope.recordCondition.createTimeEnd, 1),
      sidx : "createTime",
      sord : "desc"
    }).success(function(response) {
      $scope.items = response.rows;
      var data = {
        needAmount : 0,
        realAmount : 0
      };
      /** @type {number} */
      var i = 0;
      var l = response.rows.length;
      for (;l > i;i++) {
        var stat = response.rows[i];
        data.needAmount = UnitTools.accAdd(data.needAmount, stat.needAmount);
        data.realAmount = UnitTools.accAdd(data.realAmount, stat.realAmount);
      }
      $scope.getTotal = data;
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {?} res
   * @return {?}
   */
  $scope.filterItem = function(res) {
    return $scope.recordCondition.showDebtOrders ? 0 == $scope.orderType ? res && (res.businessSn && res.businessSn.indexOf("SK") < 0) : 1 == $scope.orderType ? res && (res.businessSn && res.businessSn.indexOf("SK") > -1) : false : true;
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function(dataAndEvents) {
    scope.show({
      date : new Date($scope.recordCondition.createTimeBegin),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.createTimeBegin = date1.getTime();
        if (dataAndEvents) {
          $scope.getList();
        }
      }
    });
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function(dataAndEvents) {
    scope.show({
      date : new Date($scope.recordCondition.createTimeEnd),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.createTimeEnd = date1.getTime();
        if (dataAndEvents) {
          $scope.getList();
        }
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.clearFilter = function() {
    $scope.recordCondition.createTimeBegin = createTimeBegin;
    /** @type {number} */
    $scope.recordCondition.createTimeEnd = expected.getTime();
    /** @type {string} */
    $scope.recordCondition.businessSn = "";
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
  });
  /**
   * @param {?} data
   * @return {?}
   */
  $scope.getFinanceRecordDetail = function(data) {
    return data.businessSn.indexOf("SK") >= 0 && 1 == data.businessItem ? false : "alipayBarPay" == data.payType || "wxpayScanPay" == data.payType ? (UnitTools.toastShow("暂不支持修改扫码收款的交易"), console.log("暂不支持修改扫码收款的交易"), false) : "wxpayPub" == data.payType ? (UnitTools.toastShow("暂不支持修改微信在线收款的交易"),
    console.log("暂不支持修改微信在线收款的交易"), false) : void(data.businessSn && (data.businessSn.indexOf("FK") >= 0 || (data.businessSn.indexOf("SK") >= 0 || data.businessSn.indexOf("JZ") >= 0)) ? (data.fromState = "KEY151", $state.go("eventmenu.KEY084", {
      item : data
    })) : $scope.gotoDetail(data.businessItem, data.businessSn));
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshClientRecord")) {
      $scope.getList();
      that.post("/KEY041?clientId=" + data.oppositeSideId).success(function(dataAndEvents) {
        if (dataAndEvents.banlance) {
          $scope.record.clientBanlance = dataAndEvents.banlance;
          /** @type {boolean} */
          $scope.isDeposit = false;
          /** @type {string} */
          $scope.receiptContent = $scope.isDeposit ? "充值" : "收款";
          /** @type {string} */
          $scope.balanceContent = $scope.record.clientBanlance < 0 || 0 == $scope.record.clientBanlance && ($scope.getAppAccResource(5) && $scope.customerPointOn) ? "当前余额" : "总欠款";
        } else {
          /** @type {number} */
          $scope.record.clientBanlance = 0;
        }
      });
      $templateCache.put("refreshClientRecord", false);
    }
  });
  $scope.gotoDetail = angular.gotoDetail;
}]).controller("ClientSettingCtrl", ["$scope", "$state", "lbSpinnerDialog", "psisServices", "$ionicModal", "Tools", "$ionicPopup", "lbScrollDelegate", function($scope, dataAndEvents, loading, $http, deepDataAndEvents, UnitTools, view, $ionicScrollDelegate) {
  $scope.tempClientItemPoints = {};
  /** @type {Array} */
  $scope.clientItemPointsArr = [];
  $scope.setting = {
    calcAllPoints : false
  };
  /**
   * @param {number} n
   * @param {boolean} c
   * @return {?}
   */
  $scope.fixedNumber = function(n, c) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{2})[0-9]*/;
    return n ? (0 > n && (n = -n), parseInt(("" + parseFloat(n)).replace(r20, "$1"))) : c || "" == c ? "" : 0;
  };
  $scope.$watch("[setting.calcAllPoints]", function(dataAndEvents, deepDataAndEvents) {
    if (0 == deepDataAndEvents[0]) {
      if (1 == dataAndEvents[0]) {
        if (window.cordova && window.cordova.plugins) {
          UnitTools.showConfirm("计算积分会根据当前换算规则与客户累计消费金额计算出各客户的积分", function(result) {
            if (2 == result.buttonIndex) {
              $scope.$apply(function() {
                /** @type {boolean} */
                $scope.setting.calcAllPoints = false;
              });
            }
          }, "提示", ["确认", "取消"]);
        } else {
          view.show({
            cssClass : "lb-KEY291-popup",
            template : "<div>计算积分会根据当前换算规则与客户累计消费金额计算出各客户的积分</div>",
            title : "提示",
            scope : $scope,
            buttons : [{
              text : "确认"
            }, {
              text : "取消",
              type : "button-assertive",
              /**
               * @return {undefined}
               */
              onTap : function() {
                /** @type {boolean} */
                $scope.setting.calcAllPoints = false;
              }
            }]
          });
        }
      }
    }
  }, true);
  /**
   * @param {?} v
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  $scope.fixedInputNumber = function(v, dataAndEvents) {
    /** @type {RegExp} */
    return UnitTools.getValidNum(v, dataAndEvents);
  };
  /**
   * @return {undefined}
   */
  $scope.addClientItemPoints = function() {
    $scope.clientItemPointsArr.push({});
    $ionicScrollDelegate.scrollBottom("ClientPointsSettingCtrlScroll");
  };
  /**
   * @param {?} r2
   * @return {?}
   */
  $scope.deleteClientItemPoints = function(r2) {
    return 1 == $scope.clientItemPointsArr.length ? (view.alert({
      template : "<div class='tc'>至少需要设置一个积分区间！</div>",
      okText : "确定"
    }), false) : ($scope.clientItemPointsArr.splice(r2, 1), void $ionicScrollDelegate.scrollBottom("ClientPointsSettingCtrlScroll"));
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  $scope.getCustomerPointRate = function(dataAndEvents) {
    $http.post("/KEY339").success(function(res) {
      if (1 == res.statusCode && ($scope.consumePointRate = res.object.consumePointRate ? res.object.consumePointRate : {}, $scope.clientItemPoints = res.object.clientItemPoints, !dataAndEvents)) {
        /** @type {number} */
        var i = 0;
        for (;i < $scope.clientItemPoints.length;i++) {
          if (null != $scope.clientItemPoints[i].minPoint) {
            var value = {};
            UnitTools.union(value, $scope.clientItemPoints[i]);
            $scope.clientItemPointsArr.push(value);
          }
        }
        if (0 == $scope.clientItemPoints.length) {
          $scope.clientItemPointsArr.push({});
        }
      }
    });
  };
  /**
   * @return {?}
   */
  $scope.saveCustomerPointRate = function() {
    if (loading.show(true), !$scope.consumePointRate.consumeAmount || !$scope.consumePointRate.pointIncome) {
      return view.alert({
        template : "<div class='tc'>请完善消费积分规则！</div>",
        okText : "确定"
      }), loading.hide(), false;
    }
    if (!/^[0-9]+$/.test($scope.consumePointRate.consumeAmount)) {
      return view.alert({
        template : "<div class='tc'>客户每消费数值必须为正整数！</div>",
        okText : "确定"
      }), loading.hide(), false;
    }
    if (!/^[0-9]+$/.test($scope.consumePointRate.pointIncome)) {
      return view.alert({
        template : "<div class='tc'>获得积分必须为正整数！</div>",
        okText : "确定"
      }), loading.hide(), false;
    }
    var paramSet = {};
    /** @type {number} */
    var i = 0;
    for (;i < $scope.clientItemPointsArr.length;i++) {
      var param = $scope.clientItemPointsArr[i];
      if (param.minPoint) {
        if (paramSet[param.minPoint]) {
          return view.alert({
            template : "<div class='tc'>请检查积分的起始值，保证起始值没有重复！</div>",
            okText : "确定"
          }), loading.hide(), false;
        }
        /** @type {boolean} */
        paramSet[param.minPoint] = true;
      }
    }
    $http.postEncode("/KEY332", {
      consumePointRate : angular.toJson($scope.consumePointRate),
      calcAllPoints : $scope.setting.calcAllPoints,
      clientItemPoints : angular.toJson($scope.clientItemPointsArr)
    }).success(function(res) {
      if (1 == res.statusCode) {
        UnitTools.toastShow("保存成功");
        $scope.consumePointRate = res.object.consumePointRate;
        $scope.clientItemPoints = res.object.clientItemPoints;
        /** @type {Array} */
        $scope.clientItemPointsArr = [];
        /** @type {number} */
        var i = 0;
        for (;i < $scope.clientItemPoints.length;i++) {
          if (null != $scope.clientItemPoints[i].minPoint) {
            var value = {};
            UnitTools.union(value, $scope.clientItemPoints[i]);
            $scope.clientItemPointsArr.push(value);
          }
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  $scope.initCustomerPoint = function() {
    var promise = view.confirm({
      template : "<div class='tc'>计算积分时，将根据客户当前累计的消费金额和当前换算关系设置积分，并更新客户的分类和折扣。确定要为所有客户初始化积分吗？</div>",
      cancelText : "取消",
      okText : "确定"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        $http.post("/KEY371").success(function(file) {
          UnitTools.toastShow(file.content);
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getCustomerPointRate();
  });
}]).controller("ClientScoreRecordCtrl", ["$scope", "$timeout", "$state", "psisServices", "lbScrollDelegate", "$ionicModal", "Tools", "lruPersistCache", "$cordovaBarcodeScanner", "$ionicPopover", "$ionicActionSheet", "lbSpinnerDialog", "$q", "pageDetail", "$cordovaDatePicker", "$stateParams", function(self, deepDataAndEvents, ignoreMethodDoesntExist, newCanvas, parent, $modal, dataAndEvents, $templateCache, textAlt, FB, keepData, loading, opt_attributes, message, $scope,
data) {
  self.client = {
    id : data.clientId
  };
  /** @type {boolean} */
  self.isLoading = true;
  /** @type {Array} */
  self.items = [];
  self.queryCondition = {
    sord : "desc",
    sidx : "createTime"
  };
  self.clientInfo = {
    typeName : {}
  };
  /** @type {Array} */
  self.typeNames = [{
    text : "初始化客户积分",
    val : 0
  }, {
    text : "销售单",
    val : 1
  }, {
    text : "销售退货单",
    val : 2
  }, {
    text : "客户管理中修改积分",
    val : 3
  }];
  $modal.fromTemplateUrl("clientScoreFilter.html", function(theTitle) {
    self.clientScoreFilterModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("typeNamePopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.typeNamePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openTypeNamePopover = function(expectedNumberOfNonCommentArgs) {
    self.typeNamePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideTypeNamePopover = function() {
    self.typeNamePopover.hide();
  };
  self.$on("$destroy", function() {
    self.clientScoreFilterModal.remove();
    self.typeNamePopover.remove();
  });
  /**
   * @return {undefined}
   */
  self.setCreateTimeBegin = function() {
    $scope.show({
      date : self.clientInfo.createTimeBegin ? new Date(self.clientInfo.createTimeBegin) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.clientInfo.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeEnd = function() {
    $scope.show({
      date : self.clientInfo.createTimeEnd ? new Date(self.clientInfo.createTimeEnd) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.clientInfo.createTimeEnd = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  var Text = function() {
    self.queryCondition.clientId = self.client.id;
    if (self.clientInfo.typeName && null != self.clientInfo.typeName.val) {
      self.queryCondition.businessType = self.clientInfo.typeName.val;
    } else {
      delete self.queryCondition.businessType;
    }
    if (self.clientInfo.createTimeBegin) {
      self.queryCondition.createTimeBegin = dataAndEvents.getDayBeginStr(self.clientInfo.createTimeBegin);
    } else {
      delete self.queryCondition.createTimeBegin;
    }
    if (self.clientInfo.createTimeEnd) {
      self.queryCondition.createTimeEnd = dataAndEvents.getOffsetDayBeginStr(self.clientInfo.createTimeEnd, 1);
    } else {
      delete self.queryCondition.createTimeEnd;
    }
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var Step = function(opt_attributes) {
    return newCanvas.postEncode("/KEY318", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    loading.show();
    Text();
    /** @type {number} */
    self.queryCondition.page = 1;
    Step(self.queryCondition).success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
      parent.scrollTop("clientScoreRecordCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step(self.queryCondition).success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("clientScoreRecordCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.doRefresh = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    Step(self.queryCondition).success(function(data) {
      self.totalBalance = data.totalBalance;
      self.items = data.rows;
      self.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    self.clientInfo = {
      typeName : {}
    };
    /** @type {string} */
    self.queryCondition.businessSn = "";
  };
  /**
   * @param {?} store
   * @return {undefined}
   */
  self.goDetail = function(store) {
    if (store.businessSn) {
      self.gotoDetail(null, store.businessSn);
    }
  };
  self.$on("$ionicView.afterEnter", function() {
    if (1 == $templateCache.get("refreshClientRecord")) {
      self.getList();
      $templateCache.put("refreshClientRecord", false);
    }
  });
  self.getList();
  self.gotoDetail = message.gotoDetail;
}]).controller("ClientDepositRecordCtrl", ["$scope", "$state", "lbSpinnerDialog", "psisServices", "$ionicModal", "$ionicPopover", "pageDetail", "$stateParams", "Tools", "$q", "lruPersistCache", "$cordovaDatePicker", "$ionicPopup", "wechatShare", "OrderType", "BluetoothPrintService", "ServerConfig", "BusinessConstant", "lbScrollDelegate", function($scope, $state, loading, that, $modal, FB, $routeParams, data, UnitTools, $q, $templateCache,
scope, view, ignoreMethodDoesntExist, textAlt, jsPDFAPI, dataAndEvents, deepDataAndEvents, parent) {
  /**
   * @return {?}
   */
  function update() {
    if (0 == $scope.fixedInputNumber($scope.record.receiptAmount) && 0 == $scope.fixedInputNumber($scope.record.discountAmount)) {
      return view.alert({
        template : "<div class='tc'>充值和赠送金额不能同时为0</div>",
        okText : "确定"
      }), false;
    }
    if (!(0 == $scope.fixedInputNumber($scope.record.realAmount) || $scope.record.KEY293 && ($scope.record.KEY293.id && ($scope.record.accountItem && $scope.record.accountItem.id)))) {
      return view.alert({
        template : "<div class='tc'>请选择账户和账目类型！</div>",
        okText : "确定"
      }), false;
    }
    if ($scope.record.clientBanlance - $scope.record.receiptAmount > 9.999999999E7 || $scope.record.clientBanlance - $scope.record.receiptAmount < -9.999999999E7) {
      return view.alert({
        template : "<div class='tc'>输入金额超出限制</div>",
        okText : "确定"
      }), false;
    }
    if ($scope.isDeposit && ($scope.record.accountItem.id = 6), $scope.record.createTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date($scope.record.createTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      $scope.record.createTime = midnight.getTime();
    }
    loading.show();
    that.post("/KEY013", {
      oppositeSideId : $scope.record.client.val,
      realAmount : $scope.fixedInputNumber($scope.record.receiptAmount),
      discountAmount : $scope.getValidNum($scope.record.discountAmount),
      accountId : $scope.record.KEY293.id,
      businessItem : $scope.record.accountItem.id,
      createTime : $scope.record.createTime,
      remark : $scope.record.remark
    }).success(function(res) {
      if (1 == res.statusCode) {
        UnitTools.toastShow($scope.isDeposit ? "充值成功！" : "成功收了一笔！");
        $scope.record.clientBanlance = null == res.object.banlance ? 0 : res.object.banlance;
        /** @type {boolean} */
        $scope.isDeposit = true;
        /** @type {string} */
        $scope.receiptContent = $scope.isDeposit ? "充值" : "收款";
        /** @type {string} */
        $scope.balanceContent = $scope.record.clientBanlance < 0 || 0 == $scope.record.clientBanlance && ($scope.getAppAccResource(5) && $scope.customerPointOn) ? "当前余额：" : "总欠款：";
        jsPDFAPI.autoPrint($scope.mainCompany.comName, res.object.businessSn, jsPDFAPI.orderType.receiptOrder);
        /** @type {number} */
        $scope.record.receiptAmount = 0;
        /** @type {string} */
        $scope.record.discountAmount = "";
        /** @type {string} */
        $scope.record.remark = "";
        $templateCache.put("clientDebtListRefresh", true);
        $templateCache.put("refreshClientList", true);
        if ($scope.depositModal && $scope.depositModal.isShown()) {
          $scope.depositModal.hide();
        } else {
          $scope.clientReceiptEditModal.hide();
        }
      } else {
        UnitTools.toastShow(res.content);
      }
    }).finally(function() {
      $scope.getList();
      loading.hide();
    });
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var getPromise3 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  $scope.clientName = data.clientName;
  /** @type {Date} */
  var xdata = new Date;
  (new Date).setMonth(xdata.getMonth() - 1);
  $scope.recordCondition = {
    oppositeSideId : data.oppositeSideId
  };
  $scope.queryCondition = {
    sidx : "createTime",
    sord : "desc"
  };
  $scope.record = {
    client : {
      text : $scope.clientName,
      val : data.oppositeSideId
    },
    clientBanlance : data.clientBanlance
  };
  /** @type {boolean} */
  $scope.customerPointOn = dataAndEvents.companyConfigData.customerPoint ? dataAndEvents.companyConfigData.customerPoint == deepDataAndEvents.CUSTOMERPOINT.ON : false;
  $scope.record.clientBanlance = null == $scope.record.clientBanlance ? 0 : $scope.record.clientBanlance;
  /** @type {boolean} */
  $scope.isDeposit = true;
  /** @type {string} */
  $scope.receiptContent = $scope.isDeposit ? "充值" : "收款";
  /** @type {string} */
  $scope.balanceContent = $scope.record.clientBanlance < 0 || 0 == $scope.record.clientBanlance && ($scope.getAppAccResource(5) && $scope.customerPointOn) ? "当前余额：" : "总欠款：";
  $modal.fromTemplateUrl("clientAccRecordFilter.html", function($location) {
    $scope.clientAccRecordModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY121.html", function($location) {
    $scope.clientReceiptEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY190 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("accountPopover_condition.html", {
    scope : $scope
  }).then(function($location) {
    $scope.accountConditionPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountConditionPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.accountConditionPopover.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY119 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  $scope.$on("$destroy", function() {
    $scope.clientReceiptEditModal.remove();
    $scope.KEY190.remove();
    $scope.KEY119.remove();
    if ($scope.depositModal) {
      $scope.depositModal.remove();
    }
  });
  /**
   * @return {undefined}
   */
  $scope.setCreateTime = function() {
    scope.show({
      date : new Date($scope.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.record.createTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.KEY121 = function() {
    if ($scope.isDeposit) {
      if ($scope.depositModal) {
        $scope.depositModal.show();
      } else {
        $modal.fromTemplateUrl("html/PClientBaseInfo/KEY043.html", function($location) {
          $scope.depositModal = $location;
          $scope.depositModal.show();
        }, {
          scope : $scope,
          animation : "slide-in-up",
          focusFirstInput : false
        });
      }
    } else {
      $scope.clientReceiptEditModal.show();
    }
    /** @type {number} */
    $scope.record.createTime = (new Date).getTime();
  };
  /**
   * @param {?} v
   * @return {?}
   */
  $scope.fixedInputNumber = function(v) {
    /** @type {RegExp} */
     return UnitTools.getValidNum(v);
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  $scope.getValidNum = function(deepDataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents);
  };
  /**
   * @param {boolean} actualObject
   * @return {undefined}
   */
  $scope.setRechargeAmount = function(actualObject) {
    /** @type {boolean} */
    var object = actualObject;
    /** @type {string} */
    var i = $scope.isDeposit ? "当前客户余额 " : "当前客户欠款 ";
    /** @type {string} */
    var x = $scope.record.clientBanlance ? i + $scope.record.clientBanlance.toFixed(2) : i + "0.00";
    /** @type {string} */
    var fd = $scope.isDeposit ? "请输入本次充值的金额" : "请输入本次收款金额";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            $scope.record.receiptAmount = res.input1 >= 0 ? $scope.getValidNum(res.input1) : object;
          });
        }
      }, fd, ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="record.receiptAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.record.receiptAmount = $scope.getValidNum($scope.record.receiptAmount);
          }
        }]
      });
    }
  };
  /**
   * @param {?} actualObject
   * @return {undefined}
   */
  $scope.setDiscountAmount = function(actualObject) {
    var object = actualObject;
    /** @type {string} */
    var x = $scope.isDeposit ? "请输入本次充值赠送金额" : "请输入本次收款优惠金额";
    /** @type {string} */
    var fd = $scope.isDeposit ? "赠送金额" : "优惠金额";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            $scope.record.discountAmount = res.input1 >= 0 ? $scope.getValidNum(res.input1) : object;
          });
        }
      }, fd, ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="record.discountAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.record.discountAmount = $scope.getValidNum($scope.record.discountAmount);
          }
        }]
      });
    }
  };
  var throttledUpdate = ionic.debounce(update, 500, true);
  /**
   * @return {undefined}
   */
  $scope.confirmReceiptAction = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  var reset = function() {
    $scope.queryCondition.oppositeSideId = $scope.recordCondition.oppositeSideId;
    if ($scope.recordCondition.KEY293 && null != $scope.recordCondition.KEY293.id) {
      $scope.queryCondition.accountId = $scope.recordCondition.KEY293.id;
    } else {
      delete $scope.queryCondition.accountId;
    }
    if ($scope.recordCondition.createTimeBegin) {
      $scope.queryCondition.createTimeBegin = UnitTools.getDayBeginStr($scope.recordCondition.createTimeBegin);
    } else {
      delete $scope.queryCondition.createTimeBegin;
    }
    if ($scope.recordCondition.createTimeEnd) {
      $scope.queryCondition.createTimeEnd = UnitTools.getOffsetDayBeginStr($scope.recordCondition.createTimeEnd, 1);
    } else {
      delete $scope.queryCondition.createTimeEnd;
    }
  };
  /**
   * @param {?} attributes
   * @return {?}
   */
  var getItem = function(attributes) {
    return that.postEncode("/KEY305", attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show();
    reset();
    /** @type {number} */
    $scope.queryCondition.page = 1;
    getItem($scope.queryCondition).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.scrollTop("clientScoreRecordCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    getItem($scope.queryCondition).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("clientScoreRecordCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    $scope.queryCondition.page = 1;
    getItem($scope.queryCondition).success(function(data) {
      $scope.totalBalance = data.totalBalance;
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.clearQueryCondition = function() {
    $scope.recordCondition = {
      oppositeSideId : data.oppositeSideId
    };
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : new Date($scope.recordCondition.createTimeBegin),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : new Date($scope.recordCondition.createTimeEnd),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.createTimeEnd = date1.getTime();
      }
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
  });
  /**
   * @param {?} data
   * @return {?}
   */
  $scope.getFinanceRecordDetail = function(data) {
    return "alipayBarPay" == data.payType || "wxpayScanPay" == data.payType ? (UnitTools.toastShow("暂不支持修改扫码收款的交易"), console.log("暂不支持修改扫码收款的交易"), false) : void(data.businessSn && (data.businessSn.indexOf("SK") >= 0 && (6 == data.businessItem && ($state.go("eventmenu.KEY084", {
      item : data
    }), data.fromState = "KEY151"))));
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    fetch().then(function(packs) {
      $scope.allAccounts = packs[0].data.rows;
      $scope.record.KEY293 = $scope.allAccounts[0];
      $scope.allAccountItems = packs[1].data.rows;
      /** @type {number} */
      var i = 0;
      for (;i < $scope.allAccountItems.length;i++) {
        if (0 == $scope.allAccountItems[i].isEnable || (1 == $scope.allAccountItems[i].id || (10 == $scope.allAccountItems[i].id || 5 == $scope.allAccountItems[i].id))) {
          $scope.allAccountItems.splice(i, 1);
          i--;
        }
      }
      $scope.record.accountItem = $scope.allAccountItems[0];
    });
    if (1 == $templateCache.get("refreshClientRecord")) {
      $scope.getList();
      that.post("/KEY041?clientId=" + data.oppositeSideId).success(function(dataAndEvents) {
        if (dataAndEvents.banlance) {
          $scope.record.clientBanlance = dataAndEvents.banlance;
          /** @type {boolean} */
          $scope.isDeposit = true;
          /** @type {string} */
          $scope.receiptContent = $scope.isDeposit ? "充值" : "收款";
          /** @type {string} */
          $scope.balanceContent = $scope.record.clientBanlance < 0 || 0 == $scope.record.clientBanlance && ($scope.getAppAccResource(5) && $scope.customerPointOn) ? "当前余额" : "总欠款";
        } else {
          /** @type {number} */
          $scope.record.clientBanlance = 0;
        }
      });
      $templateCache.put("refreshClientRecord", false);
    }
  });
  $scope.gotoDetail = $routeParams.gotoDetail;
}]);
