angular.module("collectionController", ["ionic", "services", "tools"]).controller("CollectionCtrl", ["$scope", "$state", "Tools", "ServerConfig", "psisServices", "lbScrollDelegate", "lbSpinnerDialog", "$ionicModal", "$ionicPopover", "$cordovaDatePicker", "$cordovaBarcodeScanner", "$timeout", "lruPersistCache", "$ionicPopup", "$interval", function(self, deepDataAndEvents, UnitTools, context, assert, parent, loading, $modal, FB, $scope, dataAndEvents,
ignoreMethodDoesntExist, textAlt, view, result) {
  /** @type {string} */
  self.viewTitle = "公司代收";
  self.queryCondition = {
    page : 1,
    status : ""
  };
  self.cashConfig = {
    cashType : "alipay"
  };
  /** @type {Array} */
  self.cashTypeList = [{
    value : "alipay",
    title : "支付宝"
  }];
  /** @type {number} */
  self.cashMaxOnce = 5E4;
  self.validatePhone = {
    smsType : 1
  };
  /** @type {string} */
  self.getMessageText = "获取短信验证码";
  /** @type {boolean} */
  self.showSMSCodeValidate = false;
  /** @type {boolean} */
  self.disableMsgBtn = false;
  /** @type {number} */
  self.sesconds = 60;
  var val;
  /**
   * @param {?} event
   * @return {?}
   */
  self.getValidateSMS = function(event) {
    if (event.stopPropagation() && event.preventDefault(), !self.check()) {
      return false;
    }
    if (!self.cashConfig.verifyCode) {
      return UnitTools.toastShow("请输入图片验证码！"), false;
    }
    loading.show();
    var PART = {
      verifyCode : self.cashConfig.verifyCode
    };
    assert.postEncode("/KEY387", PART).success(function(r) {
      loading.hide();
      if (1 == r.statusCode) {
        /** @type {string} */
        self.getMessageText = "60秒后重新获取";
        /** @type {boolean} */
        self.showSMSCodeValidate = true;
        /** @type {boolean} */
        self.disableMsgBtn = true;
        val = result(function() {
          if (self.sesconds > 0) {
            self.sesconds--;
            /** @type {string} */
            self.getMessageText = self.sesconds + "秒后重新获取";
          } else {
            if (angular.isDefined(val)) {
              result.cancel(val);
              val = void 0;
            }
            /** @type {number} */
            self.sesconds = 60;
            /** @type {boolean} */
            self.disableMsgBtn = false;
            /** @type {string} */
            self.getMessageText = "获取短信验证码";
          }
        }, 1E3);
      } else {
        if (2 == r.statusCode) {
          self.refreshValidateCodeImg();
          /** @type {string} */
          self.getMessageText = "获取短信验证码";
          /** @type {boolean} */
          self.disableMsgBtn = false;
          UnitTools.toastShow(r.content);
        } else {
          if (3 == r.statusCode) {
            self.phoneErrTxt = r.content;
            if (window.cordova && window.cordova.plugins) {
              UnitTools.showAlert(self.phoneErrTxt, function() {
                /** @type {boolean} */
                self.disableMsgBtn = false;
              }, "出错了");
            } else {
              view.alert({
                template : "<div class='tc'>" + self.phoneErrTxt + "</div>",
                okText : "确定"
              }).then(function() {
                /** @type {boolean} */
                self.disableMsgBtn = false;
              });
            }
          }
        }
      }
    }).error(function() {
      loading.hide();
      /** @type {boolean} */
      self.disableMsgBtn = false;
    });
  };
  /**
   * @return {?}
   */
  self.validateInput = function() {
    return!self.cellphoneValidate() || self.disableMsgBtn;
  };
  /**
   * @return {?}
   */
  var init = function() {
    var data = {
      cashSn : self.queryCondition.cashSn,
      createTimeBegin : self.queryCondition.createTimeBegin,
      createTimeEnd : self.queryCondition.createTimeEnd,
      status : self.queryCondition.status
    };
    return data.cashSn || delete data.cashSn, data.createTimeBegin || delete data.createTimeBegin, data.createTimeEnd || delete data.createTimeEnd, data.status || delete data.status, self.getSumData(), assert.post("/KEY107?page=" + self.queryCondition.page, data);
  };
  /**
   * @return {?}
   */
  var send = function() {
    var data = {
      recordSn : self.queryCondition.recordSn,
      createTimeBegin : self.queryCondition.createTimeBegin,
      createTimeEnd : self.queryCondition.createTimeEnd,
      businessItem : self.queryCondition.businessItem
    };
    return data.recordSn || delete data.recordSn, data.createTimeBegin || delete data.createTimeBegin, data.createTimeEnd || delete data.createTimeEnd, data.businessItem || delete data.businessItem, assert.post("/KEY108?page=" + self.queryCondition.page, data);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    loading.show();
    init().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      loading.hide();
      parent.scrollTop("CollectionListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getFlowList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    loading.show(true);
    send().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      loading.hide();
      parent.scrollTop("CollectionListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    if (1 === self.queryCondition.state) {
      send().success(function(options) {
        self.items = self.items.concat(options.rows);
        /** @type {boolean} */
        self.loadMoreBtn = options.page < options.total;
      }).finally(function() {
        parent.resize("CollectionListCtrlScroll");
      });
    } else {
      init().success(function(options) {
        self.items = self.items.concat(options.rows);
        /** @type {boolean} */
        self.loadMoreBtn = options.page < options.total;
      }).finally(function() {
        parent.resize("CollectionListCtrlScroll");
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.getSearch = function() {
    if (1 === self.queryCondition.state) {
      self.getFlowList();
    } else {
      self.getList();
    }
  };
  /**
   * @return {undefined}
   */
  self.getSumData = function() {
    /** @type {boolean} */
    self.sumDataLoading = true;
    assert.post("/KEY250").success(function(res) {
      if (1 == res.statusCode) {
        if (res.object && res.object.proxyAccountVO) {
          self.totalIncome = null == res.object.proxyAccountVO.totalIncome ? 0 : res.object.proxyAccountVO.totalIncome.toFixed(2);
          self.totalCash = null == res.object.proxyAccountVO.totalCash ? 0 : res.object.proxyAccountVO.totalCash.toFixed(2);
          self.balance = null == res.object.proxyAccountVO.balance ? 0 : res.object.proxyAccountVO.balance.toFixed(2);
          self.collectionIsLock = res.object.proxyAccountVO.isLock;
        } else {
          /** @type {number} */
          self.totalIncome = 0;
          /** @type {number} */
          self.totalCash = 0;
          /** @type {number} */
          self.balance = 0;
          /** @type {number} */
          self.collectionIsLock = 0;
        }
      }
    }).finally(function() {
      /** @type {boolean} */
      self.sumDataLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    self.queryCondition = {
      page : 1,
      state : self.queryCondition.state
    };
  };
  $modal.fromTemplateUrl("collectionListQuery.html", function(theTitle) {
    self.collectionListQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("withdraw.html", function(theTitle) {
    /** @type {number} */
    self.withdrawModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("collectionStatus.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.collectionStatusPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStatusPopover = function(expectedNumberOfNonCommentArgs) {
    self.collectionStatusPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideStatusPopover = function() {
    self.collectionStatusPopover.hide();
  };
  FB.fromTemplateUrl("collectionBusinessItem.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.collectionBusinessItemPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openBusinessItemPopover = function(expectedNumberOfNonCommentArgs) {
    self.collectionBusinessItemPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideBusinessItemPopover = function() {
    self.collectionBusinessItemPopover.hide();
  };
  self.$on("$destroy", function() {
    self.collectionListQueryModal.remove();
    self.withdrawModal.remove();
    self.collectionStatusPopover.remove();
    self.collectionBusinessItemPopover.remove();
  });
  /**
   * @return {undefined}
   */
  self.setCreateTimeBegin = function() {
    $scope.show({
      date : self.queryCondition.createTimeBegin ? new Date(self.queryCondition.createTimeBegin) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.queryCondition.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeEnd = function() {
    $scope.show({
      date : self.queryCondition.createTimeEnd ? new Date(self.queryCondition.createTimeEnd) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.queryCondition.createTimeEnd = date1.getTime();
      }
    });
  };
  /**
   * @param {?} reason
   * @return {?}
   */
  self.getReason = function(reason) {
    var _reason;
    switch(reason) {
      case "new":
        /** @type {string} */
        _reason = "待审核";
        break;
      case "cashing":
        /** @type {string} */
        _reason = "银行处理中";
        break;
      case "done":
        /** @type {string} */
        _reason = "完成";
        break;
      case "failed":
        /** @type {string} */
        _reason = "失败";
        break;
      default:
        /** @type {string} */
        _reason = "未知";
    }
    return _reason;
  };
  /**
   * @param {?} escapedString
   * @return {?}
   */
  self.getReasonCss = function(escapedString) {
    var getReasonCss;
    switch(escapedString) {
      case "new":
        /** @type {string} */
        getReasonCss = "lb-ac-collection-type-progress";
        break;
      case "cashing":
        /** @type {string} */
        getReasonCss = "lb-ac-collection-type-progress";
        break;
      case "done":
        /** @type {string} */
        getReasonCss = "lb-ac-collection-type-done";
        break;
      case "failed":
        /** @type {string} */
        getReasonCss = "lb-ac-collection-type-failed";
        break;
      default:
        /** @type {string} */
        getReasonCss = "lb-ac-collection-type-progress";
    }
    return getReasonCss;
  };
  /**
   * @param {?} dataAndEvents
   * @return {?}
   */
  self.getFlowType = function(dataAndEvents) {
    var getFlowType;
    switch(dataAndEvents) {
      case 1:
        /** @type {string} */
        getFlowType = "货款到账";
        break;
      case 11:
        /** @type {string} */
        getFlowType = "提现";
        break;
      case 12:
        /** @type {string} */
        getFlowType = "提现失败退款";
        break;
      default:
        /** @type {string} */
        getFlowType = "其它";
    }
    return getFlowType;
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  self.fixedInputNumber = function(deepDataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents);
  };
  /**
   * @return {?}
   */
  self.getCashLimit = function() {
    var x = self.balance;
    return x > self.cashMaxOnce ? self.cashMaxOnce : parseFloat(x);
  };
  /**
   * @return {undefined}
   */
  self.refreshValidateCodeImg = function() {
    self.validateCodeImgUrl = self.getValidateCodeImgUrl();
  };
  /**
   * @return {?}
   */
  self.check = function() {
    return self.collectionIsLock ? (UnitTools.toastShow("账户已锁定，提现处理完成后才能再次提现！"), false) : self.balance <= 0 ? (UnitTools.toastShow("账号余额不足！"), false) : self.cashConfig.amount > self.getCashLimit() ? (UnitTools.toastShow("超过可提现的最大金额！"), false) : self.cashConfig.cashAccount ?
    self.cashConfig.cashName ? self.cashConfig.amount ? true : (UnitTools.toastShow("请输入提现金额！"), false) : (UnitTools.toastShow("请输入收款人姓名！"), false) : (UnitTools.toastShow("请输入收款账号！"), false);
  };
  /**
   * @param {?} event
   * @return {?}
   */
  self.withdraw = function(event) {
    return event.stopPropagation() && event.preventDefault(), self.collectionIsLock ? void UnitTools.toastShow("账户已锁定，提现处理完成后才能再次提现！") : self.balance <= 0 ? void UnitTools.toastShow("账号余额不足！") : (self.withdrawModal.show(), loading.show(), self.validateCodeImgUrl = self.getValidateCodeImgUrl(), void assert.post("/KEY399").success(function(res) {
      loading.hide();
      if (1 == res.statusCode) {
        self.validateCellphone = res.object.validateCellphone;
      } else {
        UnitTools.toastShow(res.content);
      }
    }).error(function() {
      loading.hide();
    }));
  };
  /**
   * @return {?}
   */
  self.doWithdraw = function() {
    return self.check() ? (loading.show(true), void assert.post("/KEY363", self.cashConfig).success(function(res) {
      loading.hide();
      if (1 == res.statusCode) {
        UnitTools.showAlert("提现申请提交成功,请耐心等待审核!", null);
        self.withdrawModal.hide();
        self.getList();
      } else {
        if (2 == res.statusCode) {
          UnitTools.toastShow(res.content);
          self.refreshValidateCodeImg();
          /** @type {string} */
          self.cashConfig.smsCode = "";
          /** @type {boolean} */
          self.verifySmsCodeError = true;
        } else {
          UnitTools.toastShow(res.content);
        }
      }
    }).error(function() {
      loading.hide();
    })) : false;
  };
  self.$on("$ionicView.loaded", function() {
    self.getList();
    if (context.currentServer === context.exServer) {
      /** @type {boolean} */
      self.isEx = true;
    }
  });
}]).controller("CashCtrl", ["$scope", "$ionicPopover", "$cordovaBarcodeScanner", "Tools", "$timeout", "psisServices", "$q", "ServerConfig", "lruPersistCache", "$ionicPopup", "$ionicModal", "$state", "lbSpinnerDialog", "$ionicActionSheet", "$ionicLoading", "commonDataInterface", "VaApplyItem", "BTScanerService", "BluetoothPrintService", function(self, FB, Hogan, $, done, result, $q, obj, ignoreMethodDoesntExist, _, $modal,
$state, loading, errors, indicator, dataAndEvents, deepDataAndEvents, $document, UnitBluetoothPrint) {
  /**
   * @param {string} method
   * @return {?}
   */
  function bind(method) {
    if ($.getValidNum(self.totalNumber) > self.scanPayObj.maxNumber) {
      return $.toastShow("超过最大收款金额"), void console.log("超过最大收款金额");
    }
    /** @type {string} */
    var written = "";
    written = "pointer" == method ? "" == self.totalNumberStr ? "0." : "." : "add" == method ? "" == self.totalNumberStr ? "" : "+" : method;
    if ("+" == written || "." == written) {
      if (!cb(self.totalNumberStr, written)) {
        if (cb(self.totalNumberStr, ".") && "+" == written) {
          /** @type {string} */
          self.totalNumberStr = self.totalNumberStr + "0" + written;
        } else {
          self.totalNumberStr += cb(self.totalNumberStr, "+") && "." == written ? "0." : written;
        }
      }
    } else {
      self.totalNumberStr += written;
    }
    createBound();
  }
  /**
   * @return {undefined}
   */
  function createBound() {
    if (self.totalNumber = 0, self.totalNumberStr) {
      var employees = self.totalNumberStr.split("+");
      /** @type {number} */
      var i = 0;
      var l = employees.length;
      for (;l > i;i++) {
        var node = $.getValidNum(employees[i]);
        if (node > 0) {
          self.totalNumber = $.getValidNum($.accAdd(self.totalNumber, node));
        }
      }
    }
  }
  /**
   * @param {Object} r
   * @param {string} written
   * @return {?}
   */
  function cb(r, written) {
    return r ? r.slice(-written.length) == written : false;
  }
  /**
   * @return {undefined}
   */
  function onSuccess() {
    /** @type {string} */
    var accept = "立刻申请接入扫码收款，尽享安全极速收款";
    var oldLeft = obj.currentServer.replace("/is", "").replace("ex.", "www.").replace("web.", "www.");
    if (window.cordova && window.cordova.plugins) {
      $.showConfirm(accept, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          self.openLink(oldLeft + deepDataAndEvents.getVaItem[4].htmlName, 1);
        }
      }, "您还未接入服务", ["取消", "一键接入"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>" + accept + "</div>",
        cancelText : "取消",
        okText : "开通"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          self.openLink(oldLeft + deepDataAndEvents.getVaItem[4].htmlName, 1);
        }
      });
    }
  }
  /** @type {string} */
  self.tradeStatus = "";
  self.record = {
    KEY293 : "",
    accountItem : "",
    client : {},
    payType : "",
    amount : "",
    remark : ""
  };
  self.receiptDetail = {};
  /** @type {number} */
  self.totalNumber = 0;
  /** @type {string} */
  self.totalNumberStr = "";
  /** @type {number} */
  self.lastTotalNumber = 0;
  /** @type {number} */
  self.tempNumber = 0;
  /** @type {string} */
  self.tradeStatus = "";
  self.scanPayObj = {
    isPressAdd : 0,
    maxNumber : 999999.99,
    ePaymentStateTimes : 0
  };
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  self.getPayType = function(dataAndEvents) {
    return "cash" == dataAndEvents ? "现金收款" : "alipayBarPay" == dataAndEvents ? "支付宝收款" : "wxpayScanPay" == dataAndEvents ? "微信收款" : null;
  };
  self.cashKeyboardSettings = {
    resizeContent : true,
    theme : "light",
    /**
     * @param {string} i
     * @return {?}
     */
    action : function(i) {
      if ("pointer" == i) {
        if (0 === self.tempNumber) {
          /** @type {string} */
          self.tempNumber = "0.";
        } else {
          if (-1 != self.tempNumber.indexOf(".")) {
            return;
          }
          self.tempNumber += ".";
        }
      } else {
        if ("add" == i) {
          /** @type {number} */
          self.tempNumber = 0;
          self.lastTotalNumber = self.totalNumber;
          /** @type {number} */
          self.scanPayObj.isPressAdd = 1;
        } else {
          if (0 === self.tempNumber) {
            /** @type {string} */
            self.tempNumber = "" + i;
          } else {
            if (self.tempNumber.indexOf(".") > -1) {
              var codeSegments = self.tempNumber.toString().split(".");
              if (codeSegments.length >= 2 && 2 == codeSegments[1].length) {
                return;
              }
            }
            if ($.getValidNum(self.tempNumber + "" + i) > self.scanPayObj.maxNumber) {
              return $.toastShow("超过最大收款金额"), void console.log("超过最大收款金额");
            }
            self.tempNumber += "" + i;
          }
        }
      }
      bind(i);
    },
    leftButton : {
      html : '<i class="icon ion-backspace-outline"></i>',
      /**
       * @return {undefined}
       */
      action : function() {
        self.delTempNumber();
      }
    },
    rightButton : {
      html : '<div class="payBtn">收款</div>',
      /**
       * @param {?} event
       * @return {undefined}
       */
      action : function(event) {
        if (event) {
          event.stopPropagation();
        }
        if (0 != self.totalNumber) {
          self.payAction(self.record.payType);
        } else {
          $.toastShow("请输入收款金额.");
        }
      },
      style : {
        color : "#fff",
        activeBgColor : "#9D9EBF",
        bgColor : "#CD0000"
      }
    }
  };
  /**
   * @param {string} value
   * @return {?}
   */
  self.calTotalNumber = function(value) {
    return cb(value, "+") ? "+" + value.substr(0, value.length - 1) : cb(value, ".") ? "." + value.substr(0, value.length - 1) : value;
  };
  /**
   * @return {undefined}
   */
  self.delTempNumber = function() {
    if (self.tempNumber.length > 0) {
      self.tempNumber = self.tempNumber.slice(0, -1);
      if (0 == self.tempNumber.length || "0" === self.tempNumber) {
        /** @type {number} */
        self.tempNumber = 0;
      }
    }
    self.totalNumberStr = self.totalNumberStr.substr(0, self.totalNumberStr.length - 1);
    createBound();
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY190 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY119 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("payTypePopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.payTypePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openPayTypePopover = function(expectedNumberOfNonCommentArgs) {
    self.payTypePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  self.hidePayTypePopover = function(event) {
    self.payTypePopover.hide(event);
  };
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY216.html", function(theTitle) {
    self.clientModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.clientModalOpen = function() {
    self.clientModal.show();
  };
  $modal.fromTemplateUrl("payType.html", function(theTitle) {
    /** @type {number} */
    self.payTypeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PWithdrawCash/KEY312.html", function(theTitle) {
    self.fastReceiptDetailModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.clientModal.remove();
    self.KEY190.remove();
    self.KEY119.remove();
    self.payTypePopover.remove();
    self.payTypeModal.remove();
    self.fastReceiptDetailModal.remove();
    $document.getScanerCode(function(fmt) {
      console.log(fmt);
    }, self.bluethoothScaner);
  });
  self.$on("$ionicView.afterEnter", function() {
    $document.getScanerCode(function(key) {
      if (key) {
        /** @type {string} */
        self.record.payType = "";
        self.record.amount = self.totalNumber;
        self.scanPay(key);
      }
    }, self.bluethoothScaner);
  });
  self.$on("$ionicView.loaded", function() {
    loading.show();
    fetch().then(function(packs) {
      loading.hide();
      self.allAccounts = packs[0].data.rows;
      self.record.KEY293 = self.allAccounts[0];
      self.allAccountItems = packs[1].data.rows;
      /** @type {number} */
      var j = 0;
      for (;j < self.allAccountItems.length;j++) {
        if (0 == self.allAccountItems[j].isEnable || (1 == self.allAccountItems[j].id || (10 == self.allAccountItems[j].id || 5 == self.allAccountItems[j].id))) {
          self.allAccountItems.splice(j, 1);
          j--;
        }
      }
      self.record.accountItem = self.allAccountItems[0];
      var data = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "cash.KEY293");
      if (data) {
        /** @type {*} */
        var elem = JSON.parse(data.configValue);
        if (elem) {
          /** @type {number} */
          j = 0;
          var spaces = self.allAccounts.length;
          for (;spaces > j;j++) {
            if (elem.id == self.allAccounts[j].id) {
              self.record.KEY293 = self.allAccounts[j];
              break;
            }
          }
        }
      }
      var postData = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "cash.accountItem");
      if (postData) {
        /** @type {*} */
        elem = JSON.parse(postData.configValue);
        if (elem) {
          /** @type {number} */
          j = 0;
          spaces = self.allAccountItems.length;
          for (;spaces > j;j++) {
            if (elem.id == self.allAccountItems[j].id) {
              self.record.accountItem = self.allAccountItems[j];
              break;
            }
          }
        }
      }
    }, function() {
      loading.hide();
    });
  });
  /**
   * @return {undefined}
   */
  self.openPayType = function() {
    if (0 != self.totalNumber) {
      self.record.amount = self.totalNumber;
      self.payTypeModal.show();
    } else {
      $.toastShow("请输入收款金额.");
    }
  };
  /**
   * @return {undefined}
   */
  self.addToRemark = function() {
    if (window.cordova && window.cordova.plugins) {
      $.showConfirm("确认将当前计算的金额信息添加到备注？", function(dataAndEvents) {
        if (2 == dataAndEvents) {
          self.record.remark += self.totalNumberStr;
        }
      }, null, ["取消", "确认"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>确认将计算的金额信息添加到备注？</div>",
        cancelText : "取消",
        okText : "确认"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          self.record.remark += self.totalNumberStr;
        }
      });
    }
  };
  /**
   * @return {?}
   */
  var fetch = function() {
    var imageDfd = $q.defer();
    var request1 = result.httpCacheGet.get(result.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var getPromise3 = result.httpCacheGet.get(result.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  };
  /**
   * @return {undefined}
   */
  self.clearAction = function() {
    if (self.scanPayObj.isPressAdd) {
      var e = {
        buttons : [{
          text : "全部清空"
        }],
        cancelText : "取消"
      };
      /**
       * @param {number} i
       * @return {?}
       */
      e.buttonClicked = function(i) {
        return e.buttons[i].text.indexOf("全部清空") > -1 && self.clear(), true;
      };
      errors.show(e);
    } else {
      self.clear();
    }
  };
  /**
   * @param {?} container
   * @return {undefined}
   */
  self.bluetooth = function(container) {
    UnitBluetoothPrint.print(self.mainCompany.comName, container, UnitBluetoothPrint.orderType.fastReceiptOrder);
  };
  /**
   * @return {undefined}
   */
  self.gotoList = function() {
    $state.go("eventmenu.cashHistory");
  };
  /**
   * @return {undefined}
   */
  self.clear = function() {
    /** @type {number} */
    self.totalNumber = 0;
    /** @type {string} */
    self.totalNumberStr = "";
    /** @type {number} */
    self.lastTotalNumber = 0;
    /** @type {number} */
    self.tempNumber = 0;
    self.record.client = {};
    /** @type {string} */
    self.record.remark = "";
    self.scanPayObj = {
      isPressAdd : 0,
      maxNumber : 999999.99,
      ePaymentStateTimes : 0
    };
  };
  /**
   * @param {?} rs
   * @return {undefined}
   */
  self.payAction = function(rs) {
    if (self.record.amount = self.totalNumber, self.record.payType = rs, "cash" == rs) {
      if (window.cordova && window.cordova.plugins) {
        $.showConfirm("确认要进行现金快速收款？", function(dataAndEvents) {
          if (2 == dataAndEvents) {
            self.scanPay("");
          }
        }, null, ["取消", "确定"]);
      } else {
        var promise = _.confirm({
          template : "<div class='tc'>确认要进行现金快速收款？</div>",
          cancelText : "取消",
          okText : "确定"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            self.scanPay("");
          }
        });
      }
    } else {
      if ("none" == self.wxpayAccountType) {
        onSuccess(rs);
      } else {
        indicator.show({
          template : "正打开摄像头...",
          duration : 1E3
        });
        Hogan.scan().then(function(data) {
          return data.cancelled ? void loading.hide() : void self.scanPay(data.text);
        }, function(err) {
          loading.hide();
          console.error("Scanning failed: " + err);
          $.toastShow("二维码扫描失败！");
        });
      }
    }
  };
  /**
   * @param {?} item
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  var fn = function(item, expectedNumberOfNonCommentArgs) {
    self.receiptDetail.item = item;
    self.fastReceiptDetailModal.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {?} keepData
   * @return {?}
   */
  self.scanPay = function(keepData) {
    return self.record.amount = $.getValidNum(self.record.amount), 0 == self.record.amount || null == self.record.amount ? void $.toastShow("请输入收款金额") : (indicator.show({
      template : "支付处理中..."
    }), self.scanPayObj.ePaymentStateTimes = 0, void result.post("/KEY432", {
      accountId : self.record.KEY293.id,
      accountItem : self.record.accountItem.id,
      clientId : self.record.client.clientId,
      payType : self.record.payType,
      amount : self.record.amount,
      authCode : keepData,
      remark : self.record.remark
    }).success(function(res) {
      if (1 == res.statusCode) {
        indicator.hide();
        if ("cash" == self.record.payType) {
          if (2 == res.object.fastReceiptVO.state) {
            console.log("现金收款记账成功！");
            indicator.show({
              template : "现金收款记账成功！",
              duration : 1E3
            });
            self.payTypeModal.hide();
            self.clear();
            fn(res.object.fastReceiptVO);
            UnitBluetoothPrint.autoPrint(self.mainCompany.comName, res.object.fastReceiptVO, UnitBluetoothPrint.orderType.fastReceiptOrder);
          }
        } else {
          self.tradeStatus = res.object.salePayTradeVO.tradeStatus;
          if ("success" == self.tradeStatus) {
            console.log("用户已支付成功！");
            indicator.show({
              template : "用户已支付成功！",
              duration : 2E3
            });
            self.payTypeModal.hide();
            self.clear();
            fn(res.object.fastReceiptVO);
            UnitBluetoothPrint.autoPrint(self.mainCompany.comName, res.object.fastReceiptVO, UnitBluetoothPrint.orderType.fastReceiptOrder);
          } else {
            if ("wait" == self.tradeStatus) {
              indicator.show({
                template : "等待用户付款中..."
              });
              success(res.object.salePayTradeVO.tradeSn);
            } else {
              console.log(res.object.salePayTradeVO.errorMsg);
              $.toastShow(res.object.salePayTradeVO.errorMsg);
            }
          }
        }
      } else {
        indicator.hide();
        console.log(res.content);
        $.toastShow(res.content);
      }
    }).error(function() {
      indicator.hide();
    }));
  };
  /**
   * @param {string} nextModel
   * @return {undefined}
   */
  var success = function(nextModel) {
    result.postEncode("/KEY435", {
      tradeSn : nextModel
    }).success(function(res) {
      if (1 == res.statusCode) {
        self.tradeStatus = res.object.salePayTradeVO.tradeStatus;
        if ("success" == self.tradeStatus) {
          indicator.hide();
          loading.hide();
          console.log("支付成功！");
          $.toastShow("支付成功！", "long");
          self.payTypeModal.hide();
          self.clear();
          fn(res.object.fastReceiptVO);
          UnitBluetoothPrint.autoPrint(self.mainCompany.comName, res.object.fastReceiptVO, UnitBluetoothPrint.orderType.fastReceiptOrder);
        } else {
          if ("wait" == self.tradeStatus) {
            if (self.scanPayObj.ePaymentStateTimes < 20) {
              self.scanPayObj.ePaymentStateTimes++;
              done(function() {
                success(nextModel);
              }, 3E3);
            } else {
              indicator.hide();
              loading.hide();
              console.log("二维码超时，请重新扫码付款！");
              $.toastShow("二维码超时，请重新扫码付款！");
            }
          } else {
            if ("close" == self.tradeStatus) {
              indicator.hide();
              console.log(res.object.salePayTradeVO.errorMsg);
              $.toastShow(res.object.salePayTradeVO.errorMsg);
            }
          }
        }
      } else {
        $.toastShow("获取交易状态失败");
      }
    }).error(function() {
      indicator.hide();
      loading.hide();
    });
  };
  self.$watch("[record.KEY293, record.accountItem]", function(results, f) {
    if (results[0] && (f[0] && (results[0].id != f[0].id && f[0].id > 0))) {
      dataAndEvents.saveOrUpdateUserConfig("cash.KEY293", JSON.stringify(self.record.KEY293)).then(function(event) {
        var value = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "cash.KEY293");
        if (value) {
          $.union(value, event.object);
        } else {
          obj.userConfigData.push(event.object);
        }
      });
    } else {
      if (results[1]) {
        if (f[1]) {
          if (results[1].id != f[1].id) {
            if (f[1].id > 0) {
              dataAndEvents.saveOrUpdateUserConfig("cash.accountItem", JSON.stringify(self.record.accountItem)).then(function(event) {
                var value = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "cash.accountItem");
                if (value) {
                  $.union(value, event.object);
                } else {
                  obj.userConfigData.push(event.object);
                }
              });
            }
          }
        }
      }
    }
  }, true);
}]).controller("CashHistoryCtrl", ["$scope", "$stateParams", "$ionicPopover", "$cordovaBarcodeScanner", "Tools", "$timeout", "psisServices", "$q", "ServerConfig", "lruPersistCache", "$ionicPopup", "$ionicModal", "$state", "lbSpinnerDialog", "$ionicActionSheet", "lbScrollDelegate", "$cordovaDatePicker", "BluetoothPrintService", function(self, deepDataAndEvents, FB, ignoreMethodDoesntExist, dataAndEvents, textAlt, game, $q, keepData, opt_attributes, matcherFunction, $modal,
$state, loading, execResult, parent, $scope, UnitBluetoothPrint) {
  /** @type {boolean} */
  self.isLoading = true;
  /** @type {Array} */
  self.items = [];
  self.receiptDetail = {};
  /** @type {Date} */
  var midnight = new Date;
  midnight.setHours(0, 0, 0, 0);
  var createTimeBegin = (new Date).setDate((new Date).getDate() - 30);
  self.queryCondition = {
    page : 1,
    clientId : "",
    accountId : "",
    accountItem : ""
  };
  /** @type {Array} */
  self.payTypeOptions = ["cash", "alipayBarPay", "wxpayScanPay"];
  self.record = {
    client : {
      clientId : "",
      clientName : ""
    },
    KEY293 : "",
    accountItem : "",
    createTimeBegin : createTimeBegin,
    createTimeEnd : (new Date).getTime(),
    payType : ""
  };
  /**
   * @return {undefined}
   */
  self.goWeChatPublic = function() {
    $state.go("eventmenu.KEY326");
  };
  $modal.fromTemplateUrl("cashListQuery.html", function(theTitle) {
    self.cashListQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY216.html", function(theTitle) {
    self.clientModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.clientModalOpen = function() {
    self.clientModal.show();
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY190 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY119 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("payTypePopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.payTypePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openPayTypePopover = function(expectedNumberOfNonCommentArgs) {
    self.payTypePopover.show(expectedNumberOfNonCommentArgs);
  };
  $modal.fromTemplateUrl("html/PWithdrawCash/KEY312.html", function(theTitle) {
    self.fastReceiptDetailModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @param {?} item
   * @param {Object} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.showFastReceiptDetail = function(item, expectedNumberOfNonCommentArgs) {
    if (expectedNumberOfNonCommentArgs.stopPropagation()) {
      expectedNumberOfNonCommentArgs.preventDefault();
    }
    self.receiptDetail.item = item;
    self.fastReceiptDetailModal.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeBegin = function() {
    $scope.show({
      date : new Date(self.record.createTimeBegin),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.record.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeEnd = function() {
    $scope.show({
      date : new Date(self.record.createTimeEnd),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.record.createTimeEnd = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    self.record.client = {};
    self.record.KEY293 = {};
    /** @type {string} */
    self.record.accountItem = "";
    /** @type {string} */
    self.record.payType = "";
    delete self.queryCondition.clientIsNull;
  };
  /**
   * @return {?}
   */
  var Step = function() {
    return game.postEncode("/KEY409", self.queryCondition);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    self.queryCondition.clientId = self.record.client && self.record.client.clientId ? self.record.client.clientId : "";
    self.queryCondition.accountId = self.record.KEY293 && self.record.KEY293.id ? self.record.KEY293.id : "";
    self.queryCondition.accountItem = self.record.accountItem.id ? self.record.accountItem.id : "";
    self.queryCondition.createTimeBegin = dataAndEvents.getDayBeginStr(self.record.createTimeBegin);
    self.queryCondition.createTimeEnd = dataAndEvents.getOffsetDayBeginStr(self.record.createTimeEnd, 1);
    self.queryCondition.payType = self.record.payType;
    /** @type {number} */
    self.queryCondition.page = 1;
    if (self.queryCondition.clientId > 0) {
      delete self.queryCondition.clientIsNull;
    } else {
      if (self.record.client.clientIsNull) {
        if ("" == self.record.client.clientId) {
          /** @type {boolean} */
          self.queryCondition.clientIsNull = true;
        }
      }
    }
    loading.show();
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("cashListCtrlScroll");
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("cashListCtrlScroll");
    });
  };
  /**
   * @return {?}
   */
  var fetch = function() {
    var imageDfd = $q.defer();
    var request1 = game.httpCacheGet.get(game.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var getPromise3 = game.httpCacheGet.get(game.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  };
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  self.getPayType = function(dataAndEvents) {
    return "cash" == dataAndEvents ? "现金收款" : "alipayBarPay" == dataAndEvents ? "支付宝收款" : "wxpayScanPay" == dataAndEvents ? "微信收款" : null;
  };
  /**
   * @param {?} container
   * @return {undefined}
   */
  self.bluetooth = function(container) {
    UnitBluetoothPrint.print(self.mainCompany.comName, container, UnitBluetoothPrint.orderType.fastReceiptOrder);
  };
  self.$on("$destroy", function() {
    self.cashListQueryModal.remove();
    self.clientModal.remove();
    self.KEY190.remove();
    self.KEY119.remove();
    self.payTypePopover.remove();
    self.fastReceiptDetailModal.remove();
  });
  self.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      self.allAccounts = packs[0].data.rows;
      self.allAccountItems = packs[1].data.rows;
    });
    self.getList();
  });
}]).controller("WeChatPublicCtrl", ["$scope", "$stateParams", "$ionicPopover", "Tools", "$timeout", "psisServices", "$q", "ServerConfig", "lruPersistCache", "$ionicPopup", "$ionicModal", "$state", "lbSpinnerDialog", "$ionicActionSheet", "lbScrollDelegate", function($rootScope, ignoreMethodDoesntExist, textAlt, res, dataAndEvents, deepDataAndEvents, keepData, file, opt_attributes, _, matcherFunction, execResult, loading) {
  /**
   * @return {undefined}
   */
  function createTable() {
    /** @type {string} */
    var r20 = "weixin://";
    Wechat.jumpToWechat(r20, function() {
      console.log("Success");
    }, function(reply) {
      console.log("Failed: " + reply);
    });
  }
  /**
   * @return {undefined}
   */
  $rootScope.SaveToLocal = function() {
    /** @type {(HTMLElement|null)} */
    var xmlDoc = document.getElementById("qr");
    var canvas = angular.element(xmlDoc).find("canvas")[0];
    var win = canvas.toDataURL();
    cordova.base64ToGallery(win, {
      prefix : "img_",
      mediaScanner : true
    }, function() {
      res.toastShow("图片已成功保存在相册中！");
      /** @type {string} */
      var errStr = "打开微信扫一扫，点击右上角“相册”选图扫码！";
      if (window.cordova && window.cordova.plugins) {
        res.showConfirm(errStr, function(dataAndEvents) {
          if (2 == dataAndEvents) {
            createTable();
          }
        }, "打开微信", ["取消", "确定"]);
      } else {
        var promise = _.confirm({
          template : "<div class='tc'>" + errStr + "</div>",
          cancelText : "取消",
          okText : "确定"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            createTable();
          }
        });
      }
    }, function(template) {
      res.toastShow(template);
    });
  };
  $rootScope.$on("$ionicView.beforeEnter", function() {
    var userId = file.webServer.slice(0, file.webServer.lastIndexOf("/"));
    loading.show(true);
    deepDataAndEvents.fullPathPostEncode(userId + "/push/wechat/getTemporaryQRcodeTicket.ac?userId=" + $rootScope.mainUserConfig.userId + "&officialAccount=StarBusiness&sys=is").success(function(response) {
      if (1 == response.statusCode) {
        $rootScope.weChatPlubicObj = response.object;
      }
      console.log($rootScope.weChatPlubicObj);
    }).finally(function() {
      loading.hide();
    });
  });
}]);
