angular.module("ecommerceController", ["ionic", "services", "tools"]).controller("EcommerceCtrl", ["$scope", "$state", "Tools", "ServerConfig", "ServerType", "psisServices", "lbSpinnerDialog", function(dataAndEvents, $state) {
  /**
   * @return {undefined}
   */
  dataAndEvents.goEshopList = function() {
    $state.go("eventmenu.KEY311");
  };
  /**
   * @return {undefined}
   */
  dataAndEvents.goEshopOrderList = function() {
    $state.go("eventmenu.taoBaoOrderList");
  };
}]).controller("EshopListCtrl", ["$scope", "$http", "$timeout", "$state", "psisServices", "lbScrollDelegate", "$ionicPopup", "$ionicPopover", "$ionicModal", "lbSpinnerDialog", "$q", "Tools", "lruPersistCache", "$cordovaDatePicker", "BluetoothPrintService", "ServerConfig", function($scope, ignoreMethodDoesntExist, textAlt, $state, dataAndEvents, parent, keepData, opt_attributes, matcherFunction, loading, execResult, opt_keys, $templateCache, positionError, oFunctionBody, deepDataAndEvents) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  /** @type {boolean} */
  $scope.isLoading = true;
  /**
   * @return {?}
   */
  var getValue = function() {
    return dataAndEvents.fullPathPostEncode(deepDataAndEvents.esServer + "/KEY410");
  };
  /**
   * @return {undefined}
   */
  var run = function() {
    loading.show();
    /** @type {number} */
    page = 1;
    getValue({
      page : page
    }).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("eshopListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    getValue({
      page : ++page
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("eshopListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    page = 1;
    getValue({
      page : page
    }).success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.openEshopService = function() {
    $scope.openLink("https://fuwu.m.taobao.com/ser/detail.html?spm=a1z13.1113643.0.0.tLmgq5&service_code=FW_GOODS-1000149985&tracelog=search", 1);
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  $scope.goEshopDetail = function(term) {
    $state.go("eventmenu.eshopInfo", {
      id : term
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshEshopList")) {
      run();
      $templateCache.put("refreshEshopList", false);
    }
  });
  $scope.$on("$ionicView.loaded", function() {
    run();
  });
}]).controller("EshopDetailCtrl", ["$scope", "$http", "$rootScope", "$stateParams", "$q", "ServerConfig", "psisServices", "lbSpinnerDialog", "$ionicPopup", "ServerType", "Tools", "commonDataInterface", "lruPersistCache", "$ionicModal", "$ionicPopover", "$state", "$window", function(self, $http, deepDataAndEvents, $attrs, $q, dataAndEvents, field, loading, _, ignoreMethodDoesntExist, $, textAlt, $templateCache, $modal, FB) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = field.httpCacheGet.get(field.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var getPromise3 = field.httpCacheGet.get("/KEY070?showDisable=1&filterComStore=1");
    var c = field.httpCacheGet.get(field.httpCacheGet.ac.ALLDELIVERY);
    return $q.all([request1, getPromise3, c]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  self.eshopId = $attrs.id;
  self.viewTitle = self.eshopId ? self.NameConstant.KEY262 : self.NameConstant.SHOPADD;
  /** @type {number} */
  self.state = 0;
  self.taoBaoDetail = {
    eshopVO : {},
    eshopSendAddressVO : {},
    eshopAuthVO : {},
    statusSetting : true
  };
  self.taobaoInfo = {
    allAccount : {},
    storeHouse : {},
    logisticsCompanny : {}
  };
  /** @type {boolean} */
  self.taoBaoDetail.eshopVO.inUseing = true;
  /** @type {boolean} */
  self.taoBaoDetail.eshopVO.isAutoTransing = true;
  /** @type {string} */
  self.taoBaoDetail.eshopVO.shopType = "taobao";
  FB.fromTemplateUrl("eshopType.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.eshopTypePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openEshopTypePopover = function(expectedNumberOfNonCommentArgs) {
    self.eshopTypePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideEshopTypePopover = function() {
    self.eshopTypePopover.hide();
  };
  $modal.fromTemplateUrl("accountTypeSelect.html", function(theTitle) {
    self.accountTypeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("storeHouseSelect.html", function(theTitle) {
    self.storeHouseTypeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("logisticsCompanySelect.html", function(theTitle) {
    self.logisticsCompanyTypeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    if (self.accountTypeModal) {
      self.accountTypeModal.remove();
    }
    if (self.storeHouseTypeModal) {
      self.storeHouseTypeModal.remove();
    }
    if (self.logisticsCompanyTypeModal) {
      self.logisticsCompanyTypeModal.remove();
    }
    if (self.eshopTypePopover) {
      self.eshopTypePopover.remove();
    }
  });
  /**
   * @return {undefined}
   */
  self.ehsopAuthorization = function() {
    /** @type {string} */
    var inner = "https://oauth.m.taobao.com/authorize?response_type=code&client_id=23285140&redirect_uri=";
    /** @type {string} */
    var encodedValue = JSON.stringify({
      orderId : self.eshopId,
      deviceType : "app"
    });
    /** @type {string} */
    var arr = dataAndEvents.esServer + "/admin/ecommerce/eshop/eshopOauthCallback.ac?eshopId=" + self.eshopId + "&state=" + encodeURI(encodeURIComponent(encodedValue));
    self.openLink(inner + arr + "&view=web", 1);
  };
  /**
   * @return {?}
   */
  self.save = function() {
    return self.taoBaoDetail.eshopVO.name ? self.taoBaoDetail.eshopVO.shopType ? (loading.show(true), void field.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/eshop/eshopIsUnique.ac?eshopId=" + self.eshopId + "&newName=" + self.taoBaoDetail.eshopVO.name).success(function(e) {
      if (0 == e.isValid) {
        loading.hide();
        if (window.cordova && window.cordova.plugins) {
          $.showAlert("网店名称已存在，请输入其他名称", "确认");
        } else {
          _.alert({
            template : "<div class='tc'>网店名称已存在，请输入其他名称</div>",
            okText : "确定"
          });
        }
      } else {
        field.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/eshop/accountIsUnique.ac?KEY293=" + self.taoBaoDetail.eshopVO.KEY293 + "&eshopId=" + self.eshopId).success(function(e) {
          if (0 == e.isValid) {
            loading.hide();
            if (window.cordova && window.cordova.plugins) {
              $.showAlert("账号已存在，请输入其它账号", "确认");
            } else {
              _.alert({
                template : "<div class='tc'>账号已存在，请输入其它账号</div>",
                okText : "确定"
              });
            }
          } else {
            self.saveEshopInfo();
          }
        });
      }
    }).finally(function() {
      loading.hide();
    })) : ($.toastShow("请选择网店类型"), false) : ($.toastShow("请输入网店名称"), false);
  };
  /**
   * @return {undefined}
   */
  self.saveEshopInfo = function() {
    self.taoBaoDetail.eshopVO.accountId = self.taobaoInfo.allAccount.id ? self.taobaoInfo.allAccount.id : "";
    self.taoBaoDetail.eshopVO.storehouseId = self.taobaoInfo.storeHouse.id ? self.taobaoInfo.storeHouse.id : "";
    self.taoBaoDetail.eshopVO.deliveryCompanyId = self.taobaoInfo.logisticsCompanny.id ? self.taobaoInfo.logisticsCompanny.id : "";
    /** @type {number} */
    self.taoBaoDetail.eshopVO.inUse = self.taoBaoDetail.eshopVO.inUseing ? 1 : 0;
    /** @type {number} */
    self.taoBaoDetail.eshopVO.isAutoTrans = self.taoBaoDetail.eshopVO.isAutoTransing ? 1 : 0;
    var customer = {
      eshopVO : self.taoBaoDetail.eshopVO,
      eshopSendAddressVO : self.taoBaoDetail.eshopSendAddressVO
    };
    $http.post(dataAndEvents.esServer + "/KEY386", customer).success(function(config) {
      if (1 == config.statusCode) {
        $.union(self.taoBaoDetail, config.object);
        /** @type {number} */
        self.state = 1;
        self.viewTitle = self.NameConstant.KEY262;
        $templateCache.put("refreshEshopList", true);
        self.eshopId = config.object.eshopVO.id;
        if (window.cordova && window.cordova.plugins) {
          $.showAlert("保存成功", "", "提示", "确认");
        } else {
          _.alert({
            template : "<div class='tc'>保存成功</div>",
            okText : "确定"
          });
        }
      } else {
        if (window.cordova && window.cordova.plugins) {
          $.showAlert(config.content, "确认");
        } else {
          _.alert({
            template : "<div class='tc'>" + config.content + "</div>",
            okText : "确定"
          });
        }
      }
    }).error(function(data) {
      if (data) {
        if (data.content) {
          $.toastShow(data.content);
        }
      }
      loading.hide();
    }).finally(function() {
      loading.hide();
    });
  };
  var throttledUpdate = ionic.debounce(self.save, 1E3, true);
  /**
   * @return {undefined}
   */
  self.saveAction = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  self.eshopDelete = function() {
    _.confirm({
      template : "<div class='tc'>您确定要删除该店铺?</div>",
      cancelText : "取消",
      okText : "确认"
    }).then(function(deepDataAndEvents) {
      if (deepDataAndEvents) {
        loading.show(true);
        $http.post(dataAndEvents.esServer + "/admin/ecommerce/eshop/eshopDelete.ac?id=" + self.taoBaoDetail.eshopVO.id).success(function(r) {
          if (1 == r.statusCode) {
            /**
             * @return {undefined}
             */
            var loop = function() {
              $templateCache.put("refreshEshopList", true);
              self.goBack();
            };
            if (window.cordova && window.cordova.plugins) {
              $.showAlert("删除成功", loop, "提示", "确认");
            } else {
              _.alert({
                template : "<div class='tc'>删除成功</div>",
                okText : "确定"
              }).then(loop);
            }
          } else {
            if (window.cordova && window.cordova.plugins) {
              $.showAlert("删除失败，该网店已经被使用，不能删除，请设置启用为否", "确认");
            } else {
              _.alert({
                template : "<div class='tc'>删除失败，该网店已经被使用，不能删除，请设置启用为否。</div>",
                okText : "确定"
              });
            }
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.getEshopInfo = function() {
    loading.show();
    fetch().then(function(packs) {
      self.allAccount = packs[0].data.rows;
      self.storeHouse = packs[1].data;
      self.logisticsCompanny = packs[2].data;
      if (self.eshopId) {
        /** @type {number} */
        self.state = 1;
        field.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/eshop/eshopGet.ac?id=" + self.eshopId).success(function(reply) {
          self.taoBaoDetail = reply.object;
          /** @type {boolean} */
          self.taoBaoDetail.eshopVO.inUseing = 1 == reply.object.eshopVO.inUse ? true : false;
          /** @type {boolean} */
          self.taoBaoDetail.eshopVO.isAutoTransing = 1 == reply.object.eshopVO.isAutoTrans ? true : false;
          /** @type {number} */
          var i = 0;
          var ilen = self.allAccount.length;
          for (;ilen > i;i++) {
            if (self.taoBaoDetail.eshopVO.accountId == self.allAccount[i].id) {
              self.taobaoInfo.allAccount = self.allAccount[i];
              break;
            }
          }
          /** @type {number} */
          i = 0;
          ilen = self.storeHouse.length;
          for (;ilen > i;i++) {
            if (self.taoBaoDetail.eshopVO.storehouseId == self.storeHouse[i].id) {
              self.taobaoInfo.storeHouse = self.storeHouse[i];
              break;
            }
          }
          /** @type {number} */
          i = 0;
          ilen = self.logisticsCompanny.length;
          for (;ilen > i;i++) {
            if (self.logisticsCompanny[i].kdnCode && self.taoBaoDetail.eshopVO.deliveryCompanyId == self.logisticsCompanny[i].id) {
              self.taobaoInfo.logisticsCompanny = self.logisticsCompanny[i];
              break;
            }
          }
        }).finally(function() {
          loading.hide();
        });
      } else {
        loading.hide();
      }
    }, function() {
      loading.hide();
    });
  };
  self.$on("$ionicView.afterEnter", function() {
    self.getEshopInfo();
  });
}]).controller("EshopOrderCtrl", ["$scope", "$state", "$http", "$stateParams", "$timeout", "$ionicPopup", "$ionicPopover", "psisServices", "lbScrollDelegate", "lruPersistCache", "$ionicModal", "$cordovaDatePicker", "Tools", "lbSpinnerDialog", "ServerConfig", "BluetoothPrintService", "$q", "$window", "$ionicActionSheet", "$cordovaBarcodeScanner", function(self, $state, _, deepDataAndEvents, $sanitize, dialog, FB, game, parent, $templateCache, $modal,
$scope, response, loading, dataAndEvents, b, $q, $window, handler, Hogan) {
  /**
   * @param {Array} xs
   * @param {number} shallow
   * @return {?}
   */
  function next(xs, shallow) {
    if (0 == xs.length) {
      return false;
    }
    var pluginMap = xs.shift();
    loading.show();
    game.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/order/updatePrintFlag.ac?id=" + pluginMap.id + "&isPrint=1").success(function(r) {
      if (1 == r.statusCode) {
        loading.hide();
        next(xs, shallow);
      }
    }).finally(function() {
      loading.hide();
    });
  }
  /**
   * @param {Object} obj
   * @return {?}
   */
  function clone(obj) {
    /** @type {boolean} */
    var isArray = obj instanceof Array;
    /** @type {boolean} */
    var haveEvent = obj instanceof Object;
    if (!haveEvent) {
      return obj;
    }
    /** @type {(Array|{})} */
    var out = isArray ? [] : {};
    var i;
    for (i in obj) {
      out[i] = clone(obj[i]);
    }
    return out;
  }
  /**
   * @param {Array} data
   * @param {number} callback
   * @param {Array} results
   * @param {?} key
   * @param {number} a
   * @return {?}
   */
  function listener(data, callback, results, key, a) {
    if (0 == data.length) {
      return false;
    }
    var filter = data.shift();
    if (filter.checked) {
      a += self.logisticsNumber.stepByStep;
      results.push(fn(filter.id, key, a, self.logisticsNumber.logisticsCompanyCode, callback));
      listener(data, callback, results, key, a);
    } else {
      listener(data, callback, results, key, a);
    }
  }
  /**
   * @param {?} x
   * @param {?} y
   * @param {?} param
   * @param {?} event
   * @param {(Object|number)} arg
   * @return {?}
   */
  function fn(x, y, param, event, arg) {
    /** @type {Object} */
    var params = new Object;
    return params.orderId = x, params.deliveryId = y, params.deliverySn = param, params.logisticsCompanyCode = event, params.deliveryType = arg, params;
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = game.httpCacheGet.get(game.httpCacheGet.ac.ALLDELIVERY);
    return $q.all([request1]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  self.queryCondition = {
    page : 1
  };
  /** @type {string} */
  self.searchKey = "";
  /** @type {string} */
  self.focused = "centered";
  /** @type {boolean} */
  self.isLoading = true;
  self.listQuery = {};
  /** @type {Array} */
  self.selectedItems = [];
  /** @type {boolean} */
  self.isSelectedOrder = true;
  /** @type {Array} */
  self.selectSend = [];
  /** @type {boolean} */
  self.isSendOrders = true;
  /** @type {Array} */
  self.ordersList = [];
  /** @type {string} */
  self.selectTiltle = "全选";
  self.logisticsNumber = {
    stepByStep : 1
  };
  /** @type {Array} */
  var codeSegments = ["WAIT_BUYER_PAY", "SELLER_CONSIGNED_PART", "WAIT_SELLER_SEND_GOODS", "WAIT_BUYER_CONFIRM_GOODS", "TRADE_BUYER_SIGNED", "TRADE_FINISHED", "TRADE_CLOSED", "TRADE_CLOSED_BY_THIRD_PART"];
  /** @type {Array} */
  var prevSources = ["待付款", "部分发货", "等待卖家发货", "等待买家确认收货", "等待买家签收", "交易成功", "交易关闭", "卖家或买家主动关闭交易"];
  /**
   * @return {?}
   */
  var logEvent = function() {
    return self.searchParam = {
      includeDt : 1,
      page : self.queryCondition.page,
      consignee : self.searchKey,
      orderSn : self.queryCondition.orderSn ? self.queryCondition.orderSn : "",
      thirdOrderSn : self.queryCondition.thirdOrderSn ? self.queryCondition.thirdOrderSn : "",
      status : self.queryCondition.status ? self.queryCondition.status : "",
      isSend : null != self.queryCondition.isSend ? self.queryCondition.isSend : "",
      isPrintExpress : null != self.queryCondition.isPrintExpress ? self.queryCondition.isPrintExpress : "",
      isTransToWholesaleOrder : null != self.queryCondition.isTransToWholesaleOrder ? self.queryCondition.isTransToWholesaleOrder : "",
      isRefund : null != self.queryCondition.thirdOrderRefundCount ? self.queryCondition.thirdOrderRefundCount : "",
      eshopId : self.queryCondition.eshopId ? self.queryCondition.eshopId : "",
      payTimeBegin : null != self.queryCondition.beginTime ? response.getDayBeginStr(self.queryCondition.beginTime) : "",
      payTimeEnd : null != self.queryCondition.endTime ? response.getOffsetDayBeginStr(self.queryCondition.endTime, 1) : ""
    }, game.fullPathPostEncode(dataAndEvents.esServer + "/KEY385", self.searchParam);
  };
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  self.orderStatus = function(opt_attributes) {
    /** @type {number} */
    var dataIndex = 0;
    for (;dataIndex < opt_attributes.length;dataIndex++) {
      /** @type {number} */
      var i = 0;
      for (;i <= codeSegments.length;i++) {
        if (opt_attributes[dataIndex].status === codeSegments[i]) {
          opt_attributes[dataIndex].orderStatus = prevSources[i];
        }
      }
    }
  };
  /**
   * @param {?} el
   * @return {?}
   */
  self.esShopOrderStatus = function(el) {
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      if (el == codeSegments[i]) {
        return prevSources[i];
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.searchOrders = function() {
    if (self.queryCondition.beginTime > self.queryCondition.endTime) {
      dialog.alert({
        template : "<div class='tc'>开始日期不能大于结束日期，请您重新选择日期</div>",
        okText : "确定"
      });
    } else {
      self.getList();
      self.ordersQueryModal.hide();
    }
  };
  /**
   * @param {Array} codeSegments
   * @return {undefined}
   */
  self.initialChecked = function(codeSegments) {
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      if (!codeSegments[i].checked) {
        /** @type {boolean} */
        codeSegments[i].checked = false;
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    loading.show();
    /** @type {number} */
    self.queryCondition.page = 1;
    logEvent().success(function(data) {
      self.items = data.rows;
      self.initialChecked(self.items);
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
      self.orderStatus(self.items);
      /** @type {string} */
      self.selectTiltle = "全选";
      /** @type {Array} */
      self.ordersList = [];
    }).error(function() {
      loading.hide();
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
      parent.scrollTop("eshopOrderScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    /** @type {string} */
    self.searchKey = "";
    /** @type {string} */
    self.queryCondition.orderSn = "";
    /** @type {string} */
    self.queryCondition.thirdOrderSn = "";
    /** @type {string} */
    self.queryCondition.status = "";
    /** @type {string} */
    self.queryCondition.isSend = "";
    /** @type {string} */
    self.queryCondition.isPrintExpress = "";
    /** @type {string} */
    self.queryCondition.isTransToWholesaleOrder = "";
    /** @type {string} */
    self.queryCondition.thirdOrderRefundCount = "";
    /** @type {string} */
    self.queryCondition.eshopId = "";
    /** @type {string} */
    self.queryCondition.eshopName = "";
    /** @type {number} */
    self.queryCondition.page = 1;
    /** @type {null} */
    self.queryCondition.beginTime = null;
    /** @type {null} */
    self.queryCondition.endTime = null;
  };
  $modal.fromTemplateUrl("ordersQueryModal.html", function(theTitle) {
    /** @type {number} */
    self.ordersQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("orderListOperation.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.orderListOperationPopover = theTitle;
  });
  /**
   * @param {Object} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openOrderOperation = function(expectedNumberOfNonCommentArgs) {
    if (expectedNumberOfNonCommentArgs) {
      expectedNumberOfNonCommentArgs.stopPropagation();
    }
    self.orderListOperationPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  self.hideOrderOperation = function(event) {
    if (event) {
      event.stopPropagation();
    }
    self.orderListOperationPopover.hide();
  };
  /**
   * @return {undefined}
   */
  self.showDownloadEshopOrder = function() {
    $state.go("eventmenu.ecDownload");
  };
  $modal.fromTemplateUrl("printLogisticsOrders.html", function(theTitle) {
    /** @type {number} */
    self.logisticsOrdersModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("orderStatus.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.orderStatusPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStatusPopover = function(expectedNumberOfNonCommentArgs) {
    self.orderStatusPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideStatusPopover = function() {
    self.getList();
    self.orderStatusPopover.hide();
  };
  FB.fromTemplateUrl("sendEshopOrder.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.sendEshopOrderPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openSendOrderPopover = function(expectedNumberOfNonCommentArgs) {
    self.sendEshopOrderPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideEshopOrderPopover = function() {
    self.sendEshopOrderPopover.hide();
  };
  FB.fromTemplateUrl("printExpressOrder.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.printExpressOrderPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openExpressOrderPopover = function(expectedNumberOfNonCommentArgs) {
    self.printExpressOrderPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideExpressOrderPopover = function() {
    self.printExpressOrderPopover.hide();
  };
  FB.fromTemplateUrl("thirdRefundCount.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.thirdRefundCountPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openThirdRefundPopover = function(expectedNumberOfNonCommentArgs) {
    self.thirdRefundCountPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideThirdRefundPopover = function() {
    self.thirdRefundCountPopover.hide();
  };
  FB.fromTemplateUrl("eshopNamePopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.eshopNamePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openEshopPopover = function(expectedNumberOfNonCommentArgs) {
    self.eshopNamePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideEshopPopover = function() {
    self.eshopNamePopover.hide();
  };
  FB.fromTemplateUrl("logisticsCompannyPopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.logisticsCompannyPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openLogisticsCompannyPopover = function(expectedNumberOfNonCommentArgs) {
    self.logisticsCompannyPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideLogisticsCompannyPopover = function() {
    self.logisticsCompannyPopover.hide();
  };
  self.$on("$destroy", function() {
    if (self.orderListOperationPopover) {
      self.orderListOperationPopover.remove();
    }
    self.ordersQueryModal.remove();
    self.logisticsOrdersModal.remove();
    if (self.sendEshopOrderPopover) {
      self.sendEshopOrderPopover.remove();
    }
    if (self.printExpressOrderPopover) {
      self.printExpressOrderPopover.remove();
    }
    if (self.thirdRefundCountPopover) {
      self.thirdRefundCountPopover.remove();
    }
    if (self.eshopNamePopover) {
      self.eshopNamePopover.remove();
    }
    if (self.orderStatusPopover) {
      self.orderStatusPopover.remove();
    }
    if (self.logisticsOrdersPopover) {
      self.logisticsOrdersPopover.remove();
    }
    if (self.logisticsCompannyPopover) {
      self.logisticsCompannyPopover.remove();
    }
  });
  /**
   * @param {string} item
   * @param {?} event
   * @return {undefined}
   */
  self.selectOrders = function(item, event) {
    if (event) {
      event.stopPropagation();
    }
    var ix = self.ordersList.indexOf(item);
    if (ix > -1) {
      /** @type {null} */
      item.quantity = null;
      self.ordersList.splice(ix, 1);
    } else {
      if (item.quantity > 0) {
        self.ordersList.push(item);
      } else {
        /** @type {number} */
        item.quantity = 1;
        self.ordersList.push(item);
      }
    }
  };
  /**
   * @return {?}
   */
  self.selectedAllOrders = function() {
    if (self.items.length < 1) {
      return false;
    }
    if ("全选" == self.selectTiltle) {
      /** @type {Array} */
      self.ordersList = [];
      /** @type {number} */
      var i = 0;
      for (;i < self.items.length;i++) {
        if (!self.items[i].checked) {
          /** @type {boolean} */
          self.items[i].checked = true;
        }
        self.ordersList.push(self.items[i]);
      }
      /** @type {string} */
      self.selectTiltle = "取消";
    } else {
      /** @type {string} */
      self.selectTiltle = "全选";
      /** @type {Array} */
      self.ordersList = [];
      /** @type {number} */
      var ii = 0;
      for (;ii < self.items.length;ii++) {
        if (self.items[ii].checked) {
          /** @type {boolean} */
          self.items[ii].checked = false;
        }
      }
    }
  };
  /**
   * @return {?}
   */
  self.deleteOrders = function() {
    if (self.deleteArrs = [], self.UndeleteArrs = [], self.ordersList.length < 1) {
      return response.toastShow("请选择要删除的订单!"), false;
    }
    /** @type {number} */
    var i = 0;
    for (;i < self.items.length;i++) {
      if (self.items[i].checked && !self.items[i].isTransToWholesaleOrder) {
        self.deleteArrs.push(self.items[i].id);
      } else {
        if (self.items[i].checked) {
          if (self.items[i].isTransToWholesaleOrder) {
            self.UndeleteArrs.push(self.items[i].id);
          }
        }
      }
    }
    return self.deleteArrs.length < 1 ? (response.toastShow("您选择的订单已全部转销售单了无法删除，请重新选择订单!"), false) : void dialog.show({
      template : "<div class='tc'>共选中 " + self.ordersList.length + "张订单，其中有" + self.UndeleteArrs.length + "张订单已转销售单，无法删除。</div><div class='tc'>是否继续删除其它 " + self.deleteArrs.length + "张订单?</div>",
      scope : self,
      buttons : [{
        text : "取消"
      }, {
        text : "确定",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          loading.show(true);
          _.post(dataAndEvents.esServer + "/KEY369", self.deleteArrs).success(function(r) {
            if (1 == r.statusCode) {
              response.toastShow("删除订单成功!");
              self.getList();
            } else {
              response.toastShow(r.content);
            }
          }).error(function() {
            loading.hide();
          }).finally(function() {
            loading.hide();
          });
        }
      }]
    });
  };
  /**
   * @return {?}
   */
  self.printAndSendEshopOrder = function() {
    var copies = {};
    /** @type {string} */
    var str = "";
    if (self.printEshopOrders = [], self.ordersList.length < 1) {
      return response.toastShow("请选择要打印快递单的订单!"), false;
    }
    /** @type {number} */
    var i = 0;
    for (;i < self.items.length;i++) {
      if (self.items[i].checked) {
        str = self.items[i].consigneeProvince ? self.items[i].consigneeProvince : "";
        str += self.items[i].consigneeCity ? self.items[i].consigneeCity : "";
        str += self.items[i].consigneeDistrict ? self.items[i].consigneeDistrict : "";
        str += self.items[i].consigneeAddress ? self.items[i].consigneeAddress : "";
        copies = {
          senderName : self.items[i].sender,
          senderAddress : self.items[i].sendAddress,
          senderPhone : self.items[i].sendTelphone,
          receiverName : self.items[i].consignee,
          receiverAddress : str,
          receiverPhone : self.items[i].consigneeCellphone,
          remark : self.items[i].remark
        };
        self.printEshopOrders.push(copies);
      }
    }
    /** @type {number} */
    $window.localStorage["PrintTimes" + b.orderType.ehsopLogisticsOrder] = 1;
    b.bluetooth(self.printEshopOrders, b.orderType.ehsopLogisticsOrder);
  };
  /**
   * @return {?}
   */
  self.transToWholesaleOrder = function() {
    if (self.transSaleOrder = [], self.ordersList.length < 1) {
      return response.toastShow("请选择要转销售单的订单!"), false;
    }
    /** @type {number} */
    var i = 0;
    for (;i < self.items.length;i++) {
      if (self.items[i].checked) {
        if (!self.items[i].isTransToWholesaleOrder) {
          self.transSaleOrder.push(self.items[i]);
        }
      }
    }
    if (self.transSaleOrder.length > 0) {
      self.transToWholesaleOrderTask(self.transSaleOrder);
    } else {
      response.toastShow("您选择的订单已全部转销售单了，请重新选择订单!");
      console.log("您选择的订单已全部转销售单了，请重新选择订单!");
    }
  };
  /**
   * @param {Array} parts
   * @return {?}
   */
  self.transToWholesaleOrderTask = function(parts) {
    if (0 == parts.length) {
      return void response.toastShow("已完成!");
    }
    var pluginMap = parts.shift();
    loading.show(true);
    game.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/order/transToWholesaleOrder.ac?id=" + pluginMap.id).success(function(r) {
      if (1 == r.statusCode) {
        response.toastShow("转销售单成功");
        self.transToWholesaleOrderTask(parts);
      } else {
        if (0 != parts.length) {
          dialog.show({
            template : "<div class='tc'>订单 " + pluginMap.orderSn + " 转销售单时遇到错误:" + r.content + "</div><div class='tc'>是否继续处理其他订单?</div>",
            scope : self,
            buttons : [{
              text : "取消",
              /**
               * @return {?}
               */
              onTap : function() {
                return false;
              }
            }, {
              text : "确定",
              type : "button-assertive",
              /**
               * @return {undefined}
               */
              onTap : function() {
                self.transToWholesaleOrderTask(parts);
              }
            }]
          });
        } else {
          dialog.alert({
            template : "<div class='tc'>订单 " + pluginMap.orderSn + " 转销售单时遇到错误:" + r.content + "</div>",
            okText : "确定"
          });
        }
      }
    }).error(function() {
      loading.hide();
    }).finally(function() {
      loading.hide();
      self.getList();
    });
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    Hogan.scan().then(function(result) {
      if (!result.cancelled) {
        $sanitize(function() {
          self.logisticsNumber.logisticsSn = result.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      response.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {?}
   */
  self.setDeliveryCode = function() {
    if (self.ordersList.length < 1) {
      return response.toastShow("请先选择订单!"), false;
    }
    if (!(self.logisticsNumber.logisticsSn && self.logisticsNumber.stepByStep > 0)) {
      return response.toastShow("请设置起始物流单号和步进值!"), false;
    }
    var camelKey = self.logisticsNumber.deliveryCompanyId;
    /** @type {number} */
    var QUnit = self.logisticsNumber.logisticsSn - self.logisticsNumber.stepByStep;
    /** @type {number} */
    var restoreScript = 4;
    /** @type {Array} */
    var fmt = [];
    var info = clone(self.items);
    return camelKey ? (listener(info, restoreScript, fmt, camelKey, QUnit), loading.show(), _.post(dataAndEvents.esServer + "/KEY383", fmt).success(function(r) {
      if (1 == r.statusCode) {
        response.toastShow("设置成功!");
      }
    }).finally(function() {
      loading.hide();
    }), console.log(fmt), void console.log(info)) : (response.toastShow("请先选择物流公司!"), false);
  };
  /**
   * @param {Object} $routeParams
   * @return {undefined}
   */
  self.getLogisticsInfo = function($routeParams) {
    self.logisticsNumber.deliveryCompanyId = $routeParams.id;
    self.logisticsNumber.name = $routeParams.name;
    self.logisticsNumber.logisticsCompanyCode = $routeParams.logisticsCompanyCode;
  };
  /**
   * @return {?}
   */
  self.sendEshopOrders = function() {
    if (self.sendEshopOrderArrys = [], self.ordersList.length < 1) {
      return response.toastShow("请选择要发货的订单!"), false;
    }
    /** @type {number} */
    var i = 0;
    for (;i < self.items.length;i++) {
      if (self.items[i].checked) {
        if (!self.items[i].isSend) {
          self.sendEshopOrderArrys.push(self.items[i]);
        }
      }
    }
    if (self.sendEshopOrderArrys.length > 0) {
      self.sendEshopOrderTask(self.sendEshopOrderArrys);
    } else {
      response.toastShow("您选择的订单已全部已发货，请重新选择订单!");
    }
  };
  /**
   * @param {Array} parts
   * @return {?}
   */
  self.sendEshopOrderTask = function(parts) {
    if (0 == parts.length) {
      return void response.toastShow("完成!");
    }
    var pluginMap = parts.shift();
    loading.show(true);
    game.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/order/sendEshopOrder.ac?id=" + pluginMap.id).success(function(r) {
      if (1 == r.statusCode) {
        response.toastShow("转发货单成功");
        self.sendEshopOrderTask(parts);
      } else {
        if (0 != parts.length) {
          dialog.show({
            template : "<div class='tc'>订单 " + pluginMap.orderSn + " 发货时遇到错误:" + r.content + "，是否继续处理其他订单?</div>",
            scope : self,
            buttons : [{
              text : "取消",
              /**
               * @return {?}
               */
              onTap : function() {
                return false;
              }
            }, {
              text : "确定",
              type : "button-assertive",
              /**
               * @return {undefined}
               */
              onTap : function() {
                self.sendEshopOrderTask(parts);
              }
            }]
          });
        } else {
          dialog.alert({
            template : "<div class='tc'>订单 " + pluginMap.orderSn + " 发货时遇到错误:" + r.content + "</div>",
            okText : "确定"
          });
        }
      }
    }).error(function() {
      loading.hide();
    }).finally(function() {
      loading.hide();
      self.getList();
    });
  };
  /**
   * @param {Element} elem
   * @param {?} event
   * @return {undefined}
   */
  self.sendEshopOrderAct = function(elem, event) {
    if (event) {
      event.stopPropagation();
    }
    var user = {
      orderId : elem.id,
      deliveryType : elem.deliveryType,
      deliveryId : elem.deliveryId ? elem.deliveryId : "",
      deliverySn : elem.deliverySn ? elem.deliverySn : ""
    };
    loading.show();
    _.post(dataAndEvents.esServer + "/KEY329", user).success(function(r) {
      if (1 == r.statusCode) {
        response.toastShow("发货成功！");
        self.getList();
      } else {
        dialog.show({
          template : '<div class="tc">订单 ' + elem.orderSn + " 发货时遇到错误:" + r.content + "</div>",
          scope : self,
          buttons : [{
            text : "确定",
            type : "button-assertive"
          }]
        });
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeBegin = function() {
    $scope.show({
      date : self.queryCondition.beginTime ? new Date(self.queryCondition.beginTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.queryCondition.beginTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeEnd = function() {
    $scope.show({
      date : self.queryCondition.endTime ? new Date(self.queryCondition.endTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.queryCondition.endTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    logEvent().success(function(options) {
      self.items = self.items.concat(options.rows);
      self.initialChecked(self.items);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
      self.orderStatus(self.items);
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("eshopOrderScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.doRefresh = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    logEvent().success(function(data) {
      self.items = data.rows;
      self.initialChecked(self.items);
      /** @type {string} */
      self.selectTiltle = "全选";
      /** @type {Array} */
      self.ordersList = [];
      self.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
      self.orderStatus(self.items);
    }).finally(function() {
      loading.hide();
      parent.resize("eshopOrderScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.searchBuyers = function() {
    self.getList();
  };
  var throttledUpdate = ionic.debounce(self.searchBuyers, 500);
  /**
   * @return {undefined}
   */
  self.searchBuyersByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.searchKey = "";
    /** @type {string} */
    self.focused = "centered";
    self.searchBuyers();
  };
  /**
   * @return {undefined}
   */
  self.focus = function() {
    document.getElementById("searchInput").focus();
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  self.goOrder = function(term) {
    $state.go("eventmenu.eshopOrderEdit", {
      id : term
    });
  };
  self.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("eshopOrderListRefresh")) {
      if (1 == $templateCache.get("eshopOrderListRefresh")) {
        self.getList();
        $templateCache.put("eshopOrderListRefresh", false);
      }
    }
    if (1 == $templateCache.get("refreshOrders")) {
      self.getList();
      /** @type {Array} */
      self.ordersList = [];
      $templateCache.put("refreshOrders", false);
    }
    if ($templateCache.get("eshopOrderStatus")) {
      if (1 == $templateCache.get("eshopOrderStatus")) {
        next(self.ordersList, 1);
        $templateCache.put("eshopOrderStatus", false);
      }
    }
  });
  self.$on("$ionicView.loaded", function() {
    self.getList();
    game.fullPathPostEncode(dataAndEvents.esServer + "/KEY396").success(function(theTitle) {
      self.alleshopName = theTitle;
    });
    fetch().then(function(packs) {
      self.logisticsCompanny = packs[0].data;
    });
  });
  /**
   * @return {undefined}
   */
  self.showActionsheet = function() {
    var scope = {
      buttons : []
    };
    if ("WAIT_SELLER_SEND_GOODS" == self.queryCondition.status) {
      scope.buttons.push({
        text : '<i class="icon ion-ios-paperplane-outline assertive"></i> 发 货'
      });
    }
    scope.buttons.push({
      text : '<i class="icon ion-ios-paper-outline assertive"></i> 转 销 售 单'
    });
    scope.buttons.push({
      text : '<i class="iconfont icon-fun-KEY332 assertive"></i> 打 印 快 递 单'
    });
    scope.buttons.push({
      text : '<i class="icon ion-ios-trash-outline assertive"></i> 删 除'
    });
    /**
     * @param {number} index
     * @return {?}
     */
    scope.buttonClicked = function(index) {
      return scope.buttons[index].text.indexOf("转 销 售 单") > -1 ? self.transToWholesaleOrder() : scope.buttons[index].text.indexOf("打 印 快 递 单") > -1 ? self.logisticsOrdersModal.show() : scope.buttons[index].text.indexOf(" 删 除") > -1 ? self.deleteOrders() : scope.buttons[index].text.indexOf(" 发 货") > -1 && self.sendEshopOrders(), true;
    };
    handler.show(scope);
  };
}]).controller("EshopOrderEditCtrl", ["$scope", "$stateParams", "$http", "$state", "lbScrollDelegate", "psisServices", "BluetoothPrintService", "ServerConfig", "Tools", "lbSpinnerDialog", "$q", "$ionicModal", "$ionicPopover", "$ionicPopup", "lruPersistCache", "$cordovaBarcodeScanner", "$timeout", "$window", function($scope, depMap, $http, $state, widget, field, opts, dataAndEvents, self, loading, _, $modal, FB, dialog,
$templateCache, Hogan, $sanitize) {
  /**
   * @return {?}
   */
  function resolve() {
    var imageDfd = _.defer();
    var langKey = field.httpCacheGet.get(field.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var langName = field.httpCacheGet.get(field.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
    var c = field.httpCacheGet.get(field.httpCacheGet.ac.ALLDELIVERY);
    var d = field.httpCacheGet.getByServer(dataAndEvents.esServer, field.httpCacheGet.ac.ALLECOMMERCEDELIVERY);
    var projectName = field.httpCacheGet.get(field.httpCacheGet.ac.ALLSIZELIST);
    var projectUrl = field.httpCacheGet.get(field.httpCacheGet.ac.ALLCOLORLIST);
    return _.all([langKey, langName, c, d, projectName, projectUrl]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @return {?}
   */
  function update() {
    return $scope.selectedGood.esGood.eshopGoodsMapVO && $scope.selectedGood.esGood.eshopGoodsMapVO.name ? $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsColorName ? $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsSizeName ? (loading.show(), void $http.post(dataAndEvents.esServer + "/KEY420", $scope.selectedGood.esGood.eshopGoodsMapVO).success(function(r) {
      if (1 == r.statusCode) {
        self.toastShow("保存成功！");
        success();
      } else {
        self.toastShow(r.content);
      }
    }).finally(function() {
      loading.hide();
    })) : (self.toastShow("请选择商品的尺码！"), false) : (self.toastShow("请选择商品的颜色！"), false) : (self.toastShow("请选择需要被关联的商品！"), false);
  }
  var depId = depMap.id;
  /** @type {Array} */
  var codeSegments = ["WAIT_BUYER_PAY", "SELLER_CONSIGNED_PART", "WAIT_SELLER_SEND_GOODS", "WAIT_BUYER_CONFIRM_GOODS", "TRADE_BUYER_SIGNED", "TRADE_FINISHED", "TRADE_CLOSED", "TRADE_CLOSED_BY_THIRD_PART"];
  /** @type {Array} */
  var prevSources = ["待付款", "部分发货", "等待卖家发货", "等待买家确认收货", "等待买家签收", "交易成功", "交易关闭", "卖家或买家主动关闭交易"];
  /** @type {Array} */
  var resultItems = ["WAIT_SELLER_AGREE", "WAIT_BUYER_RETURN_GOODS", "WAIT_SELLER_CONFIRM_GOODS", "SELLER_REFUSE_BUYER", "NO_REFUND", "CLOSED", "SUCCESS"];
  /** @type {Array} */
  var groupedSelectors = ["买家已经申请退款，等待卖家同意", "卖家已经同意退款，等待买家退货", "买家已经退货，等待卖家确认收货", "卖家拒绝退款", "未申请退款", "退款关闭", "退款成功"];
  /** @type {Array} */
  var group = [];
  $scope.selectedGood = {
    esGood : {},
    good : {}
  };
  $scope.orderDetail = {
    eshopVO : {},
    eshopSendAddressVO : {},
    eshopAuthVO : {}
  };
  $scope.saleSetting = {
    eshopOrderDeliveryVO : {},
    eshopOrderVO : {}
  };
  $scope.orderInfo = {
    allAccount : {},
    storeHouse : {},
    logisticsCompanny : {}
  };
  $scope.buyersInfo = {
    id : "",
    province : {},
    city : {},
    country : {}
  };
  /** @type {number} */
  $scope.transToWholesaleOrderAvailable = 0;
  $modal.fromTemplateUrl("detailsTransactions.html", function($location) {
    $scope.detailsTransactionsModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("detailsBuyers.html", function($location) {
    /** @type {number} */
    $scope.detailsBuyersModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("sendEsshopOrderEdit.html", function($location) {
    $scope.sendEsShopOrderModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsMapEdit.html", function($location) {
    /** @type {number} */
    $scope.goodsMapEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PStorageStockBill/KEY006.html", function($location) {
    $scope.modal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("storehouse.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.storeHousePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openStoreHousePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.storeHousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideStoreHousePopover = function() {
    $scope.storeHousePopover.hide();
  };
  FB.fromTemplateUrl("KEY293.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY190 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideAccountPopover = function() {
    $scope.KEY190.hide();
  };
  FB.fromTemplateUrl("KEY351.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.deliveryCompanyPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openDeliveryCompanyPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.deliveryCompanyPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideDeliveryCompanyPopover = function() {
    $scope.deliveryCompanyPopover.hide();
  };
  $modal.fromTemplateUrl("provinceSelect.html", function($location) {
    $scope.provinceSelectModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("citySelect.html", function($location) {
    $scope.citySelectModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("countrySelect.html", function($location) {
    $scope.countrySelectModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("goodColors.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.goodColorsPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openGoodColorsPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.goodColorsPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideGoodColorsPopover = function() {
    $scope.goodColorsPopover.hide();
  };
  FB.fromTemplateUrl("goodSizes.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.goodSizesPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openGoodSizesPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.goodSizesPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideGoodSizesPopover = function() {
    $scope.goodSizesPopover.hide();
  };
  $scope.$on("$destroy", function() {
    $scope.detailsTransactionsModal.remove();
    $scope.detailsBuyersModal.remove();
    $scope.sendEsShopOrderModal.remove();
    $scope.modal.remove();
    if ($scope.storeHousePopover) {
      $scope.storeHousePopover.remove();
    }
    if ($scope.KEY190) {
      $scope.KEY190.remove();
    }
    if ($scope.deliveryCompanyPopover) {
      $scope.deliveryCompanyPopover.remove();
    }
    $scope.provinceSelectModal.remove();
    $scope.citySelectModal.remove();
    $scope.countrySelectModal.remove();
    if ($scope.goodsMapEditModal) {
      $scope.goodsMapEditModal.remove();
    }
    if ($scope.goodColorsPopover) {
      $scope.goodColorsPopover.remove();
    }
    if ($scope.goodSizesPopover) {
      $scope.goodSizesPopover.remove();
    }
  });
  /**
   * @return {undefined}
   */
  $scope.scanCode = function() {
    Hogan.scan().then(function(result) {
      if (!result.cancelled) {
        $sanitize(function() {
          $scope.order.eshopOrderDeliveryVO.deliverySn = result.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      self.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.saveOrderSale = function() {
    loading.show();
    $http.post(dataAndEvents.esServer + "/KEY411", {
      eshopOrderDeliveryVO : $scope.order.eshopOrderDeliveryVO ? $scope.order.eshopOrderDeliveryVO : {},
      eshopOrderVO : $scope.order.eshopOrderVO ? $scope.order.eshopOrderVO : {}
    }).success(function(data) {
      if (1 == data.statusCode) {
        /**
         * @return {undefined}
         */
        var complete = function() {
          self.union($scope.order, data.object);
          success();
        };
        if (window.cordova && window.cordova.plugins) {
          self.showAlert("保存成功", complete, "提示", "确认");
        } else {
          dialog.alert({
            template : "<div class='tc'>保存成功</div>",
            okText : "确定"
          }).then(complete);
        }
        $templateCache.put("refreshOrders", true);
      } else {
        if (2 == data.statusCode) {
          if (window.cordova && window.cordova.plugins) {
            self.showAlert("无法保存修改", "确认");
          } else {
            dialog.alert({
              template : "<div class='tc'>无法保存修改</div>",
              okText : "确定"
            });
          }
        } else {
          if (window.cordova && window.cordova.plugins) {
            self.showAlert(data.content, "确认");
          } else {
            dialog.alert({
              template : "<div class='tc'>" + data.content + "</div>",
              okText : "确定"
            });
          }
        }
      }
    }).error(function(a) {
      if (a) {
        if (a.content) {
          self.toastShow(a.content);
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  $scope.saveConsigneeInfo = function() {
    $scope.newEshopOrderConsigneeVO.province = $scope.newEshopOrderConsigneeVO.provinceModale ? $scope.newEshopOrderConsigneeVO.provinceModale.areaName : "";
    $scope.newEshopOrderConsigneeVO.city = $scope.newEshopOrderConsigneeVO.cityModale ? $scope.newEshopOrderConsigneeVO.cityModale.areaName : "";
    $scope.newEshopOrderConsigneeVO.district = $scope.newEshopOrderConsigneeVO.districtModale ? $scope.newEshopOrderConsigneeVO.districtModale.areaName : "";
    loading.show(true);
    $http.post(dataAndEvents.esServer + "/KEY398", $scope.newEshopOrderConsigneeVO).success(function(res) {
      if (1 == res.statusCode) {
        $scope.order.eshopOrderConsigneeVO = res.object;
        if (window.cordova && window.cordova.plugins) {
          self.showAlert("保存成功", "确认");
        } else {
          dialog.alert({
            template : "<div class='tc'>保存成功</div>",
            okText : "确定"
          });
        }
        success();
        $scope.detailsBuyersModal.hide();
      } else {
        if (window.cordova && window.cordova.plugins) {
          self.showAlert("错误:" + res.content, "确认");
        } else {
          dialog.alert({
            template : "<div class='tc'>错误:" + res.content + "</div>",
            okText : "确定"
          }).then(function() {
            $scope.newEshopOrderConsigneeVO = $scope.order.eshopOrderConsigneeVO;
            success();
          });
        }
      }
    }).error(function(a) {
      if (a) {
        if (a.content) {
          self.toastShow(a.content);
        }
      }
      loading.hide();
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  var success = function() {
    loading.show(true);
    resolve().then(function(packs) {
      $scope.allAccount = packs[0].data.rows;
      $scope.storeHouse = packs[1].data;
      $scope.logisticsCompanny = packs[2].data;
      group = packs[3].data.object;
      $scope.allSizes = packs[4].data.rows;
      $scope.allColors = packs[5].data.rows;
      $scope.provinceItems = self.getObjectList(group, "pid", 1);
      /** @type {Array} */
      $scope.cityItems = [];
      /** @type {Array} */
      $scope.countryItems = [];
      field.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/order/eshopOrderGet.ac?id=" + depId).success(function(args) {
        $scope.order = args.object;
        $scope.order.eshopOrderDeliveryVO = args.object && args.object.eshopOrderDeliveryVO ? args.object.eshopOrderDeliveryVO : {};
        /** @type {boolean} */
        $scope.transToWholesaleOrderAvailable = !$scope.order.eshopOrderVO.isTransToWholesaleOrder;
        /** @type {number} */
        var i = 0;
        var ilen = $scope.allAccount.length;
        for (;ilen > i;i++) {
          if ($scope.order.eshopOrderVO.accountId == $scope.allAccount[i].id) {
            $scope.orderInfo.allAccount = $scope.allAccount[i];
            break;
          }
        }
        /** @type {number} */
        i = 0;
        ilen = $scope.storeHouse.length;
        for (;ilen > i;i++) {
          if ($scope.order.eshopOrderVO.storehouseId == $scope.storeHouse[i].id) {
            $scope.orderInfo.storeHouse = $scope.storeHouse[i];
            break;
          }
        }
        /** @type {number} */
        i = 0;
        ilen = $scope.logisticsCompanny.length;
        for (;ilen > i;i++) {
          if (null != $scope.logisticsCompanny[i].kdnCode && (null != $scope.order.eshopOrderDeliveryVO && $scope.order.eshopOrderDeliveryVO.deliveryId == $scope.logisticsCompanny[i].id)) {
            $scope.orderInfo.logisticsCompanny = $scope.logisticsCompanny[i];
            break;
          }
        }
        var options = $scope.order.eshopOrderConsigneeVO;
        if ($scope.newEshopOrderConsigneeVO = $scope.order.eshopOrderConsigneeVO, options && (options.province && ($scope.newEshopOrderConsigneeVO.provinceModale = self.fnCheckGtoreQty($scope.provinceItems, "areaName", options.province)), options.city)) {
          var name = self.getObjectList(group, "pid", $scope.newEshopOrderConsigneeVO.provinceModale.id);
          if ($scope.newEshopOrderConsigneeVO.cityModale = self.fnCheckGtoreQty(name, "areaName", options.city), options.district) {
            var m = self.getObjectList(group, "pid", $scope.newEshopOrderConsigneeVO.cityModale.id);
            $scope.newEshopOrderConsigneeVO.districtModale = self.fnCheckGtoreQty(m, "areaName", options.district);
          }
        }
        /** @type {number} */
        $scope.order.allQuantity = 0;
        /** @type {number} */
        $scope.order.total = 0;
        /** @type {number} */
        i = 0;
        for (;i < $scope.order.eshopOrderDtVOList.length;i++) {
          $scope.order.allQuantity += $scope.order.eshopOrderDtVOList[i].quantity;
          $scope.order.total += $scope.order.eshopOrderDtVOList[i].trueAmount;
        }
        $scope.order.total += $scope.order.eshopOrderOlVO.postFee;
        /**
         * @param {string} opt_attributes
         * @return {?}
         */
        $scope.orderStatus = function(opt_attributes) {
          /** @type {number} */
          var i = 0;
          for (;i <= codeSegments.length;i++) {
            if (opt_attributes === codeSegments[i]) {
              return $scope.order.orderStatus = prevSources[i];
            }
          }
        };
        $scope.orderStatus($scope.order.eshopOrderVO.status);
        /**
         * @param {Array} b
         * @return {?}
         */
        $scope.refundStatus = function(b) {
          /** @type {number} */
          $scope.order.refundFlag = 0;
          /** @type {number} */
          var bi = 0;
          for (;bi < b.length;bi++) {
            if ("NO_REFUND" !== b[bi].thirdOrderRefundStatus) {
              /** @type {number} */
              var i = 0;
              for (;i <= resultItems.length;i++) {
                if (b[bi].thirdOrderRefundStatus === resultItems[i]) {
                  return $scope.order.refundFlag += 1, $scope.order.eshopOrderDtVOList[bi].RefundStatus = groupedSelectors[i];
                }
              }
            }
          }
        };
        $scope.refundStatus($scope.order.eshopOrderDtVOList);
        if ($scope.order.eshopOrderConsigneeVO.province) {
          $scope.order.address = $scope.order.eshopOrderConsigneeVO.province;
        }
        if ($scope.order.eshopOrderConsigneeVO.city) {
          $scope.order.address += $scope.order.eshopOrderConsigneeVO.city;
        }
        if ($scope.order.eshopOrderConsigneeVO.district) {
          $scope.order.address += $scope.order.eshopOrderConsigneeVO.district;
        }
        if ($scope.order.eshopOrderConsigneeVO.address) {
          $scope.order.address += $scope.order.eshopOrderConsigneeVO.address;
        }
        if ($scope.transFlag) {
          promote();
          /** @type {boolean} */
          $scope.transFlag = false;
        }
        if ($scope.order.eshopOrderDeliveryVO && 1 == $scope.order.eshopOrderDeliveryVO.deliveryType) {
          /** @type {boolean} */
          $scope.orderInfo.sendEshopOrderTypeOne = true;
          /** @type {boolean} */
          $scope.orderInfo.sendEshopOrderTypeTwo = false;
        } else {
          /** @type {boolean} */
          $scope.orderInfo.sendEshopOrderTypeTwo = true;
          /** @type {boolean} */
          $scope.orderInfo.sendEshopOrderTypeOne = false;
        }
      }).error(function() {
        loading.hide();
      }).finally(function() {
        loading.hide();
        widget.resize("eshopOrderScroll");
      }).then(function() {
        $scope.$watch("newEshopOrderConsigneeVO.provinceModale", function() {
          if (self.isEmpty($scope.newEshopOrderConsigneeVO.provinceModale)) {
            /** @type {Array} */
            $scope.cityItems = [];
            /** @type {Array} */
            $scope.countryItems = [];
          } else {
            $scope.cityItems = self.getObjectList(group, "pid", $scope.newEshopOrderConsigneeVO.provinceModale.id);
            /** @type {Array} */
            $scope.countryItems = [];
          }
        });
        $scope.$watch("newEshopOrderConsigneeVO.cityModale", function() {
          $scope.countryItems = self.isEmpty($scope.newEshopOrderConsigneeVO.cityModale) ? [] : self.getObjectList(group, "pid", $scope.newEshopOrderConsigneeVO.cityModale.id);
        });
        $scope.$watch("orderInfo.sendEshopOrderTypeOne", function() {
          if ($scope.orderInfo.sendEshopOrderTypeOne) {
            /** @type {boolean} */
            $scope.orderInfo.sendEshopOrderTypeTwo = false;
            /** @type {number} */
            $scope.order.eshopOrderDeliveryVO.deliveryType = 1;
          } else {
            if (!$scope.orderInfo.sendEshopOrderTypeOne) {
              /** @type {boolean} */
              $scope.orderInfo.sendEshopOrderTypeTwo = true;
              /** @type {number} */
              $scope.order.eshopOrderDeliveryVO.deliveryType = 4;
            }
          }
        });
        $scope.$watch("orderInfo.sendEshopOrderTypeTwo", function() {
          if ($scope.orderInfo.sendEshopOrderTypeTwo) {
            /** @type {boolean} */
            $scope.orderInfo.sendEshopOrderTypeOne = false;
            /** @type {number} */
            $scope.order.eshopOrderDeliveryVO.deliveryType = 4;
          } else {
            if (!$scope.orderInfo.sendEshopOrderTypeTwo) {
              /** @type {boolean} */
              $scope.orderInfo.sendEshopOrderTypeOne = true;
              /** @type {number} */
              $scope.order.eshopOrderDeliveryVO.deliveryType = 1;
            }
          }
        });
      });
    }, function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  var promote = function() {
    /** @type {number} */
    var completed = 0;
    /** @type {number} */
    var conditionIndex = 0;
    for (;conditionIndex < $scope.order.eshopOrderDtVOList.length;conditionIndex++) {
      if (null != $scope.order.eshopOrderDtVOList[conditionIndex].eshopGoodsMapVO) {
        completed += 1;
      }
    }
    if (completed === $scope.order.eshopOrderDtVOList.length) {
      $scope.showConfirm();
    } else {
      $scope.alertConfirm();
    }
  };
  /**
   * @return {undefined}
   */
  $scope.transToWholesaleOrder = function() {
    /** @type {boolean} */
    $scope.transFlag = true;
    success();
  };
  /**
   * @return {undefined}
   */
  $scope.showConfirm = function() {
    dialog.show({
      template : "<div>您要将选中的订单转为销售单吗？</div>",
      scope : $scope,
      buttons : [{
        text : "取消"
      }, {
        text : "确定",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          loading.show(true);
          field.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/order/transToWholesaleOrder.ac?id=" + $scope.order.eshopOrderVO.id).success(function(r) {
            if (0 == r.statusCode && dialog.show({
              template : '<div class="tc">订单 ' + $scope.order.eshopOrderVO.orderSn + " 转销售单时遇到错误:" + r.content + "</div>",
              scope : $scope,
              buttons : [{
                text : "确定",
                type : "button-assertive"
              }]
            }), 1 == r.statusCode) {
              $templateCache.put("refreshOrders", true);
              /**
               * @return {undefined}
               */
              var after = function() {
                $state.go("eventmenu.taoBaoOrderList", {
                  orderId : depId
                });
              };
              if (window.cordova && window.cordova.plugins) {
                self.showAlert("转销售单成功", after, "提示", "确认");
              } else {
                dialog.alert({
                  template : "<div class='tc'>转销售单成功</div>",
                  okText : "确定"
                }).then(after);
              }
            }
          }).error(function() {
            loading.hide();
          }).finally(function() {
            loading.hide();
          });
        }
      }]
    });
  };
  /**
   * @return {undefined}
   */
  $scope.alertConfirm = function() {
    dialog.show({
      template : '<div class="tc">您还有商品尚未关联内部商品，不能转换为销售单</div><div class="tc">请在【交易明细】中关联内部商品后重试!</div>',
      scope : $scope,
      buttons : [{
        text : "确定",
        type : "button-assertive"
      }]
    });
  };
  /**
   * @return {undefined}
   */
  $scope.printExpressOrder = function() {
    dialog.show({
      template : '<div class="tc">您要打印快递单吗？</div>',
      scope : $scope,
      buttons : [{
        text : "取消"
      }, {
        text : "确定",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          opts.bluetooth($scope.order.eshopOrderVO.orderSn, opts.orderType.logisticsOrder);
        }
      }]
    });
  };
  /**
   * @return {?}
   */
  $scope.sendEshopOrderAct = function() {
    if (("" == $scope.order.eshopOrderDeliveryVO.deliverySn || null == $scope.order.eshopOrderDeliveryVO.deliverySn) && 4 == $scope.order.eshopOrderDeliveryVO.deliveryType) {
      return self.toastShow("物流单号不能为空！"), false;
    }
    var customer = {
      orderId : $scope.order.eshopOrderVO.id,
      deliveryType : $scope.order.eshopOrderDeliveryVO.deliveryType,
      deliveryId : $scope.orderInfo.logisticsCompanny.id ? $scope.orderInfo.logisticsCompanny.id : "",
      deliverySn : $scope.order.eshopOrderDeliveryVO.deliverySn ? $scope.order.eshopOrderDeliveryVO.deliverySn : ""
    };
    loading.show();
    $http.post(dataAndEvents.esServer + "/KEY329", customer).success(function(r) {
      if (1 == r.statusCode) {
        self.toastShow("发货成功！");
        success();
        $scope.goBack();
      } else {
        dialog.show({
          template : '<div class="tc">订单 ' + $scope.order.eshopOrderVO.orderSn + " 发货时遇到错误:" + r.content + "</div>",
          scope : $scope,
          buttons : [{
            text : "确定",
            type : "button-assertive"
          }]
        });
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  $scope.getGoodsInfo = function(dataAndEvents) {
    $scope.goodsMapEditModal.show();
    $scope.selectedGood.esGood = dataAndEvents;
    $scope.selectedGood.id = $scope.order.eshopOrderVO.eshopId;
    if (dataAndEvents.eshopGoodsMapVO) {
      if (dataAndEvents.eshopGoodsMapVO.goodsSn) {
        loading.show();
        field.postEncode("/admin/inner/goods/goodsGetJsonBySn.ac?goodsSn=" + dataAndEvents.eshopGoodsMapVO.goodsSn).success(function(store) {
          angular.extend($scope.selectedGood, {
            currentColors : self.idStringToObjectArray($scope.allColors, store.colorIds, "id", ","),
            currentSizes : self.idStringToObjectArray($scope.allSizes, store.sizeIds, "id", ",")
          });
        }).finally(function() {
          loading.hide();
        });
      }
    }
  };
  var throttledUpdate = ionic.debounce(update, 500, true);
  /**
   * @return {undefined}
   */
  $scope.saveGoodsMapAction = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  $scope.eshopOrderDelete = function() {
    dialog.show({
      template : '<div class="tc">您确定要删除该订单吗?</div>',
      scope : $scope,
      buttons : [{
        text : "取消"
      }, {
        text : "确定",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          loading.show();
          field.fullPathPostEncode(dataAndEvents.esServer + "/KEY454?id=" + $scope.order.eshopOrderVO.id).success(function(r) {
            if (1 == r.statusCode) {
              dialog.alert({
                template : "<div class='tc'>删除订单成功</div>",
                okText : "确定"
              }).then(function() {
                $templateCache.put("refreshOrders", true);
                $scope.goBack();
              });
            }
          }).error(function() {
          }).finally(function() {
            loading.hide();
          });
        }
      }]
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    success();
  });
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshOrders")) {
      success();
      $templateCache.put("refreshOrders", false);
    }
  });
}]).controller("EcDownloadCtrl", ["$scope", "$stateParams", "$http", "$state", "lbScrollDelegate", "psisServices", "BluetoothPrintService", "ServerConfig", "Tools", "lbSpinnerDialog", "$q", "$ionicModal", "$ionicPopover", "$ionicPopup", "lruPersistCache", "$cordovaBarcodeScanner", "$timeout", "$cordovaDatePicker", function($scope, deepDataAndEvents, ignoreMethodDoesntExist, textAlt, keepData, jQuery, opt_attributes, dataAndEvents, self, loading, matcherFunction, execResult, FB,
dialog, $templateCache, opt_keys, positionError, scope) {
  /**
   * @param {Array} codeSegments
   * @param {string} dataObject
   * @param {Object} num
   * @return {undefined}
   */
  function generateList(codeSegments, dataObject, num) {
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      if (codeSegments[i].eshopVO.shopType == dataObject) {
        /** @type {Object} */
        codeSegments[i].eshopVO.shopType = num;
      }
    }
  }
  $scope.downloadVO = {};
  /** @type {Date} */
  var checkDate = new Date;
  var beginTime = (new Date).setDate(checkDate.getDate() - 6);
  $scope.downloadVO.beginTime = beginTime;
  /** @type {number} */
  $scope.downloadVO.endTime = checkDate.getTime();
  FB.fromTemplateUrl("eshopNamePopover.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.eshopNamePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openEshopPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.eshopNamePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideEshopPopover = function() {
    $scope.eshopNamePopover.hide();
  };
  $scope.$on("$destroy", function() {
    if ($scope.eshopNamePopover) {
      $scope.eshopNamePopover.remove();
    }
  });
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : $scope.downloadVO.beginTime ? new Date($scope.downloadVO.beginTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.downloadVO.beginTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : $scope.downloadVO.endTime ? new Date($scope.downloadVO.endTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.downloadVO.endTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.syncEshopOrder = function() {
    var data = $scope.downloadVO.eshopId ? $scope.downloadVO.eshopId : "";
    loading.show(true);
    jQuery.fullPathPostEncode(dataAndEvents.esServer + "/admin/ecommerce/order/syncEshopOrder.ac?eshopId=" + data).success(function(res) {
      if (1 === res.statusCode) {
        /** @type {boolean} */
        $scope.showDataCards = true;
        console.log(res.object.lstResult);
        $scope.downloadDatas = res.object.lstResult;
        $templateCache.put("eshopOrderListRefresh", true);
        generateList($scope.downloadDatas, "taobao", "淘宝");
      } else {
        self.toastShow(res.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {?}
   */
  $scope.downloadEshopOrder = function() {
    return $scope.downloadVO.beginTime && ($scope.downloadVO.endTime && $scope.downloadVO.beginTime > $scope.downloadVO.endTime) ? (self.toastShow("起始日期不能比结束日期大，请您重新调整查询日期之后再查询!"), false) : self.isInDays($scope.downloadVO.beginTime, $scope.downloadVO.endTime, 30) ? void $scope.showConfirm() : (self.toastShow("起始日期和结束日期之间的时间间隔不能大于30天，请您重新调整查询日期之后再查询!"),
    false);
  };
  /**
   * @return {undefined}
   */
  $scope.showConfirm = function() {
    var data = {
      eshopId : $scope.downloadVO.eshopId ? $scope.downloadVO.eshopId : "",
      payTimeBegin : self.getDayBeginStr($scope.downloadVO.beginTime),
      payTimeEnd : self.getOffsetDayBeginStr($scope.downloadVO.endTime, 1)
    };
    dialog.show({
      template : "<div>即将下载网店中时间段内所有的订单，可能时间稍久，是否继续？</div>",
      scope : $scope,
      buttons : [{
        text : "取消"
      }, {
        text : "确定",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          loading.show(true);
          jQuery.fullPathPostEncode(dataAndEvents.esServer + "/KEY384", data).success(function(res) {
            if (1 === res.statusCode) {
              /** @type {boolean} */
              $scope.showDataCards = true;
              console.log(res.object.lstResult);
              $scope.downloadDatas = res.object.lstResult;
              $templateCache.put("eshopOrderListRefresh", true);
              generateList($scope.downloadDatas, "taobao", "淘宝");
            } else {
              self.toastShow(res.content);
            }
          }).finally(function() {
            loading.hide();
          });
        }
      }]
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    jQuery.fullPathPostEncode(dataAndEvents.esServer + "/KEY396").success(function($location) {
      $scope.alleshopName = $location;
    });
  });
  $scope.$on("$ionicView.beforeLeave", function() {
    /** @type {boolean} */
    $scope.showDataCards = false;
  });
}]);
