angular.module("filters", []).filter("lbCurrency", ["$filter", function($sanitize) {
  return function(stmt, data) {
    var make = $sanitize("currency");
    return 0 > stmt ? make(stmt, data).replace("(" + data, data + "- ").replace(")", "") : make(stmt, data);
  };
}]).filter("lbCurrencyPlus", ["$filter", function(Vector) {
  return function(delta, a) {
    var scroll = Vector("currency");
    return 0 > delta ? "- " + scroll(-delta, a) : delta > 0 ? "+ " + scroll(delta, a) : scroll(delta, a);
  };
}]).filter("typeFormat", ["Tools", function(data_priv) {
  /**
   * @param {string} data
   * @param {?} elem
   * @param {string} type
   * @param {string} name
   * @return {?}
   */
  var get = function(data, elem, type, name) {
    if (void 0 != data) {
      type = type || "val";
      name = name || "text";
      var queue = data_priv.fnCheckGtoreQty(elem, type, data);
      /** @type {string} */
      var shape = "";
      return void 0 != queue && (shape = queue[name]), shape;
    }
    return data;
  };
  return get;
}]).filter("objToArray", function() {
  return function(results, dataAndEvents) {
    return results instanceof Object ? dataAndEvents === false ? Object.values(results) : Object.keys(results).map(function(file) {
      return Object.defineProperty(results[file], "$key", {
        enumerable : false,
        value : file
      });
    }) : results;
  };
}).filter("filterAmountTenThousand", ["$filter", function($sanitize) {
  return function(code, data) {
    if (void 0 != code) {
      var unescape = $sanitize("currency");
      if (Math.abs(code) < 1E5) {
        return unescape(code, data).replace("(" + data, data + "- ").replace(")", "");
      }
      if (Math.abs(code) < 1E8) {
        /** @type {number} */
        var html = code / 1E4;
        return unescape(html, data).replace("(" + data, data + "- ").replace(")", "") + "万";
      }
      /** @type {number} */
      html = code / 1E8;
      return unescape(html, data).replace("(" + data, data + "- ").replace(")", "") + "亿";
    }
  };
}]);
