angular.module("financeController", ["ionic", "services", "tools"]).controller("AccountFinanceListCtrl", ["$scope", "psisServices", "$state", "$stateParams", "Tools", "lbSpinnerDialog", "lruPersistCache", "$cordovaDatePicker", "lbScrollDelegate", "$ionicModal", "$ionicPopover", "$q", "$ionicPopup", function($scope, that, navigation, params, _, loading, $templateCache, scope, parent, $modal, FB, $q, view) {
  /**
   * @return {?}
   */
  function init() {
    if ($scope.record.inAmount < 0 || ($scope.record.outAmount < 0 || $scope.fixedInputNumber($scope.record.inAmount) + $scope.fixedInputNumber($scope.record.outAmount) == 0)) {
      return view.alert({
        template : "<div class='tc'>金额不允许小于0</div>",
        okText : "确定"
      }), false;
    }
    if ($scope.record.balance + $scope.record.inAmount + $scope.record.outAmount > 9.999999999E7) {
      return view.alert({
        template : "<div class='tc'>输入金额超出限制</div>",
        okText : "确定"
      }), false;
    }
    if (void 0 == $scope.record.KEY293) {
      return _.toastShow("请选择账户"), false;
    }
    if ($scope.record.createTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date($scope.record.createTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      $scope.record.createTime = midnight.getTime();
    }
    loading.show(true);
    /** @type {boolean} */
    $scope.uncommitable = true;
    that.post("/KEY021", {
      inAmount : $scope.fixedInputNumber($scope.record.inAmount),
      outAmount : $scope.fixedInputNumber($scope.record.outAmount),
      accountId : $scope.record.KEY293.id,
      businessItem : $scope.record.accountItem.id,
      createTime : $scope.record.createTime,
      remark : $scope.record.remark
    }).success(function(res) {
      if (1 == res.statusCode) {
        _.toastShow("成功记了一笔！");
        $scope.setReceiptBalances();
        if ($scope.initObject.KEY293) {
          if ($scope.initObject.KEY293.val == $scope.record.KEY293.val) {
            run($scope.initObject.KEY293.val);
          }
        }
        $scope.getList(true);
        /** @type {string} */
        $scope.record.remark = "";
        $scope.clientReceiptEditModal.hide();
      } else {
        _.toastShow(res.content);
      }
    }).finally(function() {
      parent.scrollTop("accountFinanceRecordCtrlScroll");
      /** @type {boolean} */
      $scope.uncommitable = false;
      loading.hide();
    });
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNT);
    var getPromise3 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @return {undefined}
   */
  function poll() {
    fetch().then(function(packs) {
      if ($scope.allAccounts = packs[0].data.rows, params.accountId) {
        /** @type {number} */
        var i = 0;
        for (;i < $scope.allAccounts.length;i++) {
          if ($scope.allAccounts[i].id == params.accountId) {
            $scope.record.accountCondition = $scope.allAccounts[i];
            break;
          }
        }
      }
      $scope.record.KEY293 = $scope.allAccounts[0];
      /** @type {Array} */
      $scope.allConditionAccountItems = [];
      _.union($scope.allConditionAccountItems, packs[1].data.rows);
      $scope.allAccountItems = packs[1].data.rows;
      /** @type {number} */
      i = 0;
      for (;i < $scope.allAccountItems.length;i++) {
        if (0 == $scope.allAccountItems[i].isEnable || (1 == $scope.allAccountItems[i].id || (10 == $scope.allAccountItems[i].id || 5 == $scope.allAccountItems[i].id))) {
          $scope.allAccountItems.splice(i, 1);
          i--;
        }
      }
      $scope.record.accountItem = $scope.allAccountItems[0];
      $scope.setReceiptBalances();
      /** @type {number} */
      $scope.record.createTime = (new Date).getTime();
    });
    $scope.getList();
  }
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.KEY349 = {};
  /** @type {Date} */
  var midnight = new Date;
  midnight.setHours(0, 0, 0, 0);
  /** @type {number} */
  var createTimeBegin = midnight.getTime();
  $scope.recordCondition = {
    createTimeBegin : params.createTimeBegin ? params.createTimeBegin : createTimeBegin,
    createTimeEnd : params.createTimeEnd ? params.createTimeEnd : (new Date).getTime(),
    KEY293 : {},
    page : 1
  };
  $scope.record = {
    balance : 0
  };
  /** @type {boolean} */
  $scope.uncommitable = false;
  $scope.initObject = {
    KEY293 : {},
    initAmount : "",
    initTime : (new Date).getTime(),
    initRemark : ""
  };
  /**
   * @param {Object} record
   * @return {undefined}
   */
  $scope.showDetail = function(record) {
    var currentTransition = {
      accountId : record ? record.accountId : _.isEmpty($scope.recordCondition.KEY293) ? null : $scope.recordCondition.KEY293.id,
      accountName : record ? record.accountName : null,
      createTimeBegin : $scope.recordCondition.createTimeBegin,
      createTimeEnd : $scope.recordCondition.createTimeEnd
    };
    navigation.go("eventmenu.KEY072", currentTransition);
  };
  $modal.fromTemplateUrl("accountFilter.html", function($location) {
    $scope.accountFilterModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PAccountManage/KEY121.html", function($location) {
    $scope.clientReceiptEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY190 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideAccountPopover = function() {
    $scope.KEY190.hide();
  };
  FB.fromTemplateUrl("accountFinancePopover.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.accountFinancePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountFinancePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.accountFinancePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideAccountFinancePopover = function() {
    $scope.accountFinancePopover.hide();
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY119 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.clearFilter = function() {
    $scope.recordCondition.createTimeBegin = params.createTimeBegin ? params.createTimeBegin : createTimeBegin;
    $scope.recordCondition.createTimeEnd = params.createTimeEnd ? params.createTimeEnd : (new Date).getTime();
    $scope.recordCondition.KEY293 = {};
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTime = function() {
    scope.show({
      date : new Date($scope.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.record.createTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : new Date($scope.recordCondition.createTimeBegin),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.createTimeBegin = date1.getTime();
        $scope.searchRecord();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : new Date($scope.recordCondition.createTimeEnd),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.createTimeEnd = date1.getTime();
        $scope.searchRecord();
      }
    });
  };
  $scope.$watch("record.KEY293", function() {
    if ($scope.record.KEY293 && $scope.record.KEY293.id) {
      var balance = _.fnCheckGtoreQty($scope.allAccountBalance, "accountId", $scope.record.KEY293.id);
      $scope.record.balance = balance ? balance.balance : 0;
    }
  });
  /**
   * @param {?} v
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  $scope.fixedInputNumber = function(v, dataAndEvents) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{2})[0-9]*/;
    return v ? v > 0 && 1E-7 >= v || 0 > v && v >= -1E-7 ? 0 : parseFloat(("" + parseFloat(v)).replace(r20, "$1")) : dataAndEvents && 0 != v ? "" : 0;
  };
  var dereg = ionic.debounce(init, 500, true);
  /**
   * @return {undefined}
   */
  $scope.confirmReceiptAction = function() {
    dereg();
  };
  /**
   * @param {string} id
   * @return {undefined}
   */
  var run = function(id) {
    that.post("/KEY016?accountId=" + id).success(function(obj) {
      if (null != obj.object) {
        $scope.initObject.balance = obj.object.balance;
        $scope.initObject.initAmount = obj.object.initAmount;
        $scope.initObject.initTime = obj.object.initTime ? obj.object.initTime : (new Date).getTime();
        $scope.initObject.initRemark = obj.object.initRemark;
      }
    });
  };
  $scope.$watch("[initObject.KEY293]", function(a) {
    if (a[0].val > 0) {
      run(a[0].val);
    }
  }, true);
  $scope.$on("$destroy", function() {
    $scope.accountFilterModal.remove();
    $scope.KEY190.remove();
    $scope.accountFinancePopover.remove();
    $scope.clientReceiptEditModal.remove();
    $scope.KEY119.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.setReceiptBalances = function() {
    that.post("/KEY006").success(function($location) {
      if ($scope.allAccountBalance = $location, $scope.record.KEY293 && $scope.record.KEY293.id) {
        var balance = _.fnCheckGtoreQty($scope.allAccountBalance, "accountId", $scope.record.KEY293.id);
        $scope.record.balance = balance ? balance.balance : 0;
      }
    });
  };
  /**
   * @return {?}
   */
  var update = function() {
    var attributes = {
      createTimeBegin : $scope.recordCondition.createTimeBegin ? _.getDayBeginStr($scope.recordCondition.createTimeBegin) : "",
      createTimeEnd : $scope.recordCondition.createTimeEnd ? _.getOffsetDayBeginStr($scope.recordCondition.createTimeEnd, 1) : "",
      accountId : $scope.recordCondition.KEY293.id ? $scope.recordCondition.KEY293.id : "",
      page : $scope.recordCondition.page
    };
    return attributes.createTimeBegin || delete attributes.createTimeBegin, attributes.createTimeEnd || delete attributes.createTimeEnd, attributes.accountId || delete attributes.accountId, that.postEncode("/KEY019", attributes);
  };
  /**
   * @param {number} recurring
   * @return {undefined}
   */
  $scope.getList = function(recurring) {
    if (!recurring) {
      /** @type {number} */
      $scope.recordCondition.page = 1;
      /** @type {boolean} */
      $scope.loadMoreBtn = false;
    }
    loading.show(true);
    update().success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      if (!recurring) {
        parent.scrollTop("accountFinanceCtrlScroll");
      }
      loading.hide();
      /** @type {boolean} */
      $scope.isLoading = false;
    });
    that.post("/KEY018", {
      createTimeBegin : _.getDayBegin($scope.recordCondition.createTimeBegin),
      createTimeEnd : _.getOffsetDayBegin($scope.recordCondition.createTimeEnd, 1),
      accountId : $scope.recordCondition.KEY293.id
    }).success(function(res) {
      if (1 == res.statusCode) {
        $scope.KEY349.totalOutAmount = res.object.outAmountSum;
        $scope.KEY349.totalInAmount = res.object.inAmountSum;
        $scope.KEY349.banlanceAmountSum = res.object.banlanceAmountSum;
      } else {
        _.toastShow(res.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("addReceiptFlag")) {
      if ($templateCache.get("addReceiptFlag") === true) {
        $scope.getList(true);
        $templateCache.put("addReceiptFlag", false);
      }
    }
  });
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    loading.show(true);
    $scope.recordCondition.page++;
    update().success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("accountFinanceCtrlScroll");
      loading.hide();
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    poll();
  });
  $scope.$on("$ionicView.afterEnter", function() {
    if (1 == $templateCache.get("accountFinanceListRefresh")) {
      poll();
      $templateCache.put("accountFinanceListRefresh", false);
    }
  });
}]).controller("AccountFinanceRecordCtrl", ["$scope", "psisServices", "$state", "$stateParams", "Tools", "lbSpinnerDialog", "pageDetail", "lruPersistCache", "$ionicModal", "$ionicPopover", "$q", "$cordovaDatePicker", "$ionicPopup", "lbScrollDelegate", function($scope, that, $state, params, self, loading, model, $templateCache, $modal, FB, $q, scope, _, $window) {
  /**
   * @return {?}
   */
  function init() {
    if ($scope.record.inAmount < 0 || ($scope.record.outAmount < 0 || $scope.fixedInputNumber($scope.record.inAmount) + $scope.fixedInputNumber($scope.record.outAmount) == 0)) {
      return _.alert({
        template : "<div class='tc'>金额不允许小于0</div>",
        okText : "确定"
      }), false;
    }
    if ($scope.record.balance + $scope.record.inAmount + $scope.record.outAmount > 9.999999999E7) {
      return _.alert({
        template : "<div class='tc'>输入金额超出限制</div>",
        okText : "确定"
      }), false;
    }
    if (void 0 == $scope.record.KEY293) {
      return self.toastShow("请选择账户"), false;
    }
    if ($scope.record.createTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date($scope.record.createTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      $scope.record.createTime = midnight.getTime();
    }
    loading.show(true);
    /** @type {boolean} */
    $scope.uncommitable = true;
    that.post("/KEY021", {
      inAmount : $scope.fixedInputNumber($scope.record.inAmount),
      outAmount : $scope.fixedInputNumber($scope.record.outAmount),
      accountId : $scope.record.KEY293.id,
      businessItem : $scope.record.accountItem.id,
      createTime : $scope.record.createTime,
      remark : $scope.record.remark
    }).success(function(r) {
      if (1 == r.statusCode) {
        self.toastShow("成功记了一笔！");
        $scope.setReceiptBalances();
        if ($scope.initObject.KEY293) {
          if ($scope.initObject.KEY293.val == $scope.record.KEY293.val) {
            run($scope.initObject.KEY293.val);
          }
        }
        $scope.getList();
        /** @type {string} */
        $scope.record.remark = "";
        $scope.clientReceiptEditModal.hide();
        $templateCache.put("addReceiptFlag", true);
      } else {
        self.toastShow(r.content);
      }
    }).finally(function() {
      $window.scrollTop("accountFinanceRecordCtrlScroll");
      /** @type {boolean} */
      $scope.uncommitable = false;
      loading.hide();
    });
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNT);
    var getPromise3 = that.httpCacheGet.get(that.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  var triangles = (new Date).setDate((new Date).getDate() - 6);
  $scope.recordCondition = {
    createTimeBegin : params.createTimeBegin ? params.createTimeBegin : triangles,
    createTimeEnd : params.createTimeEnd ? params.createTimeEnd : (new Date).getTime(),
    accountId : params.accountId ? params.accountId : "",
    accountName : params.accountName ? params.accountName : ""
  };
  $scope.record = {
    balance : 0
  };
  /** @type {boolean} */
  $scope.uncommitable = false;
  $scope.initObject = {
    KEY293 : {},
    initAmount : "",
    initTime : (new Date).getTime(),
    initRemark : ""
  };
  /**
   * @return {undefined}
   */
  $scope.goAccountList = function() {
    $state.go("eventmenu.KEY238", {});
  };
  $modal.fromTemplateUrl("html/PAccountManage/KEY121.html", function($location) {
    $scope.clientReceiptEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY190 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("accountPopover_condition.html", {
    scope : $scope
  }).then(function($location) {
    $scope.accountConditionPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountConditionPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.accountConditionPopover.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY119 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("accountItemPopover_condition.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.accountItemConditionPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountItemConditionPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.accountItemConditionPopover.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("accountInitOperation.html", {
    scope : $scope
  }).then(function($location) {
    $scope.accountInitOperationPopover = $location;
  });
  $modal.fromTemplateUrl("html/PAccountManage/KEY157.html", function($location) {
    /** @type {number} */
    $scope.accountInitEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("accountPopover_init.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.accountInitPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountInitPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.accountInitPopover.show(expectedNumberOfNonCommentArgs);
  };
  $scope.$on("$destroy", function() {
    $scope.KEY190.remove();
    $scope.KEY119.remove();
    $scope.accountConditionPopover.remove();
    $scope.accountItemConditionPopover.remove();
    $scope.accountInitOperationPopover.remove();
    $scope.accountInitEditModal.remove();
    $scope.accountInitPopover.remove();
  });
  /**
   * @param {string} res
   * @return {?}
   */
  $scope.getOrderType = function(res) {
    return res.businessSn && res.businessSn.indexOf("JZ") > -1 ? 10 == res.businessItem ? res.inAmount > 0 ? "账户转入" : "账户转出" : res.inAmount - res.outAmount > 0 ? "收入记账" : "支出记账" : model.getOrderType(res.businessSn);
  };
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  $scope.getPayType = function(dataAndEvents) {
    return "cash" == dataAndEvents ? "[现金收款]" : "alipayBarPay" == dataAndEvents ? "[支付宝收款]" : "wxpayScanPay" == dataAndEvents ? "[微信收款]" : "wxpayPub" == dataAndEvents ? "[微信在线收款]" : null;
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTime = function() {
    scope.show({
      date : new Date($scope.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.record.createTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : new Date($scope.recordCondition.createTimeBegin),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.createTimeBegin = date1.getTime();
        $scope.searchRecord();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : new Date($scope.recordCondition.createTimeEnd),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.createTimeEnd = date1.getTime();
        $scope.searchRecord();
      }
    });
  };
  /**
   * @param {?} data
   * @return {?}
   */
  $scope.getFinanceRecordDetail = function(data) {
    return data.businessSn.indexOf("JZ") >= 0 && 1 == data.businessItem ? false : "alipayBarPay" == data.payType || "wxpayScanPay" == data.payType ? (self.toastShow("暂不支持修改扫码收款的交易"), console.log("暂不支持修改扫码收款的交易"), false) : "wxpayPub" == data.payType ? (self.toastShow("暂不支持修改微信在线收款的交易"),
    console.log("暂不支持修改微信在线收款的交易"), false) : void(data.businessSn && (data.businessSn.indexOf("FK") >= 0 || (data.businessSn.indexOf("SK") >= 0 || data.businessSn.indexOf("JZ") >= 0)) ? $state.go("eventmenu.KEY084", {
      item : data
    }) : $scope.gotoDetail(data.businessItem, data.businessSn));
  };
  /**
   * @return {undefined}
   */
  $scope.searchRecord = function() {
    $scope.getList();
  };
  /**
   * @return {undefined}
   */
  $scope.setReceiptBalances = function() {
    that.post("/KEY006").success(function($location) {
      if ($scope.allAccountBalance = $location, $scope.record.KEY293 && $scope.record.KEY293.id) {
        var balance = self.fnCheckGtoreQty($scope.allAccountBalance, "accountId", $scope.record.KEY293.id);
        $scope.record.balance = balance ? balance.balance : 0;
      }
    });
  };
  $scope.$watch("record.KEY293", function() {
    if ($scope.record.KEY293 && $scope.record.KEY293.id) {
      var balance = self.fnCheckGtoreQty($scope.allAccountBalance, "accountId", $scope.record.KEY293.id);
      $scope.record.balance = balance ? balance.balance : 0;
    }
  });
  /**
   * @param {?} v
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  $scope.fixedInputNumber = function(v, dataAndEvents) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{2})[0-9]*/;
    return v ? v > 0 && 1E-7 >= v || 0 > v && v >= -1E-7 ? 0 : parseFloat(("" + parseFloat(v)).replace(r20, "$1")) : dataAndEvents && 0 != v ? "" : 0;
  };
  var dereg = ionic.debounce(init, 500, true);
  /**
   * @return {undefined}
   */
  $scope.confirmReceiptAction = function() {
    dereg();
  };
  /**
   * @return {undefined}
   */
  $scope.setDefaltAccount = function() {
    if ($scope.record.accountCondition) {
      if ($scope.record.accountCondition.id) {
        $scope.record.KEY293 = $scope.record.accountCondition;
      }
    }
  };
  /**
   * @param {?} qualifier
   * @return {?}
   */
  $scope.isNum = function(qualifier) {
    /** @type {RegExp} */
    var isSimple = /^-?\d+(\.\d+)?$/;
    return isSimple.test(qualifier);
  };
  /**
   * @param {?} id
   * @return {undefined}
   */
  var run = function(id) {
    that.post("/KEY016?accountId=" + id).success(function(obj) {
      if (null != obj.object) {
        $scope.initObject.balance = obj.object.balance;
        $scope.initObject.initAmount = obj.object.initAmount;
        $scope.initObject.initTime = obj.object.initTime ? obj.object.initTime : (new Date).getTime();
        $scope.initObject.initRemark = obj.object.initRemark;
      }
    });
  };
  $scope.$watch("[initObject.KEY293]", function(a) {
    if (a[0].val > 0) {
      run(a[0].val);
    }
  }, true);
  /**
   * @return {undefined}
   */
  $scope.setInitTime = function() {
    if (window.cordova) {
      scope.show({
        date : new Date($scope.initObject.initTime),
        mode : "date",
        doneButtonLabel : "确定",
        cancelButtonLabel : "取消",
        minDate : (new Date).setDate((new Date).getDate() - 90),
        maxDate : (new Date).setDate((new Date).getDate())
      }).then(function(date1) {
        if (!isNaN(date1.getTime())) {
          $scope.initObject.initTime = date1.getTime();
        }
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.confirmAccountInit = function() {
    $scope.accountInitEditModal.hide();
    $scope.updateAcountInit();
  };
  /**
   * @return {undefined}
   */
  $scope.openAccountInitEditModal = function() {
    if ($scope.GetOperatorEventLimit("KEY026")) {
      $scope.accountInitEditModal.show();
    } else {
      $scope.showMessage("无期初调整权限");
    }
  };
  /**
   * @return {?}
   */
  $scope.updateAcountInit = function() {
    if (!($scope.initObject.KEY293 && $scope.initObject.KEY293.val > 0)) {
      return self.toastShow("请选择账户"), false;
    }
    if (!$scope.isNum($scope.initObject.initAmount)) {
      return self.toastShow("请输入正确的期初欠款金额"), false;
    }
    if ($scope.initObject.initTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date($scope.initObject.initTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      $scope.initObject.initTime = midnight.getTime();
    }
    that.postEncode("/KEY017", {
      accountId : $scope.initObject.KEY293.val,
      initAmount : angular.toJson($scope.fixedInputNumber($scope.initObject.initAmount)),
      initTime : self.dateFormat(new Date($scope.initObject.initTime), "yyyy-MM-dd hh:mm:ss.S"),
      initRemark : $scope.initObject.initRemark ? $scope.initObject.initRemark : ""
    }).success(function(r) {
      if (1 == r.statusCode) {
        self.toastShow("账户期初金额修改成功");
        $scope.getList();
        run($scope.initObject.KEY293.val);
        $scope.setReceiptBalances();
        $templateCache.put("accountFinanceListRefresh", true);
      } else {
        run($scope.initObject.KEY293.id);
        self.toastShow(r.content);
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show();
    that.post("/KEY020", {
      createTimeBegin : self.getDayBegin($scope.recordCondition.createTimeBegin),
      createTimeEnd : self.getOffsetDayBegin($scope.recordCondition.createTimeEnd, 1),
      accountId : $scope.recordCondition.accountId,
      businessItem : $scope.recordCondition.businessItem,
      sidx : "createTime",
      sord : "desc"
    }).success(function(response) {
      $scope.items = response.rows;
      var data = {
        inAmount : 0,
        outAmount : 0
      };
      /** @type {number} */
      var i = 0;
      var l = response.rows.length;
      for (;l > i;i++) {
        var stat = response.rows[i];
        data.inAmount = self.accAdd(data.inAmount, stat.inAmount);
        data.outAmount = self.accAdd(data.outAmount, stat.outAmount);
      }
      $scope.getTotal = data;
    }).finally(function() {
      loading.hide();
    });
  };
  fetch().then(function(packs) {
    if ($scope.allAccounts = packs[0].data.rows, params.accountId) {
      /** @type {number} */
      var i = 0;
      for (;i < $scope.allAccounts.length;i++) {
        if ($scope.allAccounts[i].id == params.accountId) {
          $scope.record.accountCondition = $scope.allAccounts[i];
          break;
        }
      }
    }
    $scope.record.KEY293 = $scope.allAccounts[0];
    /** @type {Array} */
    $scope.allConditionAccountItems = [];
    self.union($scope.allConditionAccountItems, packs[1].data.rows);
    $scope.allAccountItems = packs[1].data.rows;
    /** @type {number} */
    i = 0;
    for (;i < $scope.allAccountItems.length;i++) {
      if (0 == $scope.allAccountItems[i].isEnable || (1 == $scope.allAccountItems[i].id || (10 == $scope.allAccountItems[i].id || 5 == $scope.allAccountItems[i].id))) {
        $scope.allAccountItems.splice(i, 1);
        i--;
      }
    }
    $scope.record.accountItem = $scope.allAccountItems[0];
    $scope.setReceiptBalances();
    /** @type {number} */
    $scope.record.createTime = (new Date).getTime();
  });
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
  });
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("accountFinanceRecordRefresh")) {
      $scope.getList();
      $scope.setReceiptBalances();
      $templateCache.put("accountFinanceRecordRefresh", false);
    }
  });
  $scope.gotoDetail = model.gotoDetail;
}]).controller("FinanceRecordDetailCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "lruPersistCache", "$ionicModal", "$ionicPopover", "lbSpinnerDialog", "$ionicPopup", "Tools", "$stateParams", "$cordovaDatePicker", "$q", "BluetoothPrintService", function(self, deepDataAndEvents, result, ignoreMethodDoesntExist, $templateCache, $modal, FB, loading, view, dojo, item, $scope, $q, dataAndEvents) {
  /**
   * @param {string} value
   * @return {undefined}
   */
  function save(value) {
    result.post("/KEY015?supplierId=" + value).success(function(dataAndEvents) {
      self.record.KEY210 = dataAndEvents.banlance;
    });
  }
  /**
   * @param {string} key
   * @return {undefined}
   */
  function fn(key) {
    result.post("/KEY041?clientId=" + key).success(function(dataAndEvents) {
      self.record.KEY265 = dataAndEvents.banlance;
    });
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = result.httpCacheGet.get(result.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var getPromise3 = result.httpCacheGet.get(result.httpCacheGet.ac.ALLACCOUNTITEM);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  self.record = {
    balance : 0
  };
  /** @type {boolean} */
  self.printAvailable = "KEY151" == item.item.fromState;
  /** @type {number} */
  self.type = 0;
  /** @type {string} */
  var _list = "";
  if (null != item.item) {
    if (item.item.businessSn.indexOf("FK") > -1) {
      /** @type {number} */
      self.type = 1;
      /** @type {string} */
      _list = "付款单";
    } else {
      if (item.item.businessSn.indexOf("SK") > -1) {
        /** @type {number} */
        self.type = 2;
        /** @type {string} */
        _list = "收款单";
      } else {
        if (item.item.businessSn.indexOf("JZ") > -1) {
          if (10 == item.item.businessItem) {
            /** @type {string} */
            _list = "账户互转";
            /** @type {number} */
            self.type = 3;
          } else {
            /** @type {string} */
            _list = 0 != item.item.inAmount ? "收入记账" : "支出记账";
          }
        }
      }
    }
  } else {
    /** @type {string} */
    _list = "更新账户流水";
  }
  self.viewTitle = "更新" + _list;
  if (1 == self.type) {
    $modal.fromTemplateUrl("html/PPurchaseBuyBill/KEY184.html", function(theTitle) {
      self.supplierModal = theTitle;
    }, {
      scope : self,
      animation : "slide-in-up"
    });
    /**
     * @return {undefined}
     */
    self.supplierModalOpen = function() {
      self.supplierModal.show().then(function() {
        dojo.keyboardShow();
      });
    };
  } else {
    if (2 == self.type) {
      $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY216.html", function(theTitle) {
        self.clientModal = theTitle;
      }, {
        scope : self,
        animation : "slide-in-up"
      });
      /**
       * @return {undefined}
       */
      self.clientModalOpen = function() {
        self.clientModal.show().then(function() {
          dojo.keyboardShow();
        });
      };
    }
  }
  FB.fromTemplateUrl("html/PAccountManage/KEY190.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY190 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY120.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.KEY120 = theTitle;
  });
  FB.fromTemplateUrl("html/PAccountManage/KEY140.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.KEY140 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openFromAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY120.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.closeFromAccountPopover = function() {
    self.KEY120.hide();
  };
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openToAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY140.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.closeToAccountPopover = function() {
    self.KEY140.hide();
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY119.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY119 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  FB.fromTemplateUrl("financeRecordDetailOperation.html", {
    scope : self
  }).then(function(theTitle) {
    self.financeRecordDetailOperationPopover = theTitle;
  });
  self.$on("$destroy", function() {
    if (1 == self.type) {
      self.supplierModal.remove();
    } else {
      if (2 == self.type) {
        self.clientModal.remove();
      }
    }
    self.KEY190.remove();
    self.KEY119.remove();
    self.KEY120.remove();
    self.KEY140.remove();
    self.financeRecordDetailOperationPopover.remove();
  });
  /**
   * @return {undefined}
   */
  self.bluetooth = function() {
    dataAndEvents.bluetooth(item.item.businessSn, dataAndEvents.orderType.receiptOrder);
  };
  /**
   * @return {undefined}
   */
  self.setCreateTime = function() {
    $scope.show({
      date : new Date(self.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.record.createTime = date1.getTime();
      }
    });
  };
  /**
   * @param {?} v
   * @return {?}
   */
  self.fixedInputNumber = function(v) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{2})[0-9]*/;
    return v ? v > 0 && 1E-7 >= v || 0 > v && v >= -1E-7 ? 0 : parseFloat(("" + parseFloat(v)).replace(r20, "$1")) : 0;
  };
  /**
   * @return {undefined}
   */
  self.setReceiptBalances = function() {
    result.post("/KEY006").success(function(theTitle) {
      self.allAccountBalance = theTitle;
      /** @type {number} */
      var balance = 0;
      if (3 == self.type) {
        if (self.record.fromAccount) {
          if (self.record.fromAccount.id) {
            balance = dojo.fnCheckGtoreQty(self.allAccountBalance, "accountId", self.record.fromAccount.id);
          }
        }
      } else {
        if (self.record.KEY293) {
          if (self.record.KEY293.id) {
            balance = dojo.fnCheckGtoreQty(self.allAccountBalance, "accountId", self.record.KEY293.id);
          }
        }
      }
      self.record.balance = balance ? balance.balance : 0;
    });
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  self.getValidNum = function(deepDataAndEvents) {
    return dojo.getValidNum(deepDataAndEvents);
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.setRechargeAmount = function(dataAndEvents) {
    /** @type {string} */
    var MSG_CLOSURE_CUSTOM_COLOR_BUTTON = self.isDeposit ? "请输入本次充值的金额" : "请输入本次收款金额";
    if (1 == self.type) {
      /** @type {string} */
      MSG_CLOSURE_CUSTOM_COLOR_BUTTON = "请输入本次付款金额";
    }
    if (self.isDeposit) {
      "充值金额";
    } else {
      "收款金额";
    }
    view.show({
      cssClass : "lb-KEY291-popup",
      template : '<input type="number" class="tc" ng-model="record.realAmount" autofocus="true" placeholder="0.00">',
      title : MSG_CLOSURE_CUSTOM_COLOR_BUTTON,
      scope : self,
      buttons : [{
        text : "确认",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          self.record.realAmount = self.fixedInputNumber(self.record.realAmount);
        }
      }]
    });
  };
  /**
   * @param {?} actualObject
   * @return {undefined}
   */
  self.setDiscountAmount = function(actualObject) {
    var object = actualObject;
    /** @type {string} */
    var x = self.isDeposit ? "请输入本次充值赠送金额" : "请输入本次收款优惠金额";
    if (1 == self.type) {
      /** @type {string} */
      x = "请输入本次付款优惠金额";
    }
    /** @type {string} */
    var after = self.isDeposit ? "赠送金额" : "优惠金额";
    if (window.cordova && window.cordova.plugins) {
      dojo.showPrompt(x, function(results) {
        if (2 == results.buttonIndex) {
          self.$apply(function() {
            self.record.discountAmount = results.input1 >= 0 ? self.getValidNum(results.input1) : object;
          });
        }
      }, after, ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="record.discountAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : self,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            self.record.discountAmount = self.getValidNum(self.record.discountAmount);
          }
        }]
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.updateCharge = function() {
    /**
     * @return {?}
     */
    function send() {
      return self.record.inAmount < 0 || (self.record.outAmount < 0 || self.fixedInputNumber(self.record.inAmount) + self.fixedInputNumber(self.record.outAmount) == 0) ? (view.alert({
        template : "<div class='tc'>金额不允许小于等于0</div>",
        okText : "确定"
      }), false) : void 0 == self.record.KEY293 ? (dojo.toastShow("请选择账户"), false) : (loading.show(), void result.post("/KEY022", {
        accountId : self.record.KEY293.id,
        businessItem : self.record.accountItem.id,
        businessSn : self.record.businessSn,
        createTime : self.record.createTime,
        inAmount : self.fixedInputNumber(self.record.inAmount),
        outAmount : self.fixedInputNumber(self.record.outAmount),
        optimisticLockVersion : self.record.optimisticLockVersion,
        remark : self.record.remark
      }).success(function(res) {
        if (1 == res.statusCode) {
          dojo.toastShow("更新" + _list + "成功");
          self.setReceiptBalances();
          $templateCache.put("accountFinanceRecordRefresh", true);
          $templateCache.put("accountFinanceListRefresh", true);
        } else {
          dojo.toastShow(res.content);
        }
      }).finally(function() {
        loading.hide();
      }));
    }
    /**
     * @return {?}
     */
    function finish() {
      if (0 == self.fixedInputNumber(self.record.realAmount) && 0 == self.getValidNum(self.record.discountAmount)) {
        /** @type {string} */
        var scope = "本次收款和优惠金额不能同时为0";
        return self.isDeposit && (scope = "充值和赠送金额不能同时为0"), view.alert({
          template : "<div class='tc'>" + scope + "</div>",
          okText : "确定"
        }), false;
      }
      return 0 == self.fixedInputNumber(self.record.realAmount) || self.record.KEY293 && (self.record.KEY293.id && (self.record.accountItem && self.record.accountItem.id)) ? self.record.realAmount > 9.999999999E7 || self.record.realAmount < -9.999999999E7 ? (view.alert({
        template : "<div class='tc'>输入金额超出限制</div>",
        okText : "确定"
      }), false) : self.record.discountAmount > 9.999999999E7 || self.record.discountAmount < -9.999999999E7 ? (view.alert({
        template : "<div class='tc'>输入金额超出限制</div>",
        okText : "确定"
      }), false) : (self.isDeposit && (self.record.accountItem && (self.record.accountItem.id = 6)), loading.show(), void result.post("/KEY029", {
        accountId : self.record.KEY293 && self.record.KEY293.id ? self.record.KEY293.id : null,
        businessItem : self.record.accountItem && self.record.accountItem.id ? self.record.accountItem.id : null,
        businessSn : self.record.businessSn,
        createTime : self.record.createTime,
        oppositeSideId : self.record.client.id,
        realAmount : self.fixedInputNumber(self.record.realAmount),
        discountAmount : self.getValidNum(self.record.discountAmount),
        remark : self.record.remark
      }).success(function(res) {
        if (1 == res.statusCode) {
          dojo.toastShow("更新" + _list + "成功");
          fn(self.record.client.id);
          $templateCache.put("accountFinanceRecordRefresh", true);
          $templateCache.put("refreshClientRecord", true);
          $templateCache.put("refreshClientList", true);
          $templateCache.put("accountFinanceListRefresh", true);
          $templateCache.put("clientDebtListRefresh", true);
        } else {
          dojo.toastShow(res.content);
        }
      }).finally(function() {
        loading.hide();
      })) : (view.alert({
        template : "<div class='tc'>请选择账户和账目类型！</div>",
        okText : "确定"
      }), false);
    }
    /**
     * @return {?}
     */
    function save() {
      return 0 == self.fixedInputNumber(self.record.realAmount) && 0 == self.getValidNum(self.record.discountAmount) ? (view.alert({
        template : "<div class='tc'>本次付款金额和优惠金额不能同时为空或零</div>",
        okText : "确定"
      }), false) : 0 == self.fixedInputNumber(self.record.realAmount) || self.record.KEY293 && (self.record.KEY293.id && (self.record.accountItem && self.record.accountItem.id)) ? self.record.realAmount > 9.999999999E7 || self.record.realAmount < -9.999999999E7 ? (view.alert({
        template : "<div class='tc'>输入金额超出限制</div>",
        okText : "确定"
      }), false) : self.record.discountAmount > 9.999999999E7 || self.record.discountAmount < -9.999999999E7 ? (view.alert({
        template : "<div class='tc'>输入金额超出限制</div>",
        okText : "确定"
      }), false) : (loading.show(), void result.post("/KEY190", {
        accountId : self.record.KEY293 && self.record.KEY293.id ? self.record.KEY293.id : null,
        businessItem : self.record.accountItem && self.record.accountItem.id ? self.record.accountItem.id : null,
        businessSn : self.record.businessSn,
        createTime : self.record.createTime,
        oppositeSideId : self.record.KEY282.id,
        realAmount : self.fixedInputNumber(self.record.realAmount),
        discountAmount : self.fixedInputNumber(self.record.discountAmount),
        remark : self.record.remark
      }).success(function(res) {
        if (1 == res.statusCode) {
          dojo.toastShow("更新" + _list + "成功");
          save(self.record.KEY282.id);
          $templateCache.put("accountFinanceRecordRefresh", true);
          $templateCache.put("refreshSupplierRecord", true);
          $templateCache.put("accountFinanceListRefresh", true);
          $templateCache.put("supplierDebtListRefresh", true);
        } else {
          dojo.toastShow(res.content);
        }
      }).finally(function() {
        loading.hide();
      })) : (view.alert({
        template : "<div class='tc'>请选择账户和账目类型！</div>",
        okText : "确定"
      }), false);
    }
    /**
     * @return {?}
     */
    function init() {
      return self.record.fromAccount.id == self.record.toAccount.id ? (view.alert({
        template : "<div class='tc'>相同账户不可转账</div>",
        okText : "确定"
      }), false) : 0 == self.fixedInputNumber(self.record.inAmount) ? (view.alert({
        template : "<div class='tc'>金额不允许等于0</div>",
        okText : "确定"
      }), false) : (loading.show(), void result.postEncode("/KEY307", {
        fromAccountId : self.record.fromAccount.id,
        toAccountId : self.record.toAccount.id,
        businessSn : self.record.businessSn,
        createTime : dojo.dateFormat(new Date(self.record.createTime), "yyyy-MM-dd hh:mm:ss.S"),
        balance : self.record.balance,
        amount : self.fixedInputNumber(self.record.inAmount),
        remark : self.record.remark ? self.record.remark : ""
      }).success(function(res) {
        if (1 == res.statusCode) {
          dojo.toastShow("更新" + _list + "成功", "short", "bottom");
          $templateCache.put("accountFinanceRecordRefresh", true);
          $templateCache.put("accountFinanceListRefresh", true);
        } else {
          dojo.toastShow(res.content);
        }
      }).finally(function() {
        loading.hide();
        self.goBack();
      }));
    }
    if (self.record.createTime && self.businessDay) {
      /** @type {Date} */
      var midnight = new Date(self.record.createTime);
      midnight.setHours(self.businessDay.getHours(), self.businessDay.getMinutes(), self.businessDay.getSeconds(), self.businessDay.getMilliseconds());
      /** @type {number} */
      self.record.createTime = midnight.getTime();
    }
    if (self.record.createTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var nd = new Date(self.record.createTime);
      nd.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      self.record.createTime = nd.getTime();
    }
    if (0 == self.type) {
      send();
    } else {
      if (1 == self.type) {
        save();
      } else {
        if (2 == self.type) {
          finish();
        } else {
          if (3 == self.type) {
            init();
          }
        }
      }
    }
  };
  /**
   * @return {?}
   */
  self.deleteCharge = function() {
    /**
     * @return {undefined}
     */
    function init() {
      loading.show();
      result.post(url, obj).success(function(res) {
        if (1 == res.statusCode) {
          dojo.toastShow("删除成功", "short", "bottom");
          $templateCache.put("accountFinanceRecordRefresh", true);
          $templateCache.put("accountFinanceListRefresh", true);
          if (1 == self.type) {
            $templateCache.put("refreshSupplierRecord", true);
            $templateCache.put("supplierDebtListRefresh", true);
            $templateCache.put("refreshSupplierList", true);
          } else {
            if (2 == self.type) {
              $templateCache.put("refreshClientRecord", true);
              $templateCache.put("clientDebtListRefresh", true);
              $templateCache.put("refreshClientList", true);
            }
          }
          self.goBack();
        } else {
          dojo.toastShow(res.content);
        }
      }).finally(function() {
        loading.hide();
      });
    }
    /** @type {string} */
    var url = "";
    var obj = {
      businessSn : self.record.businessSn
    };
    if (0 == self.type) {
      /** @type {string} */
      url = "/KEY023";
    } else {
      if (1 == self.type) {
        /** @type {string} */
        url = "/KEY191";
        obj.id = self.record.id;
      } else {
        if (2 == self.type) {
          if (url = "/KEY030", obj = {
            id : self.record.id
          }, self.isDeposit) {
            return false;
          }
        } else {
          if (3 == self.type) {
            /** @type {string} */
            url = "/admin/inner/finance/banlance/record/deleteAccountTransfer.ac?businessSn=" + self.record.businessSn;
          }
        }
      }
    }
    if (window.cordova && window.cordova.plugins) {
      dojo.showConfirm("确认要删除此" + _list + "?", function(dataAndEvents) {
        if (2 == dataAndEvents) {
          init();
        }
      }, null, ["取消", "继续删除"]);
    } else {
      var promise = view.confirm({
        template : "<div class='tc'>确认要删除此" + _list + "?</div>",
        cancelText : "取消",
        okText : "继续删除"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          init();
        }
      });
    }
  };
  self.$watch("[record.KEY282,record.client, record.KEY293]", function() {
    if (self.record.KEY282 && self.record.KEY282.id > 0) {
      save(self.record.KEY282.id);
    } else {
      if (self.record.client && self.record.client.id > 0) {
        fn(self.record.client.id);
      } else {
        if (0 == self.type) {
          if (self.record.KEY293) {
            if (self.record.KEY293.id > 0) {
              self.setReceiptBalances();
            }
          }
        }
      }
    }
  }, true);
  self.$on("$ionicView.loaded", function() {
    loading.show();
    fetch().then(function(packs) {
      /**
       * @return {undefined}
       */
      function send() {
        self.allAccounts = packs[0].data.rows;
        self.allAccountItems = packs[1].data.rows;
        /** @type {number} */
        var j = 0;
        for (;j < self.allAccountItems.length;j++) {
          if (0 == self.allAccountItems[j].isEnable || (1 == self.allAccountItems[j].id || (10 == self.allAccountItems[j].id || 5 == self.allAccountItems[j].id))) {
            self.allAccountItems.splice(j, 1);
            j--;
          }
        }
        /** @type {number} */
        j = 0;
        var spaces = self.allAccounts.length;
        for (;spaces > j;j++) {
          if (self.record.accountId == self.allAccounts[j].id) {
            self.record.KEY293 = self.allAccounts[j];
            break;
          }
        }
        self.record.accountItem = {
          id : self.record.businessItem,
          name : self.record.businessItemName ? self.record.businessItemName : self.record.accountItemName
        };
        /** @type {number} */
        j = 0;
        spaces = self.allAccountItems.length;
        for (;spaces > j;j++) {
          if (self.record.businessItem == self.allAccountItems[j].id) {
            self.record.accountItem = self.allAccountItems[j];
            break;
          }
        }
        if (self.record.createTime && (self.businessDay = new Date(self.record.createTime)), 1 == self.type) {
          self.searchModel = {};
          if (null == self.record.realAmount) {
            /** @type {number} */
            self.record.realAmount = self.record.outAmount - self.record.inAmount;
          }
          var value = self.record.supplierId > 0 ? self.record.supplierId : self.record.oppositeSideId;
          loading.show();
          result.post("/KEY185?id=" + value).success(function(dataAndEvents) {
            self.record.KEY282 = {};
            self.record.KEY282.id = value;
            self.record.KEY282.text = dataAndEvents.objSupplier.supplierName;
          }).finally(function() {
            loading.hide();
          });
        } else {
          if (2 == self.type) {
            self.searchModel = {};
            if (null == self.record.realAmount) {
              /** @type {number} */
              self.record.realAmount = self.record.inAmount - self.record.outAmount;
            }
            value = self.record.clientId > 0 ? self.record.clientId : self.record.oppositeSideId;
            loading.show();
            result.post("/KEY032?id=" + value).success(function(dataAndEvents) {
              self.record.client = {};
              self.record.client.id = value;
              self.record.client.text = dataAndEvents.objClient.clientName;
            }).finally(function() {
              loading.hide();
            });
          } else {
            if (3 == self.type) {
              loading.show();
              result.post("/admin/inner/finance/banlance/record/getAccountTransfer.ac?businessSn=" + self.record.businessSn).success(function(result) {
                if (1 == result.statusCode) {
                  self.record.inAmount = result.object.amount;
                  var f;
                  var o;
                  /** @type {number} */
                  var b = 0;
                  var a = self.allAccounts.length;
                  for (;a > b && (result.object.fromAccountId == self.allAccounts[b].id && (self.record.fromAccount = self.allAccounts[b], o = 1), result.object.toAccountId == self.allAccounts[b].id && (self.record.toAccount = self.allAccounts[b], f = 1), !o || !f);b++) {
                  }
                  self.setReceiptBalances();
                }
              }).finally(function() {
                loading.hide();
              });
            }
          }
        }
        /** @type {number} */
        self.record.type = 0 != self.record.inAmount ? 1 : 2;
      }
      var url;
      var obj;
      switch(self.record = {}, dojo.union(self.record, item.item), self.type) {
        case 1:
          /** @type {string} */
          url = "/KEY311";
          obj = {
            oppositeSideId : item.item.supplierId ? item.item.supplierId : item.item.oppositeSideId,
            businessSn : item.item.businessSn
          };
          break;
        case 2:
          /** @type {string} */
          url = "/KEY028";
          obj = {
            oppositeSideId : item.item.clientId ? item.item.clientId : item.item.oppositeSideId,
            businessSn : item.item.businessSn
          };
      }
      if (item.item.businessSn && (item.item.businessSn.indexOf("SK") > -1 || item.item.businessSn.indexOf("FK") > -1)) {
        result.post(url, obj).success(function(res) {
          if (1 == res.statusCode) {
            self.record = res.object;
            if (item.item.businessSn.indexOf("SK") > -1) {
              /** @type {boolean} */
              self.isDeposit = 6 == self.record.businessItem;
              /** @type {string} */
              _list = self.isDeposit ? "充值明细" : "收款单";
              /** @type {string} */
              self.viewTitle = "更新" + _list;
              /** @type {string} */
              self.content1 = self.isDeposit ? "充值金额" : "本次收款";
              /** @type {string} */
              self.content2 = self.isDeposit ? "赠送金额" : "优惠金额";
              /** @type {string} */
              self.content3 = self.isDeposit ? "打印充值明细" : "打印收款单";
            }
            self.record.id = item.item.id;
            self.record.discountAmount = res.object.discountAmount ? res.object.discountAmount : null;
            send();
          } else {
            dojo.toastShow("获取数据出错！");
          }
        }).finally(function() {
          loading.hide();
        });
      } else {
        loading.hide();
        send();
      }
    }, function() {
      loading.hide();
    });
  });
}]).controller("FinanceMainCtrl", ["$scope", "Menu", "$state", function(a, e, $state) {
  a.menuList = e;
  /**
   * @return {undefined}
   */
  a.goTransferAccount = function() {
    $state.go("eventmenu.KEY160");
  };
}]).controller("AccountTransferCtrl", ["$scope", "$stateParams", "$state", "psisServices", "lbScrollDelegate", "lruPersistCache", "$ionicModal", "$ionicPopover", "lbSpinnerDialog", "$ionicPopup", "Tools", "$cordovaDatePicker", function($scope, context, dataAndEvents, db, deepDataAndEvents, $templateCache, ignoreMethodDoesntExist, FB, loading, _, self, scope) {
  $scope.record = {
    fromAccount : {},
    toAccount : "",
    createTime : (new Date).setDate((new Date).getDate())
  };
  if (context.accounts) {
    $scope.record.fromAccount = context.accounts;
  }
  FB.fromTemplateUrl("html/PAccountManage/KEY120.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.KEY120 = $location;
  });
  FB.fromTemplateUrl("html/PAccountManage/KEY140.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.KEY140 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openFromAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY120.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.closeFromAccountPopover = function() {
    $scope.KEY120.hide();
  };
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openToAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY140.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.closeToAccountPopover = function() {
    $scope.KEY140.hide();
  };
  $scope.$on("$destroy", function() {
    $scope.KEY120.remove();
    $scope.KEY140.remove();
  });
  /**
   * @param {boolean} value
   * @return {?}
   */
  $scope.fixedInputStoreNumber = function(value) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{2})[0-9]*/;
    return value ? parseFloat(("" + parseFloat(value)).replace(r20, "$1")) : 0;
  };
  /**
   * @return {undefined}
   */
  $scope.setReceiptBalances = function() {
    db.post("/KEY006").success(function($location) {
      if ($scope.allAccountBalance = $location, $scope.record.fromAccount && $scope.record.fromAccount.id) {
        var balance = self.fnCheckGtoreQty($scope.allAccountBalance, "accountId", $scope.record.fromAccount.id);
        $scope.record.fromAccount.balance = balance ? balance.balance : 0;
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTime = function() {
    scope.show({
      date : new Date($scope.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.record.createTime = date1.getTime();
      }
    });
  };
  /**
   * @return {?}
   */
  $scope.KEY160 = function() {
    /**
     * @return {undefined}
     */
    function initialize() {
      loading.show(true);
      db.postEncode("/KEY005", {
        fromAccountId : $scope.record.fromAccount.id,
        toAccountId : $scope.record.toAccount.id,
        amount : $scope.record.amount,
        createTime : self.dateFormat(new Date($scope.record.createTime), "yyyy-MM-dd hh:mm:ss.S"),
        remark : $scope.record.remark ? $scope.record.remark : ""
      }).success(function(r) {
        if (1 == r.statusCode) {
          if (window.cordova && window.cordova.plugins) {
            self.showAlert("成功转账一笔", function() {
              db.httpCacheGet.remove(db.httpCacheGet.ac.ALLACCOUNT);
              $scope.setReceiptBalances();
              db.httpCacheGet.get(db.httpCacheGet.ac.ALLACCOUNT).success(function(results) {
                $scope.allAccounts = results.rows;
              });
              delete $scope.record.amount;
              delete $scope.record.toAccount;
              delete $scope.record.remark;
            }, null, "确定");
          } else {
            _.alert({
              template : "<div class='tc'>成功转账一笔</div>",
              okText : "确定"
            }).then(function() {
              db.httpCacheGet.remove(db.httpCacheGet.ac.ALLACCOUNT);
              $scope.setReceiptBalances();
              db.httpCacheGet.get(db.httpCacheGet.ac.ALLACCOUNT).success(function(results) {
                $scope.allAccounts = results.rows;
              });
              delete $scope.record.amount;
              delete $scope.record.toAccount;
              delete $scope.record.remark;
            });
          }
        }
      }).finally(function() {
        loading.hide();
        $templateCache.put("refreshAccountList", true);
      });
    }
    if ($scope.record.fromAccount.id == $scope.record.toAccount.id) {
      return void _.alert({
        template : "<div class='tc'>相同账户不可转账</div>",
        okText : "确定"
      });
    }
    if ($scope.record.amount + $scope.record.toAccount.balance > 9.999999999E7) {
      return void _.alert({
        template : "<div class='tc'>转入账户金额超出限制</div>",
        okText : "确定"
      });
    }
    /** @type {string} */
    var errorMessage = "向 " + $scope.record.toAccount.name + " 转账金额为" + $scope.record.amount + " ?";
    if (window.cordova && window.cordova.plugins) {
      self.showConfirm(errorMessage, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          $scope.$apply(function() {
            initialize();
          });
        }
      }, "确认操作", ["取消", "确认"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>是否确认此次转账?</div>",
        cancelText : "取消",
        okText : "确认"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          initialize();
        }
      });
    }
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    db.httpCacheGet.get(db.httpCacheGet.ac.ALLACCOUNT).success(function(results) {
      $scope.allAccounts = results.rows;
      if (null == context.accounts) {
        if ($scope.allAccounts.length > 0) {
          $scope.record.fromAccount = $scope.allAccounts[0];
        }
      }
    });
  });
}]).controller("AccountListCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "lruPersistCache", "$ionicModal", "$ionicPopover", "lbSpinnerDialog", "$ionicPopup", "Tools", "$cordovaDatePicker", function(self, $state, db, parent, $templateCache, $modal, FB, loading, _, dojo, $scope) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  self.items = [];
  /** @type {boolean} */
  self.isLoading = true;
  self.record = {
    fromAccount : "",
    toAccount : "",
    createTime : (new Date).setDate((new Date).getDate())
  };
  $modal.fromTemplateUrl("html/PAccountManage/KEY160.html", function(theTitle) {
    self.accountTransferModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @param {?} accounts
   * @param {?} event
   * @return {undefined}
   */
  self.goToTransferAccount = function(accounts, event) {
    if (event) {
      event.stopPropagation();
    }
    $state.go("eventmenu.KEY160", {
      accounts : accounts
    });
  };
  FB.fromTemplateUrl("html/PAccountManage/KEY120.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.KEY120 = theTitle;
  });
  FB.fromTemplateUrl("html/PAccountManage/KEY140.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.KEY140 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openFromAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY120.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.closeFromAccountPopover = function() {
    self.KEY120.hide();
  };
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openToAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY140.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.closeToAccountPopover = function() {
    self.KEY140.hide();
  };
  self.$on("$destroy", function() {
    self.accountTransferModal.remove();
    self.KEY120.remove();
    self.KEY140.remove();
  });
  /**
   * @param {boolean} value
   * @return {?}
   */
  self.fixedInputStoreNumber = function(value) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{2})[0-9]*/;
    return value ? parseFloat(("" + parseFloat(value)).replace(r20, "$1")) : 0;
  };
  /**
   * @return {undefined}
   */
  self.setReceiptBalances = function() {
    db.post("/KEY006").success(function(theTitle) {
      if (self.allAccountBalance = theTitle, self.record.fromAccount && self.record.fromAccount.id) {
        var balance = dojo.fnCheckGtoreQty(self.allAccountBalance, "accountId", self.record.fromAccount.id);
        self.record.fromAccount.balance = balance ? balance.balance : 0;
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTime = function() {
    $scope.show({
      date : new Date(self.record.createTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.record.createTime = date1.getTime();
      }
    });
  };
  /**
   * @return {?}
   */
  self.KEY160 = function() {
    return self.record.fromAccount.id == self.record.toAccount.id ? void _.alert({
      template : "<div class='tc'>相同账户不可转账</div>",
      okText : "确定"
    }) : self.record.amount + self.record.toAccount.balance > 9.999999999E7 ? void _.alert({
      template : "<div class='tc'>转入账户金额超出限制</div>",
      okText : "确定"
    }) : (loading.show(true), void db.postEncode("/KEY005", {
      fromAccountId : self.record.fromAccount.id,
      toAccountId : self.record.toAccount.id,
      amount : self.record.amount,
      createTime : dojo.dateFormat(new Date(self.record.createTime), "yyyy-MM-dd hh:mm:ss.S"),
      remark : self.record.remark ? self.record.remark : ""
    }).success(function(r) {
      if (1 == r.statusCode) {
        _.alert({
          template : "<div class='tc'>转账成功</div>",
          okText : "确定"
        }).then(function() {
          db.httpCacheGet.remove(db.httpCacheGet.ac.ALLACCOUNT);
          self.setReceiptBalances();
          self.accountTransferModal.hide();
          db.httpCacheGet.get(db.httpCacheGet.ac.ALLACCOUNT).success(function(result) {
            self.allAccounts = result.rows;
          });
          setup();
          delete self.record.amount;
          delete self.record.toAccount;
          delete self.record.remark;
        });
      }
    }).finally(function() {
      loading.hide();
    }));
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return db.postEncode("/KEY001", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var setup = function() {
    /** @type {number} */
    page = 1;
    createDom({
      page : page
    }).success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("accountListCtrlScroll");
      /** @type {boolean} */
      self.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    createDom({
      page : ++page
    }).success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("accountListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getAccountBalanceSum = function() {
    db.post("/KEY335").success(function(res) {
      if (1 == res.statusCode) {
        self.disableTotalBalance = res.object.disableTotalBalance;
        self.enableTotalBalance = res.object.enableTotalBalance;
        self.totalCount = res.object.totalCount;
      } else {
        dojo.toastShow(res.content);
      }
    });
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  self.goAccountDetailEdit = function(term) {
    $state.go("eventmenu.KEY307", {
      id : term
    });
  };
  self.$on("$ionicView.beforeEnter", function() {
    db.httpCacheGet.get(db.httpCacheGet.ac.ALLACCOUNT).success(function(result) {
      self.allAccounts = result.rows;
    });
    if (1 == $templateCache.get("refreshAccountList")) {
      setup();
      self.getAccountBalanceSum();
      $templateCache.put("refreshAccountList", false);
    }
  });
  setup();
  self.getAccountBalanceSum();
}]).controller("AccountDetailEditCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "$ionicModal", "$ionicPopup", "lbSpinnerDialog", "lruPersistCache", "$state", "$ionicPopover", "$cordovaDatePicker", function($scope, map, result, $, $modal, dataAndEvents, loading, $templateCache, $state, deepDataAndEvents, scope) {
  var name = map.id;
  $scope.viewTitle = name ? $scope.NameConstant.KEY237 : $scope.NameConstant.ACCOUNTADD;
  /** @type {number} */
  $scope.state = 0;
  $scope.accountObject = {};
  $scope.accountInfo = {
    accountType : {}
  };
  /** @type {Array} */
  $scope.arrAccountType = [{
    val : 1,
    text : "现金"
  }, {
    val : 2,
    text : "银行账户"
  }, {
    val : 3,
    text : "支付宝"
  }, {
    val : 4,
    text : "微信钱包"
  }, {
    val : 0,
    text : "其他"
  }];
  $scope.initObject = {
    KEY293 : {},
    initAmount : "",
    initTime : (new Date).getTime(),
    initRemark : ""
  };
  /**
   * @param {number} dataAndEvents
   * @return {?}
   */
  $scope.setAccountBalanceCloors = function(dataAndEvents) {
    return dataAndEvents = $scope.accountObject.balance, 0 > dataAndEvents ? "lb-color-tab-8" : "lb-color-star";
  };
  /**
   * @param {?} qualifier
   * @return {?}
   */
  $scope.isNum = function(qualifier) {
    /** @type {RegExp} */
    var isSimple = /^-?\d+(\.\d+)?$/;
    return isSimple.test(qualifier);
  };
  /**
   * @param {?} v
   * @return {?}
   */
  $scope.fixedInputNumber = function(v) {
    /** @type {RegExp} */
    var r20 = /([0-9]+\.[0-9]{2})[0-9]*/;
    return v ? v > 0 && 1E-7 >= v || 0 > v && v >= -1E-7 ? 0 : parseFloat(("" + parseFloat(v)).replace(r20, "$1")) : 0;
  };
  $modal.fromTemplateUrl("html/PAccountManage/KEY157.html", function($location) {
    /** @type {number} */
    $scope.accountInitEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PAccountManage/KEY160.html", function($location) {
    $scope.accountTransferModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.openAccountInitEditModal = function() {
    if ($scope.GetOperatorEventLimit("KEY026")) {
      $scope.accountInitEditModal.show();
    } else {
      $scope.showMessage("无期初调整权限");
    }
  };
  /**
   * @return {undefined}
   */
  $scope.confirmAccountInit = function() {
    $scope.accountInitEditModal.hide();
    $scope.updateAcountInit();
  };
  $scope.$on("$destroy", function() {
    $scope.accountInitEditModal.remove();
    $scope.accountTransferModal.remove();
  });
  /**
   * @return {?}
   */
  $scope.updateAcountInit = function() {
    if (!$scope.isNum($scope.initObject.initAmount)) {
      return $.toastShow("请输入正确的期初欠款金额"), false;
    }
    if ($scope.initObject.initTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date($scope.initObject.initTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      $scope.initObject.initTime = midnight.getTime();
    }
    result.postEncode("/KEY017", {
      accountId : $scope.accountObject.id,
      initAmount : angular.toJson($scope.fixedInputNumber($scope.initObject.initAmount)),
      initTime : $.dateFormat(new Date($scope.initObject.initTime), "yyyy-MM-dd hh:mm:ss.S"),
      initRemark : $scope.initObject.initRemark ? $scope.initObject.initRemark : ""
    }).success(function(r) {
      if (1 == r.statusCode) {
        $.toastShow("账户期初金额修改成功");
        $templateCache.put("refreshAccountList", true);
        $templateCache.put("accountFinanceListRefresh", true);
        $templateCache.put("accountFinanceRecordRefresh", true);
        listener($scope.accountObject.id);
        $scope.getList($scope.accountObject.id);
      } else {
        listener($scope.accountObject.id);
        $.toastShow(r.content);
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.goAccountDetailEdit = function() {
    $state.go("eventmenu.KEY237", {
      id : $scope.accountObject.id
    });
  };
  /**
   * @param {Element} result
   * @return {undefined}
   */
  $scope.showDetail = function(result) {
    var $stateParams = {
      accountId : result.id,
      accountName : result.accountName
    };
    $state.go("eventmenu.KEY072", $stateParams);
  };
  /**
   * @param {?} accounts
   * @param {?} event
   * @return {undefined}
   */
  $scope.goToTransferAccount = function(accounts, event) {
    if (event) {
      event.stopPropagation();
    }
    $state.go("eventmenu.KEY160", {
      accounts : accounts
    });
  };
  /**
   * @param {number} recurring
   * @return {undefined}
   */
  $scope.getList = function(recurring) {
    if (name) {
      /** @type {number} */
      $scope.state = 1;
      loading.show();
      result.post("/KEY001?id=" + recurring).success(function(res) {
        $scope.accountObject = res.rows[0];
        $scope.accountObject.accountType = $.fnCheckGtoreQty($scope.arrAccountType, "val", parseInt(res.rows[0].accountType));
      }).finally(function() {
        loading.hide();
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.setInitTime = function() {
    if (window.cordova) {
      scope.show({
        date : new Date($scope.initObject.initTime),
        mode : "date",
        doneButtonLabel : "确定",
        cancelButtonLabel : "取消",
        minDate : (new Date).setDate((new Date).getDate() - 90),
        maxDate : (new Date).setDate((new Date).getDate())
      }).then(function(date1) {
        if (!isNaN(date1.getTime())) {
          $scope.initObject.initTime = date1.getTime();
        }
      });
    }
  };
  /**
   * @param {?} value
   * @return {undefined}
   */
  var listener = function(value) {
    result.post("/KEY016?accountId=" + value).success(function(obj) {
      if (null != obj.object) {
        $scope.initObject.balance = obj.object.balance;
        $scope.initObject.initAmount = obj.object.initAmount;
        $scope.initObject.initTime = obj.object.initTime ? obj.object.initTime : (new Date).getTime();
        $scope.initObject.initRemark = obj.object.initRemark;
      }
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    return 1 == $templateCache.get("isDeleteFinance") ? ($scope.viewReplace(), $state.go("eventmenu.KEY238"), $templateCache.put("isDeleteFinance", false), false) : void 0;
  });
  $scope.$on("$ionicView.beforeEnter", function() {
    result.httpCacheGet.get(result.httpCacheGet.ac.ALLACCOUNT).success(function(results) {
      $scope.allAccounts = results.rows;
    });
  });
  $scope.getList(name);
  listener(name);
}]).controller("AccountEditCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "$ionicModal", "$ionicPopup", "lbSpinnerDialog", "lruPersistCache", "$state", function($scope, depMap, $http, $, $modal, _, loading, $templateCache) {
  var id = depMap.id;
  $scope.viewTitle = id ? $scope.NameConstant.KEY237 : $scope.NameConstant.ACCOUNTADD;
  /** @type {number} */
  $scope.state = 0;
  $scope.KEY293 = {};
  $scope.accountInfo = {
    accountType : {}
  };
  $scope.company = {};
  /** @type {Array} */
  $scope.company.userStoreItem = [];
  $scope.company.storeUser = {};
  /** @type {Array} */
  $scope.arrAccountType = [{
    val : 1,
    text : "现金"
  }, {
    val : 2,
    text : "银行账户"
  }, {
    val : 3,
    text : "支付宝"
  }, {
    val : 4,
    text : "微信钱包"
  }, {
    val : 0,
    text : "其他"
  }];
  /** @type {boolean} */
  var s = false;
  /** @type {boolean} */
  $scope.KEY293.statusSetting = true;
  $modal.fromTemplateUrl("html/PShopBaseInfo/KEY077.html", function($location) {
    $scope.comStoreModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @param {Object} config
   * @return {undefined}
   */
  $scope.selectComStore = function(config) {
    if ($scope.KEY293.storeId == config.id) {
      /** @type {null} */
      $scope.KEY293.storeId = null;
      /** @type {null} */
      $scope.company.storeUser.storeId = null;
    } else {
      $scope.KEY293.storeId = config.id;
      $scope.company.storeUser.storeId = config.id;
      $scope.KEY293.storeName = config.storeName;
    }
    $scope.comStoreModal.hide();
  };
  $modal.fromTemplateUrl("accountTypeSelect.html", function($location) {
    $scope.accountTypeModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.accountTypeModal.remove();
    $scope.comStoreModal.remove();
  });
  /**
   * @return {?}
   */
  $scope.saveAccount = function() {
    /**
     * @return {?}
     */
    function init() {
      return 1 == s ? false : (loading.show(), s = true, void $http.post("/KEY004", $scope.KEY293).success(function(event) {
        if (1 == event.statusCode) {
          _.alert({
            template : "<div class='tc'>保存成功</div>",
            okText : "确定"
          }).then(function() {
            $.union($scope.KEY293, event.object);
            /** @type {number} */
            $scope.state = 1;
            $scope.viewTitle = $scope.NameConstant.KEY237;
            $templateCache.put("refreshAccountList", true);
            $templateCache.put("accountFinanceListRefresh", true);
            $templateCache.put("accountFinanceRecordRefresh", true);
            $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLACCOUNT);
            $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
            $scope.goBack();
          });
        } else {
          _.alert({
            template : "<div class='tc'>保存失败</div>",
            okText : "确定"
          });
        }
      }).finally(function() {
        loading.hide();
        /** @type {boolean} */
        s = false;
      }));
    }
    if (!$scope.KEY293.name) {
      return $.toastShow("请填写名称！", "short", "center"), void console.log("请填写名称！");
    }
    if (!$scope.KEY293.showOrder) {
      return $.toastShow("请在排序栏输入整数", "short", "center"), void console.log("请在排序栏输入整数");
    }
    $scope.KEY293.accountType = $scope.accountInfo.accountType.val;
    /** @type {number} */
    $scope.KEY293.status = 1 == $scope.KEY293.statusSetting ? 1 : 0;
    var params = {
      newName : $scope.KEY293.name
    };
    if (1 === $scope.state) {
      params.accountId = $scope.KEY293.id;
    }
    $http.postEncode("/KEY003", params).success(function(e) {
      if (e.isValid) {
        init();
      } else {
        $.toastShow("账户名称已存在！", "short", "center");
        console.log("账户名称已存在！");
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.deleteAccount = function() {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除该结算账户?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        $http.post("/KEY007?id=" + $scope.KEY293.id).success(function(r) {
          if (1 == r.statusCode) {
            _.alert({
              template : "<div class='tc'>删除成功</div>",
              okText : "确定"
            }).then(function() {
              $templateCache.put("refreshAccountList", true);
              $templateCache.put("accountFinanceListRefresh", true);
              $templateCache.put("accountFinanceRecordRefresh", true);
              $templateCache.put("isDeleteFinance", true);
              $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLACCOUNT);
              $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
              $scope.goBack();
            });
          } else {
            _.alert({
              template : "<div class='tc'>" + r.content + "</div>",
              okText : "确定"
            });
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  if (id) {
    /** @type {number} */
    $scope.state = 1;
    loading.show();
    $http.post("/KEY001?id=" + id).success(function(res) {
      $scope.KEY293 = res.rows[0];
      $scope.accountInfo.accountType = $.fnCheckGtoreQty($scope.arrAccountType, "val", parseInt(res.rows[0].accountType));
      $scope.company.storeUser.storeId = $scope.KEY293.storeId;
      /** @type {boolean} */
      $scope.KEY293.status = $scope.KEY293.statusSetting = 1 == res.rows[0].status ? true : false;
    }).finally(function() {
      loading.hide();
    });
  } else {
    $scope.accountInfo.accountType = $scope.arrAccountType[0];
    /** @type {number} */
    $scope.KEY293.showOrder = 100;
  }
}]).controller("AccountItemListCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "Tools", "lruPersistCache", function($scope, $state, newCanvas, parent, domAttr, $templateCache) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  /** @type {boolean} */
  $scope.isLoading = true;
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return newCanvas.postEncode("/KEY008", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var setup = function() {
    /** @type {number} */
    page = 1;
    createDom({
      page : page
    }).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("accountItemListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("accountItemListCtrlScroll");
    });
  };
  /**
   * @param {string} term
   * @param {number} dataAndEvents
   * @return {undefined}
   */
  $scope.goAccountItemEdit = function(term, dataAndEvents) {
    if (0 === dataAndEvents) {
      domAttr.toastShow("系统原有账目类型，不可修改。", "short", "center");
      console.log("系统原有账目类型，不可修改。");
    } else {
      $state.go("eventmenu.KEY158", {
        id : term
      });
    }
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshAccountItemList")) {
      setup();
      $templateCache.put("refreshAccountItemList", false);
    }
  });
  setup();
}]).controller("AccountItemEditCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "$ionicPopup", "lbSpinnerDialog", "lruPersistCache", function($scope, depMap, $http, methods, _, loading, $templateCache) {
  var id = depMap.id;
  $scope.viewTitle = id ? $scope.NameConstant.KEY158 : $scope.NameConstant.ACCOUNTITEMADD;
  /** @type {number} */
  $scope.state = 0;
  $scope.KEY293 = {};
  /** @type {boolean} */
  var u = false;
  /**
   * @return {?}
   */
  $scope.saveAccount = function() {
    /**
     * @return {?}
     */
    function init() {
      return 1 == u ? false : (loading.show(true), u = true, $scope.KEY293.isEnable = 1 == $scope.KEY293.isEnableSetting ? 1 : 0, void $http.post("/KEY010", $scope.KEY293).success(function(options) {
        if (1 == options.statusCode) {
          _.alert({
            template : "<div class='tc'>保存成功</div>",
            okText : "确定"
          }).then(function() {
            methods.union($scope.KEY293, options.object);
            /** @type {number} */
            $scope.state = 1;
            $scope.viewTitle = $scope.NameConstant.KEY158;
            $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLACCOUNTITEM);
            $templateCache.put("refreshAccountItemList", true);
            $templateCache.put("accountFinanceListRefresh", true);
            $templateCache.put("accountFinanceRecordRefresh", true);
            $scope.goBack();
          });
        } else {
          _.alert({
            template : "<div class='tc'>保存失败</div>",
            okText : "确定"
          });
        }
      }).finally(function() {
        loading.hide();
        /** @type {boolean} */
        u = false;
      }));
    }
    if (!$scope.KEY293.name) {
      return methods.toastShow("请填写名称！", "short", "center"), void console.log("请填写名称！");
    }
    if (!$scope.KEY293.showOrder) {
      return methods.toastShow("请在排序栏输入整数", "short", "center"), console.log("请在排序栏输入整数"), false;
    }
    var customer = {
      newName : $scope.KEY293.name
    };
    if (1 === $scope.state) {
      customer.accountItemId = $scope.KEY293.id;
    }
    $http.postEncode("/KEY009", customer).success(function(e) {
      if (e.isValid) {
        init();
      } else {
        methods.toastShow("账目类型已存在！", "short", "center");
        console.log("账目类型已存在！");
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.deleteAccount = function() {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除该账目类型?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        $http.post("/KEY011?id=" + $scope.KEY293.id).success(function(r) {
          if (1 == r.statusCode) {
            _.alert({
              template : "<div class='tc'>删除成功</div>",
              okText : "确定"
            }).then(function() {
              $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLACCOUNTITEM);
              $templateCache.put("refreshAccountItemList", true);
              $templateCache.put("accountFinanceListRefresh", true);
              $templateCache.put("accountFinanceRecordRefresh", true);
              $scope.goBack();
            });
          } else {
            _.alert({
              template : "<div class='tc'>" + r.content + "</div>",
              okText : "确定"
            });
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  if (id) {
    /** @type {number} */
    $scope.state = 1;
    loading.show();
    $http.post("/KEY008?id=" + id).success(function(res) {
      if ($scope.KEY293 = res.rows[0], $scope.KEY293.isEnableSetting = 1 == $scope.KEY293.isEnable, void 0 == $scope.KEY293) {
        $templateCache.put("refreshAccountItemList", true);
        var promise = _.confirm({
          template : "<div class='tc'>该账目类型已删除，确认返回?</div>",
          cancelText : "取消",
          okText : "确认"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            $scope.goBack();
          }
        });
      }
    }).finally(function() {
      loading.hide();
    });
  } else {
    /** @type {boolean} */
    $scope.KEY293.isEnableSetting = true;
    /** @type {number} */
    $scope.KEY293.showOrder = 100;
  }
}]);
