angular.module("goodController", ["ionic", "services", "tools"]).controller("GoodListCtrl", ["$scope", "$rootScope", "$timeout", "$state", "psisServices", "lbScrollDelegate", "$ionicModal", "Tools", "lruPersistCache", "$cordovaBarcodeScanner", "$ionicPopover", "$window", "$ionicActionSheet", "lbSpinnerDialog", "wechatShare", "$ionicPopup", "BTScanerService", "commonDataInterface", "VaApplyItem", "qqShare", function(self, deepDataAndEvents, $sanitize, $state, game, parent,
$modal, assert, $templateCache, Hogan, FB, $window, textAlt, loading, util, _, $document, dataAndEvents, ignoreMethodDoesntExist, console) {
  /** @type {Array} */
  self.items = [];
  /** @type {boolean} */
  self.isLoading = true;
  /** @type {boolean} */
  self.isEnteredBarcode = true;
  self.goodsInfo = {
    name : "",
    isOnSale : 1,
    isOnSaleName : "启用"
  };
  self.queryCondition = {
    page : 1,
    operator : 3,
    sidx : "",
    sord : ""
  };
  self.allCategoryList = {};
  /**
   * @return {?}
   */
  var Step = function() {
    return game.postEncode("/KEY062", self.queryCondition);
  };
  /**
   * @param {?} resourceConfigOverrides
   * @return {?}
   */
  var $http = function(resourceConfigOverrides) {
    return game.postEncode("/KEY357", {
      goodsId : resourceConfigOverrides
    });
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY040.html", function(theTitle) {
    self.KEY263 = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  var err = {};
  /**
   * @param {Element} r
   * @param {?} event
   * @return {undefined}
   */
  self.shareGoods = function(r, event) {
    if (event) {
      event.stopPropagation();
    }
    loading.show(true);
    $http(r.id).success(function(result) {
      if (result && 1 == result.statusCode) {
        if (1 == result.object.isPutOnSale) {
          self.KEY263.show();
          err = result.object;
        } else {
          if (window.cordova && window.cordova.plugins) {
            assert.showConfirm("商品尚未上架到销货宝，请先上架再分享", function(dataAndEvents) {
              if (2 == dataAndEvents) {
                self.openLinkInIframe(ignoreMethodDoesntExist.getVaItem[2].title, ignoreMethodDoesntExist.getVaItem[2].htmlName);
              } else {
                if (3 == dataAndEvents) {
                  game.postEncode("/KEY377", {
                    goodsId : r.id
                  }).success(function(res) {
                    loading.show(true);
                    if (1 == res.statusCode) {
                      assert.toastShow("上架成功");
                      $http(r.id).success(function(result) {
                        if (result) {
                          if (1 == result.statusCode) {
                            if (1 == result.object.isPutOnSale) {
                              self.KEY263.show();
                              err = result.object;
                            }
                          }
                        }
                      });
                    } else {
                      _.alert({
                        template : "<div class='tc'>上架失败</div>",
                        okText : "确定"
                      });
                    }
                  }).finally(function() {
                    loading.hide();
                  });
                }
              }
            }, null, ["取消", "了解销货宝", "上架商品"]);
          } else {
            var promise = _.confirm({
              template : "<div class='tc'>商品尚未上架到销货宝，请先上架再分享</div>",
              cancelText : "取消",
              okText : "上架商品"
            });
            promise.then(function(dataAndEvents) {
              if (dataAndEvents) {
                game.postEncode("/KEY377", {
                  goodsId : r.id
                }).success(function(res) {
                  if (1 == res.statusCode) {
                    assert.toastShow("上架成功");
                    $http(r.id).success(function(result) {
                      if (result) {
                        if (1 == result.statusCode) {
                          if (1 == result.object.isPutOnSale) {
                            self.KEY263.show();
                            err = result.object;
                          }
                        }
                      }
                    });
                  } else {
                    _.alert({
                      template : "<div class='tc'>上架失败</div>",
                      okText : "确定"
                    });
                  }
                }).finally(function() {
                  loading.hide();
                });
              }
            });
          }
        }
      } else {
        assert.toastShow(result.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  self.share = function(opt_attributes) {
    var title = err.shareTitle ? err.shareTitle : "";
    var body = err.description ? err.description : "";
    var msg = err.shareImg;
    var b = err.shareLink ? err.shareLink : "";
    if ("Timeline" == opt_attributes) {
      util.shareUrlToTimeline(b, title, body, msg);
      dataAndEvents.addFuncLog("Xiaohuobao_GoodsShare_Timeline", "商品列表中分享商品到朋友圈", assert.getDeviceInfo());
    } else {
      if ("friend" == opt_attributes) {
        util.shareUrlToSession(b, title, body, msg);
        dataAndEvents.addFuncLog("Xiaohuobao_GoodsShare_Session", "商品列表中分享商品到好友", assert.getDeviceInfo());
      } else {
        if ("qq" == opt_attributes) {
          console.shareUrlToQq(b, title, body, msg);
        } else {
          if ("qz" == opt_attributes) {
            /** @type {Array} */
            var progressValues = [];
            progressValues.push(msg);
            console.shareUrlToQz(b, title, body, progressValues);
          }
        }
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    self.queryCondition.categoryIdsStr = self.goodsInfo.category ? assert.getCategoryChildIds(self.allCategoryList, self.goodsInfo.category.id) : "";
    self.queryCondition.blandId = self.goodsInfo.bland ? self.goodsInfo.bland.id : "";
    self.queryCondition.isOnSale = self.goodsInfo.isOnSale ? self.goodsInfo.isOnSale : "";
    /** @type {number} */
    self.queryCondition.page = 1;
    if (self.goodsInfo.name) {
      self.queryCondition.barCode = self.goodsInfo.name;
      self.queryCondition.goodsSn = self.goodsInfo.name;
      self.queryCondition.name = self.goodsInfo.name;
      self.queryCondition.skuBarCode = self.goodsInfo.name;
      self.queryCondition.skuSn = self.goodsInfo.name;
      self.queryCondition.standard = self.goodsInfo.name;
      self.queryCondition.waretype = self.goodsInfo.name;
    } else {
      delete self.queryCondition.barCode;
      delete self.queryCondition.goodsSn;
      delete self.queryCondition.name;
      delete self.queryCondition.skuBarCode;
      delete self.queryCondition.skuSn;
      delete self.queryCondition.standard;
      delete self.queryCondition.waretype;
    }
    loading.show();
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      parent.scrollTop("goodListCtrlScroll");
      loading.hide();
    });
  };
  /**
   * @param {string} id
   * @return {undefined}
   */
  self.getSortList = function(id) {
    /** @type {string} */
    self.queryCondition.sord = "" == id ? "" : self.queryCondition.sidx == id && "desc" == self.queryCondition.sord ? "asc" : "desc";
    /** @type {string} */
    self.queryCondition.sidx = id;
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("goodListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    /** @type {null} */
    self.goodsInfo.name = null;
    /** @type {null} */
    self.goodsInfo.bland = null;
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  self.goDetail = function(term) {
    $state.go("eventmenu.KEY291", {
      id : term
    });
  };
  /**
   * @return {undefined}
   */
  self.gotoGenerateBarCode = function() {
    $state.go("eventmenu.KEY156");
  };
  /**
   * @return {undefined}
   */
  self.gotoPrintBarCode = function() {
    $state.go("eventmenu.KEY218");
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    Hogan.scan().then(function(data) {
      if (!data.cancelled) {
        $sanitize(function() {
          self.goodsInfo.name = data.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      assert.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {undefined}
   */
  self.openOtherOpearation = function() {
    /** @type {boolean} */
    self.isEnteredBarcode = false;
    /** @type {number} */
    $window.localStorage.isEnteredBarcode = 1;
  };
  $modal.fromTemplateUrl("goodListQuery.html", function(theTitle) {
    self.goodListQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsCategoryQuery.html", function(theTitle) {
    self.goodsCategoryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsBlandQuery.html", function(theTitle) {
    self.goodsBlandModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  //分类编辑页面
  $modal.fromTemplateUrl("goodsCategoryEdit.html", function($location) {
    /** @type {number} */
    self.goodsCategoryEditModal = $location;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  //上级分类页面
  $modal.fromTemplateUrl("goodsCategoryParent.html", function($location) {
    self.goodsCategoryParentModal = $location;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("otherOperation.html", {
    scope : self
  }).then(function(theTitle) {
    self.otherOperationPopover = theTitle;
  });
  FB.fromTemplateUrl("isOnSale.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.isOnSalePopover = theTitle;
  });
  //新增商品/新增分类
  FB.fromTemplateUrl("wareOperation.html", {
    scope : self
  }).then(function(theTitle) {
    self.wareOperationPopover = theTitle;
  });

  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openIsOnSalePopover = function(expectedNumberOfNonCommentArgs) {
    self.isOnSalePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideIsOnSalePopover = function() {
    self.isOnSalePopover.hide();
  };
  self.$on("$destroy", function() {
    self.goodListQueryModal.remove();
    self.goodsCategoryModal.remove();
    self.goodsBlandModal.remove();
    self.isOnSalePopover.remove();
    self.otherOperationPopover.remove();
    self.KEY263.remove();
    self.goodsCategoryEditModal.remove();
    self.wareOperationPopover.remove();
    self.goodsCategoryParentModal.remove();
  });

  //打开新增商品分类页面
  self.openGoodsCategory = function(dataAndEvents, n, event) {
    if ("insert" === dataAndEvents) {
      self.goodsCategoryEdit = {
        isShow : 1,
        showOrder : 100,
        ifShow : 1
      };
    }
    self.goodsCategoryEditModal.show();
  };

  //添加商品分类
  self.saveGoodsCategory = function() {
    if (!self.goodsCategoryEdit.name) {
      return dojo.toastShow("请填写分类名称！", "short", "center"), void console.log("请填写分类名称！");
    }
    var t = !self.goodsCategoryEdit.id;
    self.goodsCategoryEdit.pid = null == self.goodsCategoryEdit.parentCategory ? 0 : self.goodsCategoryEdit.parentCategory.id;
    var attributes = {
      parentCategoryId : self.goodsCategoryEdit.pid,
      value : self.goodsCategoryEdit.name
    };
    if (!t) {
      attributes.categoryId = self.goodsCategoryEdit.id;
    }
    game.postEncode("/KEY053", attributes).success(function(e) {
      if (e.isValid) {
        game.post("/KEY057", self.goodsCategoryEdit).success(function(r) {
          if (1 == r.statusCode) {
            assert.toastShow("保存成功！");
            game.httpCacheGet.remove(game.httpCacheGet.ac.CATEGORYLIST);
            game.httpCacheGet.get(game.httpCacheGet.ac.CATEGORYLIST).success(function(result) {
              self.allCategoryList = result.rows;
              self.categoryTree = assert.treeForCategory(0, "", false, result.rows).children;
            });
            self.goodsCategoryEditModal.hide();
          } else {
            assert.toastShow("保存失败！");
          }
        });
      } else {
        assert.toastShow("分类名称已存在！", "short", "center");
      }
    }).finally(function() {
    });
  };

  //获取父级分类
  self.getCategoryList = function() {
    game.httpCacheGet.get(game.httpCacheGet.ac.CATEGORYLIST).success(function(column) {
      $sanitize(function() {
        self.$apply(function() {
          self.allCategoryList = column.rows;
          self.categoryTree = assert.treeForCategory(0, "", false, column.rows).children;
          /*if (null != self.goodsInfo.category.id) {
            if (null != self.goodsCategoryEdit) {
              if (self.goodsCategoryEdit.id) {
                if (self.goodsInfo.category.id == $scope.goodsCategoryEdit.id) {
                  self.goodsInfo.category = assert.fnCheckGtoreQty(self.allCategoryList, "id", self.goodsInfo.category.id);
                }
              }
            }
          }*/
        });
      });
    });
  };

  self.$on("$ionicView.afterEnter", function() {
    if ($templateCache.get("goodListRefresh")) {
      if ($templateCache.get("goodListRefresh") === true) {
        self.getList();
        $templateCache.put("goodListRefresh", false);
        $templateCache.put("goodDeleteReturn", false);
        /** @type {boolean} */
        deepDataAndEvents.isRefreshGoodsListForMain = true;
      }
    }
    game.httpCacheGet.get(game.httpCacheGet.ac.BLANDLIST).success(function(theTitle) {
      self.arrBland = theTitle;
    });
    $document.getScanerCode(function(dataAndEvents) {
      if (dataAndEvents) {
        if (!self.goodListQueryModal.isShown()) {
          self.queryCondition.barCode = dataAndEvents;
          self.queryCondition.skuBarCode = dataAndEvents;
          loading.show();
          Step().success(function(data) {
            self.items = data.rows;
            /** @type {boolean} */
            self.loadMoreBtn = data.page < data.total;
            if (self.items) {
              if (0 == self.items.length) {
                assert.toastShow("找不到条码为" + dataAndEvents + "的商品");
                _.alert({
                  template : "<div class='tc'>"+"找不到条码为" + dataAndEvents + "的商品"+"</div>",
                  okText : "确定"
                });
              }
            }
          }).finally(function() {
            parent.scrollTop("goodListCtrlScroll");
            /** @type {boolean} */
            self.isLoading = false;
            loading.hide();
          });
        }
      }
    }, self.bluethoothScaner);
    self.getCategoryList();
  });
  self.$on("$ionicView.loaded", function() {
    self.getList();
    game.httpCacheGet.get(game.httpCacheGet.ac.CATEGORYLIST).success(function(result) {
      self.allCategoryList = result.rows;
      self.categoryTree = assert.treeForCategory(0, "", false, result.rows).children;
    });
    if (1 == $window.localStorage.isEnteredBarcode) {
      /** @type {boolean} */
      self.isEnteredBarcode = false;
    }
  });
  self.$on("$ionicView.beforeLeave", function() {
    $document.getScanerCode(function() {
    }, self.bluethoothScaner);
  });
}]).controller("GoodEditCtrl", ["$scope", "$rootScope", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "$timeout", "$cordovaBarcodeScanner", "lruPersistCache", "$ionicActionSheet", "CameraService", "ServerConfig", "$cordovaFile", "lbScrollDelegate", "BTScanerService", function(self, dataAndEvents, ignores, result, UnitTools, FB, $modal, $q, _, loading, done, Hogan,
socket, dialog, item, context, exports, _this, $document) {
  /**
   * @return {undefined}
   */
  function getObject() {
    if (self.goodsClientItemPriceList) {
      /** @type {number} */
      var i = 0;
      for (;i < self.goodsInfo.clientItemPrice.length;i++) {
        var temp = UnitTools.fnCheckGtoreQty(self.goodsClientItemPriceList, "clientItemId", self.goodsInfo.clientItemPrice[i].id);
        if (temp) {
          self.goodsInfo.clientItemPrice[i].price = temp.price;
        } else {
          delete self.goodsInfo.clientItemPrice[i].price;
        }
      }
    }
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = result.get(result.httpCacheGet.ac.COLORSELECT);
    var getPromise3 = result.get(result.httpCacheGet.ac.SIZESELECT);
    var c = result.httpCacheGet.get(result.httpCacheGet.ac.BLANDLIST);
    var d = result.httpCacheGet.get(result.httpCacheGet.ac.CATEGORYLIST);
    var projectName = result.httpCacheGet.get(result.httpCacheGet.ac.UNITLIST);
    return $q.all([request1, getPromise3, c, d, projectName]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @return {?}
   */
  function resolve() {
    var imageDfd = $q.defer();
    var request1 = result.httpCacheGet.get(result.httpCacheGet.ac.COLORGROUP);
    var getPromise3 = result.httpCacheGet.get(result.httpCacheGet.ac.SIZEGROUP);
    var c = result.httpCacheGet.get(result.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
    return $q.all([request1, getPromise3, c]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  self.viewTitle = ignores.id ? self.NameConstant.KEY291 : self.NameConstant.GOODADD;
  self.isUserAccAvailable = self.GetOperatorEventLimit("KEY176");
  /** @type {string} */
  self.OTHER_GROUP = "999";
  /** @type {number} */
  self.GoodsImgMaxLength = 5;
  /** @type {number} */
  self.state = null == ignores.id ? 0 : 1;
  self.good = {};
  self.goodConfig = {
    moreItem : 0
  };
  self.goodsWarn = {
    isWarnOpen : false
  };
  self.goodsInfo = {
    bland : {},
    unit : {},
    seletedColors : [],
    seletedSizes : [],
    category : {},
    sku : {},
    imgList : [],
    imgHistoryList : [],
    imgHistoryListPage : 1,
    clientItemPrice : [],
    unitPrice : []
  };

  self.goodsAidUnitInfo = {
    aidUnit1 : {},//辅助单位1
    aidUnit2 : {},//辅助单位2
    aidUnit3 : {},//辅助单位3
  };
  /**
   * @return {undefined}
   */
  self.getMoreItem = function() {
    /** @type {number} */
    self.goodConfig.moreItem = 1;
    _this.resize("goodEditCtrlScroll");
  };
  if (ignores.barCode) {
    self.good.barCode = ignores.barCode;
  }
  $modal.fromTemplateUrl("goodsUnit.html", function(theTitle) {
    self.goodsUnitModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });

  $modal.fromTemplateUrl("goodsUnitForPrice.html", function(theTitle) {
    self.goodsUnitForPriceModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });

  $modal.fromTemplateUrl("goodsCategory.html", function(theTitle) {
    self.goodsCategoryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsBland.html", function(theTitle) {
    self.goodsBlandModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsColor.html", function(theTitle) {
    self.goodsColorModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsSize.html", function(theTitle) {
    self.goodsSizeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("goodsSex.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.goodsSexPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openGoodsSexPopover = function(expectedNumberOfNonCommentArgs) {
    self.goodsSexPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideGoodsSexPopover = function() {
    self.goodsSexPopover.hide();
  };
  $modal.fromTemplateUrl("goodsSKU.html", function(theTitle) {
    self.goodsSKUModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("clientItemPrice.html", function(theTitle) {
    self.clientItemPriceModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("unitPrice.html", function(theTitle) {
    self.unitPriceModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("initStore.html", function(theTitle) {
    /** @type {number} */
    self.initStoreModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.openInitStoreModal = function() {
    self.initStoreModal.show();
  };
  FB.fromTemplateUrl("storeHousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.storeHousePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStoreHousePopover = function(expectedNumberOfNonCommentArgs) {
    self.storeHousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.closeStoreHousePopover = function() {
    self.storeHousePopover.hide();
  };
  $modal.fromTemplateUrl("goodImages.html", function(theTitle) {
    /** @type {number} */
    self.goodImagesModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodImgHistory.html", function(theTitle) {
    /** @type {number} */
    self.goodImgHistoryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @param {?} b
   * @return {undefined}
   */
  self.showGoodImage = function(b) {
    if (!angular.equals(self.goodsInfo.image, self.goodsInfo.imgList[b].url)) {
      self.goodsInfo.image = self.goodsInfo.imgList[b].url;
      _this.zoomTo("goodImagesScroll", 1, false, 0, 0);
    }
    self.goodImagesModal.show();
  };
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY150.html", function(theTitle) {
    self.clientItemStatusModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("addGoodOperation.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.addGoodOperationPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAddGoodOperationPopover = function(expectedNumberOfNonCommentArgs) {
    self.addGoodOperationPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {?}
   */
  var $http = function() {
    return result.post("/KEY114?page=" + self.goodsInfo.imgHistoryListPage);
  };
  /**
   * @param {Array} data
   * @return {undefined}
   */
  var loop = function(data) {
    /** @type {number} */
    var i = 0;
    for (;i < data.length;i++) {
      /** @type {number} */
      data[i].sel = UnitTools.fnCheckGtoreQty(self.goodsInfo.imgList, "imgId", data[i].id) ? 1 : 0;
    }
  };
  /**
   * @return {undefined}
   */
  self.loadGoodsImgHistory = function() {
    self.goodImgHistoryModal.show();
    /** @type {boolean} */
    self.goodsImgHistoryLoading = true;
    var options = socket.get("imgHistoryListCache");
    if (options) {
      self.goodsInfo.imgHistoryList = options.rows;
      loop(self.goodsInfo.imgHistoryList);
      /** @type {boolean} */
      self.loadMoreHisImgBtn = options.page < options.total;
      self.goodsInfo.imgHistoryListPage = options.page;
      /** @type {boolean} */
      self.goodsImgHistoryLoading = false;
    } else {
      $http().success(function(data) {
        self.goodsInfo.imgHistoryList = data.rows;
        /** @type {boolean} */
        self.loadMoreHisImgBtn = data.page < data.total;
        socket.put("imgHistoryListCache", data);
      }).finally(function() {
        loop(self.goodsInfo.imgHistoryList);
        /** @type {boolean} */
        self.goodsImgHistoryLoading = false;
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.getMoreImgHistory = function() {
    /** @type {boolean} */
    self.goodsImgHistoryLoading = true;
    self.goodsInfo.imgHistoryListPage++;
    $http().success(function(data) {
      loop(data.rows);
      self.goodsInfo.imgHistoryList = self.goodsInfo.imgHistoryList.concat(data.rows);
      /** @type {boolean} */
      self.loadMoreHisImgBtn = data.page < data.total;
      var $scope = socket.get("imgHistoryListCache");
      $scope.rows = self.goodsInfo.imgHistoryList;
      $scope.page = data.page;
      $scope.total = data.total;
      socket.put("imgHistoryListCache", $scope);
    }).finally(function() {
      _this.resize("imgHistoryListCtrlScroll");
      /** @type {boolean} */
      self.goodsImgHistoryLoading = false;
    });
  };
  /**
   * @param {string} deepDataAndEvents
   * @param {string} value
   * @return {undefined}
   */
  self.selGoodImgHis = function(deepDataAndEvents, value) {
    /** @type {number} */
    var i = 0;
    for (;i < self.goodsInfo.imgHistoryList.length;i++) {
      if (self.goodsInfo.imgHistoryList[i].id === value) {
        if (self.goodsInfo.imgHistoryList[i].sel = !self.goodsInfo.imgHistoryList[i].sel, self.goodsInfo.imgHistoryList[i].sel) {
          if (void 0 == UnitTools.fnCheckGtoreQty(self.goodsInfo.imgList, "imgId", value) && self.goodsInfo.imgList.length < self.GoodsImgMaxLength) {
            if (1 === self.state) {
              loading.show();
              result.post("/KEY115?goodsId=" + deepDataAndEvents + "&imgId=" + value).success(function(mod) {
                self.goodsInfo.imgList.push({
                  name : self.goodsInfo.imgHistoryList[i].name,
                  url : self.goodsInfo.imgHistoryList[i].url,
                  imgId : self.goodsInfo.imgHistoryList[i].id,
                  id : mod.object.id
                });
                if (1 === self.goodsInfo.imgList.length) {
                  self.selPreview(deepDataAndEvents, value);
                }
              }).finally(function() {
                loading.hide();
                socket.put("goodListRefresh", true);
              });
            } else {
              self.goodsInfo.imgList.push({
                name : self.goodsInfo.imgHistoryList[i].name,
                url : self.goodsInfo.imgHistoryList[i].url,
                imgId : self.goodsInfo.imgHistoryList[i].id,
                id : -1
              });
              if (1 === self.goodsInfo.imgList.length) {
                self.selPreview(deepDataAndEvents, value);
              }
            }
          } else {
            /** @type {number} */
            self.goodsInfo.imgHistoryList[i].sel = 0;
          }
        } else {
          var d = UnitTools.fnCheckGtoreQty(self.goodsInfo.imgList, "imgId", value);
          self.delRelImg(d);
        }
        break;
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.doneSelGoodImgHis = function() {
    self.goodImgHistoryModal.hide();
  };
  /**
   * @return {undefined}
   */
  self.closeGoodsSizeModal = function() {
    self.goodsSizeModal.hide().then(function() {
      self.refreshAutoBarcode();
    });
  };
  /**
   * @return {undefined}
   */
  self.closeGoodsColorModal = function() {
    self.goodsColorModal.hide().then(function() {
      self.refreshAutoBarcode();
    });
  };
  self.$on("$destroy", function() {
    self.goodsSexPopover.remove();
    self.goodsUnitModal.remove();
    self.goodsUnitForPriceModal.remove();
    self.goodsBlandModal.remove();
    self.goodsColorModal.remove();
    self.goodsSizeModal.remove();
    self.goodsCategoryModal.remove();
    self.goodsSKUModal.remove();
    self.clientItemPriceModal.remove();
    self.unitPriceModal.remove();
    self.goodImagesModal.remove();
    self.goodImgHistoryModal.remove();
    self.clientItemStatusModal.remove();
    self.initStoreModal.remove();
    self.storeHousePopover.remove();
    self.addGoodOperationPopover.remove();
  });
  /**
   * @param {string} dataAndEvents
   * @return {undefined}
   */
  self.scanCode = function(dataAndEvents) {
    Hogan.scan().then(function(result) {
      if (!result.cancelled) {
        done("goodsSn" == dataAndEvents ? function() {
          self.good.goodsSn = result.text;
        } : function() {
          if(dataAndEvents === 'aidBarCode1'){
            self.goodsAidUnitInfo.barCode1 = result.text;
          } else if(dataAndEvents === 'aidBarCode2') {
            self.goodsAidUnitInfo.barCode2 = result.text;
          } else if(dataAndEvents === 'aidBarCode3') {
            self.goodsAidUnitInfo.barCode3 = result.text;
          } else {
            self.good.barCode = result.text;
          }
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @param {?} x
   * @param {?} y
   * @param {string} dataAndEvents
   * @return {undefined}
   */
  self.scanSkuCode = function(x, y, dataAndEvents) {
    Hogan.scan().then(function(result) {
      if (!result.cancelled) {
        done("skuSn" == dataAndEvents ? function() {
          if (x in self.goodsInfo.sku) {
            if (y in self.goodsInfo.sku[x]) {
              self.goodsInfo.sku[x][y].skuSn = result.text;
            } else {
              self.goodsInfo.sku[x][y] = {
                skuSn : result.text,
                skuBarCode : ""
              };
            }
          } else {
            self.goodsInfo.sku[x] = {};
            self.goodsInfo.sku[x][y] = {
              skuSn : result.text,
              skuBarCode : ""
            };
          }
        } : function() {
          if (x in self.goodsInfo.sku) {
            if (y in self.goodsInfo.sku[x]) {
              self.goodsInfo.sku[x][y].skuBarCode = result.text;
            } else {
              self.goodsInfo.sku[x][y] = {
                skuSn : "",
                skuBarCode : result.text
              };
            }
          } else {
            self.goodsInfo.sku[x] = {};
            self.goodsInfo.sku[x][y] = {
              skuSn : "",
              skuBarCode : result.text
            };
          }
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {undefined}
   */
  self.getBarcodeConfig = function() {
    result.post("/KEY071").success(function(res) {
      if (1 == res.statusCode) {
        self.barcodeCofig = res.object.barcodeConfig;
        self.nextBarcode = res.object.nextBarcode;
        self.refreshAutoBarcode();
      } else {
        if (res.content) {
          UnitTools.toastShow(res.content);
        }
        delete self.barcodeCofig;
      }
    }).error(function(reply, dataAndEvents) {
      if (0 != dataAndEvents) {
        console.log("error:" + reply);
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.refreshAutoBarcode = function() {
    if (self.barcodeCofig) {
      done(function() {
        if (1 == self.barcodeCofig.barcodeItem) {
          if (!self.good.barCode) {
            self.good.barCode = self.nextBarcode;
            self.nextBarcode = UnitTools.getNextEan13Code(self.nextBarcode);
          }
        } else {
          if (2 == self.barcodeCofig.barcodeItem) {
            if (0 == self.goodsInfo.seletedColors.length || 0 == self.goodsInfo.seletedSizes) {
              return false;
            }
            /** @type {number} */
            var conditionIndex = 0;
            for (;conditionIndex < self.goodsInfo.seletedColors.length;conditionIndex++) {
              var condition = self.goodsInfo.seletedColors[conditionIndex];
              /** @type {number} */
              var i = 0;
              for (;i < self.goodsInfo.seletedSizes.length;i++) {
                var seg = self.goodsInfo.seletedSizes[i];
                if (!self.goodsInfo.sku) {
                  self.goodsInfo.sku = {};
                }
                if (!(condition.id in self.goodsInfo.sku)) {
                  self.goodsInfo.sku[condition.id] = {};
                }
                if (self.goodsInfo.sku[condition.id][seg.id]) {
                  if (!self.goodsInfo.sku[condition.id][seg.id].skuBarCode) {
                    self.goodsInfo.sku[condition.id][seg.id].skuBarCode = self.nextBarcode;
                    self.nextBarcode = UnitTools.getNextEan13Code(self.nextBarcode);
                  }
                } else {
                  self.goodsInfo.sku[condition.id][seg.id] = {
                    skuBarCode : self.nextBarcode
                  };
                  self.nextBarcode = UnitTools.getNextEan13Code(self.nextBarcode);
                }
              }
            }
          }
        }
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.generateGoodsSn = function() {
    if (context.companyConfigData.goodsSngenneratorOn) {
      if (1 == self.getAppAccResource(3)) {
        result.post("/KEY099").success(function(res) {
          if (1 == res.statusCode) {
            self.good.goodsSn = res.object.nextGoodsSn;
          } else {
            UnitTools.toastShow(res.content);
          }
        });
      }
    }
  };
  /**
   * @param {?} v
   * @param {boolean} dataAndEvents
   * @return {?}
   修改使用小数
   */
  self.fixedInputNumber = function(v, dataAndEvents) {
    /** @type {RegExp} */
    return UnitTools.getValidNum(v, dataAndEvents);
  };
  /**
   * @return {undefined}
   */
  self.changeToAdd = function() {
    _this.scrollTop("goodEditCtrlScroll");
    /** @type {number} */
    self.goodConfig.moreItem = 0;
    /** @type {number} */
    self.state = 0;
    self.viewTitle = self.NameConstant.GOODADD;
    self.good = {};
    var initStore = self.goodsInfo.initStore;
    var codeSegments = self.goodsInfo.clientItemPrice;
    self.goodsInfo = {};
    self.goodsInfo.initStore = initStore;
    /** @type {number} */
    var i = 0;
    for (;i < self.goodsStoredList.length;i++) {
      /** @type {string} */
      self.goodsStoredList[i].number = "";
    }
    /** @type {number} */
    i = 0;
    for (;i < codeSegments.length;i++) {
      /** @type {string} */
      codeSegments[i].price = "";
    }
    self.goodsInfo.clientItemPrice = codeSegments;
    /** @type {Array} */
    self.goodsInfo.imgList = [];
    self.goodsInfo.seletedColors = [];
    self.goodsInfo.seletedSizes = [];
    self.InitGoodDefaultColorSize();//初始化默认颜色尺码组
    /** @type {Array} */
    self.goodsInfo.imgHistoryList = [];
    /** @type {number} */
    self.goodsInfo.imgHistoryListPage = 1;
    self.goodsInfo.bland = {};
    self.goodsInfo.unit = {};
    self.goodsInfo.category = {};
    /** @type {number} */
    self.good.sex = 0;
    /** @type {boolean} */
    self.goodsInfo.isOnSale = true;
    /** @type {number} */
    self.good.showOrder = 100;
    self.initChangeHouseOrAddCS(self.initStoreHouse.id);
    self.getBarcodeConfig();
    self.generateGoodsSn();
  };
  /**
   * @return {undefined}
   */
  self.changeToCopyAdd = function() {
    _this.scrollTop("goodEditCtrlScroll");
    /** @type {number} */
    self.goodConfig.moreItem = 0;
    /** @type {number} */
    self.state = 0;
    /** @type {string} */
    self.viewTitle = "复制" + self.NameConstant.GOODADD;
    delete self.good.id;
    delete self.good.imgUrl;
    delete self.good.optimisticLockVersion;
    delete self.good.updateTime;
    delete self.good.cid;
    delete self.good.barCode;
    delete self.goodsInfo.sku;
    /** @type {Array} */
    self.goodsInfo.imgList = [];
    self.initChangeHouseOrAddCS(self.initStoreHouse.id);
    self.getBarcodeConfig();
    self.generateGoodsSn();
  };
  /**
   * @param {Object} id
   * @param {string} item
   * @param {string} bytes
   * @return {?}
   */
  self.initChangeHouseOrAddCS = function(id, item, bytes) {
    var data = item ? [item] : self.goodsInfo.seletedColors;
    var codeSegments = bytes ? [bytes] : self.goodsInfo.seletedSizes;
    id = id ? id : self.initStoreHouse.id;
    var copies = {};
    if (null == id) {
      return false;
    }
    /** @type {number} */
    var j = 0;
    for (;j < data.length;j++) {
      /** @type {number} */
      var i = 0;
      for (;i < codeSegments.length;i++) {
        var l = UnitTools.getObjectByObject(self.goodsStoredList, {
          storehouseId : id,
          colorId : data[j].id,
          sizeId : codeSegments[i].id
        });
        if (null == l) {
          copies = {
            storehouseId : id,
            colorId : data[j].id,
            sizeId : codeSegments[i].id,
            number : ""
          };
          self.goodsStoredList.push(copies);
        }
      }
    }
  };
  /**
   * @param {number} a
   * @return {?}
   */
  self.fixedInputStoreNumber = function(a) {
    return 0 > a && (a = -a), parseInt(a);
  };
  /**
   * @param {?} a
   * @param {?} dataAndEvents
   * @param {string} deepDataAndEvents
   * @param {?} ignoreMethodDoesntExist
   * @return {?}
   */
  self.getInitNumberObj = function(a, dataAndEvents, deepDataAndEvents, ignoreMethodDoesntExist) {
    var b = {
      storehouseId : dataAndEvents,
      colorId : deepDataAndEvents,
      sizeId : ignoreMethodDoesntExist
    };
    return UnitTools.getObjectByObject(a, b) ? UnitTools.getObjectByObject(a, b) : "";
  };
  /**
   * @return {undefined}
   */
  self.modifyWarnNum = function() {
    _this.resize("goodEditCtrlScroll");
    if (self.goodsWarn.isWarnOpen) {
      /** @type {number} */
      self.good.warnNumberTop = parseInt(context.companyConfigData.warnNumberTop);
      /** @type {number} */
      self.good.warnNumberLow = parseInt(context.companyConfigData.warnNumberLow);
    }
  };
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  self.saveGood = function(dataAndEvents) {
    if (self.goodsInfo.isSaving = true, !self.good.name) {
      return UnitTools.toastShow("请填写名称！", "short"), console.log("请填写名称！"), void(self.goodsInfo.isSaving = false);
    }
    if (!self.good.goodsSn) {
      return UnitTools.toastShow("请填写货号！", "short"), console.log("请填写货号！"), void(self.goodsInfo.isSaving = false);
    }
    if (UnitTools.isEmpty(self.goodsInfo.seletedColors)) {
      return context.currentServer === context.exServer ? UnitTools.toastShow("请选择颜色，非服装行业下载辛巴手机版", "short") : UnitTools.toastShow("请选择颜色！", "short"), console.log("请选择颜色！"), void(self.goodsInfo.isSaving = false);
    }
    if (UnitTools.isEmpty(self.goodsInfo.seletedSizes)) {
      return context.currentServer === context.exServer ? UnitTools.toastShow("请选择尺码，非服装行业下载辛巴手机版", "short") : UnitTools.toastShow("请选择尺码！", "short"), console.log("请选择尺码！"), void(self.goodsInfo.isSaving = false);
    }
    if (!self.good.showOrder) {
      return UnitTools.toastShow("请在排序栏输入整数", "short", "center"), console.log("请在排序栏输入整数"), void(self.goodsInfo.isSaving = false);
    }
    if (self.goodsWarn.isWarnOpen) {
      if (!self.good.warnNumberLow && (null != self.good.warnNumberLow && 0 != self.good.warnNumberLow)) {
        return UnitTools.toastShow("库存预警下限不能小于0！", "short", "center"), console.log("库存预警下限不能小于0！"), void(self.goodsInfo.isSaving = false);
      }
      if (!self.good.warnNumberTop && (null != self.good.warnNumberTop && 0 != self.good.warnNumberTop)) {
        return UnitTools.toastShow("库存预警上限不能大于100000！", "short", "center"), console.log("库存预警上限不能大于100000！"), void(self.goodsInfo.isSaving = false);
      }
      if (null != self.good.warnNumberLow && (null != self.good.warnNumberTop && self.good.warnNumberLow >= self.good.warnNumberTop)) {
        return UnitTools.toastShow("库存预警上限必须大于下限！", "short", "center"), console.log("库存预警上限必须大于下限！"), void(self.goodsInfo.isSaving = false);
      }
    }
    if (self.goodsWarn.isWarnOpen || (self.good.warnNumberTop = null, self.good.warnNumberLow = null), void 0 === self.good.factoryPrice || (null === self.good.factoryPrice || "" === self.good.factoryPrice)) {
      /** @type {number} */
      self.good.factoryPrice = 0;
    } else {
      if (self.good.factoryPrice < 0) {
        return UnitTools.toastShow("进货价不能为负数", "short"), self.goodsInfo.isSaving = false, false;
      }
      self.good.factoryPrice = self.fixedInputNumber(self.good.factoryPrice);
    }
    if (void 0 === self.good.tradePrice || (null === self.good.tradePrice || "" === self.good.tradePrice)) {
      /** @type {number} */
      self.good.tradePrice = 0;
    } else {
      if (self.good.tradePrice < 0) {
        return UnitTools.toastShow("批发价不能为负数", "short"), self.goodsInfo.isSaving = false, false;
      }
      self.good.tradePrice = self.fixedInputNumber(self.good.tradePrice);
    }
    if (void 0 === self.good.retailPriceArea || (null === self.good.retailPriceArea || "" === self.good.retailPriceArea)) {
      /** @type {number} */
      self.good.retailPriceArea = 0;
    } else {
      if (self.good.retailPriceArea < 0) {
        return UnitTools.toastShow("零售价不能为负数", "short"), self.goodsInfo.isSaving = false, false;
      }
      self.good.retailPriceArea = self.fixedInputNumber(self.good.retailPriceArea);
    }
    /** @type {Array} */
    var schema = [];
    /** @type {Array} */
    var defs = [];
    if (self.goodsInfo.seletedColors.forEach(function(test) {
      schema.push(test.id.toString());
    }), self.goodsInfo.seletedSizes.forEach(function(test) {
      defs.push(test.id.toString());
    }), self.good.colorIds = schema.join(), self.good.sizeIds = defs.join(), self.good.blandId = self.goodsInfo.bland.id, self.good.unit = self.goodsInfo.unit.name, self.good.isOnSale = self.goodsInfo.isOnSale ? 1 : 2, self.good.categoryId = self.goodsInfo.category.id, loading.show(true), "insert" === dataAndEvents) {
      /** @type {Array} */
      var new_val = [];
      var m;
      for (m in self.goodsInfo.sku) {
        var d;
        for (d in self.goodsInfo.sku[m]) {
          if (UnitTools.includes(schema, m) && (UnitTools.includes(defs, d) && (self.goodsInfo.sku[m][d].skuSn || self.goodsInfo.sku[m][d].skuBarCode))) {
            var copies = {
              colorId : m,
              sizeId : d
            };
            if (self.goodsInfo.sku[m][d].skuSn) {
              copies.skuSn = self.goodsInfo.sku[m][d].skuSn;
            }
            if (self.goodsInfo.sku[m][d].skuBarCode) {
              copies.skuBarCode = self.goodsInfo.sku[m][d].skuBarCode;
            }
            new_val.push(copies);
          }
        }
      }
      /** @type {number} */
      self.good.year = (new Date).getFullYear();
      /** @type {string} */
      var optsData = "";
      /** @type {number} */
      var i = 0;
      for (;i < self.goodsInfo.imgList.length;i++) {
        if (1 === self.goodsInfo.imgList[i].type) {
          optsData = self.goodsInfo.imgList[i].imgId;
          break;
        }
      }
      /** @type {Array} */
      var items = [];
      /** @type {number} */
      var j = 0;
      for (;j < self.goodsInfo.clientItemPrice.length;j++) {
        if (self.goodsInfo.clientItemPrice[j].price || 0 === self.goodsInfo.clientItemPrice[j].price) {
          if (self.goodsInfo.clientItemPrice[j].price < 0) {
            return loading.hide(), UnitTools.toastShow("客户分类价格不能为负数"), self.goodsInfo.isSaving = false, false;
          }
          items.push({
            goodsSn : self.good.goodsSn,
            clientItemId : self.goodsInfo.clientItemPrice[j].id,
            price : self.goodsInfo.clientItemPrice[j].price
          });
        }
      }

      //处理多单位价格
      var unitPrices = [];
      if(self.good.unit) {
        if (self.goodsAidUnitInfo.aidUnit1 && self.goodsAidUnitInfo.tradePrice1 && self.goodsAidUnitInfo.retailPriceArea1){
          unitPrices.push({
            goodsSn : self.good.goodsSn,
            unitId : self.goodsAidUnitInfo.aidUnit1.id,
            unitName : self.goodsAidUnitInfo.aidUnit1.name,
            prepPrice1 : self.goodsAidUnitInfo.tradePrice1,
            priceRetail : self.goodsAidUnitInfo.retailPriceArea1,
            barCode : self.goodsAidUnitInfo.barCode1,
            unitRate : self.goodsAidUnitInfo.unitRate1
          });
        }

        if (self.goodsAidUnitInfo.aidUnit2 && self.goodsAidUnitInfo.tradePrice2 && self.goodsAidUnitInfo.retailPriceArea2){
          unitPrices.push({
            goodsSn : self.good.goodsSn,
            unitId : self.goodsAidUnitInfo.aidUnit2.id,
            unitName : self.goodsAidUnitInfo.aidUnit2.name,
            prepPrice1 : self.goodsAidUnitInfo.tradePrice2,
            priceRetail : self.goodsAidUnitInfo.retailPriceArea2,
            barCode : self.goodsAidUnitInfo.barCode2,
            unitRate : self.goodsAidUnitInfo.unitRate2
          });
        }

        if (self.goodsAidUnitInfo.aidUnit2 && self.goodsAidUnitInfo.tradePrice3 && self.goodsAidUnitInfo.retailPriceArea3){
          unitPrices.push({
            goodsSn : self.good.goodsSn,
            unitId : self.goodsAidUnitInfo.aidUnit3.id,
            unitName : self.goodsAidUnitInfo.aidUnit3.name,
            prepPrice1 : self.goodsAidUnitInfo.tradePrice3,
            priceRetail : self.goodsAidUnitInfo.retailPriceArea3,
            barCode : self.goodsAidUnitInfo.barCode3,
            unitRate : self.goodsAidUnitInfo.unitRate3
          });
        }
      }

      /** @type {Array} */
      var ids = [];
      /** @type {number} */
      j = 0;
      for (;j < self.goodsInfo.seletedColors.length;j++) {
        ids.push(self.goodsInfo.seletedColors[j].id);
      }
      /** @type {Array} */
      var collided_with = [];
      /** @type {number} */
      j = 0;
      for (;j < self.goodsInfo.seletedSizes.length;j++) {
        collided_with.push(self.goodsInfo.seletedSizes[j].id);
      }
      /** @type {Array} */
      var results = [];
      /** @type {number} */
      j = 0;
      for (;j < self.goodsStoredList.length;j++) {
        if (self.goodsStoredList[j].number > 0 || 0 === self.goodsStoredList[j].number) {
          if (ids.indexOf(self.goodsStoredList[j].colorId) > -1) {
            if (collided_with.indexOf(self.goodsStoredList[j].sizeId) > -1) {
              results.push(self.goodsStoredList[j]);
            }
          }
        }
      }
      result.postEncode("/KEY084", {
        imgIds : UnitTools.objectArrayToIdString(self.goodsInfo.imgList, "imgId", ","),
        previewImgId : optsData,
        goodModel : angular.toJson(self.good),
        skuModelList : angular.toJson(new_val),
        clientItemPriceList : angular.toJson(items),
        goodsStoredList : angular.toJson(results),
        unitPriceList : angular.toJson(unitPrices)
      }).success(function(event) {
        if (1 == event.statusCode) {
          if (UnitTools.union(self.good, event.object), self.state = 1, self.viewTitle = self.NameConstant.KEY291, socket.put("goodListRefresh", true), socket.get("needToAddGoodsFlag") === true) {
            /**
             * @return {undefined}
             */
            var finish = function() {
              done(function() {
                socket.put("addGoodsFlag", true);
                socket.put("newGoodsObj", self.good);
                self.goBack();
              });
            };
            _.alert({
              template : "<div class='tc'>新增商品成功</div>",
              okText : "确定"
            }).then(finish);
          } else {
            UnitTools.toastShow("新增商品成功");
          }
        } else {
          _.alert({
            template : "<div class='tc'>" + event.content + "</div>",
            okText : "确定"
          });
        }
      }).finally(function() {
        loading.hide();
        /** @type {boolean} */
        self.goodsInfo.isSaving = false;
      });
    } else {
      if ("update" === dataAndEvents) {
        /** @type {Array} */
        new_val = [];
        for (m in self.goodsInfo.sku) {
          for (d in self.goodsInfo.sku[m]) {
            if (UnitTools.includes(schema, m) && (UnitTools.includes(defs, d) && (self.goodsInfo.sku[m][d].skuSn || self.goodsInfo.sku[m][d].skuBarCode))) {
              copies = {
                goodId : self.good.id,
                colorId : m,
                sizeId : d
              };
              if (self.goodsInfo.sku[m][d].skuSn) {
                copies.skuSn = self.goodsInfo.sku[m][d].skuSn;
              }
              if (self.goodsInfo.sku[m][d].skuBarCode) {
                copies.skuBarCode = self.goodsInfo.sku[m][d].skuBarCode;
              }
              new_val.push(copies);
            }
          }
        }
        /** @type {Array} */
        items = [];
        /** @type {number} */
        j = 0;
        for (;j < self.goodsInfo.clientItemPrice.length;j++) {
          if (self.goodsInfo.clientItemPrice[j].price || 0 === self.goodsInfo.clientItemPrice[j].price) {
            if (self.goodsInfo.clientItemPrice[j].price < 0) {
              return loading.hide(), UnitTools.toastShow("客户分类价格不能为负数"), self.goodsInfo.isSaving = false, false;
            }
            items.push({
              goodsSn : self.good.goodsSn,
              clientItemId : self.goodsInfo.clientItemPrice[j].id,
              price : self.goodsInfo.clientItemPrice[j].price
            });
          }
        }

        //处理多单位价格
        var unitPrices = [];
        if(self.good.unit) {
          if (self.goodsAidUnitInfo.aidUnit1.id && self.goodsAidUnitInfo.tradePrice1 && self.goodsAidUnitInfo.retailPriceArea1 && self.goodsAidUnitInfo.unitRate1){
            unitPrices.push({
              goodsSn : self.good.goodsSn,
              unitId : self.goodsAidUnitInfo.aidUnit1.id,
              unitName : self.goodsAidUnitInfo.aidUnit1.name,
              unitRate : self.goodsAidUnitInfo.unitRate1,
              prepPrice1 : self.goodsAidUnitInfo.tradePrice1,
              priceRetail : self.goodsAidUnitInfo.retailPriceArea1,
              barCode : self.goodsAidUnitInfo.barCode1
            });
          }

          if (self.goodsAidUnitInfo.aidUnit2.id && self.goodsAidUnitInfo.tradePrice2 && self.goodsAidUnitInfo.retailPriceArea2 && self.goodsAidUnitInfo.unitRate2){
            unitPrices.push({
              goodsSn : self.good.goodsSn,
              unitId : self.goodsAidUnitInfo.aidUnit2.id,
              unitName : self.goodsAidUnitInfo.aidUnit2.name,
              unitRate : self.goodsAidUnitInfo.unitRate2,
              prepPrice1 : self.goodsAidUnitInfo.tradePrice2,
              priceRetail : self.goodsAidUnitInfo.retailPriceArea2,
              barCode : self.goodsAidUnitInfo.barCode2
            });
          }

          if (self.goodsAidUnitInfo.aidUnit2.id && self.goodsAidUnitInfo.tradePrice3 && self.goodsAidUnitInfo.retailPriceArea3 && self.goodsAidUnitInfo.unitRate3){
            unitPrices.push({
              goodsSn : self.good.goodsSn,
              unitId : self.goodsAidUnitInfo.aidUnit3.id,
              unitName : self.goodsAidUnitInfo.aidUnit3.name,
              unitRate : self.goodsAidUnitInfo.unitRate3,
              prepPrice1 : self.goodsAidUnitInfo.tradePrice3,
              priceRetail : self.goodsAidUnitInfo.retailPriceArea3,
              barCode : self.goodsAidUnitInfo.barCode3
            });
          }
        }

        result.postEncode("/KEY085", {
          goodModel : angular.toJson(self.good),
          skuModelList : angular.toJson(new_val),
          clientItemPriceList : angular.toJson(items),
          unitPriceList : angular.toJson(unitPrices)
        }).success(function(event) {
          if (1 === event.statusCode) {
            UnitTools.toastShow("修改商品成功");
            UnitTools.union(self.good, event.object);
            socket.put("goodListRefresh", true);
          } else {
            if (11 === event.statusCode) {
              _.alert({
                template : "<div class='tc'>" + event.content + "</div>",
                okText : "确定"
              }).then(function() {
                UnitTools.union(self.good, event.object);
                /** @type {Array} */
                self.goodsInfo.seletedColors = [];
                /** @type {number} */
                var i = 0;
                var ilen = self.allColors.length;
                for (;ilen > i;i++) {
                  if (event.object.colorIds.indexOf(self.allColors[i].id) > -1) {
                    self.goodsInfo.seletedColors.push(self.allColors[i]);
                  }
                }
                /** @type {Array} */
                self.goodsInfo.seletedSizes = [];
                /** @type {number} */
                i = 0;
                ilen = self.allSizes.length;
                for (;ilen > i;i++) {
                  if (event.object.sizeIds.indexOf(self.allSizes[i].id) > -1) {
                    self.goodsInfo.seletedSizes.push(self.allSizes[i]);
                  }
                }
              });
            } else {
              _.alert({
                template : "<div class='tc'>" + event.content + "</div>",
                okText : "确定"
              });
            }
          }
        }).finally(function() {
          loading.hide();
          /** @type {boolean} */
          self.goodsInfo.isSaving = false;
        });
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.deleteGood = function() {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除该商品?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        result.post("/KEY076?id=" + self.good.id).success(function(r) {
          if (1 == r.statusCode) {
            _.alert({
              template : "<div class='tc'>删除成功</div>",
              okText : "确定"
            }).then(function() {
              self.goBack();
            });
          } else {
            if (window.cordova && window.cordova.plugins) {
              if (2 == self.good.isOnSale) {
                UnitTools.showAlert("已开单的商品无法删除，可以在 设置->系统重置 中重置系统数据", null, "提示", "确定");
              } else {
                UnitTools.showConfirm("已开单的商品无法删除，是否停用此商品?", function(dataAndEvents) {
                  if (2 == dataAndEvents) {
                    result.post("/KEY077?id=" + self.good.id).success(function(r) {
                      if (1 == r.statusCode) {
                        self.goBack();
                      }
                    });
                  }
                }, null, ["取消", "停用"]);
              }
            } else {
              var promise = _.confirm({
                template : "<div class='tc'>已开单的商品无法删除，是否停用此商品?</div>",
                cancelText : "取消",
                okText : "停用"
              });
              promise.then(function(dataAndEvents) {
                if (dataAndEvents) {
                  result.post("/KEY077?id=" + self.good.id).success(function(r) {
                    if (1 == r.statusCode) {
                      UnitTools.toastShow("停用成功");
                      self.goBack();
                    }
                  });
                }
              });
            }
          }
        }).finally(function() {
          loading.hide();
          socket.put("goodListRefresh", true);
          socket.put("goodDeleteReturn", true);
        });
      }
    });
  };
  /**
   * @param {string} fileName
   * @return {undefined}
   * 旧图片上传函数
   */
  var UpdateGoodsImgFile = function(fileName) {
    loading.show(!0);
    var options = new FileUploadOptions;
    options.fileKey = "file", options.fileName = fileName.substr(fileName.lastIndexOf("/") + 1) + ".jpg", options.mimeType = "image/jpeg", options.params = {
      module: "goodsAlbum",
      goodsId: self.good.id
    }, options.chunkedMode = !1, exports.uploadFile(context.currentServer + "/KEY112", fileName, options).then(function(req) {
      loading.hide();
      var res = angular.fromJson(req.response);
      if (1 === res.statusCode) {
        self.goodsInfo.imgList.push({
          name: res.object.name,
          url: res.object.url,
          imgId: res.object.id,
          id: res.object.goodsAlbumId
        });
        var data = socket.get("imgHistoryListCache");
        data && (data.rows.unshift({
          id: res.object.id,
          name: res.object.name,
          url: res.object.url
        }), socket.put("imgHistoryListCache", data)), 1 === self.goodsInfo.imgList.length && self.selPreview(self.good.id, self.goodsInfo.imgList[0].imgId), UnitTools.toastShow("图片上传成功！")
      } else UnitTools.toastShow("图片上传失败！");
      item.cleanup().then(function() {
        console.log("CameraService cleanup successfully")
      })
    }, function(self) {
      loading.hide(), UnitTools.toastShow(413 === self.http_status ? "不能上传超过2M的图片！" : "图片上传失败！"), item.cleanup().then(function() {
        console.log("CameraService cleanup successfully")
      })
    }, function() {})
  };

  /**
   * @param {string} fileName
   * @return {undefined}
   * 新图片上传函数
   */
  var success = function(fileName) {
    loading.show(true);
    var options = new FileUploadOptions;
    /** @type {string} */
    options.fileKey = "file";
    options.fileName = fileName.substr(fileName.lastIndexOf("/") + 1) + ".jpg";
    /** @type {string} */
    options.mimeType = "image/jpeg";
    /** @type {boolean} */
    options.chunkedMode = false;
    result.post("/KEY469?module=goodsAlbum&fileName=" + options.fileName).success(function(req) {
      if (1 == req.statusCode) {
        options.params = {
          policy : req.object.policy,
          OSSAccessKeyId : req.object.accessid,
          success_action_status : "200",
          callback : req.object.callback,
          signature : req.object.signature,
          key : req.object.storeName
        };
        if (self.good.id) {
          options.params["x:goodid"] = self.good.id;
        }
        exports.uploadFile(req.object.host, fileName, options).then(function(item) {
          loading.hide();
          var res = angular.fromJson(item.response);
          if (1 === res.statusCode) {
            self.goodsInfo.imgList.push({
              name : res.object.name,
              url : res.object.url,
              imgId : res.object.id,
              id : res.object.goodsAlbumId
            });
            var data = socket.get("imgHistoryListCache");
            if (data) {
              data.rows.unshift({
                id : res.object.id,
                name : res.object.name,
                url : res.object.url
              });
              socket.put("imgHistoryListCache", data);
            }
            if (1 === self.goodsInfo.imgList.length) {
              self.selPreview(self.good.id, self.goodsInfo.imgList[0].imgId);
            }
            UnitTools.toastShow("图片上传成功！");
          } else {
            UnitTools.toastShow("图片上传失败！");
          }
        }, function(err) {
          loading.hide();
          UnitTools.toastShow(413 === err.http_status ? "不能上传超过2M的图片！" : "图片上传失败！");
        }, function() {
        });
      }
    }).finally(function() {
      item.cleanup().then(function() {
        console.log("CameraService cleanup successfully");
      });
    });
  };


  /**
   * @return {undefined}
   */
  self.choosePhoto = function() {
    dialog.show({
      buttons : [{
        text : '<i class="icon ion-camera assertive"></i> 拍 照'
      }, {
        text : '<i class="icon ion-images assertive"></i> 从相册中选择'
      }],
      /**
       * @param {?} clicked
       * @return {?}
       */
      buttonClicked : function(clicked) {
        switch(clicked) {
          case 0:
            item.startCamera(self.platformIsAndroid ? self.sysConfig.allowEditGoodImg : true).then(UpdateGoodsImgFile);
            break;
          case 1:
            item.openCameraRoll(self.platformIsAndroid ? self.sysConfig.allowEditGoodImg : true).then(UpdateGoodsImgFile);
        }
        return true;
      }
    });
  };
  /**
   * @param {Object} n
   * @return {undefined}
   */
  self.delRelImg = function(n) {
    if (-1 === n.id || 0 === self.state) {
      UnitTools.removeByKey(self.goodsInfo.imgList, "imgId", n.imgId);
    } else {
      loading.show();
      result.post("/KEY116?albumId=" + n.id).success(function(r) {
        if (1 === r.statusCode) {
          UnitTools.removeByKey(self.goodsInfo.imgList, "imgId", n.imgId);
          if (1 === n.type) {
            if (self.goodsInfo.imgList.length > 0) {
              self.selPreview(self.good.id, self.goodsInfo.imgList[0].imgId);
            } else {
              socket.put("goodListRefresh", true);
            }
          }
        }
      }).finally(function() {
        loading.hide();
      });
    }
  };
  /** @type {boolean} */
  self.enableDelImgHis = true;
  /**
   * @param {Element} n
   * @return {undefined}
   */
  self.delImgHis = function(n) {
    var promise = _.confirm({
      template : "<div class='tc'>已被商品相册引用的图片将无法删除，删除图片后商品描述、系统公告等文本中引用该图片的地方将无法正确显示图片，是否确认删除？</div>",
      cancelText : "取消",
      okText : "确认删除"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        result.post("/KEY117?imgId=" + n.id).success(function(res) {
          if (1 === res.statusCode) {
            UnitTools.toastShow("删除成功！");
            UnitTools.removeByKey(self.goodsInfo.imgHistoryList, "id", n.id);
            var result = socket.get("imgHistoryListCache");
            UnitTools.removeByKey(result.rows, "id", n.id);
            socket.put("imgHistoryListCache", result);
          } else {
            UnitTools.toastShow(res.content);
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  /**
   * @param {string} deepDataAndEvents
   * @param {string} key
   * @return {undefined}
   */
  self.selPreview = function(deepDataAndEvents, key) {
    if (void 0 != deepDataAndEvents && ("" != deepDataAndEvents && (void 0 != key && "" != key))) {
      loading.show(true);
      result.post("/KEY113?goodId=" + deepDataAndEvents + "&imgId=" + key).success(function(r) {
        if (1 === r.statusCode) {
          /** @type {number} */
          var i = 0;
          for (;i < self.goodsInfo.imgList.length;i++) {
            /** @type {(number|undefined)} */
            self.goodsInfo.imgList[i].type = self.goodsInfo.imgList[i].imgId === key ? 1 : void 0;
          }
        }
      }).finally(function() {
        loading.hide();
        socket.put("goodListRefresh", true);
      });
    } else {
      /** @type {number} */
      var i = 0;
      for (;i < self.goodsInfo.imgList.length;i++) {
        /** @type {(number|undefined)} */
        self.goodsInfo.imgList[i].type = self.goodsInfo.imgList[i].imgId === key ? 1 : void 0;
      }
    }
  };
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectColor = function(key) {
    var camelKey = self.goodsInfo.seletedColors.indexOf(key);
    if (camelKey > -1) {
      self.goodsInfo.seletedColors.splice(camelKey, 1);
    } else {
      self.goodsInfo.seletedColors.push(key);
      if (0 == self.state) {
        self.initChangeHouseOrAddCS("", key, "");
      }
    }
  };
  /**
   * @param {Array} list
   * @param {?} timeoutKey
   * @return {undefined}
   */
  self.selectGroupColors = function(list, timeoutKey) {
    /** @type {boolean} */
    self.colorGroups[timeoutKey].group.status = true;
    /** @type {number} */
    var p = 0;
    for (;p < list.length;p++) {
      var n = self.goodsInfo.seletedColors.indexOf(list[p]);
      if (0 > n) {
        self.goodsInfo.seletedColors.push(list[p]);
        if (0 == self.state) {
          self.initChangeHouseOrAddCS("", list[p], "");
        }
      }
    }
  };
  /**
   * @param {Array} codeSegments
   * @param {?} timeoutKey
   * @return {undefined}
   */
  self.deselectedAllColors = function(codeSegments, timeoutKey) {
    /** @type {boolean} */
    self.colorGroups[timeoutKey].group.status = false;
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      var fromIndex = self.goodsInfo.seletedColors.indexOf(codeSegments[i]);
      if (fromIndex > -1) {
        self.goodsInfo.seletedColors.splice(fromIndex, 1);
      }
    }
  };
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectSize = function(key) {
    var camelKey = self.goodsInfo.seletedSizes.indexOf(key);
    if (camelKey > -1) {
      self.goodsInfo.seletedSizes.splice(camelKey, 1);
    } else {
      self.goodsInfo.seletedSizes.push(key);
      if (0 == self.state) {
        self.initChangeHouseOrAddCS("", "", key);
      }
    }
  };
  /**
   * @param {Array} list
   * @param {?} timeoutKey
   * @return {undefined}
   */
  self.selectGroupSizes = function(list, timeoutKey) {
    /** @type {boolean} */
    self.sizeGroups[timeoutKey].group.status = true;
    /** @type {number} */
    var p = 0;
    for (;p < list.length;p++) {
      var n = self.goodsInfo.seletedSizes.indexOf(list[p]);
      if (0 > n) {
        self.goodsInfo.seletedSizes.push(list[p]);
        if (0 == self.state) {
          self.initChangeHouseOrAddCS("", list[p], "");
        }
      }
    }
  };
  /**
   * @param {Array} codeSegments
   * @param {?} timeoutKey
   * @return {undefined}
   */
  self.deselectedSizes = function(codeSegments, timeoutKey) {
    /** @type {boolean} */
    self.sizeGroups[timeoutKey].group.status = false;
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      var fromIndex = self.goodsInfo.seletedSizes.indexOf(codeSegments[i]);
      if (fromIndex > -1) {
        self.goodsInfo.seletedSizes.splice(fromIndex, 1);
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.getClientItemPrice = function() {
    if (0 == self.goodsInfo.clientItemPrice.length) {
      result.get("/KEY069?priceEnable=true").success(function(dataAndEvents) {
        self.goodsInfo.clientItemPrice = dataAndEvents;
        getObject();
      });
    } else {
      getObject();
    }
  };

  //初始化默认颜色尺码组，非服装版，带入全部颜色尺码
  self.InitGoodDefaultColorSize = function() {
    if(!self.goodsInfo.seletedColors || self.goodsInfo.seletedColors.length === 0){
      self.goodsInfo.seletedColors = [];
      if (self.allColors.length > 0 && self.allColors.length <= 2) {
        //添加全部颜色，新加
        for (i = 0 ; self.allColors.length > i ; i++) {
          self.goodsInfo.seletedColors.push(self.allColors[i]);
        }
      }else if (self.allColors.length > 0 ) {
        //默认取第一个颜色
        self.goodsInfo.seletedColors.push(self.allColors[0]);
      }
    }

    if (!self.goodsInfo.seletedSizes || self.goodsInfo.seletedSizes.length === 0){
      self.goodsInfo.seletedSizes = [];
      if (self.allSizes.length >0 && self.allSizes.length <= 2) {
        //添加全部尺码，新加
        for (i = 0 ; self.allSizes.length > i ; i++) {
          self.goodsInfo.seletedSizes.push(self.allSizes[i]);
        }
      }else if (self.allSizes.length >0 ) {
        //默认取第一个尺码
        self.goodsInfo.seletedSizes.push(self.allSizes[0]);
      }
    }

  };

  self.$on("$ionicView.loaded", function() {
    loading.show();
    fetch().then(function(packs) {
      self.allColors = packs[0].data.optionList;
      self.allSizes = packs[1].data.optionList;
      self.arrBland = packs[2].data;
      var c = packs[3].data.rows;
      self.allCategoryList = c;
      self.categoryTree = UnitTools.treeForCategory(0, "", false, c).children;
      self.allUnits = packs[4].data;
      if (ignores.id) {
        _this.scrollTop("goodEditCtrlScroll");
        /** @type {number} */
        self.state = 1;
        result.post("/KEY063?id=" + ignores.id).success(function(fx) {
          loading.hide();
          self.good = fx.goodsVO;
          if (null != self.good.warnNumberLow || null != self.good.warnNumberTop) {
            /** @type {boolean} */
            self.goodsWarn.isWarnOpen = true;
          }
          /** @type {number} */
          var i = 0;
          var ilen = self.allColors.length;
          for (;ilen > i;i++) {
            if (fx.goodsVO.colorIds.indexOf(self.allColors[i].id) > -1) {
              self.goodsInfo.seletedColors.push(self.allColors[i]);
            }
          }
          /** @type {number} */
          i = 0;
          ilen = self.allSizes.length;
          for (;ilen > i;i++) {
            if (fx.goodsVO.sizeIds.indexOf(self.allSizes[i].id) > -1) {
              self.goodsInfo.seletedSizes.push(self.allSizes[i]);
            }
          }
          var character = UnitTools.fnCheckGtoreQty(self.arrBland, "id", fx.goodsVO.blandId);
          self.goodsInfo.bland = character ? character : {};
          var unit = UnitTools.fnCheckGtoreQty(self.allUnits, "name", fx.goodsVO.unit);
          self.goodsInfo.unit = unit ? unit : {};
          /** @type {boolean} */
          self.goodsInfo.isOnSale = 1 === fx.goodsVO.isOnSale;
          var pos = UnitTools.fnCheckGtoreQty(c, "id", fx.goodsVO.categoryId);
          self.goodsInfo.category = pos ? pos : {};
          /** @type {number} */
          i = 0;
          ilen = fx.goodsSkuList.length;
          for (;ilen > i;i++) {
            var event = fx.goodsSkuList[i];
            if (!(event.colorId in self.goodsInfo.sku)) {
              self.goodsInfo.sku[event.colorId] = {};
            }
            self.goodsInfo.sku[event.colorId][event.sizeId] = {
              skuSn : event.skuSn,
              skuBarCode : event.skuBarCode
            };
          }
          self.goodsClientItemPriceList = fx.goodsClientItemList;

          //多单位价格回显
          var goodsUnitPriceItems = fx.goodsUnitPriceList;
          for (var j = 0; j < goodsUnitPriceItems.length; j++) {
            var unitPriceItem = goodsUnitPriceItems[j];
            if (j === 0){
              self.goodsAidUnitInfo.aidUnit1.id = unitPriceItem.unitId;
              self.goodsAidUnitInfo.aidUnit1.name = unitPriceItem.unitName;
              self.goodsAidUnitInfo.tradePrice1 = unitPriceItem.prepPrice1;
              self.goodsAidUnitInfo.retailPriceArea1 = unitPriceItem.priceRetail;
              self.goodsAidUnitInfo.unitRate1 = unitPriceItem.unitRate;
              self.goodsAidUnitInfo.barCode1 = unitPriceItem.barCode;
            } else if(j === 1){
              self.goodsAidUnitInfo.aidUnit2.id = unitPriceItem.unitId;
              self.goodsAidUnitInfo.aidUnit2.name = unitPriceItem.unitName;
              self.goodsAidUnitInfo.tradePrice2 = unitPriceItem.prepPrice1;
              self.goodsAidUnitInfo.retailPriceArea2 = unitPriceItem.priceRetail;
              self.goodsAidUnitInfo.unitRate2 = unitPriceItem.unitRate;
              self.goodsAidUnitInfo.barCode2 = unitPriceItem.barCode;
            } else if(j === 2) {
              self.goodsAidUnitInfo.aidUnit3.id = unitPriceItem.unitId;
              self.goodsAidUnitInfo.aidUnit3.name = unitPriceItem.unitName;
              self.goodsAidUnitInfo.tradePrice3 = unitPriceItem.prepPrice1;
              self.goodsAidUnitInfo.retailPriceArea3 = unitPriceItem.priceRetail;
              self.goodsAidUnitInfo.unitRate3 = unitPriceItem.unitRate;
              self.goodsAidUnitInfo.barCode3 = unitPriceItem.barCode;
            }
          }
          self.getClientItemPrice();
          self.getBarcodeConfig();
          self.InitGoodDefaultColorSize();//初始化默认颜色尺码组
        }).finally(function() {
          loading.hide();
        });
        /** @type {boolean} */
        self.goodsImgloading = true;
        done(function() {
          result.post("/KEY075?goodsId=" + ignores.id).success(function(res) {
            self.goodsInfo.imgList = res.rows;
          }).finally(function() {
            /** @type {boolean} */
            self.goodsImgloading = false;
          });
        }, 500);
      } else {
        _this.scrollTop("goodEditCtrlScroll");
        loading.hide();
        /** @type {number} */
        self.good.sex = 0;
        /** @type {boolean} */
        self.goodsInfo.isOnSale = true;
        /** @type {number} */
        self.good.showOrder = 100;
        self.getClientItemPrice();
        self.getBarcodeConfig();
        self.generateGoodsSn();
        self.InitGoodDefaultColorSize();//初始化默认颜色尺码组
      }
      done(function() {
        resolve().then(function(packs) {
          self.allColorGroups = packs[0].data;
          self.allSizeGroups = packs[1].data;
          self.colorGroups = {};
          self.allColorGroups.forEach(function(data) {
            self.colorGroups[data.id] = {};
            self.colorGroups[data.id].group = data;
            /** @type {Array} */
            self.colorGroups[data.id].colors = [];
          });
          if (!(self.allColors && 0 != self.allColors.length)) {
            self.colorGroups[self.OTHER_GROUP] = {};
            self.colorGroups[self.OTHER_GROUP].group = {
              name : "其他"
            };
            /** @type {Array} */
            self.colorGroups[self.OTHER_GROUP].colors = [];
          }
          self.allColors.forEach(function(s) {
            var i = s.colorGroupId ? s.colorGroupId : self.OTHER_GROUP;
            if (i in self.colorGroups) {
              self.colorGroups[i].colors.push(s);
            } else {
              if (!(self.OTHER_GROUP in self.colorGroups)) {
                self.colorGroups[self.OTHER_GROUP] = {};
                self.colorGroups[self.OTHER_GROUP].group = {
                  name : "其他"
                };
                /** @type {Array} */
                self.colorGroups[self.OTHER_GROUP].colors = [];
              }
              self.colorGroups[self.OTHER_GROUP].colors.push(s);
            }
          });
          self.sizeGroups = {};
          self.allSizeGroups.forEach(function(data) {
            self.sizeGroups[data.id] = {};
            self.sizeGroups[data.id].group = data;
            /** @type {Array} */
            self.sizeGroups[data.id].sizes = [];
          });
          if (!(self.allSizes && 0 != self.allSizes.length)) {
            self.sizeGroups[self.OTHER_GROUP] = {};
            self.sizeGroups[self.OTHER_GROUP].group = {
              name : "其他"
            };
            /** @type {Array} */
            self.sizeGroups[self.OTHER_GROUP].sizes = [];
          }
          self.allSizes.forEach(function(s) {
            var id = s.sizeGroupId ? s.sizeGroupId : self.OTHER_GROUP;
            if (id in self.sizeGroups && id !== self.OTHER_GROUP) {
              self.sizeGroups[id].sizes.push(s);
            } else {
              if (!(self.OTHER_GROUP in self.sizeGroups)) {
                self.sizeGroups[self.OTHER_GROUP] = {};
                self.sizeGroups[self.OTHER_GROUP].group = {
                  name : "其他"
                };
                /** @type {Array} */
                self.sizeGroups[self.OTHER_GROUP].sizes = [];
              }
              self.sizeGroups[self.OTHER_GROUP].sizes.push(s);
            }
          });
          /** @type {Array} */
          self.goodsInfo.initStore = [];
          var codeSegments = packs[2].data;
          /** @type {number} */
          var i = 0;
          for (;i < codeSegments.length;i++) {
            if ("1" == codeSegments[i].status) {
              self.goodsInfo.initStore.push(codeSegments[i]);
            }
          }
          /** @type {Array} */
          self.goodsStoredList = [];
          self.initStoreHouse = {};
          self.initStoreHouse.id = self.goodsInfo.initStore.length > 0 ? self.goodsInfo.initStore[0].id : "";
          self.initStoreHouse.text = self.goodsInfo.initStore.length > 0 ? self.goodsInfo.initStore[0].text : "";
        });
      });
    }, function() {
      loading.hide();
    });
  });
  self.$on("$ionicView.afterEnter", function() {
    $document.getScanerCode(function(dataAndEvents) {
      if (null != self.good.barCode && "" != self.good.barCode) {
        if (window.cordova && window.cordova.plugins) {
          UnitTools.showConfirm("是否替换原有条码？", function(dataAndEvents) {
            if (2 == dataAndEvents) {
              self.$apply(function() {
                self.good.barCode = dataAndEvents;
              });
            }
          }, null, ["取消", "替换"]);
        } else {
          var promise = _.confirm({
            template : "<div class='tc'>是否替换原有条码？</div>",
            cancelText : "取消",
            okText : "替换"
          });
          promise.then(function(deepDataAndEvents) {
            if (deepDataAndEvents) {
              self.good.barCode = dataAndEvents;
            }
          });
        }
      } else {
        self.good.barCode = dataAndEvents;
      }
    }, self.bluethoothScaner);
  });
  self.$on("$ionicView.beforeLeave", function() {
    $document.getScanerCode(function() {
    }, self.bluethoothScaner);
  });
}]).controller("AddGoodCtrl", ["$scope", "$rootScope", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "$timeout", "$cordovaBarcodeScanner", "lruPersistCache", "$ionicActionSheet", "CameraService", "ServerConfig", "$cordovaFile", "lbScrollDelegate", "$state", function(self, deepDataAndEvents, ignoreMethodDoesntExist, field, UnitTools, textAlt, $modal, $q, view, loading, $sanitize, Hogan,
$templateCache, keepData, opt_attributes, context, dataAndEvents, widget, $state) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = field.httpCacheGet.get(field.httpCacheGet.ac.COLORGROUP);
    var getPromise3 = field.httpCacheGet.get(field.httpCacheGet.ac.SIZEGROUP);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  self.goodsInfo = {
    seletedColors : [],
    seletedSizes : []
  };
  /** @type {string} */
  self.OTHER_GROUP = "999";
  self.good = {};
  /** @type {Array} */
  self.goodsList = [];
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY324.html", function(theTitle) {
    self.goodsColorModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY325.html", function(theTitle) {
    self.goodsSizeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.goodsColorModal.remove();
    self.goodsSizeModal.remove();
  });
  /**
   * @return {undefined}
   */
  self.closeGoodsSizeModal = function() {
    self.goodsSizeModal.hide();
  };
  /**
   * @return {undefined}
   */
  self.closeGoodsColorModal = function() {
    self.goodsColorModal.hide();
  };
  /**
   * @param {?} v
   * @return {?}
   */
  self.fixedInputNumber = function(v) {
    /** @type {RegExp} */
    return UnitTools.getValidNum(v);
  };
  /**
   * @param {string} dataAndEvents
   * @return {undefined}
   */
  self.scanCode = function(dataAndEvents) {
    Hogan.scan().then(function(result) {
      if (!result.cancelled) {
        $sanitize("goodsSn" == dataAndEvents ? function() {
          self.good.goodsSn = result.text;
        } : function() {
          self.good.barCode = result.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /** @type {boolean} */
  var b = false;
  self.$on("modal.shown", function() {
    if ($state.includes("eventmenu.KEY277")) {
      /** @type {string} */
      self.orderFrom = "store";
    } else {
      if ($state.includes("eventmenu.KEY137")) {
        /** @type {string} */
        self.orderFrom = "storeTransfer";
      }
    }
    if (!b) {
      loading.show();
      fetch().then(function(packs) {
        /** @type {boolean} */
        b = true;
        self.allColorGroups = packs[0].data;
        self.allSizeGroups = packs[1].data;
        self.colorGroups = {};
        self.allColorGroups.forEach(function(data) {
          self.colorGroups[data.id] = {};
          self.colorGroups[data.id].group = data;
          /** @type {Array} */
          self.colorGroups[data.id].colors = [];
        });
        self.allColors.forEach(function(s) {
          var i = s.colorGroupId ? s.colorGroupId : self.OTHER_GROUP;
          if (i in self.colorGroups) {
            self.colorGroups[i].colors.push(s);
          } else {
            if (!(self.OTHER_GROUP in self.colorGroups)) {
              self.colorGroups[self.OTHER_GROUP] = {};
              self.colorGroups[self.OTHER_GROUP].group = {
                name : "其他"
              };
              /** @type {Array} */
              self.colorGroups[self.OTHER_GROUP].colors = [];
            }
            self.colorGroups[self.OTHER_GROUP].colors.push(s);
          }
        });
        /**
         * @param {string} c
         * @return {undefined}
         */
        self.selectColor = function(c) {
          var pos = self.goodsInfo.seletedColors.indexOf(c);
          if (pos > -1) {
            self.goodsInfo.seletedColors.splice(pos, 1);
          } else {
            self.goodsInfo.seletedColors.push(c);
          }
        };
        self.sizeGroups = {};
        self.allSizeGroups.forEach(function(data) {
          self.sizeGroups[data.id] = {};
          self.sizeGroups[data.id].group = data;
          /** @type {Array} */
          self.sizeGroups[data.id].sizes = [];
        });
        self.allSizes.forEach(function(s) {
          var id = s.sizeGroupId ? s.sizeGroupId : self.OTHER_GROUP;
          if (id in self.sizeGroups && id !== self.OTHER_GROUP) {
            self.sizeGroups[id].sizes.push(s);
          } else {
            if (!(self.OTHER_GROUP in self.sizeGroups)) {
              self.sizeGroups[self.OTHER_GROUP] = {};
              self.sizeGroups[self.OTHER_GROUP].group = {
                name : "其他"
              };
              /** @type {Array} */
              self.sizeGroups[self.OTHER_GROUP].sizes = [];
            }
            self.sizeGroups[self.OTHER_GROUP].sizes.push(s);
          }
        });
        /**
         * @param {string} key
         * @return {undefined}
         */
        self.selectSize = function(key) {
          var camelKey = self.goodsInfo.seletedSizes.indexOf(key);
          if (camelKey > -1) {
            self.goodsInfo.seletedSizes.splice(camelKey, 1);
          } else {
            self.goodsInfo.seletedSizes.push(key);
          }
        };
      }, function() {
        loading.hide();
      });
      loading.hide();
    }
  });
  self.$watch("[goodsInfo.seletedColors, goodsInfo.seletedSizes]", function(memo) {
    if ((UnitTools.isEmpty(memo[0]) || UnitTools.isEmpty(memo[1])) && (self.goodsList = []), !UnitTools.isEmpty(memo[0]) && !UnitTools.isEmpty(memo[1])) {
      var reversed = self.goodsList.concat();
      /** @type {Array} */
      self.goodsList = [];
      var xx;
      for (xx in self.goodsInfo.seletedColors) {
        var i;
        for (i in self.goodsInfo.seletedSizes) {
          /** @type {string} */
          var module = "";
          var namespace = UnitTools.getObjectList(reversed, "colorId", self.goodsInfo.seletedColors[xx].id);
          var data = UnitTools.fnCheckGtoreQty(namespace, "sizeId", self.goodsInfo.seletedSizes[i].id);
          if (data) {
            module = data.quantity;
          }
          var copies = {
            colorId : self.goodsInfo.seletedColors[xx].id,
            sizeId : self.goodsInfo.seletedSizes[i].id,
            colorName : self.goodsInfo.seletedColors[xx].name,
            sizeName : self.goodsInfo.seletedSizes[i].name,
            quantity : module,
            number : 0
          };
          self.goodsList.push(copies);
        }
      }
    }
    widget.resize("goodAddCtrlScroll");
  }, true);
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  self.saveGood = function(dataAndEvents) {
    if (!self.good.name) {
      return UnitTools.toastShow("请填写名称！", "short"), void console.log("请填写名称！");
    }
    if (!self.good.goodsSn) {
      return UnitTools.toastShow("请填写货号！", "short"), void console.log("请填写货号！");
    }
    if (UnitTools.isEmpty(self.goodsInfo.seletedColors)) {
      return context.currentServer === context.exServer ? UnitTools.toastShow("请选择颜色，非服装行业下载辛巴手机版", "short") : UnitTools.toastShow("请选择颜色！", "short"), void console.log("请选择颜色！");
    }
    if (UnitTools.isEmpty(self.goodsInfo.seletedSizes)) {
      return context.currentServer === context.exServer ? UnitTools.toastShow("请选择尺码，非服装行业下载辛巴手机版", "short") : UnitTools.toastShow("请选择尺码！", "short"), void console.log("请选择尺码！");
    }
    if (void 0 === self.good.factoryPrice || (null === self.good.factoryPrice || "" === self.good.factoryPrice)) {
      /** @type {number} */
      self.good.factoryPrice = 0;
    } else {
      if (self.good.factoryPrice < 0) {
        return UnitTools.toastShow("进货价不能为负数", "short"), false;
      }
      self.good.factoryPrice = self.fixedInputNumber(self.good.factoryPrice);
    }
    /** @type {Array} */
    var tagNameArr = [];
    /** @type {Array} */
    var UNICODE_SPACES = [];
    self.goodsInfo.seletedColors.forEach(function(test) {
      tagNameArr.push(test.id.toString());
    });
    self.goodsInfo.seletedSizes.forEach(function(test) {
      UNICODE_SPACES.push(test.id.toString());
    });
    /** @type {string} */
    self.good.colorIds = tagNameArr.join();
    /** @type {string} */
    self.good.sizeIds = UNICODE_SPACES.join();
    loading.show(true);
    /** @type {number} */
    self.good.year = (new Date).getFullYear();
    /** @type {number} */
    self.good.showOrder = 100;
    /** @type {number} */
    self.good.isOnSale = 1;
    /** @type {number} */
    self.good.tradePrice = 0;
    /** @type {number} */
    self.good.retailPriceArea = 0;
    /** @type {Array} */
    var traversed = [];
    /** @type {number} */
    var i = 0;
    for (;i < self.goodsInfo.seletedColors.length;i++) {
      traversed.push(self.goodsInfo.seletedColors[i].id);
    }
    /** @type {Array} */
    var bmIds = [];
    /** @type {number} */
    i = 0;
    for (;i < self.goodsInfo.seletedSizes.length;i++) {
      bmIds.push(self.goodsInfo.seletedSizes[i].id);
    }
    field.postEncode("/KEY084", {
      imgIds : "",
      previewImgId : "",
      goodModel : angular.toJson(self.good),
      skuModelList : angular.toJson([]),
      clientItemPriceList : angular.toJson([]),
      goodsStoredList : angular.toJson([])
    }).success(function(config) {
      if (1 == config.statusCode) {
        UnitTools.union(self.good, config.object);
        /** @type {number} */
        self.state = 1;
        self.viewTitle = self.NameConstant.KEY291;
        $templateCache.put("goodListRefresh", true);
        $templateCache.put("needToAddGoodsFlag", true);
        UnitTools.toastShow("新增商品成功");
        $sanitize(function() {
          $templateCache.put("addGoodsFlag", true);
          $templateCache.put("newGoodsObj", self.good);
          if (self.purchaseOrderContent && self.purchaseOrderContent.status) {
            self.purchaseOrderContent.refreshSelectedGoods(self.good);
          } else {
            self.orderContent.addGoodsToGroup(self.goodsList, self.good);
          }
          self.goodsInfo = {
            seletedColors : [],
            seletedSizes : []
          };
          self.good = {};
          /** @type {Array} */
          self.goodsList = [];
          if ("save" == dataAndEvents) {
            if (self.purchaseOrderContent && self.purchaseOrderContent.status) {
              self.purchaseOrderContent.closeGoodsAddModal();
            } else {
              self.orderContent.closeGoodsAddModal();
            }
          }
          if (self.purchaseOrderContent && self.purchaseOrderContent.status) {
            self.purchaseOrderContent.refreshCacheData();
          } else {
            self.orderContent.refreshCacheData();
          }
        });
      } else {
        view.alert({
          template : "<div class='tc'>" + config.content + "</div>",
          okText : "确定"
        });
      }
    }).finally(function() {
      loading.hide();
    });
  };
}]).controller("GoodColorCtrl", ["$scope", "psisServices", "$ionicPopup", "Tools", "$ionicPopover", "lruPersistCache", "$ionicActionSheet", "$ionicModal", "lbSpinnerDialog", function(scope, self, view, $, FB, $templateCache, $dialog, passport, loading) {
  scope.colorGroupEdit = {};
  /** @type {string} */
  scope.editTitle = "颜色编辑";
  FB.fromTemplateUrl("colorGroupPopover.html", {
    scope : scope
  }).then(function(transclude) {
    /** @type {number} */
    scope.colorGroupPopover = transclude;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  scope.openColorGroupPopover = function(expectedNumberOfNonCommentArgs) {
    scope.colorGroupPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  scope.hidecColorGroupPopover = function() {
    scope.colorGroupPopover.hide();
  };
  passport.fromTemplateUrl("goodsColorAndSizeEdit.html", {
    scope : scope
  }).then(function(transclude) {
    /** @type {number} */
    scope.goodsInformodal = transclude;
  });
  FB.fromTemplateUrl("groupPopover.html", {
    scope : scope
  }).then(function(transclude) {
    /** @type {number} */
    scope.groupPopover = transclude;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  scope.openGroupPopover = function(expectedNumberOfNonCommentArgs) {
    scope.groupPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  scope.hideGroupPopover = function() {
    scope.groupPopover.hide();
  };
  scope.$on("$destroy", function() {
    scope.colorGroupPopover.remove();
    if (scope.goodsInformodal) {
      scope.goodsInformodal.remove();
    }
    if (scope.groupPopover) {
      scope.groupPopover.remove();
    }
  });
  /**
   * @param {Node} s
   * @return {undefined}
   */
  scope.editColorGroup = function(s) {
    scope.colorGroupEdit.colorGroupName = s ? s.name : "";
    view.show({
      cssClass : "lb-KEY291-popup",
      template : '<input type="text" ng-model="colorGroupEdit.colorGroupName" autofocus="true" placeholder="分组名称（必填）">',
      title : "颜色分组",
      scope : scope,
      buttons : [{
        text : "取消"
      }, {
        text : "保存",
        type : "button-assertive",
        /**
         * @param {?} e
         * @return {undefined}
         */
        onTap : function(e) {
          if (scope.colorGroupEdit.colorGroupName) {
            var customer = {
              name : scope.colorGroupEdit.colorGroupName
            };
            if (s) {
              customer.id = s.id;
              customer.optimisticLockVersion = s.optimisticLockVersion;
            }
            self.post("/KEY086", customer).success(function(response) {
              if (1 == response.statusCode) {
                $.toastShow("添加成功！");
                if (!s) {
                  scope.colorGroups[response.object.id] = {};
                  /** @type {Array} */
                  scope.colorGroups[response.object.id].colors = [];
                }
                scope.colorGroups[response.object.id].group = response.object;
                if ($templateCache.get("needToAddGoodsFlag") === true) {
                  $templateCache.put("refreshGoodColorFlag", true);
                }
              } else {
                $.toastShow(0 == response.statusCode ? "已经存在同名颜色组！" : "添加失败！");
              }
            }).finally(function() {
              self.httpCacheGet.remove(self.httpCacheGet.ac.COLORGROUP);
              self.httpCacheGet.remove(self.httpCacheGet.ac.ALLCOLORLIST);
            });
          } else {
            e.preventDefault();
          }
        }
      }]
    });
  };
  /**
   * @param {string} i
   * @param {string} dataAndEvents
   * @return {?}
   */
  scope.deleteColorGroup = function(i, dataAndEvents) {
    var promise = view.confirm({
      template : "<div class='tc'>您确认要删除" + dataAndEvents + "分组?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        self.post("/KEY089?id=" + i).success(function(r) {
          if (1 == r.statusCode) {
            /*if (scope.colorGroups[i].colors.length) {
              if (!(scope.OTHER_GROUP in scope.colorGroups)) {
                scope.colorGroups[scope.OTHER_GROUP] = {};
                scope.colorGroups[scope.OTHER_GROUP].group = {
                  name : "其他"
                };
                scope.colorGroups[scope.OTHER_GROUP].colors = [];
              }
              scope.colorGroups[scope.OTHER_GROUP].colors = scope.colorGroups[scope.OTHER_GROUP].colors.concat(scope.colorGroups[i].colors);
            }*/
            delete scope.colorGroups[i];
            $.toastShow("删除成功！");
            if ($templateCache.get("needToAddGoodsFlag") === true) {
              $templateCache.put("refreshGoodColorFlag", true);
            }
          } else {
            $.toastShow("删除失败！" + r.content);
            if ($templateCache.get("needToAddGoodsFlag") === true) {
              $templateCache.put("refreshGoodColorFlag", true);
            }
            if (r.object) {
              var arr = [];
              for(var j = 0 ; j < scope.colorGroups[i].colors.length ; j++) {
                if (r.object.indexOf(scope.colorGroups[i].colors[j].id) === -1) {
                  arr.push(scope.colorGroups[i].colors[j]);
                }
              }
              scope.colorGroups[i].colors = arr;
            }
          }
        }).finally(function() {
          self.httpCacheGet.remove(self.httpCacheGet.ac.COLORGROUP);
          self.httpCacheGet.remove(self.httpCacheGet.ac.ALLCOLORLIST);
        });
      }
    }), true;
  };
  /**
   * @param {undefined} i
   * @return {undefined}
   */
  scope.insertColor = function(i) {
    /** @type {string} */
    scope.colorGroupEdit.colorName = "";
    /** @type {number} */
    scope.colorGroupEdit.showOrder = 100;
    view.show({
      cssClass : "lb-KEY291-popup",
      templateUrl : "colorFormItem.html",
      title : "添加颜色",
      scope : scope,
      buttons : [{
        text : "取消"
      }, {
        text : "保存",
        type : "button-assertive",
        /**
         * @param {?} e
         * @return {undefined}
         */
        onTap : function(e) {
          if (scope.colorGroupEdit.colorName) {
            var doc = {
              name : scope.colorGroupEdit.colorName,
              showOrder : scope.colorGroupEdit.showOrder
            };
            if (i != scope.OTHER_GROUP) {
              doc.colorGroupId = i;
              var j;
              for (j in scope.colorGroups) {
                if (i == j) {
                  doc.colorGroupName = scope.colorGroups[j].group.name;
                }
              }
            }
            self.post("/KEY087", doc).success(function(res) {
              if (1 == res.statusCode) {
                $.toastShow("添加成功！");
                res.object.colorGroupName = scope.colorGroups[i].group.name;
                scope.colorGroups[i].colors.push(res.object);
                if ($templateCache.get("needToAddGoodsFlag") === true) {
                  $templateCache.put("refreshGoodColorFlag", true);
                }
              } else {
                $.toastShow(0 == res.statusCode ? "已经存在同名颜色！" : "添加失败！");
              }
            }).finally(function() {
              self.httpCacheGet.remove(self.httpCacheGet.ac.COLORSELECT);
              self.httpCacheGet.remove(self.httpCacheGet.ac.ALLCOLORLIST);
            });
          } else {
            e.preventDefault();
          }
        }
      }]
    });
  };
  /**
   * @param {Object} key
   * @param {?} i
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  scope.deleteColor = function(key, i, deepDataAndEvents) {
    var promise = view.confirm({
      template : "<div class='tc'>您确认要删除" + key.name + "?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        self.post("/KEY088?id=" + key.id).success(function(r) {
          if (1 == r.statusCode) {
            $.toastShow("删除成功！");
            var camelKey = scope.goodsInfo.seletedColors.indexOf(key);
            if (camelKey > -1) {
              scope.goodsInfo.seletedColors.splice(camelKey, 1);
            }
            scope.colorGroups[i].colors.splice(deepDataAndEvents, 1);
            if ($templateCache.get("needToAddGoodsFlag") === true) {
              $templateCache.put("refreshGoodColorFlag", true);
            }
          } else {
            $.toastShow("删除失败，不能删除已被使用的颜色！");
          }
        }).finally(function() {
          self.httpCacheGet.remove(self.httpCacheGet.ac.COLORSELECT);
          self.httpCacheGet.remove(self.httpCacheGet.ac.ALLCOLORLIST);
        });
      }
    }), true;
  };
  /**
   * @param {Object} data
   * @param {(Object|string)} next
   * @return {?}
   */
  scope.edit = function(data, next) {
    /**
     * @param {Array} drop
     * @param {?} keepData
     * @return {undefined}
     */
    function remove(drop, keepData) {
      /** @type {number} */
      var i = 0;
      for (;i < drop.length;i++) {
        if (drop[i].id == keepData) {
          drop.splice(i, 1);
        }
      }
    }
    return scope.obj.colorGroupId = scope.obj.comGroupId, "" === data.pseudonymName && (data.colorGroupName = "", scope.obj.colorGroupId = 0), data.colorGroupName || (scope.obj.colorGroupId || (data.colorGroupName = "", scope.obj.colorGroupId = 0)), data.showOrder = parseInt(data.showOrder), data.id = data.id.toString(), scope.obj.colorGroupId = parseInt(scope.obj.colorGroupId), data.name ?
    data.showOrder ? (loading.show(), void self.post("/KEY087", data).success(function(options) {
      if (1 == options.statusCode) {
        $.toastShow("修改成功!");
        delete options.object.cid;
        delete options.object.limitFlag;
        delete options.object.updateTime;
        delete options.object.pseudonymName;
        /** @type {Array.<string>} */
        var codeSegments = Object.keys(scope.colorGroups);
        var d = function() {
          /** @type {number} */
          var i = 0;
          for (;i < codeSegments.length;i++) {
            if (codeSegments[i] == options.object.colorGroupId) {
              return true;
            }
          }
          return false;
        }();
        if (d || (options.object.colorGroupId = 999), next == options.object.colorGroupId) {
          scope.groupColorsObj = scope.colorGroups[options.object.colorGroupId.toString()];
          var value = $.fnCheckGtoreQty(scope.groupColorsObj.colors, "id", options.object.id.toString());
          $.union(value, options.object);
          scope.groupColorsObj.colors.sort(function(a, b) {
            return a.showOrder > b.showOrder ? 1 : a.showOrder < b.showOrder ? -1 : 0;
          });
        } else {
          scope.groupColorsObj = scope.colorGroups[next.toString()];
          options.object.colorGroupName = scope.colorGroups[options.object.colorGroupId.toString()].group.name ? scope.colorGroups[options.object.colorGroupId.toString()].group.name : "";
          scope.colorGroups[options.object.colorGroupId.toString()].colors.push(options.object);
          scope.colorGroups[options.object.colorGroupId.toString()].colors.sort(function(a, b) {
            return a.showOrder > b.showOrder ? 1 : a.showOrder < b.showOrder ? -1 : 0;
          });
          remove(scope.groupColorsObj.colors, options.object.id.toString());
        }
        if ($templateCache.get("needToAddGoodsFlag") === true) {
          $templateCache.put("refreshGoodColorFlag", true);
        }
        scope.goodsInformodal.hide();
      } else {
        $.toastShow(options.content ? options.content : "修改失败!");
      }
    }).finally(function() {
      self.httpCacheGet.remove(self.httpCacheGet.ac.COLORSELECT);
      self.httpCacheGet.remove(self.httpCacheGet.ac.ALLCOLORLIST);
      loading.hide();
    })) : ($.toastShow("排序值不能为空且必须大于0!"), false) : ($.toastShow("请填写名称!"), false);
  };
  /**
   * @param {?} data
   * @param {?} newValue
   * @param {?} deepDataAndEvents
   * @return {undefined}
   */
  scope.showActionsheet = function(data, newValue, deepDataAndEvents) {
    var opts = {
      buttons : []
    };
    opts.buttons.push({
      text : '<i class="icon ion-ios-compose-outline assertive"></i> 编 辑'
    });
    /**
     * @param {number} i
     * @return {?}
     */
    opts.buttonClicked = function(i) {
      return opts.buttons[i].text.indexOf("编 辑") > -1 && (scope.goodsInformodal.show(), scope.obj = data, scope.obj.colorGroupId = newValue, scope.obj.comGroupId = newValue, scope.groupId = newValue, scope.obj.pseudonymName = scope.obj.colorGroupName ? scope.obj.colorGroupName : "", scope.groups = scope.allColorGroups), true;
    };
    /** @type {string} */
    opts.destructiveText = '<i class="icon ion-ios-trash-outline assertive"></i> 删 除';
    /**
     * @return {?}
     */
    opts.destructiveButtonClicked = function() {
      return scope.deleteColor(data, newValue, deepDataAndEvents), true;
    };
    $dialog.show(opts);
  };
}]).controller("GoodSizeCtrl", ["$scope", "psisServices", "$ionicPopup", "Tools", "$ionicPopover", "lruPersistCache", "$ionicModal", "$ionicActionSheet", "lbSpinnerDialog", function(self, $http, view, _, FB, $templateCache, passport, handler, loading) {
  self.sizeGroupEdit = {};
  /** @type {string} */
  self.editTitle = "尺码编辑";
  FB.fromTemplateUrl("sizeGroupPopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.sizeGroupPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openSizeGroupPopover = function(expectedNumberOfNonCommentArgs) {
    self.sizeGroupPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hidecSizeGroupPopover = function() {
    self.sizeGroupPopover.hide();
  };
  passport.fromTemplateUrl("goodsColorAndSizeEdit.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.goodsInformodal = theTitle;
  });
  FB.fromTemplateUrl("groupPopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.groupPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openGroupPopover = function(expectedNumberOfNonCommentArgs) {
    self.groupPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideGroupPopover = function() {
    self.groupPopover.hide();
  };
  self.$on("$destroy", function() {
    self.sizeGroupPopover.remove();
    if (self.goodsInformodal) {
      self.goodsInformodal.remove();
    }
    if (self.groupPopover) {
      self.groupPopover.remove();
    }
  });
  /**
   * @param {Node} s
   * @return {undefined}
   */
  self.editSizeGroup = function(s) {
    self.sizeGroupEdit.sizeGroupName = s ? s.name : "";
    view.show({
      cssClass : "lb-KEY291-popup",
      template : '<input type="text" ng-model="sizeGroupEdit.sizeGroupName" autofocus="true" placeholder="分组名称（必填）">',
      title : "尺码分组",
      scope : self,
      buttons : [{
        text : "取消"
      }, {
        text : "保存",
        type : "button-assertive",
        /**
         * @param {?} e
         * @return {undefined}
         */
        onTap : function(e) {
          if (self.sizeGroupEdit.sizeGroupName) {
            var customer = {
              name : self.sizeGroupEdit.sizeGroupName
            };
            if (s) {
              customer.id = s.id;
              customer.optimisticLockVersion = s.optimisticLockVersion;
            }
            $http.post("/KEY079", customer).success(function(response) {
              if (1 == response.statusCode) {
                _.toastShow("添加成功！");
                if (!s) {
                  self.sizeGroups[response.object.id] = {};
                  /** @type {Array} */
                  self.sizeGroups[response.object.id].sizes = [];
                }
                self.sizeGroups[response.object.id].group = response.object;
                if ($templateCache.get("needToAddGoodsFlag") === true) {
                  $templateCache.put("refreshGoodSizeFlag", true);
                }
              } else {
                _.toastShow(0 == response.statusCode ? "已经存在同名尺码组！" : "添加失败！");
              }
            }).finally(function() {
              $http.httpCacheGet.remove($http.httpCacheGet.ac.SIZEGROUP);
              $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLSIZELIST);
            });
          } else {
            e.preventDefault();
          }
        }
      }]
    });
  };
  /**
   * @param {string} key
   * @param {string} dataAndEvents
   * @return {?}
   */
  self.deleteSizeGroup = function(key, dataAndEvents) {
    var promise = view.confirm({
      template : "<div class='tc'>您确认要删除" + dataAndEvents + "分组?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        $http.post("/KEY082?id=" + key).success(function(r) {
          if (1 == r.statusCode) {
            /*if (self.sizeGroups[key].sizes.length) {
              if (!(self.OTHER_GROUP in self.sizeGroups)) {
                self.sizeGroups[self.OTHER_GROUP] = {};
                self.sizeGroups[self.OTHER_GROUP].group = {
                  name : "其他"
                };
                self.sizeGroups[self.OTHER_GROUP].sizes = [];
              }
              self.sizeGroups[self.OTHER_GROUP].sizes = self.sizeGroups[self.OTHER_GROUP].sizes.concat(self.sizeGroups[key].sizes);
            }*/
            delete self.sizeGroups[key];
            _.toastShow("删除成功！");
            if ($templateCache.get("needToAddGoodsFlag") === true) {
              $templateCache.put("refreshGoodSizeFlag", true);
            }
          } else {
            _.toastShow("删除失败！" + r.content);
            if ($templateCache.get("needToAddGoodsFlag") === true) {
              $templateCache.put("refreshGoodSizeFlag", true);
            }
            if (r.object) {
              var arr = [];
              for(var j = 0 ; j < self.sizeGroups[key].sizes.length ; j++) {
                if (r.object.indexOf(self.sizeGroups[key].sizes[j].id) === -1) {
                  arr.push(self.sizeGroups[key].sizes[j]);
                }
              }
              self.sizeGroups[key].sizes = arr;
            }
          }
        }).finally(function() {
          $http.httpCacheGet.remove($http.httpCacheGet.ac.SIZEGROUP);
          $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLSIZELIST);
        });
      }
    }), true;
  };
  /**
   * @param {undefined} i
   * @return {undefined}
   */
  self.insertSize = function(i) {
    /** @type {string} */
    self.sizeGroupEdit.sizeName = "";
    /** @type {number} */
    self.sizeGroupEdit.showOrder = 100;
    view.show({
      cssClass : "lb-KEY291-popup",
      templateUrl : "sizeFormItem.html",
      title : "添加尺码",
      scope : self,
      buttons : [{
        text : "取消"
      }, {
        text : "保存",
        type : "button-assertive",
        /**
         * @param {?} e
         * @return {undefined}
         */
        onTap : function(e) {
          if (self.sizeGroupEdit.sizeName) {
            var data = {
              name : self.sizeGroupEdit.sizeName,
              showOrder : self.sizeGroupEdit.showOrder
            };
            if (i != self.OTHER_GROUP) {
              data.sizeGroupId = i;
              var sid;
              for (sid in self.sizeGroups) {
                if (i == sid) {
                  data.sizeGroupName = self.sizeGroups[sid].group.name;
                }
              }
            }
            $http.post("/KEY080", data).success(function(res) {
              if (1 == res.statusCode) {
                _.toastShow("添加成功！");
                res.object.sizeGroupName = self.sizeGroups[i].group.name;
                self.sizeGroups[i].sizes.push(res.object);
                if ($templateCache.get("needToAddGoodsFlag") === true) {
                  $templateCache.put("refreshGoodSizeFlag", true);
                }
              } else {
                _.toastShow(0 == res.statusCode ? "已经存在同名尺码！" : "添加失败！");
              }
            }).finally(function() {
              $http.httpCacheGet.remove($http.httpCacheGet.ac.SIZESELECT);
              $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLSIZELIST);
            });
          } else {
            e.preventDefault();
          }
        }
      }]
    });
  };
  /**
   * @param {Object} platform
   * @param {?} timeoutKey
   * @param {?} millis
   * @return {?}
   */
  self.deleteSize = function(platform, timeoutKey, millis) {
    var promise = view.confirm({
      template : "<div class='tc'>您确认要删除" + platform.name + "?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        $http.post("/KEY081?id=" + platform.id).success(function(r) {
          if (1 == r.statusCode) {
            _.toastShow("删除成功！");
            var fromIndex = self.goodsInfo.seletedSizes.indexOf(platform);
            if (fromIndex > -1) {
              self.goodsInfo.seletedSizes.splice(fromIndex, 1);
            }
            self.sizeGroups[timeoutKey].sizes.splice(millis, 1);
            if ($templateCache.get("needToAddGoodsFlag") === true) {
              $templateCache.put("refreshGoodSizeFlag", true);
            }
          } else {
            _.toastShow("删除失败，不能删除已被使用的尺码！");
          }
        }).finally(function() {
          $http.httpCacheGet.remove($http.httpCacheGet.ac.SIZESELECT);
          $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLSIZELIST);
        });
      }
    }), true;
  };
  /**
   * @param {Object} data
   * @param {(Object|string)} next
   * @return {?}
   */
  self.edit = function(data, next) {
    /**
     * @param {Array} drop
     * @param {?} keepData
     * @return {undefined}
     */
    function remove(drop, keepData) {
      /** @type {number} */
      var i = 0;
      for (;i < drop.length;i++) {
        if (drop[i].id == keepData) {
          drop.splice(i, 1);
        }
      }
    }
    return self.obj.sizeGroupId = self.obj.comGroupId, "" === data.pseudonymName && (data.sizeGroupName = "", self.obj.sizeGroupId = 0), data.sizeGroupName || (self.obj.sizeGroupId || (data.sizeGroupName = "", self.obj.sizeGroupId = 0)), data.showOrder = parseInt(data.showOrder), data.id = data.id.toString(), self.obj.sizeGroupId = parseInt(self.obj.sizeGroupId), data.name ?
    data.showOrder ? (loading.show(), void $http.post("/KEY080", data).success(function(options) {
      if (1 == options.statusCode) {
        _.toastShow("修改成功!");
        delete options.object.cid;
        delete options.object.limitFlag;
        delete options.object.updateTime;
        delete options.object.pseudonymName;
        /** @type {Array.<string>} */
        var codeSegments = Object.keys(self.sizeGroups);
        var d = function() {
          /** @type {number} */
          var i = 0;
          for (;i < codeSegments.length;i++) {
            if (codeSegments[i] == options.object.sizeGroupId) {
              return true;
            }
          }
          return false;
        }();
        if (d || (options.object.sizeGroupId = 999), next == options.object.sizeGroupId) {
          self.groupSizeObj = self.sizeGroups[options.object.sizeGroupId.toString()];
          var value = _.fnCheckGtoreQty(self.groupSizeObj.sizes, "id", options.object.id.toString());
          _.union(value, options.object);
          self.groupSizeObj.sizes.sort(function(a, b) {
            return a.showOrder > b.showOrder ? 1 : a.showOrder < b.showOrder ? -1 : 0;
          });
        } else {
          self.groupSizeObj = self.sizeGroups[next.toString()];
          options.object.sizeGroupName = self.sizeGroups[options.object.sizeGroupId.toString()].group.name ? self.sizeGroups[options.object.sizeGroupId.toString()].group.name : "";
          self.sizeGroups[options.object.sizeGroupId.toString()].sizes.push(options.object);
          self.sizeGroups[options.object.sizeGroupId.toString()].sizes.sort(function(a, b) {
            return a.showOrder > b.showOrder ? 1 : a.showOrder < b.showOrder ? -1 : 0;
          });
          remove(self.groupSizeObj.sizes, options.object.id.toString());
        }
        if ($templateCache.get("needToAddGoodsFlag") === true) {
          $templateCache.put("refreshGoodSizeFlag", true);
        }
        self.goodsInformodal.hide();
      } else {
        _.toastShow(options.content ? options.content : "修改失败!");
      }
    }).finally(function() {
      loading.hide();
      $http.httpCacheGet.remove($http.httpCacheGet.ac.SIZESELECT);
      $http.httpCacheGet.remove($http.httpCacheGet.ac.ALLSIZELIST);
    })) : (_.toastShow("排序值不能为空且必须大于0!"), false) : (_.toastShow("请填写名称!"), false);
  };
  /**
   * @param {?} details
   * @param {?} id
   * @param {?} millis
   * @return {undefined}
   */
  self.showActionsheet = function(details, id, millis) {
    var scope = {
      buttons : []
    };
    scope.buttons.push({
      text : '<i class="icon ion-ios-compose-outline assertive"></i> 编 辑'
    });
    /**
     * @param {number} index
     * @return {?}
     */
    scope.buttonClicked = function(index) {
      return scope.buttons[index].text.indexOf("编 辑") > -1 && (self.goodsInformodal.show(), self.obj = details, self.obj.sizeGroupId = id, self.obj.comGroupId = id, self.groupId = id, self.obj.pseudonymName = self.obj.sizeGroupName ? self.obj.sizeGroupName : "", self.groups = self.allSizeGroups), true;
    };
    /** @type {string} */
    scope.destructiveText = '<i class="icon ion-ios-trash-outline assertive"></i> 删 除';
    /**
     * @return {?}
     */
    scope.destructiveButtonClicked = function() {
      return self.deleteSize(details, id, millis), true;
    };
    handler.show(scope);
  };
}]).controller("GoodsBlandCtrl", ["$scope", "psisServices", "$ionicPopup", "Tools", "$ionicPopover", "$ionicModal", "lbScrollDelegate", function(self, $scope, _, dojo, dataAndEvents, $modal, widget) {
  self.searchObj = {
    searchBland : ""
  };
  /** @type {string} */
  self.focused = "centered";
  $modal.fromTemplateUrl("goodsBlandEdit.html", function(theTitle) {
    /** @type {number} */
    self.goodsBlandEditModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.goodsBlandEditModal.remove();
  });
  /**
   * @param {string} dataAndEvents
   * @param {(Object|string)} theTitle
   * @param {?} event
   * @return {undefined}
   */
  self.openGoodsBland = function(dataAndEvents, theTitle, event) {
    if ("insert" === dataAndEvents) {
      self.goodsBlandEdit = {
        isShow : 1,
        showOrder : 100
      };
    } else {
      if ("update" === dataAndEvents) {
        /** @type {(Object|string)} */
        self.goodsBlandEdit = theTitle;
        if (event) {
          event.stopPropagation();
        }
      }
    }
    self.goodsBlandEditModal.show();
  };
  /**
   * @param {?} test
   * @param {string} pass
   * @return {undefined}
   */
  self.selectGoodsBland = function(test, pass) {
    test.bland = test.bland == pass ? {} : pass;
    self.goodsBlandModal.hide();
  };
  /**
   * @return {?}
   */
  self.saveGoodsBland = function() {
    if (!self.goodsBlandEdit.name) {
      return dojo.toastShow("请填写名称！", "short", "center"), void console.log("请填写名称！");
    }
    /** @type {boolean} */
    var t = !self.goodsBlandEdit.id;
    var user = {
      newName : self.goodsBlandEdit.name
    };
    if (!t) {
      user.blandId = self.goodsBlandEdit.id;
    }
    $scope.postEncode("/KEY060", user).success(function(e) {
      if (e.isValid) {
        $scope.post("/KEY061", self.goodsBlandEdit).success(function(event) {
          if (1 == event.statusCode) {
            dojo.toastShow("保存成功！");
            dojo.union(self.goodsBlandEdit, event.object);
            if (t) {
              self.arrBland.unshift(event.object);
            }
            self.goodsBlandEditModal.hide();
          } else {
            dojo.toastShow("保存失败！");
          }
        });
      } else {
        dojo.toastShow("品牌名称已存在！", "short", "center");
        console.log("品牌名称已存在！");
      }
    }).finally(function() {
      $scope.httpCacheGet.remove($scope.httpCacheGet.ac.BLANDLIST);
    });
  };
  /**
   * @param {Function} exception
   * @return {?}
   */
  self.filterBland = function(exception) {
    return self.searchObj.searchBland.length > 0 ? exception.name.indexOf(self.searchObj.searchBland) > -1 : true;
  };
  /**
   * @return {undefined}
   */
  self.blandResize = function() {
    widget.resize("blandListCtrlScroll");
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.searchObj.searchBland = "";
    /** @type {string} */
    self.focused = "centered";
  };
  /**
   * @param {Object} expected
   * @param {?} r2
   * @param {Object} event
   * @return {?}
   */
  self.deleteGoodsBland = function(expected, r2, event) {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除" + expected.name + "?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        $scope.post("/KEY083?id=" + expected.id).success(function(r) {
          if (1 == r.statusCode) {
            dojo.toastShow("删除成功！");
            self.arrBland.splice(r2, 1);
            if (angular.equals(self.goodsInfo.bland, expected)) {
              self.goodsInfo.bland = {};
            }
          } else {
            dojo.toastShow("删除失败，不能删除已被使用的品牌！");
          }
        }).finally(function() {
          $scope.httpCacheGet.remove($scope.httpCacheGet.ac.BLANDLIST);
        });
      }
    }), event && event.stopPropagation(), true;
  };
}]).controller("GoodsUnitCtrl", ["$scope", "psisServices", "$ionicPopup", "Tools", "$ionicPopover", "$ionicModal", "lbScrollDelegate", "$rootScope", function(self, $scope, _, dojo, dataAndEvents, $modal, widget,rs) {
  self.searchObj = {
    searchUnit : ""
  };
  /** @type {string} */
  self.focused = "centered";
  $modal.fromTemplateUrl("goodsUnitEdit.html", function(theTitle) {
    /** @type {number} */
    self.goodsUnitEditModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.goodsUnitEditModal.remove();
  });

  self.goodsUnitModalSign = function(sign) {
    rs.goodsAidUnitSign = sign;
    self.goodsUnitForPriceModal.show();
  };

  /**
   * 选择单位
   * @param goodsInfo 商品信息
   * @param unitSelect  选中单位
   * @param goodsAidUnitInfo  辅助单位信息
   * @param sign  辅助单位标记
   */
  self.selectGoodsUnit = function(goodsInfo, unitSelect,goodsAidUnitInfo,sign) {
    var closeFlag = false;
    if (!sign){
      //基本单位
        if (goodsAidUnitInfo.aidUnit2.id === unitSelect.id || goodsAidUnitInfo.aidUnit3.id === unitSelect.id || goodsAidUnitInfo.aidUnit1.id === unitSelect.id){
          //dojo.toastShow("同一个商品不能选择相同单位", "short","bottom");
          //console.log("同一个商品不能选择相同单位");
          _.alert({
            template : "<div class='tc'>同一个商品不能选择相同单位</div>",
            okText : "确定"
          }).then(function() {
            //self.goBack();
          });
        }else {
          goodsInfo.unit = goodsInfo.unit === unitSelect ? {} : unitSelect;
          closeFlag = true;
        }
    } else if(angular.toJson(goodsInfo.unit) === "{}") {
        //dojo.toastShow("请先设置商品基本单位", "short","bottom");
        //console.log("请先设置商品基本单位");
      _.alert({
        template : "<div class='tc'>请先设置商品基本单位</div>",
        okText : "确定"
      }).then(function() {
        //self.goBack();
      });
    } else if (sign === "aid1") {//辅助单位1
        if (goodsAidUnitInfo.aidUnit2.id === unitSelect.id || goodsAidUnitInfo.aidUnit3.id === unitSelect.id || goodsInfo.unit.id === unitSelect.id){
          //dojo.toastShow("同一个商品不能选择相同单位", "short","bottom");
          //console.log("同一个商品不能选择相同单位");
          _.alert({
            template : "<div class='tc'>同一个商品不能选择相同单位</div>",
            okText : "确定"
          }).then(function() {
            //self.goBack();
          });
        }else{
          goodsAidUnitInfo.aidUnit1 = goodsAidUnitInfo.aidUnit1.id === unitSelect.id ? {} : unitSelect;
          closeFlag = true;
        }
    } else if (sign === "aid2") {//辅助单位2
        if (goodsAidUnitInfo.aidUnit1.id === unitSelect.id || goodsAidUnitInfo.aidUnit3.id === unitSelect.id || goodsInfo.unit.id === unitSelect.id){
          //dojo.toastShow("同一个商品不能选择相同单位", "short","bottom");
          //console.log("同一个商品不能选择相同单位");
          _.alert({
            template : "<div class='tc'>同一个商品不能选择相同单位</div>",
            okText : "确定"
          }).then(function() {
            //self.goBack();
          });
        }else{
          goodsAidUnitInfo.aidUnit2 = goodsAidUnitInfo.aidUnit2.id === unitSelect.id ? {} : unitSelect;
          closeFlag = true;
        }
    } else if (sign === "aid3") {//辅助单位3
        if (goodsAidUnitInfo.aidUnit1.id === unitSelect.id || goodsAidUnitInfo.aidUnit2.id === unitSelect.id || goodsInfo.unit.id === unitSelect.id){
          //dojo.toastShow("同一个商品不能选择相同单位", "short","bottom");
          //console.log("同一个商品不能选择相同单位");
          _.alert({
            template : "<div class='tc'>同一个商品不能选择相同单位</div>",
            okText : "确定"
          }).then(function() {
            //self.goBack();
          });
        }else{
          goodsAidUnitInfo.aidUnit3 = goodsAidUnitInfo.aidUnit3.id === unitSelect.id ? {} : unitSelect;
          closeFlag = true;
        }
    }

    if (closeFlag){
      self.goodsUnitModal.hide();
      self.goodsUnitForPriceModal.hide();
    }
  };
  /**
   * @param {string} dataAndEvents
   * @param {(Object|string)} theTitle
   * @param {?} event
   * @return {undefined}
   */
  self.openGoodsUnit = function(dataAndEvents, theTitle, event) {
    if ("insert" === dataAndEvents) {
      self.goodsUnitEdit = {
        enable : 1,
        showOrder : 100
      };
    } else {
      if ("update" === dataAndEvents) {
        /** @type {(Object|string)} */
        self.goodsUnitEdit = theTitle;
        if (event) {
          event.stopPropagation();
        }
      }
    }
    self.goodsUnitEditModal.show();
  };
  /**
   * @return {?}
   */
  self.saveGoodsUnit = function() {
    if (!self.goodsUnitEdit.name) {
      return dojo.toastShow("请填写名称！", "short", "center"), void console.log("请填写名称！");
    }
    /** @type {boolean} */
    var t = !self.goodsUnitEdit.id;
    var user = {
      newName : self.goodsUnitEdit.name
    };
    if (!t) {
      user.unitId = self.goodsUnitEdit.id;
    }
    $scope.postEncode("/KEY054", user).success(function(e) {
      if (e.isValid) {
        $scope.post("/KEY055", self.goodsUnitEdit).success(function(event) {
          if (1 == event.statusCode) {
            dojo.toastShow("保存成功！");
            dojo.union(self.goodsUnitEdit, event.object);
            if (t) {
              self.allUnits.push(event.object);
            }
            self.goodsUnitEditModal.hide();
          } else {
            dojo.toastShow("保存失败！");
          }
        });
      } else {
        dojo.toastShow("单位名称已存在！", "short", "center");
        console.log("单位名称已存在！");
      }
    }).finally(function() {
      $scope.httpCacheGet.remove($scope.httpCacheGet.ac.UNITLIST);
    });
  };
  /**
   * @param {Function} exception
   * @return {?}
   */
  self.filterUnit = function(exception) {
    return self.searchObj.searchUnit.length > 0 ? exception.name.indexOf(self.searchObj.searchUnit) > -1 : true;
  };
  /**
   * @return {undefined}
   */
  self.unitResize = function() {
    widget.resize("unitListCtrlScroll");
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.searchObj.searchUnit = "";
    /** @type {string} */
    self.focused = "centered";
  };
  /**
   * @param {Object} expected
   * @param {?} r2
   * @param {Object} event
   * @return {?}
   */
  self.deleteGoodsUnit = function(expected, r2, event) {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除" + expected.name + "?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        $scope.post("/KEY056?id=" + expected.id).success(function(r) {
          if (1 == r.statusCode) {
            dojo.toastShow("删除成功！");
            self.allUnits.splice(r2, 1);
            if (angular.equals(self.goodsInfo.unit, expected)) {
              self.goodsInfo.unit = {};
            }
          } else {
            dojo.toastShow("删除失败，不能删除已被使用的单位！");
          }
        }).finally(function() {
          $scope.httpCacheGet.remove($scope.httpCacheGet.ac.UNITLIST);
        });
      }
    }), event && event.stopPropagation(), true;
  };
}]).controller("GoodsCategoryCtrl", ["$scope", "psisServices", "$ionicPopup", "Tools", "$ionicPopover", "$ionicModal", "$timeout", "lbScrollDelegate", function($scope, _, $window, dojo, dataAndEvents, $modal, $sanitize, widget) {
  $scope.searchObj = {
    searchCategory : ""
  };
  /** @type {string} */
  $scope.focused = "centered";
  $modal.fromTemplateUrl("goodsCategoryEdit.html", function($location) {
    /** @type {number} */
    $scope.goodsCategoryEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.goodsCategoryEditModal.remove();
  });
  $modal.fromTemplateUrl("goodsCategoryParent.html", function($location) {
    $scope.goodsCategoryParentModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @param {string} dataAndEvents
   * @param {Element} n
   * @param {?} event
   * @return {undefined}
   */
  $scope.openGoodsCategory = function(dataAndEvents, n, event) {
    if ("insert" === dataAndEvents) {
      $scope.goodsCategoryEdit = {
        isShow : 1,
        showOrder : 100,
        ifShow : 1
      };
    } else {
      if ("update" === dataAndEvents) {
        $scope.goodsCategoryEdit = dojo.fnCheckGtoreQty($scope.allCategoryList, "id", n.id);
        $scope.goodsCategoryEdit.parentCategory = dojo.fnCheckGtoreQty($scope.allCategoryList, "id", $scope.goodsCategoryEdit.pid);
        if (event) {
          event.stopPropagation();
        }
      }
    }
    $scope.goodsCategoryEditModal.show();
  };
  /**
   * @return {undefined}
   */
  $scope.getCategoryList = function() {
    _.httpCacheGet.get(_.httpCacheGet.ac.CATEGORYLIST).success(function(column) {
      $sanitize(function() {
        $scope.$apply(function() {
          $scope.allCategoryList = column.rows;
          $scope.categoryTree = dojo.treeForCategory(0, "", false, column.rows).children;
          if (null != $scope.goodsInfo.category.id) {
            if (null != $scope.goodsCategoryEdit) {
              if ($scope.goodsCategoryEdit.id) {
                if ($scope.goodsInfo.category.id == $scope.goodsCategoryEdit.id) {
                  $scope.goodsInfo.category = dojo.fnCheckGtoreQty($scope.allCategoryList, "id", $scope.goodsInfo.category.id);
                }
              }
            }
          }
        });
      });
    });
  };
  /**
   * @param {MessageEvent} data
   * @param {Function} p2
   * @return {undefined}
   */
  $scope.selectGoodsCategory = function(data, p2) {
    data.category = data.category.id == p2.id ? {} : p2;
    $scope.goodsCategoryModal.hide();
  };
  /**
   * @return {?}
   */
  $scope.saveGoodsCategory = function() {
    if (!$scope.goodsCategoryEdit.name) {
      return dojo.toastShow("请填写分类名称！", "short", "center"), void console.log("请填写分类名称！");
    }
    /** @type {boolean} */
    var t = !$scope.goodsCategoryEdit.id;
    $scope.goodsCategoryEdit.pid = null == $scope.goodsCategoryEdit.parentCategory ? 0 : $scope.goodsCategoryEdit.parentCategory.id;
    var attributes = {
      parentCategoryId : $scope.goodsCategoryEdit.pid,
      value : $scope.goodsCategoryEdit.name
    };
    if (!t) {
      attributes.categoryId = $scope.goodsCategoryEdit.id;
    }
    _.postEncode("/KEY053", attributes).success(function(e) {
      if (e.isValid) {
        _.post("/KEY057", $scope.goodsCategoryEdit).success(function(r) {
          if (1 == r.statusCode) {
            dojo.toastShow("保存成功！");
            _.httpCacheGet.remove(_.httpCacheGet.ac.CATEGORYLIST);
            $scope.getCategoryList();
            $scope.goodsCategoryEditModal.hide();
          } else {
            dojo.toastShow("保存失败！");
          }
        });
      } else {
        dojo.toastShow("分类名称已存在！", "short", "center");
        console.log("分类名称已存在！");
      }
    }).finally(function() {
    });
  };
  /**
   * @return {undefined}
   */
  $scope.clearSearch = function() {
    /** @type {string} */
    $scope.searchObj.searchCategory = "";
    /** @type {string} */
    $scope.focused = "centered";
  };
  /**
   * @return {undefined}
   */
  $scope.categoryResize = function() {
    widget.resize("categoryListCtrlScroll");
  };
  /**
   * @param {Object} expected
   * @param {?} dataAndEvents
   * @param {Object} event
   * @return {?}
   */
  $scope.deleteGoodsCategory = function(expected, dataAndEvents, event) {
    var promise = $window.confirm({
      template : "<div class='tc'>您确认要删除" + expected.name + "?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    return promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        if (expected && expected.children.length > 0) {
          return dojo.toastShow("删除失败，请先删除此类别下的所有子类别！"), false;
        }
        _.post("/KEY058?id=" + expected.id).success(function(r) {
          if (1 == r.statusCode) {
            dojo.toastShow("删除成功！");
            if (angular.equals($scope.goodsInfo.category, expected)) {
              $scope.goodsInfo.category = {};
            }
            _.httpCacheGet.remove(_.httpCacheGet.ac.CATEGORYLIST);
            $scope.getCategoryList();
          } else {
            dojo.toastShow("删除失败，不能删除已被使用的分类！");
          }
        }).finally(function() {
        });
      }
    }), event && event.stopPropagation(), true;
  };
}]).controller("GenerateBarCodeCtrl", ["$scope", "$rootScope", "$timeout", "$state", "psisServices", "lbScrollDelegate", "$ionicModal", "Tools", "lruPersistCache", "$cordovaBarcodeScanner", "$ionicPopover", "lbSpinnerDialog", "$ionicPopup", "$q", function($, dataAndEvents, deepDataAndEvents, ignoreMethodDoesntExist, $http, textAlt, keepData, model, opt_attributes, matcherFunction, execResult, loading, _, $q) {
  /**
   * @param {?} dataAndEvents
   * @return {?}
   */
  function init(dataAndEvents) {
    var data = {
      barcodeItem : $.barCodeSetting.barcodeItem,
      barcodeType : $.barCodeSetting.barcodeType,
      factoryCode : $.barCodeSetting.factoryCode,
      startCode : $.barCodeSetting.startCode,
      id : $.barCodeSetting.id,
      optimisticLockVersion : $.barCodeSetting.optimisticLockVersion
    };
    /** @type {number} */
    data.status = $.barCodeSetting.enable ? 1 : 0;
    if (!dataAndEvents) {
      loading.show(true);
    }
    var imageDfd = $q.defer();
    return $http.post("/KEY074", data).success(function(image) {
      imageDfd.resolve(image);
    }).error(function() {
      console.error("服务器获取数据出现异常！");
      imageDfd.reject();
    }).finally(function() {
      loading.hide();
    }), imageDfd.promise;
  }
  $.barCodeSetting = {};
  /** @type {boolean} */
  $.addBarCodeEnable = false;
  /**
   * @return {?}
   */
  $.saveSetting = function() {
    return void 0 === $.barCodeSetting.factoryCode ? (model.toastShow("请检查8位厂商识别码"), false) : void 0 === $.barCodeSetting.startCode ? (model.toastShow("请检查产品代码起始值"), false) : void init().then(function(res) {
      if (1 == res.statusCode) {
        $.barCodeSetting = {
          id : res.object.id,
          optimisticLockVersion : res.object.optimisticLockVersion,
          barcodeItem : res.object.barcodeItem.toString(),
          barcodeType : res.object.barcodeType,
          status : res.object.status,
          startCode : res.object.startCode,
          factoryCode : res.object.factoryCode
        };
        /** @type {boolean} */
        $.barCodeSetting.enable = 1 == res.object.status;
        /** @type {boolean} */
        $.addBarCodeEnable = $.barCodeSetting.enable;
        model.toastShow("保存成功");
      }
    });
  };
  /**
   * @return {?}
   */
  $.addBarcode = function() {
    /**
     * @return {undefined}
     */
    function create() {
      /** @type {string} */
      var e = 1 == $.barCodeSetting.barcodeItem ? "商品条码" : "单品条码";
      var promise = _.confirm({
        template : "<div class='tc'>对所有无条码商品自动生成" + e + "</div>",
        cancelText : "取消",
        okText : "确认生成"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          loading.show(true);
          $http.post("/KEY073").success(function(res) {
            if (1 == res.statusCode) {
              /** @type {string} */
              var e = 1 == res.object.barcodeItem ? "商品" : "单品";
              if (0 == res.object.applyCount) {
                model.toastShow("不存在无条码" + e + "！");
              } else {
                if (res.object.applyCount < res.object.totalCount) {
                  _.alert({
                    template : "每次最多只能补充" + res.object.applyCount + "个条码<br>系统有" + res.object.totalCount + "个无条码" + e + "<br>本次操作已补充最近" + res.object.applyCount + "个" + e + "条码",
                    okText : "操作成功"
                  });
                } else {
                  model.toastShow("操作成功，共补充了" + res.object.applyCount + "个" + e + "条码！");
                }
              }
            } else {
              model.toastShow(res.content);
            }
          }).finally(function() {
            loading.hide();
          });
        }
      });
    }
    return void 0 === $.barCodeSetting.factoryCode ? (model.toastShow("请检查8位厂商识别码"), false) : void 0 === $.barCodeSetting.startCode ? (model.toastShow("请检查产品代码起始值"), false) : void init(true).then(function(res) {
      if (1 == res.statusCode) {
        $.barCodeSetting = {
          id : res.object.id,
          optimisticLockVersion : res.object.optimisticLockVersion,
          barcodeItem : res.object.barcodeItem.toString(),
          barcodeType : res.object.barcodeType,
          status : res.object.status,
          startCode : res.object.startCode,
          factoryCode : res.object.factoryCode
        };
        /** @type {boolean} */
        $.barCodeSetting.enable = 1 == res.object.status;
        /** @type {boolean} */
        $.addBarCodeEnable = $.barCodeSetting.enable;
        create();
      }
    });
  };
  $.$on("$ionicView.loaded", function() {
    loading.show();
    $http.post("/KEY072").success(function(res) {
      if (1 == res.statusCode) {
        if (res.object) {
          $.barCodeSetting = {
            id : res.object.id,
            optimisticLockVersion : res.object.optimisticLockVersion,
            barcodeItem : res.object.barcodeItem.toString(),
            barcodeType : res.object.barcodeType,
            status : res.object.status,
            startCode : res.object.startCode,
            factoryCode : res.object.factoryCode
          };
          /** @type {boolean} */
          $.barCodeSetting.enable = 1 == res.object.status ? true : false;
          /** @type {boolean} */
          $.addBarCodeEnable = $.barCodeSetting.enable;
        } else {
          $.barCodeSetting = {
            enable : false,
            barcodeItem : "2",
            barcodeType : "ean13",
            factoryCode : 69012345,
            startCode : 1234
          };
          /** @type {boolean} */
          $.addBarCodeEnable = false;
        }
      }
    }).finally(function() {
      loading.hide();
    });
  });
}]).controller("PrintBarCodeCtrl", ["$scope", "$rootScope", "$timeout", "$state", "psisServices", "lbScrollDelegate", "$ionicModal", "Tools", "lruPersistCache", "$cordovaBarcodeScanner", "$ionicPopover", "lbSpinnerDialog", "$ionicPopup", "$stateParams", "commonDataInterface", "$window", "BluetoothPrintService", "BTScanerService", "PrintType", function(self, dataAndEvents, $sanitize, $state, game, parent, $modal, path, keepData, Hogan, FB,
loading, view, textAlt, deepDataAndEvents, $window, jQuery, $document, ignoreMethodDoesntExist) {
  /** @type {Array} */
  self.items = [];
  /** @type {Array} */
  self.selectedItems = [];
  /** @type {boolean} */
  self.isLoading = true;
  /** @type {string} */
  self.selectTiltle = "全选";
  /** @type {string} */
  $window.localStorage.bluePrinterBarCodeId = "";
  /** @type {Array} */
  self.columnList = [{
    text : "名称",
    val : "goodsName"
  }, {
    text : "货号",
    val : "goodsSn"
  }, {
    text : "品牌",
    val : "blandName"
  }, {
    text : "颜色",
    val : "color"
  }, {
    text : "尺码",
    val : "size"
  }, {
    text : "售价",
    val : "price"
  }, {
    text : "条码",
    val : "barCode"
  }];
  /** @type {Array} */
  self.checkColumns = [];
  self.goodsInfo = {
    name : "",
    isOnSale : 1,
    isOnSaleName : "启用"
  };
  self.queryCondition = {
    page : 1,
    operator : 3,
    sidx : "",
    sord : "",
    listModel : 1
  };
  self.filterObj = {
    noBarCode : true
  };
  self.printObj = {
    gap : 3,
    times : 1,
    barCodePrice : "retailPrice",
    barCodeType : "128",
    labelType : "normal"
  };
  self.allCategoryList = {};
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    Hogan.scan().then(function(data) {
      if (!data.cancelled) {
        $sanitize(function() {
          self.goodsInfo.name = data.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      path.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {?}
   */
  var Step = function() {
    return game.postEncode("/KEY121", self.queryCondition);
  };
  self.queryCondition.ordersSn = textAlt.ordersSn;
  /**
   * @param {?} dataAndEvents
   * @return {?}
   */
  self.getBarcode = function(dataAndEvents) {
    return 1 == self.queryCondition.listModel ? dataAndEvents.barCode : 0 != self.queryCondition.listModel ? dataAndEvents.skuBarCode : dataAndEvents.skuBarCode ? dataAndEvents.skuBarCode : void 0;
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {string} */
    self.selectTiltle = "全选";
    loading.show(true);
    if (0 == self.queryCondition.listModel) {
      /** @type {number} */
      self.queryCondition.page = 1;
      delete self.queryCondition.barCode;
      delete self.queryCondition.goodsSn;
      delete self.queryCondition.name;
      delete self.queryCondition.skuBarCode;
      delete self.queryCondition.skuSn;
      delete self.queryCondition.categoryIdsStr;
      delete self.queryCondition.blandId;
      delete self.queryCondition.isOnSale;
    } else {
      self.queryCondition.categoryIdsStr = self.goodsInfo.category ? path.getCategoryChildIds(self.allCategoryList, self.goodsInfo.category.id) : "";
      self.queryCondition.blandId = self.goodsInfo.bland ? self.goodsInfo.bland.id : "";
      self.queryCondition.isOnSale = self.goodsInfo.isOnSale ? self.goodsInfo.isOnSale : "";
      /** @type {number} */
      self.queryCondition.page = 1;
      if (!self.queryCondition.ordersSn) {
        delete self.queryCondition.ordersSn;
      }
      if (self.goodsInfo.name) {
        self.queryCondition.barCode = self.goodsInfo.name;
        self.queryCondition.goodsSn = self.goodsInfo.name;
        self.queryCondition.name = self.goodsInfo.name;
        self.queryCondition.skuBarCode = self.goodsInfo.name;
        self.queryCondition.skuSn = self.goodsInfo.name;
      } else {
        delete self.queryCondition.barCode;
        delete self.queryCondition.goodsSn;
        delete self.queryCondition.name;
        delete self.queryCondition.skuBarCode;
        delete self.queryCondition.skuSn;
      }
      if (self.goodsInfo.name || (self.queryCondition.categoryIdsStr || (self.queryCondition.blandId || 1 !== self.queryCondition.isOnSale))) {
        if (self.queryCondition.ordersSn) {
          delete self.queryCondition.ordersSn;
        }
      }
    }
    Step().success(function(response) {
      if (1 == response.statusCode && response.object) {
        /** @type {Array} */
        self.selectedItems = [];
        self.items = response.object.rows;
        /** @type {boolean} */
        self.loadMoreBtn = response.object.page < response.object.total;
        if (0 == self.items.length) {
          if (1 == self.queryCondition.listModel) {
            path.toastShow("暂无数据，可尝试切换到【单品条码】");
          } else {
            if (2 == self.queryCondition.listModel) {
              path.toastShow("暂无数据，可尝试切换到【商品条码】");
            }
          }
        }
      } else {
        /** @type {Array} */
        self.selectedItems = [];
        /** @type {Array} */
        self.items = [];
        /** @type {boolean} */
        self.loadMoreBtn = false;
      }
    }).finally(function() {
      parent.scrollTop("goodListCtrlScroll");
      loading.hide();
      /** @type {boolean} */
      self.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    loading.show(true);
    Step().success(function(response) {
      if (1 == response.statusCode) {
        self.items = self.items.concat(response.object.rows);
        /** @type {boolean} */
        self.loadMoreBtn = response.object.page < response.object.total;
      } else {
        /** @type {boolean} */
        self.loadMoreBtn = false;
      }
    }).finally(function() {
      parent.resize("goodListCtrlScroll");
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.resetByOrderSn = function() {
    /** @type {number} */
    self.queryCondition.listModel = 0;
    /** @type {Array} */
    self.selectedItems = [];
    /** @type {Array} */
    self.items = [];
    /** @type {boolean} */
    self.loadMoreBtn = false;
    /** @type {string} */
    self.selectTiltle = "全选";
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    /** @type {null} */
    self.goodsInfo.name = null;
    /** @type {null} */
    self.goodsInfo.category = null;
    /** @type {null} */
    self.goodsInfo.bland = null;
    /** @type {null} */
    self.queryCondition.ordersSn = null;
  };
  /**
   * @return {undefined}
   */
  self.selectAll = function() {
    if ("全选" == self.selectTiltle) {
      /** @type {Array} */
      self.selectedItems = [];
      /** @type {number} */
      var i = 0;
      var ilen = self.items.length;
      for (;ilen > i;i++) {
        if (self.items[i].skuBarCode && 1 != self.queryCondition.listModel || self.items[i].barCode && 1 == self.queryCondition.listModel) {
          if (self.items[i].quantity > 0) {
            self.selectedItems.push(self.items[i]);
          } else {
            self.items[i].quantity = self.printObj.times;
            self.selectedItems.push(self.items[i]);
          }
        }
      }
      /** @type {string} */
      self.selectTiltle = "取消";
    } else {
      /** @type {string} */
      self.selectTiltle = "全选";
      /** @type {number} */
      i = 0;
      ilen = self.items.length;
      for (;ilen > i;i++) {
        /** @type {string} */
        self.items[i].quantity = "";
      }
      /** @type {Array} */
      self.selectedItems = [];
    }
  };
  /**
   * @param {string} item
   * @return {undefined}
   */
  self.selectGoods = function(item) {
    if (item.skuBarCode && 1 != self.queryCondition.listModel || item.barCode && 1 == self.queryCondition.listModel) {
      var ix = self.selectedItems.indexOf(item);
      if (ix > -1) {
        /** @type {string} */
        item.quantity = "";
        self.selectedItems.splice(ix, 1);
      } else {
        if (item.quantity > 0) {
          self.selectedItems.push(item);
        } else {
          item.quantity = self.printObj.times;
          self.selectedItems.push(item);
        }
      }
    }
  };
  /**
   * @param {string} item
   * @param {?} event
   * @return {undefined}
   */
  self.updatePrintTimes = function(item, event) {
    if (event) {
      event.stopPropagation();
    }
    /** @type {string} */
    var value = "更改打印份数";
    /** @type {string} */
    var x = "请输入" + (1 == self.queryCondition.listModel ? "商品" : "单品") + "条码打印份数";
    if (window.cordova && window.cordova.plugins) {
      path.showPrompt(x, function(result) {
        if (2 == result.buttonIndex) {
          self.$apply(function() {
            if (result.input1 > 0 && /^[0-9]+$/.test(result.input1)) {
              item.quantity = result.input1;
              var $item = self.selectedItems.indexOf(item);
              if (0 > $item) {
                self.selectedItems.push(item);
              }
            } else {
              path.toastShow("请填写正整数");
            }
          });
        }
      }, value, ["取消", "确认"], item.quantity ? item.quantity.toString() : "0");
    } else {
      self.Object = {
        quantity : item.quantity
      };
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" ng-model="Object.quantity" class="tc"  placeholder="" autofocus="true">',
        title : value,
        subTitle : x,
        scope : self,
        buttons : [{
          text : "取消"
        }, {
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            if (self.Object.quantity > 0 && /^[0-9]+$/.test(self.Object.quantity)) {
              item.quantity = self.Object.quantity;
              var $item = self.selectedItems.indexOf(item);
              if (0 > $item) {
                self.selectedItems.push(item);
              }
            } else {
              path.toastShow("请填写正整数");
            }
          }
        }]
      });
    }
  };
  /**
   * @return {?}
   */
  self.barCodePrintSetting = function() {
    return self.printObj.gap > 0 ? self.printObj.times ? "diy" != self.printObj.labelType || self.printObj.width >= 5 && self.printObj.width <= 110 ? "diy" != self.printObj.labelType || self.printObj.height >= 5 && self.printObj.height <= 150 ? (self.printSettingForBarCodeModal.hide(), void self.saveConfig()) : (path.toastShow("标签高度度需要大于等于5小于等于150的整数"),
    false) : (path.toastShow("标签宽度需要大于等于5小于等于110的整数"), false) : (path.toastShow("请检查 打印份数"), false) : (path.toastShow("请检查 标签间隙"), false);
  };
  /**
   * @return {?}
   */
  self.printSelectedItems = function() {
    if (!(self.printObj.gap > 0)) {
      return path.toastShow("请检查 标签间隙"), false;
    }
    if (!self.printObj.times) {
      return path.toastShow("请检查 打印份数"), false;
    }
    /** @type {number} */
    var node = 0;
    /** @type {number} */
    var i = 0;
    for (;i < self.selectedItems.length;i++) {
      node = path.accAdd(self.selectedItems[i].quantity, node);
    }
    /** @type {number} */
    var labelWidth = 40;
    /** @type {number} */
    var labelHeight = 30;
    if ("normal" == self.printObj.labelType) {
      /** @type {number} */
      labelWidth = 40;
      /** @type {number} */
      labelHeight = 30;
    } else {
      if ("cloth" == self.printObj.labelType) {
        /** @type {number} */
        labelWidth = 40;
        /** @type {number} */
        labelHeight = 50;
      } else {
        labelWidth = self.printObj.width > 0 ? self.printObj.width : 40;
        labelHeight = self.printObj.height > 0 ? self.printObj.height : 30;
      }
    }
    var promise = view.confirm({
      template : "1、打印规格为" + labelWidth + "*" + labelHeight + " 标签/条码" + ("<br>2、选择" + (1 == self.queryCondition.listModel ? "商品" : "单品") + "数为 " + self.selectedItems.length + "；一共待打印" + node + " 张") + "<br><br><span class='f12'>注意：打印机需切换到条码模式（LABEL）</span>",
      cancelText : "取消",
      okText : "打印"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        /** @type {Array} */
        var args = [];
        /** @type {number} */
        var program = 20;
        /** @type {number} */
        var i = 0;
        var l = self.selectedItems.length;
        for (;l > i;i++) {
          var post = {};
          /** @type {string} */
          var foo = "售价: " + self.currencySymbol + ("retailPrice" == self.printObj.barCodePrice ? self.selectedItems[i].retailPriceArea : self.selectedItems[i].tradePrice);
          if (1 == self.queryCondition.listModel) {
            if ("cloth" == self.printObj.labelType || "diy" == self.printObj.labelType) {
              if (self.checkColumns.indexOf("goodsName") > -1) {
                /** @type {string} */
                post.title = "名称：" + self.selectedItems[i].name;
              }
              if (self.checkColumns.indexOf("goodsSn") > -1) {
                /** @type {string} */
                post.str1 = "货号：" + self.selectedItems[i].goodsSn;
              }
              if (self.checkColumns.indexOf("blandName") > -1) {
                if (self.selectedItems[i].blandName) {
                  /** @type {string} */
                  post.str2 = "品牌：" + (self.selectedItems[i].blandName ? self.selectedItems[i].blandName : "");
                }
              }
              if (self.checkColumns.indexOf("price") > -1) {
                /** @type {string} */
                post.str3 = foo;
              }
              if (self.checkColumns.indexOf("barCode") > -1) {
                post.barCode = self.selectedItems[i].barCode;
              }
              post.printTimes = self.selectedItems[i].quantity > 0 ? self.selectedItems[i].quantity.toString() : "";
              args.push(post);
            } else {
              if (self.checkColumns.indexOf("goodsName") > -1) {
                post.title = self.selectedItems[i].name;
              }
              if (self.checkColumns.indexOf("goodsSn") > -1) {
                post.str1 = self.selectedItems[i].goodsSn;
              }
              if (self.checkColumns.indexOf("blandName") > -1) {
                if (self.selectedItems[i].blandName) {
                  post.str2 = self.selectedItems[i].blandName ? self.selectedItems[i].blandName : "";
                }
              }
              if (self.checkColumns.indexOf("price") > -1) {
                post.str3 = path.padLeft(foo, program, " ");
              }
              if (self.checkColumns.indexOf("barCode") > -1) {
                post.barCode = self.selectedItems[i].barCode;
              }
              post.printTimes = self.selectedItems[i].quantity > 0 ? self.selectedItems[i].quantity.toString() : "";
              args.push(post);
            }
          } else {
            if ("cloth" == self.printObj.labelType || "diy" == self.printObj.labelType) {
              if (self.checkColumns.indexOf("goodsName") > -1) {
                /** @type {string} */
                post.title = "名称：" + self.selectedItems[i].name;
              }
              if (self.checkColumns.indexOf("goodsSn") > -1) {
                /** @type {string} */
                post.str1 = "货号：" + self.selectedItems[i].goodsSn;
              }
              if (self.checkColumns.indexOf("color") > -1) {
                /** @type {string} */
                post.str2 = "颜色：" + self.selectedItems[i].colorName;
              }
              if (self.checkColumns.indexOf("size") > -1) {
                /** @type {string} */
                post.str3 = "尺码：" + self.selectedItems[i].sizeName;
              }
              if (self.checkColumns.indexOf("blandName") > -1) {
                if (self.selectedItems[i].blandName) {
                  /** @type {string} */
                  post.str4 = "品牌：" + (self.selectedItems[i].blandName ? self.selectedItems[i].blandName : "");
                }
              }
              if (self.checkColumns.indexOf("price") > -1) {
                /** @type {string} */
                post.str5 = foo;
              }
              if (self.checkColumns.indexOf("barCode") > -1) {
                post.barCode = self.selectedItems[i].skuBarCode ? self.selectedItems[i].skuBarCode : self.selectedItems[i].barCode;
              }
              post.printTimes = self.selectedItems[i].quantity > 0 ? self.selectedItems[i].quantity.toString() : "";
              args.push(post);
            } else {
              if (self.checkColumns.indexOf("goodsName") > -1) {
                post.title = self.selectedItems[i].name;
              }
              if (self.checkColumns.indexOf("goodsSn") > -1) {
                post.str1 = self.selectedItems[i].goodsSn;
              }
              if (self.checkColumns.indexOf("color") > -1) {
                /** @type {string} */
                post.str2 = self.selectedItems[i].colorName + " - " + self.selectedItems[i].sizeName;
              }
              if (self.checkColumns.indexOf("blandName") > -1) {
                if (self.selectedItems[i].blandName) {
                  post.str4 = self.selectedItems[i].blandName ? self.selectedItems[i].blandName : "";
                }
              }
              if (self.checkColumns.indexOf("price") > -1) {
                post.str5 = path.padLeft(foo, program, " ");
              }
              if (self.checkColumns.indexOf("barCode") > -1) {
                post.barCode = self.selectedItems[i].skuBarCode ? self.selectedItems[i].skuBarCode : self.selectedItems[i].barCode;
              }
              post.printTimes = self.selectedItems[i].quantity > 0 ? self.selectedItems[i].quantity.toString() : "";
              args.push(post);
            }
          }
        }
        if (args.length > 0) {
          var restoreScript = {
            labelWidth : labelWidth,
            labelHeight : labelHeight,
            labelGap : self.printObj.gap > 0 ? self.printObj.gap : 3,
            barCodeType : self.printObj.barCodeType,
            labelType : self.printObj.labelType
          };
          if ($window.localStorage.bluePrinterBarCodeId) {
            jQuery.connectBluetoothForBarCode($window.localStorage.bluePrinterBarCodeId, restoreScript, args, self.printObj.times, ignoreMethodDoesntExist.printLabel, true);
          } else {
            $state.go("eventmenu.KEY116", {
              printType : ignoreMethodDoesntExist.printLabel,
              labelSetting : restoreScript,
              labelArray : args,
              printTimes : self.printObj.times
            });
          }
        } else {
          path.toastShow("未选择任何存在条码的数据");
        }
      }
    });
  };
  /**
   * @param {?} dataAndEvents
   * @return {?}
   */
  self.filterItem = function(dataAndEvents) {
    return self.filterObj.noBarCode ? (1 != self.queryCondition.listModel || dataAndEvents.barCode) && ((2 != self.queryCondition.listModel || dataAndEvents.skuBarCode) && (0 != self.queryCondition.listModel || dataAndEvents.skuBarCode)) ? true : false : true;
  };
  $modal.fromTemplateUrl("goodListQuery.html", function(theTitle) {
    self.goodListQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsCategoryQuery.html", function(theTitle) {
    self.goodsCategoryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsBlandQuery.html", function(theTitle) {
    self.goodsBlandModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("isOnSale.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.isOnSalePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openIsOnSalePopover = function(expectedNumberOfNonCommentArgs) {
    self.isOnSalePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideIsOnSalePopover = function() {
    self.isOnSalePopover.hide();
  };
  $modal.fromTemplateUrl("printSettingForBarCode.html", function(theTitle) {
    /** @type {number} */
    self.printSettingForBarCodeModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.goodListQueryModal.remove();
    self.goodsCategoryModal.remove();
    self.goodsBlandModal.remove();
    self.isOnSalePopover.remove();
    self.printSettingForBarCodeModal.remove();
  });
  self.$on("$ionicView.afterEnter", function() {
    $document.getScanerCode(function(dataAndEvents) {
      if (dataAndEvents) {
        if (!self.goodListQueryModal.isShown()) {
          self.queryCondition.barCode = dataAndEvents;
          self.queryCondition.skuBarCode = dataAndEvents;
          loading.show(true);
          Step().success(function(response) {
            if (1 == response.statusCode) {
              /** @type {Array} */
              self.selectedItems = [];
              if (response.object) {
                self.items = response.object.rows;
                /** @type {boolean} */
                self.loadMoreBtn = response.object.page < response.object.total;
                if (self.items) {
                  if (0 == self.items.length) {
                    path.toastShow("找不到条码为" + dataAndEvents + "的商品");
                    view.alert({
                      template : "<div class='tc'>"+"找不到条码为" + dataAndEvents + "的商品"+"</div>",
                      okText : "确定"
                    });
                  }
                }
              }
            } else {
              path.toastShow("找不到条码为" + dataAndEvents + "的商品");

              view.alert({
                template : "<div class='tc'>"+"找不到条码为" + dataAndEvents + "的商品"+"</div>",
                okText : "确定"
              });

              /** @type {Array} */
              self.selectedItems = [];
              /** @type {Array} */
              self.items = [];
              /** @type {boolean} */
              self.loadMoreBtn = false;
            }
          }).finally(function() {
            parent.scrollTop("goodListCtrlScroll");
            loading.hide();
            /** @type {boolean} */
            self.isLoading = false;
          });
        }
      }
    }, self.bluethoothScaner);
    game.httpCacheGet.get(game.httpCacheGet.ac.BLANDLIST).success(function(theTitle) {
      self.arrBland = theTitle;
    });
  });
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectColumn = function(key) {
    var camelKey = self.checkColumns.indexOf(key);
    if (camelKey > -1) {
      self.checkColumns.splice(camelKey, 1);
    } else {
      self.checkColumns.push(key);
    }
  };
  /**
   * @return {undefined}
   */
  self.saveConfig = function() {
    var generatedColumn = {
      printObj : self.printObj,
      checkColumns : self.checkColumns
    };
    deepDataAndEvents.saveOrUpdateUserConfig("labelPrintSetting", JSON.stringify(generatedColumn), 2).then(function() {
      console.log("保存成功！");
    }, function() {
      console.log("服务器获取数据出现异常！");
    });
  };
  self.$on("$ionicView.loaded", function() {
    if (self.queryCondition.ordersSn) {
      /** @type {number} */
      self.queryCondition.listModel = 0;
      /** @type {boolean} */
      self.filterObj.noBarCode = false;
    }
    self.getList();
    game.httpCacheGet.get(game.httpCacheGet.ac.CATEGORYLIST).success(function(info) {
      self.allCategoryList = info.rows;
      self.categoryTree = path.treeForCategory(0, "", false, info.rows).children;
    });
    deepDataAndEvents.getUserConfig("labelPrintSetting").then(function(res) {
      if (1 == res.statusCode && (res.object && res.object.configValue)) {
        /** @type {*} */
        var message = JSON.parse(res.object.configValue);
        self.printObj = message.printObj;
        self.printObj.gap = message.printObj && message.printObj.gap ? message.printObj.gap : 3;
        self.checkColumns = message.checkColumns;
      } else {
        /** @type {Array} */
        self.checkColumns = ["goodsName", "goodsSn", "color", "size", "price", "barCode"];
      }
    });
  });
  self.$on("$ionicView.beforeLeave", function() {
    $document.getScanerCode(function() {
    }, self.bluethoothScaner);
  });
}]);
