angular.module("goodScanController", ["ionic", "services", "tools"]).controller("GoodScanNavCtrl", ["$scope", "$rootScope", "$state", "$stateParams", "$ionicModal", "psisServices", "lbSpinnerDialog", "$q", "Tools", "$timeout", "lbScrollDelegate", "$window", "$ionicSlideBoxDelegate", "lruPersistCache", "$ionicPopover", "$filter", "ReportConstant", "BTScanerService", "$ionicLoading", "$ionicActionSheet", function(self, deepDataAndEvents, options, err, $modal, result, loading,
$q, $, $sanitize, parent, $window, dataAndEvents, $templateCache, FB, toString, colls, $document, ignoreMethodDoesntExist, a) {
  /**
   * @return {?}
   */
  function resolve() {
    var imageDfd = $q.defer();
    var request1 = result.httpCacheGet.get(result.httpCacheGet.ac.COLORSELECT);
    var getPromise3 = result.httpCacheGet.get(result.httpCacheGet.ac.SIZESELECT);
    var c = result.httpCacheGet.get(result.httpCacheGet.ac.BLANDLIST);
    var d = result.httpCacheGet.get(result.httpCacheGet.ac.CATEGORYLIST);
    var projectName = result.httpCacheGet.get(result.httpCacheGet.ac.STOREHOUSEAVAILABLE);
    return $q.all([request1, getPromise3, c, d, projectName]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @return {undefined}
   */
  function init() {
    /** @type {Array} */
    var keys = [];
    $.union(keys, self.items);
    /** @type {number} */
    var i = 0;
    for (;i < self.allStorehouse.length;i++) {
      /** @type {number} */
      var idx = 0;
      for (;idx < self.goodsInfo.colors.length;idx++) {
        /** @type {number} */
        var s = 0;
        for (;s < self.goodsInfo.sizes.length;s++) {
          var key = $.getObjectByObject(keys, {
            storehouseId : self.allStorehouse[i].id,
            colorId : self.goodsInfo.colors[idx].id,
            sizeId : self.goodsInfo.sizes[s].id
          });
          if (key) {
            /** @type {number} */
            var k = keys.indexOf(key);
            keys.splice(k, 1);
          } else {
            self.items.push({
              storehouseId : self.allStorehouse[i].id,
              storehouseName : self.allStorehouse[i].name,
              colorId : self.goodsInfo.colors[idx].id,
              colorName : self.goodsInfo.colors[idx].name,
              sizeId : self.goodsInfo.sizes[s].id,
              sizeName : self.goodsInfo.sizes[s].name,
              number : ""
            });
          }
        }
      }
    }
  }
  var data;
  /** @type {string} */
  self.goodsSn = "";
  self.goods = {};
  self.goodsInfo = {
    bland : {},
    unit : {},
    colors : [],
    sizes : [],
    category : {},
    sku : {},
    imgList : []
  };
  self.order = {};
  self.isShowGoodsStore = err.isFromStore ? self.GetOperatorEventLimit("KEY142") : false;
  /** @type {boolean} */
  self.isShowImportantPrice = false;
  self.showImgHandle = dataAndEvents.$getByHandle("imgShowDelegate");
  /**
   * @param {string} settings
   * @return {?}
   */
  self.parseToInt = function(settings) {
    return settings.number ? parseInt(settings.number) : 0;
  };
  /** @type {string} */
  self.backTitle = ionic.Platform.isIOS() ? "返回" : "";
  self.setting = {
    hideNull : true,
    mergeStore : true,
    hideZero : true
  };
  /**
   * @param {string} err
   * @return {?}
   */
  self.filterNull = function(err) {
    return(self.setting.hideNull ? "" !== err.number : true) && (self.setting.hideZero ? "0" !== err.number : true);
  };
  self.$on("$ionicView.afterEnter", function() {
    if ($templateCache.get("goodListRefresh")) {
      if ($templateCache.get("goodListRefresh") === true) {
        $templateCache.put("goodListRefresh", false);
        /** @type {boolean} */
        deepDataAndEvents.isRefreshGoodsListForMain = true;
        if ($templateCache.get("goodDeleteReturn") && $templateCache.get("goodDeleteReturn") === true) {
          $templateCache.put("goodDeleteReturn", false);
          self.goBack();
        } else {
          save();
          if (!self.isShowGoodsStore) {
            process({
              goodsSn : err.goodsSn,
              createTimeBegin : $.getOffsetDayBegin((new Date).getTime(), -29),
              createTimeEnd : $.getOffsetDayBegin((new Date).getTime(), 1)
            }).then(function(option) {
              loading.hide();
              data = echarts.init(document.getElementById("saleVolumeChartDiv"), colls.echartsTheme);
              data.setOption(option);
            });
          }
        }
      }
    }
    $document.getScanerCode(function(dataAndEvents) {
      self.search.goodKey = dataAndEvents;
      self.searchGoods();
    }, self.bluethoothScaner);
  });
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var process = function(opt_attributes) {
    var conn = $q.defer();
    return result.post("/KEY100", opt_attributes).success(function(res) {
      var data = res.rows;
      /** @type {Array} */
      var products = [];
      /** @type {Array} */
      var player = [];
      /** @type {Array} */
      var parsedData = [];
      /** @type {Array} */
      var postData = [];
      /** @type {number} */
      var i = 0;
      var l = data.length;
      for (;l > i;i++) {
        products.push(toString("date")(data[i].calDate, "MM-dd"));
        player.push(data[i].amount);
        parsedData.push(data[i].quantity);
        postData.push(data[i].sumGrossProfit);
      }
      var d = {
        tooltip : {
          trigger : "axis"
        },
        legend : {
          data : ["日销售量", "日销售额", "日毛利"]
        },
        toolbox : {
          show : false,
          feature : {
            mark : {
              show : true
            },
            dataView : {
              show : true,
              readOnly : false
            },
            magicType : {
              show : true,
              type : ["line", "bar"]
            },
            restore : {
              show : true
            },
            saveAsImage : {
              show : true
            }
          }
        },
        calculable : false,
        xAxis : [{
          type : "category",
          name : "(日)",
          boundaryGap : false,
          data : products
        }],
        yAxis : [{
          name : "单位(" + self.currencySymbol + ")",
          type : "value",
          axisLabel : {
            formatter : "{value}"
          }
        }, {
          name : "销售量",
          type : "value",
          axisLabel : {
            formatter : "{value}"
          }
        }],
        series : [{
          name : "日销售量",
          type : "bar",
          data : parsedData,
          yAxisIndex : 1,
          itemStyle : {
            normal : {
              label : {
                show : false
              },
              color : "#a7e4fa"
            }
          }
        }, {
          name : "日销售额",
          type : "line",
          smooth : true,
          data : player,
          yAxisIndex : 0,
          itemStyle : {
            normal : {
              label : {
                show : false
              },
              color : "#ff9000"
            }
          }
        }, {
          name : "日毛利",
          type : "line",
          smooth : true,
          data : postData,
          yAxisIndex : 0,
          itemStyle : {
            normal : {
              label : {
                show : false
              },
              color : "#ffd200"
            }
          }
        }]
      };
      conn.resolve(d);
    }).error(function() {
      conn.reject();
    }), conn.promise;
  };
  self.$on("$ionicView.loaded", function() {
    /** @type {boolean} */
    self.setting.hideNull = "false" == $window.localStorage.goodsStoreHideNull ? false : true;
    /** @type {boolean} */
    self.setting.mergeStore = "false" == $window.localStorage.goodsStoreMergeStore ? false : true;
    /** @type {boolean} */
    self.setting.hideZero = "false" == $window.localStorage.goodsStoreHideZero ? false : true;
    save();
    if (!self.isShowGoodsStore) {
      process({
        goodsSn : err.goodsSn,
        createTimeBegin : $.getOffsetDayBegin((new Date).getTime(), -29),
        createTimeEnd : $.getOffsetDayBegin((new Date).getTime(), 1)
      }).then(function(option) {
        loading.hide();
        data = echarts.init(document.getElementById("saleVolumeChartDiv"), colls.echartsTheme);
        data.setOption(option);
      });
    }
  });
  self.$on("$ionicView.beforeLeave", function() {
    /** @type {string} */
    $window.localStorage.goodsStoreHideNull = self.setting.hideNull ? "true" : "false";
    /** @type {string} */
    $window.localStorage.goodsStoreMergeStore = self.setting.mergeStore ? "true" : "false";
    /** @type {string} */
    $window.localStorage.goodsStoreHideZero = self.setting.hideZero ? "true" : "false";
  });
  /**
   * @return {undefined}
   */
  var save = function() {
    loading.show();
    resolve().then(function(packs) {
      self.allColors = packs[0].data.optionList;
      self.allSizes = packs[1].data.optionList;
      self.arrBland = packs[2].data;
      var width = packs[3].data.rows;
      self.allCategoryList = width;
      self.categoryTree = $.treeForCategory(0, "", false, width).children;
      /** @type {Array} */
      self.allDept = [];
      /** @type {number} */
      var dataIndex = 0;
      for (;dataIndex < packs[4].data.length;dataIndex++) {
        if ("1" == packs[4].data[dataIndex].status) {
          self.allDept.push(packs[4].data[dataIndex]);
        }
      }
      self.allStorehouse = packs[4].data;
      result.post("/KEY075?goodsId=" + err.code).success(function(result) {
        self.goodImgs = result.rows;
        if (0 == self.goodImgs.length) {
          /** @type {Array} */
          self.goodImgs = [{
            url : "img/detailpic_no_s.png"
          }];
          /** @type {number} */
          self.noImages = 1;
        } else {
          /** @type {number} */
          self.noImages = 0;
        }
      });
      if (err.code) {
        /** @type {number} */
        self.state = 1;
        result.post("/KEY063?id=" + err.code).success(function(req) {
          self.goods = req.goodsVO;
          self.goodsSn = req.goodsVO.goodsSn;
          /** @type {Array} */
          self.goodsInfo.colors = [];
          /** @type {Array} */
          self.goodsInfo.sizes = [];
          /** @type {number} */
          var i = 0;
          var ilen = self.allColors.length;
          for (;ilen > i;i++) {
            if (req.goodsVO.colorIds.indexOf(self.allColors[i].id) > -1) {
              self.goodsInfo.colors.push(self.allColors[i]);
            }
          }
          /** @type {number} */
          i = 0;
          ilen = self.allSizes.length;
          for (;ilen > i;i++) {
            if (req.goodsVO.sizeIds.indexOf(self.allSizes[i].id) > -1) {
              self.goodsInfo.sizes.push(self.allSizes[i]);
            }
          }
          var character = $.fnCheckGtoreQty(self.arrBland, "id", req.goodsVO.blandId);
          self.goodsInfo.bland = character ? character : {};
          var buf = $.fnCheckGtoreQty(self.allCategoryList, "id", req.goodsVO.categoryId);
          self.goodsInfo.category = buf ? buf : {};
          result.postEncode("/KEY092", {
            goodsSn : self.goodsSn
          }).success(function(p) {
            $sanitize(function() {
              /** @type {Array} */
              self.items = [];
              /** @type {number} */
              var l = 0;
              var pl = p.length;
              for (;pl > l;l++) {
                if (p.length > l && (p[l].storehouseId && p[l].storehouseId > 0)) {
                  /** @type {number} */
                  var i = 0;
                  for (;i < self.allStorehouse.length;i++) {
                    if (p[l].storehouseId == self.allStorehouse[i].id) {
                      self.items.push(p[l]);
                    }
                  }
                }
              }
              init();
              self.scrollContent();
            });
          }).finally(function() {
            loading.hide();
          });
        }).finally(function() {
          loading.hide();
        });
        result.post("/KEY097?goodsSn=" + err.goodsSn).success(function(message) {
          self.goodReport = message.goodSaleReport;
        });
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.scrollContent = function() {
    parent.resize("ScanCtrlScroll");
  };
  /**
   * @return {undefined}
   */
  self.showGoodsStore = function() {
    /** @type {boolean} */
    self.isShowGoodsStore = true;
    self.scrollContent();
    if (1 == self.isShowGoodsStore) {
      if (null == self.items) {
        loading.show();
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.showSaleVolume = function() {
    /** @type {boolean} */
    self.isShowGoodsStore = false;
    process({
      goodsSn : err.goodsSn,
      createTimeBegin : $.getOffsetDayBegin((new Date).getTime(), -29),
      createTimeEnd : $.getOffsetDayBegin((new Date).getTime(), 1)
    }).then(function(option) {
      loading.hide();
      data = echarts.init(document.getElementById("saleVolumeChartDiv"), colls.echartsTheme);
      data.setOption(option);
    });
    self.scrollContent();
  };
  /**
   * @param {string} src
   * @return {undefined}
   */
  self.onHoldImage = function(src) {
    if (src && "img/detailpic_no_s.png" != src) {
      var expectedNumberOfNonCommentArgs = {
        buttons : [{
          text : '<i class="icon ion-ios-compose-outline assertive"></i> 保存图片'
        }],
        cancelText : "取消"
      };
      /**
       * @param {number} clicked
       * @return {?}
       */
      expectedNumberOfNonCommentArgs.buttonClicked = function(clicked) {
        return 0 == clicked && self.saveImage(src), true;
      };
      a.show(expectedNumberOfNonCommentArgs);
    }
  };
  $modal.fromTemplateUrl("KEY227.html", function(theTitle) {
    /** @type {number} */
    self.KEY227 = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.KEY227.remove();
    self.skuStoreModal.remove();
    if (data) {
      data.dispose();
    }
  });
  /**
   * @param {?} mixed
   * @return {undefined}
   */
  self.showGoodImage = function(mixed) {
    self.KEY227.show();
    $sanitize(function() {
      self.showImgHandle.slide(mixed, 1);
    }, 50);
  };
  /**
   * @return {?}
   */
  self.changCss = function() {
    if (self.goodImgs) {
      if (1 == self.goodImgs.length) {
        return "absolute-center";
      }
      if (2 == self.goodImgs.length) {
        return "lb-imgScroll-2";
      }
      if (3 == self.goodImgs.length) {
        return "lb-imgScroll-3";
      }
    }
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return result.postEncode("/KEY233", opt_attributes);
  };
  self.search = {
    goodKey : "",
    show : false,
    pageNum : 1
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      if (!result.cancelled) {
        self.$apply(function() {
          self.search.goodKey = result.text;
          self.searchGoods();
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      $.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {undefined}
   */
  self.searchGoods = function() {
    /** @type {number} */
    self.search.pageNum = 1;
    createDom({
      page : self.search.pageNum,
      searchKey : self.search.goodKey
    }).success(function(info) {
      self.KEY288 = info.optionList;
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
      if (1 === self.KEY288.length) {
        result.post("/KEY075?goodsId=" + self.KEY288[0].id).success(function(result) {
          self.goodImgs = result.rows;
          if (0 == self.goodImgs.length) {
            /** @type {Array} */
            self.goodImgs = [{
              url : "img/detailpic_no_s.png"
            }];
            /** @type {number} */
            self.noImages = 1;
          } else {
            /** @type {number} */
            self.noImages = 0;
          }
        });
        /** @type {number} */
        self.state = 1;
        result.post("/KEY063?id=" + self.KEY288[0].id).success(function(req) {
          self.goods = req.goodsVO;
          self.goodsSn = req.goodsVO.goodsSn;
          /** @type {Array} */
          self.goodsInfo.colors = [];
          /** @type {Array} */
          self.goodsInfo.sizes = [];
          /** @type {number} */
          var i = 0;
          var ilen = self.allColors.length;
          for (;ilen > i;i++) {
            if (req.goodsVO.colorIds.indexOf(self.allColors[i].id) > -1) {
              self.goodsInfo.colors.push(self.allColors[i]);
            }
          }
          /** @type {number} */
          i = 0;
          ilen = self.allSizes.length;
          for (;ilen > i;i++) {
            if (req.goodsVO.sizeIds.indexOf(self.allSizes[i].id) > -1) {
              self.goodsInfo.sizes.push(self.allSizes[i]);
            }
          }
          var buf = $.fnCheckGtoreQty(self.arrBland, "id", req.goodsVO.blandId);
          self.goodsInfo.bland = buf ? buf : {};
          var character = $.fnCheckGtoreQty(self.allCategoryList, "id", req.goodsVO.categoryId);
          self.goodsInfo.category = character ? character : {};
          result.postEncode("/KEY092", {
            goodsSn : self.goodsSn
          }).success(function(p) {
            $sanitize(function() {
              /** @type {Array} */
              self.items = [];
              /** @type {number} */
              var l = 0;
              var pl = p.length;
              for (;pl > l;l++) {
                if (p.length > l && (p[l].storehouseId && p[l].storehouseId > 0)) {
                  /** @type {number} */
                  var i = 0;
                  for (;i < self.allStorehouse.length;i++) {
                    if (p[l].storehouseId == self.allStorehouse[i].id) {
                      self.items.push(p[l]);
                    }
                  }
                }
              }
              init();
              self.scrollContent();
            });
          }).finally(function() {
            loading.hide();
          });
        }).finally(function() {
          loading.hide();
        });
        result.post("/KEY097?goodsSn=" + self.KEY288[0].goodsSn).success(function(message) {
          self.goodReport = message.goodSaleReport;
        });
        process({
          goodsSn : self.KEY288[0].goodsSn,
          createTimeBegin : $.getOffsetDayBegin((new Date).getTime(), -29),
          createTimeEnd : $.getOffsetDayBegin((new Date).getTime(), 1)
        }).then(function(option) {
          loading.hide();
          data = echarts.init(document.getElementById("saleVolumeChartDiv"), colls.echartsTheme);
          data.setOption(option);
        });
      } else {
        /** @type {boolean} */
        self.isFromScanToAddGoodsTrend = true;
        self.openSearch();
      }
    }).finally(function() {
      parent.scrollTop("scanGoodListScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.search.pageNum++;
    createDom({
      page : self.search.pageNum,
      searchKey : self.search.goodKey
    }).success(function(info) {
      self.KEY288 = self.KEY288.concat(info.optionList);
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
    }).finally(function() {
      parent.resize("scanGoodListScroll");
    });
  };
  /**
   * @param {?} _xhr
   * @return {undefined}
   */
  self.KEY264 = function(_xhr) {
    /** @type {boolean} */
    self.search.show = false;
    self.viewReplace();
    options.go("eventmenu.KEY225", {
      code : _xhr.id
    });
  };
  /**
   * @return {undefined}
   */
  self.KEY189 = function() {
    options.go("eventmenu.KEY189", {
      goods : {
        goodsName : self.goods.name,
        goodsSn : self.goods.goodsSn,
        colorId : self.goods.colorIds,
        sizeId : self.goods.sizeIds
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.openSearch = function() {
    /** @type {boolean} */
    self.search.show = true;
  };
  /**
   * @return {undefined}
   */
  self.addGood = function() {
    if (self.isFromScanToAddGoodsTrend = true) {
      options.go("eventmenu.KEY291", {
        barCode : self.search.goodKey
      });
      /** @type {boolean} */
      self.isFromScanToAddGoodsTrend = false;
    } else {
      options.go("eventmenu.KEY291");
    }
  };
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    self.storehousePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    self.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideStorehousePopover = function() {
    self.storehousePopover.hide();
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY075.html", function(theTitle) {
    /** @type {number} */
    self.skuStoreModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.skuStoreModal.remove();
    self.storehousePopover.remove();
  });
  /**
   * @param {Object} option
   * @return {undefined}
   */
  self.selectStorehouse = function(option) {
    self.hideStorehousePopover();
    self.storehouse.text = option.text;
    self.storehouse.val = option.val;
    var err = $.fnCheckGtoreQty(self.goodsArr, "storehouseId", self.storehouse.val);
    self.beforeNumber = err ? err.number : 0;
  };
  /**
   * @param {Array} suite
   * @param {number} resolved
   * @return {undefined}
   */
  self.openSkuStoreModal = function(suite, resolved) {
    /** @type {boolean} */
    self.storehouseSelectable = 1 == resolved;
    /** @type {Array} */
    self.goodsArr = [];
    if (suite && suite.length > 0) {
      /** @type {Array} */
      self.goodsArr = suite;
    } else {
      self.goodsArr.push(suite);
    }
    self.goods = self.goodsArr[0];
    if (0 == self.storehouseSelectable) {
      self.storehouse = {
        val : self.goods.storehouseId,
        text : self.goods.storehouseName
      };
      self.beforeNumber = self.goods.number ? self.goods.number : 0;
    } else {
      self.storehouse = {};
    }
    self.skuStoreModal.show();
  };
  /**
   * @return {?}
   */
  self.goodsStore = function() {
    return self.storehouse.val > 0 ? self.goods.storeNumber >= 0 ? (exec(self.storehouse.val, self.order.remark, self.goods, self.beforeNumber, self.goods.storeNumber), void self.skuStoreModal.hide()) : ($.toastShow("盘点数量必须大于等于0"), false) : ($.toastShow("请选择仓库"), false);
  };
  /**
   * @param {?} jumpToNext
   * @param {?} iSearch
   * @param {?} data
   * @param {?} text
   * @param {number} type
   * @return {undefined}
   */
  var exec = function(jumpToNext, iSearch, data, text, type) {
    result.postEncode("/KEY430", {
      storeOrder : angular.toJson({
        storehouseId : jumpToNext,
        orderType : 2,
        status : 1,
        remark : iSearch
      }),
      goods : angular.toJson([{
        goodsSn : data.goodsSn,
        colorId : data.colorId,
        sizeId : data.sizeId,
        number : type,
        beforeNumber : text
      }])
    }).success(function(r) {
      if (1 == r.statusCode) {
        $.toastShow("库存调整成功！");
        /** @type {string} */
        self.order.remark = "";
        result.postEncode("/KEY092", {
          goodsSn : data.goodsSn
        }).success(function(p) {
          /** @type {Array} */
          self.items = [];
          /** @type {number} */
          var l = 0;
          var pl = p.length;
          for (;pl > l;l++) {
            if (p.length > l) {
              if (p[l].storehouseId) {
                if (p[l].storehouseId > 0) {
                  self.items.push(p[l]);
                }
              }
            }
          }
          init();
        });
      } else {
        $.toastShow(r.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.goOtherState = function(dataAndEvents) {
    /** @type {string} */
    var core_rnotwhite = "eventmenu.KEY219";
    switch(dataAndEvents) {
      case 1:
        /** @type {string} */
        core_rnotwhite = "eventmenu.KEY219";
        break;
      case 2:
        /** @type {string} */
        core_rnotwhite = "eventmenu.KEY284";
        break;
      case 3:
        /** @type {string} */
        core_rnotwhite = "eventmenu.KEY257";
        break;
      case 4:
        /** @type {string} */
        core_rnotwhite = "eventmenu.KEY277";
    }
    $templateCache.put("stockSearchRefresh", true);
    options.go(core_rnotwhite, {
      goodsSn : self.goodsSn,
      goodsId : self.goods.id,
      timeStamp : $.getTimeStamp(),
      goods : {
        goodsId : self.goods.id
      }
    });
  };
}]);
