angular.module("partnerController", ["ionic", "services", "tools"]).controller("PartnerMainCtrl", ["$scope", "Tools", "psisServices", "lbScrollDelegate", "Menu", "$ionicPopover", "lbSpinnerDialog", function(scope, dataAndEvents, deepDataAndEvents, ignoreMethodDoesntExist, transclude) {
  scope.menuList = transclude;
  scope.$on("$ionicView.loaded", function() {
  });
  scope.$on("$destroy", function() {
  });
}]).controller("PartnerClientCtrl", ["$scope", "Tools", "psisServices", "lbScrollDelegate", "$state", "$ionicPopover", "lbSpinnerDialog", function($scope, dataAndEvents, newCanvas, parent, $state) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  /** @type {string} */
  $scope.searchKey = "";
  /** @type {string} */
  $scope.focused = "centered";
  /** @type {boolean} */
  $scope.isLoading = true;
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return newCanvas.postEncode("/KEY355", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var setup = function() {
    /** @type {number} */
    page = 1;
    createDom({
      page : page
    }).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("partnerClientListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("partnerClientListCtrlScroll");
    });
  };
  /**
   * @param {Object} client
   * @return {undefined}
   */
  $scope.gotoDetail = function(client) {
    if (1 === client.granted) {
      $state.go("eventmenu.KEY235", {
        clientId : client.clientId,
        clientName : client.clientName
      });
    } else {
      dataAndEvents.toastShow("客户未授权，请联系客户授权");
    }
  };
  /**
   * @return {undefined}
   */
  $scope.gotoBinding = function() {
    $state.go("eventmenu.KEY269", {
      binding : 1
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    setup();
  });
  $scope.$on("$destroy", function() {
  });
}]).controller("PartnerSupplierCtrl", ["$scope", "Tools", "psisServices", "lbScrollDelegate", "$state", "$ionicPopover", "lbSpinnerDialog", function($scope, dataAndEvents, newCanvas, parent, $state) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  /** @type {string} */
  $scope.searchKey = "";
  /** @type {string} */
  $scope.focused = "centered";
  /** @type {boolean} */
  $scope.isLoading = true;
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return newCanvas.postEncode("/KEY327", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var setup = function() {
    /** @type {number} */
    page = 1;
    createDom({
      page : page
    }).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("partnerClientListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("partnerClientListCtrlScroll");
    });
  };
  /**
   * @param {Array} recurring
   * @return {undefined}
   */
  $scope.gotoDetail = function(recurring) {
    if (recurring.supplierId) {
      $state.go("eventmenu.KEY044", {
        supplierId : recurring.supplierId,
        supplierName : recurring.supplierName
      });
    } else {
      dataAndEvents.toastShow("请先绑定供应商");
    }
  };
  /**
   * @return {undefined}
   */
  $scope.gotoBinding = function() {
    $state.go("eventmenu.KEY209", {
      binding : 1
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    setup();
  });
  $scope.$on("$destroy", function() {
  });
}]).controller("BindingPartnerClientCtrl", ["$scope", "Tools", "psisServices", "lbScrollDelegate", "$state", "$ionicPopover", "lbSpinnerDialog", function(self, dataAndEvents, newCanvas, parent, $state) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  self.clients = [];
  /** @type {string} */
  self.searchKey = "";
  /** @type {string} */
  self.focused = "centered";
  /** @type {number} */
  var showDisable = 0;
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var moveTo = function(opt_attributes) {
    return newCanvas.postEncode("/KEY040", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var loaded = function() {
    /** @type {number} */
    page = 1;
    moveTo({
      page : page,
      searchKey : self.searchKey,
      showDisable : showDisable
    }).success(function(info) {
      self.clients = info.optionList;
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
    }).finally(function() {
      parent.scrollTop("selectClientCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    moveTo({
      page : ++page,
      searchKey : self.searchKey,
      showDisable : showDisable
    }).success(function(info) {
      self.clients = self.clients.concat(info.optionList);
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
    }).finally(function() {
      parent.resize("selectClientCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.searchClient = function() {
    loaded();
  };
  var throttledUpdate = ionic.debounce(self.searchClient, 500);
  /**
   * @return {undefined}
   */
  self.searchClientByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  self.focusSearchInput = function() {
    document.getElementById("searchClientInput").focus();
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.searchKey = "";
    /** @type {string} */
    self.focused = "centered";
    self.searchClient();
  };
  /**
   * @return {undefined}
   */
  self.KEY216 = function() {
  };
  /**
   * @return {undefined}
   */
  self.addClient = function() {
    var params = {};
    if (self.searchKey) {
      if ("" != self.searchKey) {
        params = {
          name : self.searchKey
        };
      }
    }
    $state.go("eventmenu.KEY268", params);
  };
  self.$on("$ionicView.loaded", function() {
    loaded();
  });
}]).controller("ClientStoreCtrl", ["$scope", "Tools", "psisServices", "lbScrollDelegate", "$stateParams", "$state", "$ionicModal", "$ionicPopover", "lbSpinnerDialog", function(self, dataAndEvents, assert, parent, message, $state, $modal, deepDataAndEvents, poster) {
  /** @type {Array} */
  self.items = [];
  /** @type {Array} */
  self.sumData = [];
  /** @type {string} */
  self.focused = "centered";
  /** @type {boolean} */
  self.isLoading = true;
  self.viewTitle = message.clientName;
  self.queryCondition = {
    page : 1,
    sidx : "",
    sord : "",
    clientId : message.clientId
  };
  self.filterObj = {};
  $modal.fromTemplateUrl("listFilter.html", function(theTitle) {
    self.listFilterModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {?}
   */
  var Step = function() {
    return assert.postEncode("/KEY356", self.queryCondition);
  };
  /**
   * @return {undefined}
   */
  self.getListSum = function() {
    assert.post("/admin/inner/clientChain/getClientGoodsStoredSumData.ac?clientId=" + self.queryCondition.clientId).success(function(res) {
      if (1 == res.statusCode) {
        if (res.object) {
          self.sumData = res.object;
        }
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    self.queryCondition.minNumber = self.filterObj.minNumber || 0 === self.filterObj.minNumber ? self.filterObj.minNumber : "";
    self.queryCondition.maxNumber = self.filterObj.maxNumber || 0 === self.filterObj.maxNumber ? self.filterObj.maxNumber : "";
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      poster.hide();
      parent.scrollTop("partnerClientStoreCtrlScroll");
    });
    self.getListSum();
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("partnerClientStoreCtrlScroll");
    });
  };
  var throttledUpdate = ionic.debounce(self.getList, 500);
  /**
   * @return {undefined}
   */
  self.getGoodsByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @param {string} id
   * @return {undefined}
   */
  self.getSortList = function(id) {
    /** @type {string} */
    self.queryCondition.sord = "" == id ? "" : self.queryCondition.sidx == id && "desc" == self.queryCondition.sord ? "asc" : "desc";
    /** @type {string} */
    self.queryCondition.sidx = id;
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.searchObj.searchKey = "";
    /** @type {string} */
    self.focused = "centered";
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.clearFilter = function() {
    /** @type {string} */
    self.filterObj.minNumber = "";
    /** @type {string} */
    self.filterObj.maxNumber = "";
  };
  /**
   * @return {undefined}
   */
  self.filterAction = function() {
    self.listFilterModal.hide();
    self.getList();
  };
  /**
   * @param {Array} recurring
   * @return {undefined}
   */
  self.gotoDetail = function(recurring) {
    $state.go("eventmenu.KEY123", {
      clientId : self.queryCondition.clientId,
      goodsId : recurring
    });
  };
  self.$on("$ionicView.loaded", function() {
    if (self.queryCondition.clientId && "" != self.queryCondition.clientId) {
      self.getList();
    } else {
      dataAndEvents.toastShow("不存在相关合作客户");
    }
  });
  self.$on("$destroy", function() {
    self.listFilterModal.remove();
  });
}]).controller("ClientStoreDetailCtrl", ["$scope", "Tools", "psisServices", "lbScrollDelegate", "$stateParams", "$state", "$ionicPopover", "lbSpinnerDialog", function($scope, model, $cookieStore, parent, message) {
  /** @type {boolean} */
  $scope.isLoading = true;
  /** @type {Array} */
  $scope.item = [];
  $scope.queryCondition = {
    clientId : message.clientId,
    goodsId : message.goodsId
  };
  /**
   * @return {?}
   */
  var callback = function() {
    return $cookieStore.postEncode("/KEY334", $scope.queryCondition);
  };
  /**
   * @return {undefined}
   */
  var setup = function() {
    /** @type {number} */
    $scope.queryCondition.page = 1;
    callback().success(function(data) {
      if (1 == data.statusCode) {
        $scope.items = data.object;
        /** @type {boolean} */
        $scope.loadMoreBtn = data.page < data.total;
      } else {
        model.toastShow(data.content);
      }
    }).finally(function() {
      parent.scrollTop("clientStoreDetailCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    callback().success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("clientStoreDetailCtrlScroll");
    });
  };
  /**
   * @param {string} settings
   * @return {?}
   */
  $scope.parseToInt = function(settings) {
    return settings.number ? parseInt(settings.number) : 0;
  };
  $scope.$on("$ionicView.loaded", function() {
    setup();
  });
}]).controller("PartnerSupplierDetailCtrl", ["$scope", "Tools", "psisServices", "lbScrollDelegate", "$stateParams", "$ionicPopover", "lbSpinnerDialog", "ServerType", "ServerConfig", function($scope, model, options, parent, data, deepDataAndEvents, loading, dataAndEvents, context) {
  $scope.viewTitle = data.supplierName;
  /** @type {number} */
  var page = 1;
  /**
   * @param {string} inverse
   * @return {?}
   */
  var filter = function(inverse) {
    return options.postEncode("/KEY472?supplierId=" + inverse);
  };
  /**
   * @param {?} name
   * @return {?}
   */
  var Step = function(name) {
    var attributes = {
      page : page,
      supplierId : name,
      sidx : "businessTime",
      sord : "desc"
    };
    return options.postEncode("/KEY135", attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    /** @type {number} */
    page = 1;
    loading.show();
    Step(data.supplierId).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.scrollTop("PartnerSupplierDetailCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    page++;
    loading.show();
    Step(data.supplierId).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.resize("PartnerSupplierDetailCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.refreshColorAndSize = function() {
    options.httpCacheGet.remove(options.httpCacheGet.ac.ALLSIZELIST);
    options.httpCacheGet.remove(options.httpCacheGet.ac.ALLCOLORLIST);
  };
  $scope.$on("$ionicView.loaded", function() {
    loading.show();
    filter(data.supplierId).success(function(res) {
      if (1 == res.statusCode) {
        $scope.supplierChain = res.object ? res.object : {};
        var path = context.tmsServer.replace(/cid/, $scope.supplierChain.supplierCid);
        if (dataAndEvents.isEX()) {
          path = path.replace(/www/, "ex");
        } else {
          if (context.currentServer.indexOf("dev") >= 0) {
            path = path.replace(/www/, "dev");
          }
        }
        $scope.shopAdress = path;
      } else {
        model.toastShow(res.content);
      }
    }).finally(function() {
      loading.hide();
    });
    $scope.getList();
  });
  $scope.$on("$destroy", function() {
  });
}]);
