angular.module("passengerVolumeCtrl", ["ionic", "services", "tools"]).controller("PVMainCtrl", ["$scope", "ServerConfig", "wechatShare", "psisServices", "lbSpinnerDialog", "$ionicPopover", "$state", "$filter", "$q", "ReportConstant", "$ionicScrollDelegate", "lruPersistCache", function(me, deepDataAndEvents, ignoreMethodDoesntExist, $http, loading, FB, $state, textAlt, $q, colls, dataAndEvents, $templateCache) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = $http.postEncode("/KEY312");
    return $q.all([request1]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  me.searchModel = {
    type : "today"
  };
  /** @type {number} */
  me.todayPassengerCount = 0;
  /** @type {number} */
  me.todayPassengerUnitPrice = 0;
  /** @type {number} */
  me.last7DaysPassengerUnitPrice = 0;
  /** @type {number} */
  me.last7DaysPassengerCount = 0;
  var obj;
  var instance;
  /** @type {Array} */
  var k = ["#FF9500", "#E4E4E4", "#4f6794"];
  /**
   * @return {undefined}
   */
  me.gotoList = function() {
    $state.go("eventmenu.KEY301");
  };
  /**
   * @return {undefined}
   */
  me.goToAddPV = function() {
    $state.go("eventmenu.KEY300");
  };
  /**
   * @return {undefined}
   */
  me.gotoRecord = function() {
    $state.go("eventmenu.KEY283", {
      imei : me.selectedShop.imei,
      shopName : me.selectedShop.shopName
    });
  };
  FB.fromTemplateUrl("shopsPopover.html", {
    scope : me
  }).then(function(e) {
    /** @type {number} */
    me.shopsPopover = e;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  me.openShopsPopover = function(expectedNumberOfNonCommentArgs) {
    me.shopsPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {Object} e
   * @param {?} event
   * @return {undefined}
   */
  me.hideShopsPopover = function(e, event) {
    /** @type {Object} */
    me.selectedShop = e;
    me.getTotalCountData(me.selectedShop.id);
    update("hour");
    run("week");
    me.shopsPopover.hide(event);
  };
  FB.fromTemplateUrl("tipsPopover.html", {
    scope : me
  }).then(function(e) {
    /** @type {number} */
    me.tipsPopover = e;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  me.openTipsPopover = function(expectedNumberOfNonCommentArgs) {
    me.tipsPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {?} values
   * @param {string} event
   * @param {string} name
   * @param {string} color
   * @return {?}
   */
  var next = function(values, event, name, color) {
    /** @type {Array} */
    var events = [];
    /** @type {number} */
    var id = 0;
    var valuesLen = values.length;
    for (;valuesLen > id;id++) {
      events.push(values[id][name]);
    }
    return{
      name : event,
      type : "line",
      data : events,
      itemStyle : {
        normal : {
          label : {
            show : true
          },
          areaStyle : {
            type : "default"
          },
          color : color
        }
      }
    };
  };
  /**
   * @param {string} key
   * @return {?}
   */
  var fn = function(key) {
    var imageDfd = $q.defer();
    return $http.post("/admin/inner/passengercounter/passengerCountByHour.ac?counterId=" + key).success(function(initial) {
      /** @type {string} */
      var res = initial;
      /** @type {Array} */
      var products = [];
      /** @type {Array} */
      var series = [];
      /** @type {Array} */
      var dataArray = ["今日", "上周同比"];
      if (1 == res.statusCode) {
        if (res.object) {
          /** @type {number} */
          var b = 0;
          for (;23 >= b;b++) {
            products.push(23 == b ? "23:59" : b + ":00");
          }
          series.push(next(res.object.today, dataArray[0], "passengerSumCnt", k[0]));
          series.push(next(res.object.lastWeek, dataArray[1], "passengerSumCnt", k[1]));
          var graph_options = {
            tooltip : {
              trigger : "axis"
            },
            legend : {
              data : dataArray
            },
            toolbox : {
              show : false
            },
            xAxis : [{
              name : "时间",
              type : "category",
              axisLabel : {
                interval : 0
              },
              data : products
            }],
            yAxis : [{
              name : "人次",
              type : "value",
              boundaryGap : [0, 0.1],
              axisLabel : {
                formatter : "{value}"
              }
            }],
            series : series
          };
          imageDfd.resolve(graph_options);
        }
      } else {
        imageDfd.reject();
      }
    }).error(function() {
      imageDfd.reject();
    }), imageDfd.promise;
  };
  /**
   * @param {string} id
   * @param {string} selector
   * @return {?}
   */
  var init = function(id, selector) {
    var imageDfd = $q.defer();
    return $http.post("/admin/inner/passengercounter/passengerCountFromLastWeekByDay.ac?counterId=" + id).success(function(initial) {
      /** @type {string} */
      var res = initial;
      /** @type {Array} */
      var series = [];
      if (1 == res.statusCode) {
        if (res.object) {
          /** @type {string} */
          var errorName = "人次";
          if ("week" == selector) {
            /** @type {Array} */
            var dataArray = ["本周", "上周"];
            /** @type {Array} */
            var task = ["周一", "周二", "周三", "周四", "周五", "周六", "周日"];
            series.push(next(res.object.thisWeek, dataArray[0], "passengerSumCnt", k[0]));
            series.push(next(res.object.lastWeek, dataArray[1], "passengerSumCnt", k[1]));
          } else {
            if ("unitPrice" == selector) {
              /** @type {Array} */
              dataArray = ["本周", "上周"];
              /** @type {Array} */
              task = ["周一", "周二", "周三", "周四", "周五", "周六", "周日"];
              series.push(next(res.object.thisWeek, dataArray[0], "guestUnitPrice", k[0]));
              series.push(next(res.object.lastWeek, dataArray[1], "guestUnitPrice", k[1]));
              /** @type {string} */
              errorName = "单价";
            } else {
              if ("transferRate" != selector) {
                return imageDfd.reject(), imageDfd.promise;
              }
              /** @type {Array} */
              dataArray = ["本周", "上周"];
              /** @type {Array} */
              task = ["周一", "周二", "周三", "周四", "周五", "周六", "周日"];
              series.push(next(res.object.thisWeek, dataArray[0], "passengerTransferRate", k[0]));
              series.push(next(res.object.lastWeek, dataArray[1], "passengerTransferRate", k[1]));
              /** @type {string} */
              errorName = "转化率";
            }
          }
          var graph_options = {
            tooltip : {
              trigger : "axis"
            },
            legend : {
              data : dataArray
            },
            toolbox : {
              show : false
            },
            xAxis : [{
              name : "时间",
              type : "category",
              axisLabel : {
                interval : 0
              },
              data : task
            }],
            yAxis : [{
              name : errorName,
              type : "value",
              boundaryGap : [0, 0.1],
              axisLabel : {
                formatter : "{value}"
              }
            }],
            series : series
          };
          imageDfd.resolve(graph_options);
        }
      } else {
        imageDfd.reject();
      }
    }).error(function() {
      imageDfd.reject();
    }), imageDfd.promise;
  };
  /**
   * @param {string} selector
   * @return {?}
   */
  var remove = function(selector) {
    return "hour" == selector ? fn(me.selectedShop.id) : init(me.selectedShop.id, selector);
  };
  /**
   * @param {?} keep
   * @return {undefined}
   */
  me.getTotalCountData = function(keep) {
    if (keep) {
      /** @type {string} */
      me.todayPassengerCount = "...";
      /** @type {string} */
      me.todayPassengerUnitPrice = "...";
      /** @type {string} */
      me.last7DaysPassengerUnitPrice = "...";
      /** @type {string} */
      me.last7DaysPassengerCount = "...";
      $http.post("/admin/inner/passengercounter/getPassengerFlowInfo.ac?counterId=" + keep).success(function(res) {
        if (1 == res.statusCode) {
          me.todayPassengerCount = res.object.todayPassengerCount;
          me.todayPassengerUnitPrice = res.object.todayPassengerUnitPrice;
          me.last7DaysPassengerUnitPrice = res.object.last7DaysPassengerUnitPrice;
          me.last7DaysPassengerCount = res.object.last7DaysPassengerCount;
        }
      });
    }
  };
  /**
   * @return {undefined}
   */
  me.getChart = function() {
    if ("today" == me.searchModel.type) {
      update("hour");
    } else {
      run(me.searchModel.type);
    }
  };
  /**
   * @param {string} val
   * @return {undefined}
   */
  var update = function(val) {
    loading.show();
    remove(val).then(function(option) {
      loading.hide();
      obj = echarts.init(document.getElementById("dailyVolumeChartDiv"), colls.echartsTheme);
      obj.setOption(option);
      dataAndEvents.$getByHandle("dailyVolumeChartDivScroll").scrollTo(320, 0, true);
    }, function() {
      loading.hide();
      console.error("获取报表数据出现异常！");
    });
  };
  /**
   * @param {string} key
   * @return {undefined}
   */
  var run = function(key) {
    loading.show();
    remove(key).then(function(option) {
      loading.hide();
      instance = echarts.init(document.getElementById("weekVolumeChartDiv"), colls.echartsTheme);
      instance.setOption(option);
    }, function() {
      loading.hide();
      console.error("获取报表数据出现异常！");
    });
  };
  me.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      me.shopItems = packs[0].data;
      if (me.shopItems && me.shopItems.length > 0) {
        me.selectedShop = me.shopItems[0];
        me.getTotalCountData(me.selectedShop.id);
        me.getChart();
      } else {
        me.selectedShop = void 0;
      }
    });
  });
  me.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshPVMain")) {
      fetch().then(function(packs) {
        me.shopItems = packs[0].data;
        if (me.shopItems && me.shopItems.length > 0) {
          me.selectedShop = me.shopItems[0];
          me.getTotalCountData(me.selectedShop.id);
          me.getChart();
        } else {
          me.selectedShop = void 0;
        }
      });
      $templateCache.put("refreshPVMain", false);
    }
  });
  me.$on("$destroy", function() {
    me.shopsPopover.remove();
    me.tipsPopover.remove();
    if (obj) {
      obj.dispose();
    }
    if (instance) {
      instance.dispose();
    }
  });
}]).controller("PVListCtrl", ["$scope", "ServerConfig", "wechatShare", "psisServices", "lbSpinnerDialog", "$ionicPopup", "$state", "lbScrollDelegate", "lruPersistCache", function($scope, dataAndEvents, deepDataAndEvents, newCanvas, ignoreMethodDoesntExist, textAlt, $state, parent, $templateCache) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  /** @type {boolean} */
  $scope.isLoading = true;
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return newCanvas.postEncode("/KEY312", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.goToAddPV = function() {
    $state.go("eventmenu.KEY300");
  };
  /**
   * @param {(number|string)} x
   * @return {undefined}
   */
  $scope.goToPVInfo = function(x) {
    $state.go("eventmenu.KEY300", {
      item : x
    });
  };
  /**
   * @return {undefined}
   */
  var setup = function() {
    /** @type {number} */
    page = 1;
    createDom({
      page : page
    }).success(function(data) {
      /** @type {Object} */
      $scope.items = data;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("pvItemListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("pvItemListCtrlScroll");
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshPVItemList")) {
      setup();
      $templateCache.put("refreshPVItemList", false);
    }
  });
  setup();
}]).controller("PVEditCtrl", ["$scope", "ServerConfig", "wechatShare", "psisServices", "lbSpinnerDialog", "$ionicPopup", "$state", "$stateParams", "Tools", "$q", "lruPersistCache", "$cordovaBarcodeScanner", "$timeout", function(self, dataAndEvents, deepDataAndEvents, result, loading, _, ignoreMethodDoesntExist, ev, Y, $q, $templateCache, Hogan, $sanitize) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = result.httpCacheGet.get(result.httpCacheGet.ac.KEY177);
    return $q.all([request1]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /** @type {number} */
  self.state = 0;
  var item = ev.item;
  if (item) {
    /** @type {Array} */
    var headerRowsInt = [];
    if (item.storehouseIds) {
      var strings = item.storehouseIds.split(",");
      /** @type {number} */
      var i = 0;
      var l = strings.length;
      for (;l > i;i++) {
        headerRowsInt.push(parseInt(strings[i]));
      }
    }
    self.pv = {
      id : item.id,
      storehouseIds : headerRowsInt,
      shopName : item.shopName,
      imei : item.imei
    };
    /** @type {number} */
    self.state = 1;
    /** @type {string} */
    self.viewTitle = "编辑设备";
  } else {
    self.pv = {
      storehouseIds : []
    };
    /** @type {string} */
    self.viewTitle = "新增设备";
  }
  /**
   * @param {Element} evt
   * @return {undefined}
   */
  self.selectStoreHouse = function(evt) {
    var fromIndex = self.pv.storehouseIds.indexOf(evt.id);
    if (fromIndex > -1) {
      self.pv.storehouseIds.splice(fromIndex, 1);
    } else {
      self.pv.storehouseIds.push(evt.id);
    }
  };
  /**
   * @return {?}
   */
  self.savePV = function() {
    return self.pv.shopName ? self.pv.imei ? self.pv.storehouseIds.length < 1 ? (Y.toastShow("请选择关联的仓库", "short", "center"), void console.log("请选择关联的仓库")) : (loading.show(), void result.postEncode("/KEY306", {
      passengerCounter : angular.toJson(self.pv)
    }).success(function(config) {
      if (1 == config.statusCode) {
        Y.union(self.pv, config.object);
        /** @type {number} */
        self.state = 1;
        /** @type {string} */
        self.viewTitle = "编辑设备";
        $templateCache.put("refreshPVItemList", true);
        $templateCache.put("refreshPVMain", true);
        Y.toastShow("保存成功");
      } else {
        Y.toastShow("保存失败");
      }
    }).finally(function() {
      loading.hide();
    })) : (Y.toastShow("请填写设备号", "short", "center"), void console.log("请填写设备号")) : (Y.toastShow("请填写店铺名称", "short", "center"), void console.log("请填写店铺名称"));
  };
  /**
   * @return {undefined}
   */
  self.deletePV = function() {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除该此客流设备?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        result.post("/admin/inner/passengercounter/passengerCounterDelete.ac?counterId=" + self.pv.id).success(function(r) {
          if (1 == r.statusCode) {
            _.alert({
              template : "<div class='tc'>删除成功</div>",
              okText : "确定"
            }).then(function() {
              $templateCache.put("refreshPVItemList", true);
              $templateCache.put("refreshPVMain", true);
              self.goBack();
            });
          } else {
            _.alert({
              template : "<div class='tc'>删除失败，不能删除已被使用的设备！</div>",
              okText : "确定"
            });
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  self.scanCode = function(event) {
    if (event) {
      if (event.preventDefault()) {
        event.stopPropagation();
      }
    }
    Hogan.scan().then(function(result) {
      if (!result.cancelled) {
        $sanitize(function() {
          self.pv.imei = result.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      Y.toastShow("二维码扫描失败！");
    });
  };
  self.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      /** @type {Array} */
      self.allDept = [];
      /** @type {number} */
      var dataIndex = 0;
      for (;dataIndex < packs[0].data.length;dataIndex++) {
        if ("1" == packs[0].data[dataIndex].status) {
          self.allDept.push(packs[0].data[dataIndex]);
        }
      }
    });
  });
}]).controller("PVRecordCtrl", ["$scope", "ServerConfig", "psisServices", "lbSpinnerDialog", "$stateParams", "$state", "lbScrollDelegate", "$cordovaDatePicker", "$http", "$filter", function(self, dataAndEvents, deepDataAndEvents, ignoreMethodDoesntExist, first, textAlt, parent, $scope, $templateCache, $filter) {
  /** @type {boolean} */
  self.isLoading = true;
  var i = first.shopName;
  var pos = first.imei;
  self.viewTitle = i;
  self.recordCondition = {
    page : 1,
    startTime : (new Date).getTime(),
    endTime : (new Date).getTime(),
    imei : pos
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.setCreateTimeBegin = function(dataAndEvents) {
    $scope.show({
      date : new Date(self.recordCondition.startTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.recordCondition.startTime = date1.getTime();
        if (dataAndEvents) {
          self.getList();
        }
      }
    });
  };
  /**
   * @param {Object} data
   * @return {?}
   */
  var init = function(data) {
    /** @type {Date} */
    var midnight = new Date(data.startTime);
    midnight.setHours(0, 0, 0, 0);
    /** @type {number} */
    data.startTime = midnight.getTime();
    /** @type {Date} */
    var nd = new Date(data.startTime);
    return nd.setHours(23, 59, 59), data.endTime = nd.getTime(), $templateCache.get(dataAndEvents.currentServer + "/passengerstatistics/getPassengerStatisticsDataByMi.ac?imei=" + data.imei + "&startTime=" + $filter("date")(data.startTime, "yyyy-MM-ddTHH:mm:ss.sssZ") + "&endTime=" + $filter("date")(data.endTime, "yyyy-MM-ddTHH:mm:ss.sssZ") + "&page=" + data.page);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.recordCondition.page = 1;
    init(self.recordCondition).success(function(children) {
      if (null == children || 0 == children.length) {
        /** @type {boolean} */
        self.loadMoreBtn = false;
      } else {
        /** @type {string} */
        self.items = children;
        /** @type {boolean} */
        self.loadMoreBtn = true;
      }
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      parent.scrollTop("pvRecordListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.recordCondition.page++;
    init(self.recordCondition).success(function(items) {
      if (null == items || 0 == items.length) {
        /** @type {boolean} */
        self.loadMoreBtn = false;
      } else {
        self.items = self.items.concat(items);
        /** @type {boolean} */
        self.loadMoreBtn = true;
      }
    }).finally(function() {
      parent.resize("pvRecordListCtrlScroll");
    });
  };
  self.$on("$ionicView.loaded", function() {
    self.getList();
  });
}]);
