angular.module("purchaseController", ["ionic", "services", "tools"]).controller("PurchaseListCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "$ionicModal", "Tools", "$cordovaDatePicker", "lruPersistCache", "lbSpinnerDialog", "BTScanerService", function(self, $state, goog, parent, $modal, test, $scope, $templateCache, loading, $document) {
  var character;
  var chr;
  if (self.commonConfig) {
    var n = self.commonConfig.orderListDays;
    if (n) {
      character = (new Date).setDate((new Date).getDate() - n);
      /** @type {number} */
      chr = (new Date).getTime();
    }
  }
  self.listQuerySupplier = {};
  self.listQuerySupplier.createTimeBegin = character ? character : "";
  /** @type {(number|string)} */
  self.listQuerySupplier.createTimeEnd = chr ? chr : "";
  /** @type {number} */
  self._itemType = 0;
  if ($state.includes("eventmenu.KEY220")) {
    /** @type {number} */
    self._itemType = 1;
    self.viewTitle = self.NameConstant.KEY220;
  } else {
    if ($state.includes("eventmenu.KEY107")) {
      /** @type {number} */
      self._itemType = 2;
      self.viewTitle = self.NameConstant.KEY107;
    }
  }
  /** @type {boolean} */
  self.isLoading = true;
  self.queryCondition = {
    page : 1,
    itemType : self._itemType,
    state : 12
  };
  self.isUserAccAvailable = self.GetOperatorEventLimit("KEY168");
  /**
   * @return {?}
   */
  var Step = function() {
    /** @type {string} */
    var tokens = "";
    switch(self._itemType) {
      case 1:
        /** @type {string} */
        tokens = "/KEY123";
        break;
      case 2:
        /** @type {string} */
        tokens = "/KEY124";
    }
    return goog.postEncode(tokens, self.queryCondition);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    if (self.listQuerySupplier.createTimeBegin) {
      self.queryCondition.createTimeBegin = test.transferGMTStringtoBJTime(test.getDayBeginStr(self.listQuerySupplier.createTimeBegin));
    } else {
      delete self.queryCondition.createTimeBegin;
    }
    if (self.listQuerySupplier.createTimeEnd) {
      self.queryCondition.createTimeEnd = test.transferGMTStringtoBJTime(test.getOffsetDayBeginStr(self.listQuerySupplier.createTimeEnd, 1));
    } else {
      delete self.queryCondition.createTimeEnd;
    }
    if (0 == self.queryCondition.state) {
      delete self.queryCondition.state;
    }
    loading.show();
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("purchaseListCtrlScroll");
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("purchaseListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.createNewOrder = function() {
    if (1 === self._itemType) {
      $state.go("eventmenu.KEY219", {
        goodsSn : null,
        purchaseSn : null,
        timeStamp : test.getTimeStamp()
      });
    } else {
      if (2 === self._itemType) {
        $state.go("eventmenu.KEY106", {
          goodsSn : null,
          purchaseSn : null,
          timeStamp : test.getTimeStamp()
        });
      }
    }
  };
  /**
   * @param {?} dataAndEvents
   * @param {(number|string)} deepDataAndEvents
   * @return {undefined}
   */
  self.goPurchase = function(dataAndEvents, deepDataAndEvents) {
    var logoutState;
    if (1 === deepDataAndEvents) {
      switch(self._itemType) {
        case 1:
          /** @type {string} */
          logoutState = "eventmenu.KEY219";
          break;
        case 2:
          /** @type {string} */
          logoutState = "eventmenu.KEY106";
      }
    } else {
      switch(self._itemType) {
        case 1:
          /** @type {string} */
          logoutState = "eventmenu.KEY188";
          break;
        case 2:
          /** @type {string} */
          logoutState = "eventmenu.KEY063";
      }
    }
    $state.go(logoutState, {
      purchaseSn : dataAndEvents
    });
  };
  /**
   * @param {?} object
   * @return {?}
   */
  self.getTotalAmount = function(object) {
    var length = object.trueTotalAmount;
    return object.otherCost && (length = test.accAdd(length, object.otherCost)), object.wipeZero && (length = test.accSub(length, object.wipeZero)), length;
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeBegin = function() {
    $scope.show({
      date : self.listQuerySupplier.createTimeBegin ? new Date(self.listQuerySupplier.createTimeBegin) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.listQuerySupplier.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeEnd = function() {
    $scope.show({
      date : self.listQuerySupplier.createTimeEnd ? new Date(self.listQuerySupplier.createTimeEnd) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.listQuerySupplier.createTimeEnd = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    /** @type {null} */
    self.listQuerySupplier.createTimeBegin = null;
    /** @type {null} */
    self.listQuerySupplier.createTimeEnd = null;
    /** @type {string} */
    self.listQuerySupplier.text = "";
    delete self.queryCondition.supplierId;
    delete self.queryCondition.purchaseSn;
  };
  $modal.fromTemplateUrl("purchaseListQuery.html", function(theTitle) {
    /** @type {number} */
    self.purchaseListQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PPurchaseBuyBill/KEY184.html", function(theTitle) {
    self.supplierModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  /**
   * @return {undefined}
   */
  self.supplierModalOpen = function() {
    self.supplierModal.show().then(function() {
      test.keyboardShow();
    });
  };
  self.$on("$destroy", function() {
    self.purchaseListQueryModal.remove();
    self.supplierModal.remove();
  });
  self.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("purchaseListRefresh")) {
      if ($templateCache.get("purchaseListRefresh") === true) {
        self.getList();
        $templateCache.put("purchaseListRefresh", false);
      }
    }
    $document.getScanerCode(function(fmt) {
      console.log(fmt);
    }, self.bluethoothScaner);
  });
  self.$on("$ionicView.loaded", function() {
    self.getList();
  });
}]).controller("PurchaseDetailCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "$state", "wechatShare", "lbSpinnerDialog", "$ionicPopover", "$ionicPopup", "lruPersistCache", "OrderType", "BluetoothPrintService", "BTScanerService", "$ionicModal", function(self, element, $http, $, $state, jQuery, loading, FB, _, $templateCache, tmp, UnitBluetoothPrint, $document, $modal) {
  var className = element.purchaseSn;
  self.isUserAccAvailable = self.GetOperatorEventLimit("KEY168");
  /** @type {number} */
  self._itemType = 0;
  if ($state.includes("eventmenu.KEY188")) {
    /** @type {number} */
    self._itemType = 1;
    self.viewTitle = self.NameConstant.KEY329;
    self.isPrintAvailable = self.GetOperatorEventLimit("KEY099");
  } else {
    if ($state.includes("eventmenu.KEY063")) {
      /** @type {number} */
      self._itemType = 2;
      self.viewTitle = self.NameConstant.KEY330;
      self.isPrintAvailable = self.GetOperatorEventLimit("KEY040");
    }
  }
  self.destroyAccAvailable = 1 == self._itemType && self.GetOperatorEventLimit("KEY082") || 2 == self._itemType && self.GetOperatorEventLimit("KEY021");
  self.tranToAccAvailable = 1 == self._itemType && self.GetOperatorEventLimit("KEY087");
  FB.fromTemplateUrl("copyOperation.html", {
    scope : self
  }).then(function(theTitle) {
    self.copyOperationPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openCopyOperationPopover = function(expectedNumberOfNonCommentArgs) {
    self.copyOperationPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.copyForOrder = function(dataAndEvents) {
    /** @type {string} */
    var logoutState = "eventmenu.KEY219";
    switch(self.viewReplace(), dataAndEvents) {
      case 0:
        /** @type {string} */
        logoutState = "eventmenu.KEY106";
        break;
      case 1:
        /** @type {string} */
        logoutState = "eventmenu.KEY219";
    }
    self.copyOrder = {
      order : self.orderDetail.order,
      goodsGroup : self.goodsGroup
    };
    $state.go(logoutState, {
      ordersSn : null,
      timeStamp : $.getTimeStamp(),
      copyOrder : self.copyOrder
    });
  };
  /**
   * @return {undefined}
   */
  self.share = function() {
    switch(self._itemType) {
      case 1:
        jQuery.shareSnUrl(className, tmp.KEY329);
        break;
      case 2:
        jQuery.shareSnUrl(className, tmp.KEY330);
    }
  };
  /**
   * @return {undefined}
   */
  self.destroyOrder = function() {
    /** @type {string} */
    var server = "";
    switch(self._itemType) {
      case 1:
        /** @type {string} */
        server = "/KEY131?purchaseSn=";
        break;
      case 2:
        /** @type {string} */
        server = "/KEY132?purchaseSn=";
    }
    var promise = _.confirm({
      template : "<div class='tc'>单据撤销将撤销相应的库存、账务，且撤销后不可恢复，是否确认撤销该单据？</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show(true);
        $http.post(server + className).success(function(r) {
          if (1 === r.statusCode) {
            /** @type {boolean} */
            self.isDestroy = true;
            $.toastShow("撤销成功！");
          } else {
            $.toastShow(r.content);
          }
        }).finally(function() {
          loading.hide();
          $templateCache.put("purchaseListRefresh", true);
          $templateCache.put("refreshSupplierRecord", true);
          $templateCache.put("supplierDebtListRefresh", true);
          $templateCache.put("goodsStoredRecordListRefresh", true);
          $templateCache.put("accountFinanceRecordRefresh", true);
        });
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.bluetoothPrint = function() {
    UnitBluetoothPrint.print(self.mainCompany.comName, className, 1 === self._itemType ? UnitBluetoothPrint.orderType.KEY329 : UnitBluetoothPrint.orderType.KEY330);
  };
  /**
   * @return {undefined}
   */
  self.bluetooth = function() {
    switch(self._itemType) {
      case 1:
        UnitBluetoothPrint.bluetooth(className, UnitBluetoothPrint.orderType.KEY329);
        break;
      case 2:
        UnitBluetoothPrint.bluetooth(className, UnitBluetoothPrint.orderType.KEY330);
    }
  };
  /**
   * @return {undefined}
   */
  self.gotoBarCodePrint = function() {
    $state.go("eventmenu.KEY218", {
      ordersSn : className
    });
  };
  /**
   * @return {undefined}
   */
  self.openGoodImgModal = function() {
    if (self.KEY227) {
      self.KEY227.show();
    } else {
      $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY227.html", function(theTitle) {
        self.KEY227 = theTitle;
        self.KEY227.show();
      }, {
        scope : self,
        animation : "slide-in-up"
      });
    }
  };
  /**
   * @param {?} dataAndEvents
   * @param {?} event
   * @return {undefined}
   */
  self.showGoodImage = function(dataAndEvents, event) {
    if (event) {
      event.stopPropagation();
    }
    if (dataAndEvents.goodsId) {
      loading.show();
      $http.post("/KEY075?goodsId=" + dataAndEvents.goodsId).success(function(result) {
        self.goodImgs = result.rows;
        if (self.goodImgs.length > 0) {
          self.openGoodImgModal();
        } else {
          $.toastShow("此商品暂无图片");
        }
      }).finally(function() {
        loading.hide();
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.gotoSupplierDebtDetail = function() {
    $state.go("eventmenu.KEY136", {
      oppositeSideId : self.orderDetail.order.supplierId,
      supplierName : self.orderDetail.order.supplierName,
      supplierBanlance : self.supplierBanlance
    });
  };
  FB.fromTemplateUrl("KEY186.html", {
    scope : self
  }).then(function(theTitle) {
    self.orderOperationPopover = theTitle;
  });
  /**
   * @return {?}
   */
  self.getTotalAmount = function() {
    var initial = self.orderDetail.order.trueTotalAmount;
    return self.orderDetail.order.otherCost && (initial = $.accAdd(initial, self.orderDetail.order.otherCost)), self.orderDetail.order.wipeZero && (initial = $.accSub(initial, self.orderDetail.order.wipeZero)), initial;
  };
  /**
   * @return {undefined}
   */
  self.createNewOrder = function() {
    self.viewReplace();
    if (1 === self._itemType) {
      $state.go("eventmenu.KEY219", {
        goodsSn : null,
        purchaseSn : null,
        timeStamp : $.getTimeStamp()
      });
    } else {
      if (2 === self._itemType) {
        $state.go("eventmenu.KEY106", {
          goodsSn : null,
          purchaseSn : null,
          timeStamp : $.getTimeStamp()
        });
      }
    }
  };
  self.$on("$destroy", function() {
    self.orderOperationPopover.remove();
    self.copyOperationPopover.remove();
    if (self.KEY227) {
      self.KEY227.remove();
    }
  });
  loading.show();
  self.$on("$ionicView.beforeEnter", function() {
    /** @type {string} */
    var server = "";
    switch(self._itemType) {
      case 1:
        /** @type {string} */
        server = "/KEY129?purchaseSn=";
        break;
      case 2:
        /** @type {string} */
        server = "/KEY130?purchaseSn=";
    }
    $http.post(server + className).success(function(action) {
      self.orderDetail = action;
      /** @type {boolean} */
      self.isDestroy = 9 === self.orderDetail.order.state;
      /** @type {Array} */
      self.goodsGroup = [];
      /** @type {number} */
      var cssValue = 0;
      action.orderGoods.forEach(function(data) {
        /** @type {boolean} */
        var r = false;
        /** @type {number} */
        var timeoutKey = 0;
        var cnl = self.goodsGroup.length;
        for (;cnl > timeoutKey;timeoutKey++) {
          var a = self.goodsGroup[timeoutKey].goodsSn;
          if (data.goodsSn == a) {
            /** @type {boolean} */
            r = true;
            self.goodsGroup[timeoutKey].goods.push($.getPropertyObj(data, ["colorId", "sizeId", "colorName", "sizeName", "quantity", "price", "discount", "unit", "truePrice","standard","waretype"]));
          }
        }
        if (!r) {
          var meta = {};
          /** @type {Array} */
          meta.goods = [];
          meta.goods.push($.getPropertyObj(data, ["colorId", "sizeId", "colorName", "sizeName", "quantity", "price", "discount", "unit", "truePrice","standard","waretype"]));
          meta.goodName = data.goodName;
          meta.goodsSn = data.goodsSn;
          meta.goodsId = data.goodsId;
          meta.barCode = data.barCode;//条码
          self.goodsGroup.push(meta);
        }
        cssValue = $.accAdd(cssValue, data.quantity);
      });
      self.totalQuantity = cssValue;
      $http.post("/KEY015?supplierId=" + action.order.supplierId).success(function(dataAndEvents) {
        self.supplierBanlance = dataAndEvents.banlance ? dataAndEvents.banlance : 0;
      });
    }).finally(function() {
      loading.hide();
    });
    $document.getScanerCode(function(fmt) {
      console.log(fmt);
    }, self.bluethoothScaner);
  });
}]).controller("PurchaseEditCtrl", ["$scope", "$stateParams", "$q", "$ionicModal", "$ionicPopup", "$state", "lbSpinnerDialog", "$ionicSideMenuDelegate", "psisServices", "Tools", "$ionicPopover", "$ionicActionSheet", "lbScrollDelegate", "showInstructionBackdrop", "wechatShare", "lruPersistCache", "OrderType", "commonDataInterface", "$cordovaDatePicker", "$ionicPlatform", "BluetoothPrintService", "$timeout", "ServerConfig", "BTScanerService", "$ionicLoading", "BusinessConstant", function(self,
input, $q, $modal, view, $state, thingy, keepData, result, UnitTools, FB, handler, parent, v, dataAndEvents, $templateCache, deepDataAndEvents, model, $scope, textAlt, jsPDFAPI, $sanitize, info, $document, loading, ignoreMethodDoesntExist) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = result.httpCacheGet.get(result.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
    var getPromise3 = result.httpCacheGet.get(result.httpCacheGet.ac.ALLSIZELIST);
    var c = result.httpCacheGet.get(result.httpCacheGet.ac.ALLCOLORLIST);
    var d = result.httpCacheGet.get(result.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    return $q.all([request1, getPromise3, c, d]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /** @type {number} */
  self._itemType = 0;
  if ($state.includes("eventmenu.KEY219")) {
    /** @type {number} */
    self._itemType = 1;
    self.viewTitle = input.copyOrder ? "复制为进货单" : self.NameConstant.KEY329;
    self.isUserAccAvailable = self.GetOperatorEventLimit("KEY168");
  } else {
    if ($state.includes("eventmenu.KEY106")) {
      /** @type {number} */
      self._itemType = 2;
      self.viewTitle = input.copyOrder ? "复制为退货单" : self.NameConstant.KEY330;
      self.isUserAccAvailable = self.GetOperatorEventLimit("KEY045");
    }
  }
  /** @type {string} */
  var label = 2 == self._itemType ? "rejectPurchaseList" : "KEY220";
  /** @type {boolean} */
  self.inComstore = true;
  self.purchaseDraftAccAvailable = 1 == self._itemType && self.GetOperatorEventLimit("KEY055") || 2 == self._itemType && self.GetOperatorEventLimit("KEY047");
  self.purchaseConfirmAccAvailable = 1 == self._itemType && self.GetOperatorEventLimit("KEY048") || 2 == self._itemType && self.GetOperatorEventLimit("KEY010");
  self.purchaseDraftOrConfirmAccAvailable = self.purchaseDraftAccAvailable || self.purchaseConfirmAccAvailable;
  var name = input.purchaseSn;
  var il = input.goodsSn;
  /** @type {number} */
  self.totalAmount = 0;
  /** @type {number} */
  self.totalQuantity = 0;
  /** @type {number} */
  self.totalInvoiceAmount = 0;
  /** @type {boolean} */
  self.isOpenScroll = true;
  self.userConfigData = info.userConfigData;
  self.businessConfig = UnitTools.fnCheckGtoreQty(self.userConfigData, "configKey", "businessConfig");
  /** @type {*} */
  self.businessConfigValue = self.businessConfig && self.businessConfig.configValue ? JSON.parse(self.businessConfig.configValue) : {
    zeroPaid : ignoreMethodDoesntExist.ZEROPAID.ON,
    defaultLastPrice : 0
  };
  self.purchaseOrderContent = {};
  /** @type {boolean} */
  self.purchaseOrderContent.status = false;
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY147.html", function(theTitle) {
    self.selectedGoodListModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.openSelectedGoodModal = function() {
    if (!(self.selectedGoodModal && self.selectedGoodModal.isShown())) {
      $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY093.html", {
        scope : self,
        animation : "slide-in-up"
      }).then(function(theTitle) {
        self.selectedGoodModal = theTitle;
        self.selectedGoodModal.show();
        $sanitize(function() {
          parent.resize("selectGoodForOrderMulScroll");
        });
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.closeSelectedGoodModal = function() {
    self.selectedGoodModal.hide();
    self.selectedGoodModal.remove();
  };
  /**
   * @return {?}
   */
  self.openModal = function() {
    return UnitTools.isEmpty(self.KEY329.purchaseDepot) ? window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择仓库！", null), false) : (view.alert({
      template : "<div class='tc'>请选择仓库！</div>",
      okText : "确定"
    }), false) : void self.modal.show();
  };
  self.$on("$ionicView.loaded", function() {
    if (!name) {
      if (!il) {
        // v.show(self, "instruction_purchase_1.html");
      }
    }
  });
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.clearSelectedGood = function(dataAndEvents) {
    if (angular.isObject(self.selectedGood.good)) {
      if (self.selectedGood.good.goodsSn == dataAndEvents) {
        self.selectedGood.good = {};
      }
    }
  };
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  self.deleteGoods = function(opt_attributes) {
    /** @type {number} */
    var otherwiseLineIndex = 0;
    var cnl = self.KEY329.goodsGroup.length;
    for (;cnl > otherwiseLineIndex;otherwiseLineIndex++) {
      if (opt_attributes == self.KEY329.goodsGroup[otherwiseLineIndex].goodsSn) {
        self.KEY329.goodsGroup.splice(otherwiseLineIndex, 1);
        break;
      }
    }
    self.setTotalAmount();
    self.selectedGood.good = {};
  };
  /**
   * @param {(Object|string)} dataAndEvents
   * @param {string} last
   * @return {undefined}
   */
  self.deletePurchaseGoods = function(dataAndEvents, last) {
    /** @type {number} */
    var otherwiseLineIndex = 0;
    var cnl = self.KEY329.goodsGroup.length;
    for (;cnl > otherwiseLineIndex;otherwiseLineIndex++) {
      if (dataAndEvents == self.KEY329.goodsGroup[otherwiseLineIndex].goodsSn) {
        var i;
        for (i in self.KEY329.goodsGroup[otherwiseLineIndex].goods) {
          if (i == last) {
            self.KEY329.goodsGroup[otherwiseLineIndex].goods.splice(i, 1);
            break;
          }
        }
        if (0 === self.KEY329.goodsGroup[otherwiseLineIndex].goods.length) {
          self.KEY329.goodsGroup.splice(otherwiseLineIndex, 1);
        }
        break;
      }
    }
    if (self.isGoodsGroupNull()) {
      /** @type {boolean} */
      self.KEY329.showDelete = false;
    }
    self.setTotalAmount();
    self.selectedGood.good = {};
  };
  self.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("addSupplierFlag") === true) {
      $templateCache.put("needToAddSupplierFlag", false);
      $templateCache.put("addSupplierFlag", false);
      var filter = $templateCache.get("newSupplierObj");
      if (filter && filter.id) {
        var response = {
          id : filter.id,
          text : filter.supplierName,
          discount : filter.discount
        };
        self.KEY329.KEY184(response);
        $templateCache.put("newSupplierObj", null);
      }
    } else {
      if ($templateCache.get("needToAddGoodsFlag") === true) {
        $templateCache.put("needToAddGoodsFlag", false);
        /**
         * @return {undefined}
         */
        var put = function() {
          if ($templateCache.get("addGoodsFlag") === true) {
            $templateCache.put("addGoodsFlag", false);
            var filter = $templateCache.get("newGoodsObj");
            if (filter) {
              if (filter.id) {
                self.searchGoodsById(filter.id);
                UnitTools.toastShow("新增商品 " + filter.name + " 成功");
                $templateCache.put("newGoodsObj", null);
              }
            }
          }
        };
        $templateCache.put("refreshGoodColorFlag", false);
        $templateCache.put("refreshGoodSizeFlag", false);
        model.getAllColorSize().then(function(packs) {
          if (null != packs) {
            self.allColors = packs[0].data.rows;
            self.allSizes = packs[1].data.rows;
          }
          put();
        }, function() {
          put();
        });
      }
    }
    $document.getScanerCode(function(key) {
      self.searchGoodsByBarCode(key);
    }, self.bluethoothScaner);
  });
  var value = {
    state : 1,
    itemType : self._itemType
  };
  /** @type {number} */
  self.state = 0;
  self.KEY329 = {
    goodsGroup : [],
    KEY282 : {},
    showDelete : false,
    purchaseSn : name,
    otherAccountItem : {},
    otherCost : ""
  };
  /** @type {Array} */
  self.allAccountItems = [];
  self.selectedGood = {};
  /**
   * @return {?}
   */
  self.isGoodsGroupNull = function() {
    return UnitTools.isEmpty(self.KEY329.goodsGroup);
  };
  /**
   * @param {Object} event
   * @return {undefined}
   */
  self.gobackToListAction = function(event) {
    if (event && (event.stopPropagation() && event.preventDefault()), "eventmenu.KEY219" == $state.current.name || "eventmenu.KEY106" == $state.current.name) {
      if (0 != self.state || self.isGoodsGroupNull()) {
        (done || angular.noop)();
        self.goBack();
      } else {
        var promise = view.confirm({
          template : "<div class='tc'>确认要退出开单?</div>",
          cancelText : "取消",
          okText : "继续退出"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            (done || angular.noop)();
            self.goBack();
          }
        });
      }
    } else {
      (done || angular.noop)();
      self.goBack();
    }
  };
  var done = textAlt.registerBackButtonAction(function() {
    return self.gobackToListAction(), false;
  }, 140);
  $modal.fromTemplateUrl("html/PPurchaseBuyBill/KEY184.html", function(theTitle) {
    self.supplierModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  /**
   * @return {undefined}
   */
  self.supplierModalOpen = function() {
    self.supplierModal.show().then(function() {
      UnitTools.keyboardShow();
    });
  };
  /** @type {string} */
  var modalOptions = self.platformIsPad ? "html/PRetailAndSellBill/KEY036.html" : "html/PRetailAndSellBill/KEY204.html";
  $modal.fromTemplateUrl(modalOptions, function(theTitle) {
    self.modal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    self.storehousePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    self.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideStorehousePopover = function() {
    self.storehousePopover.hide();
    /** @type {number} */
    self.isShowInvalidStoreMsg = 0;
  };
  FB.fromTemplateUrl("KEY190.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY190 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideAccountPopover = function() {
    self.KEY190.hide();
  };
  FB.fromTemplateUrl("KEY119.html", {
    scope : self
  }).then(function(theTitle) {
    self.KEY119 = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openAccountItemPopover = function(expectedNumberOfNonCommentArgs) {
    self.KEY119.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.hideAccountItemPopover = function(dataAndEvents) {
    self.KEY329.otherAccountItem = dataAndEvents;
    /** @type {boolean} */
    self.selectedOtherAccountItem = true;
    self.KEY119.hide();
  };
  $modal.fromTemplateUrl("otherCostModal.html", function(theTitle) {
    self.otherCostModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up",
    backdropClickToClose : false
  });
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY323.html", function(theTitle) {
    /** @type {number} */
    self.goodsAddModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.purchaseOrderContent.closeGoodsAddModal = function() {
    self.goodsAddModal.hide();
  };
  /**
   * @return {undefined}
   */
  self.purchaseOrderContent.refreshCacheData = function() {
    if ($templateCache.get("needToAddGoodsFlag") === true) {
      $templateCache.put("needToAddGoodsFlag", false);
      $templateCache.put("refreshGoodColorFlag", false);
      $templateCache.put("refreshGoodSizeFlag", false);
      model.getAllColorSize().then(function(packs) {
        if (null != packs) {
          self.allColors = packs[0].data.rows;
          self.allSizes = packs[1].data.rows;
        }
      });
    }
  };
  /**
   * @param {Object} rec
   * @return {undefined}
   */
  self.purchaseOrderContent.refreshSelectedGoods = function(rec) {
    model.getAllColorSize().then(function(packs) {
      if (null != packs) {
        self.allColors = packs[0].data.rows;
        self.allSizes = packs[1].data.rows;
      }
      if (rec) {
        if (rec.id) {
          self.searchGoodsById(rec.id);
          UnitTools.toastShow("新增商品 " + rec.name + " 成功，请添加进货数量", "long");
        }
      }
    }, function() {
      if (rec) {
        if (rec.id) {
          self.searchGoodsById(rec.id);
          UnitTools.toastShow("新增商品 " + rec.name + " 成功，请添加进货数量", "long");
        }
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.openOtherCostModal = function() {
    if (self.otherCostModal.show(), null == self.KEY329.otherAccountItem.id && 0 == self.state) {
      /** @type {boolean} */
      var o = true
    }
    if (0 == self.allAccountItems.length && result.httpCacheGet.get(result.httpCacheGet.ac.ALLACCOUNTITEM).success(function(result) {
      self.allAccountItems = result.rows;
      /** @type {number} */
      var i = 0;
      for (;i < self.allAccountItems.length;i++) {
        if (o) {
          if (self.KEY220.otherAccountItemValue == self.allAccountItems[i].id) {
            if (1 == self.allAccountItems[i].isEnable) {
              self.KEY329.otherAccountItem = self.allAccountItems[i];
            }
          }
        }
        if (0 == self.allAccountItems[i].isEnable || (1 == self.allAccountItems[i].id || (10 == self.allAccountItems[i].id || 5 == self.allAccountItems[i].id))) {
          self.allAccountItems.splice(i, 1);
          i--;
        }
      }
    }), o && (self.allAccountItems.length > 0 && self.KEY220.otherAccountItemValue)) {
      /** @type {number} */
      var b = 0;
      var a = self.allAccountItems.length;
      for (;a > b;b++) {
        if (self.KEY220.otherAccountItemValue == self.allAccountItems[b].id) {
          self.KEY329.otherAccountItem = self.allAccountItems[b];
          break;
        }
      }
    }
  };
  self.$on("$destroy", function() {
    self.modal.remove();
    self.supplierModal.remove();
    self.storehousePopover.remove();
    self.KEY190.remove();
    if (self.selectedGoodModal) {
      self.selectedGoodModal.remove();
    }
    self.selectedGoodListModal.remove();
    self.KEY119.remove();
    self.otherCostModal.remove();
    if (self.goodsAddModal) {
      self.goodsAddModal.remove();
    }
  });
  /**
   * @return {undefined}
   */
  self.setWipeZero = function() {
    var v = self.KEY329.wipeZero;
    /** @type {number} */
    var version = parseFloat(v > 0 ? v : UnitTools.accSub(self.totalAmount, parseInt(self.totalAmount)));
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt("请输入抹零金额", function(results) {
        if (2 == results.buttonIndex) {
          self.$apply(function() {
            if (1 == self.isNum(results.input1) && results.input1 >= 0) {
              self.KEY329.wipeZero = self.fixedInputNumber(results.input1);
              self.setTotalAmount();
            } else {
              self.KEY329.wipeZero = v;
              UnitTools.toastShow("抹零金额必须大于等于零");
            }
          });
        }
      }, "抹零", ["取消", "确认"], version.toString());
    } else {
      /** @type {number} */
      self.KEY329.wipeZero = version;
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="KEY329.wipeZero" autofocus="true" placeholder="0.00">',
        title : "请输入抹零金额",
        scope : self,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            self.KEY329.wipeZero = self.fixedInputNumber(self.KEY329.wipeZero);
            self.setTotalAmount();
          }
        }]
      });
    }
  };
  /**
   * @param {?} dataAndEvents
   * @return {?}
   */
  self.setOtherCost = function(dataAndEvents) {
    if (dataAndEvents) {
      /** @type {string} */
      self.KEY329.otherCost = "";
    } else {
      if (!self.KEY329.otherAccountItem.id && self.KEY329.otherCost) {
        return UnitTools.toastShow("请选择账目类型"), false;
      }
    }
    self.setTotalAmount();
  };
  /**
   * @param {?} value
   * @return {undefined}
   */
  self.querySupplierBanlance = function(value) {
    result.post("/KEY015?supplierId=" + value).success(function(dataAndEvents) {
      self.supplierBanlance = dataAndEvents.banlance ? dataAndEvents.banlance : 0;
    });
  };
  /**
   * @param {number} key
   * @return {?}直接修改数量单价后的计算
   */
  self.calcTotalAmount = function(key) {
    /** @type {number} */
    var header = 0;
    /** @type {number} */
    var now = 0;
    /** @type {number} */
    var unlock = 0;
    var cnl = self.KEY329.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      /** @type {number} */
      var j = 0;
      var spaces = self.KEY329.goodsGroup[unlock].goods.length;
      for (;spaces > j;j++) {
        var data = self.KEY329.goodsGroup[unlock].goods[j];
        if (data.price || 0 === data.price) {
          if (data.discount) {
            if (data.quantity) {
              /** @type {number} */
              data.isEnoughStore = 2 === self._itemType ? data.quantity <= data.storeNumber ? 1 : 0 : 1;
              if (key) {
                /** @type {number} */
                data.discount = key;
                data.truePrice = self.calcDetailTruePrice(data.price, data.discount);
              }
              header = UnitTools.accAdd(header, UnitTools.accMul(data.truePrice, data.quantity));
              now = UnitTools.accAdd(now, data.quantity);
            }
          }
        }
      }
    }
    self.totalAmount = header;
    self.totalQuantity = now;
    /** @type {number} */
    var node = 0;
    if (self.KEY329.otherAccountItem.id) {
      if (self.KEY329.otherCost) {
        if (self.isNum(self.KEY329.otherCost)) {
          node = UnitTools.accAdd(node, self.KEY329.otherCost);
        }
      }
    }
    if (self.KEY329.wipeZero) {
      if (self.isNum(self.KEY329.wipeZero)) {
        node = UnitTools.accSub(node, self.KEY329.wipeZero);
      }
    }
    var value = UnitTools.accAdd(header, node);
    return self.totalInvoiceAmount = value, value;
  };
  /**
   * @return {undefined}
   */
  self.setTotalAmount = function() {
    /** @type {number} */
    self.KEY329.alreadyPaid = parseFloat(self.calcTotalAmount().toFixed(2));
    if (self.businessConfigValue) {
      if (self.businessConfigValue.zeroPaid == ignoreMethodDoesntExist.ZEROPAID.ON) {
        /** @type {number} */
        self.KEY329.alreadyPaid = 0;
      }
    }
  };
  /**
   * @param {string} isXML
   * @param {string} funcToCall
   * @return {undefined}
   */
  self.toggleDetailInput = function(isXML, funcToCall) {
    /** @type {(null|string)} */
    self.shownDetailInput = self.isDetailInputShown(isXML, funcToCall) ? null : isXML + "-" + funcToCall;
  };
  /**
   * @param {string} value
   * @param {string} funcToCall
   * @return {?}
   */
  self.isDetailInputShown = function(value, funcToCall) {
    return self.shownDetailInput === value + "-" + funcToCall;
  };
  /**
   * @param {?} ids
   * @param {?} data
   * @return {?}
   */
  self.calcDetailTruePrice = function(ids, data) {
    return ids && data ? parseFloat(UnitTools.accDiv(UnitTools.accMul(ids, data), 100).toFixed(2)) : 0;
  };
  /**
   * @param {number} i
   * @param {number} hash
   * @return {?}
   */
  self.calcDetailDiscount = function(i, hash) {
    return i && hash ? parseFloat(UnitTools.accMul(UnitTools.accDiv(i, hash), 100).toFixed(2)) : 0 == i ? 100 : 0;
  };
  /**
   * @param {?} event
   * @param {(Object|string)} onComplete
   * @param {string} dataAndEvents
   * @param {?} deepDataAndEvents
   * @param {(Object|number|string)} ignoreMethodDoesntExist
   * @return {undefined}
   */
  self.openPurchaseBatchModifyModal = function(event, onComplete, dataAndEvents, deepDataAndEvents, ignoreMethodDoesntExist) {
    if (event) {
      event.stopPropagation();
    }
    self.KEY329.modifyPrice = deepDataAndEvents;
    /** @type {(Object|number|string)} */
    self.KEY329.modifyDiscount = ignoreMethodDoesntExist;
    /** @type {string} */
    var MSG_CLOSURE_CUSTOM_COLOR_BUTTON = dataAndEvents + "(" + onComplete + ")";
    view.show({
      cssClass : "lb-KEY291-popup",
      templateUrl : "purchaseBatchModifyModal.html",
      title : MSG_CLOSURE_CUSTOM_COLOR_BUTTON,
      scope : self,
      buttons : [{
        text : "取消"
      }, {
        text : "确认",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          self.purchaseBatchModify(onComplete);
        }
      }]
    });
  };
  /**
   * @param {(Object|string)} onComplete
   * @return {undefined}
   */
  self.purchaseBatchModify = function(onComplete) {
    /** @type {number} */
    var unlock = 0;
    var cnl = self.KEY329.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      if (onComplete == self.KEY329.goodsGroup[unlock].goodsSn) {
        var uri;
        for (uri in self.KEY329.goodsGroup[unlock].goods) {
          var json = self.KEY329.goodsGroup[unlock].goods[uri];
          json.price = self.fixedInputNumber(self.KEY329.modifyPrice);
          json.discount = self.fixedInputNumber(self.KEY329.modifyDiscount);
          json.truePrice = self.purchaseModify();
        }
      }
    }
    self.setTotalAmount();
  };
  /**
   * @return {?}
   */
  self.purchaseModify = function() {
    var attempted = self.KEY329.modifyPrice ? self.KEY329.modifyPrice : 0;
    var desiredValue = self.KEY329.modifyDiscount ? self.KEY329.modifyDiscount : 0;
    return self.calcDetailTruePrice(self.fixedInputNumber(attempted), self.fixedInputNumber(desiredValue));
  };
  /**
   * @param {?} qualifier
   * @return {?}
   */
  self.isNum = function(qualifier) {
    /** @type {RegExp} */
    var isSimple = /^\d+(\.\d+)?$/;
    return isSimple.test(qualifier);
  };
  /**
   * @return {undefined}
   */
  self.changePrice = function() {
    var a = self.KEY329.goodsGroup;
    if (!UnitTools.isEmpty(a)) {
      /** @type {number} */
      var i = 0;
      var l = a.length;
      for (;l > i;i++) {
        var resolveValues = a[i].goods;
        if (self.selectedGood.good.goodsSn == a[i].goodsSn) {
          /** @type {number} */
          var index = 0;
          var length = resolveValues.length;
          for (;length > index;index++) {
            resolveValues[index].price = self.selectedGood.good.factoryPrice;
            /** @type {number} */
            resolveValues[index].truePrice = parseFloat(UnitTools.accDiv(UnitTools.accMul(resolveValues[index].price, resolveValues[index].discount), 100).toFixed(2));
          }
          break;
        }
      }
    }
    self.setTotalAmount();
  };
  /**
   * @param {Function} button
   * @param {?} event
   * @return {undefined}
   */
  self.KEY329.openPriceEditPopup = function(button, event) {
    if (event) {
      event.stopPropagation();
    }
    /** @type {string} */
    var MSG_CLOSURE_CUSTOM_COLOR_BUTTON = button.name + "(" + button.goodsSn + ")";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt("请输入进货价", function(results) {
        if (2 == results.buttonIndex) {
          self.$apply(function() {
            if (1 == self.isNum(results.input1)) {
              if (results.input1 >= 0) {
                button.factoryPrice = self.fixedInputNumber(results.input1);
                self.changePrice();
              }
            }
          });
        }
      }, "临时改价", ["取消", "确认"], 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="selectedGood.good.factoryPrice" autofocus="true" placeholder="请输入进货价">',
        title : MSG_CLOSURE_CUSTOM_COLOR_BUTTON,
        scope : self,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            button.factoryPrice = self.fixedInputNumber(button.factoryPrice);
            self.changePrice();
          }
        }]
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.getWholeOrderDiscount = function() {
    var wholeOrderDiscount = self.KEY329.wholeOrderDiscount;
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt("请输入折扣（%）", function(results) {
        if (2 == results.buttonIndex) {
          self.$apply(function() {
            if (1 == self.isNum(results.input1) && results.input1 >= 0) {
              self.KEY329.wholeOrderDiscount = self.fixedInputNumber(results.input1);
              self.calcTotalAmount(self.KEY329.wholeOrderDiscount);
              self.setTotalAmount();
            } else {
              self.KEY329.wholeOrderDiscount = wholeOrderDiscount;
            }
          });
        }
      }, "整单折扣", ["取消", "打折"], 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" ng-blur="KEY329.wholeOrderDiscount=fixedInputNumber(KEY329.wholeOrderDiscount)" class="tc" ng-model="KEY329.wholeOrderDiscount" placeholder="" autofocus="true">',
        title : "整单折扣(%)",
        scope : self,
        buttons : [{
          text : "取消",
          /**
           * @return {undefined}
           */
          onTap : function() {
            self.KEY329.wholeOrderDiscount = wholeOrderDiscount;
          }
        }, {
          text : "打折",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            self.KEY329.wholeOrderDiscount = self.fixedInputNumber(self.KEY329.wholeOrderDiscount);
            if (self.KEY329.wholeOrderDiscount <= 0) {
              self.KEY329.wholeOrderDiscount = wholeOrderDiscount;
            } else {
              self.calcTotalAmount(self.KEY329.wholeOrderDiscount);
            }
            self.setTotalAmount();
          }
        }]
      });
    }
  };
  /**
   * @param {boolean} version
   * @return {?}
   */
  self.dealInputNumber = function(version) {
    return version ? parseFloat(version) : 0;
  };
  /**
   * @param {?} deepDataAndEvents
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  self.fixedInputNumber = function(deepDataAndEvents, dataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents, dataAndEvents);
  };
  /**
   * @return {undefined}
   */
  self.setBusinessTime = function() {
    if (window.cordova) {
      $scope.show({
        date : new Date(self.KEY329.businessTime),
        mode : "date",
        doneButtonLabel : "确定",
        cancelButtonLabel : "取消",
        minDate : (new Date).setDate((new Date).getDate() - 90),
        maxDate : (new Date).setDate((new Date).getDate())
      }).then(function(date1) {
        if (!isNaN(date1.getTime())) {
          if (self.GetOperatorEventLimit("KEY257") || date1.getTime() >= UnitTools._stringToDate((new Date).toLocaleDateString()).getTime()) {
            self.KEY329.businessTime = date1.getTime();
          } else {
            UnitTools.toastShow("没有补录权限，选择的日期必须为今天");
          }
        }
      });
    }
  };
  /**
   * @param {boolean} showMessage
   * @return {undefined}
   */
  self.setAlreadyPaid = function(showMessage) {
    var dstUri = self.KEY329.alreadyPaid;
    /** @type {string} */
    var body = showMessage ? "实退金额" : "实付金额";
    /** @type {string} */
    var x = (showMessage ? "本单应退金额 " : "本单应付金额 ") + (self.totalAmount ? self.totalAmount.toString() : 0) + " \n (月结供应商填0则记在欠供应商款中)";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(results) {
        if (2 == results.buttonIndex) {
          self.$apply(function() {
            self.KEY329.alreadyPaid = 1 == self.isNum(results.input1) && results.input1 >= 0 ? self.fixedInputNumber(results.input1) : dstUri;
          });
        }
      }, body, ["取消", "确认"], dstUri ? dstUri.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="KEY329.alreadyPaid" autofocus="true" placeholder="0.00">',
        title : x,
        scope : self,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            self.KEY329.alreadyPaid = self.fixedInputNumber(self.KEY329.alreadyPaid);
          }
        }]
      });
    }
  };
  /** @type {number} */
  var page = 1;
  self.selectedGood = {
    good : {},
    goodStore : {},
    seletedColors : [],
    seletedSizes : [],
    quantity : 1
  };
  self.search = {
    goodKey : ""
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      console.log("We got a barcode\nResult: " + result.text + "\nFormat: " + result.format + "\nCancelled: " + result.cancelled);
      if (!result.cancelled) {
        self.$apply(function() {
          self.searchGoodsByBarCode(result.text);
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return result.postEncode("/KEY233", opt_attributes);
  };
  /**
   * @param {?} value
   * @return {undefined}
   */
  self.searchGoodsById = function(value) {
    if (value) {
      model.getGoodsById(value).then(function(dataAndEvents) {
        if (dataAndEvents) {
          /** @type {Array} */
          self.KEY288 = [];
          self.KEY288[0] = dataAndEvents;
          /** @type {boolean} */
          self.loadMoreBtn = false;
          self.KEY264(self.KEY288[0]);
          self.search.goodKey = self.KEY288[0].goodsSn;
          self.openSelectedGoodModal();
        } else {
          UnitTools.toastShow("找不到相关商品信息");
        }
      }, function() {
        UnitTools.toastShow("获取商品信息失败");
      });
    }
  };
  /**
   * @param {string} value
   * @return {undefined}
   */
  self.searchGoodsByGoodsSn = function(value) {
    if (null != value) {
      model.getGoodsByGoodsSn(value).then(function(dataAndEvents) {
        if (dataAndEvents) {
          /** @type {Array} */
          self.KEY288 = [];
          self.KEY288[0] = dataAndEvents;
          /** @type {boolean} */
          self.loadMoreBtn = false;
          self.KEY264(self.KEY288[0]);
          self.search.goodKey = self.KEY288[0].goodsSn;
          self.openSelectedGoodModal();
        } else {
          UnitTools.toastShow("找不到相关商品信息");
        }
      }, function() {
        UnitTools.toastShow("获取商品信息失败");
      });
    }
  };
  /**
   * @param {string} keepData
   * @return {undefined}
   */
  self.searchGoodsByBarCode = function(keepData) {
    if (keepData) {
      model.getGoodsByBarCode(keepData).then(function(data) {
        if ((data) && (data.id !== "")) {
          if (self.selectedGood.good != null && angular.isObject(self.selectedGood.good) && self.selectedGood.good.goodsSn == data.goodsSn) {
            if (self.currentColors.length > 0) {
              if (data.skuCount && (1 === data.skuCount && data.skuColorId)) {
                /** @type {Array} */
                self.selectedGood.seletedColors = [];
                self.selectedGood.seletedColors[0] = UnitTools.fnCheckGtoreQty(self.currentColors, "id", data.skuColorId);
              } else {
                /** @type {Array} */
                self.selectedGood.seletedColors = [];
                self.selectedGood.seletedColors[0] = self.currentColors[0];
              }
            } else {
              /** @type {Array} */
              self.selectedGood.seletedColors = [];
            }
            self.selectedGood.size = self.currentSizes.length > 0 ? data.skuCount && (1 === data.skuCount && data.skuSizeId) ? UnitTools.fnCheckGtoreQty(self.currentSizes, "id", data.skuSizeId) : self.currentSizes[0] : void 0;
            self.addToGoodsGroup(self.selectedGood.seletedColors, self.selectedGood.size, 1, true);
          } else {
            /** @type {Array} */
            self.KEY288 = [];
            self.KEY288[0] = data;
            /** @type {boolean} */
            self.loadMoreBtn = false;
            self.KEY264(data, true);
            /** @type {string} */
            self.search.goodKey = keepData;
          }
          //self.openSelectedGoodModal();//这行会扫码成功后还弹出编辑数量框
        } else {
          UnitTools.toastShow("找不到 " + keepData + " 的商品");

          view.alert({
            template : "<div class='tc'>"+"找不到" + keepData + "的商品"+"</div>",
            okText : "确定"
          });

          navigator.notification.beep(1);
        }
      }, function() {
        UnitTools.toastShow("获取商品信息失败");
      });
    }
  };
  /**
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  self.searchGoods = function(dataAndEvents) {
    /** @type {number} */
    page = 1;
    createDom({
      page : page,
      searchKey : self.search.goodKey
    }).success(function(info) {
      self.KEY288 = info.optionList;
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
      if (!dataAndEvents) {
        if (self.search.goodKey) {
          if (1 == self.KEY288.length) {
            if (window.cordova && (window.cordova.plugins && window.cordova.plugins.Keyboard)) {
              cordova.plugins.Keyboard.close();
              window.setTimeout(function() {
                self.KEY264(self.KEY288[0]);
              }, 100);
            } else {
              self.KEY264(self.KEY288[0]);
            }
            self.selectedGoodModal.show();
            UnitTools.keyboardHide();
          }
        }
      }
    }).finally(function() {
      parent.scrollTop("saleGoodModalCtrlScroll");
    });
  };
  var HOP = ionic.debounce(self.searchGoods, 500);
  /**
   * @param {?} walkers
   * @return {undefined}
   */
  self.searchGoodsByKeyword = function(walkers) {
    HOP(walkers);
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    createDom({
      page : ++page,
      searchKey : self.search.goodKey
    }).success(function(info) {
      self.KEY288 = self.KEY288.concat(info.optionList);
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("saleGoodModalCtrlScroll");
    });
  };
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectSize = function(key) {
    var camelKey = self.selectedGood.seletedSizes.indexOf(key);
    if (camelKey > -1) {
      self.selectedGood.seletedSizes.splice(camelKey, 1);
    } else {
      self.selectedGood.seletedSizes.push(key);
    }
  };
  /**
   * @return {undefined}
   */
  self.selectAllSizes = function() {
    if (self.selectedGood.seletedSizes.length == self.currentSizes.length) {
      /** @type {Array} */
      self.selectedGood.seletedSizes = [];
    } else {
      var index;
      for (index in self.currentSizes) {
        if (self.selectedGood.seletedSizes.indexOf(self.currentSizes[index]) < 0) {
          self.selectedGood.seletedSizes.push(self.currentSizes[index]);
        }
      }
    }
  };
  /**
   * @param {Element} model
   * @param {?} spy
   * @return {?}
   */
  self.getGoodStoreNum = function(model, spy) {
    var ex = UnitTools.fnCheckGtoreQty(self.selectedGood.goodStore, "serialNo", self.KEY329.purchaseDepot.val + "-" + self.selectedGood.good.id + "-" + spy.id + "-" + model.id);
    if (self.selectedGood.selectedUnits[0].unitRate){
      var unitRate = self.selectedGood.selectedUnits[0].unitRate;
      return ex ? 0 == ex.number ? 0 : Math.floor(ex.number / unitRate).toFixed(1) : 0;
    } else {
      return ex ? 0 == ex.number ? 0 : ex.number : 0;
    }
  };
  /**
   * @param {string} data
   * @return {?}
   */
  self.isAddToGoodGroup = function(data) {
    var queue = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", data);
    return queue ? true : false;
  };
  /**
   * @param {string} data
   * @return {?}
   */
  self.getGoodsCount = function(data) {
    /** @type {number} */
    var count = 0;
    var queue = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", data);
    if (queue) {
      var employees = queue.goods;
      /** @type {number} */
      var i = 0;
      var l = employees.length;
      for (;l > i;i++) {
        count += employees[i].quantity;
      }
    }
    return count ? count : "";
  };
  /**
   * @param {string} body
   * @return {?}
   */
  self.getGoodsSkuCount = function(body) {
    /** @type {number} */
    var m1 = 0;
    /** @type {number} */
    var c = 0;
    var data = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", body);
    if (data) {
      var items = data.goods;
      m1 = items.length;
      /** @type {number} */
      var i = 0;
      var ilen = items.length;
      for (;ilen > i;i++) {
        c += items[i].quantity;
      }
    }
    return m1 ? m1 + " 款 " + c + " 件" : "";
  };
  /**
   * @param {string} data
   * @return {?}
   */
  self.getGoodsAmount = function(data) {
    /** @type {number} */
    var caption = 0;
    var queue = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", data);
    if (queue) {
      var employees = queue.goods;
      /** @type {number} */
      var i = 0;
      var l = employees.length;
      for (;l > i;i++) {
        var meta = employees[i];
        if (meta.price || 0 === meta.price) {
          if (meta.discount) {
            if (meta.quantity) {
              caption = UnitTools.accAdd(caption, UnitTools.accMul(meta.truePrice, meta.quantity));
            }
          }
        }
      }
    }
    return caption;
  };
  /**
   * @param {Element} ev
   * @param {?} str
   * @return {?}
   */
  self.getStoreWarningCss = function(ev, str) {
    if (2 === self._itemType && (self.selectedGood.good[ev.id] && self.selectedGood.good[ev.id][str.id])) {
      var id = self.selectedGood.good[ev.id][str.id];
      var key = self.getGoodStoreNum(ev, str);
      if (0 == key || id > key) {
        return "lb-select-goods-sku-store-warning";
      }
    }
    return "";
  };

  /**
   * 切换单位
   */
  self.selectUnit = function(unit) {
    var pos = self.selectedGood.selectedUnits.indexOf(unit);
    if (pos <= -1) {
      self.selectedGood.selectedUnits.splice(0, 1);
      self.selectedGood.selectedUnits.push(unit);
    }
  };


  /**
   * @param {?} models
   * @param {?} str
   * @param {number} dataAndEvents
   * @param {boolean} deepDataAndEvents
   * @return {?}
   采购单添加商品
   */
  self.addToGoodsGroup = function(models, str, dataAndEvents, deepDataAndEvents,units,standard,waretype) {
    if (null != models && (0 != models.length && (null != str && !(deepDataAndEvents && (0 > dataAndEvents && self.selectedGood.good.numArray[models[0].id][str.id] <= 0))))) {
      /** @type {number} */
      var pos = 0;
      /** @type {number} */
      var index = 0;
      var length = self.KEY329.goodsGroup.length;
      for (;length > index;index++) {
        pos += self.KEY329.goodsGroup[index].goods.length;
      }
      var expectedOutput = self.selectedGood.good.goodsSn;

      //使用辅助单位的标志
      var useAidUnitFlag = false;
      if (units[0].unitId !== 0){
        useAidUnitFlag = true;
      }
      //从购物车中获取商品
      var meta = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", expectedOutput);
      if (meta) {
        /** @type {number} */
        var i = 0;
        var l = models.length;
        for (;l > i;i++) {
          var h = UnitTools.getObjectByObjectMultUnit(meta.goods, {
            colorId : models[i].id,
            sizeId : str.id,
            unitId : units[0].unitId
          });
          if (!h) {
            pos++;
          }
        }
      } else {
        meta = {
          goods : [],
          goodName : self.selectedGood.good.name,
          barCode : self.selectedGood.good.barCode,//条码
          goodsSn : expectedOutput,
          imagine : self.selectedGood.good.imagine
        };
        self.KEY329.goodsGroup.push(meta);
        pos++;
      }
      if (pos > self.limitNum) {
        /** @type {string} */
        var gotErr = "单据中的单品条数已超出" + self.limitNum + "条的限制！";
        return UnitTools.toastShow(gotErr, "short", "center"), false;
      }
      /** @type {number} */
      i = 0;
      l = models.length;
      for (;l > i;i++) {
        var BuyItem = {
          colorId : models[i].id,
          sizeId : str.id,
          colorName : models[i].name,
          sizeName : str.name,
          quantity : dataAndEvents,
          price : self.selectedGood.good.factoryPrice,
          discount : self.selectedGood.discount,
          unit : units[0].unitName,
          unitId : units[0].unitId,
          truePrice : parseFloat(UnitTools.accDiv(UnitTools.accMul(self.selectedGood.good.factoryPrice, self.selectedGood.discount), 100).toFixed(2)),
          storeNumber : self.getGoodStoreNum(models[i], str),
          standard : standard,
          waretype : waretype
        };

        //设置价格
        if (useAidUnitFlag){
          if (useAidUnitFlag){
            BuyItem.price = parseFloat(units[0].intoPrice.toFixed(2));//辅助单位中的价格
            BuyItem.truePrice = parseFloat(UnitTools.accDiv(UnitTools.accMul(units[0].intoPrice, self.selectedGood.discount), 100).toFixed(2));//辅助单位中的价格
          }
        }

        if (str.name == "赠送") {//是否为赠送
        	BuyItem.price = 0; //如果尺码是增送，单价设置为0
        	BuyItem.truePrice = 0; //如果尺码是增送，折后单价设置为0
				}
        /** @type {Array} */
        var sourceKeys = meta.goods;
        /** @type {boolean} */
        var O = false;
        /** @type {number} */
        index = 0;
        /** @type {number} */
        length = sourceKeys.length;
        for (;length > index;index++) {
          var a = sourceKeys[index];
          if (a.colorId == BuyItem.colorId && a.sizeId == BuyItem.sizeId && a.unitId == BuyItem.unitId) {
            if (deepDataAndEvents) {
              if (a.quantity + BuyItem.quantity < 0) {
                return false;
              }
              a.quantity += BuyItem.quantity;
              if (self.currentUnits.length > 1){
                self.selectedGood.good.numArray[models[i].id][str.id][units[0].unitId] = a.quantity;
              }else {
                self.selectedGood.good.numArray[models[i].id][str.id] = a.quantity;
              }
            } else {
              a.quantity = BuyItem.quantity;
              if (self.currentUnits.length > 1){
                self.selectedGood.good.numArray[models[i].id][str.id][units[0].unitId] = a.quantity;
              } else {
                self.selectedGood.good.numArray[models[i].id][str.id] = a.quantity;
              }
            }
            if (0 == a.quantity) {
              meta.goods.splice(index, 1);
            }
            /** @type {boolean} */
            O = true;
            break;
          }
        }
        if (!O) {
          if (BuyItem.quantity > 0) {
            //更新存储二维/三维数组中数量
            if (self.currentUnits.length > 1){
              self.selectedGood.good.numArray[models[i].id][str.id][units[0].unitId] = BuyItem.quantity;
            } else {
              self.selectedGood.good.numArray[models[i].id][str.id] = BuyItem.quantity;
            }
            meta.goods.push(BuyItem);
          }
        }
      }
      if (0 == meta.goods.length) {
        UnitTools.removeByKey(self.KEY329.goodsGroup, "goodsSn", expectedOutput);
      }
      self.setTotalAmount();
    }
  };
  /**
   * @param {Array} results
   * @param {number} dataAndEvents
   * @param {boolean} deepDataAndEvents
   * @return {?}
   */
  self.addToGoodsGroupBatch = function(results, dataAndEvents, deepDataAndEvents) {
    if (null != results && (0 != results.length && !(deepDataAndEvents && (0 > dataAndEvents && self.selectedGood.good.batchNumArray[results[0].id] <= 0)))) {
      /** @type {number} */
      var pos = 0;
      /** @type {number} */
      var i = 0;
      var len = self.KEY329.goodsGroup.length;
      for (;len > i;i++) {
        pos += self.KEY329.goodsGroup[i].goods.length;
      }
      var expectedOutput = self.selectedGood.good.goodsSn;
      var meta = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", expectedOutput);
      if (meta) {
        /** @type {number} */
        var a = 0;
        var l = results.length;
        for (;l > a;a++) {
          /** @type {number} */
          i = 0;
          len = self.currentSizes.length;
          for (;len > i;i++) {
            var p = UnitTools.getObjectByObject(meta.goods, {
              colorId : results[a].id,
              sizeId : self.currentSizes[i].id
            });
            if (!p) {
              pos++;
            }
          }
        }
      } else {
        meta = {
          goods : [],
          goodName : self.selectedGood.good.name,
          barCode : self.selectedGood.good.barCode,//条码
          goodsSn : expectedOutput,
          imagine : self.selectedGood.good.imagine
        };
        self.KEY329.goodsGroup.push(meta);
        pos += self.currentSizes.length;
      }
      if (pos > self.limitNum) {
        /** @type {string} */
        var gotErr = "单据中的单品条数已超出" + self.limitNum + "条的限制！";
        return UnitTools.toastShow(gotErr, "short", "center"), false;
      }
      /** @type {number} */
      a = 0;
      l = results.length;
      for (;l > a;a++) {
        /** @type {number} */
        var index = 0;
        var startOffset = self.currentSizes.length;
        for (;startOffset > index;index++) {
          var prop = self.currentSizes[index];
          var d = {
            colorId : results[a].id,
            sizeId : prop.id,
            colorName : results[a].name,
            sizeName : prop.name,
            quantity : dataAndEvents,
            price : self.selectedGood.good.factoryPrice,
            discount : self.selectedGood.discount,
            unit : self.selectedGood.good.unit,
            truePrice : parseFloat(UnitTools.accDiv(UnitTools.accMul(self.selectedGood.good.factoryPrice, self.selectedGood.discount), 100).toFixed(2)),
            storeNumber : self.getGoodStoreNum(results[a], prop)
          };
          /** @type {Array} */
          var rawParams = meta.goods;
          /** @type {boolean} */
          var v = false;
          /** @type {number} */
          i = 0;
          /** @type {number} */
          len = rawParams.length;
          for (;len > i;i++) {
            var data = rawParams[i];
            if (data.colorId == d.colorId && data.sizeId == d.sizeId) {
              if (deepDataAndEvents) {
                if (data.quantity + d.quantity < 0) {
                  return self.selectedGood.good.batchNumArray[results[a].id] = 0, false;
                }
                data.quantity += d.quantity;
                self.selectedGood.good.numArray[results[a].id][prop.id] = data.quantity;
              } else {
                data.quantity = d.quantity;
                self.selectedGood.good.numArray[results[a].id][prop.id] = data.quantity;
              }
              if (0 == data.quantity) {
                meta.goods.splice(i, 1);
              }
              /** @type {boolean} */
              v = true;
              break;
            }
          }
          if (!v) {
            if (d.quantity > 0) {
              self.selectedGood.good.numArray[results[a].id][prop.id] = deepDataAndEvents ? 1 : dataAndEvents;
              meta.goods.push(d);
            }
          }
        }
      }
      if (0 == meta.goods.length) {
        UnitTools.removeByKey(self.KEY329.goodsGroup, "goodsSn", expectedOutput);
      }
      self.selectedGood.good.batchNumArray[results[0].id] = UnitTools.accAdd(self.selectedGood.good.batchNumArray[results[0].id], dataAndEvents);
      self.setTotalAmount();
    }
  };
  /**
   * @param {Element} def
   * @return {?}
   */
  self.getColorNumber = function(def) {
    var expectedOutput = self.selectedGood.good.goodsSn;
    var left = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", expectedOutput);
    /** @type {number} */
    var count = 0;
    if (left) {
      var a = left.goods;
      /** @type {number} */
      var i = 0;
      var l = a.length;
      for (;l > i;i++) {
        var data = a[i];
        if (data.colorId == def.id) {
          count += data.quantity;
        }
      }
    }
    return count ? count : "";
  };
  /**
   * @return {undefined}
   */
  self.KEY289 = function() {
    var listEntries = angular.element(document.querySelector("#selectedGoodsNum"));
    listEntries.removeClass("lb-goods-num-slideInUp");
    $sanitize(function() {
      self.addToSaleGoods();
    }, 200);
  };
  /**
   * @return {?}
   */
  self.addToSaleGoods = function() {
    if (0 == self.selectedGood.seletedColors.length) {
      return void UnitTools.toastShow("请选择颜色！", "short", "center");
    }
    if (0 == self.selectedGood.seletedSizes.length) {
      return void UnitTools.toastShow("请选择尺码！", "short", "center");
    }
    if (!self.selectedGood.quantity) {
      return self.selectedGood.quantity = "", void UnitTools.toastShow("请输入数量！", "short", "center");
    }
    /** @type {number} */
    var pos = 0;
    /** @type {number} */
    var dataName = 0;
    var n = self.KEY329.goodsGroup.length;
    for (;n > dataName;dataName++) {
      pos += self.KEY329.goodsGroup[dataName].goods.length;
    }
    var expectedOutput = self.selectedGood.good.goodsSn;
    var test = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", expectedOutput);
    if (test) {
      /** @type {number} */
      var b = 0;
      var a = self.selectedGood.seletedColors.length;
      for (;a > b;b++) {
        /** @type {number} */
        var i = 0;
        var ilen = self.selectedGood.seletedSizes.length;
        for (;ilen > i;i++) {
          var attributes = {
            colorId : self.selectedGood.seletedColors[b].id,
            sizeId : self.selectedGood.seletedSizes[i].id
          };
          var buttonElement = UnitTools.getObjectByObject(test.goods, attributes);
          if (!buttonElement) {
            pos++;
          }
        }
      }
    } else {
      pos += self.selectedGood.seletedColors.length * self.selectedGood.seletedSizes.length;
    }
    if (pos > self.limitNum) {
      /** @type {string} */
      var gotErr = "单据中的单品条数已超出" + self.limitNum + "条的限制！";
      return UnitTools.toastShow(gotErr, "short", "center"), false;
    }
    if (!test) {
      test = {
        goods : [],
        goodName : self.selectedGood.good.name,
        barCode : self.selectedGood.good.barCode,//条码
        goodsSn : expectedOutput,
        imagine : self.selectedGood.good.imagine
      };
      self.KEY329.goodsGroup.push(test);
    }
    /** @type {number} */
    b = 0;
    a = self.selectedGood.seletedColors.length;
    for (;a > b;b++) {
      /** @type {number} */
      i = 0;
      ilen = self.selectedGood.seletedSizes.length;
      for (;ilen > i;i++) {
        var item = {
          colorId : self.selectedGood.seletedColors[b].id,
          sizeId : self.selectedGood.seletedSizes[i].id,
          colorName : self.selectedGood.seletedColors[b].name,
          sizeName : self.selectedGood.seletedSizes[i].name,
          quantity : self.selectedGood.quantity,
          price : self.selectedGood.good.factoryPrice,
          discount : self.selectedGood.discount,
          unit : self.selectedGood.good.unit,
          truePrice : parseFloat(UnitTools.accDiv(UnitTools.accMul(self.selectedGood.good.factoryPrice, self.selectedGood.discount), 100).toFixed(2)),
          storeNumber : self.getGoodStoreNum(self.selectedGood.seletedColors[b], self.selectedGood.seletedSizes[i])
        };

        /** @type {Array} */
        var result = test.goods;
        /** @type {boolean} */
        var f = false;
        /** @type {number} */
        dataName = 0;
        /** @type {number} */
        n = result.length;
        for (;n > dataName;dataName++) {
          var data = result[dataName];
          if (data.colorId == item.colorId && data.sizeId == item.sizeId) {
            data.quantity += item.quantity;
            data.price = item.price;
            /** @type {number} */
            data.truePrice = parseFloat(UnitTools.accDiv(UnitTools.accMul(data.price, data.discount), 100).toFixed(2));
            /** @type {boolean} */
            f = true;
            break;
          }
        }
        if (!f) {
          test.goods.push(item);
        }
      }
    }
    if (0 == test.goods.length) {
      UnitTools.removeByKey(self.KEY329.goodsGroup, "goodsSn", expectedOutput);
    }
    self.setTotalAmount();
  };
  /**
   * @param {?} _xhr
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  self.KEY264 = function(_xhr, dataAndEvents) {
    //选中商品对象
    self.selectedGood.good = _xhr;

    //辅助单位
    self.currentUnits = [];
    //基本单位
    self.currentUnits.push({
      id : 0,
      unitName : _xhr.unit ? _xhr.unit : "件",
      unitId : 0,
      priceRetail : _xhr.retailPriceArea,
      prepPrice1 : _xhr.tradePrice
    });
    //追加辅助单位
    if (_xhr.goodsUnitPriceList){
      for (var z = 0; z < _xhr.goodsUnitPriceList.length; z++) {
        self.currentUnits.push(_xhr.goodsUnitPriceList[z]);
      }
    }
    //选中的单位
    self.selectedGood.selectedUnits = [];
    if (self.currentUnits.length > 0){
      self.selectedGood.selectedUnits.push(self.currentUnits[0]);
    }

    self.currentColors = UnitTools.idStringToObjectArray(self.allColors, _xhr.colorIds, "id", ",");
    self.currentSizes = UnitTools.idStringToObjectArray(self.allSizes, _xhr.sizeIds, "id", ",");
    self.selectedGood.discount = UnitTools.isEmpty(self.KEY329.KEY282) ? 100 : self.KEY329.KEY282.discount;
    var promise = model.getGoodsStoredCount(_xhr.goodsSn, self.KEY329.purchaseDepot.val);
    promise.then(function(dataAndEvents) {
      self.selectedGood.goodStore = dataAndEvents;
    }, function() {
      self.selectedGood.goodStore = void 0;
      UnitTools.toastShow("获取商品库存信息失败！");
    });
    //选中的颜色
    self.selectedGood.seletedColors = [];
    //二/三维数组存储数量
    self.selectedGood.good.numArray = [];
    /** @type {Array} */
    self.selectedGood.good.batchNumArray = [];
    var child = UnitTools.fnCheckGtoreQty(self.KEY329.goodsGroup, "goodsSn", _xhr.goodsSn);
    /** @type {number} */
    var b = 0;
    var a = self.currentColors.length;
    var unitsLength = self.currentUnits.length;
    for (;a > b;b++) {
      /** @type {number} */
      self.selectedGood.good.batchNumArray[self.currentColors[b].id] = 0;
      /** @type {Array} */
      self.selectedGood.good.numArray[self.currentColors[b].id] = [];
      /** @type {number} */
      var j = 0;
      var spaces = self.currentSizes.length;
      for (;spaces > j;j++) {
        if (child) {
          var node = self.currentColors[b].id;
          var from = self.currentSizes[j].id;

          if (self.currentUnits.length <= 1) { //没有辅助单位
            var p = equal(child.goods, node, from);
            self.selectedGood.good.numArray[self.currentColors[b].id][self.currentSizes[j].id] = p > 0 ? p : 0;
          } else {
            self.selectedGood.good.numArray[self.currentColors[b].id][self.currentSizes[j].id] = [];
            var m = 0;
            for(; unitsLength > m ; m++){
              var unitId = self.currentUnits[m].unitId;
              var q = equalMultUnit(child.goods,node,from,unitId);
              self.selectedGood.good.numArray[self.currentColors[b].id][self.currentSizes[j].id][self.currentUnits[m].unitId] = q > 0 ? q : 0;
            }
          }
        } else {
          if (unitsLength <= 1){
            self.selectedGood.good.numArray[self.currentColors[b].id][self.currentSizes[j].id] = 0;
          }else{
            //如果多单位，二维数组修改为三维数组,以unitId作为下标
            self.selectedGood.good.numArray[self.currentColors[b].id][self.currentSizes[j].id] = [];
            var k = 0;
            for(; unitsLength > k ; k++){
              self.selectedGood.good.numArray[self.currentColors[b].id][self.currentSizes[j].id][self.currentUnits[k].unitId] = 0;
            }
          }
        }
      }
    }
    if (self.currentColors.length > 0) {
      self.selectedGood.seletedColors.push(_xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuColorId) ? UnitTools.fnCheckGtoreQty(self.currentColors, "id", _xhr.skuColorId) : self.currentColors[0]);
    } else {
      /** @type {Array} */
      self.selectedGood.seletedColors = [];
    }
    self.selectedGood.size = self.currentSizes.length > 0 && (_xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuSizeId)) ? UnitTools.fnCheckGtoreQty(self.currentSizes, "id", _xhr.skuSizeId) : self.currentSizes[0];

    if (dataAndEvents) {
      self.addToGoodsGroup(self.selectedGood.seletedColors, self.selectedGood.size, 1, true);
    }
  };
  /**
   * @param {Array} a
   * @param {?} dataAndEvents
   * @param {?} b
   * @return {?}
   */
  var equal = function(a, dataAndEvents, b) {
    /** @type {number} */
    var i = 0;
    var l = a.length;
    for (;l > i;i++) {
      if (a[i].colorId == dataAndEvents && a[i].sizeId == b) {
        return a[i].quantity;
      }
    }
    return 0;
  };

  var equalMultUnit = function(goods, colorId, sizeId,unitId) {
    /** @type {number} */
    var i = 0;
    var l = goods.length;
    for (;l > i;i++) {
      if (goods[i].colorId == colorId && goods[i].sizeId == sizeId && goods[i].unitId == unitId) {
        return goods[i].quantity;
      }
    }
    return 0;
  };
  /**
   * @param {string} from
   * @return {?}
   */
  self.savePurchase = function(from) {
    /**
     * @return {?}
     */
    function combine() {
      /** @type {Array} */
      var resp = [];
      /** @type {number} */
      var unlock = 0;
      var cnl = self.KEY329.goodsGroup.length;
      for (;cnl > unlock;unlock++) {
        var goodsSn = self.KEY329.goodsGroup[unlock].goodsSn;
        var dataName;
        for (dataName in self.KEY329.goodsGroup[unlock].goods) {
          var data = self.KEY329.goodsGroup[unlock].goods[dataName];
          resp.push({
            storehouseId : camelKey,
            goodsSn : goodsSn,
            colorId : data.colorId,
            sizeId : data.sizeId
          });
        }
      }
      return model.getGoodsListStoredCount(resp);
    }
    /**
     * @param {string} key
     * @param {string} id
     * @param {?} data
     * @param {?} name
     * @return {undefined}
     */
    function fnCheckGtoreQty(key, id, data, name) {
      var match = UnitTools.fnCheckGtoreQty(name, "serialNo", key + "-" + id + "-" + data.colorId + "-" + data.sizeId);
      var count = match ? match.number : 0;
      data.storeNumber = count;
      if (data.quantity <= count) {
        /** @type {number} */
        data.isEnoughStore = 1;
      }
      else if (data.sizeName=="赠送") {
        data.isEnoughStore = 1;       //赠送尺码不检测库存
      }
      else {
        /** @type {number} */
        data.isEnoughStore = 0;
        /** @type {number} */
        self.isShowInvalidStoreMsg = 1;
      }
    }
    if (UnitTools.isEmpty(self.KEY329.KEY282)) {
      return UnitTools.toastShow("需要选择供应商！"), self.supplierModalOpen(), false;
    }
    if (UnitTools.isEmpty(self.KEY329.purchaseDepot)) {
      return view.alert({
        template : "<div class='tc'>需要选择仓库</div>",
        okText : "确定"
      }), false;
    }
    if (UnitTools.isEmpty(self.KEY329.goodsGroup)) {
      return view.alert({
        template : "<div class='tc'>请选择商品</div>",
        okText : "确定"
      }), false;
    }
    if (self.KEY329.businessTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date(self.KEY329.businessTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      self.KEY329.businessTime = midnight.getTime();
    }
    /** @type {Array} */
    var items = [];
    /** @type {number} */
    self.isShowInvalidStoreMsg = 0;
    loading.show({
      template : "检查商品信息..."
    });
    var camelKey = self.KEY329.purchaseDepot.val;
    combine().then(function(optgroup) {
      /**
       * @return {?}
       */
      function update() {
        if (UnitTools.union(value, {
          supplierId : self.KEY329.KEY282.id,
          depotId : self.KEY329.purchaseDepot.val,
          accountId : self.KEY329.purchaseAccount.id,
          discount : self.KEY329.wholeOrderDiscount ? self.KEY329.wholeOrderDiscount : self.KEY329.KEY282.discount,
          remark : self.KEY329.remark,
          alreadyPaid : self.KEY329.alreadyPaid ? self.KEY329.alreadyPaid : 0,
          businessTime : self.KEY329.businessTime,
          otherAccountItem : self.KEY329.otherAccountItem.id,
          otherCost : self.KEY329.otherCost,
          wipeZero : self.KEY329.wipeZero
        }), self.totalAmount + value.otherCost < value.wipeZero) {
          return UnitTools.toastShow("抹零金额不能大于商品金额."), false;
        }
        if (thingy.show(true), "update" === from || "insert" === from) {
          var tasks;
          switch(self._itemType) {
            case 1:
              /** @type {string} */
              tasks = "/KEY125";
              break;
            case 2:
              /** @type {string} */
              tasks = "/KEY126";
          }
          result.postEncode(tasks, {
            order : angular.toJson(value),
            goods : angular.toJson(items)
          }).success(function(res) {
            if (1 == res.statusCode) {
              UnitTools.toastShow("保存成功！");
              if ("update" === from) {
                UnitTools.union(value, {
                  optimisticLockVersion : res.object.optimisticLockVersion
                });
              } else {
                if ("insert" === from) {
                  UnitTools.union(value, res.object);
                  self.state = res.object.state;
                  self.KEY329.purchaseSn = res.object.purchaseSn;
                  self.KEY329.handlerName = res.object.handlerName;
                  self.KEY329.businessTime = res.object.businessTime;
                }
              }
            } else {
              UnitTools.toastShow(res.content);
            }
          }).finally(function() {
            thingy.hide();
            $templateCache.put("purchaseListRefresh", true);
          });
        } else {
          if ("approval" === from) {
            switch(self._itemType) {
              case 1:
                /** @type {string} */
                tasks = "/KEY127";
                break;
              case 2:
                /** @type {string} */
                tasks = "/KEY128";
            }
            result.postEncode(tasks, {
              order : angular.toJson(value),
              goods : angular.toJson(items)
            }).success(function(res) {
              if (1 == res.statusCode) {
                var logoutState;
                switch(self._itemType) {
                  case 1:
                    /** @type {string} */
                    logoutState = "eventmenu.KEY188";
                    UnitTools.toastShow("进货成功！");
                    if (input.goodsId) {
                      $templateCache.put("goodListRefresh", true);
                    }
                    break;
                  case 2:
                    /** @type {string} */
                    logoutState = "eventmenu.KEY063";
                    UnitTools.toastShow("退货成功！");
                }
                /** @type {Array} */
                self.KEY329.goodsGroup = [];
                jsPDFAPI.autoPrint(self.mainCompany.comName, res.object.purchaseSn, 1 === self._itemType ? jsPDFAPI.orderType.KEY329 : jsPDFAPI.orderType.KEY330);
                self.viewReplace();
                $state.go(logoutState, {
                  purchaseSn : res.object.purchaseSn
                });
              } else {
                UnitTools.toastShow(res.content);
              }
            }).finally(function() {
              thingy.hide();
              $templateCache.put("purchaseListRefresh", true);
            });
          }
        }
      }
      /** @type {number} */
      var unlock = 0;
      var cnl = self.KEY329.goodsGroup.length;
      for (;cnl > unlock;unlock++) {
        var id = self.KEY329.goodsGroup[unlock].goodsSn;
        var nkey;
        for (nkey in self.KEY329.goodsGroup[unlock].goods) {
          var item = self.KEY329.goodsGroup[unlock].goods[nkey];
          if (null != item.price) {
            if (null != item.discount) {
              if (null != item.truePrice) {
                if (null != item.quantity) {
                  if (0 != item.quantity) {
                    if (2 === self._itemType) {
                      fnCheckGtoreQty(camelKey, id, item, optgroup);
                    } else {
                      /** @type {number} */
                      item.isEnoughStore = 1;
                    }
                    items.push({
                      goodsSn : id,
                      color : item.colorId,
                      size : item.sizeId,
                      quantity : item.quantity,
                      price : item.price,
                      discount : item.discount,
                      truePrice : item.truePrice,
                      amount : UnitTools.accMul(item.price, item.quantity),
                      trueAmount : UnitTools.accMul(item.truePrice, item.quantity),
                      unitId : item.unitId
                    });
                  }
                }
              }
            }
          }
        }
      }
      if (loading.hide(), items.length <= 0) {
        return view.alert({
          template : "<div class='tc'>请检查商品信息</div>",
          okText : "确定"
        }), false;
      }
      if (1 === self.isShowInvalidStoreMsg) {
        var promise = view.confirm({
          template : "<div class='tc'>商品库存不足，是否继续3?</div>",
          cancelText : "取消",
          okText : "approval" === from ? 2 === self._itemType ? "继续退货" : "继续进货" : "继续保存"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            update();
          }
        });
      } else {
        update();
      }
    }, function() {
      loading.hide();
    });
  };
  /**
   * @param {number} dataAndEvents
   * @return {undefined}
   */
  self.showActionsheet = function(dataAndEvents) {
    var r = 1 === self._itemType && self.GetOperatorEventLimit("KEY099") || 2 === self._itemType && self.GetOperatorEventLimit("KEY040");
    var scope = {
      buttons : []
    };
    if (self.purchaseDraftAccAvailable) {
      scope.buttons.push({
        text : '<i class="icon ion-ios-compose-outline assertive"></i> 草 稿'
      });
    }
    if (self.purchaseConfirmAccAvailable) {
      scope.buttons.push(1 === self._itemType ? {
        text : '<i class="icon ion-ios-paper-outline assertive"></i> 采 购'
      } : {
        text : '<i class="icon ion-ios-paper-outline assertive"></i> 退 货'
      });
    }
    // if (1 == dataAndEvents) {
    //   scope.buttons.push({
    //     text : '<i class="icon ion-share balanced"></i> 微信分享'
    //   });
    // }
    if (1 == dataAndEvents) {
      if (r) {
        scope.buttons.push({
          text : '<i class="icon ion-bluetooth assertive"></i> 蓝牙打印'
        });
      }
    }
    /**
     * @param {number} index
     * @return {?}
     */
    scope.buttonClicked = function(index) {
      return scope.buttons[index].text.indexOf("草 稿") > -1 ? self.savePurchase("insert") : scope.buttons[index].text.indexOf("采 购") > -1 || scope.buttons[index].text.indexOf("退 货") > -1 ? self.savePurchase("approval") : scope.buttons[index].text.indexOf("微信分享") > -1 ? dataAndEvents.shareSnUrl(self.KEY329.purchaseSn, 1 === self._itemType ? deepDataAndEvents.KEY329 :
      deepDataAndEvents.KEY330) : scope.buttons[index].text.indexOf("蓝牙打印") > -1 && jsPDFAPI.bluetooth(self.KEY329.purchaseSn, 1 === self._itemType ? jsPDFAPI.orderType.KEY329 : jsPDFAPI.orderType.KEY330), true;
    };
    if (1 == dataAndEvents) {
      if (1 == self._itemType && self.GetOperatorEventLimit("KEY088") || 2 == self._itemType && self.GetOperatorEventLimit("KEY028")) {
        /** @type {string} */
        scope.destructiveText = '<i class="icon ion-ios-trash-outline assertive"></i> 删 除';
        /**
         * @return {?}
         */
        scope.destructiveButtonClicked = function() {
          var promise = view.confirm({
            template : "<div class='tc'>您确认要删除该进货单?</div>",
            cancelText : "取消",
            okText : "确认"
          });
          return promise.then(function(dataAndEvents) {
            if (dataAndEvents) {
              thingy.show(true);
              result.post("/KEY133?purchaseSn=" + value.purchaseSn).success(function(r) {
                if (1 == r.statusCode) {
                  view.alert({
                    template : "<div class='tc'>删除成功</div>",
                    okText : "确定"
                  }).then(function() {
                    self.goBack();
                  });
                } else {
                  view.alert({
                    template : "<div class='tc'>" + r.content + "</div>",
                    okText : "确定"
                  });
                }
              }).finally(function() {
                thingy.hide();
                $templateCache.put("purchaseListRefresh", true);
              });
            }
          }), true;
        };
      }
    }
    handler.show(scope);
  };
  /**
   * @return {undefined}
   */
  self.createNewOrder = function() {
    self.viewReplace();
    $state.go($state.current, {
      goodsSn : null,
      purchaseSn : null,
      timeStamp : UnitTools.getTimeStamp(),
      copyOrder : null
    }, {
      reload : true
    });
  };
  thingy.show();
  self.$watch("[KEY329.KEY282, KEY329.purchaseDepot, KEY329.purchaseAccount,KEY329.otherAccountItem]", function(SelectBasicData, BillHeadData) {
    if (SelectBasicData[0] && (UnitTools.isEmpty(BillHeadData[0]) || (BillHeadData[0] && (SelectBasicData[0].id != BillHeadData[0].id && BillHeadData[0].id > 0)))) {
      if (!UnitTools.isEmpty(self.KEY329.KEY282)){
        self.KEY329.KEY282.val = self.KEY329.KEY282.id;
        model.saveOrUpdateUserConfig(label + ".KEY282", JSON.stringify(self.KEY329.KEY282), 3).then(function(node) {
          self.KEY220.KEY282 = UnitTools.fnCheckGtoreQty(info.userConfigData, "configKey", label + ".KEY282");
          if (self.KEY220.KEY282) {
            UnitTools.union(self.KEY220.KEY282, node.object);
          } else {
            info.userConfigData.push(node.object);
          }
          /** @type {*} */
          self.KEY220.supplierValue = JSON.parse(node.object.configValue);
        }, function() {
          UnitTools.toastShow("服务器获取数据出现异常！");
        });
      }
    } else {
      if (SelectBasicData[1] && (UnitTools.isEmpty(BillHeadData[1]) || (BillHeadData[1] && (SelectBasicData[1].val != BillHeadData[1].val && BillHeadData[1].val > 0)))) {
        if (!UnitTools.isEmpty(self.KEY329.purchaseDepot)) {
          model.saveOrUpdateUserConfig(label + ".depot", JSON.stringify(self.KEY329.purchaseDepot), 3).then(function (node) {
            self.KEY220.depot = UnitTools.fnCheckGtoreQty(info.userConfigData, "configKey", label + ".depot");
            if (self.KEY220.depot) {
              UnitTools.union(self.KEY220.depot, node.object);
            } else {
              info.userConfigData.push(node.object);
            }
            /** @type {*} */
            self.KEY220.depotValue = JSON.parse(node.object.configValue);
          }, function () {
            UnitTools.toastShow("服务器获取数据出现异常！");
          });
        }
      } else {
        if (SelectBasicData[2] && (BillHeadData[2] && (SelectBasicData[2].val != BillHeadData[2].val && BillHeadData[2].val > 0))) {
          model.saveOrUpdateUserConfig(label + ".accountId", JSON.stringify(self.KEY329.purchaseAccount.val), 3).then(function(node) {
            self.KEY220.accountId = UnitTools.fnCheckGtoreQty(info.userConfigData, "configKey", label + ".accountId");
            if (self.KEY220.accountId) {
              UnitTools.union(self.KEY220.accountId, node.object);
            } else {
              info.userConfigData.push(node.object);
            }
            /** @type {*} */
            self.KEY220.accountIdValue = JSON.parse(node.object.configValue);
          }, function() {
            UnitTools.toastShow("服务器获取数据出现异常！");
          });
        } else {
          if (SelectBasicData[3]) {
            if (BillHeadData[3]) {
              if (SelectBasicData[3].id != BillHeadData[3].id) {
                if (SelectBasicData[3].id > 0) {
                  if (1 == self.selectedOtherAccountItem) {
                    /** @type {boolean} */
                    self.selectedOtherAccountItem = false;
                    model.saveOrUpdateUserConfig(label + ".otherAccountItem", JSON.stringify(self.KEY329.otherAccountItem.id), 3).then(function(node) {
                      self.KEY220.otherAccountItem = UnitTools.fnCheckGtoreQty(info.userConfigData, "configKey", label + ".otherAccountItem");
                      if (self.KEY220.otherAccountItem) {
                        UnitTools.union(self.KEY220.otherAccountItem, node.object);
                      } else {
                        info.userConfigData.push(node.object);
                      }
                      /** @type {*} */
                      self.KEY220.accountIdValue = JSON.parse(node.object.configValue);
                    }, function() {
                      UnitTools.toastShow("服务器获取数据出现异常！");
                    });
                  }
                }
              }
            }
          }
        }
      }
    }
  }, true);
  self.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      self.totalDept = packs[0].data;
      /** @type {Array} */
      self.allDept = [];
      /** @type {number} */
      var i = 0;
      for (;i < packs[0].data.length;i++) {
        if ("1" == packs[0].data[i].status) {
          self.allDept.push(packs[0].data[i]);
        }
      }
      if (self.allSizes = packs[1].data.rows, self.allColors = packs[2].data.rows, self.allAccounts = packs[3].data.rows, self.KEY220 = {}, self.KEY220.KEY282 = UnitTools.fnCheckGtoreQty(self.userConfigData, "configKey", label + ".KEY282"), self.KEY220.KEY282 && (self.KEY220.KEY282.configValue && (self.KEY220.supplierValue = JSON.parse(self.KEY220.KEY282.configValue))),
      self.KEY220.depot = UnitTools.fnCheckGtoreQty(self.userConfigData, "configKey", label + ".depot"), self.KEY220.depot && (self.KEY220.depot.configValue && (self.KEY220.depotValue = JSON.parse(self.KEY220.depot.configValue))), self.KEY220.accountId = UnitTools.fnCheckGtoreQty(self.userConfigData, "configKey", label + ".accountId"), self.KEY220.accountId && (self.KEY220.accountId.configValue &&
      (self.KEY220.accountIdValue = JSON.parse(self.KEY220.accountId.configValue))), self.KEY220.otherAccountItem = UnitTools.fnCheckGtoreQty(self.userConfigData, "configKey", label + ".otherAccountItem"), self.KEY220.otherAccountItem && (self.KEY220.otherAccountItem.configValue && (self.KEY220.otherAccountItemValue = JSON.parse(self.KEY220.otherAccountItem.configValue))), null != input.goodsId ?
      self.searchGoodsById(input.goodsId) : self.searchGoods(), name) {
        /** @type {string} */
        var _ = "";
        switch(self._itemType) {
          case 1:
            /** @type {string} */
            _ = "/KEY129?purchaseSn=";
            break;
          case 2:
            /** @type {string} */
            _ = "/KEY130?purchaseSn=";
        }
        result.post(_ + name).success(function(event) {
          UnitTools.union(value, event.order);
          self.state = event.order.state;
          self.KEY329.remark = event.order.remark;
          self.KEY329.purchaseSn = event.order.purchaseSn;
          self.KEY329.handlerName = event.order.handlerName;
          self.KEY329.businessTime = null == event.order.businessTime ? UnitTools.getTimeStamp() : event.order.businessTime;
          self.KEY329.alreadyPaid = event.order.alreadyPaid ? event.order.alreadyPaid : 0;
          self.KEY329.KEY282.id = event.order.supplierId;
          self.KEY329.KEY282.text = event.order.supplierName;
          self.KEY329.KEY282.discount = event.order.supplierDiscount;
          self.KEY329.wholeOrderDiscount = event.order.discount;
          self.KEY329.otherAccountItem.id = event.order.otherAccountItem;
          self.KEY329.otherAccountItem.name = event.order.otherAccountItemName;
          self.KEY329.otherCost = event.order.otherCost;
          self.KEY329.wipeZero = event.order.wipeZero;
          /** @type {number} */
          var i = 0;
          var ilen = self.totalDept.length;
          for (;ilen > i;i++) {
            if (event.order.depotId == self.totalDept[i].val) {
              self.KEY329.purchaseDepot = self.totalDept[i];
              break;
            }
          }
          /** @type {number} */
          i = 0;
          ilen = self.allAccounts.length;
          for (;ilen > i;i++) {
            if (event.order.accountId == self.allAccounts[i].id) {
              self.KEY329.purchaseAccount = self.allAccounts[i];
              break;
            }
          }
          if (null == self.KEY329.purchaseDepot) {
            var props = {
              text : event.order.depotName,
              id : event.order.depotId
            };
            self.KEY329.purchaseDepot = props;
            /** @type {boolean} */
            self.inComstore = false;
          }
          if (null == self.KEY329.purchaseAccount) {
            var obj = {
              name : event.order.accountName,
              id : event.order.accountId
            };
            self.KEY329.purchaseAccount = obj;
            /** @type {boolean} */
            self.inComstore = false;
          }
          self.querySupplierBanlance(event.order.supplierId);
          event.orderGoods.forEach(function(i) {
            /** @type {boolean} */
            var r = false;
            /** @type {number} */
            var unlock = 0;
            var cnl = self.KEY329.goodsGroup.length;
            for (;cnl > unlock;unlock++) {
              var l = self.KEY329.goodsGroup[unlock].goodsSn;
              if (i.goodsSn == l) {
                /** @type {boolean} */
                r = true;
                self.KEY329.goodsGroup[unlock].goods.push(UnitTools.getPropertyObj(i, ["colorId", "sizeId", "colorName", "sizeName", "quantity", "price", "discount", "unit", "truePrice","standard","waretype"]));
              }
            }
            if (!r) {
              var c = {};
              /** @type {Array} */
              c.goods = [];
              c.goods.push(UnitTools.getPropertyObj(i, ["colorId", "sizeId", "colorName", "sizeName", "quantity", "price", "discount", "unit", "truePrice","standard","waretype"]));
              c.goodName = i.goodName;
              c.goodsSn = i.goodsSn;
              c.barCode = i.barCode;//条码
              self.KEY329.goodsGroup.push(c);
            }
          });
          self.calcTotalAmount();
          if (!self.inComstore) {
            UnitTools.toastShow("您只有此单据的查看权限！");
          }
        }).finally(function() {
          thingy.hide();
        });
      } else {
        if (input.copyOrder) {
          self.copyOrder = input.copyOrder;
          self.KEY329.goodsGroup = self.copyOrder.goodsGroup;
          /** @type {number} */
          self.KEY329.businessTime = (new Date).getTime();
          self.KEY329.wholeOrderDiscount = self.copyOrder.order.discount;
          self.KEY329.otherAccountItem.id = self.copyOrder.order.otherAccountItem;
          self.KEY329.otherAccountItem.name = self.copyOrder.order.otherAccountItemName;
          self.KEY329.otherCost = self.copyOrder.order.otherCost;
          self.KEY329.wipeZero = self.copyOrder.order.wipeZero;
          self.KEY329.KEY282 = {
            id : self.copyOrder.order.supplierId,
            text : self.copyOrder.order.supplierName,
            discount : self.copyOrder.order.supplierDiscount
          };
          /** @type {number} */
          i = 0;
          /** @type {number} */
          var ilen = self.allDept.length;
          for (;ilen > i;i++) {
            if (self.copyOrder.order.depotId == self.allDept[i].val) {
              self.KEY329.purchaseDepot = self.allDept[i];
              break;
            }
          }
          if (null == self.KEY329.purchaseDepot) {
            UnitTools.toastShow("原草稿仓库已停用或没有其权限");
            //self.KEY329.purchaseDepot = self.allDept[0];
          }
          /** @type {number} */
          i = 0;
          ilen = self.allAccounts.length;
          for (;ilen > i;i++) {
            if (self.copyOrder.order.accountId == self.allAccounts[i].id) {
              self.KEY329.purchaseAccount = self.allAccounts[i];
              break;
            }
          }
          self.querySupplierBanlance(self.KEY329.KEY282.id);
          self.setTotalAmount();
          self.KEY329.alreadyPaid = self.copyOrder.order.alreadyPaid;
          thingy.hide();
        } else {
          //self.KEY329.purchaseDepot = self.allDept[0]; 初始读取第一仓库
          if (self.KEY220.supplierValue && (self.KEY220.supplierValue.val > 0 && result.post("/KEY185?id=" + self.KEY220.supplierValue.val).success(function(ioargs) {
            if (1 == ioargs.objSupplier.status) {
              self.KEY329.KEY282 = self.KEY220.supplierValue ? self.KEY220.supplierValue : self.KEY329.KEY282;
              self.querySupplierBanlance(self.KEY329.KEY282.id);
            }
          })), self.KEY220.depotValue) {
            /** @type {number} */
            i = 0;
            /** @type {number} */
            ilen = self.allDept.length;
            for (;ilen > i;i++) {
              if (self.KEY220.depotValue.val == self.allDept[i].id) {
                self.KEY329.purchaseDepot = self.allDept[i];
                break;
              }
            }
          }
          if (self.KEY329.purchaseAccount = self.allAccounts[0], self.KEY220.accountIdValue) {
            /** @type {number} */
            i = 0;
            ilen = self.allAccounts.length;
            for (;ilen > i;i++) {
              if (self.KEY220.accountIdValue == self.allAccounts[i].id) {
                self.KEY329.purchaseAccount = self.allAccounts[i];
                break;
              }
            }
          }
          /** @type {number} */
          self.KEY329.businessTime = (new Date).getTime();
          thingy.hide();
        }
      }
    }, function() {
      thingy.hide();
    });
  });
}]).controller("PurchaseSelectSupplierCtrl", ["$scope", "$timeout", "psisServices", "Tools", "lbScrollDelegate", "$state", "lruPersistCache", function($scope, send, newCanvas, auth, parent, $state, $templateCache) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.suppliers = [];
  /** @type {string} */
  $scope.searchKey = "";
  /** @type {string} */
  $scope.focused = "centered";
  /** @type {number} */
  var showDisable = 0;
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var moveTo = function(opt_attributes) {
    return newCanvas.postEncode("/KEY122", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var loaded = function() {
    /** @type {number} */
    showDisable = $state.includes("eventmenu.KEY219") || $state.includes("eventmenu.KEY106") ? 1 : 0;
    /** @type {number} */
    page = 1;
    moveTo({
      page : page,
      searchKey : $scope.searchKey,
      showDisable : showDisable,
      supplierNamePy : $scope.searchKey
    }).success(function(info) {
      $scope.suppliers = info.optionList;
      /** @type {boolean} */
      $scope.loadMoreBtn = info.currentPage < info.totalPage;
      if ($scope.suppliers.length > 0) {
        if ($scope.KEY329) {
          if (null == $scope.KEY329.purchaseSn) {
            /* 新单会读取第一个单位，，我们新单为空
            if (!$scope.KEY329.KEY282.id) {//如果是新单。单位为空时读入默认单位
              $scope.KEY329.KEY282.id = $scope.suppliers[0].id;
              $scope.KEY329.KEY282.text = $scope.suppliers[0].text;
              $scope.KEY329.KEY282.discount = $scope.suppliers[0].discount;
              $scope.querySupplierBanlance($scope.KEY329.KEY282.id);
            }*/
          }
        }
      }
    }).finally(function() {
      parent.scrollTop("purchaseSelectSupplierCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    moveTo({
      page : ++page,
      searchKey : $scope.searchKey,
      showDisable : showDisable,
      supplierNamePy : $scope.searchKey
    }).success(function(info) {
      $scope.suppliers = $scope.suppliers.concat(info.optionList);
      /** @type {boolean} */
      $scope.loadMoreBtn = info.currentPage < info.totalPage;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("purchaseSelectSupplierCtrlScroll");
    });
  };
  /**
   * @param {Object} p
   * @return {undefined}
   */
  var addFile = function(p) {
    send(function() {
      $scope.querySupplierBanlance(p.id);
      var type = p.discount;
      var unlock;
      for (unlock in $scope.KEY329.goodsGroup) {
        var dataName;
        for (dataName in $scope.KEY329.goodsGroup[unlock].goods) {
          var data = $scope.KEY329.goodsGroup[unlock].goods[dataName];
          data.discount = type;
          data.truePrice = $scope.calcDetailTruePrice(data.price, data.discount);
        }
      }
      if (!auth.isEmpty($scope.selectedGood)) {
        $scope.selectedGood.discount = type;
        $scope.setTotalAmount();
      }
      /** @type {Object} */
      $scope.KEY329.KEY282 = p;
    });
    $scope.supplierModal.hide();
  };
  /**
   * @param {Object} item
   * @return {undefined}
   */
  var fn = function(item) {
    $scope.queryCondition.supplierId = item.id;
    $scope.listQuerySupplier.text = item.text;
    $scope.supplierModal.hide();
  };
  /**
   * @param {?} d
   * @return {undefined}
   */
  var objectToString = function(d) {
    $scope.initDebtObject.KEY282 = d;
    $scope.supplierModal.hide();
  };
  /**
   * @param {?} data
   * @return {undefined}
   */
  var success = function(data) {
    $scope.searchModel.KEY282 = data;
    $scope.supplierModal.hide();
  };
  /**
   * @param {Object} data
   * @return {undefined}
   */
  var execute = function(data) {
    $scope.record.KEY282.text = data.text;
    $scope.record.KEY282.id = data.id;
    $scope.supplierModal.hide();
  };
  /**
   * @return {undefined}
   */
  $scope.searchSupplier = function() {
    loaded();
  };
  var throttledUpdate = ionic.debounce($scope.searchSupplier, 500);
  /**
   * @return {undefined}
   */
  $scope.searchSupplierByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  $scope.focusSearchInput = function() {
    document.getElementById("searchSupplierInput").focus();
  };
  /**
   * @return {undefined}
   */
  $scope.clearSearch = function() {
    /** @type {string} */
    $scope.searchKey = "";
    /** @type {string} */
    $scope.focused = "centered";
    $scope.searchSupplier();
  };
  /**
   * @param {Object} d
   * @return {undefined}
   */
  $scope.KEY184 = function(d) {
    if ($state.includes("eventmenu.KEY219") || $state.includes("eventmenu.KEY106")) {
      addFile(d);
    } else {
      if ($state.includes("eventmenu.KEY220") || $state.includes("eventmenu.KEY107")) {
        fn(d);
      } else {
        if ($state.includes("eventmenu.KEY255")) {
          objectToString(d);
        } else {
          if ($state.includes("eventmenu.KEY084")) {
            execute(d);
          } else {
            success(d);
          }
        }
      }
    }
  };
  $scope.$on("modal.hidden", function() {
    auth.keyboardHide();
  });
  /**
   * @return {undefined}
   */
  $scope.addSupplier = function() {
    $scope.supplierModal.hide();
    if ($scope.purchaseListQueryModal) {
      $scope.purchaseListQueryModal.hide();
    }
    $templateCache.put("needToAddSupplierFlag", true);
    send(function() {
      var params = {};
      if ($scope.searchKey) {
        if ("" != $scope.searchKey) {
          params = {
            name : $scope.searchKey
          };
        }
      }
      $state.go("eventmenu.KEY208", params);
    });
  };
  if ($state.includes("eventmenu.KEY219") || $state.includes("eventmenu.KEY106")) {
    /**
     * @param {Object} a
     * @return {undefined}
     */
    $scope.KEY329.KEY184 = function(a) {
      $scope.KEY184(a);
      /** @type {number} */
      page = 1;
      loaded({
        page : page
      });
    };
  }
  loaded({
    page : page
  });
}]);
