angular.module("retailController", ["ionic"]).controller("RetailListCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "$ionicModal", "$ionicPopover", "$cordovaDatePicker", "Tools", "lruPersistCache", "lbSpinnerDialog", "BTScanerService", function($scope, $state, User, parent, $modal, FB, scope, dataAndEvents, $templateCache, loading, $cookieStore) {
  var character;
  var chr;
  if ($scope.commonConfig) {
    var n = $scope.commonConfig.orderListDays;
    if (n) {
      character = (new Date).setDate((new Date).getDate() - n);
      /** @type {number} */
      chr = (new Date).getTime();
    }
  }
  $scope.search = {};
  $scope.search.createTimeBegin = character ? character : "";
  /** @type {(number|string)} */
  $scope.search.createTimeEnd = chr ? chr : "";
  $scope.isUserAccAvailable = $scope.GetOperatorEventLimit("KEY211");
  $scope.queryCondition = {
    page : 1,
    state : 2
  };
  /** @type {boolean} */
  $scope.isLoading = true;
  /**
   * @return {?}
   */
  var Step = function() {
    return User.postEncode("/KEY150", $scope.queryCondition);
  };
  $modal.fromTemplateUrl("retailListQuery.html", function($location) {
    $scope.retailListQueryModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY092.html", function($location) {
    $scope.salerModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.salerModalOpen = function(expectedNumberOfNonCommentArgs) {
    $scope.salerModal.show(expectedNumberOfNonCommentArgs).then(function() {
      dataAndEvents.keyboardShow();
    });
  };
  FB.fromTemplateUrl("salerPopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.salerPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openSalerPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.salerPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideSalerPopover = function() {
    $scope.salerPopover.hide();
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
    User.httpCacheGet.get(User.httpCacheGet.ac.COMPANYUSERBYCASHIER).success(function(column) {
      $scope.allSaler = column.optionList;
    });
  });
  $scope.$on("$destroy", function() {
    $scope.retailListQueryModal.remove();
    $scope.salerPopover.remove();
    $scope.salerModal.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : $scope.search.createTimeBegin ? new Date($scope.search.createTimeBegin) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.search.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : $scope.search.createTimeEnd ? new Date($scope.search.createTimeEnd) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.search.createTimeEnd = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    /** @type {number} */
    $scope.queryCondition.page = 1;
    if ($scope.search.createTimeBegin) {
      $scope.queryCondition.createTimeBegin = dataAndEvents.transferGMTStringtoBJTime(dataAndEvents.getDayBeginStr($scope.search.createTimeBegin));
    } else {
      delete $scope.queryCondition.createTimeBegin;
    }
    if ($scope.search.createTimeEnd) {
      $scope.queryCondition.createTimeEnd = dataAndEvents.transferGMTStringtoBJTime(dataAndEvents.getOffsetDayBeginStr($scope.search.createTimeEnd, 1));
    } else {
      delete $scope.queryCondition.createTimeEnd;
    }
    if ($scope.search.saler && $scope.search.saler.val > 0) {
      $scope.queryCondition.salerId = $scope.search.saler.val;
    } else {
      delete $scope.queryCondition.salerId;
    }
    if (0 == $scope.queryCondition.state) {
      delete $scope.queryCondition.state;
    }
    loading.show();
    Step().success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      parent.scrollTop("retailListCtrlScroll");
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    Step().success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("retailListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.createNewOrder = function() {
    $state.go("eventmenu.KEY257", {
      timeStamp : dataAndEvents.getTimeStamp()
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step().success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("retailListRefresh")) {
      if ($templateCache.get("retailListRefresh") === true) {
        $scope.getList();
        $templateCache.put("retailListRefresh", false);
      }
    }
    $cookieStore.getScanerCode(function(fmt) {
      console.log(fmt);
    }, $scope.bluethoothScaner);
  });
  /**
   * @return {undefined}
   */
  $scope.clearQueryCondition = function() {
    /** @type {null} */
    $scope.search.createTimeBegin = null;
    /** @type {null} */
    $scope.search.createTimeEnd = null;
    $scope.search = {};
    delete $scope.queryCondition.ordersSn;
    delete $scope.queryCondition.salerId;
  };
}]).controller("RetailDetailCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "lbSpinnerDialog", "$ionicPopover", "$ionicPopup", "BluetoothPrintService", "$state", "lruPersistCache", "BTScanerService", function(self, element, $http, Y, loading, FB, _, UnitBluetoothPrint, ret, $templateCache, $document) {
  var className = element.ordersSn;
  self.isUserAccAvailable = self.GetOperatorEventLimit("KEY211");
  FB.fromTemplateUrl("KEY186.html", {
    scope : self
  }).then(function(theTitle) {
    self.orderOperationPopover = theTitle;
  });
  /**
   * @return {undefined}
   */
  self.createNewOrder = function() {
    self.viewReplace();
    ret.go("eventmenu.KEY257", {
      timeStamp : Y.getTimeStamp(),
      copyOrder : null
    });
  };
  /**
   * @return {undefined}
   */
  self.copyForOrder = function() {
    self.viewReplace();
    /** @type {string} */
    var rreturn = "eventmenu.KEY257";
    self.copyOrder = {
      order : self.orderDetail.order,
      goodsGroup : self.goodsGroup
    };
    ret.go(rreturn, {
      timeStamp : Y.getTimeStamp(),
      copyOrder : self.copyOrder
    });
  };
  self.$on("$destroy", function() {
    self.orderOperationPopover.remove();
  });
  /**
   * @return {undefined}
   */
  self.destroyOrder = function() {
    var promise = _.confirm({
      template : "<div class='tc'>单据撤销将撤销相应的库存、账务，且撤销后不可恢复，是否确认撤销该单据？</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show(true);
        $http.post("/KEY153?ordersSn=" + className).success(function(r) {
          if (1 === r.statusCode) {
            /** @type {boolean} */
            self.isDestroy = true;
            $templateCache.put("retailListRefresh", true);
            $templateCache.put("goodsStoredRecordListRefresh", true);
            $templateCache.put("clientDebtListRefresh", true);
            $templateCache.put("refreshClientRecord", true);
            $templateCache.put("accountFinanceRecordRefresh", true);
            Y.toastShow("撤销成功！");
          } else {
            Y.toastShow(r.content);
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.bluetoothPrint = function() {
    UnitBluetoothPrint.print(self.mainCompany.comName, className, UnitBluetoothPrint.orderType.retailOrder);
  };
  /**
   * @return {undefined}
   */
  self.bluetooth = function() {
    UnitBluetoothPrint.bluetooth(className, UnitBluetoothPrint.orderType.retailOrder);
  };
  loading.show();
  self.$on("$ionicView.beforeEnter", function() {
    $http.post("/KEY152?ordersSn=" + className).success(function(user) {
      self.orderDetail = user;
      /** @type {boolean} */
      self.isDestroy = 9 === self.orderDetail.order.state;
      self.retailRepay = Y.accSub(self.orderDetail.order.trueTotalAmount, Y.accSub(self.orderDetail.order.totalAmount, self.orderDetail.order.wipeZero ? self.orderDetail.order.wipeZero : 0));
      /** @type {Array} */
      self.goodsGroup = [];
      /** @type {number} */
      var drag = 0;
      user.orderGoods.forEach(function(options) {
        /** @type {boolean} */
        var a = false;
        /** @type {number} */
        var timeoutKey = 0;
        var cnl = self.goodsGroup.length;
        for (;cnl > timeoutKey;timeoutKey++) {
          var play = self.goodsGroup[timeoutKey].goodsSn;
          if (options.goodsSn == play) {
            /** @type {boolean} */
            a = true;
            self.goodsGroup[timeoutKey].goods.push(Y.getPropertyObj(options, ["colorId", "sizeId", "colorName", "sizeName", "quantity", "price", "discount", "unit", "truePrice","standard","waretype"]));
          }
        }
        if (!a) {
          var reporter = {};
          /** @type {Array} */
          reporter.goods = [];
          reporter.goods.push(Y.getPropertyObj(options, ["colorId", "sizeId", "colorName", "sizeName", "quantity", "price", "discount", "unit", "truePrice","standard","waretype"]));
          reporter.goodName = options.goodName;
          reporter.goodsSn = options.goodsSn;
          reporter.barCode = options.barCode;//条码
          self.goodsGroup.push(reporter);
        }
        drag = Y.accAdd(drag, options.quantity);
      });
      self.totalQuantity = drag;
    }).finally(function() {
      loading.hide();
    });
    $document.getScanerCode(function(fmt) {
      console.log(fmt);
    }, self.bluethoothScaner);
  });
}]).controller("RetailEditCtrl", ["$scope", "$stateParams", "$q", "$ionicModal", "$ionicPopup", "$state", "lbSpinnerDialog", "psisServices", "Tools", "$ionicPopover", "$ionicSideMenuDelegate", "lbScrollDelegate", "commonDataInterface", "BluetoothPrintService", "$ionicPlatform", "lruPersistCache", "$timeout", "ServerConfig", "BTScanerService", "VaApplyItem", "$ionicLoading", function($scope, $routeParams, $q, $modal, view, $state, loading, field,
UnitTools, FB, ignoreMethodDoesntExist, that, res, jsPDFAPI, dataAndEvents, $templateCache, done, obj, $cookieStore, deepDataAndEvents, parent) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = field.httpCacheGet.get(field.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
    var getPromise3 = field.httpCacheGet.get(field.httpCacheGet.ac.ALLSIZELIST);
    var c = field.httpCacheGet.get(field.httpCacheGet.ac.ALLCOLORLIST);
    var d = field.httpCacheGet.get(field.httpCacheGet.ac.ALLACCOUNTBYCOMSTORE);
    var projectName = field.httpCacheGet.get(field.httpCacheGet.ac.COMPANYUSERBYCASHIER);
    return $q.all([request1, getPromise3, c, d, projectName]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @param {string} className
   * @param {number} index
   * @return {undefined}
   */
  function animate(className, index) {
    var newDuration = document.getElementsByClassName(className)[index].offsetTop;
    that.scrollTo("scanGoodListScroll", 0, newDuration);
  }
  $scope.retailOrder = {
    goodsGroup : [],
    showDelete : false,
    trueTotalAmount : 0,
    wipeZero : 0
  };
  $scope.selectedGood = {};
  /** @type {number} */
  $scope.totalAmount = 0;
  /** @type {number} */
  $scope.totalQuantity = 0;
  /** @type {number} */
  $scope.state = 0;
  /** @type {boolean} */
  $scope.isOpenScroll = true;
  /** @type {number} */
  var b = 0;
  /** @type {boolean} */
  $scope.notModifySalerAvailable = !$scope.GetOperatorEventLimit("KEY199");
  $scope.saleNegativeStore = obj.companyConfigData.saleNegativeStore ? obj.companyConfigData.saleNegativeStore : 1;
  /**
   * @return {?}
   */
  $scope.isGoodsGroupNull = function() {
    return UnitTools.isEmpty($scope.retailOrder.goodsGroup);
  };
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY147.html", function($location) {
    $scope.selectedGoodListModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.openSelectedGoodModal = function() {
    if (!($scope.selectedGoodModal && $scope.selectedGoodModal.isShown())) {
      $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY093.html", {
        scope : $scope,
        animation : "slide-in-up"
      }).then(function($location) {
        $scope.selectedGoodModal = $location;
        $scope.selectedGoodModal.show();
        done(function() {
          that.resize("selectGoodForOrderMulScroll");
        });
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.closeSelectedGoodModal = function() {
    $scope.selectedGoodModal.hide();
    $scope.selectedGoodModal.remove();
  };
  $modal.fromTemplateUrl("scanPay.html", function($location) {
    /** @type {number} */
    $scope.scanPayModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @param {Object} event
   * @return {undefined}
   */
  $scope.gobackToListAction = function(event) {
    if (event && (event.stopPropagation() && event.preventDefault()), "eventmenu.KEY257" == $state.current.name) {
      if (0 !== $scope.state || $scope.isGoodsGroupNull()) {
        (iterator || angular.noop)();
        $scope.goBack();
      } else {
        var promise = view.confirm({
          template : "<div class='tc'>确认要退出开单?</div>",
          cancelText : "取消",
          okText : "继续退出"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            (iterator || angular.noop)();
            $scope.goBack();
          }
        });
      }
    } else {
      (iterator || angular.noop)();
      $scope.goBack();
    }
  };
  var iterator = dataAndEvents.registerBackButtonAction(function() {
    return $scope.gobackToListAction(), false;
  }, 140);
  $scope.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("needToAddGoodsFlag") === true) {
      $templateCache.put("needToAddGoodsFlag", false);
      /**
       * @return {undefined}
       */
      var put = function() {
        if ($templateCache.get("addGoodsFlag") === true) {
          $templateCache.put("addGoodsFlag", false);
          var p = $templateCache.get("newGoodsObj");
          if (p) {
            if (p.id) {
              $scope.searchGoodsById(p.id);
              UnitTools.toastShow("成功添加 " + p.name);
              $templateCache.put("newGoodsObj", null);
            }
          }
        }
      };
      $templateCache.put("refreshGoodColorFlag", false);
      $templateCache.put("refreshGoodSizeFlag", false);
      res.getAllColorSize().then(function(packs) {
        if (null != packs) {
          $scope.allColors = packs[0].data.rows;
          $scope.allSizes = packs[1].data.rows;
        }
        put();
      }, function() {
        put();
      });
    }
  });
  $scope.isUserAccAvailable = $scope.GetOperatorEventLimit("KEY211");
  /** @type {string} */
  $scope.goodSelectSource = "retail";
  $modal.fromTemplateUrl($scope.platformIsPad ? "html/PRetailAndSellBill/KEY036.html" : "html/PRetailAndSellBill/KEY204.html", function($location) {
    $scope.modal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.storehousePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideStorehousePopover = function() {
    $scope.storehousePopover.hide();
    /** @type {number} */
    $scope.isShowInvalidStoreMsg = 0;
  };
  FB.fromTemplateUrl("KEY190.html", {
    scope : $scope
  }).then(function($location) {
    $scope.KEY190 = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openAccountPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.KEY190.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideAccountPopover = function() {
    $scope.KEY190.hide();
  };
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY092.html", function($location) {
    $scope.salerModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.salerModalOpen = function(expectedNumberOfNonCommentArgs) {
    $scope.salerModal.show(expectedNumberOfNonCommentArgs).then(function() {
      UnitTools.keyboardShow();
    });
  };
  FB.fromTemplateUrl("salerPopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.salerPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openSalerPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.salerPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideSalerPopover = function() {
    $scope.salerPopover.hide();
  };
  $scope.$on("$destroy", function() {
    $scope.modal.remove();
    $scope.storehousePopover.remove();
    $scope.salerModal.remove();
    $scope.KEY190.remove();
    $scope.retailSettleModal.remove();
    if ($scope.selectedGoodModal) {
      $scope.selectedGoodModal.remove();
    }
    $scope.selectedGoodListModal.remove();
    if ($scope.scanCodeListModal) {
      $scope.scanCodeListModal.remove();
    }
    $scope.scanPayModal.remove();
    if ($scope.salerPopover) {
      $scope.salerPopover.remove();
    }
  });
  /**
   * @param {?} a
   * @return {?}
   */
  $scope.calcTotalAmount = function(a) {
    /** @type {number} */
    var unknown = 0;
    /** @type {number} */
    var comment = 0;
    /** @type {number} */
    var unlock = 0;
    var cnl = $scope.retailOrder.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      /** @type {number} */
      var control = 0;
      var spaces = $scope.retailOrder.goodsGroup[unlock].goods.length;
      for (;spaces > control;control++) {
        var options = $scope.retailOrder.goodsGroup[unlock].goods[control];
        if (options.truePrice || 0 === options.truePrice) {
          if (options.quantity) {
            /** @type {number} */
            options.isEnoughStore = options.quantity <= options.storeNumber ? 1 : 0;
            if (a) {
              options.truePrice = $scope.calcDetailTruePrice(options.price, a);
            }
            unknown = UnitTools.accAdd(unknown, UnitTools.accMul(options.truePrice, options.quantity));
            comment = UnitTools.accAdd(comment, options.quantity);
          }
        }
      }
    }
    return $scope.totalAmount = unknown, $scope.totalQuantity = comment, unknown;
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  $scope.setWipeZero = function(event) {
    if (event) {
      event.stopPropagation();
    }
    var v = $scope.retailOrder.wipeZero;
    /** @type {number} */
    var version = parseFloat(v > 0 ? v : UnitTools.accSub($scope.totalAmount, parseInt($scope.totalAmount)));
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt("请输入抹零金额", function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            if (1 == UnitTools.isNumber(res.input1) && res.input1 >= 0) {
              $scope.retailOrder.wipeZero = $scope.fixedInputNumber(res.input1);
              $scope.getTrueTotalAmount();
            } else {
              $scope.retailOrder.wipeZero = v;
            }
          });
        }
      }, "抹零", ["取消", "确认"], version.toString());
    } else {
      /** @type {number} */
      $scope.retailOrder.wipeZero = version;
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="retailOrder.wipeZero" autofocus="true" placeholder="0.00">',
        title : "请输入抹零金额",
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.retailOrder.wipeZero = $scope.fixedInputNumber($scope.retailOrder.wipeZero);
            $scope.getTrueTotalAmount();
          }
        }]
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.attachToWipe = function() {
    $scope.retailOrder.wipeZero = UnitTools.accSub($scope.calcTotalAmount(), $scope.retailOrder.trueTotalAmount ? $scope.retailOrder.trueTotalAmount : 0);
  };
  /**
   * @return {undefined}
   */
  $scope.getTrueTotalAmount = function() {
    /** @type {number} */
    var version = parseFloat(UnitTools.accSub($scope.totalAmount, $scope.retailOrder.wipeZero ? $scope.retailOrder.wipeZero : 0));
    if (0 > version) {
      UnitTools.toastShow("抹零金额大于应收金额");
      /** @type {string} */
      $scope.retailOrder.wipeZero = "";
    } else {
      /** @type {number} */
      $scope.retailOrder.trueTotalAmount = version;
    }
  };
  /**
   * @return {?}
   */
  $scope.retailRepay = function() {
    return UnitTools.accSub($scope.retailOrder.trueTotalAmount ? $scope.retailOrder.trueTotalAmount : 0, UnitTools.accSub($scope.calcTotalAmount(), $scope.retailOrder.wipeZero ? $scope.retailOrder.wipeZero : 0));
  };
  /**
   * @param {number} actualObject
   * @return {undefined}
   */
  $scope.setTrueTotalAmount = function(actualObject) {
    /** @type {number} */
    var object = actualObject;
    /** @type {string} */
    var x = "请输入收款金额";
    /** @type {string} */
    var address = "应收金额 " + $scope.totalAmount;
    if ($scope.retailOrder.wipeZero > 0) {
      address += " , 抹零 " + $scope.retailOrder.wipeZero;
    }
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            $scope.retailOrder.trueTotalAmount = UnitTools.isNumber(res.input1) && res.input1 >= 0 ? $scope.fixedInputNumber(res.input1) : object;
          });
        }
      }, address, ["取消", "确认"], object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="retailOrder.trueTotalAmount" autofocus="true" placeholder="0.00">',
        title : address,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.retailOrder.trueTotalAmount = $scope.fixedInputNumber($scope.retailOrder.trueTotalAmount);
          }
        }]
      });
    }
  };
  /**
   * @param {string} header
   * @param {string} funcToCall
   * @return {undefined}
   */
  $scope.toggleDetailInput = function(header, funcToCall) {
    /** @type {(null|string)} */
    $scope.shownDetailInput = $scope.isDetailInputShown(header, funcToCall) ? null : header + "-" + funcToCall;
  };
  /**
   * @param {string} value
   * @param {string} funcToCall
   * @return {?}
   */
  $scope.isDetailInputShown = function(value, funcToCall) {
    return $scope.shownDetailInput === value + "-" + funcToCall;
  };
  /**
   * @param {(Object|string)} dataAndEvents
   * @param {string} last
   * @return {undefined}
   */
  $scope.deletePurchaseGoods = function(dataAndEvents, last) {
    /** @type {number} */
    var otherwiseLineIndex = 0;
    var cnl = $scope.retailOrder.goodsGroup.length;
    for (;cnl > otherwiseLineIndex;otherwiseLineIndex++) {
      if (dataAndEvents == $scope.retailOrder.goodsGroup[otherwiseLineIndex].goodsSn) {
        var i;
        for (i in $scope.retailOrder.goodsGroup[otherwiseLineIndex].goods) {
          if (i == last) {
            $scope.retailOrder.goodsGroup[otherwiseLineIndex].goods.splice(i, 1);
            break;
          }
        }
        if (0 === $scope.retailOrder.goodsGroup[otherwiseLineIndex].goods.length) {
          $scope.retailOrder.goodsGroup.splice(otherwiseLineIndex, 1);
          break;
        }
      }
    }
    if ($scope.isGoodsGroupNull()) {
      /** @type {boolean} */
      $scope.retailOrder.showDelete = false;
    }
    $scope.calcTotalAmount();
    if (!$scope.platformIsPad) {
      $scope.selectedGood.good = {};
    }
  };
  /**
   * @param {?} event
   * @param {(Object|string)} deepDataAndEvents
   * @param {string} ignoreMethodDoesntExist
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  $scope.openRetailBatchModifyModal = function(event, deepDataAndEvents, ignoreMethodDoesntExist, dataAndEvents) {
    if (event) {
      event.stopPropagation();
    }
    $scope.retailOrder.modifyPrice = dataAndEvents;
    /** @type {number} */
    $scope.retailOrder.modifyDiscount = 100;
    /** @type {string} */
    var MSG_CLOSURE_CUSTOM_COLOR_BUTTON = ignoreMethodDoesntExist + "(" + deepDataAndEvents + ")";
    view.show({
      cssClass : "lb-KEY291-popup",
      templateUrl : "retailBatchModifyModal.html",
      title : MSG_CLOSURE_CUSTOM_COLOR_BUTTON,
      scope : $scope,
      buttons : [{
        text : "取消"
      }, {
        text : "确认",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          $scope.retailBatchModify(deepDataAndEvents);
        }
      }]
    });
  };
  /**
   * @param {(Object|string)} deepDataAndEvents
   * @return {undefined}
   */
  $scope.retailBatchModify = function(deepDataAndEvents) {
    /** @type {number} */
    var unlock = 0;
    var cnl = $scope.retailOrder.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      if (deepDataAndEvents == $scope.retailOrder.goodsGroup[unlock].goodsSn) {
        var fingerprint;
        for (fingerprint in $scope.retailOrder.goodsGroup[unlock].goods) {
          var timeZoneList = $scope.retailOrder.goodsGroup[unlock].goods[fingerprint];
          timeZoneList.truePrice = $scope.retailModify();
        }
      }
    }
    $scope.calcTotalAmount();
  };
  /**
   * @return {?}
   */
  $scope.retailModify = function() {
    var attempted = $scope.retailOrder.modifyPrice ? $scope.retailOrder.modifyPrice : 0;
    var desiredValue = $scope.retailOrder.modifyDiscount ? $scope.retailOrder.modifyDiscount : 0;
    return $scope.calcDetailTruePrice($scope.fixedInputNumber(attempted), $scope.fixedInputNumber(desiredValue));
  };
  /**
   * @return {undefined}
   */
  $scope.changePrice = function() {
    var context = $scope.retailOrder.goodsGroup;
    if (!UnitTools.isEmpty(context)) {
      /** @type {number} */
      var i = 0;
      var j = context.length;
      for (;j > i;i++) {
        var classNames = context[i].goods;
        if ($scope.selectedGood.good.goodsSn == context[i].goodsSn) {
          /** @type {number} */
          var c = 0;
          var cnl = classNames.length;
          for (;cnl > c;c++) {
            classNames[c].truePrice = $scope.selectedGood.good.retailPriceArea;
          }
          break;
        }
      }
    }
    $scope.setTotalAmount();
  };
  /**
   * @param {Function} $attr
   * @param {?} event
   * @return {undefined}
   */
  $scope.retailOrder.openPriceEditPopup = function($attr, event) {
    if (event) {
      event.stopPropagation();
    }
    /** @type {string} */
    var MSG_CLOSURE_CUSTOM_COLOR_BUTTON = $attr.name + "(" + $attr.goodsSn + ")";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt("请输入零售价", function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            if (1 == UnitTools.isNumber(res.input1)) {
              if (res.input1 >= 0) {
                $attr.retailPriceArea = $scope.fixedInputNumber(res.input1);
                $scope.changePrice();
              }
            }
          });
        }
      }, "临时改价", ["取消", "确认"], 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="selectedGood.good.retailPriceArea" autofocus="true" placeholder="请输入零售价">',
        title : MSG_CLOSURE_CUSTOM_COLOR_BUTTON,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $attr.retailPriceArea = $scope.fixedInputNumber($attr.retailPriceArea);
            $scope.changePrice();
          }
        }]
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.getWholeOrderDiscount = function() {
    var wholeOrderDiscount = $scope.retailOrder.wholeOrderDiscount;
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt("请输入折扣（%）", function(res) {
        if (2 == res.buttonIndex) {
          $scope.$apply(function() {
            if (1 == UnitTools.isNumber(res.input1) && res.input1 >= 0) {
              $scope.retailOrder.wholeOrderDiscount = $scope.fixedInputNumber(res.input1);
              $scope.calcTotalAmount($scope.retailOrder.wholeOrderDiscount);
            } else {
              $scope.retailOrder.wholeOrderDiscount = wholeOrderDiscount;
            }
          });
        }
      }, "整单折扣", ["取消", "打折"], 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" ng-blur="retailOrder.wholeOrderDiscount=fixedInputNumber(retailOrder.wholeOrderDiscount)" class="tc" ng-model="retailOrder.wholeOrderDiscount" placeholder="" autofocus="true">',
        title : "整单折扣(%)",
        scope : $scope,
        buttons : [{
          text : "取消",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.retailOrder.wholeOrderDiscount = wholeOrderDiscount;
          }
        }, {
          text : "打折",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.retailOrder.wholeOrderDiscount = $scope.fixedInputNumber($scope.retailOrder.wholeOrderDiscount);
            if ($scope.retailOrder.wholeOrderDiscount <= 0) {
              $scope.retailOrder.wholeOrderDiscount = wholeOrderDiscount;
            } else {
              $scope.calcTotalAmount($scope.retailOrder.wholeOrderDiscount);
            }
          }
        }]
      });
    }
  };
  /**
   * @param {?} deepDataAndEvents
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  $scope.fixedInputNumber = function(deepDataAndEvents, dataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents, dataAndEvents);
  };
  /**
   * @param {?} el
   * @param {?} attributes
   * @return {?}
   */
  $scope.calcDetailTruePrice = function(el, attributes) {
    return el && attributes ? parseFloat(UnitTools.accDiv(UnitTools.accMul(el, attributes), 100).toFixed(2)) : 0;
  };
  /**
   * @param {boolean} version
   * @return {?}
   */
  $scope.dealInputNumber = function(version) {
    return version ? parseFloat(version) : 0;
  };
  /** @type {number} */
  var page = 1;
  $scope.selectedGood = {
    good : {},
    goodStore : {},
    quantity : 1
  };
  $scope.search = {
    goodKey : ""
  };
  /**
   * @return {undefined}
   */
  $scope.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(event) {
      console.log("We got a barcode\nResult: " + event.text + "\nFormat: " + event.format + "\nCancelled: " + event.cancelled);
      if (!event.cancelled) {
        $scope.$apply(function() {
          $scope.searchGoodsByBarCode(event.text);
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return field.postEncode("/KEY233", opt_attributes);
  };
  /**
   * @param {?} type
   * @return {undefined}
   */
  $scope.searchGoodsById = function(type) {
    if (null != type) {
      res.getGoodsById(type).then(function(dataAndEvents) {
        if (dataAndEvents) {
          /** @type {Array} */
          $scope.KEY288 = [];
          $scope.KEY288[0] = dataAndEvents;
          /** @type {boolean} */
          $scope.loadMoreBtn = false;
          $scope.KEY264($scope.KEY288[0]);
          $scope.search.goodKey = $scope.KEY288[0].goodsSn;
          $scope.openSelectedGoodModal();
        }
      }, function() {
        UnitTools.toastShow("获取商品信息失败");
      });
    }
  };
  /**
   * @param {string} object
   * @return {undefined}
   */
  $scope.searchGoodsByGoodsSn = function(object) {
    if (null != object) {
      res.getGoodsByGoodsSn(object).then(function(dataAndEvents) {
        if (dataAndEvents) {
          /** @type {Array} */
          $scope.KEY288 = [];
          $scope.KEY288[0] = dataAndEvents;
          /** @type {boolean} */
          $scope.loadMoreBtn = false;
          $scope.KEY264($scope.KEY288[0]);
          $scope.search.goodKey = $scope.KEY288[0].goodsSn;
          $scope.openSelectedGoodModal();
        } else {
          UnitTools.toastShow("找不到相关商品信息");
        }
      }, function() {
        UnitTools.toastShow("获取商品信息失败");
      });
    }
  };
  /**
   * @param {string} objects
   * @return {undefined}
   */
  $scope.searchGoodsByBarCode = function(objects) {
    if (objects) {
      res.getGoodsByBarCode(objects).then(function(data) {
        if ((data) && (data.id !== "")) {
          if ($scope.selectedGood.good != null && angular.isObject($scope.selectedGood.good) && $scope.selectedGood.good.goodsSn == data.goodsSn) {
            if ($scope.currentColors.length > 0) {
              if (data.skuCount && (1 === data.skuCount && data.skuColorId)) {
                /** @type {Array} */
                $scope.selectedGood.seletedColors = [];
                $scope.selectedGood.seletedColors[0] = UnitTools.fnCheckGtoreQty($scope.currentColors, "id", data.skuColorId);
              } else {
                /** @type {Array} */
                $scope.selectedGood.seletedColors = [];
                $scope.selectedGood.seletedColors[0] = $scope.currentColors[0];
              }
            } else {
              /** @type {Array} */
              $scope.selectedGood.seletedColors = [];
            }
            $scope.selectedGood.size = $scope.currentSizes.length > 0 ? data.skuCount && (1 === data.skuCount && data.skuSizeId) ? UnitTools.fnCheckGtoreQty($scope.currentSizes, "id", data.skuSizeId) : $scope.currentSizes[0] : void 0;
            $scope.addToGoodsGroup($scope.selectedGood.seletedColors, $scope.selectedGood.size, 1, true);
          } else {
            /** @type {Array} */
            $scope.KEY288 = [];
            $scope.KEY288[0] = data;
            /** @type {boolean} */
            $scope.loadMoreBtn = false;
            $scope.KEY264(data, true);
          }
          //$scope.openSelectedGoodModal();//这行会扫码成功后还弹出编辑数量框
        } else {
          UnitTools.toastShow("找不到 " + objects + " 的商品");
          view.alert({
            template : "<div class='tc'>"+"找不到" + objects + "的商品"+"</div>",
            okText : "确定"
          });
          navigator.notification.beep(1);
        }
      }, function() {
        UnitTools.toastShow("获取商品信息失败");
      });
    }
  };
  /**
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  $scope.searchGoods = function(dataAndEvents) {
    /** @type {number} */
    page = 1;
    createDom({
      page : page,
      searchKey : $scope.search.goodKey
    }).success(function(info) {
      $scope.KEY288 = info.optionList;
      /** @type {boolean} */
      $scope.loadMoreBtn = info.currentPage < info.totalPage;
      if (!dataAndEvents) {
        if ($scope.search.goodKey) {
          if (1 == $scope.KEY288.length) {
            if (window.cordova && (window.cordova.plugins && window.cordova.plugins.Keyboard)) {
              cordova.plugins.Keyboard.close();
              window.setTimeout(function() {
                $scope.KEY264($scope.KEY288[0]);
              }, 100);
            } else {
              $scope.KEY264($scope.KEY288[0]);
            }
            $scope.selectedGoodModal.show();
            UnitTools.keyboardHide();
          }
        }
      }
    }).finally(function() {
      that.scrollTop("saleGoodModalCtrlScroll");
    });
  };
  var HOP = ionic.debounce($scope.searchGoods, 500);
  /**
   * @param {?} walkers
   * @return {undefined}
   */
  $scope.searchGoodsByKeyword = function(walkers) {
    HOP(walkers);
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page,
      searchKey : $scope.search.goodKey
    }).success(function(info) {
      $scope.KEY288 = $scope.KEY288.concat(info.optionList);
      /** @type {boolean} */
      $scope.loadMoreBtn = info.currentPage < info.totalPage;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      that.resize("saleGoodModalCtrlScroll");
    });
  };
  /**
   * @param {Element} model
   * @param {?} spy
   * @return {?}
   */
  $scope.getGoodStoreNum = function(model, spy) {
    var ex = UnitTools.fnCheckGtoreQty($scope.selectedGood.goodStore, "serialNo", $scope.retailOrder.retailDepot.val + "-" + $scope.selectedGood.good.id + "-" + spy.id + "-" + model.id);
    if ($scope.selectedGood.selectedUnits[0].unitRate){
      var unitRate = $scope.selectedGood.selectedUnits[0].unitRate;
      return ex ? 0 == ex.number ? 0 : Math.floor(ex.number / unitRate).toFixed(1) : 0;
    } else {
      return ex ? 0 == ex.number ? 0 : ex.number : 0;
    }
  };
  /**
   * @param {string} data
   * @return {?}
   */
  $scope.getGoodsCount = function(data) {
    /** @type {number} */
    var count = 0;
    var queue = UnitTools.fnCheckGtoreQty($scope.retailOrder.goodsGroup, "goodsSn", data);
    if (queue) {
      var employees = queue.goods;
      /** @type {number} */
      var i = 0;
      var l = employees.length;
      for (;l > i;i++) {
        count += employees[i].quantity;
      }
    }
    return count ? count : "";
  };
  /**
   * @param {string} data
   * @return {?}
   */
  $scope.getGoodsSkuCount = function(data) {
    /** @type {number} */
    var m1 = 0;
    /** @type {number} */
    var c = 0;
    var queue = UnitTools.fnCheckGtoreQty($scope.retailOrder.goodsGroup, "goodsSn", data);
    if (queue) {
      var employees = queue.goods;
      m1 = employees.length;
      /** @type {number} */
      var i = 0;
      var l = employees.length;
      for (;l > i;i++) {
        c += employees[i].quantity;
      }
    }
    return m1 ? m1 + " 款 " + c + " 件" : "";
  };
  /**
   * @param {string} data
   * @return {?}
   */
  $scope.getGoodsAmount = function(data) {
    /** @type {number} */
    var cssValue = 0;
    var result = UnitTools.fnCheckGtoreQty($scope.retailOrder.goodsGroup, "goodsSn", data);
    if (result) {
      var context = result.goods;
      /** @type {number} */
      var k = 0;
      var j = context.length;
      for (;j > k;k++) {
        var v = context[k];
        if (v.truePrice || 0 === v.truePrice) {
          if (v.quantity) {
            cssValue = UnitTools.accAdd(cssValue, UnitTools.accMul(v.truePrice, v.quantity));
          }
        }
      }
    }
    return cssValue;
  };
  /**
   * @param {Element} model
   * @param {?} str
   * @return {?}
   */
  $scope.getStoreWarningCss = function(model, str) {
    if ($scope.selectedGood.good[model.id] && $scope.selectedGood.good[model.id][str.id]) {
      var id = $scope.selectedGood.good[model.id][str.id];
      var key = $scope.getGoodStoreNum(model, str);
      if (0 == key || id > key) {
        return "lb-select-goods-sku-store-warning";
      }
    }
    return "";
  };

  /**
   * 切换单位
   */
  $scope.selectUnit = function(unit) {
    var pos = $scope.selectedGood.selectedUnits.indexOf(unit);
    if (pos <= -1) {
      $scope.selectedGood.selectedUnits.splice(0, 1);
      $scope.selectedGood.selectedUnits.push(unit);
    }
  };


  /**
   * @param {?} results
   * @param {?} str
   * @param {number} dataAndEvents
   * @param {boolean} deepDataAndEvents
   * @return {?}
   */
  $scope.addToGoodsGroup = function(results, str, dataAndEvents, deepDataAndEvents,units,standard,waretype) {
    if (null != results && (0 != results.length && (null != str && !(deepDataAndEvents && (0 > dataAndEvents && $scope.selectedGood.good.numArray[results[0].id][str.id] <= 0))))) {
      /** @type {number} */
      var prevChunksLen = 0;
      /** @type {number} */
      var idx = 0;
      var i = $scope.retailOrder.goodsGroup.length;
      for (;i > idx;idx++) {
        prevChunksLen += $scope.retailOrder.goodsGroup[idx].goods.length;
      }
      var expectedOutput = $scope.selectedGood.good.goodsSn;

      //使用辅助单位的标志
      var useAidUnitFlag = false;
      if (units[0].unitId !== 0){
        useAidUnitFlag = true;
      }
      //从购物车中获取商品
      var params = UnitTools.fnCheckGtoreQty($scope.retailOrder.goodsGroup, "goodsSn", expectedOutput);
      if (params) {
        /** @type {number} */
        var d = 0;
        var l = results.length;
        for (;l > d;d++) {
          //根据颜色id,sizeId,unitId
          var p = UnitTools.getObjectByObjectMultUnit(params.goods, {
            colorId : results[d].id,
            sizeId : str.id,
            unitId : units[0].unitId
          });
          if (!p) {
            prevChunksLen++;
          }
        }
      } else {
        params = {
          goods : [],
          goodName : $scope.selectedGood.good.name,
          barCode : $scope.selectedGood.good.barCode,//条码
          goodsSn : expectedOutput,
          goodsNum : 0,
          imagine : $scope.selectedGood.good.imagine
        };
        $scope.retailOrder.goodsGroup.push(params);
        /** @type {number} */
        $scope.selectedGood.good.goodsNum = 0;
        prevChunksLen++;
      }
      if (prevChunksLen > $scope.limitNum) {
        /** @type {string} */
        var speed = "单据中的单品条数已超出" + $scope.limitNum + "条的限制！";
        return UnitTools.toastShow(speed, "short", "center"), false;
      }
      /** @type {number} */
      d = 0;
      l = results.length;
      for (;l > d;d++) {
        var item = {
          colorId : results[d].id,
          sizeId : str.id,
          colorName : results[d].name,
          sizeName : str.name,
          quantity : dataAndEvents,
          price : $scope.selectedGood.good.retailPriceArea,
          unit : units[0].unitName,
          unitId : units[0].unitId,
          truePrice : parseFloat($scope.selectedGood.good.retailPriceArea.toFixed(2)),
          storeNumber : $scope.getGoodStoreNum(results[d], str),
          standard : standard,
          waretype : waretype
        };

        //设置价格
        if (useAidUnitFlag){
          if (useAidUnitFlag){
            item.price = parseFloat(units[0].priceRetail.toFixed(2));//辅助单位中的价格
            item.truePrice = parseFloat(units[0].priceRetail.toFixed(2));//辅助单位中的价格
          }
        }
        if (str.name == "赠送") {//是否为赠送
          item.price = 0; //如果尺码是增送，单价设置为0
          item.truePrice = 0; //如果尺码是增送，折后单价设置为0
        }
        /** @type {Array} */
        var items = params.goods;
        /** @type {boolean} */
        var v = false;
        /** @type {number} */
        idx = 0;
        /** @type {number} */
        i = items.length;
        for (;i > idx;idx++) {
          var current = items[idx];
          if (current.colorId == item.colorId && current.sizeId == item.sizeId && current.unitId == item.unitId) {
            if (deepDataAndEvents) {
              if (current.quantity + item.quantity < 0) {
                return false;
              }
              current.quantity += item.quantity;
              if ($scope.currentUnits.length > 1){
                $scope.selectedGood.good.numArray[results[d].id][str.id][units[0].unitId] = current.quantity;
              }else {
                $scope.selectedGood.good.numArray[results[d].id][str.id] = current.quantity;
              }
              params.goodsNum += item.quantity;
            } else {
              /** @type {number} */
              params.goodsNum = params.goodsNum - current.quantity;
              current.quantity = item.quantity;
              if ($scope.currentUnits.length > 1){
                $scope.selectedGood.good.numArray[results[d].id][str.id][units[0].unitId] = current.quantity;
              } else {
                $scope.selectedGood.good.numArray[results[d].id][str.id] = current.quantity;
              }
              params.goodsNum += item.quantity;
            }
            if (0 == current.quantity) {
              params.goods.splice(idx, 1);
            }
            /** @type {boolean} */
            v = true;
            break;
          }
        }
        if (!v) {
          if (item.quantity > 0) {
            params.goodsNum += item.quantity;
            //更新存储二维/三维数组中数量
            if ($scope.currentUnits.length > 1){
              $scope.selectedGood.good.numArray[results[d].id][str.id][units[0].unitId] = item.quantity;
            } else {
              $scope.selectedGood.good.numArray[results[d].id][str.id] = item.quantity;
            }
            params.goods.push(item);
          }
        }
      }
      if (0 == params.goods.length) {
        UnitTools.removeByKey($scope.retailOrder.goodsGroup, "goodsSn", expectedOutput);
      }
      $scope.selectedGood.good.goodsNum = params.goodsNum;
      $scope.setTotalAmount();
    }
  };
  /**
   * @param {Array} results
   * @param {number} dataAndEvents
   * @param {boolean} deepDataAndEvents
   * @return {?}
   */
  $scope.addToGoodsGroupBatch = function(results, dataAndEvents, deepDataAndEvents) {
    if (null != results && (0 != results.length && !(deepDataAndEvents && (0 > dataAndEvents && $scope.selectedGood.good.batchNumArray[results[0].id] <= 0)))) {
      /** @type {number} */
      var prevChunksLen = 0;
      /** @type {number} */
      var idx = 0;
      var i = $scope.retailOrder.goodsGroup.length;
      for (;i > idx;idx++) {
        prevChunksLen += $scope.retailOrder.goodsGroup[idx].goods.length;
      }
      var expectedOutput = $scope.selectedGood.good.goodsSn;
      var params = UnitTools.fnCheckGtoreQty($scope.retailOrder.goodsGroup, "goodsSn", expectedOutput);
      if (params) {
        /** @type {number} */
        var d = 0;
        var l = results.length;
        for (;l > d;d++) {
          /** @type {number} */
          idx = 0;
          i = $scope.currentSizes.length;
          for (;i > idx;idx++) {
            var g = UnitTools.getObjectByObject(params.goods, {
              colorId : results[d].id,
              sizeId : $scope.currentSizes[idx].id
            });
            if (!g) {
              prevChunksLen++;
            }
          }
        }
      } else {
        params = {
          goods : [],
          goodName : $scope.selectedGood.good.name,
          barCode : $scope.selectedGood.good.barCode,//条码
          goodsSn : expectedOutput,
          goodsNum : 0,
          imagine : $scope.selectedGood.good.imagine
        };
        $scope.retailOrder.goodsGroup.push(params);
        /** @type {number} */
        $scope.selectedGood.good.goodsNum = 0;
        prevChunksLen += $scope.currentSizes.length;
      }
      if (prevChunksLen > $scope.limitNum) {
        /** @type {string} */
        var speed = "单据中的单品条数已超出" + $scope.limitNum + "条的限制！";
        return UnitTools.toastShow(speed, "short", "center"), false;
      }
      /** @type {number} */
      d = 0;
      l = results.length;
      for (;l > d;d++) {
        /** @type {number} */
        var id = 0;
        var cnl = $scope.currentSizes.length;
        for (;cnl > id;id++) {
          var str = $scope.currentSizes[id];
          var item = {
            colorId : results[d].id,
            sizeId : str.id,
            colorName : results[d].name,
            sizeName : str.name,
            quantity : dataAndEvents,
            price : $scope.selectedGood.good.retailPriceArea,
            unit : $scope.selectedGood.good.unit,
            truePrice : parseFloat($scope.selectedGood.good.retailPriceArea.toFixed(2)),
            storeNumber : $scope.getGoodStoreNum(results[d], str)
          };
          /** @type {Array} */
          var items = params.goods;
          /** @type {boolean} */
          var y = false;
          /** @type {number} */
          idx = 0;
          /** @type {number} */
          i = items.length;
          for (;i > idx;idx++) {
            var current = items[idx];
            if (current.colorId == item.colorId && current.sizeId == item.sizeId) {
              if (deepDataAndEvents) {
                if (current.quantity + item.quantity < 0) {
                  return $scope.selectedGood.good.batchNumArray[results[d].id] = 0, false;
                }
                current.quantity += item.quantity;
                $scope.selectedGood.good.numArray[results[d].id][str.id] = current.quantity;
                params.goodsNum += item.quantity;
              } else {
                /** @type {number} */
                params.goodsNum = params.goodsNum - current.quantity;
                current.quantity = item.quantity;
                $scope.selectedGood.good.numArray[results[d].id][str.id] = current.quantity;
                params.goodsNum += item.quantity;
              }
              if (0 == current.quantity) {
                params.goods.splice(idx, 1);
              }
              /** @type {boolean} */
              y = true;
              break;
            }
          }
          if (!y) {
            if (item.quantity > 0) {
              params.goodsNum += item.quantity;
              $scope.selectedGood.good.numArray[results[d].id][str.id] = deepDataAndEvents ? 1 : dataAndEvents;
              params.goods.push(item);
            }
          }
        }
      }
      if (0 == params.goods.length) {
        UnitTools.removeByKey($scope.retailOrder.goodsGroup, "goodsSn", expectedOutput);
      }
      $scope.selectedGood.good.goodsNum = params.goodsNum;
      $scope.selectedGood.good.batchNumArray[results[0].id] = UnitTools.accAdd($scope.selectedGood.good.batchNumArray[results[0].id], dataAndEvents);
      $scope.setTotalAmount();
    }
  };
  /**
   * @param {Element} def
   * @return {?}
   */
  $scope.getColorNumber = function(def) {
    var remove = $scope.selectedGood.good.goodsSn;
    var left = UnitTools.fnCheckGtoreQty($scope.retailOrder.goodsGroup, "goodsSn", remove);
    /** @type {number} */
    var count = 0;
    if (left) {
      var a = left.goods;
      /** @type {number} */
      var i = 0;
      var l = a.length;
      for (;l > i;i++) {
        var data = a[i];
        if (data.colorId == def.id) {
          count += data.quantity;
        }
      }
    }
    return count ? count : "";
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  $scope.clearSelectedGood = function(dataAndEvents) {
    if (angular.isObject($scope.selectedGood.good)) {
      if ($scope.selectedGood.good.goodsSn == dataAndEvents) {
        $scope.selectedGood.good = {};
      }
    }
  };
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  $scope.deleteGoods = function(opt_attributes) {
    /** @type {number} */
    var i = 0;
    var ilen = $scope.retailOrder.goodsGroup.length;
    for (;ilen > i;i++) {
      if (opt_attributes == $scope.retailOrder.goodsGroup[i].goodsSn) {
        $scope.retailOrder.goodsGroup.splice(i, 1);
        break;
      }
    }
    /** @type {number} */
    i = 0;
    ilen = $scope.KEY288.length;
    for (;ilen > i;i++) {
      if (opt_attributes == $scope.KEY288[i].goodsSn) {
        /** @type {number} */
        $scope.KEY288[i].goodsNum = 0;
        break;
      }
    }
    $scope.setTotalAmount();
    if (!$scope.platformIsPad) {
      $scope.selectedGood.good = {};
    }
    /** @type {number} */
    i = 0;
    for (;i < $scope.codeArr.length;i++) {
      if ($scope.codeArr[i].goodsSn == opt_attributes) {
        $scope.scannedInTotal -= $scope.codeArr[i].scannedInQuantity;
        $scope.scannedOutTotal -= $scope.codeArr[i].scannedOutQuantity;
        $scope.codeArr.splice(i, 1);
        i--;
      }
    }
  };
  /**
   * @param {(Object|string)} dataAndEvents
   * @param {string} end
   * @param {?} deepDataAndEvents
   * @return {undefined}
   */
  $scope.deletePurchaseGoods = function(dataAndEvents, end, deepDataAndEvents) {
    /** @type {number} */
    var i = 0;
    var ilen = $scope.retailOrder.goodsGroup.length;
    for (;ilen > i;i++) {
      if (dataAndEvents == $scope.retailOrder.goodsGroup[i].goodsSn) {
        var start;
        for (start in $scope.retailOrder.goodsGroup[i].goods) {
          if (start == end) {
            if ($scope.codeArr.length > 0) {
              var todayMonth = $scope.retailOrder.goodsGroup[start].goods[i].colorId;
              var todayYear = $scope.retailOrder.goodsGroup[start].goods[i].sizeId;
            }
            $scope.retailOrder.goodsGroup[i].goods.splice(start, 1);
            if (deepDataAndEvents) {
              /** @type {number} */
              $scope.retailOrder.goodsGroup[i].goodsNum = $scope.retailOrder.goodsGroup[i].goodsNum - deepDataAndEvents;
            }
            break;
          }
        }
        if (0 === $scope.retailOrder.goodsGroup[i].goods.length) {
          $scope.retailOrder.goodsGroup.splice(i, 1);
        }
        break;
      }
    }
    if (deepDataAndEvents) {
      /** @type {number} */
      i = 0;
      ilen = $scope.KEY288.length;
      for (;ilen > i;i++) {
        if (dataAndEvents == $scope.KEY288[i].goodsSn) {
          /** @type {number} */
          $scope.KEY288[i].goodsNum = $scope.KEY288[i].goodsNum - deepDataAndEvents;
          break;
        }
      }
    }
    if ($scope.isGoodsGroupNull()) {
      /** @type {boolean} */
      $scope.retailOrder.showDelete = false;
    }
    $scope.setTotalAmount();
    if (!$scope.platformIsPad) {
      $scope.selectedGood.good = {};
    }
    /** @type {number} */
    i = 0;
    for (;i < $scope.codeArr.length;i++) {
      if ($scope.codeArr[i].goodsSn == dataAndEvents && ($scope.codeArr[i].good.colorId == todayMonth && $scope.codeArr[i].good.sizeId == todayYear)) {
        $scope.scannedInTotal -= $scope.codeArr[i].scannedInQuantity;
        $scope.scannedOutTotal -= $scope.codeArr[i].scannedOutQuantity;
        $scope.codeArr.splice(i, 1);
        break;
      }
    }
  };
  /**
   * @return {undefined}
   */
  $scope.setTotalAmount = function() {
    $scope.calcTotalAmount();
  };
  /**
   * @return {?}
   */
  $scope.openModal = function() {
    return UnitTools.isEmpty($scope.retailOrder.retailDepot) ? window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择仓库！", null), false) : (view.alert({
      template : "<div class='tc'>请选择仓库！</div>",
      okText : "确定"
    }), false) : void $scope.modal.show();
  };
  /**
   * @param {?} _xhr
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  $scope.KEY264 = function(_xhr, dataAndEvents) {
    //选中商品对象
    $scope.selectedGood.good = _xhr;

    //辅助单位
    $scope.currentUnits = [];
    //基本单位
    $scope.currentUnits.push({
      id : 0,
      unitName : _xhr.unit ? _xhr.unit : "件",
      unitId : 0,
      priceRetail : _xhr.retailPriceArea,
      prepPrice1 : _xhr.tradePrice
    });
    //追加辅助单位
    if (_xhr.goodsUnitPriceList){
      for (var z = 0; z < _xhr.goodsUnitPriceList.length; z++) {
        $scope.currentUnits.push(_xhr.goodsUnitPriceList[z]);
      }
    }
    //选中的单位
    $scope.selectedGood.selectedUnits = [];
    if ($scope.currentUnits.length > 0){
      $scope.selectedGood.selectedUnits.push($scope.currentUnits[0]);
    }

    $scope.currentColors = UnitTools.idStringToObjectArray($scope.allColors, _xhr.colorIds, "id", ",");
    $scope.currentSizes = UnitTools.idStringToObjectArray($scope.allSizes, _xhr.sizeIds, "id", ",");
    var promise = res.getGoodsStoredCount(_xhr.goodsSn, $scope.retailOrder.retailDepot.val);
    promise.then(function(dataAndEvents) {
      $scope.selectedGood.goodStore = dataAndEvents;
    }, function() {
      $scope.selectedGood.goodStore = void 0;
      UnitTools.toastShow("获取商品库存信息失败！");
    });

    //选中的颜色
    $scope.selectedGood.seletedColors = [];
    //二/三维数组存储数量
    $scope.selectedGood.good.numArray = [];

    $scope.selectedGood.good.batchNumArray = [];
    var opts = UnitTools.fnCheckGtoreQty($scope.retailOrder.goodsGroup, "goodsSn", _xhr.goodsSn);
    /** @type {number} */
    var i = 0;
    var l = $scope.currentColors.length;
    var unitsLength = $scope.currentUnits.length;
    for (;l > i;i++) {
      /** @type {number} */
      $scope.selectedGood.good.batchNumArray[$scope.currentColors[i].id] = 0;
      /** @type {Array} */
      $scope.selectedGood.good.numArray[$scope.currentColors[i].id] = [];
      /** @type {number} */
      var j = 0;
      var spaces = $scope.currentSizes.length;
      for (;spaces > j;j++) {
        if (opts) {
          var modId = $scope.currentColors[i].id;
          var udataCur = $scope.currentSizes[j].id;
          if ($scope.currentUnits.length <= 1) { //没有辅助单位
            var r = convert(opts.goods, modId, udataCur);
            $scope.selectedGood.good.numArray[$scope.currentColors[i].id][$scope.currentSizes[j].id] = r > 0 ? r : 0;
          } else {
            $scope.selectedGood.good.numArray[$scope.currentColors[i].id][$scope.currentSizes[j].id] = [];
            var m = 0;
            for(; unitsLength > m ; m++){
              var unitId = $scope.currentUnits[m].unitId;
              var q = equalMultUnit(opts.goods,modId,udataCur,unitId);
              $scope.selectedGood.good.numArray[$scope.currentColors[i].id][$scope.currentSizes[j].id][$scope.currentUnits[m].unitId] = q > 0 ? q : 0;
            }
          }
        } else {
          if (unitsLength <= 1){
            $scope.selectedGood.good.numArray[$scope.currentColors[i].id][$scope.currentSizes[j].id] = 0;
          }else{
            //如果多单位，二维数组修改为三维数组,以unitId作为下标
            $scope.selectedGood.good.numArray[$scope.currentColors[i].id][$scope.currentSizes[j].id] = [];
            var k = 0;
            for(; unitsLength > k ; k++){
              $scope.selectedGood.good.numArray[$scope.currentColors[i].id][$scope.currentSizes[j].id][$scope.currentUnits[k].unitId] = 0;
            }
          }
        }
      }
    }
    /** @type {Array} */
    if ($scope.currentColors.length > 0) {
      $scope.selectedGood.seletedColors.push(_xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuColorId) ? UnitTools.fnCheckGtoreQty($scope.currentColors, "id", _xhr.skuColorId) : $scope.currentColors[0]);
    } else {
      /** @type {Array} */
      $scope.selectedGood.seletedColors = [];
    }
    $scope.selectedGood.size = $scope.currentSizes.length > 0 && (_xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuSizeId)) ? UnitTools.fnCheckGtoreQty($scope.currentSizes, "id", _xhr.skuSizeId) : $scope.currentSizes[0];
    if (dataAndEvents) {
      $scope.addToGoodsGroup($scope.selectedGood.seletedColors, $scope.selectedGood.size, 1, true);
    }
  };
  /**
   * @param {Array} employees
   * @param {?} name
   * @param {?} value
   * @return {?}
   */
  var convert = function(employees, name, value) {
    /** @type {number} */
    var i = 0;
    var l = employees.length;
    for (;l > i;i++) {
      if (employees[i].colorId == name && employees[i].sizeId == value) {
        return employees[i].quantity;
      }
    }
    return 0;
  };

  var equalMultUnit = function(goods, colorId, sizeId,unitId) {
    /** @type {number} */
    var i = 0;
    var l = goods.length;
    for (;l > i;i++) {
      if (goods[i].colorId == colorId && goods[i].sizeId == sizeId && goods[i].unitId == unitId) {
        return goods[i].quantity;
      }
    }
    return 0;
  };

  $modal.fromTemplateUrl("retailSettle.html", function($location) {
    /** @type {number} */
    $scope.retailSettleModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.retailSettleModalOpen = function() {
    $scope.retailSettleModal.show();
    done(function() {
      $scope.setTrueTotalAmount($scope.retailOrder.trueTotalAmount);
    }, 500);
  };
  /**
   * @return {undefined}
   */
  $scope.retailSettleModalClose = function() {
    $scope.retailSettleModal.hide();
  };
  /**
   * @param {string} initValues
   * @return {undefined}
   */
  var init = function(initValues) {
    console.log("queryAliTradeStatus...【" + b + "】 次");
    field.postEncode("/KEY358", {
      tradeSn : initValues
    }).success(function(res) {
      if (1 == res.statusCode && "TRADE_SUCCESS" == res.content) {
        loading.hide();
        console.log("支付成功！");
        UnitTools.toastShow("支付成功！");
        /** @type {number} */
        $scope.state = 1;
        jsPDFAPI.autoPrint($scope.mainCompany.comName, res.object.ordersSn, jsPDFAPI.orderType.retailOrder);
        if ($routeParams.goodsId) {
          $templateCache.put("goodListRefresh", true);
        }
        $scope.viewReplace();
        $state.go("eventmenu.KEY215", {
          ordersSn : res.object.ordersSn
        });
      } else {
        if (1 == res.statusCode && "WAIT_BUYER_PAY" == res.content) {
          if (12 > b) {
            b++;
            UnitTools.toastShow("等待用户付款，请稍候...", "long");
            done(function() {
              init(initValues);
            }, 5E3);
          } else {
            loading.hide();
            console.log("二维码超时，请重新扫码付款！");
            UnitTools.toastShow("二维码超时，请重新扫码付款！");
          }
        } else {
          if (1 == res.statusCode && "TRADE_CLOSED" == res.content) {
            loading.hide();
            console.log("交易超时/余额不足.");
            UnitTools.toastShow("交易超时/余额不足.");
          } else {
            loading.hide();
            console.log("服务器获取数据出现异常！");
            UnitTools.toastShow("服务器获取数据出现异常！");
          }
        }
      }
    });
  };
  /**
   * @param {number} dataAndEvents
   * @return {undefined}
   */
  $scope.openScanPay = function(dataAndEvents) {
    if (($scope.retailOrder.isAliPay || $scope.retailOrder.isWechatPay) && ("none" == $scope.payAccountType && 0 == $scope.isAppOpen)) {
      /** @type {string} */
      var errorMessage = "开通公司代收或者扫码支付即可对接支付宝或者微信支付，扫码极速收款";
      if ($scope.payEndTime && (errorMessage = "您开通的扫码支付已到期，请重新开通扫码支付或开通公司代收"), $scope.retailOrder.isAliPay = false, $scope.retailOrder.isWechatPay = false, window.cordova && window.cordova.plugins) {
        UnitTools.showConfirm(errorMessage, function(dataAndEvents) {
          if (1 == dataAndEvents) {
            $scope.retailSettleModalClose();
            $scope.openLinkInIframe(deepDataAndEvents.getVaItem[4].title, deepDataAndEvents.getVaItem[4].htmlName);
          } else {
            if (2 == dataAndEvents) {
              $scope.retailSettleModalClose();
              $scope.openLinkInIframe(deepDataAndEvents.getVaItem[0].title, deepDataAndEvents.getVaItem[0].htmlName);
            }
          }
        }, null, ["开通扫码支付", "开通公司代收", "取消"]);
      } else {
        var promise = view.confirm({
          template : "<div class='tc'>" + errorMessage + "</div>",
          cancelText : "取消",
          okText : "了解更多"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            $scope.retailSettleModalClose();
            $scope.openLinkInIframe(deepDataAndEvents.getVaItem[4].title, deepDataAndEvents.getVaItem[4].htmlName);
          }
        });
      }
    } else {
      if (1 == dataAndEvents) {
        /** @type {boolean} */
        $scope.retailOrder.isWechatPay = false;
        /** @type {string} */
        $scope.scanPayTitle = "支付宝";
      } else {
        /** @type {boolean} */
        $scope.retailOrder.isAliPay = false;
        /** @type {string} */
        $scope.scanPayTitle = "微信";
      }
    }
  };
  /** @type {Array} */
  var new_val = [];
  var value = {};
  /**
   * @return {?}
   */
  $scope.saveOrder = function() {
    return UnitTools.isEmpty($scope.retailOrder.retailDepot) ? window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择仓库！", null), false) : (view.alert({
      template : "<div class='tc'>请选择仓库！</div>",
      okText : "确定"
    }), false) : UnitTools.isEmpty($scope.retailOrder.goodsGroup) ? window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择商品！", null), false) : (view.alert({
      template : "<div class='tc'>请选择商品！</div>",
      okText : "确定"
    }), false) : UnitTools.isEmpty($scope.retailOrder.retailAccount) ? window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择结算账户！", null), false) : (view.alert({
      template : "<div class='tc'>请选择结算账户！</div>",
      okText : "确定"
    }), false) : ($scope.retailOrder.wipeZero = 0, void $scope.retailSettleModalOpen());
  };
  /** @type {number} */
  var L = 0;
  /**
   * @return {?}
   */
  $scope.saveOrderConfirm = function() {
    /**
     * @return {?}
     */
    function combine() {
      /** @type {Array} */
      var js = [];
      /** @type {number} */
      var unlock = 0;
      var cnl = $scope.retailOrder.goodsGroup.length;
      for (;cnl > unlock;unlock++) {
        var goodsSn = $scope.retailOrder.goodsGroup[unlock].goodsSn;
        var dataName;
        for (dataName in $scope.retailOrder.goodsGroup[unlock].goods) {
          var data = $scope.retailOrder.goodsGroup[unlock].goods[dataName];
          js.push({
            storehouseId : val,
            goodsSn : goodsSn,
            colorId : data.colorId,
            sizeId : data.sizeId
          });
        }
      }
      return res.getGoodsListStoredCount(js);
    }
    /**
     * @param {string} x
     * @param {string} y
     * @param {?} data
     * @param {?} className
     * @return {undefined}
     */
    function SaveBillProcess(x, y, data, className) {
      var match = UnitTools.fnCheckGtoreQty(className, "serialNo", x + "-" + y + "-" + data.colorId + "-" + data.sizeId);
      var count = match ? match.number : 0;
      data.storeNumber = count;
      if (data.quantity <= count) {
        /** @type {number} */
        data.isEnoughStore = 1;
      }
      else if (data.sizeName=="赠送") {
        data.isEnoughStore = 1;       //赠送尺码不检测库存
      }
      else {
        /** @type {number} */
        data.isEnoughStore = 0;
        /** @type {number} */
        $scope.isShowInvalidStoreMsg = 1;
      }
    }
    if (null === $scope.retailOrder.trueTotalAmount || "" === $scope.retailOrder.trueTotalAmount) {
      UnitTools.toastShow("请填写实收金额！", "short", "center");
      e.preventDefault();
    } else {
      if (new_val = [], $scope.isShowInvalidStoreMsg = 0, 1 == L) {
        return false;
      }
      /** @type {number} */
      L = 1;
      parent.show({
        template : "检查库存状况..."
      });
      var val = $scope.retailOrder.retailDepot.val;
      combine().then(function(classToRemove) {
        /**
         * @return {?}
         */
        function fn() {
          return L = 0, loading.show(true), value = {
            trueTotalAmount : $scope.retailOrder.trueTotalAmount,
            totalAmount : $scope.calcTotalAmount(),
            wipeZero : $scope.retailOrder.wipeZero ? $scope.retailOrder.wipeZero : 0,
            depotId : $scope.retailOrder.retailDepot.val,
            accountId : $scope.retailOrder.retailAccount.id,
            salerId : $scope.retailOrder.saler.val,
            salerName : $scope.retailOrder.saler.text
          }, new_val.length <= 0 ? (loading.hide(), false) : ($scope.retailOrder.isAliPay || $scope.retailOrder.isWechatPay) && 0 != $scope.retailOrder.trueTotalAmount ? ($scope.scanPayTitle = $scope.retailOrder.isAliPay ? "支付宝" : "微信", $scope.scanPayModal.show(), loading.hide(), false) : void field.postEncode("/KEY151", {
            order : angular.toJson(value),
            goods : angular.toJson(new_val)
          }).success(function(res) {
            if (1 == res.statusCode) {
              UnitTools.toastShow("结账成功！");
              /** @type {Array} */
              $scope.retailOrder.goodsGroup = [];
              /** @type {number} */
              $scope.state = 1;
              jsPDFAPI.autoPrint($scope.mainCompany.comName, res.object.ordersSn, jsPDFAPI.orderType.retailOrder);
              if ($routeParams.goodsId) {
                $templateCache.put("goodListRefresh", true);
              }
              $scope.viewReplace();
              $state.go("eventmenu.KEY215", {
                ordersSn : res.object.ordersSn
              });
            } else {
              UnitTools.toastShow(res.content);
            }
          }).finally(function() {
            loading.hide();
            $templateCache.put("retailListRefresh", true);
            $scope.retailSettleModalClose();
          });
        }
        /** @type {number} */
        var unlock = 0;
        var cnl = $scope.retailOrder.goodsGroup.length;
        for (;cnl > unlock;unlock++) {
          var y = $scope.retailOrder.goodsGroup[unlock].goodsSn;
          var dataName;
          for (dataName in $scope.retailOrder.goodsGroup[unlock].goods) {
            var data = $scope.retailOrder.goodsGroup[unlock].goods[dataName];
            if (void 0 != data.quantity) {
              if (0 != data.quantity) {
                if (void 0 != data.truePrice) {
                  SaveBillProcess(val, y, data, classToRemove);
                  new_val.push({
                    goodsSn : y,
                    colorId : data.colorId,
                    sizeId : data.sizeId,
                    quantity : data.quantity,
                    price : data.price,
                    truePrice : data.truePrice,
                    amount : UnitTools.accMul(data.truePrice, data.quantity),
                    trueAmount : UnitTools.accMul(data.truePrice, data.quantity),
                    unitId : data.unitId
                  });
                }
              }
            }
          }
        }
        if (parent.hide(), new_val.length <= 0) {
          return L = 0, view.alert({
            template : "<div class='tc'>请检查商品信息</div>",
            okText : "确定"
          }), false;
        }
        if (1 === $scope.isShowInvalidStoreMsg) {
          if (2 == $scope.saleNegativeStore) {
            /** @type {number} */
            L = 0;
            /** @type {string} */
            var parsed = "商品库存不足，不允许销售";
            return window.cordova && window.cordova.plugins ? (UnitTools.showAlert(parsed, null), false) : (view.alert({
              template : "<div class='tc'>" + parsed + "</div>",
              okText : "确定"
            }), false);
          }
          if (window.cordova && window.cordova.plugins) {
            UnitTools.showConfirm("商品库存不足，是否继续?", function(dataAndEvents) {
              if (2 == dataAndEvents) {
                fn();
              } else {
                /** @type {number} */
                L = 0;
              }
            }, null, ["取消", "继续结账"]);
          } else {
            var promise = view.confirm({
              template : "<div class='tc'>商品库存不足，是否继续?</div>",
              cancelText : "取消",
              okText : "继续结账"
            });
            promise.then(function(dataAndEvents) {
              if (dataAndEvents) {
                fn();
              } else {
                /** @type {number} */
                L = 0;
              }
            });
          }
        } else {
          fn();
        }
      }, function() {
        parent.hide();
        /** @type {number} */
        L = 0;
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.openScan = function() {
    if ($scope.retailOrder.isAliPay || $scope.retailOrder.isWechatPay) {
      if (window.cordova) {
        if (window.cordova.plugins) {
          cordova.plugins.barcodeScanner.scan(function(res) {
            return res.cancelled ? void loading.hide() : void $scope.scanPay(res.text);
          });
        }
      }
    } else {
      UnitTools.toastShow("请选择一种支付方式");
    }
  };
  /** @type {boolean} */
  $scope.lockState = false;
  /**
   * @param {?} keepData
   * @return {?}
   */
  $scope.scanPay = function(keepData) {
    return $scope.lockState ? false : ($scope.lockState = true, b = 0, void field.postEncode("/KEY366", {
      order : angular.toJson(value),
      goods : angular.toJson(new_val),
      authCode : keepData,
      payType : $scope.retailOrder.isWechatPay ? "wxpayScanPay" : "alipayBarPay"
    }).success(function(res) {
      if (1 == res.statusCode) {
        if (1 == res.statusCode) {
          UnitTools.toastShow("结账成功！");
          /** @type {Array} */
          $scope.retailOrder.goodsGroup = [];
          /** @type {number} */
          $scope.state = 1;
          jsPDFAPI.autoPrint($scope.mainCompany.comName, res.object.ordersSn, jsPDFAPI.orderType.retailOrder);
          if ($routeParams.goodsId) {
            $templateCache.put("goodListRefresh", true);
          }
          $scope.viewReplace();
          $state.go("eventmenu.KEY215", {
            ordersSn : res.object.ordersSn
          });
        } else {
          UnitTools.toastShow(res.content);
        }
        if ($scope.scanPayModal.isShown()) {
          $scope.scanPayModal.hide();
        }
        /** @type {boolean} */
        $scope.lockState = false;
      } else {
        /** @type {number} */
        $scope.state = 1;
        $scope.retailOrder.ordersSn = res.object.order.ordersSn;
        UnitTools.union(value, {
          id : res.object.order.id,
          ordersSn : res.object.order.ordersSn,
          optimisticLockVersion : res.object.order.optimisticLockVersion
        });
        if (10003 == res.statusCode) {
          UnitTools.toastShow(res.content, "long");
          b++;
          loading.show(true);
          done(function() {
            init(res.object.trade.tradeSn);
          }, 5E3);
        } else {
          view.alert({
            template : "<div class='tc'>" + res.content + "</div>",
            okText : "确定"
          });
        }
        if ($scope.scanPayModal.isShown()) {
          $scope.scanPayModal.hide();
        }
        /** @type {boolean} */
        $scope.lockState = false;
      }
    }).finally(function() {
      loading.hide();
      $templateCache.put("retailListRefresh", true);
      $scope.retailSettleModalClose();
    }));
  };
  loading.show();
  $scope.$watch("[retailOrder.retailDepot, retailOrder.retailAccount]", function(a, blobs) {
    if (a[0] && (blobs[0] && (a[0].val != blobs[0].val && blobs[0].val > 0))) {
      res.saveOrUpdateUserConfig("checkout.depotId", JSON.stringify($scope.retailOrder.retailDepot.val), 3).then(function(node) {
        $scope.checkout.depotId = UnitTools.fnCheckGtoreQty(obj.userConfigData, "configKey", "checkout.depotId");
        if ($scope.checkout.depotId) {
          UnitTools.union($scope.checkout.depotId, node.object);
        } else {
          obj.userConfigData.push(node.object);
        }
        /** @type {*} */
        $scope.checkout.depotIdValue = JSON.parse(node.object.configValue);
      }, function() {
        UnitTools.toastShow("服务器获取数据出现异常！");
      });
    } else {
      if (a[1] && (blobs[1] && (a[1].val != blobs[1].val && blobs[1].val > 0))) {
        var msg = {
          id : $scope.retailOrder.retailAccount.id,
          val : $scope.retailOrder.retailAccount.val,
          text : $scope.retailOrder.retailAccount.text,
          name : $scope.retailOrder.retailAccount.name
        };
        res.saveOrUpdateUserConfig("checkout.KEY293", JSON.stringify(msg), 3).then(function(node) {
          $scope.checkout.KEY293 = UnitTools.fnCheckGtoreQty(obj.userConfigData, "configKey", "checkout.KEY293");
          if ($scope.checkout.KEY293) {
            UnitTools.union($scope.checkout.KEY293, node.object);
          } else {
            obj.userConfigData.push(node.object);
          }
          /** @type {*} */
          $scope.checkout.accountValue = JSON.parse(node.object.configValue);
        }, function() {
          UnitTools.toastShow("服务器获取数据出现异常！");
        });
      }
    }
  }, true);
  /**
   * @param {string} success
   * @param {Function} cb
   * @return {undefined}
   */
  var exec = function(success, cb) {
    if (success) {
      field.postEncode("/KEY372", {
        barCode : success
      }).success(function(outErr) {
        if (null != outErr) {
          cb(outErr);
        }
      });
    }
  };
  /** @type {Array} */
  $scope.codeArr = [];
  /** @type {number} */
  $scope.scannedInTotal = 0;
  /** @type {number} */
  $scope.scannedOutTotal = 0;
  /** @type {number} */
  $scope.lastGoodIndex = -1;
  /**
   * @param {string} success
   * @return {?}
   */
  $scope.scanCallback = function(success) {
    if ($scope.selectedGoodModal && $scope.selectedGoodModal.isShown()) {
      return UnitTools.toastShow("请先关闭当前商品选择页面再进行扫码"), false;
    }
    if ($scope.modal) {
      if ($scope.modal.isShown()) {
        $scope.modal.hide();
      }
    }
    if ($scope.scanCodeListModal) {
      if (!$scope.scanCodeListModal.isShown()) {
        if (!$scope.modal.isShown()) {
          $scope.scanCodeListModal.show();
        }
      }
    } else {
      $modal.fromTemplateUrl("scanCodeList.html", function($location) {
        /** @type {number} */
        $scope.scanCodeListModal = $location;
        $scope.scanCodeListModal.show();
      }, {
        scope : $scope,
        animation : "slide-in-up"
      });
    }
    var options = UnitTools.fnCheckGtoreQty($scope.codeArr, "code", success);
    if (options && (options.name || options.notFound)) {
      if (options.name) {
        options.scannedOutQuantity = options.scannedOutQuantity ? options.scannedOutQuantity + 1 : 1;
      }
      options.scannedInQuantity += 1;
      $scope.scannedInTotal++;
      /** @type {number} */
      var i = 0;
      for (;i < $scope.codeArr.length;i++) {
        if ($scope.codeArr[i].selected) {
          /** @type {boolean} */
          $scope.codeArr[i].selected = false;
          break;
        }
      }
      /** @type {number} */
      i = 0;
      for (;i < $scope.codeArr.length;i++) {
        if (success == $scope.codeArr[i].code) {
          /** @type {boolean} */
          $scope.codeArr[i].selected = true;
          animate("codeClass", i);
          options.notFound;
          break;
        }
      }
      if (options.name) {
        $scope.scannedOutTotal++;
        if (options.good) {
          options.good.quantity += 1;
          $scope.setTotalAmount();
        }
      }
    } else {
      if (options) {
        options.scannedInQuantity += 1;
        $scope.scannedInTotal++;
      } else {
        $scope.codeArr.push({
          code : success,
          scannedInQuantity : 1
        });
        $scope.scannedInTotal++;
      }
      options = UnitTools.fnCheckGtoreQty($scope.codeArr, "code", success);
      exec(success, function(data) {
        /** @type {number} */
        var i = 0;
        for (;i < $scope.codeArr.length;i++) {
          if ($scope.codeArr[i].selected) {
            /** @type {boolean} */
            $scope.codeArr[i].selected = false;
            break;
          }
        }
        /** @type {number} */
        i = 0;
        for (;i < $scope.codeArr.length;i++) {
          if (success == $scope.codeArr[i].code) {
            /** @type {boolean} */
            $scope.codeArr[i].selected = true;
            animate("codeClass", i);
            data.skuBarCode != success;
            break;
          }
        }
        if (data.skuBarCode == success) {
          if ($scope.KEY264(data, true), options) {
            options.scannedOutQuantity = options.scannedOutQuantity ? options.scannedOutQuantity + 1 : 1;
            $scope.scannedOutTotal++;
            options.name = data.name;
            options.goodsSn = data.goodsSn;
            var opts = UnitTools.fnCheckGtoreQty($scope.retailOrder.goodsGroup, "goodsSn", data.goodsSn);
            if (opts && opts.goods) {
              var POST = UnitTools.getObjectByObject(opts.goods, {
                colorId : data.skuColorId,
                sizeId : data.skuSizeId
              });
              options.good = POST;
            }
            if (options.scannedOutQuantity != options.scannedInQuantity) {
              $scope.scannedOutTotal += options.scannedInQuantity - options.scannedOutQuantity;
              options.good.quantity += options.scannedInQuantity - options.scannedOutQuantity;
              options.scannedOutQuantity = options.scannedInQuantity;
            }
            $scope.setTotalAmount();
          }
        } else {
          if (data.barCode == success) {
            UnitTools.toastShow("暂不支持非单品条码");
            if (options) {
              /** @type {boolean} */
              options.notFound = true;
            }
          } else {
            UnitTools.toastShow(success + "条码暂无商品信息");
            if (options) {
              /** @type {boolean} */
              options.notFound = true;
            }
          }
        }
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.scanFinish = function() {
    loading.show(true);
    $scope.scanCodeListModal.hide();
    loading.hide();
  };
  /**
   * @param {Function} dataAndEvents
   * @return {undefined}
   */
  $scope.getScanerCode = function(dataAndEvents) {
    if (dataAndEvents) {
      UnitTools.toastShow("此功能用于条码枪断开后重新连接");
    }
    $cookieStore.getScanerCode(function(key) {
      if (key && $scope.scanPayModal.isShown()) {
        if ($scope.retailOrder.isAliPay || $scope.retailOrder.isWechatPay) {
          $scope.scanPay(key);
        } else {
          UnitTools.toastShow("请选择一种支付方式");
        }
      } else {
        if (null != key) {
          $scope.searchGoodsByBarCode(key);
        }
      }
    }, $scope.bluethoothScaner);
  };
  $scope.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      /** @type {Array} */
      $scope.allDept = [];
      /** @type {number} */
      var i = 0;
      for (;i < packs[0].data.length;i++) {
        if ("1" == packs[0].data[i].status) {
          $scope.allDept.push(packs[0].data[i]);
        }
      }
      $scope.allSizes = packs[1].data.rows;
      $scope.allColors = packs[2].data.rows;
      $scope.allAccounts = packs[3].data.rows;
      /** @type {Array} */
      $scope.allSaler = [];
      /** @type {number} */
      i = 0;
      for (;i < packs[4].data.optionList.length;i++) {
        if ("1" == packs[4].data.optionList[i].status) {
          $scope.allSaler.push(packs[4].data.optionList[i]);
        }
      }
      /** @type {number} */
      i = 0;
      /** @type {number} */
      var ilen = $scope.allSaler.length;
      for (;ilen > i;i++) {
        if ($scope.allSaler[i].val == $scope.mainUserConfig.userId) {
          $scope.retailOrder.saler = {
            text : $scope.allSaler[i].text,
            val : $scope.allSaler[i].val
          };
          break;
        }
      }
      if ($scope.checkout = {}, $scope.checkout.depotId = UnitTools.fnCheckGtoreQty(obj.userConfigData, "configKey", "checkout.depotId"), $scope.checkout.depotId && ($scope.checkout.depotId.configValue && ($scope.checkout.depotIdValue = JSON.parse($scope.checkout.depotId.configValue))), $scope.checkout.KEY293 = UnitTools.fnCheckGtoreQty(obj.userConfigData, "configKey", "checkout.KEY293"), $scope.checkout.KEY293 && ($scope.checkout.KEY293.configValue &&
      ($scope.checkout.accountValue = JSON.parse($scope.checkout.KEY293.configValue))), null != $routeParams.goodsId ? $scope.searchGoodsById($routeParams.goodsId) : $scope.searchGoods(), $routeParams.copyOrder) {
        $scope.copyOrder = $routeParams.copyOrder;
        $scope.retailOrder.goodsGroup = $scope.copyOrder.goodsGroup;
        /** @type {number} */
        i = 0;
        /** @type {number} */
        ilen = $scope.allDept.length;
        for (;ilen > i;i++) {
          if ($scope.copyOrder.order.depotId == $scope.allDept[i].val) {
            $scope.retailOrder.retailDepot = $scope.allDept[i];
            break;
          }
        }
        if (null == $scope.retailOrder.retailDepot) {
          UnitTools.toastShow("原草稿仓库已停用");
          //$scope.retailOrder.retailDepot = $scope.allDept[0];
        }
        /** @type {number} */
        i = 0;
        ilen = $scope.allAccounts.length;
        for (;ilen > i;i++) {
          if ($scope.copyOrder.order.accountId == $scope.allAccounts[i].id) {
            $scope.retailOrder.retailAccount = $scope.allAccounts[i];
            break;
          }
        }
        $scope.calcTotalAmount();
        loading.hide();
      } else {
        //$scope.retailOrder.retailDepot = $scope.allDept[0];   初始读取第一仓库
        if ($scope.checkout.accountValue) {
          /** @type {number} */
          i = 0;
          /** @type {number} */
          ilen = $scope.allDept.length;
          for (;ilen > i;i++) {
            if ($scope.checkout.depotIdValue == $scope.allDept[i].id) {
              $scope.retailOrder.retailDepot = $scope.allDept[i];
              break;
            }
          }
        }
        if ($scope.retailOrder.retailAccount = $scope.allAccounts[0], $scope.checkout.accountValue) {
          /** @type {number} */
          i = 0;
          ilen = $scope.allAccounts.length;
          for (;ilen > i;i++) {
            if ($scope.checkout.accountValue.val == $scope.allAccounts[i].id) {
              $scope.retailOrder.retailAccount = $scope.allAccounts[i];
              break;
            }
          }
        }
      }
      loading.hide();
    }, function() {
      loading.hide();
    });
    $scope.getScanerCode();
  });
}]);
