angular.module("serviceController", ["ionic", "services", "tools"]).controller("PaymentListCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "Tools", "lbSpinnerDialog", "$window", "$q", "$http", "ServerConfig", "$ionicModal", function($scope, $state, ret, parent, domAttr, loading, dataAndEvents, $q, $templateCache, current, $modal) {
  /**
   * @param {?} data
   * @return {?}
   */
  function parseNode(data) {
    return 2 == data.isProvide ? false : void("1" === data.applyFromPc || "1" === data.openInApp ? data.openUrl ? $scope.openLink(data.openUrl, true) : domAttr.toastShow("请在进销存电脑版申请此服务！", "long", "center") : data.shopUrl.indexOf("eventmenu") > -1 ? $scope.openLinkInIframe(data.name, data.currentUrl) : window.open(data.shopUrl, "_system"));
  }
  /**
   * @return {?}
   */
  function fn() {
    var imageDfd = $q.defer();
    var name = current.currentServer.replace("/is", "").replace("ex.", "www.").replace("web.", "www.");
    /** @type {string} */
    var val = "va_service_list" + ($scope.platformIsIOS ? "_ios.json" : "_android.json");
    return $templateCache.get(name + "/download/" + val + "?random=" + domAttr.getTimeStamp()).success(function(image) {
      imageDfd.resolve(image);
    }).error(function() {
      console.error("从服务器获取增值服务信息异常！");
      imageDfd.reject();
    }), imageDfd.promise;
  }
  $scope.queryCondition = {
    state : 0,
    category : 0
  };
  /** @type {boolean} */
  $scope.isLoading = true;
  /** @type {number} */
  var page = 1;
  /**
   * @param {?} xml
   * @param {?} event
   * @return {undefined}
   */
  $scope.goDetail = function(xml, event) {
    if (event) {
      event.stopPropagation();
    }
    parseNode(xml);
  };
  /**
   * @param {?} xml
   * @param {?} event
   * @return {undefined}
   */
  $scope.openWindowForShop = function(xml, event) {
    if (event) {
      event.stopPropagation();
    }
    parseNode(xml);
  };
  /**
   * @param {?} dataAndEvents
   * @return {?}
   */
  $scope.getPictureUrl = function(dataAndEvents) {
    /** @type {string} */
    var u = "";
    /** @type {number} */
    var i = 0;
    var l = $scope.items.length;
    for (;l > i;i++) {
      if (dataAndEvents === $scope.items[i].serviceType) {
        u = $scope.items[i].url;
        break;
      }
    }
    return u;
  };
  /**
   * @return {undefined}
   */
  $scope.resizeWin = function() {
    parent.scrollTop("paymentListCtrlScroll");
  };
  /**
   * @param {number} dataAndEvents
   * @return {?}
   */
  $scope.filterServiceName = function(dataAndEvents) {
    /** @type {string} */
    var optsData = "";
    return 1 == dataAndEvents ? optsData = "草稿" : 2 == dataAndEvents ? optsData = "待审核" : 3 == dataAndEvents ? optsData = "待付款" : 4 == dataAndEvents ? optsData = "处理中" : 5 == dataAndEvents ? optsData = "已完成" : -1 == dataAndEvents && (optsData = "已撤销"), optsData;
  };
  /**
   * @return {undefined}
   */
  $scope.gotoMyVaService = function() {
    $state.go("eventmenu.KEY246");
  };
  $modal.fromTemplateUrl("html/PServiceManage/KEY012.html", function($location) {
    $scope.voucherListQueryModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.voucherListQueryModal.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.openVoucherList = function() {
    $state.go("eventmenu.KEY254");
  };
  /**
   * @return {undefined}
   */
  $scope.getVoucherNum = function() {
    loading.show(true);
    createDom({
      page : page
    }).success(function(result) {
      if (result.records) {
        $scope.voucherNum = result.records;
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {string} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    /** @type {string} */
    var rreturn = current.mgrServer + "/KEY249";
    return ret.fullPathPostEncode(rreturn, opt_attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page
    }).success(function(options) {
      $scope.myItems = $scope.myItems.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      /** @type {number} */
      var i = 0;
      for (;i < $scope.myItems.length;i++) {
        /** @type {number} */
        var j = 0;
        for (;j < $scope.items.length;j++) {
          if ($scope.myItems[i].serviceType == $scope.items[j].serviceType) {
            $scope.myItems[i].shopUrl = $scope.items[j].shopUrl;
            $scope.myItems[i].htmlName = $scope.items[j].htmlName;
            $scope.myItems[i].url = $scope.items[j].url;
            $scope.myItems[i].category = $scope.items[j].category;
            $scope.myItems[i].name = $scope.items[j].name;
          }
        }
      }
    }).finally(function() {
      parent.resize("voucherListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    fn().then(function(buffer) {
      /** @type {Array} */
      var results = [];
      /** @type {number} */
      var i = 0;
      var l = buffer.length;
      for (;l > i;i++) {
        if ($scope.isExceptionForAppStore) {
          if (1 == buffer[i].category) {
            /** @type {number} */
            buffer[i].category = 9;
          } else {
            if (99 == buffer[i].category) {
              /** @type {number} */
              buffer[i].category = 1;
              results.push(buffer[i]);
            } else {
              results.push(buffer[i]);
            }
          }
        } else {
          results.push(buffer[i]);
        }
      }
      /** @type {Array} */
      $scope.items = results;
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
    $scope.getVoucherNum();
    if (window.cordova) {
      if ("undefined" != typeof MobclickAgent) {
        MobclickAgent.onEventWithLabel("openVaServiceList", "打开增值服务列表");
      }
    }
  });
}]).controller("MyVaServiceCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "Tools", "lbSpinnerDialog", "$window", "$q", "$http", "ServerConfig", function($scope, dataAndEvents, ret, widget, _, loading, deepDataAndEvents, $q, $templateCache, current) {
  /**
   * @return {?}
   */
  function fn() {
    var imageDfd = $q.defer();
    var name = current.currentServer.replace("/is", "").replace("ex.", "www.").replace("web.", "www.");
    /** @type {string} */
    var val = "va_service_list" + ($scope.platformIsIOS ? "_ios.json" : "_android.json");
    return $templateCache.get(name + "/download/" + val + "?random=" + _.getTimeStamp()).success(function(image) {
      imageDfd.resolve(image);
    }).error(function() {
      console.error("从服务器获取增值服务信息异常！");
      imageDfd.reject();
    }), imageDfd.promise;
  }
  $scope.queryCondition = {
    state : 0,
    category : 0
  };
  /** @type {boolean} */
  $scope.isLoading = true;
  /** @type {number} */
  var page = 1;
  /** @type {string} */
  var camelKey = current.mgrServer + "/KEY251";
  $scope.$on("$destroy", function() {
  });
  /**
   * @param {number} dataAndEvents
   * @return {?}
   */
  $scope.filterServiceName = function(dataAndEvents) {
    /** @type {string} */
    var optsData = "";
    return 1 == dataAndEvents ? optsData = "草稿" : 2 == dataAndEvents ? optsData = "待审核" : 3 == dataAndEvents ? optsData = "待付款" : 4 == dataAndEvents ? optsData = "处理中" : 5 == dataAndEvents ? optsData = "已完成" : -1 == dataAndEvents && (optsData = "已撤销"), optsData;
  };
  /**
   * @param {string} opt_attributes
   * @param {string} key
   * @return {?}
   */
  var dataAttr = function(opt_attributes, key) {
    return ret.fullPathPostEncode(key, opt_attributes);
  };
  /**
   * @param {boolean} helper
   * @param {boolean} view
   * @return {?}
   */
  $scope.serviceListStyle = function(helper, view) {
    return helper ? "" : view ? "" : "lb-payment-no-service";
  };
  /**
   * @return {undefined}
   */
  $scope.getMyService = function() {
    /** @type {Array} */
    $scope.myItems = [];
    /** @type {number} */
    page = 1;
    dataAttr({
      status : "",
      page : page
    }, camelKey).success(function(results) {
      $scope.myItems = results.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = results.page < results.total;
      /** @type {number} */
      var i = 0;
      for (;i < $scope.myItems.length;i++) {
        /** @type {number} */
        var j = 0;
        for (;j < $scope.items.length;j++) {
          if ($scope.myItems[i].serviceType == $scope.items[j].serviceType) {
            $scope.myItems[i].shopUrl = $scope.items[j].shopUrl;
            $scope.myItems[i].htmlName = $scope.items[j].htmlName;
            $scope.myItems[i].url = $scope.items[j].url;
            $scope.myItems[i].category = $scope.items[j].category;
            $scope.myItems[i].name = $scope.items[j].name;
            $scope.myItems[i].appId = $scope.items[j].appId;
          }
        }
      }
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    dataAttr({
      status : "",
      page : ++page
    }, camelKey).success(function(options) {
      $scope.myItems = $scope.myItems.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      /** @type {number} */
      var i = 0;
      for (;i < $scope.myItems.length;i++) {
        /** @type {number} */
        var j = 0;
        for (;j < $scope.items.length;j++) {
          if ($scope.myItems[i].serviceType == $scope.items[j].serviceType) {
            $scope.myItems[i].shopUrl = $scope.items[j].shopUrl;
            $scope.myItems[i].htmlName = $scope.items[j].htmlName;
            $scope.myItems[i].url = $scope.items[j].url;
            $scope.myItems[i].category = $scope.items[j].category;
            $scope.myItems[i].name = $scope.items[j].name;
            $scope.myItems[i].appId = $scope.items[j].appId;
          }
        }
      }
    }).finally(function() {
      widget.resize("myVaServiceCtrlScroll");
    });
  };
  /**
   * @param {Object} worker
   * @return {undefined}
   */
  $scope.cancleApply = function(worker) {
    /** @type {string} */
    var header = "您确认要撤销此服务？";
    /** @type {string} */
    var rreturn = current.mgrServer + "/KEY252";
    if (window.cordova && window.cordova.plugins) {
      _.showConfirm(header, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          loading.show(true);
          ret.fullPathPostEncode(rreturn, {
            id : worker.id
          }).success(function(res) {
            if (1 == res.statusCode) {
              _.toastShow("撤销成功");
              /** @type {number} */
              worker.status = -1;
            } else {
              _.toastShow(res.content);
            }
          }).finally(function() {
            loading.hide();
          });
        }
      }, "提示", ["取消", "确认"]);
    } else {
      var promise = $ionicPopup.confirm({
        template : header,
        cancelText : "取消",
        okText : "确认"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          loading.show(true);
          ret.fullPathPostEncode(rreturn, {
            id : worker.id
          }).success(function(res) {
            if (1 == res.statusCode) {
              _.toastShow("撤销成功");
              /** @type {number} */
              worker.status = -1;
            } else {
              _.toastShow(res.content);
            }
          }).finally(function() {
            loading.hide();
          });
        }
      });
    }
  };
  /**
   * @param {Element} $attrs
   * @return {undefined}
   */
  $scope.payForService = function($attrs) {
    /** @type {string} */
    var node = current.mgrServer + "/payservice/payMobileForService.ac?id=" + $attrs.id + "&clientType=app";
    $scope.openLinkInIframe($attrs.serviceTypeName, node);
  };
  /**
   * @param {string} options
   * @return {undefined}
   */
  $scope.renewForService = function(options) {
    /** @type {string} */
    var node = "";
    /** @type {string} */
    node = options.appId ? current.mgrServer + "/app/openMyAppPageOnMobile.ac?id=" + options.appId + "&clientType=app" : current.mgrServer + "/paymentservice/payServiceCommonMobileApply.ac?serviceType=" + options.serviceType + "&clientType=app";
    if (!_.isEmpty(node)) {
      $scope.openLinkInIframe(options.serviceTypeName, node);
    }
  };
  /**
   * @param {Object} options
   * @param {string} dataAndEvents
   * @return {undefined}
   */
  $scope.editForService = function(options, dataAndEvents) {
    /** @type {string} */
    var node = "";
    if (!options.appId) {
      /** @type {string} */
      node = current.mgrServer + "/paymentservice/payServiceCommonMobileApply.ac?serviceType=" + options.serviceType + "&operateType=" + dataAndEvents + "&applyId=" + options.id;
    }
    if (!_.isEmpty(node)) {
      $scope.openLinkInIframe(options.serviceTypeName, node);
    }
  };
  $scope.$on("$ionicView.loaded", function() {
    if ($scope.isExceptionForAppStore) {
      /** @type {boolean} */
      $scope.isLoading = false;
    } else {
      fn().then(function(data) {
        $scope.items = data;
        $scope.getMyService();
      });
    }
  });
}]).controller("VoucherListCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "Tools", "lbSpinnerDialog", "$window", "ServerConfig", function($scope, $state, ret, widget, deepDataAndEvents, loading, ignoreMethodDoesntExist, dataAndEvents) {
  /** @type {boolean} */
  $scope.isLoading = true;
  /** @type {number} */
  var page = 1;
  /**
   * @return {undefined}
   */
  $scope.getVoucherList = function() {
    loading.show(true);
    createDom({
      page : page
    }).success(function(results) {
      $scope.KEY254 = results.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = results.page < results.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      widget.resize("voucherListCtrlScroll");
      loading.hide();
    });
  };
  /**
   * @param {string} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    /** @type {string} */
    var rreturn = dataAndEvents.mgrServer + "/KEY249";
    return ret.fullPathPostEncode(rreturn, opt_attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    loading.show(true);
    createDom({
      page : ++page
    }).success(function(options) {
      $scope.KEY254 = $scope.KEY254.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      widget.resize("voucherListCtrlScroll");
      loading.hide();
    });
  };
  /**
   * @param {string} item
   * @return {undefined}
   */
  $scope.clickList = function(item) {
    if ("normal" === item.status) {
      if (0 != item.balance) {
        $state.go("eventmenu.KEY244");
      }
    }
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getVoucherList();
  });
}]).controller("PayServiceApplyCtrl", ["$scope", "$state", "Tools", "lbSpinnerDialog", "psisServices", "ServerConfig", "$stateParams", "$sce", "HandleMessageService", function(scope, deepDataAndEvents, ignoreMethodDoesntExist, textAlt, keepData, dataAndEvents, service, $sce, self) {
  var options = service.serviceType;
  /** @type {string} */
  scope.title = 6 == service.serviceType ? "培训服务" : 9 == service.serviceType ? "专属顾问" : 10 == service.serviceType ? "数据初始化" : "增值服务";
  /** @type {string} */
  scope.currentUrl = dataAndEvents.mgrServer + "/paymentservice/payServiceCommonMobileApply.ac?serviceType=" + options + "&clientType=app";
  scope.currentUrl = $sce.trustAsResourceUrl(scope.currentUrl);
  /**
   * @param {Object} event
   * @return {undefined}
   */
  var completed = function(event) {
    self.handleMessage(event, scope);
  };
  window.addEventListener("message", completed, false);
  scope.$on("$destroy", function() {
    window.removeEventListener("message", completed, false);
  });
}]).controller("SmsSettingCtrl", ["$scope", "psisServices", "lbSpinnerDialog", "$ionicPopup", "$rootScope", "Tools", "ServerConfig", "$state", "$ionicModal", "ServerType", function(self, socket, loading, _, deepDataAndEvents, db, ignoreMethodDoesntExist, assert, $modal, dataAndEvents) {
  /** @type {string} */
  self.viewTitle = "短信中心";
  self.smsConfig = {};
  $modal.fromTemplateUrl("KEY249.html", function(theTitle) {
    self.smsTemplateModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("smsInfoEdit.html", function(theTitle) {
    /** @type {number} */
    self.smsInfoEditModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @param {number} resolved
   * @return {undefined}
   */
  self.openSmsInfoEditModal = function(resolved) {
    self.oldValue = {
      signName : self.smsConfig.signName ? self.smsConfig.signName : self.mainCompany.comName,
      emergencyMobile : self.smsConfig.emergencyMobile
    };
    self.smsInfoEditModal.show();
    /** @type {boolean} */
    self.isSignNameEdit = 1 == resolved;
  };
  /**
   * @return {undefined}
   */
  self.closeSmsInfoEditModal = function() {
    self.smsInfoEditModal.hide();
    self.smsConfig.signName = self.oldValue.signName;
    self.smsConfig.emergencyMobile = self.oldValue.emergencyMobile;
  };
  self.$on("$destroy", function() {
    self.smsTemplateModal.remove();
    self.smsInfoEditModal.remove();
  });
  /**
   * @return {undefined}
   */
  self.goSmsPay = function() {
    assert.go("eventmenu.KEY234", {
      title : "短信服务",
      currentUrl : "/mgr/paymentservice/payServiceCommonMobileApply.ac?serviceType=17"
    });
  };
  /**
   * @param {string} encoding
   * @return {undefined}
   */
  self.goState = function(encoding) {
    var enc = encoding ? encoding : "eventmenu.KEY195";
    assert.go(enc);
  };
  /**
   * @param {?} theTitle
   * @return {undefined}
   */
  self.selectSMSTemplate = function(theTitle) {
    self.smTemplateTypes = theTitle;
    self.smsTemplateModal.show();
  };
  /** @type {Array} */
  self.selectedItems = [];
  /**
   * @param {Object} u
   * @return {undefined}
   */
  self.selectTemplate = function(u) {
    /** @type {number} */
    var pos = -1;
    /** @type {number} */
    var i = 0;
    for (;i < self.selectedItems.length;i++) {
      if (self.selectedItems[i].type == u.type) {
        /** @type {number} */
        pos = i;
        break;
      }
    }
    if (pos > -1) {
      if (self.selectedItems[pos].id != u.id) {
        self.selectedItems.push(u);
        if (dataAndEvents.isEX()) {
          db.toastShow("体验环境短信模板启用后暂不支持发送短信", "long");
        }
        self.setSmConfig(u, 1);
      }
      self.setSmConfig(self.selectedItems[i], 0);
      self.selectedItems.splice(pos, 1);
    } else {
      self.selectedItems.push(u);
      if (dataAndEvents.isEX()) {
        db.toastShow("体验环境短信模板启用后暂不支持发送短信", "long");
      }
      self.setSmConfig(u, 1);
    }
  };
  /** @type {Array} */
  self.smCategory = [];
  /**
   * @return {undefined}
   */
  self.getSmConfigList = function() {
    loading.show();
    socket.post("/KEY425").success(function(doc) {
      if (doc.object && doc.object.length > 0) {
        /** @type {number} */
        var i = 0;
        for (;i < doc.object.length;i++) {
          var info = doc.object[i];
          var cats = db.fnCheckGtoreQty(self.smCategory, "category", info.category);
          if (!cats) {
            var b = db.getObjectList(doc.object, "category", info.category);
            if (b && b.length > 0) {
              /** @type {Array} */
              var params = [];
              /** @type {number} */
              var bi = 0;
              for (;bi < b.length;bi++) {
                var elem = b[bi];
                var listener = db.fnCheckGtoreQty(params, "type", elem.type);
                if (!listener) {
                  var dom = db.getObjectList(b, "type", elem.type);
                  params.push({
                    type : elem.type,
                    name : elem.name,
                    smTemplate : dom
                  });
                }
              }
            }
            self.smCategory.push({
              category : info.category,
              smCategory : params
            });
          }
        }
        /** @type {number} */
        var j = 0;
        for (;j < doc.object.length;j++) {
          var target = doc.object[j];
          if (1 == target.state) {
            self.selectedItems.push(target);
          }
          if (/\$\{([a-zA-Z]*)\}/.test(target.templateContent)) {
            target.templateContent = target.templateContent.replace(/\$\{([a-zA-Z]*)\}/g, "xx");
          }
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {Object} c
   * @param {number} recurring
   * @return {undefined}
   */
  self.setSmConfig = function(c, recurring) {
    var id = c.id;
    loading.show();
    socket.postEncode("/KEY431", {
      templateId : id,
      state : recurring
    }).success(function(result) {
      if (1 == result.statusCode) {
        db.toastShow("操作成功");
      } else {
        var pos = self.selectedItems.indexOf(c);
        if (pos > -1) {
          self.selectedItems.splice(pos, 1);
        }
        db.toastShow(result.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {string} callback
   * @return {undefined}
   */
  var post = function(callback) {
    if (window.cordova && window.cordova.plugins) {
      db.showAlert("", null, callback, "确定");
    } else {
      _.alert({
        template : "<div class='tc'>" + callback + "</div>",
        okText : "确定"
      });
    }
  };
  /**
   * @param {?} dataAndEvents
   * @param {?} qualifier
   * @return {?}
   */
  self.saveSmsConfig = function(dataAndEvents, qualifier) {
    /** @type {RegExp} */
    var isSimple = /[^\da-zA-Z一-龥]/;
    if (!(qualifier && (qualifier.length >= 3 && qualifier.length <= 8)) || isSimple.test(qualifier)) {
      /** @type {string} */
      var restoreScript = "签名请输入中文、字母、数字，长度为3到8个字";
      return post(restoreScript), false;
    }
    loading.show(true);
    socket.postEncode("/KEY415", {
      emergencyMobile : "",
      signName : qualifier
    }).success(function(result) {
      if (1 == result.statusCode) {
        db.toastShow("保存成功");
        self.smsInfoEditModal.hide();
      } else {
        db.toastShow(result.content);
      }
    }).error(function() {
      if (window.cordova && window.cordova.plugins) {
        db.showAlert("保存失败", null, "提示");
      } else {
        _.alert({
          template : "<div class='tc'>保存失败</div>",
          okText : "确定"
        });
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.getSmsAccountInfo = function() {
    loading.show();
    socket.post("/KEY416").success(function(reply) {
      if (reply) {
        if (reply.object) {
          self.smsConfig = reply.object;
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
  self.getSmsAccountInfo();
  self.getSmConfigList();
}]).controller("SmsRecordCtrl", ["$scope", "psisServices", "lbScrollDelegate", "$ionicModal", "Tools", "lbSpinnerDialog", "$cordovaDatePicker", function($scope, newCanvas, parent, $modal, dataAndEvents, loading, scope) {
  /** @type {boolean} */
  $scope.isLoading = true;
  /** @type {Array} */
  $scope.items = [];
  $scope.queryCondition = {};
  $scope.smsObject = {
    beginTime : (new Date).setDate((new Date).getDate() - 6),
    endTime : (new Date).setDate((new Date).getDate())
  };
  $modal.fromTemplateUrl("smsRecordFilter.html", function($location) {
    /** @type {number} */
    $scope.smsRecordFilterModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.smsRecordFilterModal.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : $scope.smsObject.beginTime ? new Date($scope.smsObject.beginTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.smsObject.beginTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : $scope.smsObject.endTime ? new Date($scope.smsObject.endTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.smsObject.endTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  var getLayerInfo = function() {
    if ($scope.smsObject.beginTime) {
      $scope.queryCondition.beginTime = dataAndEvents.getDayBeginStr($scope.smsObject.beginTime);
    } else {
      delete $scope.queryCondition.beginTime;
    }
    if ($scope.smsObject.endTime) {
      $scope.queryCondition.endTime = dataAndEvents.getOffsetDayBeginStr($scope.smsObject.endTime, 1);
    } else {
      delete $scope.queryCondition.endTime;
    }
  };
  /**
   * @return {undefined}
   */
  $scope.resizeContentArea = function() {
    parent.resize("smsRecordCtrlScroll");
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var Step = function(opt_attributes) {
    return newCanvas.postEncode("/KEY433", opt_attributes);
  };
  /**
   * @return {?}
   */
  $scope.getSmsBill = function() {
    return dataAndEvents.isInDays($scope.smsObject.beginTime, $scope.smsObject.endTime, 30) ? ($scope.getList(), void $scope.smsRecordFilterModal.hide()) : (dataAndEvents.toastShow("查询时间必须为30天内"), false);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show();
    getLayerInfo();
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step($scope.queryCondition).success(function(options) {
      if (options) {
        if (options.object) {
          if (options.object.rows) {
            $scope.items = options.object.rows;
            /** @type {boolean} */
            $scope.loadMoreBtn = options.page < options.total;
          }
        }
      }
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.scrollTop("smsRecordCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    Step($scope.queryCondition).success(function(options) {
      if (options) {
        if (options.object) {
          if (options.object.rows) {
            $scope.items = $scope.items.concat(options.object.rows);
            /** @type {boolean} */
            $scope.loadMoreBtn = options.page < options.total;
          }
        }
      }
    }).finally(function() {
      parent.resize("smsRecordCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step($scope.queryCondition).success(function(options) {
      if (options) {
        if (options.object) {
          if (options.object.rows) {
            $scope.items = options.object.rows;
            /** @type {boolean} */
            $scope.loadMoreBtn = options.page < options.total;
          }
        }
      }
    }).finally(function() {
      $scope.$broadcast("scroll.refreshComplete");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.clearQueryCondition = function() {
    $scope.smsObject = {
      beginTime : (new Date).setDate((new Date).getDate() - 6),
      endTime : (new Date).setDate((new Date).getDate())
    };
  };
  $scope.getList();
}]).controller("SmsTemplateCtrl", ["$scope", "psisServices", "lbScrollDelegate", "$ionicModal", "Tools", "lbSpinnerDialog", "$ionicPopup", function($scope, $http, $window, $modal, res, loading, view) {
  /** @type {boolean} */
  $scope.isLoading = true;
  /** @type {Array} */
  $scope.items = [];
  $scope.smsConfig = {};
  $scope.templateObj = {
    name : "",
    templateContent : ""
  };
  $modal.fromTemplateUrl("applyTemplate.html", function($location) {
    /** @type {number} */
    $scope.applyTemplateModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @param {number} dataAndEvents
   * @return {undefined}
   */
  $scope.openApplyTemplateModal = function(dataAndEvents) {
    $scope.oldValue = {
      name : $scope.templateObj.name,
      templateContent : $scope.templateObj.templateContent
    };
    $scope.applyTemplateModal.show();
    /** @type {boolean} */
    $scope.isSignNameEdit = 1 == dataAndEvents;
  };
  /**
   * @return {undefined}
   */
  $scope.closeApplyTemplateModal = function() {
    $scope.applyTemplateModal.hide();
    $scope.templateObj.name = $scope.oldValue.name;
    $scope.templateObj.templateContent = $scope.oldValue.templateContent;
  };
  $scope.$on("$destroy", function() {
    $scope.applyTemplateModal.remove();
  });
  /**
   * @return {?}
   */
  var getEncodedLen = function() {
    return $http.post("/KEY391");
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show();
    getEncodedLen().success(function(data) {
      if (data) {
        if (data.object) {
          $scope.items = data.object;
        }
      }
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      $window.scrollTop("smsRecordCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getSmsAccountInfo = function() {
    loading.show();
    $http.post("/KEY416").success(function(data) {
      if (data) {
        if (data.object) {
          $scope.smsConfig = data.object;
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {number} dataAndEvents
   * @param {?} WIDTH
   * @return {?}
   */
  $scope.getNumberOfSm = function(dataAndEvents, WIDTH) {
    if (dataAndEvents > 0) {
      /** @type {number} */
      var SCREENX = dataAndEvents;
      /** @type {number} */
      var o = 1;
      return SCREENX > 70 && (SCREENX -= 67, o += SCREENX % WIDTH == 0 ? SCREENX / WIDTH : (WIDTH - SCREENX % WIDTH + SCREENX) / WIDTH), o;
    }
  };
  /**
   * @return {undefined}
   */
  $scope.fixTemplateContent = function() {
    if ($scope.templateObj.templateContent) {
      if ($scope.smsConfig.signName) {
        if ($scope.templateObj.templateContent.length + $scope.smsConfig.signName.length + 6 > 134) {
          $scope.templateObj.templateContent = $scope.templateObj.templateContent.substr(0, 134 - $scope.smsConfig.signName.length - 6);
        }
      }
    }
  };
  /**
   * @return {?}
   */
  $scope.applyTemplate = function() {
    /**
     * @return {undefined}
     */
    function fn() {
      loading.show();
      $http.postEncode("/KEY413", {
        name : $scope.templateObj.name,
        templateContent : $scope.templateObj.templateContent
      }).success(function(r) {
        if (1 == r.statusCode) {
          res.toastShow("操作成功");
          $scope.templateObj = {
            name : "",
            templateContent : ""
          };
          $scope.applyTemplateModal.hide();
          $scope.getList();
        } else {
          res.toastShow(r.content);
        }
      }).finally(function() {
        loading.hide();
      });
    }
    if (!($scope.templateObj.name && $scope.templateObj.name.length > 0)) {
      return res.toastShow("请输入模板名称"), false;
    }
    if (!($scope.templateObj.templateContent && $scope.templateObj.templateContent.length > 0)) {
      return res.toastShow("请填写短信模板"), false;
    }
    /** @type {string} */
    var errStr = "确认申请短信模板？";
    if (window.cordova && window.cordova.plugins) {
      res.showConfirm(errStr, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          $scope.$apply(function() {
            fn();
          });
        }
      }, "再次确认", ["取消", "确认"]);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : "<div>" + errStr + "</div>",
        title : "再次确认",
        scope : $scope,
        buttons : [{
          text : "确认",
          /**
           * @return {undefined}
           */
          onTap : function() {
            fn();
          }
        }, {
          text : "取消",
          type : "button-assertive"
        }]
      });
    }
  };
  $scope.getList();
  $scope.getSmsAccountInfo();
}]).controller("SmBatchSendingCtrl", ["$scope", "psisServices", "lbSpinnerDialog", "$ionicPopup", "$rootScope", "Tools", "ServerConfig", "$state", "$ionicModal", "ServerType", function(self, $http, loading, view, dataAndEvents, $rootScope, deepDataAndEvents, ignoreMethodDoesntExist, $modal) {
  /** @type {string} */
  self.viewTitle = "短信群发";
  self.smsConfig = {};
  /** @type {Array} */
  self.smTemplate = [];
  /** @type {Array} */
  self.items = [];
  self.selectObj = {
    isSelectAll : true
  };
  $modal.fromTemplateUrl("html/PClientBaseInfo/KEY039.html", function(theTitle) {
    /** @type {number} */
    self.KEY039 = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up",
    focusFirstInput : false
  });
  /**
   * @return {undefined}
   */
  self.openClientMultiSelectModal = function() {
    self.KEY039.show();
  };
  /**
   * @return {undefined}
   */
  self.closeClientMultiSelectModal = function() {
    self.KEY039.hide();
    $rootScope.keyboardHide();
  };
  $modal.fromTemplateUrl("KEY249.html", function(theTitle) {
    self.smsTemplateModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.smsTemplateModal.remove();
    self.KEY039.remove();
  });
  /**
   * @param {Object} _xhr
   * @return {?}
   */
  self.filterTemplate = function(_xhr) {
    return _xhr && 1 == _xhr.state;
  };
  /** @type {Array} */
  self.selectedTemplate = [];
  /**
   * @param {?} spaceName
   * @return {undefined}
   */
  self.selectTemplate = function(spaceName) {
    if (self.selectedTemplate.length > 0) {
      self.selectedTemplate.splice(0);
    }
    self.selectedTemplate.push(spaceName);
  };
  self.checklist = {};
  /** @type {Array} */
  self.checklist.selectedClients = [];
  /**
   * @return {undefined}
   */
  self.ensurePushClients = function() {
    self.KEY039.hide();
  };
  /**
   * @param {number} $p2
   * @param {?} b
   * @return {?}
   */
  self.getNumberOfSm = function($p2, b) {
    if ($p2 > 0) {
      /** @type {number} */
      var a = $p2;
      /** @type {number} */
      var o = 1;
      return a > 70 && (a -= 67, o += a % b == 0 ? a / b : (b - a % b + a) / b), o;
    }
  };
  /** @type {Array} */
  self.smCategory = [];
  /**
   * @return {undefined}
   */
  self.getSmTemplates = function() {
    loading.show();
    $http.post("/KEY391").success(function(res) {
      if (res && 1 == res.statusCode) {
        self.smTemplate = res.object;
        /** @type {number} */
        var i = 0;
        for (;i < self.smTemplate.length;i++) {
          if (!self.filterTemplate(self.smTemplate[i])) {
            self.smTemplate.splice(i, 1);
            i--;
          }
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {string} e
   * @return {undefined}
   */
  var cb = function(e) {
    if (window.cordova && window.cordova.plugins) {
      $rootScope.showAlert("", null, e, "确定");
    } else {
      view.alert({
        template : "<div class='tc'>" + e + "</div>",
        okText : "确定"
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.getSmsAccountInfo = function() {
    loading.show();
    $http.post("/KEY416").success(function(opts) {
      if (opts && opts.object) {
        self.smsConfig = opts.object;
      } else {
        self.smsConfig.signName = self.mainCompany.comName;
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {Element} elem
   * @return {?}
   */
  self.getIndexOfSelectClient = function(elem) {
    /** @type {number} */
    var declarationError = -1;
    /** @type {number} */
    var e = 0;
    for (;e < self.checklist.selectedClients.length;e++) {
      if (self.checklist.selectedClients[e].id == elem.id) {
        /** @type {number} */
        declarationError = e;
        break;
      }
    }
    return declarationError;
  };
  /**
   * @param {Element} arg
   * @return {undefined}
   */
  self.selectClients = function(arg) {
    var keyName = self.getIndexOfSelectClient(arg);
    if (!(keyName > -1)) {
      self.checklist.selectedClients.push(arg);
    }
  };
  /**
   * @param {?} player
   * @return {?}
   */
  self.filterClient = function(player) {
    return player.cellphone && (player.cellphone.length > 0 && $rootScope.isValidCellPhoneNo(player.cellphone));
  };
  /** @type {number} */
  var page = 0;
  /**
   * @return {undefined}
   */
  self.selectAllClient = function() {
    loading.show();
    page++;
    $http.postEncode("/KEY340", {
      maxPageSize : 500,
      page : page
    }).success(function(results) {
      if (results && (results.rows && results.rows.length > 0)) {
        if (self.items = self.items.concat(results.rows), self.loadMoreBtn = results.page < results.total, self.loadMoreBtn) {
          self.selectAllClient();
        } else {
          /** @type {Array} */
          self.checklist.selectedClients = [];
          /** @type {number} */
          var i = 0;
          for (;i < self.items.length;i++) {
            if (self.filterClient(self.items[i])) {
              self.selectClients(self.items[i]);
            }
          }
          /** @type {number} */
          page = 0;
          /** @type {boolean} */
          self.selectObj.isSelectAll = false;
        }
      } else {
        $rootScope.toastShow("暂无录有手机号客户可选");
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {?}
   */
  self.KEY185 = function() {
    if (!(self.selectedTemplate && self.selectedTemplate.length > 0)) {
      return $rootScope.toastShow("请选择发送的短信模板"), false;
    }
    if (!(self.checklist.selectedClients && self.checklist.selectedClients.length > 0)) {
      return $rootScope.toastShow("请选择客户"), false;
    }
    /** @type {string} */
    var failure = "对已选择的客户发送短信，扣除相应的短信条数";
    if (window.cordova && window.cordova.plugins) {
      $rootScope.showConfirm(failure, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          self.$apply(function() {
            /** @type {Array} */
            var collection = [];
            /** @type {number} */
            var i = 0;
            for (;i < self.checklist.selectedClients.length;i++) {
              var client = self.checklist.selectedClients[i];
              if (client.id > 0) {
                if (client.cellphone) {
                  if (client.cellphone.length > 0) {
                    collection.push({
                      clientId : client.id,
                      targetCellphone : client.cellphone,
                      targetName : client.clientName
                    });
                  }
                }
              }
            }
            /** @type {Array} */
            self.KEY269 = collection;
            self.sendSmBatch(self.KEY269);
          });
        }
      }, "确认群发短信", ["取消", "确认"]);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : "<div>" + failure + "</div>",
        title : "再次确认",
        scope : self,
        buttons : [{
          text : "确认",
          /**
           * @return {undefined}
           */
          onTap : function() {
            /** @type {Array} */
            var collection = [];
            /** @type {number} */
            var i = 0;
            for (;i < self.checklist.selectedClients.length;i++) {
              var client = self.checklist.selectedClients[i];
              if (client.id > 0) {
                if (client.cellphone) {
                  if (client.cellphone.length > 0) {
                    collection.push({
                      clientId : client.id,
                      targetCellphone : client.cellphone,
                      targetName : client.clientName
                    });
                  }
                }
              }
            }
            /** @type {Array} */
            self.KEY269 = collection;
            self.sendSmBatch(self.KEY269);
          }
        }, {
          text : "取消",
          type : "button-assertive"
        }]
      });
    }
  };
  /**
   * @param {(Array|string)} deepDataAndEvents
   * @return {?}
   */
  self.sendSmBatch = function(deepDataAndEvents) {
    if (self.sending = true, self.hasSendCount = 0, self.maxCountPerBatch = 500, self.totalSendCount = 0, self.successPhones = 0, self.totalSendCount = self.KEY269 > self.maxCountPerBatch ? Math.ceil(self.KEY269.length / self.maxCountPerBatch) : self.KEY269.length, deepDataAndEvents && self.processConfigTask.initTask(deepDataAndEvents), self.processConfigTask.isTaskEnd()) {
      return true;
    }
    if (self.processConfigTask.getAllCount() <= self.maxCountPerBatch) {
      /** @type {string} */
      self.sendMessage = "发送中...";
    } else {
      var valsLength;
      /** @type {number} */
      var diff = self.processConfigTask.batch * self.maxCountPerBatch + 1;
      if (self.KEY269.length - diff > self.maxCountPerBatch) {
        /** @type {number} */
        valsLength = diff + self.maxCountPerBatch - 1;
        /** @type {string} */
        self.sendMessage = "正在发送第" + diff + "至" + valsLength + "位客户，请稍后...";
      } else {
        valsLength = self.KEY269.length;
        /** @type {string} */
        self.sendMessage = "正在发送第" + valsLength + "位客户，请稍后...";
      }
    }
    var pdataCur = self.processConfigTask.nextTaskList();
    self.sendSm(pdataCur);
  };
  /**
   * @param {?} data
   * @return {undefined}
   */
  self.sendSm = function(data) {
    var keep = self.selectedTemplate[0].templateId;
    $http.post("/admin/inner/sms/sendSmBatch.ac?templateId=" + keep, data, {
      headers : {
        "Content-Type" : "application/json; charset=UTF-8"
      }
    }).success(function(res) {
      if (self.hasSendCount++, res.content) {
        if (1 == res.statusCode) {
          if (self.successPhones += res.object.successPhones, self.failPhones += res.object.failPhones, self.processConfigTask.isTaskEnd()) {
            /** @type {string} */
            var evt = "";
            evt = 1 == self.processConfigTask.batch ? res.content : "短信已经发送！详细发送情况请到发送记录查看！";
            cb(evt);
            self.processConfigTask.reset();
            /** @type {boolean} */
            self.sending = false;
            self.clearBatchInfo();
            self.getSmsAccountInfo();
          } else {
            self.sendSmBatch();
          }
        } else {
          cb(res.content);
          /** @type {boolean} */
          self.sending = false;
        }
      }
    }).error(function() {
      /** @type {boolean} */
      self.sending = false;
    });
  };
  /** @type {number} */
  self.maxCountPerBatch = 500;
  self.processConfigTask = {
    taskList : [],
    stepSize : self.maxCountPerBatch,
    batch : 0,
    stepIndex : 0,
    tips : "",
    /**
     * @return {?}
     */
    getAllCount : function() {
      return this.taskList.length;
    },
    /**
     * @param {Array} deepDataAndEvents
     * @return {undefined}
     */
    initTask : function(deepDataAndEvents) {
      /** @type {Array} */
      this.taskList = deepDataAndEvents;
      this.stepSize = self.maxCountPerBatch;
      /** @type {string} */
      this.tips = "";
      /** @type {number} */
      this.stepIndex = 0;
      /** @type {number} */
      this.batch = 0;
    },
    /**
     * @return {?}
     */
    nextTaskList : function() {
      var num = this.stepIndex + this.stepSize;
      if (num >= this.getAllCount()) {
        num = this.getAllCount();
      }
      this.batch += 1;
      var indexForNum = this.taskList.slice(this.stepIndex, num);
      return this.stepIndex = num, indexForNum;
    },
    /**
     * @return {?}
     */
    isTaskEnd : function() {
      return this.stepIndex >= this.getAllCount() ? true : void 0;
    },
    /**
     * @return {undefined}
     */
    reset : function() {
      /** @type {Array} */
      this.taskList = [];
      this.stepSize = self.maxCountPerBatch;
      /** @type {string} */
      this.tips = "";
      /** @type {number} */
      this.stepIndex = 0;
      /** @type {number} */
      this.batch = 0;
    }
  };
  /**
   * @return {undefined}
   */
  self.clearBatchInfo = function() {
    self.templateId = {};
    /** @type {Array} */
    self.KEY269 = [];
  };
  self.getSmTemplates();
  self.getSmsAccountInfo();
}]).controller("VaApplyCtrl", ["$scope", "$state", "Tools", "lbSpinnerDialog", "psisServices", "ServerConfig", "$stateParams", "$sce", "HandleMessageService", "$ionicPopup", function(scope, dataAndEvents, deepDataAndEvents, ignoreMethodDoesntExist, textAlt, event, data, $sce, self) {
  var type = event.currentServer;
  var tag = data.htmlName;
  scope.title = data.title;
  /** @type {number} */
  var p = 1;
  var front = event.currentServer.replace("/is", "").replace("ex.", "www.").replace("web.", "www.");
  if (type.indexOf("ex") > -1) {
    /** @type {number} */
    p = 2;
  } else {
    if (type.indexOf("dev") > -1) {
      /** @type {number} */
      p = 3;
    }
  }
  tag = tag ? tag : "associatorRecharge.html";
  scope.title = scope.title ? scope.title : "进销存会员";
  /** @type {string} */
  scope.currentUrl = front + "/m/va/" + tag + "?type=" + p + "&clientType=app";
  if ("associatorRecharge.html" == tag) {
    if (scope.getAppAccResource(3)) {
      /** @type {string} */
      scope.currentUrl = event.currentServer + "/KEY414";
    }
  }
  if ("collection.html" == tag) {
    /** @type {string} */
    scope.currentUrl = front + "/isAppHtml/m/va/" + tag + "?type=" + p + "&clientType=app";
  }
  scope.currentUrl = $sce.trustAsResourceUrl(scope.currentUrl);
  /**
   * @param {Object} event
   * @return {undefined}
   */
  var completed = function(event) {
    self.handleMessage(event, scope);
  };
  window.addEventListener("message", completed, false);
  scope.$on("$destroy", function() {
    window.removeEventListener("message", completed, false);
  });
}]);
