angular.module("signinController", ["ionic", "services", "tools"]).controller('signinMapCtrl', ["$scope", "psisServices", "Tools", "$ionicModal", "$q", "$ionicPopup", function ($scope, $http, $tool, $modal, $q, $popup) {
    $scope.signInInfo = {
      isOffLine: 0,         //离线/自动签到标志     0未开启  1开启
      address: '',          //定位地址
      longitude: '',        //经度
      latitude: '',         //纬度
      map: {},              //地图对象
      signNum: '',          //签到次数
      comName: '',          //单位名称
      clientId: '',         //单位id
      clientType: 0         //单位类型
    };

    var longitude = 0;
    var latitude = 0;
    var count = 1;          //自动签到计数

    //todo:时间间隔参数
    var distime = 10;//10分钟间隔
    var timer = null;
    var setTimer = function () {
      clearInterval(timer);
      timer = setInterval(
        function () {
          //定位
          $scope.autocheck();//自动签到
        },
        distime * 60 * 1000, ''
      ); //一分钟上报一次位置
    };

    //自动签到
    $scope.autocheck = function () {
      //如果没有离线，那么上报位置
      if ($scope.signInInfo.isOffLine === 1) {
        count++;
        console.log("autocheck");
        console.log("count", count);
        $scope.signIn(1, 0);
      }
    };

    //切换离线或者自动签到
    $scope.offlineOrAutoSign = function () {
      if ($scope.signInInfo.isOffLine === 1) {
        $scope.signInInfo.isOffLine = 0;
        clearInterval(timer);
        console.log("离线成功，关闭自动签到");
        $tool.toastShow("离线成功，关闭自动签到");
      } else {
        if (!$scope.signInInfo.address || !$scope.signInInfo.longitude || !$scope.signInInfo.latitude) {
          console.log("地址信息不全，请定位后再操作！");
          $tool.toastShow("地址信息不全，请定位后再操作！");
          return;
        }

        if (!$scope.signInInfo.clientId) {
          console.log("请选择单位！");
          $tool.toastShow("请选择单位！");
          return;
        }
        count = 0;
        $scope.signInInfo.isOffLine = 1;
        setTimer();//开启定时器
        console.log("开启自动签到，时间间隔" + distime + "分钟");
        $tool.toastShow("开启自动签到，时间间隔" + distime + "分钟");
      }
    };
    //setTimer();//开启定时器

    //签到/签退
    //signType : 签到类型：签到1/签退0
    //signWay : 签到方式：手动1/自动0
    $scope.signIn = function (signType, signWay) {
      console.log("type：", signType + "-----way：" + signWay);
      if (!$scope.signInInfo.address || !$scope.signInInfo.longitude || !$scope.signInInfo.latitude) {
        console.log("地址信息不全，请定位后再操作！");
        $tool.toastShow("地址信息不全，请定位后再操作！");
        return;
      }

      if (!$scope.signInInfo.clientId) {
        console.log("请选择单位！");
        $tool.toastShow("请选择单位！");
        return;
      }

      var data = {
        "addressInfo": $scope.signInInfo.address,
        "addressLongitude": $scope.signInInfo.longitude,
        "addressLatitude": $scope.signInInfo.latitude,
        "clientId": $scope.signInInfo.clientId,
        "type": signType,
        "means": signWay,
        "clientType": $scope.signInInfo.clientType
      };
      $http.post("/sign-out/signIn", angular.toJson(data)).success(function (res) {
        initSignNum();
        console.log("success");
        if (signType === 1) {
          $tool.toastShow("签到成功！");
          if (data.means === 1) {
            $popup.alert({
              template: "<div class='tc'>签到成功！</div>",
              okText: "确定"
            });
          }
        } else {
          $tool.toastShow("签退成功！");
          if (data.means === 1) {
            $popup.alert({
              template: "<div class='tc'>签退成功！</div>",
              okText: "确定"
            });
          }
        }
      }).error(function (res) {
        console.log("error");
        if (signType === 1) {
          $tool.toastShow("签到失败！");
          if (data.means === 1) {
            $popup.alert({
              template: "<div class='tc'>签到失败！</div>",
              okText: "确定"
            });
          }
        } else {
          $tool.toastShow("签退失败！");
          if (data.means === 1) {
            $popup.alert({
              template: "<div class='tc'>签退失败！</div>",
              okText: "确定"
            });
          }
        }
      });
    };


    //今日签到次数
    var initSignNum = function () {
      $http.get($http.httpCacheGet.ac.SIGNINCOUNT).success(function (result) {
        if (result.code === "success") {
          $scope.signInInfo.signNum = result.data;
        } else {
          $scope.signInInfo.signNum = 0;
        }
      });
    };
    initSignNum();

    ////////////////////////////////////////////////////////////选择单位 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
    $scope.searchKeyWord = {
      keyWord: ""
    };
    $scope.KEY269 = [];
    $scope.KEY209 = [];

    $modal.fromTemplateUrl("companyList.html", function ($location) {
      $scope.companyListModal = $location;
    }, {
      scope: $scope,
      animation: "slide-in-up"
    });

    //打开单位列表
    $scope.openCompanyListModal = function () {
      $scope.companyListModal.show();
      $scope.searchCompany();
    };

    //关闭单位列表
    $scope.closeCompanyListModal = function () {
      $scope.companyListModal.hide();
    };

    //清空搜索输入框
    $scope.clearSearch = function () {
      $scope.searchKeyWord.keyWord = "";
      $scope.focused = "centered";
      $scope.searchCompany();
    };

    //搜素单位
    $scope.searchCompany = function () {
      var defer = $q.defer();
      var keyWord = $scope.searchKeyWord.keyWord;
      var result = $http.httpCacheGet.get($http.httpCacheGet.ac.SIGNINCOMPANYLIST + "?keyWord=" + keyWord);
      $q.all([result]).then(function (data) {
        var response = data[0].data;
        if (response.code === "success") {
          $scope.companyList = response.data;
          $scope.KEY269 = response.data[0];
          $scope.KEY209 = response.data[1];
        }
        $scope.$broadcast("scroll.refreshComplete");
      });
    };

    //下拉刷新
    $scope.doRefresh = function () {
      $scope.searchKeyWord.keyWord = "";
      $scope.searchCompany();
    };

    //选择单位
    $scope.selectCompany = function (clientId, clientName, clientType) {
      if (clientId === $scope.signInInfo.clientId) {
        $scope.signInInfo.clientId = "";
        $scope.signInInfo.comName = "";
        $scope.signInInfo.clientType = 0;
      } else {
        $scope.signInInfo.clientId = clientId;
        $scope.signInInfo.comName = clientName;
        $scope.signInInfo.clientType = clientType;
      }
      $scope.closeCompanyListModal();
    };
    ////////////////////////////////////////////////////////////选择单位 end\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


///////////////////////////////////////////////////////////////////////////地图 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
    //定位对象
    var geolocation;
    //逆编码对象
    var geocoder;
    //逆编码方法
    var regeocoder;
    //地图元素
    var map = new AMap.Map(document.getElementById("map_container"), {
      zoom: 11, //级别
      center: [104.073975, 30.573778], //中心点坐标(成都)
      dragEnable: true,
      zoomEnable: true,
      viewMode: '3D' //使用3D视图
    });

    //地图设置
    var options = {
      // zoom: 11,
      timeout: 10000,                       //超过10秒后停止定位，默认：无穷大
      enableHighAccuracy: true,             //是否使用高精度定位，默认:true
      zoomToAccuracy: true,                 //定位成功后调整地图视野范围使定位位置及精度范围视野内可见，默认：false
      showButton: true,                     //显示定位按钮，默认：true
      buttonPosition: 'LT',                 //定位按钮停靠位置，默认：'LB'，左下角 (LT LB RT RB)
      buttonOffset: new AMap.Pixel(10, 20), //定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
      showMarker: true,                     //定位成功后在定位到的位置显示点标记，默认：true
      panToLocation: true,                  //定位成功后将定位到的位置作为地图中心点，默认：true
      showCircle: true,                     //定位成功后用圆圈表示定位精度范围，默认：true
      /*circleOptions: {                    //定位点Circle的配置，不设置该属性则使用默认Circle样式
        strokeColor: '#0093FF',
        noSelect: true,
        strokeOpacity: 0.5,
        strokeWeight: 1,
        fillColor: '#02B0FF',
        fillOpacity: 0.25
      },*/
      markerOptions: {                      //定位点Marker的配置，不设置该属性则使用默认Marker样式
        position: new AMap.LngLat(longitude, latitude),
        //offset: new AMap.Pixel(-18, -36),                                                                                                     蓝色
        //content: '<img src="https://a.amap.com/jsapi_demos/static/resource/img/user.png" style="width:36px;height:36px"/>'                    //蓝色
        offset: new AMap.Pixel(-13, -30),
        content: '<img src="https://a.amap.com/jsapi_demos/static/demo-center/icons/poi-marker-red.png" style="width:25px;height:34px"/>'       //红色
      },
      resizeEnable: true
    };

    //定位
    map.plugin('AMap.Geolocation', function () {
      geolocation = new AMap.Geolocation(options);    //定位对象
      map.addControl(geolocation);
      geolocation.getCurrentPosition();

      // geolocation.getCurrentPosition();
      AMap.event.addListener(geolocation, 'complete', onComplete);
      AMap.event.addListener(geolocation, 'error', onError);

      //定位成功事件
      function onComplete(position) {
        if (position.info === "SUCCESS") {
          console.log("高德地图定位成功:" + position.position.lng + "," + position.position.lat + "," + position.formattedAddress);
          $scope.signInInfo.longitude = position.position.lng;
          $scope.signInInfo.latitude = position.position.lat;
          $scope.signInInfo.address = position.formattedAddress;
          $scope.$apply();//手动更新视图
        } else {
          console.log("高德地图定位失败:" + position);
          //使用浏览器谷歌定位
          if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function (position) {
                // console.log("navigator定位", position)
                $scope.signInInfo.latitude = position.coords.latitude;
                $scope.signInInfo.longitude = position.coords.longitude;
                //地球坐标系——WGS84（谷歌）  转  火星坐标系——GCJ-02（高德）
                var respoi = wgs84togcj02($scope.signInInfo.longitude, $scope.signInInfo.latitude);
                console.log('respoi', respoi[0], respoi[1]);
                $scope.signInInfo.latitude = respoi[1].toFixed(6);
                $scope.signInInfo.longitude = respoi[0].toFixed(6);
                console.log("谷歌地图定位成功:" + $scope.signInInfo.longitude + "," + $scope.signInInfo.latitude);
                var marker = new AMap.Marker({
                  position: [$scope.signInInfo.longitude, $scope.signInInfo.latitude],       //位置
                  //offset: new AMap.Pixel(-18, -36),                                                                                                     蓝色
                  //content: '<img src="https://a.amap.com/jsapi_demos/static/resource/img/user.png" style="width:36px;height:36px"/>'                    //蓝色
                  offset: new AMap.Pixel(-13, -30),
                  content: '<img src="https://a.amap.com/jsapi_demos/static/demo-center/icons/poi-marker-red.png" style="width:25px;height:34px"/>'       //红色
                });
                map.add(marker); //添加到地图
                marker.setPosition([$scope.signInInfo.longitude, $scope.signInInfo.latitude]);
                //逆地理编码
                var lnglat = [$scope.signInInfo.longitude, $scope.signInInfo.latitude];
                regeocoder(lnglat);
              }, function (data) {
                console.log("谷歌地图定位出错1:" + data.message);
                $tool.toastShow("定位失败");
              }
            );
          } else {
            // 定位出错
            console.log("定位失败");
            $tool.toastShow("定位失败");
          }
        }
      }

      //定位失败事件
      function onError(data) {
        //谷歌 定位
        if (navigator.geolocation) {
          navigator.geolocation.getCurrentPosition(function (position) {
              // console.log("navigator定位", position)
              $scope.signInInfo.latitude = position.coords.latitude;
              $scope.signInInfo.longitude = position.coords.longitude;
              //地球坐标系——WGS84（谷歌）转火星坐标系——GCJ-02（高德）
              var respoi = wgs84togcj02($scope.signInInfo.longitude, $scope.signInInfo.latitude);
              console.log('respoi', respoi[0], respoi[1]);
              $scope.signInInfo.latitude = respoi[1].toFixed(6);
              $scope.signInInfo.longitude = respoi[0].toFixed(6);
              console.log("谷歌地图定位成功:" + $scope.signInInfo.longitude + "," + $scope.signInInfo.latitude);
              var marker = new AMap.Marker({
                position: [$scope.signInInfo.longitude, $scope.signInInfo.latitude], //位置
                //offset: new AMap.Pixel(-18, -36),                                                                                                     蓝色
                //content: '<img src="https://a.amap.com/jsapi_demos/static/resource/img/user.png" style="width:36px;height:36px"/>'                    //蓝色
                offset: new AMap.Pixel(-13, -30),
                content: '<img src="https://a.amap.com/jsapi_demos/static/demo-center/icons/poi-marker-red.png" style="width:25px;height:34px"/>'       //红色
              });
              map.add(marker); //添加到地图
              marker.setPosition([$scope.signInInfo.longitude, $scope.signInInfo.latitude]);

              //逆地理编码
              var lnglat = [$scope.signInInfo.longitude, $scope.signInInfo.latitude];
              geocoder.getAddress(lnglat, function (status, result) {
                if (status === 'complete' && result.info === 'OK') {
                  // result为对应的地理位置详细信息
                  $scope.signInInfo.address = result;
                }
              });
            }, function (data) {
              console.log("谷歌地图定位出错2:" + data.message);
              $tool.toastShow("定位失败");
            }
          );
        } else {
          // 定位出错
          console.log("定位出错:" + data.message);
          $tool.toastShow("定位失败");
        }
      }
    });

    /*实时路况
    var trafficLayer = new AMap.TileLayer.Traffic({
      zIndex: 10
    });
     map.add(trafficLayer);//添加图层到地图*/

    AMap.plugin(['AMap.ToolBar',], function () {
      // 在图面添加工具条控件，工具条控件集成了缩放、平移、定位等功能按钮在内的组合控件
      map.addControl(new AMap.ToolBar({
        liteStyle: true,           // 简易缩放模式，默认为 false
        position: "RT"             //控件停靠位置
      }));
    });

    //经纬度转地址
    AMap.plugin('AMap.Geocoder', function () {
      geocoder = new AMap.Geocoder({     //地理编码与逆地理编码类，用于地址描述与坐标之间的转换，getAddress将地理坐标（经纬度）转换成地址描述信息，getLocation将地址描述信息转换成地理坐标
        city: '全国',                     //城市，地理编码时，设置地址描述所在城市
        radius: 1000,                     //以给定坐标为中心点，单位：米
        extensions: 'all'                 //返回信息的详略
      });

      regeocoder = function (lnglat) {
        //逆地理编码
        geocoder.getAddress(lnglat, function (status, result) {
          if (status === 'complete' && result.info === 'OK') {
            // result为对应的地理位置详细信息
            $scope.signInInfo.address = result.regeocode.formattedAddress;
            $scope.$apply();//手动更新视图
            console.log("逆地理编码:" + result.regeocode.formattedAddress);
          }
        });
      };
    });


    var x_PI = 3.14159265358979324 * 3000.0 / 180.0,
      PI = 3.1415926535897932384626,
      a = 6378245.0,
      ee = 0.00669342162296594323;

    var wgs84togcj02 = function (lng, lat) {
      // console.log("PI",PI,this.PI)
      var lat = +lat;
      var lng = +lng;
      if (out_of_china(lng, lat)) {
        return [lng, lat];
      } else {
        var dlat = transformlat(lng - 105.0, lat - 35.0);
        var dlng = transformlng(lng - 105.0, lat - 35.0);
        var radlat = lat / 180.0 * PI;
        var magic = Math.sin(radlat);
        magic = 1 - ee * magic * magic;
        var sqrtmagic = Math.sqrt(magic);
        dlat = (dlat * 180.0) / ((a * (1 - ee)) / (magic * sqrtmagic) * PI);
        dlng = (dlng * 180.0) / (a / sqrtmagic * Math.cos(radlat) * PI);
        var mglat = lat + dlat;
        var mglng = lng + dlng;
        return [mglng, mglat];
      }
    };


    var transformlat = function (lng, lat) {
      var lat = +lat;
      var lng = +lng;
      var ret = -100.0 + 2.0 * lng + 3.0 * lat + 0.2 * lat * lat + 0.1 * lng * lat + 0.2 * Math.sqrt(Math.abs(lng));
      ret += (20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0 / 3.0;
      ret += (20.0 * Math.sin(lat * PI) + 40.0 * Math.sin(lat / 3.0 * PI)) * 2.0 / 3.0;
      ret += (160.0 * Math.sin(lat / 12.0 * PI) + 320 * Math.sin(lat * PI / 30.0)) * 2.0 / 3.0;
      return ret;
    };

    var transformlng = function (lng, lat) {
      var lat = +lat;
      var lng = +lng;
      var ret = 300.0 + lng + 2.0 * lat + 0.1 * lng * lng + 0.1 * lng * lat + 0.1 * Math.sqrt(Math.abs(lng));
      ret += (20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0 / 3.0;
      ret += (20.0 * Math.sin(lng * PI) + 40.0 * Math.sin(lng / 3.0 * PI)) * 2.0 / 3.0;
      ret += (150.0 * Math.sin(lng / 12.0 * PI) + 300.0 * Math.sin(lng / 30.0 * PI)) * 2.0 / 3.0;
      return ret;
    };

    var out_of_china = function (lng, lat) {
      var lat = +lat;
      var lng = +lng;
      // 纬度3.86~53.55,经度73.66~135.05
      return !(lng > 73.66 && lng < 135.05 && lat > 3.86 && lat < 53.55);
    };

    var getNowTime = function () {
      var now = new Date();
      var year = now.getFullYear();
      var month = now.getMonth() + 1;
      var day = now.getDate();
      var h = now.getHours();
      var m = now.getMinutes();
      var s = now.getSeconds();

      if (month < 10) {
        month = '0' + month;
      }
      ;
      if (day < 10) {
        day = '0' + day;
      }
      ;
      //  如果需要时分秒，就放开
      // var h = now.getHours();
      // var m = now.getMinutes();
      // var s = now.getSeconds();
      var formatDate = year + '-' + month + '-' + day + ' ' + h + ':' + m + ':' + s;
      return formatDate;
    };
///////////////////////////////////////////////////////////////////////////地图 end\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  }]
).controller('signinQueryCtrl', ["$scope", "psisServices", "Tools", "$ionicModal", "$q", "$cordovaDatePicker", function ($scope, $http, $tool, $modal, $q, datePicker) {

  $scope.signInQueryInfo = {
    clientId: "",
    comName: "",
    date: new Date(),
    personId: "",
    personName: ""
  };

  $scope.signInRecords = [];


  $scope.signInQuery = function () {
    $http.post("/sign-out/query", angular.toJson($scope.signInQueryInfo)).success(function (res) {
      console.log("success");
      //清除地图点
      clearMarkers();
      if (res.data.length > 0) {
        $scope.signInRecords = res.data;
        //绘制地图点
        paintMarkers();
      }
    }).error(function (res) {
      console.log("error");
    });
  };


  ////////////////////////////////////////////////////////////选择日期 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  $scope.setBusinessTime = function () {
    if (window.cordova) {
      datePicker.show({
        date: new Date($scope.signInQueryInfo.date),
        mode: "date",
        doneButtonLabel: "确定",
        cancelButtonLabel: "取消",
        minDate: (new Date).setDate((new Date).getDate() - 90),
        maxDate: (new Date).setDate((new Date).getDate())
      }).then(function (date1) {
        if (!isNaN(date1.getTime())) {
          $scope.signInQueryInfo.date = date1.getTime();
        }
      });
    }
  };


  ////////////////////////////////////////////////////////////选择人员 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  $scope.personList = [];

  $modal.fromTemplateUrl("personList.html", function ($location) {
    $scope.personListModal = $location;
  }, {
    scope: $scope,
    animation: "slide-in-up"
  });

  //打开人员列表
  $scope.openPersonListModal = function () {
    $scope.personListModal.show();
    $scope.searchPerson();
  };

  //关闭人员列表
  $scope.closePersonListModal = function () {
    $scope.personListModal.hide();
  };

  //搜素人员
  $scope.searchPerson = function () {
    $q.defer();
    var result = $http.httpCacheGet.get($http.httpCacheGet.ac.SIGNINPERSONLIST);
    $q.all([result]).then(function (data) {
      var response = data[0].data;
      if (response.code === "success") {
        $scope.personList = response.data;
      }
      $scope.$broadcast("scroll.refreshComplete");
    });
  };

  //下拉刷新
  $scope.doRefreshPerson = function () {
    $scope.searchPerson();
  };

  //选择人员
  $scope.selectPerson = function (personId, personName) {
    if (personId === $scope.signInQueryInfo.personId) {
      $scope.signInQueryInfo.personId = "";
      $scope.signInQueryInfo.personName = "";
    } else {
      $scope.signInQueryInfo.personId = personId;
      $scope.signInQueryInfo.personName = personName;
    }
    $scope.closePersonListModal();
  };


  ////////////////////////////////////////////////////////////选择人员 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


  ////////////////////////////////////////////////////////////选择单位 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  $scope.searchKeyWord = {
    keyWord: ""
  };
  $scope.KEY269 = [];
  $scope.KEY209 = [];

  $modal.fromTemplateUrl("companyList.html", function ($location) {
    $scope.companyListModal = $location;
  }, {
    scope: $scope,
    animation: "slide-in-up"
  });

  //打开单位列表
  $scope.openCompanyListModal = function () {
    $scope.companyListModal.show();
    $scope.searchCompany();
  };

  //关闭单位列表
  $scope.closeCompanyListModal = function () {
    $scope.companyListModal.hide();
  };

  //清空搜索输入框
  $scope.clearSearch = function () {
    $scope.searchKeyWord.keyWord = "";
    $scope.focused = "centered";
    $scope.searchCompany();
  };

  //搜素单位
  $scope.searchCompany = function () {
    $q.defer();
    var keyWord = $scope.searchKeyWord.keyWord;
    var result = $http.httpCacheGet.get($http.httpCacheGet.ac.SIGNINCOMPANYLIST + "?keyWord=" + keyWord);
    $q.all([result]).then(function (data) {
      var response = data[0].data;
      if (response.code === "success") {
        $scope.companyList = response.data;
        $scope.KEY269 = response.data[0];
        $scope.KEY209 = response.data[1];
      }
      $scope.$broadcast("scroll.refreshComplete");
    });
  };

  //下拉刷新
  $scope.doRefresh = function () {
    $scope.searchKeyWord.keyWord = "";
    $scope.searchCompany();
  };

  //选择单位
  $scope.selectCompany = function (clientId, clientName) {
    if (clientId === $scope.signInQueryInfo.clientId) {
      $scope.signInQueryInfo.clientId = "";
      $scope.signInQueryInfo.comName = "";
    } else {
      $scope.signInQueryInfo.clientId = clientId;
      $scope.signInQueryInfo.comName = clientName;
    }
    $scope.closeCompanyListModal();
  };
  ////////////////////////////////////////////////////////////选择单位 end\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


  ////////////////////////////////////////////////////////////地图 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

  var longitude = 0;
  var latitude = 0;

  //定位对象
  var geolocation;
  //地图元素
  var map = new AMap.Map(document.getElementById("map_container_query"), {
    zoom: 11, //级别
    //center: [104.073975, 30.573778], //中心点坐标(成都)
    dragEnable: true,
    zoomEnable: true,
    viewMode: '3D' //使用3D视图
  });

  AMap.plugin(['AMap.ToolBar',], function () {
    // 在图面添加工具条控件，工具条控件集成了缩放、平移、定位等功能按钮在内的组合控件
    map.addControl(new AMap.ToolBar({
      liteStyle: true,           // 简易缩放模式，默认为 false
      position: "RT"            //控件停靠位置
    }));
  });

  var markers = [];
  var paintMarkers = function () {
    for (var i = 0; i < $scope.signInRecords.length; i++) {
      var record = $scope.signInRecords[i];
      var marker = new AMap.Marker({
        position: [record.addressLongitude, record.addressLatitude], //位置
        //offset: new AMap.Pixel(-18, -36),                                                                                                     蓝色
        //content: '<img src="https://a.amap.com/jsapi_demos/static/resource/img/user.png" style="width:36px;height:36px"/>'                    //蓝色
        offset: new AMap.Pixel(-13, -30),
        content: '<img src="https://a.amap.com/jsapi_demos/static/demo-center/icons/poi-marker-red.png" style="width:25px;height:34px"/>'       //红色
      });
      map.add(marker); //添加到地图
      markers.push(marker);
      if (i === 0) {
        map.setCenter([record.addressLongitude, record.addressLatitude]);
      }
    }
  };

  var clearMarkers = function () {
    map.remove(markers);
    markers = [];
  };
  ////////////////////////////////////////////////////////////地图 end\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

}]).controller('signinCountCtrl', ["$scope", "psisServices", "Tools", "$ionicModal", "$q", "$cordovaDatePicker", function ($scope, $http, $tool, $modal, $q, datePicker) {

  $scope.signInCountInfo = {
    personNames: [],
    personNamesStr: "",
    personIds: [],
    cycle: "today",
    cycleStr: "今天",
    count: 0,
    type: 0,     //1明细   2统计
    page: 1,
    pageSize: 10,
    loadMoreBtn: false
  };

  $scope.signInDetails = [];//签到明细
  $scope.signInStats = [];//签到统计


  $scope.$on("$ionicView.beforeLeave", function () {
    $scope.signInDetails = [];//签到明细
    $scope.signInStats = [];//签到统计
    $scope.signInCountInfo = {
      personNames: [],
      personNamesStr: "",
      personIds: [],
      cycle: "today",
      cycleStr: "今天",
      count: 0,
      type: 0,     //1明细   2统计
      page: 1,
      pageSize: 10,
      loadMoreBtn: false
    };
  });

  //签到次数
  $scope.getSignInCount = function () {
    $http.post("/sign-out/signCount", angular.toJson({
      timeFrame: $scope.signInCountInfo.cycle,
      personIdList: $scope.signInCountInfo.personIds
    })).success(function (result) {
      if (result.code === "success") {
        $scope.signInCountInfo.count = result.data;
      } else {
        $scope.signInCountInfo.count = 0;
      }
    });
  };
  $scope.getSignInCount();

  //改变类型
  $scope.changeType = function (type) {
    $scope.signInCountInfo.type = type;
    $scope.initPageCondition();
    $scope.signInDetails = [];//签到明细
    $scope.signInStats = [];//签到统计
    $scope.getData();
  };

  //签到明细
  $scope.getSignInDetail = function () {
    $http.post("/sign-out/signInStatsDetail", angular.toJson({
      timeFrame: $scope.signInCountInfo.cycle,
      personIdList: $scope.signInCountInfo.personIds,
      pageNum: $scope.signInCountInfo.page,
      pageSize: $scope.signInCountInfo.pageSize
    })).success(function (result) {
      if (result.code === "success") {
        $scope.signInDetails = $scope.signInDetails.concat(result.data.datas);
        if ($scope.signInDetails.length < result.data.total) {
          $scope.signInCountInfo.loadMoreBtn = true;
        } else {
          $scope.signInCountInfo.loadMoreBtn = false;
        }
      }
    });
  };

  //签到统计
  $scope.getSignInStats = function () {
    $http.post("/sign-out/signInStatsInfo", angular.toJson({
      timeFrame: $scope.signInCountInfo.cycle,
      personIdList: $scope.signInCountInfo.personIds,
      pageNum: $scope.signInCountInfo.page,
      pageSize: $scope.signInCountInfo.pageSize
    })).success(function (result) {
      if (result.code === "success") {
        $scope.signInStats = $scope.signInStats.concat(result.data.datas);
        if ($scope.signInStats.length < result.data.total) {
          $scope.signInCountInfo.loadMoreBtn = true;
        } else {
          $scope.signInCountInfo.loadMoreBtn = false;
        }
      }
    });
  };

  //获取数据
  $scope.getData = function () {
    if ($scope.signInCountInfo.type === 1) { //明细
      $scope.getSignInDetail();
      $scope.signInStats = [];
    } else if ($scope.signInCountInfo.type === 2) { //统计
      $scope.getSignInStats();
      $scope.signInDetails = [];
    }
  };

  //分页继续加载
  $scope.getMoreData = function () {
    console.log("继续加载");
    $scope.signInCountInfo.page++;
    $scope.getData();
    $scope.$broadcast('scroll.infiniteScrollComplete');//加载完数据,要进行一次广播
  };

  //初始化分页条件
  $scope.initPageCondition = function () {
    $scope.signInCountInfo.loadMoreBtn = false;
    $scope.signInCountInfo.page = 1;
  };

  //初始化数据
  $scope.initData = function () {
    $scope.signInCountInfo.type = 0;
    $scope.signInDetails = [];//签到明细
    $scope.signInStats = [];//签到统计
  };
  //////////////////////////////////////////////////////////////选择人员 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  $scope.personList = [];

  $modal.fromTemplateUrl("personList.html", function ($location) {
    $scope.personListModal = $location;
  }, {
    scope: $scope,
    animation: "slide-in-up"
  });

  //打开人员列表
  $scope.openPersonListModal = function () {
    $scope.personListModal.show();
    $scope.searchPerson();
  };

  //关闭人员列表
  $scope.closePersonListModal = function () {
    $scope.personListModal.hide();
  };

  //搜素人员
  $scope.searchPerson = function () {
    $q.defer();
    var result = $http.httpCacheGet.get($http.httpCacheGet.ac.SIGNINPERSONLIST);
    $q.all([result]).then(function (data) {
      var response = data[0].data;
      if (response.code === "success") {
        $scope.personList = response.data;
      }
      $scope.$broadcast("scroll.refreshComplete");
    });
  };

  //下拉刷新
  $scope.doRefreshPerson = function () {
    $scope.searchPerson();
  };

  //选择人员
  $scope.selectPerson = function (personId, personName) {
    var index1 = $scope.signInCountInfo.personIds.indexOf(personId);
    var index2 = $scope.signInCountInfo.personNames.indexOf(personName);
    if (index1 > -1 && index2 > -1) {
      $scope.signInCountInfo.personIds.splice(index1, 1);
      $scope.signInCountInfo.personNames.splice(index2, 1);
    } else {
      $scope.signInCountInfo.personIds.push(personId);
      $scope.signInCountInfo.personNames.push(personName);
    }
    $scope.signInCountInfo.personNamesStr = $scope.signInCountInfo.personNames.join(",");
    $scope.getSignInCount();
    $scope.initData();
    $scope.initPageCondition();
    $scope.getData();
  };
  //////////////////////////////////////////////////////////////选择人员 end\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  //////////////////////////////////////////////////////////////选择周期 begin\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  $modal.fromTemplateUrl("cycleList.html", function ($location) {
    $scope.cycleListModal = $location;
  }, {
    scope: $scope,
    animation: "slide-in-up"
  });

  //打开人员列表
  $scope.openCycleListModal = function () {
    $scope.cycleListModal.show();
  };

  //关闭人员列表
  $scope.closeCycleListModal = function () {
    $scope.cycleListModal.hide();
  };

  //选择周期
  $scope.selectCycle = function (cycle, cycleStr) {
    $scope.signInCountInfo.cycle = cycle;
    $scope.signInCountInfo.cycleStr = cycleStr;
    $scope.closeCycleListModal();
    $scope.getSignInCount();
    $scope.initData();
    $scope.initPageCondition();
    $scope.getData();
  };
  //////////////////////////////////////////////////////////////选择周期 end\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
}]);
