angular.module("statisticalChartCtrl", ["ionic", "services", "tools"]).controller("SaleVolumeChartCtrl", ["$scope", "psisServices", "$filter", "$q", "lbSpinnerDialog", "ReportConstant", "$ionicActionSheet", "$cordovaDatePicker", "$ionicModal", "Tools", "$ionicScrollDelegate", "$timeout", function($scope, $http, $filter, $q, ignoreMethodDoesntExist, element, $element, scope, $modal, dataAndEvents, deepDataAndEvents, $sanitize) {
  var self;
  /**
   * @return {undefined}
   */
  $scope.showActionsheet = function() {
    $element.show(element.actionSheet($scope));
  };
  /**
   * @param {?} data
   * @return {?}
   */
  var process = function(data) {
    var conn = $q.defer();
    return $http.post("/KEY100", data).success(function(res) {
      var a = res.rows;
      /** @type {Array} */
      var products = [];
      /** @type {Array} */
      var player = [];
      /** @type {Array} */
      var parsedData = [];
      /** @type {Array} */
      var postData = [];
      /** @type {number} */
      var i = 0;
      var l = a.length;
      for (;l > i;i++) {
        products.push($filter("date")(a[i].calDate, "dd") + "日");
        player.push(a[i].amount);
        parsedData.push(a[i].sumGrossProfit);
        postData.push(a[i].quantity);
      }
      var options = {
        title : {
          text : "销售走势",
          subtext : $filter("date")(data.createTimeBegin, "yyyy/MM/dd") + "日  到  " + $filter("date")(data.createTimeEnd, "yyyy/MM/dd") + "日",
          x : "center"
        },
        tooltip : {
          show : true,
          trigger : "axis",
          backgroundColor : "#FFFDE7",
          textStyle : {
            color : "#263238"
          }
        },
        grid : {
          x : 70,
          y : 70,
          x2 : 80,
          y2 : 70
        },
        toolbox : {
          show : false
        },
        animation : false,
        xAxis : [{
          name : "日期",
          type : "category",
          boundaryGap : true,
          data : products
        }],
        yAxis : [{
          name : "销售额(" + $scope.currencySymbol + ")",
          type : "value"
        }, {
          name : "销量(件)",
          type : "value",
          axisLabel : {
            formatter : "{value}"
          }
        }],
        series : [{
          name : "销量",
          type : "bar",
          data : postData,
          itemStyle : {
            normal : {
              label : {
                show : false
              },
              color : "#ff6600"
            }
          },
          yAxisIndex : 1
        }, {
          name : "销售额",
          type : "line",
          smooth : true,
          data : player,
          itemStyle : {
            normal : {
              label : {
                show : false
              },
              color : "#ff6600"
            }
          }
        }, {
          name : "毛利",
          type : "line",
          smooth : true,
          data : parsedData,
          itemStyle : {
            normal : {
              label : {
                show : false
              },
              color : "#ffba00"
            }
          }
        }]
      };
      conn.resolve(options);
    }).error(function() {
      conn.reject();
    }), conn.promise;
  };
  $scope.searchModel = {};
  $modal.fromTemplateUrl("customDateTimeQuery.html", function($location) {
    $scope.customDateTimeQueryModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : $scope.searchModel.beginTime ? new Date($scope.searchModel.beginTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        /** @type {Date} */
        var nextMonth = new Date(date1.getTime());
        if (nextMonth.setDate(nextMonth.getDate() + 29) - $scope.searchModel.endTime < 0) {
          /** @type {Date} */
          nextMonth = new Date($scope.searchModel.endTime);
          dataAndEvents.toastShow("查询时间范围不能超过30天");
          nextMonth.setDate(nextMonth.getDate() - 29);
          /** @type {Date} */
          $scope.searchModel.beginTime = nextMonth;
        } else {
          $scope.searchModel.beginTime = date1.getTime();
        }
        $scope.getCustomQuery();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : $scope.searchModel.endTime ? new Date($scope.searchModel.endTime) : new Date,
      mode : "date",
      minDate : (new Date($scope.searchModel.beginTime)).setDate((new Date($scope.searchModel.beginTime)).getDate()),
      maxDate : (new Date).setDate((new Date).getDate()),
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        /** @type {Date} */
        var end = new Date(date1.getTime());
        if (end.setDate(end.getDate() - 29) - $scope.searchModel.beginTime > 0) {
          /** @type {Date} */
          end = new Date($scope.searchModel.beginTime);
          dataAndEvents.toastShow("查询时间范围不能超过30天");
          end.setDate(end.getDate() + 29);
          /** @type {Date} */
          $scope.searchModel.endTime = end;
        } else {
          $scope.searchModel.endTime = date1.getTime();
        }
        $scope.getCustomQuery();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getCustomQuery = function() {
    send($scope.searchModel.beginTime, $scope.searchModel.endTime);
  };
  /**
   * @return {undefined}
   */
  var send = function() {
    self.showLoading();
    /** @type {Date} */
    var midnight = new Date($scope.searchModel.beginTime);
    midnight.setHours(0, 0, 0, 0);
    /** @type {number} */
    $scope.searchModel.beginTime = midnight.getTime();
    /** @type {Date} */
    var nd = new Date($scope.searchModel.endTime);
    nd.setHours(23, 59, 59);
    /** @type {number} */
    $scope.searchModel.endTime = nd.getTime();
    process({
      createTimeBegin : $filter("date")($scope.searchModel.beginTime, "yyyy-MM-ddTHH:mm:ss.sssZ"),
      createTimeEnd : $filter("date")($scope.searchModel.endTime, "yyyy-MM-ddTHH:mm:ss.sssZ")
    }).then(function(answer) {
      self.hideLoading();
      self.setOption(answer);
    }, function() {
      self.hideLoading();
      console.error("获取报表数据出现异常！");
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    self = echarts.init(document.getElementById("saleVolumeChartDiv"));
    /** @type {Date} */
    $scope.searchModel.endTime = new Date;
    /** @type {Date} */
    $scope.searchModel.beginTime = new Date;
    $scope.searchModel.beginTime.setDate($scope.searchModel.beginTime.getDate() - 14);
    send($scope.searchModel.beginTime, $scope.searchModel.endTime);
    $sanitize(function() {
      deepDataAndEvents.$getByHandle("salesVolumeChartDivScroll").scrollTo(200, 0, true);
    }, 500);
  });
  $scope.$on("$destroy", function() {
    $scope.customDateTimeQueryModal.remove();
    if (self) {
      self.dispose();
    }
  });
}]).controller("StatisticalChartProfitCtrl", ["$scope", "psisServices", "$filter", "Tools", "lbSpinnerDialog", "$ionicPopover", "$cordovaDatePicker", "ReportConstant", "$ionicActionSheet", function($scope, $http, $filter, url, loading, FB, scope, element, $element) {
  var obj;
  /** @type {Date} */
  var tempDate = new Date;
  var currentTime = tempDate.setMonth(tempDate.getMonth() - 1);
  $scope.recordCondition = {
    beginTime : currentTime,
    endTime : (new Date).getTime()
  };
  /** @type {number} */
  $scope.profitType = 1;
  $scope.reportLevel = element.reportLevel;
  /**
   * @return {undefined}
   */
  $scope.showActionsheet = function() {
    $element.show(element.actionSheet($scope));
  };
  /**
   * @return {undefined}
   */
  $scope.setBeginTime = function() {
    scope.show({
      date : new Date($scope.recordCondition.beginTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.beginTime = date1.getTime();
        init();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setEndTime = function() {
    scope.show({
      date : new Date($scope.recordCondition.endTime),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.recordCondition.endTime = date1.getTime();
        init();
      }
    });
  };
  FB.fromTemplateUrl("profitTypePopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.profitTypePopover = $location;
  });
  FB.fromTemplateUrl("profitTipsPopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.profitTipsPopover = $location;
  });
  /**
   * @param {?} serialised
   * @param {number} expectedNumberOfNonCommentArgs
   * @return {?}
   */
  var load = function(serialised, expectedNumberOfNonCommentArgs) {
    var ch;
    switch(expectedNumberOfNonCommentArgs) {
      case 1:
        /** @type {string} */
        ch = "毛利排行前十";
        break;
      case 2:
        /** @type {string} */
        ch = "毛利率排行前十";
        break;
      case 3:
        /** @type {string} */
        ch = "毛利排行后十";
        break;
      case 4:
        /** @type {string} */
        ch = "毛利率排行后十";
    }
    /** @type {Array} */
    var d = [];
    /** @type {Array} */
    var vals = [];
    /** @type {Array} */
    var response = [];
    serialised.forEach(function(request) {
      d.unshift(request.goodName);
      vals.unshift(url.accMul(request.profitRate, 100));
      response.unshift(request.profit);
    });
    var options = {
      title : {
        text : ch,
        x : 20
      },
      tooltip : {
        show : true,
        trigger : "axis"
      },
      grid : {
        x : 130,
        y : 50,
        x2 : 60,
        y2 : 25
      },
      legend : {
        data : ["毛利", "毛利率"],
        x : "right",
        y : 10,
        selectedMode : false,
        textStyle : {
          color : "auto"
        }
      },
      toolbox : {
        show : false
      },
      animation : false,
      xAxis : [{
        type : "value",
        name : "单位(" + $scope.currencySymbol + ")",
        nameTextStyle : {
          color : "#726f83"
        },
        axisLabel : {
          textStyle : {
            color : "#726f83"
          },
          /**
           * @param {number} v
           * @return {?}
           */
          formatter : function(v) {
            return v > 1E4 ? v / 1E4 + "w" : v;
          }
        },
        splitNumber : 3
      }, {
        type : "value",
        nameTextStyle : {
          color : "#726f83"
        },
        axisLabel : {
          textStyle : {
            color : "#726f83"
          },
          formatter : "{value} %"
        },
        splitNumber : 3
      }],
      yAxis : [{
        type : "category",
        boundaryGap : true,
        axisLabel : {
          textStyle : {
            color : "#726f83"
          },
          /**
           * @param {string} x
           * @return {?}
           */
          formatter : function(x) {
            return x.replace(/(\S{10})(\S+)/, "$1\n$2");
          }
        },
        data : d
      }],
      series : [{
        name : "毛利",
        type : "bar",
        data : response,
        itemStyle : {
          normal : {
            label : {
              show : true
            }
          }
        }
      }, {
        name : "毛利率",
        type : "line",
        smooth : true,
        data : vals,
        xAxisIndex : 1,
        itemStyle : {
          normal : {
            label : {
              show : false
            }
          }
        }
      }]
    };
    return options;
  };
  $scope.$on("$destroy", function() {
    if (obj) {
      obj.dispose();
    }
    $scope.profitTypePopover.remove();
    $scope.profitTipsPopover.remove();
  });
  /**
   * @return {undefined}
   */
  var init = function() {
    loading.show();
    /** @type {Date} */
    var midnight = new Date($scope.recordCondition.beginTime);
    midnight.setHours(0, 0, 0, 0);
    /** @type {number} */
    $scope.recordCondition.beginTime = midnight.getTime();
    /** @type {Date} */
    var nd = new Date($scope.recordCondition.endTime);
    nd.setHours(23, 59, 59);
    /** @type {number} */
    $scope.recordCondition.endTime = nd.getTime();
    $http.post("/KEY144", {
      beginTime : $filter("date")($scope.recordCondition.beginTime, "yyyy-MM-ddTHH:mm:ss.sssZ"),
      endTime : $filter("date")($scope.recordCondition.endTime, "yyyy-MM-ddTHH:mm:ss.sssZ")
    }).success(function(d) {
      loading.hide();
      $scope.saleProfitTotal = {
        profitRateAvg : url.accMul(d.saleProfitTotal ? d.saleProfitTotal.profitRateAvg : 0, 100),
        totalProfit : d.saleProfitTotal ? d.saleProfitTotal.totalProfit : 0,
        profitReportLevel : d.profitReportLevel
      };
      /**
       * @param {number} alertTitle
       * @return {undefined}
       */
      $scope.setEchartsOption = function(alertTitle) {
        switch($scope.profitType = alertTitle ? alertTitle : $scope.profitType, obj && obj.dispose(), $scope.profitType) {
          case 1:
            if (d.profitByGoodsTop10.length) {
              obj = echarts.init(document.getElementById("optionProfitDiv"), element.echartsTheme);
              obj.setOption(load(d.profitByGoodsTop10, 1));
            } else {
              /** @type {null} */
              obj = null;
            }
            break;
          case 2:
            if (d.profitRateByGoodsTop10.length) {
              obj = echarts.init(document.getElementById("optionProfitDiv"), element.echartsTheme);
              obj.setOption(load(d.profitRateByGoodsTop10, 2));
            } else {
              /** @type {null} */
              obj = null;
            }
            break;
          case 3:
            if (d.profitByGoodsDown10.length) {
              obj = echarts.init(document.getElementById("optionProfitDiv"), element.echartsTheme);
              obj.setOption(load(d.profitByGoodsDown10, 3));
            } else {
              /** @type {null} */
              obj = null;
            }
            break;
          case 4:
            if (d.profitRateByGoodsDown10.length) {
              obj = echarts.init(document.getElementById("optionProfitDiv"), element.echartsTheme);
              obj.setOption(load(d.profitRateByGoodsDown10, 4));
            } else {
              /** @type {null} */
              obj = null;
            }
          ;
        }
      };
      $scope.setEchartsOption();
    }).error(function() {
      loading.hide();
      console.error("获取报表数据出现异常！");
    });
  };
  init();
}]).controller("DynamicSaleRateChartCtrl", ["$scope", "psisServices", "$filter", "Tools", "lbSpinnerDialog", "$ionicPopover", "ReportConstant", "$ionicActionSheet", function($scope, $http, dataAndEvents, should, loading, FB, element, $element) {
  /** @type {Date} */
  var currentTime = new Date;
  currentTime.setMonth(currentTime.getMonth() - 11);
  currentTime.setDate(0);
  /** @type {Date} */
  var end = new Date;
  end.setDate(0);
  var obj;
  $scope.reportLevel = element.reportLevel;
  /**
   * @return {undefined}
   */
  $scope.showActionsheet = function() {
    $element.show(element.actionSheet($scope));
  };
  FB.fromTemplateUrl("dynamicSaleTipsPopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.dynamicSaleTipsPopover = $location;
  });
  $scope.$on("$destroy", function() {
    if (obj) {
      obj.dispose();
    }
    $scope.dynamicSaleTipsPopover.remove();
  });
  loading.show();
  $http.post("/KEY145", {
    beginTime : currentTime,
    endTime : end
  }).success(function(selectElement) {
    loading.hide();
    /** @type {Array} */
    var data = [];
    /** @type {Array} */
    var lines = [];
    /** @type {number} */
    var j = 0;
    var spaces = selectElement.companyDynamicSaleRateJSON.length;
    for (;spaces > j;j++) {
      var e = selectElement.companyDynamicSaleRateJSON[j];
      data.push(should.accMul(e.dynamicSaleRate, 100));
      lines.push(e.month.substring(0, 4) + "-" + e.month.substring(5, 7));
    }
    /** @type {Date} */
    var value = new Date;
    if (lines[0]) {
      value.setFullYear(parseInt(lines[0].substring(0, 4)), parseInt(lines[0].substring(5, 7)), 0);
    }
    /** @type {number} */
    j = 0;
    /** @type {number} */
    spaces = 12 - selectElement.companyDynamicSaleRateJSON.length;
    for (;spaces > j;j++) {
      value.setDate(0);
      data.unshift(0);
      lines.unshift(value.getFullYear() + "-" + (value.getMonth() + 1));
    }
    $scope.lastDynSaleRate = data[11];
    /** @type {number} */
    $scope.lastDynSaleLevel = $scope.lastDynSaleRate >= 80 && $scope.lastDynSaleRate <= 100 ? 1 : $scope.lastDynSaleRate >= 50 && $scope.lastDynSaleRate <= 130 ? 2 : 3;
    var options = {
      title : {
        text : "动销率走势",
        x : 20
      },
      tooltip : {
        show : false,
        trigger : "axis"
      },
      grid : {
        x : 50,
        y : 40,
        x2 : 30,
        y2 : 55
      },
      toolbox : {
        show : false
      },
      animation : false,
      xAxis : [{
        type : "category",
        boundaryGap : true,
        axisLabel : {
          textStyle : {
            color : "#726f83"
          },
          interval : 0,
          rotate : 45
        },
        data : lines
      }],
      yAxis : [{
        type : "value",
        nameTextStyle : {
          color : "#726f83"
        },
        axisLabel : {
          textStyle : {
            color : "#726f83"
          },
          formatter : "{value} %"
        }
      }],
      series : [{
        name : "动销率",
        type : "line",
        smooth : true,
        data : data,
        itemStyle : {
          normal : {
            label : {
              show : true
            }
          }
        }
      }]
    };
    obj = echarts.init(document.getElementById("optionDynSaleDiv"), element.echartsTheme);
    obj.setOption(options);
  }).error(function() {
    loading.hide();
    console.error("获取报表数据出现异常！");
  });
}]).controller("TurnOverRateChartCtrl", ["$scope", "psisServices", "$filter", "Tools", "$ionicPopover", "lbSpinnerDialog", "ReportConstant", "$ionicActionSheet", function($scope, $http, $filter, deepDataAndEvents, FB, loading, element, $element) {
  var obj;
  /**
   * @param {Date} sum
   * @return {undefined}
   */
  var createIntervalElements = function(sum) {
    sum.setDate(0);
    sum.setHours(0);
    sum.setMinutes(0);
    sum.setSeconds(0);
    sum.setMilliseconds(0);
  };
  /** @type {Array} */
  $scope.turnOverRateMonths = [];
  /** @type {number} */
  $scope.turnOverRateType = 1;
  $scope.reportLevel = element.reportLevel;
  /**
   * @return {undefined}
   */
  $scope.showActionsheet = function() {
    $element.show(element.actionSheet($scope));
  };
  /**
   * @return {undefined}
   */
  $scope.initTurnOverRateMonths = function() {
    /** @type {Date} */
    var sum = new Date;
    /** @type {Date} */
    var against = new Date("2014,9,30");
    /** @type {number} */
    var n = 0;
    for (;12 > n && (createIntervalElements(sum), !(against > sum));n++) {
      !function(time) {
        $scope.turnOverRateMonths.push({
          value : time.getTime(),
          text : time.getFullYear() + "年" + (time.getMonth() + 1) + "月"
        });
      }(sum);
    }
  };
  FB.fromTemplateUrl("turnOverRateMonths.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.turnOverRateMonthsPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openTurnOverRateMonthsPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.turnOverRateMonthsPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideTurnOverRateMonthsPopover = function() {
    $scope.turnOverRateMonthsPopover.hide();
  };
  FB.fromTemplateUrl("turnOverTipsPopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.turnOverTipsPopover = $location;
  });
  FB.fromTemplateUrl("turnOverRateTypePopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.turnOverRateTypePopover = $location;
  });
  $scope.$on("$destroy", function() {
    if (obj) {
      obj.dispose();
    }
    $scope.turnOverRateMonthsPopover.remove();
    $scope.turnOverTipsPopover.remove();
    $scope.turnOverRateTypePopover.remove();
  });
  /**
   * @param {Array} data
   * @param {number} extra
   * @return {?}
   */
  var trigger = function(data, extra) {
    var ch;
    switch(extra) {
      case 1:
        /** @type {string} */
        ch = "周转率排行前十";
        break;
      case 2:
        /** @type {string} */
        ch = "周转率排行后十";
    }
    /** @type {Array} */
    var d = [];
    /** @type {Array} */
    var response = [];
    data.forEach(function(dataAndEvents) {
      d.unshift(dataAndEvents.colorName + "|" + dataAndEvents.sizeName + "|" + dataAndEvents.goodName);
      response.unshift(deepDataAndEvents.accMul(dataAndEvents.turnoverRate ? dataAndEvents.turnoverRate : 0, 100));
    });
    var options = {
      title : {
        text : ch,
        x : 20
      },
      tooltip : {
        show : false,
        trigger : "axis"
      },
      grid : {
        x : 130,
        y : 40,
        x2 : 60,
        y2 : 25
      },
      toolbox : {
        show : false
      },
      animation : false,
      xAxis : [{
        type : "value",
        nameTextStyle : {
          color : "#726f83"
        },
        axisLabel : {
          textStyle : {
            color : "#726f83"
          },
          formatter : "{value} %"
        },
        splitNumber : 3
      }],
      yAxis : [{
        type : "category",
        boundaryGap : true,
        axisLabel : {
          textStyle : {
            color : "#726f83",
            fontSize : 11
          },
          /**
           * @param {string} x
           * @return {?}
           */
          formatter : function(x) {
            return x.replace(/(\S{15})(\S{0,15})(\S*)/, "$1\n$2\n$3");
          }
        },
        data : d
      }],
      series : [{
        name : "周转率",
        type : "bar",
        data : response,
        itemStyle : {
          normal : {
            label : {
              show : true
            }
          }
        }
      }]
    };
    return options;
  };
  /**
   * @param {?} data
   * @return {undefined}
   */
  $scope.turnOverRateSearch = function(data) {
    $scope.selectMouth = data;
    var customer = {
      endTime : $filter("date")(data.value, "yyyy-MM-ddTHH:mm:ss.sssZ")
    };
    loading.show();
    $http.post("/KEY146", customer).success(function(data) {
      loading.hide();
      /**
       * @param {number} alertTitle
       * @return {undefined}
       */
      $scope.setEchartsOption = function(alertTitle) {
        switch($scope.turnOverRateType = alertTitle ? alertTitle : $scope.turnOverRateType, obj && obj.dispose(), $scope.turnOverRateType) {
          case 1:
            if (data.goodsTurnOverRateTop10.length) {
              obj = echarts.init(document.getElementById("optionTurnOverRateDiv"), element.echartsTheme);
              obj.setOption(trigger(data.goodsTurnOverRateTop10, 1));
            } else {
              /** @type {null} */
              obj = null;
            }
            break;
          case 2:
            if (data.goodsTurnOverRateDown10.length) {
              obj = echarts.init(document.getElementById("optionTurnOverRateDiv"), element.echartsTheme);
              obj.setOption(trigger(data.goodsTurnOverRateDown10, 2));
            } else {
              /** @type {null} */
              obj = null;
            }
          ;
        }
      };
      $scope.turnOverRateAvg = data.goodsTurnOverRateAvg ? deepDataAndEvents.accMul(data.goodsTurnOverRateAvg.turnOverRateAvg, 100) : 0;
      $scope.turnOverRateLevel = data.turnOverRateLevel;
      $scope.setEchartsOption();
    }).error(function() {
      loading.hide();
      console.error("获取报表数据出现异常！");
    });
  };
  $scope.initTurnOverRateMonths();
  $scope.turnOverRateSearch($scope.turnOverRateMonths[0]);
}]).controller("OperateDetailCtrl", ["$scope", "$state", "Tools", "psisServices", "lbSpinnerDialog", "$ionicModal", "$ionicPopover", "$cordovaDatePicker", "$timeout", "lruPersistCache", function(self, $state, list, _, loading, $modal, FB, $scope, dataAndEvents, $templateCache) {
  self.viewTitle = self.NameConstant.KEY198;
  self.searchModel = {
    storeHouse : {}
  };
  $modal.fromTemplateUrl("operateDetailQuery.html", function(theTitle) {
    self.operateDetailQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    self.storehousePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    self.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideStorehousePopover = function() {
    self.storehousePopover.hide();
  };
  self.$on("$destroy", function() {
    self.storehousePopover.remove();
    self.operateDetailQueryModal.remove();
  });
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    self.searchModel.storeHouse = {};
    self.searchModel.beginTime = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
    self.searchModel.endTime = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeBegin = function() {
    $scope.show({
      date : self.searchModel.beginTime ? new Date(self.searchModel.beginTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.searchModel.beginTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeEnd = function() {
    $scope.show({
      date : self.searchModel.endTime ? new Date(self.searchModel.endTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.searchModel.endTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.refreshTimePeriod = function() {
    /** @type {string} */
    self.searchModel.timePeriod = self.searchModel.beginTime || self.searchModel.endTime ? self.searchModel.beginTime && self.searchModel.endTime ? list.getDayBeginStr(self.searchModel.beginTime) == list.getDayBeginStr((new Date).getTime()) && list.getDayBeginStr(self.searchModel.endTime) == list.getDayBeginStr((new Date).getTime()) ? "today" : list.getDayBeginStr(self.searchModel.beginTime) ==
    list.getOffsetDayBeginStr((new Date).getTime(), -1) && list.getDayBeginStr(self.searchModel.endTime) == list.getOffsetDayBeginStr((new Date).getTime(), -1) ? "yesterday" : list.getDayBeginStr(self.searchModel.beginTime) == list.getOffsetDayBeginStr((new Date).getTime(), -6) && list.getDayBeginStr(self.searchModel.endTime) == list.getDayBeginStr((new Date).getTime()) ? "thisWeek" : list.getDayBeginStr(self.searchModel.beginTime) ==
    list.getOffsetDayBeginStr((new Date).getTime(), -29) && list.getDayBeginStr(self.searchModel.endTime) == list.getDayBeginStr((new Date).getTime()) ? "thisMonth" : "other" : "other" : "all";
  };
  /**
   * @param {number} includeAssociated
   * @return {undefined}
   */
  self.getData = function(includeAssociated) {
    /** @type {number} */
    self.searchModel.page = 1;
    if (2 == includeAssociated) {
      self.refreshTimePeriod();
    }
    loading.show(true);
    success().success(function(item) {
      self.item = item;
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  self.getAllData = function() {
    loading.show(true);
    success().success(function(item) {
      self.item = item;
      fillDaysFullMonth().success(function(theTitle) {
        self.saleItem = theTitle;
      }).finally(function() {
        /** @type {boolean} */
        self.saleDataLoading = false;
      });
      $http().success(function(theTitle) {
        self.financItem = theTitle;
      }).finally(function() {
        /** @type {boolean} */
        self.financDataLoading = false;
      });
      post().success(function(theTitle) {
        self.storehouseItem = theTitle;
      }).finally(function() {
        /** @type {boolean} */
        self.storehouseDataLoading = false;
      });
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {?}
   */
  var fillDaysFullMonth = function() {
    self.searchModel.beginTime = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
    self.searchModel.endTime = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
    var attributes = {
      beginTime : list.getDayBeginStr(self.searchModel.beginTime),
      endTime : list.getOffsetDayBeginStr(self.searchModel.endTime, 1)
    };
    return _.postEncode("/KEY142", attributes);
  };
  /**
   * @return {?}
   */
  var $http = function() {
    return _.postEncode("/KEY143");
  };
  /**
   * @return {?}
   */
  var post = function() {
    return _.post("/KEY091", {
      existsNumber : 1,
      listDataType : 1,
      operator : 3,
      storehouseId : "",
      storehouseMerge : true
    });
  };
  /**
   * @return {?}
   */
  var success = function() {
    if ("today" == self.searchModel.timePeriod) {
      self.searchModel.beginTime = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
      self.searchModel.endTime = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
    } else {
      if ("yesterday" == self.searchModel.timePeriod) {
        self.searchModel.beginTime = list.getDayBegin((new Date).setDate((new Date).getDate() - 1)).getTime();
        self.searchModel.endTime = list.getDayBegin((new Date).setDate((new Date).getDate() - 1)).getTime();
      } else {
        if ("thisWeek" == self.searchModel.timePeriod) {
          self.searchModel.beginTime = list.getDayBegin((new Date).setDate((new Date).getDate() - 6)).getTime();
          self.searchModel.endTime = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
        } else {
          if ("thisMonth" == self.searchModel.timePeriod) {
            self.searchModel.beginTime = list.getDayBegin((new Date).setDate((new Date).getDate() - 29)).getTime();
            self.searchModel.endTime = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
          } else {
            if ("all" == self.searchModel.timePeriod) {
              /** @type {string} */
              self.searchModel.beginTime = "";
              /** @type {string} */
              self.searchModel.endTime = "";
            }
          }
        }
      }
    }
    var value = {
      storehouseId : self.searchModel.storeHouse ? self.searchModel.storeHouse.val : null,
      beginTime : list.getDayBeginStr(self.searchModel.beginTime),
      endTime : list.getOffsetDayBeginStr(self.searchModel.endTime, 1)
    };
    return value.storehouseId || delete value.storehouseId, value.beginTime || delete value.beginTime, value.endTime || delete value.endTime, _.postEncode("/KEY141", value);
  };
  /**
   * @param {string} str
   * @return {?}
   */
  self.getTimePeriod = function(str) {
    /** @type {string} */
    var space = "";
    /** @type {string} */
    var arg = "";
    if ("today" == str) {
      space = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
      arg = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
    } else {
      if ("yesterday" == str) {
        space = list.getDayBegin((new Date).setDate((new Date).getDate() - 1)).getTime();
        arg = list.getDayBegin((new Date).setDate((new Date).getDate() - 1)).getTime();
      } else {
        if ("thisWeek" == str) {
          space = list.getDayBegin((new Date).setDate((new Date).getDate() - 6)).getTime();
          arg = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
        } else {
          if ("thisMonth" == str) {
            space = list.getDayBegin((new Date).setDate((new Date).getDate() - 29)).getTime();
            arg = list.getDayBegin((new Date).setDate((new Date).getDate())).getTime();
          } else {
            if ("all" == str) {
              /** @type {string} */
              space = "";
              /** @type {string} */
              arg = "";
            }
          }
        }
      }
    }
    var newTimeObject = {
      beginTime : list.getDayBeginStr(space),
      endTime : list.getOffsetDayBeginStr(arg, 1),
      timePeriod : str
    };
    return newTimeObject;
  };
  /**
   * @param {number} dataAndEvents
   * @param {string} err
   * @return {undefined}
   */
  self.goReport = function(dataAndEvents, err) {
    if (1 == dataAndEvents) {
      var data = err ? self.getTimePeriod(err) : self.searchModel;
      $templateCache.put("saleQueryCondition", JSON.stringify(data));
      $state.go("eventmenu.KEY144");
    } else {
      if (2 == dataAndEvents) {
        $templateCache.put("purchaseQueryCondition", JSON.stringify(self.searchModel));
        $state.go("eventmenu.KEY067");
      } else {
        if (3 != dataAndEvents || self.storehouseDataLoading) {
          if (4 == dataAndEvents && (!self.financDataLoading && self.GetOperatorEventLimit("KEY084"))) {
            $state.go("eventmenu.KEY265");
          } else {
            if (5 == dataAndEvents) {
              var $stateParams = {
                createTimeBegin : self.searchModel.beginTime,
                createTimeEnd : self.searchModel.endTime
              };
              $state.go("eventmenu.KEY072", $stateParams);
            } else {
              if (6 == dataAndEvents && (!self.financDataLoading && self.GetOperatorEventLimit("KEY058"))) {
                $state.go("eventmenu.KEY255");
              } else {
                if (7 == dataAndEvents) {
                  if (self.GetOperatorEventLimit("KEY169")) {
                    $state.go("eventmenu.KEY207", {
                      existsNumber : 1
                    });
                  }
                }
              }
            }
          }
        } else {
          $state.go("eventmenu.KEY248");
        }
      }
    }
  };
  self.$on("$ionicView.loaded", function() {
    self.searchModel = {
      timePeriod : "today"
    };
    /** @type {boolean} */
    self.saleDataLoading = true;
    /** @type {boolean} */
    self.financDataLoading = true;
    /** @type {boolean} */
    self.storehouseDataLoading = true;
    self.getAllData();
    _.httpCacheGet.get(_.httpCacheGet.ac.KEY177).success(function(theTitle) {
      self.allDept = theTitle;
    });
  });
}]);
