angular.module("tmsController", ["ionic", "services", "tools"]).controller("TmsMainCtrl", ["$scope", "$state", "Tools", "ServerConfig", "ServerType", "psisServices", "lbSpinnerDialog", "$ionicModal", "wechatShare", "commonDataInterface", "qqShare", function($scope, $state, index, context, deepDataAndEvents, $http, loading, $modal, self, dataAndEvents, util) {
  var path = context.tmsServer.replace(/cid/, $scope.mainCompany.id);
  if (deepDataAndEvents.isEX()) {
    path = path.replace(/web/, "ex");
  } else {
    if (context.currentServer.indexOf("dev") >= 0) {
      path = path.replace(/www/, "dev");
    }
  }
  /** @type {boolean} */
  $scope.isShowWechatShopAccount = false;
  $scope.ac = {};
  $scope.shopAdress = path;
  /**
   * @return {undefined}
   */
  var open = function() {
    loading.show();
    $http.post("/KEY336").success(function(res) {
      if (1 == res.statusCode) {
        if (res.object) {
          if (res.object.wechatShopAccount) {
            $scope.ac = res.object.wechatShopAccount;
            if ($scope.collectionAmount) {
              if ($scope.collectionAmount.proxyAmountNotSettled > 0) {
                /** @type {boolean} */
                $scope.isShowWechatShopAccount = true;
              }
            }
          }
        }
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {?}
   */
  $scope.gotoCollection = function() {
    return $scope.GetOperatorEventLimit("KEY064") ? void $state.go("eventmenu.collection") : (index.toastShow("此子账户没提现的权限"), false);
  };
  /**
   * @param {Array} dataAndEvents
   * @return {undefined}
   */
  $scope.gotoTradeList = function(dataAndEvents) {
    $state.go("eventmenu.KEY213", {
      isSettled : dataAndEvents
    });
  };
  /**
   * @return {undefined}
   */
  $scope.shareShop = function() {
    $http.post("/KEY320").success(function(result) {
      if (1 === result.statusCode) {
        if (result.object) {
          err = result.object;
          $scope.KEY263.show();
        }
      }
    });
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY040.html", function($location) {
    $scope.KEY263 = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  var err = {};
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  $scope.share = function(opt_attributes) {
    var right = err.shareTitle ? err.shareTitle : "";
    var body = err.description ? err.description : "";
    var msg = err.shareImg;
    var b = err.shareLink ? err.shareLink : "";
    if ("Timeline" == opt_attributes) {
      self.shareUrlToTimeline(b, right, body, msg);
      dataAndEvents.addFuncLog("Xiaohuobao_ShopShare_Session", "销货宝店铺分享商品到好友", index.getDeviceInfo());
    } else {
      if ("friend" == opt_attributes) {
        self.shareUrlToSession(b, right, body, msg);
        dataAndEvents.addFuncLog("Xiaohuobao_ShopShare_Timeline", "销货宝店铺分享商品到朋友圈", index.getDeviceInfo());
      } else {
        if ("qq" == opt_attributes) {
          util.shareUrlToQq(b, right, body, msg);
        } else {
          if ("qz" == opt_attributes) {
            /** @type {Array} */
            var progressValues = [];
            progressValues.push(msg);
            util.shareUrlToQz(b, right, body, progressValues);
          }
        }
      }
    }
  };
  $scope.$on("$destroy", function() {
    $scope.KEY263.remove();
  });
  $scope.$on("$ionicView.loaded", function() {
    if ($scope.GetOperatorEventLimit("KEY085")) {
      open();
    }
  });
}]).controller("TmsGoodsListCtrl", ["$scope", "$rootScope", "$timeout", "$state", "psisServices", "lbScrollDelegate", "$ionicModal", "Tools", "lruPersistCache", "$cordovaBarcodeScanner", "lbSpinnerDialog", "$ionicPopup", "$ionicActionSheet", "$ionicPopover", "wechatShare", "ServerConfig", "ServerType", "$ionicPlatform", "commonDataInterface", "qqShare", "PrintType", function(self, mod, $sanitize, $state, test, parent, $modal, $, $templateCache,
Hogan, loading, _, handler, FB, util, context, ignoreMethodDoesntExist, textAlt, dataAndEvents, console, deepDataAndEvents) {
  /** @type {boolean} */
  self.isLoading = true;
  var path = context.tmsServer.replace(/cid/, self.mainCompany.id);
  if (ignoreMethodDoesntExist.isEX()) {
    path = path.replace(/web/, "ex");
  } else {
    if (context.currentServer.indexOf("dev") >= 0) {
      path = path.replace(/www/, "dev");
    }
  }
  /** @type {Array} */
  self.items = [];
  /** @type {Array} */
  self.selectedGoods = [];
  /** @type {Array} */
  self.selectedGoodsId = [];
  /** @type {Array} */
  self.selectedIsOnSale = [];
  /** @type {number} */
  self.selectedNum = 0;
  self.goodsInfo = {
    name : ""
  };
  self.queryCondition = {
    page : 1,
    isOnSale : 0
  };
  self.allCategoryList = {};
  /** @type {string} */
  self.selectTiltle = "全选";
  /**
   * @return {?}
   */
  var Step = function() {
    return test.postEncode("/admin/shop/wechat/commodity/commodityListJSON.ac?goodsUnion=y", self.queryCondition);
  };
  /**
   * @return {undefined}
   */
  self.getCondition = function() {
    self.queryCondition.categoryIdsStr = self.goodsInfo.category ? $.getCategoryChildIds(self.allCategoryList, self.goodsInfo.category.id) : "";
    self.queryCondition.blandId = self.goodsInfo.bland ? self.goodsInfo.bland.id : "";
    /** @type {number} */
    self.queryCondition.operator = 3;
    /** @type {number} */
    self.queryCondition.page = 1;
    if (self.goodsInfo.name) {
      self.queryCondition.barCode = self.goodsInfo.name;
      self.queryCondition.goodsSn = self.goodsInfo.name;
      self.queryCondition.commodityName = self.goodsInfo.name;
      self.queryCondition.skuBarCode = self.goodsInfo.name;
      self.queryCondition.skuSn = self.goodsInfo.name;
    } else {
      delete self.queryCondition.barCode;
      delete self.queryCondition.goodsSn;
      delete self.queryCondition.commodityName;
      delete self.queryCondition.skuBarCode;
      delete self.queryCondition.skuSn;
    }
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    self.getCondition();
    self.clearSelectedGoodsInfo();
    loading.show();
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      parent.scrollTop("goodListCtrlScroll");
      loading.hide();
    });
  };
  /**
   * @param {?} line
   * @param {?} event
   * @return {undefined}
   */
  self.selectGoods = function(line, event) {
    if (event) {
      event.stopPropagation();
    }
    var fromIndex = self.selectedGoodsId.indexOf(line.goodsId);
    if (fromIndex > -1) {
      self.selectedGoodsId.splice(fromIndex, 1);
      self.selectedGoods.splice(fromIndex, 1);
      self.selectedNum--;
    } else {
      self.selectedGoodsId.push(line.goodsId);
      self.selectedGoods.push(line);
      self.selectedNum++;
    }
    if (fromIndex > -1) {
      self.selectedIsOnSale.splice(fromIndex, 1);
    } else {
      self.selectedIsOnSale.push(line.isOnSale);
    }
  };
  /**
   * @param {string} dataAndEvents
   * @param {?} event
   * @return {undefined}
   */
  self.goTmsGoodsEdit = function(dataAndEvents, event) {
    if (event) {
      event.stopPropagation();
    }
    $state.go("eventmenu.KEY318", {
      tmsGoodsId : dataAndEvents
    });
  };
  /**
   * @return {?}
   */
  self.isSelectedGoodsNull = function() {
    return $.isEmpty(self.selectedGoodsId);
  };
  /** @type {Array} */
  var _emails = ["/KEY342", "/KEY350"];
  /**
   * @param {number} i
   * @return {?}
   */
  self.dealGoods = function(i) {
    if (self.isSelectedGoodsNull()) {
      return void $.toastShow("请选择商品操作");
    }
    if (0 == i) {
      if (!$.contains(self.selectedIsOnSale, 1)) {
        return void _.alert({
          template : "<div class='tc'>请选择已上架的商品！</div>",
          okText : "确定"
        });
      }
    } else {
      if (1 == i && !$.contains(self.selectedIsOnSale, 0)) {
        return void _.alert({
          template : "<div class='tc'>请选择已下架的商品！</div>",
          okText : "确定"
        });
      }
    }
    loading.show();
    /** @type {string} */
    var optsData = "";
    if (0 == i) {
      /** @type {string} */
      optsData = "下架";
    } else {
      if (1 == i) {
        /** @type {string} */
        optsData = "上架";
      }
    }
    test.post(_emails[i], {
      goodsId : self.selectedGoodsId
    }).success(function(r) {
      if (1 == r.statusCode) {
        _.alert({
          template : "<div class='tc'>" + optsData + "成功</div>",
          okText : "确定"
        }).then(function() {
          self.getList();
        });
      } else {
        _.alert({
          template : "<div class='tc'>" + optsData + "失败，" + r.content + "</div>",
          okText : "确定"
        });
      }
    }).finally(function() {
      loading.hide();
    });
  };
  self.processConfigTask = {
    taskList : [],
    stepSize : 5,
    stepIndex : 0,
    process : 0,
    stopFlag : false,
    tips : "",
    /**
     * @return {?}
     */
    getAllCount : function() {
      return this.taskList.length;
    },
    /**
     * @param {Array} deepDataAndEvents
     * @return {undefined}
     */
    initTask : function(deepDataAndEvents) {
      /** @type {Array} */
      this.taskList = deepDataAndEvents;
      /** @type {number} */
      this.stepSize = 5;
      /** @type {number} */
      this.stepIndex = 0;
      /** @type {boolean} */
      this.stopFlag = false;
      /** @type {number} */
      this.process = 0;
      /** @type {string} */
      this.tips = "";
    },
    /**
     * @return {?}
     */
    nextTaskList : function() {
      var num = this.stepIndex + this.stepSize;
      if (num >= this.getAllCount()) {
        num = this.getAllCount();
      }
      var indexForNum = this.taskList.slice(this.stepIndex, num);
      return this.stepIndex = num, this.process = (this.stepIndex / this.getAllCount() * 100).toFixed(0), this.stepIndex >= this.getAllCount() && (this.process = 100), indexForNum;
    },
    /**
     * @return {?}
     */
    isTaskEnd : function() {
      return this.stepIndex >= this.getAllCount() ? true : void 0;
    },
    /**
     * @return {undefined}
     */
    stopForce : function() {
      /** @type {boolean} */
      this.stopFlag = true;
    },
    /**
     * @return {?}
     */
    isStopForce : function() {
      return this.stopFlag;
    }
  };
  /** @type {Array} */
  var flags = ["/KEY350", "/KEY342", "/KEY380"];
  /**
   * @param {number} key
   * @param {(Array|string)} deepDataAndEvents
   * @return {?}
   */
  self.dealALLGoodsTask = function(key, deepDataAndEvents) {
    /** @type {string} */
    var quote = "";
    if (0 == key ? quote = "上架" : 1 == key ? quote = "下架" : 2 == key && (quote = "同步"), deepDataAndEvents && (window.cordova ? ionic.Platform.isAndroid() ? window.plugins.ProgressView.show(quote + "处理中...", "HORIZONTAL") : progress.show({
      text : quote + "处理中..."
    }) : loading.show(), self.processConfigTask.initTask(deepDataAndEvents)), self.processConfigTask.isTaskEnd()) {
      return self.hideProgress(), void _.alert({
        template : "<div class='tc'>" + quote + "成功</div>",
        okText : "确定"
      }).then(function() {
        self.getList();
      });
    }
    var goodsId = self.processConfigTask.nextTaskList();
    if (window.cordova) {
      if (ionic.Platform.isAndroid()) {
        window.plugins.ProgressView.setProgress(self.processConfigTask.stepIndex / self.processConfigTask.getAllCount(), function() {
        });
      } else {
        setTimeout(function() {
          progress.update({
            text : "正在处理中" + self.processConfigTask.stepIndex + "/" + self.processConfigTask.getAllCount() + " ..."
          });
        }, 300);
      }
    } else {
      loading.show();
    }
    var data = {
      goodsId : goodsId
    };
    if (2 == key) {
      data = {
        goodsId : goodsId,
        synType : "baseInfo,skuInfo,parameterInfo,pictures,detailInfo"
      };
    }
    test.post(flags[key], data).success(function(r) {
      if (1 == r.statusCode) {
        if (self.processConfigTask.isStopForce()) {
          return self.hideProgress(), void _.alert({
            template : "<div class='tc'>已终止任务</div>",
            okText : "确定"
          }).then(function() {
            self.getList();
          });
        }
        self.dealALLGoodsTask(key);
      } else {
        self.hideProgress();
        _.alert({
          template : "<div class='tc'>" + quote + "失败，" + r.content + "</div>",
          okText : "确定"
        });
      }
    }).error(function() {
      self.hideProgress();
    });
  };
  /**
   * @param {number} key
   * @return {undefined}
   */
  self.dealAllGoods = function(key) {
    /** @type {string} */
    var optsData = "";
    if (0 == key) {
      /** @type {string} */
      optsData = "上架";
    } else {
      if (1 == key) {
        /** @type {string} */
        optsData = "下架";
      }
    }
    if (2 == key) {
      /** @type {string} */
      optsData = "同步";
    }
    loading.show();
    self.getCondition();
    var data = {};
    if (0 == key) {
      data = {
        isOnSale : 0
      };
    } else {
      if (1 == key) {
        data = {
          isOnSale : 1
        };
      }
    }
    test.post("/KEY361", data).success(function(res) {
      loading.hide();
      if (1 == res.statusCode) {
        if (res.object.goodsId && res.object.goodsId.length <= 0) {
          _.alert({
            template : "<div class='tc'>没有找到可以" + optsData + "的商品! </div>",
            okText : "确定"
          }).then(function() {
            self.getList();
          });
        } else {
          self.dealALLGoodsTask(key, res.object.goodsId);
        }
      } else {
        _.alert({
          template : "<div class='tc'>" + optsData + "失败，" + res.content + "</div>",
          okText : "确定"
        });
      }
    });
  };
  /**
   * @param {number} part
   * @return {undefined}
   */
  self.uploadAllGoods = function(part) {
    /** @type {string} */
    var accept = "【全部上架】操作会将本地所有启用的商品上架至销货宝，是否继续？";
    if (window.cordova && window.cordova.plugins) {
      $.showConfirm(accept, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          self.dealAllGoods(part);
        }
      }, null, ["取消", "确认"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>【全部上架】操作会将本地所有启用的商品上架至销货宝，是否继续？</div>",
        cancelText : "取消",
        okText : "确定"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          self.dealAllGoods(part);
        }
      });
    }
  };
  /**
   * @param {number} part
   * @return {undefined}
   */
  self.removeAllGoods = function(part) {
    /** @type {string} */
    var accept = "【全部下架】操作会将销货宝上所有的商品都下架，是否继续？";
    if (window.cordova && window.cordova.plugins) {
      $.showConfirm(accept, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          self.dealAllGoods(part);
        }
      }, null, ["取消", "确认"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>【全部下架】操作会将销货宝上所有的商品都下架，是否继续？</div>",
        cancelText : "取消",
        okText : "确定"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          self.dealAllGoods(part);
        }
      });
    }
  };
  /**
   * @param {number} part
   * @return {undefined}
   */
  self.synAllGoods = function(part) {
    /** @type {string} */
    var accept = "同步会将销货宝店铺商品的名称、价格等信息重新按内部商品重置，是否继续？";
    if (window.cordova && window.cordova.plugins) {
      $.showConfirm(accept, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          self.dealAllGoods(part);
        }
      }, null, ["取消", "确认"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>同步会将销货宝店铺商品的名称、价格等信息重新按内部商品重置，是否继续？</div>",
        cancelText : "取消",
        okText : "确定"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          self.dealAllGoods(part);
        }
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.hideProgress = function() {
    if (window.cordova) {
      if (ionic.Platform.isAndroid()) {
        window.plugins.ProgressView.hide();
      } else {
        progress.hide();
      }
    } else {
      loading.hide();
    }
  };
  /**
   * @param {?} prototype
   * @return {undefined}
   */
  self.modifySelectedData = function(prototype) {
    var sid;
    for (sid in self.selectedGoodsId) {
      var itemName;
      for (itemName in self.items) {
        var object = self.items[itemName];
        if (self.selectedGoodsId[sid] == object.goodsId) {
          object.isOnSale = prototype;
          break;
        }
      }
    }
    self.clearSelectedGoodsInfo();
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.modifyAllData = function(dataAndEvents) {
    var itemName;
    for (itemName in self.items) {
      self.items[itemName].isOnSale = dataAndEvents;
    }
    self.clearSelectedGoodsInfo();
  };
  /**
   * @param {(Object|string)} dataAndEvents
   * @param {?} deepDataAndEvents
   * @return {undefined}
   */
  self.modifyGoodsState = function(dataAndEvents, deepDataAndEvents) {
    var itemName;
    for (itemName in self.items) {
      if (dataAndEvents && dataAndEvents == self.items[itemName].goodsId) {
        self.items[itemName].isOnSale = deepDataAndEvents;
        break;
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.showActionsheet = function() {
    var buttons;
    var isEmpty;
    /** @type {Array} */
    buttons = [{
      text : '<i class="icon ion-ios-upload-outline assertive"></i> 全部上架'
    }, {
      text : '<i class="icon ion-ios-download-outline assertive"></i> 全部下架'
    }, {
      text : '<i class="icon ion-android-sync assertive"></i> 同步'
    }, {
      text : '<i class="icon ion-ios-close-outline assertive"></i> 取消'
    }];
    /**
     * @param {?} str
     * @return {?}
     */
    isEmpty = function(str) {
      switch(str) {
        case 0:
          self.uploadAllGoods(0);
          break;
        case 1:
          self.removeAllGoods(1);
          break;
        case 2:
          self.synAllGoods(2);
      }
      return true;
    };
    var expectedNumberOfNonCommentArgs = {
      buttons : buttons,
      /** @type {function (?): ?} */
      buttonClicked : isEmpty
    };
    handler.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {?} resourceConfigOverrides
   * @return {?}
   */
  var $http = function(resourceConfigOverrides) {
    return test.postEncode("/KEY357", {
      goodsId : resourceConfigOverrides
    });
  };
  var err = {};
  /**
   * @param {?} req
   * @param {?} event
   * @return {undefined}
   */
  self.shareGoods = function(req, event) {
    err = {};
    if (event) {
      event.stopPropagation();
    }
    loading.show(true);
    $http(req.goodsId).success(function(result) {
      if (result && 1 == result.statusCode) {
        if (1 == result.object.isPutOnSale) {
          self.KEY263.show();
          err = result.object;
        } else {
          var promise = _.confirm({
            template : "<div class='tc'>商品尚未上架到销货宝，请先上架再分享</div>",
            cancelText : "取消",
            okText : "上架商品"
          });
          promise.then(function(dataAndEvents) {
            if (dataAndEvents) {
              loading.show(true);
              test.postEncode("/KEY377", {
                goodsId : req.goodsId
              }).success(function(r) {
                if (1 == r.statusCode) {
                  $.toastShow("上架成功");
                  $http(req.goodsId).success(function(result) {
                    if (result) {
                      if (1 == result.statusCode) {
                        if (1 == result.object.isPutOnSale) {
                          self.modifyGoodsState(req.goodsId, result.object.isPutOnSale);
                          self.KEY263.show();
                          err = result.object;
                        }
                      }
                    }
                  });
                } else {
                  _.alert({
                    template : "<div class='tc'>上架失败</div>",
                    okText : "确定"
                  });
                }
              }).finally(function() {
                loading.hide();
              });
            }
          });
        }
      } else {
        $.toastShow(result.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  self.share = function(opt_attributes) {
    var title = err.shareTitle ? err.shareTitle : "";
    var body = err.description ? err.description : "";
    var msg = err.shareImg;
    var b = err.shareLink ? err.shareLink : "";
    if ("Timeline" == opt_attributes) {
      util.shareUrlToTimeline(b, title, body, msg);
      dataAndEvents.addFuncLog("Xiaohuobao_GoodsShare_Timeline", "商品列表中分享商品到朋友圈", $.getDeviceInfo());
    } else {
      if ("friend" == opt_attributes) {
        util.shareUrlToSession(b, title, body, msg);
        dataAndEvents.addFuncLog("Xiaohuobao_GoodsShare_Session", "商品列表中分享商品到好友", $.getDeviceInfo());
      } else {
        if ("qq" == opt_attributes) {
          console.shareUrlToQq(b, title, body, msg);
        } else {
          if ("qz" == opt_attributes) {
            /** @type {Array} */
            var progressValues = [];
            progressValues.push(msg);
            console.shareUrlToQz(b, title, body, progressValues);
          }
        }
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    self.goodsInfo = {
      name : ""
    };
  };
  /**
   * @return {undefined}
   */
  self.clearSelectedGoodsInfo = function() {
    /** @type {Array} */
    self.selectedGoods = [];
    /** @type {Array} */
    self.selectedGoodsId = [];
    /** @type {Array} */
    self.selectedIsOnSale = [];
    /** @type {number} */
    self.selectedNum = 0;
    /** @type {string} */
    self.selectTiltle = "全选";
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("goodListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    Hogan.scan().then(function(data) {
      if (!data.cancelled) {
        $sanitize(function() {
          self.goodsInfo.name = data.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      $.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {?}
   */
  self.selectedAllGoods = function() {
    if (self.items.length < 1) {
      return false;
    }
    if ("全选" == self.selectTiltle) {
      self.clearSelectedGoodsInfo();
      /** @type {number} */
      self.selectedNum = 0;
      /** @type {number} */
      var b = 0;
      var a = self.items.length;
      for (;a > b;b++) {
        self.selectedGoods.push(self.items[b]);
        self.selectedGoodsId.push(self.items[b].goodsId);
        self.selectedIsOnSale.push(self.items[b].isOnSale);
        self.selectedNum++;
      }
      console.log(self.selectedGoods);
      /** @type {string} */
      self.selectTiltle = "取消";
    } else {
      self.clearSelectedGoodsInfo();
    }
  };
  /**
   * @return {undefined}
   */
  self.printQRCodeArray = function() {
    if (self.selectedGoods && self.selectedGoods.length > 0) {
      var path = context.tmsServer.replace(/cid/, mod.mainCompany.id);
      if (ignoreMethodDoesntExist.isEX()) {
        path = path.replace(/web/, "ex");
      } else {
        if (context.currentServer.indexOf("dev") >= 0) {
          path = path.replace(/web/, "dev");
        }
      }
      var args = self.processingPrintData(self.selectedGoods, path);
      if (args.length < self.selectedGoods.length) {
        $.toastShow("部分未上架的商品将无法打印", "long", "bottom");
      }
      if (args.length > 0) {
        $state.go("eventmenu.KEY116", {
          printType : deepDataAndEvents.printQRCode,
          labelArray : args
        });
      }
    } else {
      $.toastShow("请选择商品进行二维码打印");
    }
  };
  /**
   * @param {Array} codeSegments
   * @param {string} setting
   * @return {?}
   */
  self.processingPrintData = function(codeSegments, setting) {
    /** @type {Array} */
    var assigns = [];
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      if (codeSegments[i].commodityId) {
        /** @type {string} */
        codeSegments[i].goodsUrl = setting + "/item.html?id=" + codeSegments[i].commodityId;
        var vvar = {
          goodsName : "名称：" + codeSegments[i].commodityName,
          goodsSn : "货号：" + codeSegments[i].goodsSn,
          goodsPrice : "零售价：" + codeSegments[i].tradePrice.toFixed(2),
          goodsUrl : codeSegments[i].goodsUrl
        };
        assigns.push(vvar);
      }
    }
    return assigns;
  };
  $modal.fromTemplateUrl("goodListQuery.html", function(theTitle) {
    self.goodListQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsCategoryQuery.html", function(theTitle) {
    self.goodsCategoryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsBlandQuery.html", function(theTitle) {
    self.goodsBlandModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("goodsIsOnSale.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.goodsIsOnSalePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openGoodsIsOnSalePopover = function(expectedNumberOfNonCommentArgs) {
    self.goodsIsOnSalePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideGoodsIsOnSalePopover = function() {
    self.goodsIsOnSalePopover.hide();
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY040.html", function(theTitle) {
    self.KEY263 = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.goodListQueryModal.remove();
    self.goodsCategoryModal.remove();
    self.goodsBlandModal.remove();
    self.goodsIsOnSalePopover.remove();
    self.KEY263.remove();
  });
  self.$on("$ionicView.afterEnter", function() {
    if ($templateCache.get("tmsGoodListRefresh")) {
      if ($templateCache.get("tmsGoodListRefresh") === true) {
        self.getList();
        $templateCache.put("tmsGoodListRefresh", false);
      }
    }
    test.httpCacheGet.get(test.httpCacheGet.ac.BLANDLIST).success(function(theTitle) {
      self.arrBland = theTitle;
    });
  });
  self.$on("$ionicView.loaded", function() {
    self.getList();
    test.httpCacheGet.get(test.httpCacheGet.ac.CATEGORYLIST).success(function(data) {
      self.allCategoryList = data.rows;
      self.categoryTree = $.treeForCategory(0, "", false, data.rows).children;
    });
  });
  /**
   * @return {undefined}
   */
  self.showPrintQrcodeAction = function() {
    var scope = {
      buttons : []
    };
    scope.buttons.push({
      text : '<i class="icon icon-fun-KEY332 assertive"></i> 打印商品二维码'
    });
    if (0 === self.queryCondition.isOnSale) {
      scope.buttons.push({
        text : '<i class="icon ion-ios-upload-outline assertive"></i> 上架商品'
      });
    } else {
      if (1 === self.queryCondition.isOnSale) {
        scope.buttons.push({
          text : '<i class="icon ion-ios-download-outline assertive"></i> 下架商品'
        });
      }
    }
    scope.buttons.push({
      text : '<i class="icon ion-ios-close-outline assertive"></i> 取 消'
    });
    /**
     * @param {number} index
     * @return {?}
     */
    scope.buttonClicked = function(index) {
      return scope.buttons[index].text.indexOf("打印商品二维码") > -1 ? self.printQRCodeArray() : scope.buttons[index].text.indexOf("上架商品") > -1 ? self.dealGoods(1) : scope.buttons[index].text.indexOf("下架商品") > -1 && self.dealGoods(0), true;
    };
    handler.show(scope);
  };
}]).controller("ShopDetailCtrl", ["$scope", "$rootScope", "ServerConfig", "wechatShare", "psisServices", "lbSpinnerDialog", "$ionicPopup", "ServerType", "Tools", "commonDataInterface", "$ionicModal", "qqShare", "lbScrollDelegate", function($scope, mod, context, assert, db, loading, view, deepDataAndEvents, self, dataAndEvents, $modal, $element, widget) {
  var path = context.tmsServer.replace(/cid/, mod.mainCompany.id);
  if (deepDataAndEvents.isEX()) {
    path = path.replace(/web/, "ex");
  } else {
    if (context.currentServer.indexOf("dev") >= 0) {
      path = path.replace(/www/, "dev");
    }
  }
  $scope.shopAdress = path;
  $scope.setting = {
    soldVolumeShowSwitch : "",
    storeNumberShowSwitch : "",
    storeNumberMinusOnPay : "",
    priceType : "",
    priceOptions : [{
      value : "1",
      title : "零售价"
    }, {
      value : "2",
      title : "批发价"
    }]
  };
  /**
   * @return {undefined}
   */
  $scope.resizeScroll = function() {
    widget.resize("ShopDetailCtrlScroll");
  };
  /**
   * @return {undefined}
   */
  $scope.goToTmsShop = function() {
    $scope.openLink(path, 1);
  };
  /**
   * @return {undefined}
   */
  $scope.refreshColorAndSize = function() {
    db.httpCacheGet.remove(db.httpCacheGet.ac.ALLSIZELIST);
    db.httpCacheGet.remove(db.httpCacheGet.ac.ALLCOLORLIST);
  };
  /**
   * @return {undefined}
   */
  $scope.getShopInfo = function() {
    db.post("/KEY317").success(function(res) {
      if (1 === res.statusCode) {
        if (res.object) {
          $scope.shop = res.object.wechatShopVO;
          $scope.shopConfig = res.object.wechatShopBaseConfigVO;
          /** @type {boolean} */
          $scope.setting.soldVolumeShowSwitch = 1 == $scope.shopConfig.soldVolumeShowSwitch;
          /** @type {boolean} */
          $scope.setting.storeNumberShowSwitch = 1 == $scope.shopConfig.storeNumberShowSwitch;
          /** @type {boolean} */
          $scope.setting.storeNumberMinusOnPay = 1 == $scope.shopConfig.storeNumberMinusOnPay;
          /** @type {string} */
          $scope.setting.priceType = 1 == $scope.shopConfig.defaultPriceType ? "1" : "2";
        }
      }
    });
  };
  /**
   * @return {?}
   */
  $scope.saveWechatShopInfo = function() {
    return $scope.shop.shopName ? ($scope.shopConfig.soldVolumeShowSwitch = $scope.setting.soldVolumeShowSwitch ? 1 : 0, $scope.shopConfig.storeNumberShowSwitch = $scope.setting.storeNumberShowSwitch ? 1 : 0, $scope.shopConfig.storeNumberMinusOnPay = $scope.setting.storeNumberMinusOnPay ? 1 : 0, $scope.shopConfig.defaultPriceType = "1" == $scope.setting.priceType ? 1 : 2, loading.show(true), void db.post("/KEY314",
    {
      wechatShopBaseConfigVO : $scope.shopConfig,
      wechatShopVO : $scope.shop
    }).success(function(res) {
      if (1 === res.statusCode && res.object) {
        view.alert({
          template : "<div class='tc'>保存成功</div>",
          okText : "确定"
        });
        $scope.getShopInfo();
      } else {
        if (res.content) {
          self.toastShow(res.content);
        }
      }
    }).finally(function() {
      loading.hide();
    })) : void view.alert({
      template : "<div class='tc'>店铺名称为必填</div>",
      okText : "确定"
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getStoreNumberScale = function() {
    var storeNumberScale = $scope.shopConfig.storeNumberScale;
    if (window.cordova && window.cordova.plugins) {
      self.showPrompt("请输入库存百分比（%）", function(result) {
        if (2 == result.buttonIndex) {
          /** @type {number} */
          $scope.shopConfig.storeNumberScale = 1;
          self.keyboardHide();
          $scope.$apply(function() {
            $scope.shopConfig.storeNumberScale = result.input1 >= 0 ? result.input1 : storeNumberScale;
          });
        }
      }, "库存百分比", ["取消", "确定"], 0);
    } else {
      view.show({
        cssClass : "lb-wholeOrderDiscount-popup",
        template : '<input type="number"  class="tc" ng-model="shopConfig.storeNumberScale" placeholder="" autofocus="true">',
        title : "库存百分比",
        scope : $scope,
        buttons : [{
          text : "取消",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.shopConfig.storeNumberScale = storeNumberScale;
          }
        }, {
          text : "确定",
          type : "button-assertive"
        }]
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.getStoreNumberAddition = function() {
    var storeNumberAddition = $scope.shopConfig.storeNumberAddition;
    if (window.cordova && window.cordova.plugins) {
      self.showPrompt("请输入库存调整数量", function(result) {
        if (2 == result.buttonIndex) {
          self.keyboardHide();
          $scope.$apply(function() {
            $scope.shopConfig.storeNumberAddition = result.input1 >= 0 ? result.input1 : storeNumberAddition;
          });
        }
      }, "库存调整数量", ["取消", "确定"], 0);
    } else {
      view.show({
        cssClass : "lb-wholeOrderDiscount-popup",
        template : '<input type="number"  class="tc" ng-model="shopConfig.storeNumberAddition" placeholder="" autofocus="true">',
        title : "库存调整",
        scope : $scope,
        buttons : [{
          text : "取消",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.shopConfig.storeNumberAddition = storeNumberAddition;
          }
        }, {
          text : "确定",
          type : "button-assertive"
        }]
      });
    }
  };
  /**
   * @param {Array} dataAndEvents
   * @return {undefined}
   */
  $scope.gotoTradeList = function(dataAndEvents) {
    $state.go("eventmenu.KEY213", {
      isSettled : dataAndEvents
    });
  };
  /**
   * @return {undefined}
   */
  $scope.shareShop = function() {
    db.post("/KEY320").success(function(result) {
      if (1 === result.statusCode) {
        if (result.object) {
          err = result.object;
          $scope.KEY263.show();
        }
      }
    });
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY040.html", function($location) {
    $scope.KEY263 = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  var err = {};
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  $scope.share = function(opt_attributes) {
    var right = err.shareTitle ? err.shareTitle : "";
    var body = err.description ? err.description : "";
    var pdataCur = err.shareImg;
    var form = err.shareLink ? err.shareLink : "";
    if ("Timeline" == opt_attributes) {
      assert.shareUrlToTimeline(form, right, body, pdataCur);
      dataAndEvents.addFuncLog("Xiaohuobao_ShopShare_Session", "销货宝店铺分享商品到好友", self.getDeviceInfo());
    } else {
      if ("friend" == opt_attributes) {
        assert.shareUrlToSession(form, right, body, pdataCur);
        dataAndEvents.addFuncLog("Xiaohuobao_ShopShare_Timeline", "销货宝店铺分享商品到朋友圈", self.getDeviceInfo());
      } else {
        if ("qq" == opt_attributes) {
          $element.shareUrlToQq(form, right, body, pdataCur);
        } else {
          if ("qz" == opt_attributes) {
            /** @type {Array} */
            var progressValues = [];
            progressValues.push(pdataCur);
            $element.shareUrlToQz(form, right, body, progressValues);
          }
        }
      }
    }
  };
  $scope.$on("$destroy", function() {
    $scope.KEY263.remove();
  });
  $scope.$on("$ionicView.loaded", function() {
    $scope.getShopInfo();
  });
}]).controller("TmsOrderListCtrl", ["$scope", "$state", "psisServices", "lbScrollDelegate", "lruPersistCache", "$ionicModal", "$cordovaDatePicker", "Tools", "lbSpinnerDialog", function(self, $state, $document, parent, $templateCache, $modal, $scope, dataAndEvents, loading) {
  self.queryCondition = {
    page : 1
  };
  /** @type {boolean} */
  self.isLoading = true;
  self.listQueryDate = {};
  /**
   * @return {?}
   */
  var Step = function() {
    return $document.postEncode("/KEY321", self.queryCondition);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    if (self.listQueryDate.createTimeBegin) {
      self.queryCondition.beginTime = dataAndEvents.getDayBeginStr(self.listQueryDate.createTimeBegin);
    } else {
      delete self.queryCondition.beginTime;
    }
    if (self.listQueryDate.createTimeEnd) {
      self.queryCondition.endTime = dataAndEvents.getOffsetDayBeginStr(self.listQueryDate.createTimeEnd, 1);
    } else {
      delete self.queryCondition.endTime;
    }
    loading.show();
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
      parent.scrollTop("tmsOrderCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("tmsOrderCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.doRefresh = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    Step().success(function(data) {
      self.items = data.rows;
      self.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.goOrder = function(dataAndEvents) {
    $state.go("eventmenu.KEY211", {
      ordersSn : dataAndEvents
    });
  };
  $modal.fromTemplateUrl("orderListQuery.html", function(theTitle) {
    self.orderListQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.setCreateTimeBegin = function() {
    $scope.show({
      date : self.listQueryDate.createTimeBegin ? new Date(self.listQueryDate.createTimeBegin) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.listQueryDate.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setCreateTimeEnd = function() {
    $scope.show({
      date : self.listQueryDate.createTimeEnd ? new Date(self.listQueryDate.createTimeEnd) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.listQueryDate.createTimeEnd = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    /** @type {null} */
    self.listQueryDate.createTimeBegin = null;
    /** @type {null} */
    self.listQueryDate.createTimeEnd = null;
    delete self.queryCondition.ordersSn;
  };
  self.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("tmsOrderListRefresh")) {
      if ($templateCache.get("tmsOrderListRefresh") === true) {
        self.getList();
        $templateCache.put("tmsOrderListRefresh", false);
      }
    }
  });
  self.$on("$ionicView.loaded", function() {
    self.getList();
  });
}]).controller("TmsOrderEditCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "lbSpinnerDialog", "$q", "$ionicModal", "$state", "$ionicPopover", "$ionicPopup", "lruPersistCache", function($scope, dataAndEvents, $, UnitTools, loading, $q, $modal, $state, FB, view, $templateCache) {
  var encodedValue = dataAndEvents.ordersSn;
  /**
   * @return {?}
   */
  var fetch = function() {
    var imageDfd = $q.defer();
    var request1 = $.httpCacheGet.get($.httpCacheGet.ac.ALLSIZELIST);
    var getPromise3 = $.httpCacheGet.get($.httpCacheGet.ac.ALLCOLORLIST);
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  };
  $scope.KEY273 = {
    orderClient : {},
    canEdit : false
  };
  /** @type {number} */
  $scope.totalInvoiceAmount = 0;
  $scope.MEMBER_ORDER_STATE = {
    STATE_TO_PAY : 0,
    STATE_TO_CONFIRM : 1,
    STATE_TO_DELIVER : 3,
    STATE_TO_RECEIVED : 5,
    STATE_COMPLETED : 9,
    STATE_CANCELED : -1
  };
  /**
   * @param {?} dataAndEvents
   * @return {?}
   */
  $scope.getOrderState = function(dataAndEvents) {
    return dataAndEvents === $scope.MEMBER_ORDER_STATE.STATE_TO_PAY ? "待付款" : dataAndEvents === $scope.MEMBER_ORDER_STATE.STATE_TO_CONFIRM ? "待确认" : dataAndEvents === $scope.MEMBER_ORDER_STATE.STATE_TO_DELIVER ? "待出售" : dataAndEvents === $scope.MEMBER_ORDER_STATE.STATE_TO_RECEIVED ? "待收货" : dataAndEvents === $scope.MEMBER_ORDER_STATE.STATE_COMPLETED ? "已完成" : dataAndEvents === $scope.MEMBER_ORDER_STATE.STATE_CANCELED ?
    "已撤销" : "其它";
  };
  /** @type {Array} */
  $scope.paymentTypeEnum = [{
    val : "cod",
    text : "货到付款"
  }, {
    val : "wxpayPub",
    text : "微信支付"
  }, {
    val : "wechatQrcodeTransfer",
    text : "微信二维码转账"
  }, {
    val : "alipayWap",
    text : "支付宝"
  }];
  /**
   * @param {(Object|string)} dataAndEvents
   * @return {?}
   */
  $scope.getPaymentTypeName = function(dataAndEvents) {
    /** @type {number} */
    var i = 0;
    for (;i < $scope.paymentTypeEnum.length;i++) {
      var option = $scope.paymentTypeEnum[i];
      if (dataAndEvents == option.val) {
        return option.text;
      }
    }
    return "";
  };
  /** @type {Array} */
  $scope.refundStateEnum = [{
    text : "买家申请/修改申请处理中",
    val : 1E3
  }, {
    text : "卖家确认处理中",
    val : 1030
  }, {
    text : "买家退货中",
    val : 1050
  }, {
    text : "卖家确认收退货中",
    val : 1060
  }, {
    text : "退款中",
    val : 1070
  }, {
    text : "已完成",
    val : 1100
  }, {
    text : "已取消",
    val : -1
  }];
  /** @type {Array} */
  $scope.refundTypeEnum = [{
    text : "退款不退货",
    val : "refund"
  }, {
    text : "退款且退货",
    val : "refundAndReject"
  }];
  /** @type {Array} */
  $scope.refundReasonEnum = [{
    text : "买/卖双方协商一致",
    val : "negotiation"
  }, {
    text : "买错/多买/不想要",
    val : "wrongOrder"
  }, {
    text : "商品质量问题",
    val : "qualityProblem"
  }, {
    text : "未收到货品",
    val : "reciveNothing"
  }, {
    text : "其他",
    val : "others"
  }];
  /**
   * @param {string} dataAndEvents
   * @return {?}
   */
  $scope.isProxyOrders = function(dataAndEvents) {
    return "proxy" == dataAndEvents ? true : false;
  };
  /**
   * @param {?} dataAndEvents
   * @param {?} deepDataAndEvents
   * @return {undefined}
   */
  $scope.goSaleOrderPage = function(dataAndEvents, deepDataAndEvents) {
    if (deepDataAndEvents === $scope.MEMBER_ORDER_STATE.STATE_COMPLETED) {
      $state.go("eventmenu.KEY260", {
        ordersSn : dataAndEvents
      });
    } else {
      $state.go("eventmenu.KEY284", {
        ordersSn : dataAndEvents
      });
    }
  };
  FB.fromTemplateUrl("html/POrderFormInfo/KEY186.html", {
    scope : $scope
  }).then(function($location) {
    $scope.orderOperationPopover = $location;
  });
  $modal.fromTemplateUrl("refundDealModal.html", function($location) {
    /** @type {number} */
    $scope.refundDealModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    if ($scope.clientModal) {
      $scope.clientModal.remove();
    }
    $scope.orderOperationPopover.remove();
    $scope.refundDealModal.remove();
  });
  /**
   * @param {boolean} actualObject
   * @return {undefined}
   */
  $scope.setDeliveryAmount = function(actualObject) {
    /** @type {boolean} */
    var object = actualObject;
    /** @type {string} */
    var x = "请输入运费金额";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          UnitTools.keyboardHide();
          $scope.$apply(function() {
            $scope.order.deliveryAmount = 1 == UnitTools.isNumber(res.input1) && res.input1 >= 0 ? $scope.fixedInputNumber(res.input1) : object;
            $scope.sumTotalAmount(true);
          });
        }
      }, "修改运费金额", ["取消", "确认"], $scope.platformIsAndroid && object ? object.toString() : 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="order.deliveryAmount" autofocus="true" placeholder="0.00">',
        title : x,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.sumTotalAmount(true);
          }
        }]
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.setFreeDelivery = function() {
    /** @type {number} */
    $scope.order.deliveryAmount = 0;
    $scope.sumTotalAmount(true);
  };
  /**
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  $scope.sumTotalAmount = function(dataAndEvents) {
    $scope.totalInvoiceAmount = $scope.order.trueTotalAmount + $scope.order.deliveryAmount;
    if (dataAndEvents) {
      /** @type {boolean} */
      $scope.isPriceChanged = true;
    }
  };
  /**
   * @param {number} i
   * @param {number} attributes
   * @return {?}
   */
  $scope.calcDetailDiscount = function(i, attributes) {
    return i && attributes ? parseFloat(UnitTools.accMul(UnitTools.accDiv(i, attributes), 100).toFixed(2)) : 0 == i ? 100 : 0;
  };
  /**
   * @return {undefined}
   */
  $scope.memberOrdersGet = function() {
    loading.show();
    $.post("/admin/shop/wechat/memberOrders/memberOrdersGet.ac?ordersSn=" + encodeURIComponent(encodedValue)).success(function(row) {
      $scope.order = row.order;
      $scope.orderRefund = row.orderRefund;
      $scope.transToWholesaleOrderAvailable = 1 != $scope.order.isLock && (1 == $scope.order.state && $scope.order.ordersSn);
      $scope.destroyOrderAvailable = 1 != $scope.order.isLock && (!$scope.isProxyOrders($scope.order.paymentType) && (1 == $scope.order.state && $scope.order.ordersSn));
      $scope.getOrderRefundAvailable = $scope.orderRefund && null != $scope.orderRefund.refundSn;
      $scope.copyForReturnOrderAvailable = 1 != $scope.order.isLock && (void 0 != $scope.order.wholesaleOrdersSn && ("" != $scope.order.wholesaleOrdersSn && ($scope.orderRefund && ($scope.orderRefund.refundState > 1060 && $scope.order.ordersSn))));
      $scope.orderOperationPopoverAvailable = $scope.transToWholesaleOrderAvailable || ($scope.destroyOrderAvailable || ($scope.getOrderRefundAvailable || $scope.copyForReturnOrderAvailable));
      $scope.updatePriceAvailable = 1 != $scope.order.isLock && (0 == $scope.order.state && $scope.GetOperatorEventLimit("KEY163"));
      if (1 === $scope.order.state && $state.includes("eventmenu.KEY211")) {
        $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY216.html", function($location) {
          $scope.clientModal = $location;
        }, {
          scope : $scope,
          animation : "slide-in-up",
          focusFirstInput : true
        });
        /**
         * @return {undefined}
         */
        $scope.clientModalOpen = function() {
          $scope.clientModal.show().then(function() {
            UnitTools.keyboardShow();
          });
        };
        /** @type {boolean} */
        $scope.KEY273.isNew = true;
        if ($scope.order.clientId) {
          /** @type {boolean} */
          $scope.KEY273.isNew = false;
          $scope.KEY273.orderClient.val = $scope.order.clientId;
          $scope.KEY273.orderClient.text = $scope.order.memberClientName;
        }
      } else {
        if ($scope.order.wholesaleClientId) {
          $scope.KEY273.orderClient.val = $scope.order.wholesaleClientId;
          $scope.KEY273.orderClient.text = $scope.order.orderClientName;
        } else {
          if ($scope.order.clientId) {
            $scope.KEY273.orderClient.val = $scope.order.clientId;
            $scope.KEY273.orderClient.text = $scope.order.memberClientName;
          } else {
            /** @type {string} */
            $scope.KEY273.orderClient.val = "new";
            /** @type {string} */
            $scope.KEY273.orderClient.text = "新建客户";
          }
        }
      }
      /** @type {string} */
      $scope.order.receiveAddress = $scope.order.consigneeAddress + "(" + $scope.order.consignee + " ";
      if ($scope.order.consigneeCellphone) {
        $scope.order.receiveAddress += " " + $scope.order.consigneeCellphone;
      }
      if ($scope.order.consigneeTelphone) {
        $scope.order.receiveAddress += " " + $scope.order.consigneeTelphone;
      }
      $scope.order.receiveAddress += " 收)";
      fetch().then(function(packs) {
        var m = packs[0].data.rows;
        var i = packs[1].data.rows;
        /** @type {Array} */
        $scope.goodsGroup = [];
        /** @type {number} */
        var unknown = 0;
        row.orderGoods.forEach(function(data) {
          /** @type {boolean} */
          var t = false;
          /** @type {number} */
          var count = 0;
          var thumbsCount = $scope.goodsGroup.length;
          for (;thumbsCount > count;count++) {
            var a = $scope.goodsGroup[count].goodsSn;
            if (data.goodsSn == a) {
              /** @type {boolean} */
              t = true;
              $scope.goodsGroup[count].goods.push({
                id : data.id,
                quantity : data.quantity,
                unit : data.unit,
                price : data.price,
                discount : $scope.calcDetailDiscount(data.truePrice, data.price),
                truePrice : data.truePrice,
                colorId : data.colorId,
                sizeId : data.sizeId,
                colorName : UnitTools.fnCheckGtoreQty(i, "id", data.colorId).name,
                sizeName : UnitTools.fnCheckGtoreQty(m, "id", data.sizeId).name
              });
            }
          }
          if (!t) {
            var meta = {};
            /** @type {Array} */
            meta.goods = [];
            meta.goods.push({
              id : data.id,
              quantity : data.quantity,
              unit : data.unit,
              price : data.price,
              truePrice : data.truePrice,
              discount : $scope.calcDetailDiscount(data.truePrice, data.price),
              colorId : data.colorId,
              sizeId : data.sizeId,
              colorName : UnitTools.fnCheckGtoreQty(i, "id", data.colorId).name,
              sizeName : UnitTools.fnCheckGtoreQty(m, "id", data.sizeId).name
            });
            meta.goodName = data.goodsName;
            meta.goodsSn = data.goodsSn;
            meta.barCode = data.barCode;//条码
            $scope.goodsGroup.push(meta);
          }
          unknown = UnitTools.accAdd(unknown, data.quantity);
        });
        $scope.totalQuantity = unknown;
        $scope.sumTotalAmount();
        /** @type {boolean} */
        $scope.isPriceChanged = false;
      }, function() {
        loading.hide();
      });
    }).error(function() {
      loading.hide();
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @return {?}
   */
  $scope.transToWholesaleOrder = function() {
    if (!$scope.KEY273.isNew && !$scope.KEY273.orderClient.val) {
      return void view.alert({
        template : "<div class='tc'>请选择关联进销存客户</div>",
        okText : "确定"
      });
    }
    loading.show();
    /** @type {string} */
    var url = "/admin/shop/wechat/memberOrders/transToWholesaleOrder.ac?ordersSn=" + encodeURIComponent($scope.order.ordersSn);
    if (!$scope.KEY273.isNew) {
      url += "&clientId=" + $scope.KEY273.orderClient.val;
    }
    $.post(url).success(function(res) {
      if (1 === res.statusCode) {
        if (res.object.order && res.object.order.wholesaleOrdersSn) {
          var promise = view.confirm({
            template : "<div class='tc'>已成功转为销售单，现在去出售？</div>",
            cancelText : "取消",
            okText : "确认"
          });
          promise.then(function(dataAndEvents) {
            if (dataAndEvents) {
              $state.go("eventmenu.KEY284", {
                ordersSn : res.object.order.wholesaleOrdersSn
              });
            } else {
              $scope.viewReplace();
              $state.go("eventmenu.KEY211", {
                ordersSn : $scope.order.ordersSn
              }, {
                reload : true
              });
            }
          });
        } else {
          UnitTools.toastShow("转为销售单成功！");
          $scope.viewReplace();
          $state.go("eventmenu.KEY211", {
            ordersSn : $scope.order.ordersSn
          }, {
            reload : true
          });
        }
      } else {
        UnitTools.toastShow("转为销售单异常！" + res.content);
      }
    }).finally(function() {
      loading.hide();
      $templateCache.put("tmsOrderListRefresh", true);
    });
  };
  /**
   * @return {undefined}
   */
  $scope.destroyOrder = function() {
    /** @type {string} */
    var o = "撤销后，该单据将不可转为销售单，是否确认撤销？";
    if ("1" == $scope.order.paymentStatus) {
      /** @type {string} */
      o = "该订单买家已使用" + $scope.getPaymentTypeName($scope.order.paymentType) + "付款，撤销后请自行与买家进行退款操作！";
    }
    var promise = view.confirm({
      template : "<div class='tc'>" + o + "</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        $.post("/admin/shop/wechat/memberOrders/destroyOrder.ac?ordersSn=" + encodeURIComponent($scope.order.ordersSn)).success(function(r) {
          if (1 === r.statusCode) {
            UnitTools.toastShow("撤销成功！");
            $scope.viewReplace();
            $state.go("eventmenu.KEY211", {
              ordersSn : $scope.order.ordersSn
            }, {
              reload : true
            });
          } else {
            UnitTools.toastShow("撤销异常！");
          }
        }).finally(function() {
          loading.hide();
          $templateCache.put("tmsOrderListRefresh", true);
        });
      }
    });
  };
  /** @type {Array} */
  $scope.agreeOptions = [{
    value : 0,
    title : "同意"
  }, {
    value : 1,
    title : "拒绝"
  }];
  /**
   * @return {undefined}
   */
  $scope.getOrderRefund = function() {
    loading.show();
    $.post("/admin/shop/wechat/memberOrders/orderRefundGet.ac?ordersSn=" + encodeURIComponent($scope.order.ordersSn)).success(function(res) {
      if (1 === res.statusCode) {
        $scope.memberOrdersRefundVO = res.object.memberOrdersRefundVO;
        $scope.memberOrdersRefundVO.isRefuse = $scope.memberOrdersRefundVO.isRefuse ? $scope.memberOrdersRefundVO.isRefuse : 0;
        $scope.refundDealModal.show();
      }
    }).finally(function() {
      loading.hide();
      $templateCache.put("tmsOrderListRefresh", true);
    });
  };
  /**
   * @return {undefined}
   */
  $scope.confirmDealRefundOrder = function() {
    /** @type {string} */
    var o = 1 == $scope.memberOrdersRefundVO.isRefuse ? "您确定要拒绝买家的退款/退货申请吗？" : "您确定要同意买家的退款/退货申请吗？";
    var promise = view.confirm({
      template : "<div class='tc'>" + o + "</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        $.post("/KEY315", $scope.memberOrdersRefundVO).success(function(r) {
          if (1 === r.statusCode) {
            $scope.refundDealModal.hide();
            $state.go("eventmenu.KEY211", {
              ordersSn : $scope.order.ordersSn
            }, {
              reload : true
            });
          }
        }).finally(function() {
          loading.hide();
          $templateCache.put("tmsOrderListRefresh", true);
        });
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.confirmReciveBuyerReject = function() {
    var promise = view.confirm({
      template : "<div class='tc'>您已经收到买家的退货了吗？</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        $.post("/KEY308", $scope.memberOrdersRefundVO).success(function(r) {
          if (1 === r.statusCode) {
            $scope.refundDealModal.hide();
          }
        }).finally(function() {
          loading.hide();
          $templateCache.put("tmsOrderListRefresh", true);
        });
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.copyForReturnOrder = function() {
    $.post("/KEY160?ordersSn=" + encodeURIComponent($scope.order.wholesaleOrdersSn)).success(function(aspect) {
      $scope.viewReplace();
      /** @type {string} */
      var logoutState = "eventmenu.KEY179";
      $scope.copyOrder = {
        order : aspect.order,
        goodsGroup : $scope.goodsGroup
      };
      $state.go(logoutState, {
        ordersSn : null,
        timeStamp : UnitTools.getTimeStamp(),
        copyOrder : $scope.copyOrder
      });
    }).finally(function() {
      loading.hide();
      $templateCache.put("tmsOrderListRefresh", true);
    });
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  $scope.fixedInputNumber = function(deepDataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents);
  };
  $scope.modifyGood = {};
  /**
   * @param {?} $routeParams
   * @param {?} data
   * @return {undefined}
   */
  $scope.modifyGoodsPrice = function($routeParams, data) {
    $scope.modifyGood = angular.copy($routeParams);
    $scope.modifyGood = $.extend($scope.modifyGood, data);
    /** @type {string} */
    var MSG_CLOSURE_CUSTOM_COLOR_BUTTON = $scope.modifyGood.goodName + "(" + $scope.modifyGood.goodsSn + "):" + $scope.modifyGood.colorName + " " + $scope.modifyGood.sizeName;
    view.show({
      cssClass : "lb-KEY291-popup",
      templateUrl : "modifyGoodsPrice.html",
      title : MSG_CLOSURE_CUSTOM_COLOR_BUTTON,
      scope : $scope,
      buttons : [{
        text : "取消"
      }, {
        text : "确认",
        type : "button-assertive",
        /**
         * @return {undefined}
         */
        onTap : function() {
          $scope.confirmModifyPrice();
        }
      }]
    });
  };
  /**
   * @return {undefined}
   */
  $scope.confirmModifyPrice = function() {
    /** @type {number} */
    var count = 0;
    var thumbsCount = $scope.goodsGroup.length;
    for (;thumbsCount > count;count++) {
      if ($scope.modifyGood.goodsSn == $scope.goodsGroup[count].goodsSn) {
        var uri;
        for (uri in $scope.goodsGroup[count].goods) {
          var json = $scope.goodsGroup[count].goods[uri];
          if ($scope.modifyGood.colorId == json.colorId) {
            if ($scope.modifyGood.sizeId == json.sizeId) {
              json.price = $scope.fixedInputNumber($scope.modifyGood.price);
              if (json.discount != $scope.modifyGood.discount || json.truePrice != $scope.modifyGood.truePrice) {
                json.discount = $scope.fixedInputNumber($scope.modifyGood.discount);
                json.truePrice = $scope.fixedInputNumber($scope.modifyGood.truePrice);
                /** @type {boolean} */
                $scope.isPriceChanged = true;
              }
            }
          }
        }
      }
    }
    $scope.calcTotalAmount();
  };
  /**
   * @return {undefined}
   */
  $scope.calcTotalAmount = function() {
    /** @type {number} */
    var cssValue = 0;
    /** @type {number} */
    var unknown = 0;
    var thumbsCount = $scope.goodsGroup.length;
    /** @type {number} */
    var count = 0;
    for (;thumbsCount > count;count++) {
      var employees = $scope.goodsGroup[count].goods;
      var l = employees.length;
      /** @type {number} */
      var i = 0;
      for (;l > i;i++) {
        var item = employees[i];
        if (item.price || 0 === item.price) {
          if (item.discount) {
            if (item.quantity) {
              cssValue = UnitTools.accAdd(cssValue, UnitTools.accMul(item.truePrice, item.quantity));
              unknown = UnitTools.accAdd(unknown, item.quantity);
            }
          }
        }
      }
    }
    $scope.totalQuantity = unknown;
    $scope.order.trueTotalAmount = cssValue;
    $scope.sumTotalAmount();
  };
  /**
   * @return {undefined}
   */
  $scope.onModifyDiscount = function() {
    if (null != $scope.modifyGood.discount) {
      $scope.modifyGood.discount = $scope.fixedInputNumber($scope.modifyGood.discount);
      $scope.modifyGood.truePrice = $scope.fixedInputNumber(($scope.modifyGood.price * $scope.modifyGood.discount / 100).toFixed(2));
    }
  };
  /**
   * @return {undefined}
   */
  $scope.onModifyTruePrice = function() {
    if (null != $scope.modifyGood.truePrice) {
      $scope.modifyGood.truePrice = $scope.fixedInputNumber($scope.modifyGood.truePrice);
      if (0 == $scope.modifyGood.price) {
        /** @type {number} */
        $scope.modifyGood.truePrice = 0;
        /** @type {number} */
        $scope.modifyGood.discount = 100;
      } else {
        $scope.modifyGood.discount = 0 == $scope.modifyGood.truePrice ? 0 : $scope.fixedInputNumber((100 * $scope.modifyGood.truePrice / $scope.modifyGood.price).toFixed(2));
      }
    }
  };
  /**
   * @return {?}
   */
  $scope.saveUpdatePrice = function() {
    if ($scope.orderGoods = [], $scope.order.trueTotalAmount && $scope.order.trueTotalAmount > 1E8 || $scope.order.totalAmount && $scope.order.totalAmount > 1E8) {
      return void UnitTools.toastShow("金额、本单金额不能超过1亿.");
    }
    $scope.order.deliveryAmount = $scope.fixedInputNumber($scope.order.deliveryAmount);
    /** @type {number} */
    var count = 0;
    var thumbsCount = $scope.goodsGroup.length;
    for (;thumbsCount > count;count++) {
      if ($scope.modifyGood.goodsSn == $scope.goodsGroup[count].goodsSn) {
        var i;
        for (i in $scope.goodsGroup[count].goods) {
          var instance = $scope.goodsGroup[count].goods[i];
          instance.price = $scope.fixedInputNumber($scope.modifyGood.price);
          $scope.orderGoods.push({
            id : instance.id,
            price : instance.price,
            truePrice : instance.truePrice,
            discount : instance.discount
          });
        }
      }
    }
    var promise = view.confirm({
      template : "<div class='tc'>您确认要修改商品的价格吗？</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show();
        $.post("/KEY309", {
          ordersSn : $scope.order.ordersSn,
          deliveryAmount : $scope.order.deliveryAmount,
          memberOrdersDtList : $scope.orderGoods
        }).success(function(r) {
          loading.hide();
          if (1 === r.statusCode) {
            UnitTools.toastShow("改价成功！");
            $scope.viewReplace();
            $state.go("eventmenu.KEY211", {
              ordersSn : $scope.order.ordersSn
            }, {
              reload : true
            });
          } else {
            UnitTools.toastShow("改价失败！");
          }
        }).finally(function() {
          loading.hide();
          $templateCache.put("tmsOrderListRefresh", true);
        });
      }
    });
  };
  $scope.memberOrdersGet();
}]).controller("TmsTradeListCtrl", ["$scope", "$stateParams", "$state", "psisServices", "lbScrollDelegate", "lruPersistCache", "$ionicModal", "$cordovaDatePicker", "Tools", "lbSpinnerDialog", function(self, edge, $state, $document, parent, $templateCache, $modal, $scope, dataAndEvents, loading) {
  var vb = edge.isSettled;
  if (!vb) {
    /** @type {number} */
    vb = 0;
  }
  self.queryCondition = {
    page : 1,
    isSettled : vb,
    tradeItem : "member"
  };
  /** @type {boolean} */
  self.isLoading = true;
  self.listQueryDate = {};
  /**
   * @return {?}
   */
  var Step = function() {
    return $document.postEncode("/KEY322", self.queryCondition);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    if (self.listQueryDate.beginTime) {
      self.queryCondition.beginTime = dataAndEvents.getDayBeginStr(self.listQueryDate.beginTime);
    } else {
      delete self.queryCondition.beginTime;
    }
    if (self.listQueryDate.endTime) {
      self.queryCondition.endTime = dataAndEvents.getOffsetDayBeginStr(self.listQueryDate.endTime, 1);
    } else {
      delete self.queryCondition.endTime;
    }
    loading.show();
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
      parent.scrollTop("tmsTradeCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    loading.show();
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      loading.hide();
      parent.resize("tmsTradeCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.doRefresh = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    Step().success(function(data) {
      self.items = data.rows;
      self.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.goOrder = function(dataAndEvents) {
    $state.go("eventmenu.KEY211", {
      ordersSn : dataAndEvents
    });
  };
  $modal.fromTemplateUrl("tradeListQuery.html", function(theTitle) {
    self.tradeListQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.setBeginTime = function() {
    $scope.show({
      date : self.listQueryDate.beginTime ? new Date(self.listQueryDate.beginTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.listQueryDate.beginTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.setEndTime = function() {
    $scope.show({
      date : self.listQueryDate.endTime ? new Date(self.listQueryDate.endTime) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        self.listQueryDate.endTime = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    /** @type {null} */
    self.listQueryDate.beginTime = null;
    /** @type {null} */
    self.listQueryDate.endTime = null;
    delete self.queryCondition.ordersSn;
  };
  self.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("tmsTradeListRefresh")) {
      if ($templateCache.get("tmsTradeListRefresh") === true) {
        self.getList();
        $templateCache.put("tmsTradeListRefresh", false);
      }
    }
  });
  self.$on("$ionicView.loaded", function() {
    self.getList();
  });
}]).controller("MemberListCtrl", ["$scope", "$stateParams", "$state", "psisServices", "lruPersistCache", "lbScrollDelegate", "lbSpinnerDialog", function($scope, dataAndEvents, $state, newCanvas, $templateCache, widget) {
  /** @type {Array} */
  $scope.items = [];
  /** @type {string} */
  $scope.searchKey = "";
  /** @type {number} */
  $scope.clientSum = 0;
  /** @type {string} */
  $scope.focused = "centered";
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.queryCondition = {
    clientItem : "",
    area : "",
    page : 1
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var Step = function(opt_attributes) {
    return newCanvas.postEncode("/KEY323", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step({
      page : $scope.queryCondition.page,
      cellphone : $scope.searchKey
    }).success(function(data) {
      $scope.items = data.rows;
      $scope.clientSum = data.records;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      widget.resize("memberManagementCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    Step({
      page : $scope.queryCondition.page,
      cellphone : $scope.searchKey
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      widget.resize("memberManagementCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.searchMember = function() {
    $scope.getList();
  };
  var throttledUpdate = ionic.debounce($scope.searchMember, 500);
  /**
   * @return {undefined}
   */
  $scope.searchMemberByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @return {undefined}
   */
  $scope.focus = function() {
    document.getElementById("searchInput").focus();
  };
  /**
   * @return {undefined}
   */
  $scope.clearSearch = function() {
    /** @type {string} */
    $scope.searchKey = "";
    /** @type {string} */
    $scope.focused = "centered";
    $scope.searchMember();
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("memberListRefresh")) {
      if ($templateCache.get("memberListRefresh") === true) {
        $scope.getList();
        $templateCache.put("memberListRefresh", false);
      }
    }
  });
  /**
   * @param {string} term
   * @return {undefined}
   */
  $scope.goMemberEdit = function(term) {
    $state.go("eventmenu.KEY313", {
      id : term
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
  });
}]).controller("MemberEditCtrl", ["$scope", "$state", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "ServerConfig", "lruPersistCache", "lbScrollDelegate", function(self, dataAndEvents, map, field, dojo, deepDataAndEvents, $modal, $q, _, loading, ignoreMethodDoesntExist, $templateCache, $window) {
  var modId = map.id;
  /** @type {boolean} */
  self.relationState = false;
  self.memberVO = {
    nickName : "",
    cellphone : ""
  };
  self.clientVO = {};
  /** @type {string} */
  self.memberClientVO = "";
  /** @type {Array} */
  var key = [];
  /** @type {string} */
  self.provinceStr = "";
  /** @type {string} */
  self.cityStr = "";
  /** @type {string} */
  self.countryStr = "";
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY216.html", function(theTitle) {
    self.clientModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.clientModalOpen = function() {
    self.clientModal.show();
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return field.postEncode("/admin/shop/wechat/memberclient/getMemberClientInfo.ac?memberId=" + modId, opt_attributes);
  };
  /**
   * @return {undefined}
   */
  self.getMemberClientInfo = function() {
    loading.show();
    createDom({
      id : self.searchKey,
      memberVO : self.searchKey,
      clientVO : self.searchKey,
      memberClientVO : self.searchKey
    }).success(function(mockObject) {
      self.memberVO = mockObject.object.memberVO;
      self.clientVO = mockObject.object.clientVO;
      self.memberClientVO = mockObject.object.memberClientVO;
      if (null != self.clientVO) {
        self.memberClientVO.client = {
          val : self.clientVO.id,
          text : self.clientVO.clientName
        };
      }
      /** @type {boolean} */
      self.relationState = null != self.clientVO;
    }).finally(function() {
      loading.hide();
      if (self.clientVO.provinceId) {
        self.getClientAdrr();
      }
    });
  };
  /**
   * @param {string} targetClass
   * @return {undefined}
   */
  self.getClientInfo = function(targetClass) {
    /**
     * @param {?} opt_attributes
     * @return {?}
     */
    var createDom = function(opt_attributes) {
      return field.postEncode("/KEY032?id=" + targetClass, opt_attributes);
    };
    /**
     * @return {undefined}
     */
    var init = function() {
      loading.show();
      createDom({
        objClient : self.searchKey
      }).success(function(message) {
        self.clientVO = message.objClient;
        self.memberClientVO.clientId = self.clientVO.id;
      }).finally(function() {
        $window.scrollTop("MemberEditCtrlScroll");
        loading.hide();
        if (self.clientVO.provinceId) {
          self.getClientAdrr();
        }
      });
    };
    init();
  };
  /**
   * @return {undefined}
   */
  self.bindMemberClient = function() {
    if (self.clientVO && self.clientVO.id > 0) {
      loading.show();
      field.postEncode("/KEY347", {
        memberClientVO : angular.toJson(self.memberClientVO),
        memberVO : angular.toJson(self.memberVO)
      }).success(function() {
        _.alert({
          template : "<div class='tc'>保存成功</div>",
          okText : "确定"
        });
        /** @type {boolean} */
        self.relationState = true;
        $templateCache.put("memberListRefresh", true);
      }).finally(function() {
        loading.hide();
      });
    } else {
      _.alert({
        template : "<div class='tc'>请选择客户</div>",
        okText : "确定"
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.unbindMemberClient = function() {
    if (self.relationState) {
      var promise = _.confirm({
        template : "<div class='tc'>您要解除销货宝客户和进销存客户的关联吗？解除关联后，该销货宝客户将不能享受分类价格，是否继续？</div>",
        cancelText : "取消",
        okText : "确认"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          loading.show();
          field.postEncode("/admin/shop/wechat/memberclient/unbindMemberClient.ac?memberId=" + self.memberVO.id).success(function(r) {
            if (1 == r.statusCode) {
              _.alert({
                template : "<div class='tc'>解除绑定成功</div>",
                okText : "确定"
              }).then(function() {
                modId = self.memberVO.id;
                self.getMemberClientInfo();
                $templateCache.put("memberListRefresh", true);
              });
            } else {
              _.alert({
                template : "<div class='tc'>" + r.content + "</div>",
                okText : "确定"
              });
            }
          }).finally(function() {
            loading.hide();
          });
        }
      });
    }
  };
  /**
   * @return {?}
   */
  var fetch = function() {
    var imageDfd = $q.defer();
    var request1 = field.httpCacheGet.get(field.httpCacheGet.ac.AllArea);
    return $q.all([request1]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  };
  /**
   * @return {undefined}
   */
  self.getClientAdrr = function() {
    if (0 != key.length) {
      self.translateAddr();
    } else {
      fetch().then(function(packs) {
        key = packs[0].data;
        self.translateAddr();
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.translateAddr = function() {
    var camelKey = dojo.getObjectList(key, "pid", 0);
    var that = {};
    if (self.clientVO.provinceId && (that.province = dojo.fnCheckGtoreQty(camelKey, "id", self.clientVO.provinceId), self.provinceStr = that.province.areaName, self.clientVO.cityId)) {
      var value = dojo.getObjectList(key, "pid", that.province.id);
      if (that.city = dojo.fnCheckGtoreQty(value, "id", self.clientVO.cityId), self.cityStr = that.city.areaName, self.clientVO.countyId) {
        var node = dojo.getObjectList(key, "pid", that.city.id);
        that.country = dojo.fnCheckGtoreQty(node, "id", self.clientVO.countyId);
        self.countryStr = that.country.areaName;
      }
    }
  };
  self.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      key = packs[0].data;
    });
    self.getMemberClientInfo();
  });
}]).controller("TmsGoodsEditCtrl", ["$scope", "$state", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "ServerConfig", "lruPersistCache", "lbScrollDelegate", "$http", function($scope, dataAndEvents, data, field, UnitTools, deepDataAndEvents, $modal, _, view, loading, ignoreMethodDoesntExist, $templateCache, _this) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = _.defer();
    var langKey = field.httpCacheGet.get(field.httpCacheGet.ac.CATEGORYLIST);
    var langName = field.httpCacheGet.get(field.httpCacheGet.ac.BLANDLIST);
    var order = field.httpCacheGet.get(field.httpCacheGet.ac.UNITLIST);
    var d = field.httpCacheGet.get(field.httpCacheGet.ac.SEASONLIST);
    var projectName = field.httpCacheGet.get(field.httpCacheGet.ac.MATERIALLIST);
    var projectUrl = field.httpCacheGet.get(field.httpCacheGet.ac.STYLELIST);
    var projectCodeUrl = field.httpCacheGet.get(field.httpCacheGet.ac.TMSGOODSDELIVERYFEELIST);
    return _.all([langKey, langName, order, d, projectName, projectUrl, projectCodeUrl]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  $scope.tmsGoodsId = data.tmsGoodsId;
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.goodsInfo = {
    selectedColors : [],
    colors : [],
    selectedSizes : [],
    sizes : []
  };
  $scope.allCategoryList = {};
  $scope.groups = {
    basicInformation : {
      name : "基本信息",
      show : true
    },
    priceSetting : {
      name : "单品价格设置",
      show : false
    },
    specifications : {
      name : "规格参数",
      show : false
    },
    productAlbum : {
      name : "商品相册",
      show : false
    }
  };
  /**
   * @param {Object} node
   * @param {?} evt
   * @return {undefined}
   */
  $scope.toggleGroup = function(node, evt) {
    if (evt) {
      evt.stopPropagation();
    }
    /** @type {boolean} */
    node.show = !node.show;
  };
  $modal.fromTemplateUrl("tmsGoodsCategoryQuery.html", function($location) {
    $scope.goodsCategoryModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("tmsGoodsBlandQuery.html", function($location) {
    $scope.tmsGoodsBlandModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("tmsGoodsUnitQuery.html", function($location) {
    $scope.tmsGoodsUnitModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("tmsGoodsStyleQuery.html", function($location) {
    $scope.tmsGoodsStyleModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("tmsGoodsMaterialQuery.html", function($location) {
    $scope.tmsGoodsMaterialModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("tmsGoodsSeasonQuery.html", function($location) {
    $scope.tmsGoodsSeasonModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("tmsGoodsShippingType.html", function($location) {
    $scope.tmsGoodsShippingTypeModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("tmsGoodsImages.html", function($location) {
    /** @type {number} */
    $scope.tmsGoodsImagesModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    if ($scope.goodsCategoryModal) {
      $scope.goodsCategoryModal.remove();
    }
    if ($scope.tmsGoodsBlandModal) {
      $scope.tmsGoodsBlandModal.remove();
    }
    if ($scope.tmsGoodsUnitModal) {
      $scope.tmsGoodsUnitModal.remove();
    }
    if ($scope.tmsGoodsShippingTypeModal) {
      $scope.tmsGoodsShippingTypeModal.remove();
    }
    if ($scope.tmsGoodsImagesModal) {
      $scope.tmsGoodsImagesModal.remove();
    }
    if ($scope.tmsGoodsStyleModal) {
      $scope.tmsGoodsStyleModal.remove();
    }
    if ($scope.tmsGoodsMaterialModal) {
      $scope.tmsGoodsMaterialModal.remove();
    }
    if ($scope.tmsGoodsSeasonModal) {
      $scope.tmsGoodsSeasonModal.remove();
    }
  });
  /**
   * @return {?}
   */
  var $http = function() {
    return field.postEncode("/admin/shop/wechat/commodity/getCommodityInfo.ac?goodsId=" + $scope.tmsGoodsId);
  };
  /**
   * @return {undefined}
   */
  $scope.getTmsGoodsInfo = function() {
    loading.show();
    fetch().then(function(packs) {
      $scope.allCategoryList = packs[0].data.rows;
      $scope.categoryTree = UnitTools.treeForCategory(0, "", false, packs[0].data.rows).children;
      $scope.arrBland = packs[1].data;
      $scope.arrUnit = packs[2].data;
      $scope.arrSeason = packs[3].data.rows;
      $scope.arrMaterial = packs[4].data.rows;
      $scope.arrStyle = packs[5].data.rows;
      $scope.deliveryFeeTempletList = packs[6].data.rows;
      $http().success(function(res) {
        if (1 == res.statusCode) {
          if ($scope.item = res.object, 1 == $scope.item.commodityVO.isOnSale ? $scope.item.commodityVO.isShelves = true : 0 == $scope.item.commodityVO.isOnSale && ($scope.item.commodityVO.isShelves = false), $scope.item.commodityVO.isNewChecked = $scope.item.commodityVO.isNew ? true : false, $scope.item.commodityVO.isHotChecked = $scope.item.commodityVO.isHot ? true : false, $scope.item.commodityVO.isBestChecked = $scope.item.commodityVO.isBest ?
          true : false, $scope.item.commodityVO.isDeliveryFeeSetting = $scope.item.commodityVO.isDeliveryFee ? true : false, $scope.item.commodityVO && $scope.item.commodityVO.deliveryFeeTempletId) {
            /** @type {number} */
            var i = 0;
            for (;i < $scope.deliveryFeeTempletList.length;i++) {
              if ($scope.item.commodityVO.deliveryFeeTempletId == $scope.deliveryFeeTempletList[i].id) {
                $scope.goodsInfo.deliveryFeeTemplet = $scope.deliveryFeeTempletList[i];
                break;
              }
            }
          }
          if ($scope.item.commodityVO && $scope.item.commodityVO.categoryId) {
            /** @type {number} */
            i = 0;
            for (;i < $scope.allCategoryList.length;i++) {
              if ($scope.item.commodityVO.categoryId == $scope.allCategoryList[i].id) {
                $scope.goodsInfo.category = $scope.allCategoryList[i];
                break;
              }
            }
          }
          if ($scope.item.commodityVO && $scope.item.commodityVO.blandId) {
            /** @type {number} */
            i = 0;
            for (;i < $scope.arrBland.length;i++) {
              if ($scope.item.commodityVO.blandId == $scope.arrBland[i].id) {
                $scope.goodsInfo.bland = $scope.arrBland[i];
                break;
              }
            }
          }
          if ($scope.item.commodityVO && $scope.item.commodityVO.unit) {
            /** @type {number} */
            i = 0;
            for (;i < $scope.arrUnit.length;i++) {
              if ($scope.item.commodityVO.unit == $scope.arrUnit[i].name) {
                $scope.goodsInfo.unit = $scope.arrUnit[i];
                break;
              }
            }
          }
          if ($scope.item.commodityVO) {
            if ($scope.item.commodityVO.styleId) {
              $scope.goodsInfo.style = UnitTools.fnCheckGtoreQty($scope.arrStyle, "id", $scope.item.commodityVO.styleId);
            }
          }
          if ($scope.item.commodityVO) {
            if ($scope.item.commodityVO.materialId) {
              $scope.goodsInfo.material = UnitTools.fnCheckGtoreQty($scope.arrMaterial, "id", $scope.item.commodityVO.materialId);
            }
          }
          if ($scope.item.commodityVO) {
            if ($scope.item.commodityVO.seasonId) {
              $scope.goodsInfo.season = UnitTools.fnCheckGtoreQty($scope.arrSeason, "id", $scope.item.commodityVO.seasonId);
            }
          }
          if ($scope.item) {
            if ($scope.item.commodityImgs) {
              $scope.goodsInfo.imagArrays = $scope.item.commodityImgs;
            }
          }
          /** @type {Array} */
          $scope.goodsInfo.selectedColors = [];
          /** @type {Array} */
          $scope.goodsInfo.colors = [];
          /** @type {Array} */
          $scope.goodsInfo.selectedSizes = [];
          /** @type {Array} */
          $scope.goodsInfo.sizes = [];
          /** @type {number} */
          $scope.goodsInfo.colorsLength = 0;
          /** @type {number} */
          $scope.goodsInfo.sizesLength = 0;
          /** @type {number} */
          i = 0;
          var ilen = $scope.item.commodityColors.length;
          for (;ilen > i;i++) {
            $scope.goodsInfo.selectedColors.push($scope.item.commodityColors[i]);
            if (1 == $scope.item.commodityColors[i].enable) {
              $scope.goodsInfo.colorsLength += 1;
            }
          }
          /** @type {number} */
          i = 0;
          ilen = $scope.item.commoditySizes.length;
          for (;ilen > i;i++) {
            $scope.goodsInfo.selectedSizes.push($scope.item.commoditySizes[i]);
            if (1 == $scope.item.commoditySizes[i].enable) {
              $scope.goodsInfo.sizesLength += 1;
            }
          }
          $scope.classifiedByColor();
        } else {
          UnitTools.toastShow(res.content);
        }
      }).finally(function() {
        /** @type {boolean} */
        $scope.isLoading = false;
        loading.hide();
      });
    });
  };
  /**
   * @param {Object} data
   * @return {?}
   */
  $scope.selectColor = function(data) {
    if (data.enable) {
      if (data.enable = 0, 1 == $scope.goodsInfo.colorsLength) {
        return UnitTools.toastShow("至少保留一种颜色！"), data.enable = 1, false;
      }
      $scope.goodsInfo.colorsLength -= 1;
    } else {
      if ($scope.goodsInfo.colorsLength += 1, data.enable = 1, !UnitTools.fnCheckGtoreQty($scope.item.commodityOnsaleLst, "colorId", data.colorId)) {
        /** @type {number} */
        var i = 0;
        for (;i < $scope.goodsInfo.selectedSizes.length;i++) {
          if ($scope.goodsInfo.selectedSizes[i].enable) {
            $scope.item.commodityOnsaleLst.push({
              goodsId : $scope.item.commodityVO.id,
              goodsSn : $scope.item.commodityVO.goodsSn,
              sizeId : $scope.goodsInfo.selectedSizes[i].sizeId,
              colorId : data.colorId
            });
          }
        }
      }
    }
    $scope.classifiedByColor();
  };
  /**
   * @param {Object} item
   * @return {?}
   */
  $scope.selectSize = function(item) {
    if (item.enable) {
      if (item.enable = 0, 1 == $scope.goodsInfo.sizesLength) {
        return UnitTools.toastShow("至少保留一种尺码！"), item.enable = 1, false;
      }
      $scope.goodsInfo.sizesLength -= 1;
    } else {
      if ($scope.goodsInfo.sizesLength += 1, item.enable = 1, !UnitTools.fnCheckGtoreQty($scope.item.commodityOnsaleLst, "sizeId", item.sizeId)) {
        /** @type {number} */
        var i = 0;
        for (;i < $scope.goodsInfo.selectedColors.length;i++) {
          if ($scope.goodsInfo.selectedColors[i].enable) {
            $scope.item.commodityOnsaleLst.push({
              goodsId : $scope.item.commodityVO.id,
              goodsSn : $scope.item.commodityVO.goodsSn,
              sizeId : item.sizeId,
              colorId : $scope.goodsInfo.selectedColors[i].colorId
            });
          }
        }
      }
    }
    $scope.classifiedByColor();
  };
  /**
   * @return {undefined}
   */
  $scope.classifiedByColor = function() {
    /** @type {number} */
    $scope.stockInventories = 0;
    /** @type {number} */
    var classId = 0;
    var cnl = $scope.goodsInfo.selectedColors.length;
    for (;cnl > classId;classId++) {
      if ($scope.goodsInfo.selectedColors[classId].enable) {
        /** @type {Array} */
        $scope.goodsInfo.selectedColors[classId].singleItem = [];
        /** @type {number} */
        var i = 0;
        var l = $scope.item.commodityOnsaleLst.length;
        for (;l > i;i++) {
          if ($scope.goodsInfo.selectedColors[classId].colorId == $scope.item.commodityOnsaleLst[i].colorId) {
            var field = UnitTools.fnCheckGtoreQty($scope.goodsInfo.selectedSizes, "sizeId", $scope.item.commodityOnsaleLst[i].sizeId);
            if (field) {
              if (field.enable) {
                $scope.item.commodityOnsaleLst[i].sizeName = field.name;
                $scope.stockInventories += $scope.item.commodityOnsaleLst[i].salesVolume ? $scope.item.commodityOnsaleLst[i].salesVolume : 0;
                $scope.goodsInfo.selectedColors[classId].singleItem.push($scope.item.commodityOnsaleLst[i]);
              }
            }
          }
        }
      }
    }
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  $scope.fixedInputNumber = function(deepDataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents);
  };
  /**
   * @return {undefined}
   */
  $scope.setSingelItem = function() {
    /** @type {string} */
    var x = "请输入商品单品价格";
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          UnitTools.keyboardHide();
          $scope.$apply(function() {
            if (1 == UnitTools.isNumber(res.input1)) {
              if (res.input1 >= 0) {
                $scope.goodsInfo.singelPrice = $scope.fixedInputNumber(res.input1);
                $scope.setSingelPrice();
              }
            }
          });
        }
      }, "批量修改单品价格", ["取消", "确认"], 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" class="tc" ng-model="goodsInfo.singelPrice" autofocus="true" placeholder="0.00">',
        title : x,
        scope : $scope,
        buttons : [{
          text : "确认",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            $scope.setSingelPrice();
          }
        }]
      });
    }
  };
  /**
   * @return {undefined}
   */
  $scope.setSingelPrice = function() {
    /** @type {number} */
    var classId = 0;
    var cnl = $scope.goodsInfo.selectedColors.length;
    for (;cnl > classId;classId++) {
      if ($scope.goodsInfo.selectedColors[classId].enable && ($scope.goodsInfo.selectedColors[classId].singleItem && $scope.goodsInfo.selectedColors[classId].singleItem.length > 0)) {
        /** @type {number} */
        var i = 0;
        for (;i < $scope.goodsInfo.selectedColors[classId].singleItem.length;i++) {
          $scope.goodsInfo.selectedColors[classId].singleItem[i].price = $scope.goodsInfo.singelPrice;
        }
      }
    }
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  $scope.scrollContent = function(event) {
    if (event) {
      event.stopPropagation();
    }
    _this.resize("resourceScroll");
  };
  /**
   * @param {?} b
   * @return {undefined}
   */
  $scope.showBulletinImage = function(b) {
    if (!angular.equals($scope.goodsInfo.image, $scope.goodsInfo.imagArrays[b].url)) {
      $scope.goodsInfo.image = $scope.goodsInfo.imagArrays[b].url;
      _this.zoomTo("tmsGoodsImagesScroll", 1, false, 0, 0);
    }
    $scope.tmsGoodsImagesModal.show();
  };
  /**
   * @return {undefined}
   */
  $scope.removeSingelItem = function() {
    /** @type {Array} */
    $scope.goodsOnsaleLst = [];
    var copies;
    /** @type {number} */
    var k = 0;
    for (;k < $scope.goodsInfo.selectedColors.length;k++) {
      copies = UnitTools.fnCheckGtoreQty($scope.item.commodityOnsaleLst, "colorId", $scope.goodsInfo.selectedColors[k].colorId);
      if (copies) {
        if ($scope.goodsInfo.selectedColors[k].enable) {
          $scope.goodsOnsaleLst.push(copies);
        }
      }
    }
    /** @type {number} */
    var i = 0;
    for (;i < $scope.goodsInfo.selectedSizes.length;i++) {
      /** @type {number} */
      var y = 0;
      for (;y < $scope.item.commodityOnsaleLst.length;y++) {
        if ($scope.item.commodityOnsaleLst[y].sizeId == $scope.goodsInfo.selectedSizes[i].sizeId) {
          if ($scope.goodsInfo.selectedSizes[i].enable) {
            if ($scope.goodsOnsaleLst.indexOf($scope.item.commodityOnsaleLst[y]) <= -1) {
              $scope.goodsOnsaleLst.push($scope.item.commodityOnsaleLst[y]);
            }
          }
        }
      }
    }
  };
  /**
   * @return {?}
   */
  $scope.saveTmsGoodsInfo = function() {
    if (!$scope.item.commodityVO.name) {
      return UnitTools.toastShow("请输入商品名称"), false;
    }
    if (!$scope.item.commodityVO.tradePrice) {
      return UnitTools.toastShow("请输入商品销售价"), false;
    }
    if ($scope.item.commodityVO.isOnSale = $scope.item.commodityVO.isShelves ? 1 : 0, $scope.item.commodityVO.isNew = $scope.item.commodityVO.isNewChecked ? 1 : 0, $scope.item.commodityVO.isHot = $scope.item.commodityVO.isHotChecked ? 1 : 0, $scope.item.commodityVO.isBest = $scope.item.commodityVO.isBestChecked ? 1 : 0, $scope.item.commodityVO.isDeliveryFee = $scope.item.commodityVO.isDeliveryFeeSetting ? 1 : 0, $scope.item.commodityVO.isDeliveryFeeSetting &&
    ($scope.goodsInfo.deliveryFeeTemplet && $scope.goodsInfo.deliveryFeeTemplet.id)) {
      $scope.item.commodityVO.deliveryFeeTempletId = $scope.goodsInfo.deliveryFeeTemplet.id;
    } else {
      if ($scope.item.commodityVO.isDeliveryFeeSetting && !$scope.goodsInfo.deliveryFeeTemplet) {
        return UnitTools.toastShow("请选择运费模板！"), false;
      }
    }
    if ($scope.goodsInfo.category) {
      if ($scope.goodsInfo.category.id) {
        $scope.item.commodityVO.categoryId = $scope.goodsInfo.category.id;
      }
    }
    if ($scope.goodsInfo.bland) {
      if ($scope.goodsInfo.bland.id) {
        $scope.item.commodityVO.blandId = $scope.goodsInfo.bland.id;
      }
    }
    if ($scope.goodsInfo.unit) {
      if ($scope.goodsInfo.unit.name) {
        $scope.item.commodityVO.unit = $scope.goodsInfo.unit.name;
      }
    }
    if ($scope.goodsInfo.style) {
      if ($scope.goodsInfo.style.id) {
        $scope.item.commodityVO.styleId = $scope.goodsInfo.style.id;
      }
    }
    if ($scope.goodsInfo.material) {
      if ($scope.goodsInfo.material.id) {
        $scope.item.commodityVO.materialId = $scope.goodsInfo.material.id;
      }
    }
    if ($scope.goodsInfo.season) {
      if ($scope.goodsInfo.season.id) {
        $scope.item.commodityVO.seasonId = $scope.goodsInfo.season.id;
      }
    }
    $scope.removeSingelItem();
    /** @type {number} */
    var i = 0;
    for (;i < $scope.goodsOnsaleLst.length;i++) {
      if (null == $scope.goodsOnsaleLst[i].price || void 0 == $scope.goodsOnsaleLst[i].price) {
        return UnitTools.toastShow("商品单品的价格不能为空！"), false;
      }
    }
    loading.show(true);
    field.postEncode("/KEY359", {
      commodityVO : angular.toJson($scope.item.commodityVO),
      commodityOnsaleLst : angular.toJson($scope.goodsOnsaleLst),
      commodityColors : angular.toJson($scope.item.commodityColors),
      commoditySizes : angular.toJson($scope.item.commoditySizes)
    }).success(function(r) {
      if (1 == r.statusCode) {
        $scope.getTmsGoodsInfo();
        $templateCache.put("tmsGoodListRefresh", true);
        UnitTools.toastShow("保存成功！");
      } else {
        UnitTools.toastShow(r.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getTmsGoodsInfo();
  });
}]).controller("TmsPaymentSetCtrl", ["$scope", "$state", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "ServerConfig", "lruPersistCache", "lbScrollDelegate", "$http", "CameraService", "$cordovaFile", "$ionicActionSheet", "VaApplyItem", function(self, deepDataAndEvents, ignoreMethodDoesntExist, $http, assert, textAlt, $modal, keepData, _, loading, current, opt_attributes, _this,
matcherFunction, item, exports, dialog, dataAndEvents) {
  /**
   * @param {string} res
   * @return {undefined}
   */
  function onSuccess(res) {
    /** @type {string} */
    var boundary = "wxpayScanPay" == res ? "接入微信支付，客户即可在销货宝进行微信支付下单" : "接入支付宝支付，客户即可在销货宝进行支付宝支付下单";
    var oldLeft = current.currentServer.replace("/is", "").replace("ex.", "www.").replace("web.", "www.");
    if (window.cordova && window.cordova.plugins) {
      assert.showConfirm(boundary, function(deepDataAndEvents) {
        if (2 == deepDataAndEvents) {
          self.openLink(oldLeft + dataAndEvents.getVaItem[4].htmlName, 1);
        }
      }, "您还未接入服务", ["取消", "一键接入"]);
    } else {
      var promise = _.confirm({
        template : "<div class='tc'>" + boundary + "</div>",
        cancelText : "取消",
        okText : "开通"
      });
      promise.then(function(deepDataAndEvents) {
        if (deepDataAndEvents) {
          self.openLink(oldLeft + dataAndEvents.getVaItem[4].htmlName, 1);
        }
      });
    }
  }
  self.tmsPaymentPicture = {
    imgList : []
  };
  /** @type {boolean} */
  self.isLoading = true;
  self.tmsPaymentMethod = {
    offline : {
      show : true
    },
    collect : {
      show : true
    },
    weChat : {
      show : true
    },
    transfer : {
      show : true
    }
  };
  /**
   * @param {Object} node
   * @param {?} evt
   * @return {undefined}
   */
  self.toggleGroup = function(node, evt) {
    if (evt) {
      evt.stopPropagation();
    }
    /** @type {boolean} */
    node.show = !node.show;
  };
  /**
   * @param {?} event
   * @return {undefined}
   */
  self.scrollContent = function(event) {
    if (event) {
      event.stopPropagation();
    }
    _this.resize("resourceScroll");
  };
  /**
   * @return {?}
   */
  var throttledUpdate = function() {
    return $http.postEncode("/KEY324");
  };
  /**
   * @return {undefined}
   */
  self.getTmsPayConfig = function() {
    loading.show();
    throttledUpdate().success(function(res) {
      if (1 == res.statusCode) {
        self.item = res.object;
        /** @type {boolean} */
        self.tmsPaymentMethod.offline.offlinePayments = self.item.wechatShopPayConfigVO.codSwitch ? true : false;
        /** @type {boolean} */
        self.tmsPaymentMethod.collect.collection = self.item.wechatShopPayConfigVO.alipaySwitch ? true : false;
        /** @type {boolean} */
        self.tmsPaymentMethod.weChat.wechatPayments = self.item.wechatShopPayConfigVO.wxpaySwitch ? true : false;
        /** @type {boolean} */
        self.tmsPaymentMethod.transfer.wechatTransfer = self.item.wechatShopPayConfigVO.wechatQrcodeTransferSwitch ? true : false;
        if (self.item.pubUploadImgVO) {
          /** @type {Array} */
          self.tmsPaymentPicture.imgList = [];
          self.tmsPaymentPicture.imgList.push(self.item.pubUploadImgVO);
        }
      }
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
    });
  };
  /**
   * @return {?}
   */
  self.saveTmsPayConfig = function() {
    return self.tmsPaymentMethod.offline.offlinePayments || (self.tmsPaymentMethod.collect.collection || (self.tmsPaymentMethod.weChat.wechatPayments || self.tmsPaymentMethod.transfer.wechatTransfer)) ? self.tmsPaymentMethod.transfer.wechatTransfer && (!self.tmsPaymentPicture.imgList || self.tmsPaymentPicture.imgList.length < 1) ? (assert.toastShow("微信转账二维码不能为空，请上传微信转账二维码图片！"),
    false) : (self.item.wechatShopPayConfigVO.codSwitch = self.tmsPaymentMethod.offline.offlinePayments ? 1 : 0, self.item.wechatShopPayConfigVO.alipaySwitch = self.tmsPaymentMethod.collect.collection ? 1 : 0, self.item.wechatShopPayConfigVO.wxpaySwitch = self.tmsPaymentMethod.weChat.wechatPayments ? 1 : 0, self.item.wechatShopPayConfigVO.wechatQrcodeTransferSwitch = self.tmsPaymentMethod.transfer.wechatTransfer ? 1 : 0, loading.show(true),
    void $http.post("/KEY316", self.item.wechatShopPayConfigVO).success(function(res) {
      if (1 == res.statusCode) {
        assert.toastShow(res.content);
        self.getTmsPayConfig();
      } else {
        if (3 == res.statusCode) {
          onSuccess("wxpayScanPay");
        } else {
          self.showMessage(res.content);
        }
      }
    }).finally(function() {
      loading.hide();
    })) : (assert.toastShow("请至少选择一种支付方式!"), false);
  };
  $modal.fromTemplateUrl("tmsPaymentImages.html", function(theTitle) {
    /** @type {number} */
    self.tmsPaymentImagesModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    if (self.tmsPaymentImagesModal) {
      self.tmsPaymentImagesModal.remove();
    }
  });
  /**
   * @param {?} b
   * @return {undefined}
   */
  self.showBulletinImage = function(b) {
    if (!angular.equals(self.tmsPaymentPicture.image, self.tmsPaymentPicture.imgList[b].url)) {
      self.tmsPaymentPicture.image = self.tmsPaymentPicture.imgList[b].url;
      _this.zoomTo("tmsPaymentImagesScroll", 1, false, 0, 0);
    }
    self.tmsPaymentImagesModal.show();
  };
  /**
   * @param {string} fileName
   * @return {undefined}
   */
  var parse = function(fileName) {
    loading.show(true);
    var options = new FileUploadOptions;
    /** @type {string} */
    options.fileKey = "file";
    options.fileName = fileName.substr(fileName.lastIndexOf("/") + 1) + ".jpg";
    /** @type {string} */
    options.mimeType = "image/jpeg";
    options.params = {
      module : "wechatShopQrcodeTransferAlbum",
      tmsPaymentId : self.item.wechatShopPayConfigVO.id
    };
    /** @type {boolean} */
    options.chunkedMode = false;
    exports.uploadFile(current.currentServer + "/KEY328", fileName, options).then(function(data) {
      loading.hide();
      var res = angular.fromJson(data.response);
      if (1 === res.statusCode) {
        self.tmsPaymentPicture.imgList.push(res.object.pubUploadImgVO);
        assert.toastShow("图片上传成功！");
      } else {
        assert.toastShow("图片上传失败！");
      }
      item.cleanup().then(function() {
        console.log("CameraService cleanup successfully");
      });
    }, function(err) {
      loading.hide();
      assert.toastShow(413 === err.http_status ? "不能上传超过500K的图片！" : "图片上传失败！");
      item.cleanup().then(function() {
        console.log("CameraService cleanup successfully");
      });
    }, function() {
    });
  };
  /**
   * @return {undefined}
   */
  self.choosePhoto = function() {
    dialog.show({
      buttons : [{
        text : '<i class="icon ion-camera assertive"></i> 拍 照'
      }, {
        text : '<i class="icon ion-images assertive"></i> 从相册中选择'
      }],
      /**
       * @param {?} clicked
       * @return {?}
       */
      buttonClicked : function(clicked) {
        switch(clicked) {
          case 0:
            item.startCamera(self.platformIsAndroid ? self.sysConfig.allowEditGoodImg : true).then(parse);
            break;
          case 1:
            item.openCameraRoll(self.platformIsAndroid ? self.sysConfig.allowEditGoodImg : true).then(parse);
        }
        return true;
      }
    });
  };
  /**
   * @param {?} v23
   * @return {undefined}
   */
  self.delRelImg = function(v23) {
    if (v23) {
      v23.stopPropagation();
    }
    loading.show();
    $http.post("/KEY333").success(function(res) {
      if (1 === res.statusCode) {
        /** @type {Array} */
        self.tmsPaymentPicture.imgList = [];
        assert.toastShow(res.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  self.$on("$ionicView.loaded", function() {
    self.getTmsPayConfig();
  });
}]).controller("TmsShippingSetCtrl", ["$scope", "$state", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "ServerConfig", "lruPersistCache", "lbScrollDelegate", function($scope, dataAndEvents, deepDataAndEvents, $, UnitTools, ignoreMethodDoesntExist, $modal, textAlt, keepData, loading, opt_attributes, matcherFunction, parent) {
  /** @type {number} */
  var page = 1;
  var params = {
    page : page
  };
  /** @type {boolean} */
  $scope.isLoading = true;
  /** @type {boolean} */
  $scope.closeShippingEditModalFlag = false;
  /**
   * @param {?} attributes
   * @return {?}
   */
  var link = function(attributes) {
    return $.postEncode("/KEY302", attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getDeliveryFeeList = function() {
    /** @type {number} */
    page = 1;
    loading.show();
    link(params).success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
      /** @type {boolean} */
      $scope.isLoading = false;
      if ($scope.closeShippingEditModalFlag) {
        $scope.tmsShippingEditModal.hide();
        /** @type {boolean} */
        $scope.closeShippingEditModalFlag = false;
      }
    }).error(function() {
      loading.hide();
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.scrollTop("deliveryFeeListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    page = 1;
    link(params).success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    link({
      page : ++page
    }).success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("deliveryFeeListCtrlScroll");
    });
  };
  /**
   * @param {?} deepDataAndEvents
   * @return {?}
   */
  $scope.fixedInputNumber = function(deepDataAndEvents) {
    return UnitTools.getValidNum(deepDataAndEvents);
  };
  $modal.fromTemplateUrl("tmsShippingEdit.html", function($location) {
    /** @type {number} */
    $scope.tmsShippingEditModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    if ($scope.tmsShippingEditModal) {
      $scope.tmsShippingEditModal.remove();
    }
  });
  /**
   * @param {?} r
   * @param {Object} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.goEdit = function(r, expectedNumberOfNonCommentArgs) {
    if (expectedNumberOfNonCommentArgs) {
      expectedNumberOfNonCommentArgs.stopPropagation();
    }
    $scope.tmsShippingEditModal.show(expectedNumberOfNonCommentArgs);
    /** @type {*} */
    $scope.tmsShippingInfoEdit = JSON.parse(JSON.stringify(r));
  };
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.newAddedShipping = function(expectedNumberOfNonCommentArgs) {
    $scope.tmsShippingEditModal.show(expectedNumberOfNonCommentArgs);
    var custom1 = {
      templetName : null,
      intNumber : null,
      intFee : null,
      continuedNumber : null,
      continuedFee : null
    };
    /** @type {*} */
    $scope.tmsShippingInfoEdit = JSON.parse(JSON.stringify(custom1));
  };
  /**
   * @return {?}
   */
  $scope.saveTmsShippingInfo = function() {
    return $scope.tmsShippingInfoEdit.templetName ? $scope.tmsShippingInfoEdit.intNumber ? $scope.tmsShippingInfoEdit.intFee ? $scope.tmsShippingInfoEdit.continuedNumber ? $scope.tmsShippingInfoEdit.continuedFee ? (loading.show(true), void $.post("/KEY301", $scope.tmsShippingInfoEdit).success(function(r) {
      if (1 == r.statusCode) {
        UnitTools.toastShow(r.content);
        $.httpCacheGet.remove($.httpCacheGet.ac.TMSGOODSDELIVERYFEELIST);
        /** @type {boolean} */
        $scope.closeShippingEditModalFlag = true;
        $scope.getDeliveryFeeList();
      } else {
        UnitTools.toastShow(r.content);
      }
    }).finally(function() {
      loading.hide();
    })) : (UnitTools.toastShow("请输入续件的运费！"), false) : (UnitTools.toastShow("请输入续件的数量！"), false) : (UnitTools.toastShow("请输入首件的运费！"), false) : (UnitTools.toastShow("请输入首件的数量！"), false) : (UnitTools.toastShow("请输入运费类型名称！"), false);
  };
  /**
   * @param {string} e
   * @return {undefined}
   */
  $scope.deleteTmsShippingInfo = function(e) {
    loading.show();
    $.postEncode("/admin/shop/wechat/deliveryfeetemplet/deliveryFeeTempletDelete.ac?id=" + e).success(function(r) {
      if (1 == r.statusCode) {
        UnitTools.toastShow(r.content);
        $.httpCacheGet.remove($.httpCacheGet.ac.TMSGOODSDELIVERYFEELIST);
        /** @type {boolean} */
        $scope.closeShippingEditModalFlag = true;
        $scope.getDeliveryFeeList();
      } else {
        UnitTools.toastShow(r.content);
      }
    }).finally(function() {
      loading.hide();
    });
  };
  $scope.$on("$ionicView.loaded", function() {
    $scope.getDeliveryFeeList();
  });
}]);
