angular.module("storeController", ["ionic", "services", "tools"]).controller("StoreListCtrl", ["$scope", "$state", "psisServices", "lruPersistCache", "lbScrollDelegate", "$ionicModal", "$ionicPopover", "$cordovaDatePicker", "lbSpinnerDialog", "Tools", "BTScanerService", function($scope, $state, User, $templateCache, parent, $modal, FB, scope, loading, dataAndEvents, $cookieStore) {
  var character;
  var chr;
  if ($scope.commonConfig) {
    var n = $scope.commonConfig.orderListDays;
    if (n) {
      character = (new Date).setDate((new Date).getDate() - n);
      /** @type {number} */
      chr = (new Date).getTime();
    }
  }
  /** @type {boolean} */
  $scope.isLoading = true;
  /** @type {Array} */
  $scope.items = [];
  $scope.searchModel = {
    storeHouse : {},
    orderNo : ""
  };
  $scope.searchModel.createTimeBegin = character ? character : "";
  /** @type {(number|string)} */
  $scope.searchModel.createTimeEnd = chr ? chr : "";
  $scope.queryCondition = {
    page : 1,
    orderType : 2,
    status : ""
  };
  /**
   * @return {?}
   */
  var Step = function() {
    return User.postEncode("/KEY195", $scope.queryCondition);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    loading.show();
    /** @type {number} */
    $scope.queryCondition.page = 1;
    $scope.queryCondition.storehouseId = $scope.searchModel.storeHouse.val ? $scope.searchModel.storeHouse.val : "";
    $scope.queryCondition.orderNo = $scope.searchModel.orderNo;
    if ($scope.searchModel.createTimeBegin) {
      $scope.queryCondition.createTimeBegin = dataAndEvents.transferGMTStringtoBJTime(dataAndEvents.getDayBeginStr($scope.searchModel.createTimeBegin));
    } else {
      delete $scope.queryCondition.createTimeBegin;
    }
    if ($scope.searchModel.createTimeEnd) {
      $scope.queryCondition.createTimeEnd = dataAndEvents.transferGMTStringtoBJTime(dataAndEvents.getOffsetDayBeginStr($scope.searchModel.createTimeEnd, 1));
    } else {
      delete $scope.queryCondition.createTimeEnd;
    }
    Step().success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.scrollTop("storeListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    Step().success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("storeListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    loading.show(true);
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step().success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      loading.hide();
      parent.scrollTop("storeListCtrlScroll");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    });
  };
  /**
   * @return {undefined}
   */
  $scope.createNewOrder = function() {
    $state.go("eventmenu.KEY277", {
      timeStamp : dataAndEvents.getTimeStamp()
    });
  };
  /**
   * @param {?} dataAndEvents
   * @param {string} deepDataAndEvents
   * @return {undefined}
   */
  $scope.goStore = function(dataAndEvents, deepDataAndEvents) {
    if ("1" === deepDataAndEvents) {
      $state.go("eventmenu.KEY277", {
        orderNo : dataAndEvents
      });
    } else {
      $state.go("eventmenu.KEY256", {
        orderNo : dataAndEvents
      });
    }
  };
  $modal.fromTemplateUrl("storeListQuery.html", function($location) {
    $scope.storeListQueryModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : $scope.searchModel.createTimeBegin ? new Date($scope.searchModel.createTimeBegin) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.searchModel.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : $scope.searchModel.createTimeEnd ? new Date($scope.searchModel.createTimeEnd) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.searchModel.createTimeEnd = date1.getTime();
      }
    });
  };
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.storehousePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideStorehousePopover = function() {
    $scope.storehousePopover.hide();
  };
  /**
   * @return {undefined}
   */
  $scope.clearQueryCondition = function() {
    $scope.searchModel.storeHouse = {};
    /** @type {string} */
    $scope.searchModel.orderNo = "";
    /** @type {null} */
    $scope.searchModel.createTimeBegin = null;
    /** @type {null} */
    $scope.searchModel.createTimeEnd = null;
  };
  $scope.$on("$destroy", function() {
    $scope.storeListQueryModal.remove();
    $scope.storehousePopover.remove();
  });
  $scope.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("storeListRefresh")) {
      if ($templateCache.get("storeListRefresh") === true) {
        $scope.getList();
        $templateCache.put("storeListRefresh", false);
      }
    }
    $cookieStore.getScanerCode(function(fmt) {
      if (fmt) {
        console.log(fmt);
      }
    }, $scope.bluethoothScaner);
  });
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
    User.httpCacheGet.get(User.httpCacheGet.ac.STOREHOUSECHECKCONFIG).success(function($location) {
      $scope.allDept = $location;
    });
  });
}]).controller("StoreDetailCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "lbSpinnerDialog", "$state", "$ionicModal", "lbScrollDelegate", "BTScanerService", "$ionicPopover", function($scope, event, $, errors, loading, $state, $modal, parent, $cookieStore, FB) {
  var type = event.orderNo;
  /** @type {number} */
  var apiCall = 1;
  $scope.condition = {
    searchKey : "",
    colorName : "",
    sizeName : ""
  };
  /** @type {Array} */
  $scope.goodsGroup = [];
  /**
   * @return {undefined}
   */
  $scope.clearQueryCondition = function() {
    /** @type {string} */
    $scope.condition.searchKey = "";
    /** @type {string} */
    $scope.condition.colorName = "";
    /** @type {string} */
    $scope.condition.sizeName = "";
  };
  $modal.fromTemplateUrl("detailQuery.html", function($location) {
    $scope.detailQueryModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("copyOperation.html", {
    scope : $scope
  }).then(function($location) {
    $scope.copyOperationPopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openCopyOperationPopover = function(expectedNumberOfNonCommentArgs) {
    $scope.copyOperationPopover.show(expectedNumberOfNonCommentArgs);
  };
  $scope.$on("$destroy", function() {
    $scope.detailQueryModal.remove();
    $scope.copyOperationPopover.remove();
  });
  $scope.isUserAccAvailable = $scope.GetOperatorEventLimit("KEY206");
  $scope.isUserAccProfitAmount = $scope.GetOperatorEventLimit("KEY051");
  /**
   * @return {undefined}
   */
  $scope.createNewOrder = function() {
    if (1 === $scope.status) {
      $scope.clearTempData();
    }
    $scope.viewReplace();
    $state.go("eventmenu.KEY277", {
      timeStamp : errors.getTimeStamp()
    });
  };
  /**
   * @return {undefined}
   */
  $scope.gotoBarCodePrint = function() {
    $state.go("eventmenu.KEY218", {
      ordersSn : type
    });
  };
  /**
   * @return {undefined}
   */
  $scope.copyForOrder = function() {
    $scope.viewReplace();
    /** @type {string} */
    $scope.orderDetail.order.orderFrom = "storeStockTransferEdit";
    delete $scope.orderDetail.order.submitUserName;
    $scope.copyOrder = {
      order : $scope.orderDetail.order
    };
    $state.go("eventmenu.KEY277", {
      timeStamp : errors.getTimeStamp(),
      goods : $scope.copyOrder
    });
  };
  /**
   * @param {Blob} str
   * @return {?}
   */
  var escape = function(str) {
    var attributes = {
      page : str,
      goodsName : $scope.condition.searchKey,
      goodsSn : $scope.condition.searchKey,
      barCode : $scope.condition.searchKey,
      sizeName : $scope.condition.sizeName,
      skuBarCode : $scope.condition.searchKey,
      colorName : $scope.condition.colorName,
      storeOrderNo : type
    };
    return $.postEncode("/KEY207", attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    /** @type {number} */
    apiCall = 1;
    loading.show(true);
    escape(apiCall).success(function(data) {
      /** @type {Array} */
      $scope.goodsGroup = [];
      $scope.totalQuantity = data.sumNumber;
      $scope.totalProfitNumber = data.sumProfitNumber;
      $scope.totalProfitAmount = data.sumProfitAmount;
      data.rows.forEach(function(w) {
        /** @type {boolean} */
        var t = false;
        /** @type {number} */
        var count = 0;
        var thumbsCount = $scope.goodsGroup.length;
        for (;thumbsCount > count;count++) {
          var auto = $scope.goodsGroup[count].goodsSn;
          if (w.goodsSn == auto) {
            /** @type {boolean} */
            t = true;
            $scope.goodsGroup[count].goods.push(errors.getPropertyObj(w, ["colorName", "sizeName", "quantity", "number", "profitNumber", "profitAmount"]));
          }
        }
        if (!t) {
          var reporter = {};
          /** @type {Array} */
          reporter.goods = [];
          reporter.goods.push(errors.getPropertyObj(w, ["colorName", "sizeName", "quantity", "number", "profitNumber", "profitAmount"]));
          reporter.goodName = w.goodName;
          reporter.goodsSn = w.goodsSn;
          reporter.barCode = w.barCode;//条码
          $scope.goodsGroup.push(reporter);
        }
      });
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      loading.hide();
      parent.scrollTop("StoreDetailCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    apiCall++;
    loading.show(true);
    escape(apiCall).success(function(options) {
      options.rows.forEach(function(w) {
        /** @type {boolean} */
        var t = false;
        /** @type {number} */
        var count = 0;
        var thumbsCount = $scope.goodsGroup.length;
        for (;thumbsCount > count;count++) {
          var auto = $scope.goodsGroup[count].goodsSn;
          if (w.goodsSn == auto) {
            /** @type {boolean} */
            t = true;
            $scope.goodsGroup[count].goods.push(errors.getPropertyObj(w, ["colorName", "sizeName", "quantity", "number", "profitNumber", "profitAmount"]));
          }
        }
        if (!t) {
          var reporter = {};
          /** @type {Array} */
          reporter.goods = [];
          reporter.goods.push(errors.getPropertyObj(w, ["colorName", "sizeName", "quantity", "number", "profitNumber", "profitAmount"]));
          reporter.goodName = w.goodName;
          reporter.goodsSn = w.goodsSn;
          reporter.barCode = w.barCode;//条码
          $scope.goodsGroup.push(reporter);
        }
      });
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
    }).finally(function() {
      parent.resize("StoreDetailCtrlScroll");
      loading.hide();
    });
  };
  /**
   * @return {undefined}
   */
  $scope.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      if (!result.cancelled) {
        $scope.$apply(function() {
          $scope.condition.searchKey = result.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      errors.toastShow("二维码扫描失败！");
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    loading.show(true);
    $.post("/KEY206?orderNo=" + type).success(function($location) {
      $scope.orderDetail = $location;
      $scope.getList();
    }).finally(function() {
      loading.hide();
    });
    $cookieStore.getScanerCode(function(fmt) {
      if (fmt) {
        console.log(fmt);
      }
    }, $scope.bluethoothScaner);
  });
}]).controller("StoreEditCtrl", ["$scope", "$stateParams", "$q", "$ionicModal", "$ionicPopup", "$state", "lbSpinnerDialog", "psisServices", "Tools", "$ionicPopover", "$ionicActionSheet", "showInstructionBackdrop", "$ionicPlatform", "lruPersistCache", "commonDataInterface", "lbScrollDelegate", "BTScanerService", "$timeout", function(self, c, $q, $modal, view, $state, loading, result, UnitTools, FB, handler, deepDataAndEvents,
dataAndEvents, $templateCache, nv, that, $document, $sanitize) {
  /**
   * @return {?}
   */
  function resolve() {
    var imageDfd = $q.defer();
    var request1 = result.httpCacheGet.get(result.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
    var getPromise3 = result.httpCacheGet.get(result.httpCacheGet.ac.ALLSIZELIST);
    var c = result.httpCacheGet.get(result.httpCacheGet.ac.ALLCOLORLIST);
    return $q.all([request1, getPromise3, c]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @param {?} keepData
   * @param {?} pool
   * @param {?} cback
   * @return {?}
   */
  function fetch(keepData, pool, cback) {
    var imageDfd = $q.defer();
    var request1 = result.postEncode("/KEY199", {
      goodsSn : pool,
      storeOrderNo : keepData
    });
    var getPromise3 = result.postEncode("/KEY092", {
      goodsSn : pool,
      storehouseId : cback
    });
    return $q.all([request1, getPromise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /**
   * @param {Array} args
   * @return {undefined}
   */
  function exec(args) {
    /** @type {Array} */
    var params = [];
    if (config.codeArr = [], args.length > 0) {
      /** @type {number} */
      var i = 0;
      for (;i < args.length;i++) {
        if (args[i].name) {
          var data = args[i].good;
          params.push({
            goodsSn : args[i].goodsSn,
            colorId : data.colorId,
            sizeId : data.sizeId,
            number : self.fixedInputNumber(data.quantity),
            beforeNumber : data.number
          });
        }
      }
      value.storehouseId = self.storeOrder.storeDepot.val;
      serialize(params).success(function(res) {
        if (1 !== res.statusCode) {
          UnitTools.toastShow(res.content);
        }
      });
    }
  }
  /**
   * @return {?}
   */
  function promote() {
    return config.codeArr.length >= 50;
  }
  /**
   * @param {string} str
   * @param {number} n
   * @return {undefined}
   */
  function f(str, n) {
    var newDuration = document.getElementsByClassName(str)[n].offsetTop;
    that.scrollTo("scanGoodListScroll", 0, newDuration);
  }
  var key = c.orderNo;
  var value = {
    status : self.status
  };
  self.upLoadGoodsList = {
    goodsSn : "",
    goods : []
  };
  self.uploadDelGoodsList = {
    goodsSn : "",
    goods : []
  };
  /** @type {number} */
  self.status = 0;
  /** @type {Array} */
  self.KEY288 = [];
  self.storeOrder = {
    goodsGroup : [],
    showDelete : false,
    number : 0
  };
  self.selectedGood = {
    skuStoreGood : []
  };
  self.search = {
    goodKey : ""
  };
  self.condition = {
    searchKey : "",
    colorName : "",
    sizeName : ""
  };
  self.notStoreCondition = {
    searchKey : "",
    colorName : "",
    sizeName : ""
  };
  /** @type {Array} */
  self.queryGoodsGroup = [];
  /** @type {number} */
  self.totalQuantity = 0;
  /** @type {number} */
  self.finalTotalQuantity = 0;
  /** @type {number} */
  self.orderTotalQuantity = 0;
  self.orderContent = {};
  /** @type {boolean} */
  self.isOpenScroll = true;
  /** @type {boolean} */
  self.inComstore = true;
  /** @type {number} */
  self.modalShowFlag = 0;
  self.isUserAccAvailable = self.GetOperatorEventLimit("KEY206");
  self.storeDraftAccAvailable = self.GetOperatorEventLimit("KEY094");
  self.storeConfirmAccAvailable = self.GetOperatorEventLimit("KEY115");
  self.storeDraftOrConfirmAccAvailable = self.GetOperatorEventLimit("KEY094") || self.GetOperatorEventLimit("KEY115");
  /**
   * @return {undefined}
   */
  self.createNewOrder = function() {
    self.viewReplace();
    $state.go("eventmenu.KEY277", {
      orderNo : null,
      timeStamp : UnitTools.getTimeStamp()
    }, {
      reload : true
    });
  };
  /**
   * @param {Object} event
   * @return {undefined}
   */
  self.gobackToListAction = function(event) {
    if (event && (event.stopPropagation() && event.preventDefault()), "eventmenu.KEY277" == $state.current.name) {
      if (0 === self.status && (self.isGoodsGroupNull() && (key && self.deleteTempOrder())), 1 === self.status && self.clearTempData(), 0 !== self.status || self.isGoodsGroupNull()) {
        if (self.getGroupGoodsNum() > self.orderTotalQuantity) {
          var promise = view.confirm({
            template : "<div class='tc'>当前盘点存在尚未保存的商品，确认要退出和放弃?</div>",
            cancelText : "取消",
            okText : "确认退出"
          });
          promise.then(function(dataAndEvents) {
            if (dataAndEvents) {
              (done || angular.noop)();
              self.deleteTempOrder();
              self.goBack();
            }
          });
        } else {
          (done || angular.noop)();
          self.goBack();
        }
      } else {
        promise = view.confirm({
          template : "<div class='tc'>确认要退出盘点?</div>",
          cancelText : "取消",
          okText : "继续退出"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            (done || angular.noop)();
            self.deleteTempOrder();
            self.goBack();
          }
        });
      }
    } else {
      (done || angular.noop)();
      self.goBack();
    }
  };
  var done = dataAndEvents.registerBackButtonAction(function() {
    return self.gobackToListAction(), false;
  }, 140);
  self.$on("$ionicView.loaded", function() {
    if (!key) {
      !c.goods;
    }
  });
  /**
   * @return {?}
   */
  self.isGoodsGroupNull = function() {
    return UnitTools.isEmpty(self.storeOrder.goodsGroup);
  };
  $modal.fromTemplateUrl("html/PStorageStockBill/KEY049.html", function(theTitle) {
    self.modal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {?}
   */
  self.modalOpen = function() {
    return UnitTools.isEmpty(self.storeOrder.storeDepot) ? window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择仓库！", null), false) : (view.alert({
      template : "<div class='tc'>请选择仓库！</div>",
      okText : "确定"
    }), false) : (self.modal.show(), self.storeOrder.showDelete = false, void(0 == self.modalShowFlag ? self.modalShowFlag = 2 : 1 == self.modalShowFlag && (self.selectedGoodModal.remove(), $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY093.html", function(theTitle) {
      self.selectedGoodModal = theTitle;
    }, {
      scope : self,
      animation : "slide-in-up"
    }), self.modalShowFlag = 2)));
  };
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    self.storehousePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    self.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  self.hideStorehousePopover = function() {
    self.storehousePopover.hide();
  };
  $modal.fromTemplateUrl("storeQuery.html", function(theTitle) {
    self.storeQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.clearQueryCondition = function() {
    /** @type {string} */
    self.condition.searchKey = "";
    /** @type {string} */
    self.condition.colorName = "";
    /** @type {string} */
    self.condition.sizeName = "";
  };
  /**
   * @return {undefined}
   */
  self.clearNotStoreQueryCondition = function() {
    /** @type {string} */
    self.notStoreCondition.searchKey = "";
    /** @type {string} */
    self.notStoreCondition.colorName = "";
    /** @type {string} */
    self.notStoreCondition.sizeName = "";
  };
  /**
   * @param {Array} data
   * @param {Array} val
   * @return {?}
   */
  var serialize = function(data, val) {
    return result.postEncode("/KEY201", {
      storeOrder : angular.toJson(value),
      goods : angular.toJson(data) ? angular.toJson(data) : "",
      deleteGoods : angular.toJson(val) ? angular.toJson(val) : ""
    });
  };
  /**
   * @param {?} object
   * @param {?} selectElement
   * @return {undefined}
   */
  self.realTimeSaveGoodsList = function(object, selectElement) {
    /** @type {Array} */
    var params = [];
    /** @type {Array} */
    var indents = [];
    if (params) {
      /** @type {number} */
      var j = 0;
      for (;j < object.goods.length;j++) {
        var data = object.goods[j];
        params.push({
          goodsSn : object.goodsSn,
          colorId : data.colorId,
          sizeId : data.sizeId,
          number : self.fixedInputNumber(data.quantity),
          beforeNumber : data.number
        });
      }
    }
    if (selectElement) {
      /** @type {number} */
      j = 0;
      for (;j < selectElement.goods.length;j++) {
        data = selectElement.goods[j];
        indents.push({
          goodsSn : selectElement.goodsSn,
          colorId : data.colorId,
          sizeId : data.sizeId,
          number : 0
        });
      }
    }
    value.storehouseId = self.storeOrder.storeDepot.val;
    serialize(params, indents).success(function(res) {
      if (1 !== res.statusCode) {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /**
   * @param {string} data
   * @param {string} dataAndEvents
   * @return {undefined}
   */
  self.realTimeSaveGoods = function(data, dataAndEvents) {
    /** @type {Array} */
    var params = [];
    params.push({
      goodsSn : dataAndEvents,
      colorId : data.colorId,
      sizeId : data.sizeId,
      number : self.fixedInputNumber(data.quantity),
      beforeNumber : data.number
    });
    value.storehouseId = self.storeOrder.storeDepot.val;
    serialize(params).success(function(res) {
      if (1 !== res.statusCode) {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /** @type {number} */
  self.skuCount = 0;
  var data = {};
  /** @type {string} */
  var node = "";
  /**
   * @param {?} event
   * @param {string} dataAndEvents
   * @param {number} index
   * @return {undefined}
   */
  self.saveUpdateData = function(event, dataAndEvents, index) {
    if (UnitTools.isEmpty(data)) {
      data = event;
      /** @type {string} */
      node = dataAndEvents;
    }
    if (data.sizeId != event.sizeId || data.colorId != event.colorId) {
      /** @type {number} */
      self.skuCount = 0;
      /** @type {number} */
      index = -1;
      self.realTimeSaveGoods(data, node);
      data = event;
      /** @type {string} */
      node = dataAndEvents;
    }
    self.skuCount++;
    $sanitize(function() {
      if (self.skuCount == index + 1) {
        self.realTimeSaveGoods(event, dataAndEvents);
        /** @type {number} */
        self.skuCount = 0;
        data = {};
        /** @type {string} */
        node = "";
      }
    }, 2E3);
  };
  /**
   * @return {undefined}
   */
  self.getOrderNo = function() {
    if (UnitTools.isEmpty(key)) {
      UnitTools.union(value, {
        orderType : 2,
        storehouseId : self.storeOrder.storeDepot.val,
        remark : self.storeOrder.remark,
        orderNo : key
      });
      result.postEncode("/KEY200", {
        storeOrder : angular.toJson(value)
      }).success(function(res) {
        if (1 == res.statusCode) {
          value = res.object;
          key = res.object.orderNo;
        } else {
          UnitTools.toastShow(res.content);
        }
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.deleteTempOrder = function() {
    result.postEncode("/KEY209", {
      storeOrder : angular.toJson(value)
    }).success(function(res) {
      if (1 != res.statusCode) {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.clearTempData = function() {
    result.postEncode("/KEY210", {
      storeOrder : angular.toJson(value)
    }).success(function(res) {
      if (1 != res.statusCode) {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /**
   * @param {Array} obj
   * @return {?}
   */
  var logger = function(obj) {
    return result.postEncode("/KEY360", {
      storeOrder : angular.toJson(value),
      goods : angular.toJson(obj)
    });
  };
  /**
   * @param {string} data
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.deleteTempSku = function(data, dataAndEvents) {
    /** @type {Array} */
    var failures = [];
    failures.push({
      goodsSn : dataAndEvents,
      colorId : data.colorId,
      sizeId : data.sizeId,
      number : self.fixedInputNumber(data.quantity),
      beforeNumber : data.number
    });
    logger(failures).success(function(res) {
      if (1 != res.statusCode) {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /**
   * @param {?} selectElement
   * @return {undefined}
   */
  self.deleteTempSkuList = function(selectElement) {
    /** @type {Array} */
    var failures = [];
    /** @type {number} */
    var j = 0;
    for (;j < selectElement.goods.length;j++) {
      var data = selectElement.goods[j];
      failures.push({
        goodsSn : selectElement.goodsSn,
        colorId : data.colorId,
        sizeId : data.sizeId,
        number : self.fixedInputNumber(data.quantity),
        beforeNumber : data.number
      });
    }
    logger(failures).success(function(res) {
      if (1 != res.statusCode) {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.deleteTempGoods = function(dataAndEvents) {
    result.postEncode("/KEY326", {
      storeOrder : angular.toJson(value),
      goodsSn : dataAndEvents
    }).success(function(res) {
      if (1 != res.statusCode) {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /**
   * @param {?} failures
   * @param {string} rank
   * @param {number} theTitle
   * @param {boolean} deepDataAndEvents
   * @return {undefined}
   */
  self.getFinalData = function(failures, rank, theTitle, deepDataAndEvents) {
    /** @type {Array} */
    var new_val = [];
    failures.forEach(function(event) {
      var data = UnitTools.getPropertyObj(event, ["goodsSn", "colorId", "sizeId"]);
      new_val.push(UnitTools.union({
        storehouseId : rank
      }, data));
    });
    result.postEncode("/KEY204", {
      goodsList : angular.toJson(new_val)
    }).success(function(name) {
      failures.forEach(function(data) {
        var event = UnitTools.fnCheckGtoreQty(name, "serialNo", rank + "-" + data.goodsSn + "-" + data.colorId + "-" + data.sizeId);
        var copies = UnitTools.union({
          number : event ? event.number : 0
        }, UnitTools.getPropertyObj(data, ["goodsSn", "colorId", "sizeId", "colorName", "sizeName", "quantity", "unit"]));
        /** @type {boolean} */
        var d = false;
        /** @type {number} */
        var unlock = 0;
        var cnl = self.storeOrder.goodsGroup.length;
        for (;cnl > unlock;unlock++) {
          var a = self.storeOrder.goodsGroup[unlock].goodsSn;
          if (data.goodsSn == a) {
            /** @type {boolean} */
            d = true;
            var u = UnitTools.getObjectByObject(self.storeOrder.goodsGroup[unlock].goods, {
              colorId : data.colorId,
              sizeId : data.sizeId
            });
            if (!u) {
              self.storeOrder.goodsGroup[unlock].goods.push(copies);
            }
          }
        }
        if (!d) {
          var meta = {};
          /** @type {Array} */
          meta.goods = [];
          meta.goods.push(copies);
          meta.goodName = data.goodName;
          meta.goodsSn = data.goodsSn;
          meta.barCode = data.barCode;//条码
          self.storeOrder.goodsGroup.push(meta);
        }
      });
      /** @type {number} */
      self.finalTotalQuantity = theTitle;
      self.totalQuantity = self.getGroupGoodsNum();
      if (deepDataAndEvents) {
        /** @type {number} */
        self.orderTotalQuantity = theTitle;
      }
    }).finally(function() {
      loading.hide();
    });
  };
  /**
   * @param {Blob} str
   * @return {?}
   */
  var push = function(str) {
    var obj = {
      page : str,
      goodsName : self.condition.searchKey,
      goodsSn : self.condition.searchKey,
      barCode : self.condition.searchKey,
      skuBarCode : self.condition.searchKey,
      sizeName : self.condition.sizeName,
      colorName : self.condition.colorName,
      storeOrderNo : key
    };
    return result.postEncode("/KEY207", obj);
  };
  /** @type {number} */
  var task = 1;
  /**
   * @return {undefined}
   */
  self.getStoreMore = function() {
    loading.show(true);
    task++;
    push(task).success(function(options) {
      self.getFinalData(options.rows, self.storeOrder.storeDepot.val, options.sumNumber);
      /** @type {boolean} */
      self.loadMoreStoreBtn = options.page < options.total;
    }).finally(function() {
      that.resize("StoreEditCtrlScroll");
    });
  };
  /**
   * @param {boolean} deepDataAndEvents
   * @return {undefined}
   */
  self.getStoreList = function(deepDataAndEvents) {
    /** @type {number} */
    task = 1;
    loading.show(true);
    push(task).success(function(options) {
      /** @type {Array} */
      self.storeOrder.goodsGroup = [];
      self.getFinalData(options.rows, self.storeOrder.storeDepot.val, options.sumNumber, deepDataAndEvents);
      /** @type {boolean} */
      self.loadMoreStoreBtn = options.page < options.total;
    }).finally(function() {
      that.scrollTop("StoreEditCtrlScroll");
    });
  };
  /**
   * @return {?}
   */
  self.getGroupGoodsNum = function() {
    /** @type {number} */
    var caption = 0;
    /** @type {number} */
    var unlock = 0;
    var cnl = self.storeOrder.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      /** @type {number} */
      var b = 0;
      var a = self.storeOrder.goodsGroup[unlock].goods.length;
      for (;a > b;b++) {
        var line = self.storeOrder.goodsGroup[unlock].goods[b];
        if (line.quantity) {
          caption = UnitTools.accAdd(caption, line.quantity);
        }
      }
    }
    return caption;
  };
  /**
   * @param {string} name
   * @return {undefined}
   */
  self.getPopup = function(name) {
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showConfirm(name, function(dataAndEvents) {
        if (2 == dataAndEvents) {
          loading.show(true);
          result.postEncode("/KEY203", {
            storeOrder : angular.toJson(value)
          }).success(function(res) {
            if (1 == res.statusCode) {
              /** @type {number} */
              self.status = 1;
              UnitTools.toastShow("库存调整成功！");
              $templateCache.put("stockSearchRefresh", true);
              $templateCache.put("stockSearchDetailRefresh", true);
              self.viewReplace();
              $state.go("eventmenu.KEY256", {
                orderNo : res.object.orderNo
              });
            } else {
              UnitTools.toastShow(res.content);
            }
          }).finally(function() {
            loading.hide();
            $templateCache.put("storeListRefresh", true);
          });
        }
      }, "提交盘点", ["取消", "确认"]);
    } else {
      var promise = view.confirm({
        template : name,
        cancelText : "取消",
        okText : "确认"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          loading.show(true);
          result.postEncode("/KEY203", {
            storeOrder : angular.toJson(value)
          }).success(function(res) {
            if (1 == res.statusCode) {
              /** @type {number} */
              self.status = 1;
              UnitTools.toastShow("库存调整成功！");
              $templateCache.put("stockSearchRefresh", true);
              $templateCache.put("stockSearchDetailRefresh", true);
              self.viewReplace();
              $state.go("eventmenu.KEY256", {
                orderNo : res.object.orderNo
              });
            } else {
              UnitTools.toastShow(res.content);
            }
          }).finally(function() {
            loading.hide();
            $templateCache.put("storeListRefresh", true);
          });
        }
      });
    }
  };
  /**
   * @param {string} name
   * @return {?}
   */
  self.saveStore = function(name) {
    if (self.codeArr = [], self.scannedInTotal = 0, self.scannedOutTotal = 0, self.isGoodsGroupNull()) {
      return window.cordova && window.cordova.plugins ? (UnitTools.showAlert("盘点明细不能为空，请添加商品！", null), false) : (view.alert({
        template : "<div class='tc'>盘点明细不能为空，请添加商品！</div>",
        okText : "确定"
      }), false);
    }
    if (UnitTools.isEmpty(self.storeOrder.storeDepot)) {
      return window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择仓库！", null), false) : (view.alert({
        template : "<div class='tc'>请选择仓库！</div>",
        okText : "确定"
      }), false);
    }
    if (value.storehouseId = self.storeOrder.storeDepot.val, value.allStore = self.storeOrder.allStore ? 1 : 0, value.remark = self.storeOrder.remark, value.allStore = 0, "draft" === name) {
      loading.show(true);
      /** @type {number} */
      value.status = 1;
      result.postEncode("/KEY202", {
        storeOrder : angular.toJson(value)
      }).success(function(res) {
        if (1 == res.statusCode) {
          loading.show();
          push(task).success(function(message) {
            self.orderTotalQuantity = message.sumNumber;
          }).finally(function() {
            loading.hide();
          });
          UnitTools.toastShow("保存成功！");
          UnitTools.union(value, res.object);
          /** @type {number} */
          self.status = 1;
        } else {
          UnitTools.toastShow(res.content);
        }
      }).finally(function() {
        loading.hide();
        $templateCache.put("storeListRefresh", true);
      });
    } else {
      if ("commit" === name) {
        /** @type {string} */
        var optgroup = "将按此盘点结果调整商品库存数量，确认要执行库存调整吗？";
        self.getPopup(optgroup);
      }
    }
  };
  /**
   * @return {?}
   */
  var Text = function() {
    var obj = {
      page : page,
      goodsName : self.notStoreCondition.searchKey,
      goodsSn : self.notStoreCondition.searchKey,
      barCode : self.notStoreCondition.searchKey,
      skuBarCode : self.notStoreCondition.searchKey,
      sizeName : self.notStoreCondition.sizeName,
      colorName : self.notStoreCondition.colorName,
      orderNo : key,
      storehouseId : self.storeOrder.storeDepot.val
    };
    return result.postEncode("/KEY205", obj);
  };
  $modal.fromTemplateUrl("queryNotStoreGoods.html", function(theTitle) {
    /** @type {number} */
    self.notStoreQueryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {?}
   */
  self.queryNotStoreGoods = function() {
    return UnitTools.isEmpty(self.storeOrder.storeDepot) ? window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择仓库！", null), false) : (view.alert({
      template : "<div class='tc'>请选择仓库！</div>",
      okText : "确定"
    }), false) : (self.notStoreQueryModal.show(), void self.queryNotStoredSkuList());
  };
  $modal.fromTemplateUrl("notStoreQuery.html", function(theTitle) {
    self.notStoreQueryConditionModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /** @type {number} */
  var page = 1;
  /** @type {string} */
  var ret = "";
  /**
   * @return {undefined}
   */
  self.queryNotStoredSkuList = function() {
    /** @type {boolean} */
    self.isLoading = true;
    /** @type {string} */
    self.notStoreQueryTitle = self.storeOrder.storeDepot.name + "的未盘点商品";
    /** @type {number} */
    page = 1;
    ret = self.storeOrder.storeDepot.val;
    value.storehouseId = self.storeOrder.storeDepot.val;
    loading.show(true);
    Text().success(function(results) {
      self.notStoreGoodsList = results.rows;
      /** @type {boolean} */
      self.loadMoreNotStoreBtn = results.page < results.total;
      self.notStoreTotalQuantity = results.records;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
      that.scrollTop("NotStoreListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.getNotStoreMore = function() {
    page++;
    loading.show(true);
    Text().success(function(options) {
      self.notStoreGoodsList = self.notStoreGoodsList.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreNotStoreBtn = options.page < options.total;
    }).finally(function() {
      loading.hide();
      that.resize("NotStoreListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.scrollToBottomList = function() {
    $sanitize(function() {
      that.scrollBottom("StoreEditCtrlScroll");
    }, 300);
  };
  /**
   * @param {?} qualifier
   * @return {?}
   */
  self.isNum = function(qualifier) {
    /** @type {RegExp} */
    var isSimple = /^\d+$/;
    return isSimple.test(qualifier);
  };
  /**
   * @param {?} info
   * @param {?} r2
   * @return {undefined}
   */
  self.addToStoreList = function(info, r2) {
    /** @type {string} */
    var path = "（当前库存：" + info.storedNumber + ")";
    if (window.cordova && window.cordova.plugins) {
      /** @type {string} */
      var x = "请输入 " + info.colorName + "-" + info.sizeName + " 的盘点数量" + path;
      /** @type {string} */
      var all = info.goodName + "(" + info.goodsSn + ")";
      UnitTools.showPrompt(x, function(res) {
        if (2 == res.buttonIndex) {
          self.$apply(function() {
            if (1 == self.isNum(res.input1) && res.input1 >= 0) {
              /** @type {number} */
              var qty = parseInt(res.input1);
              var json = {
                colorId : info.colorId,
                sizeId : info.sizeId,
                quantity : qty,
                number : info.storeNumber
              };
              self.realTimeSaveGoods(json, info.goodsSn);
              self.addSkuToGoodList(info, qty);
              self.notStoreGoodsList.splice(r2, 1);
              self.notStoreTotalQuantity--;
              UnitTools.toastShow("添加成功！");
            } else {
              UnitTools.toastShow("添加失败！请输入正确的数量");
            }
          });
        }
      }, all, ["取消", "添加"], 0);
    } else {
      view.show({
        cssClass : "lb-KEY291-popup",
        template : '<input type="number" ng-model="storeOrder.number" class="tc"  placeholder="" autofocus="true">',
        title : "请输入盘点数量" + path,
        scope : self,
        buttons : [{
          text : "取消"
        }, {
          text : "添加",
          type : "button-assertive",
          /**
           * @return {undefined}
           */
          onTap : function() {
            var json = {
              colorId : info.colorId,
              sizeId : info.sizeId,
              quantity : self.storeOrder.number,
              number : info.storeNumber
            };
            self.realTimeSaveGoods(json, info.goodsSn);
            self.addSkuToGoodList(info, self.storeOrder.number);
            self.notStoreGoodsList.splice(r2, 1);
            self.notStoreTotalQuantity--;
            /** @type {number} */
            self.storeOrder.number = 0;
          }
        }]
      });
    }
  };
  /**
   * @param {number} curr
   * @return {undefined}
   */
  self.allStore = function(curr) {
    var attributes = {
      storeOrder : angular.toJson(value),
      goodsName : self.notStoreCondition.searchKey,
      goodsSn : self.notStoreCondition.searchKey,
      barCode : self.notStoreCondition.searchKey,
      skuBarCode : self.notStoreCondition.searchKey,
      sizeName : self.notStoreCondition.sizeName,
      colorName : self.notStoreCondition.colorName,
      storeNumber : curr
    };
    result.postEncode("/KEY208", attributes).success(function(res) {
      if (1 == res.statusCode) {
        self.getStoreList();
        if (self.notStoreQueryModal.isShown()) {
          self.notStoreQueryModal.hide();
        }
        if (res.content) {
          UnitTools.toastShow(res.content);
        }
      } else {
        UnitTools.toastShow(res.content);
      }
    });
  };
  /**
   * @return {undefined}
   */
  self.addAllToStoreList = function() {
    if (window.cordova && window.cordova.plugins) {
      UnitTools.showConfirm("确认将列表中所有未盘点商品添加到盘点单?", function(dataAndEvents) {
        if (2 == dataAndEvents) {
          /** @type {string} */
          var x = "请输入批量盘点数量，如需全库盘点则将未找到的商品盘点为0";
          /** @type {string} */
          var all = "将列表中所有未盘点商品添加到盘点单";
          UnitTools.showPrompt(x, function(res) {
            if (2 == res.buttonIndex) {
              self.$apply(function() {
                if (1 == self.isNum(res.input1) && res.input1 >= 0) {
                  /** @type {number} */
                  var curr = parseInt(res.input1);
                  self.allStore(curr);
                  /** @type {Array} */
                  self.notStoreGoodsList = [];
                  self.clearNotStoreQueryCondition();
                  self.clearQueryCondition();
                  UnitTools.toastShow("添加成功！");
                } else {
                  UnitTools.toastShow("添加失败！请输入正确的数量");
                }
              });
            }
          }, all, ["取消", "添加"], 0);
        }
      }, null, ["取消", "确认"]);
    } else {
      var promise = view.confirm({
        template : "确认将列表中所有未盘点商品添加到盘点单?",
        cancelText : "取消",
        okText : "确认"
      });
      promise.then(function(dataAndEvents) {
        if (dataAndEvents) {
          view.show({
            cssClass : "lb-KEY291-popup",
            template : '<input type="number" ng-model="storeOrder.number" class="tc"  placeholder="" autofocus="true">',
            title : "请输入批量盘点数量",
            scope : self,
            buttons : [{
              text : "取消"
            }, {
              text : "添加",
              type : "button-assertive",
              /**
               * @return {undefined}
               */
              onTap : function() {
                self.allStore(self.storeOrder.number);
                /** @type {Array} */
                self.notStoreGoodsList = [];
                /** @type {number} */
                self.storeOrder.number = 0;
                self.clearNotStoreQueryCondition();
                self.clearQueryCondition();
              }
            }]
          });
        }
      });
    }
  };
  self.updateGood = {
    quantity : 0
  };
  /**
   * @param {string} data
   * @param {?} store
   * @return {undefined}
   */
  self.updateSelectGoodNum = function(data, store) {
    /** @type {string} */
    self.selectedGood.good = data;
    self.updateGood.quantity = data.quantity;
    /** @type {boolean} */
    self.storeOrder.isFocus = true;
    /** @type {string} */
    var MSG_CLOSURE_CUSTOM_COLOR_BUTTON = store.goodName + "(" + store.goodsSn + ")";
    /** @type {string} */
    var subTitle = "请输入 " + data.colorName + "-" + data.sizeName + " 的盘点数量";
    view.show({
      cssClass : "lb-select-goods-popup-goods-store",
      templateUrl : "html/PStorageStockBill/KEY163.html",
      title : MSG_CLOSURE_CUSTOM_COLOR_BUTTON,
      subTitle : subTitle,
      scope : self,
      buttons : [{
        text : "确认",
        type : "button-assertive",
        /**
         * @return {?}
         */
        onTap : function() {
          return UnitTools.isEmpty(self.updateGood.quantity + "") ? false : (data.quantity = self.fixedInputNumber(self.updateGood.quantity), self.setTotalAmount(), self.clearSelectedGood(store.goodsSn), void self.realTimeSaveGoods(data, store.goodsSn));
        }
      }]
    });
  };
  /**
   * @param {?} data
   * @param {number} qty
   * @return {undefined}
   */
  self.addSkuToGoodList = function(data, qty) {
    var copies = {
      colorId : data.colorId,
      sizeId : data.sizeId,
      colorName : data.colorName,
      sizeName : data.sizeName,
      quantity : qty,
      number : data.storedNumber,
      unit : data.unitName
    };
    var reporter = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", data.goodsSn);
    if (reporter) {
      reporter.goods.push(copies);
    } else {
      reporter = {
        goods : [],
        goodName : data.goodName,
        goodsSn : data.goodsSn,
        barCode : data.barCode
      };
      reporter.goods.push(copies);
      self.storeOrder.goodsGroup.push(reporter);
    }
    self.calcTotalAmount();
  };
  self.$on("$destroy", function() {
    self.modal.remove();
    self.storehousePopover.remove();
    if (self.selectedGoodModal) {
      self.selectedGoodModal.remove();
    }
    self.selectedGoodListModal.remove();
    self.goodsAddModal.remove();
    self.storeQueryModal.remove();
    self.notStoreQueryModal.remove();
    self.notStoreQueryConditionModal.remove();
    if (self.scanCodeListModal) {
      self.scanCodeListModal.remove();
    }
  });
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY093.html", function(theTitle) {
    self.selectedGoodModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY147.html", function(theTitle) {
    self.selectedGoodListModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY076.html", function(theTitle) {
    /** @type {number} */
    self.goodsAddModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.openSelectedGoodModal = function() {
    if (0 == self.modalShowFlag) {
      /** @type {number} */
      self.modalShowFlag = 1;
    }
    if (!self.selectedGoodModal.isShown()) {
      self.selectedGoodModal.show();
    }
  };
  /**
   * @return {undefined}
   */
  self.closeSelectedGoodModal = function() {
    self.selectedGoodModal.hide();
  };
  /**
   * @return {undefined}
   */
  self.orderContent.closeGoodsAddModal = function() {
    self.goodsAddModal.hide();
  };
  /**
   * @param {?} timeoutKey
   * @return {undefined}
   */
  self.listItemDelete = function(timeoutKey) {
    delete self.storeOrder.goodsGroup[timeoutKey];
  };
  /**
   * @return {undefined}
   */
  self.orderContent.refreshCacheData = function() {
    if ($templateCache.get("needToAddGoodsFlag") === true) {
      $templateCache.put("needToAddGoodsFlag", false);
      $templateCache.put("refreshGoodColorFlag", false);
      $templateCache.put("refreshGoodSizeFlag", false);
      nv.getAllColorSize().then(function(packs) {
        if (null != packs) {
          self.allColors = packs[0].data.rows;
          self.allSizes = packs[1].data.rows;
        }
      });
    }
  };
  /**
   * @param {Array} drop
   * @param {Function} unused
   * @return {undefined}
   */
  self.orderContent.addGoodsToGroup = function(drop, unused) {
    /** @type {number} */
    var count = 0;
    /** @type {number} */
    var i = 0;
    for (;i < drop.length;i++) {
      if ("" !== drop[i].quantity && void 0 !== drop[i].quantity) {
        count += drop[i].quantity;
      } else {
        drop.splice(i, 1);
        i -= 1;
      }
    }
    if (drop.length > 0) {
      if (!self.storeOrder.goodsGroup) {
        /** @type {Array} */
        self.storeOrder.goodsGroup = [];
      }
      var copies = {
        goods : drop,
        goodName : unused.name,
        goodsSn : unused.goodsSn
      };
      self.storeOrder.goodsGroup.push(copies);
      var which = {
        goodsSn : unused.goodsSn,
        goods : drop
      };
      self.realTimeSaveGoodsList(which);
      self.setTotalAmount();
    } else {
      self.search.goodKey = unused.goodsSn;
    }
    $sanitize(function() {
      self.searchGoods(true);
    });
  };
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  self.deleteGoods = function(opt_attributes) {
    /** @type {number} */
    var i = 0;
    var l = self.storeOrder.goodsGroup.length;
    for (;l > i;i++) {
      if (opt_attributes == self.storeOrder.goodsGroup[i].goodsSn) {
        self.storeOrder.goodsGroup.splice(i, 1);
        break;
      }
    }
    self.setTotalAmount();
    /** @type {number} */
    i = 0;
    for (;i < self.codeArr.length;i++) {
      if (self.codeArr[i].goodsSn == opt_attributes) {
        self.scannedInTotal -= self.codeArr[i].scannedInQuantity;
        self.scannedOutTotal -= self.codeArr[i].scannedOutQuantity;
        self.codeArr.splice(i, 1);
        i--;
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.setTotalAmount = function() {
    /** @type {number} */
    var i = 0;
    /** @type {number} */
    var unlock = 0;
    var cnl = self.storeOrder.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      /** @type {number} */
      var j = 0;
      var spaces = self.storeOrder.goodsGroup[unlock].goods.length;
      for (;spaces > j;j++) {
        self.storeOrder.goodsGroup[unlock].goods[j];
        i = UnitTools.accAdd(i, self.storeOrder.goodsGroup[unlock].goods[j].quantity);
      }
    }
    self.finalTotalQuantity = i - self.totalQuantity + self.finalTotalQuantity;
    self.totalQuantity = i;
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.clearSelectedGood = function(dataAndEvents) {
    if (angular.isObject(self.selectedGood.good)) {
      if (self.selectedGood.good.goodsSn == dataAndEvents) {
        self.selectedGood.good = {};
      }
    }
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      console.log("We got a barcode\nResult: " + result.text + "\nFormat: " + result.format + "\nCancelled: " + result.cancelled);
      if (!result.cancelled) {
        self.$apply(function() {
          self.searchGoodsByBarCode(result.text);
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {undefined}
   */
  self.storeScanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      if (!result.cancelled) {
        self.$apply(function() {
          self.condition.searchKey = result.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {undefined}
   */
  self.notStoreScanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      if (!result.cancelled) {
        self.$apply(function() {
          self.notStoreCondition.searchKey = result.text;
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {?}
   */
  self.addToStoreGoods = function() {
    var a = self.selectedGood;
    if (!a.color) {
      return UnitTools.toastShow("请选择颜色！", "short", "center"), false;
    }
    if (!a.size) {
      return UnitTools.toastShow("请选择尺码！", "short", "center"), false;
    }
    if (UnitTools.isNull(a.quantity) || ("" === a.quantity || a.quantity < 0)) {
      return UnitTools.toastShow("请检查盘点数量！", "short", "center"), self.storeOrder.focusInput = true, false;
    }
    if (!self.storeOrder.goodsGroup) {
      /** @type {Array} */
      self.storeOrder.goodsGroup = [];
    }
    var copies = {
      colorId : a.color.id,
      colorName : a.color.name,
      sizeId : a.size.id,
      sizeName : a.size.name,
      quantity : a.quantity,
      number : self.goodsStoredCount
    };
    var column = self.selectedGood.good.goodsSn;
    var val = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", column);
    if (!val) {
      val = {
        goods : [],
        goodName : self.selectedGood.good.name,
        barCode : self.selectedGood.good.barCode,//条码
        goodsSn : column
      };
      self.storeOrder.goodsGroup.push(val);
    }
    /** @type {Array} */
    var employees = val.goods;
    /** @type {boolean} */
    var d = false;
    /** @type {number} */
    var i = 0;
    /** @type {number} */
    var l = employees.length;
    for (;l > i;i++) {
      var b = employees[i];
      if (b.colorId == a.color.id && b.sizeId == a.size.id) {
        b.quantity += a.quantity;
        /** @type {boolean} */
        d = true;
        break;
      }
    }
    if (!d) {
      val.goods.push(copies);
    }
    self.setTotalAmount();
    UnitTools.toastShow("添加成功！");
  };
  self.$watch("[storeOrder.storeDepot]", function(results) {
    if (results[0] && !UnitTools.isEmpty(self.storeOrder.goodsGroup)) {
      /** @type {Array} */
      var new_val = [];
      /** @type {number} */
      var unlock = 0;
      var cnl = self.storeOrder.goodsGroup.length;
      for (;cnl > unlock;unlock++) {
        var goodsSn = self.storeOrder.goodsGroup[unlock].goodsSn;
        /** @type {number} */
        var j = 0;
        var spaces = self.storeOrder.goodsGroup[unlock].goods.length;
        for (;spaces > j;j++) {
          var block = self.storeOrder.goodsGroup[unlock].goods[j];
          var data = UnitTools.getPropertyObj(block, ["colorId", "sizeId"]);
          new_val.push(UnitTools.union({
            goodsSn : goodsSn
          }, UnitTools.union({
            storehouseId : results[0].id
          }, data)));
        }
      }
      result.postEncode("/KEY204", {
        goodsList : angular.toJson(new_val)
      }).success(function(source) {
        /** @type {number} */
        var unlock = 0;
        var cnl = self.storeOrder.goodsGroup.length;
        for (;cnl > unlock;unlock++) {
          var month = self.storeOrder.goodsGroup[unlock].goodsSn;
          /** @type {number} */
          var j = 0;
          var spaces = self.storeOrder.goodsGroup[unlock].goods.length;
          for (;spaces > j;j++) {
            var info = self.storeOrder.goodsGroup[unlock].goods[j];
            var e = UnitTools.fnCheckGtoreQty(source, "serialNo", results[0].id + "-" + month + "-" + info.colorId + "-" + info.sizeId);
            var status = e ? e.number : 0;
            self.storeOrder.goodsGroup[unlock].goods[j].number = status;
          }
        }
        self.calcTotalAmount();
      });
    }
  }, true);
  /**
   * @param {number} dataAndEvents
   * @return {undefined}
   */
  self.showActionsheet = function(dataAndEvents) {
    var scope = {
      buttons : []
    };
    if (self.storeDraftAccAvailable) {
      scope.buttons.push({
        text : '<i class="icon ion-ios-compose-outline assertive"></i> 草 稿'
      });
    }
    if (self.storeConfirmAccAvailable) {
      scope.buttons.push({
        text : '<i class="icon ion-ios-paper-outline assertive"></i> 盘 点'
      });
    }
    /**
     * @param {number} index
     * @return {?}
     */
    scope.buttonClicked = function(index) {
      return scope.buttons[index].text.indexOf("草 稿") > -1 ? self.saveStore("draft") : scope.buttons[index].text.indexOf("盘 点") > -1 && self.saveStore("commit"), true;
    };
    if (1 == dataAndEvents) {
      if (self.GetOperatorEventLimit("KEY118")) {
        /** @type {string} */
        scope.destructiveText = '<i class="icon ion-ios-trash-outline assertive"></i> 删 除';
        /**
         * @return {?}
         */
        scope.destructiveButtonClicked = function() {
          var promise = view.confirm({
            template : "<div class='tc'>您确认要删除该盘点单?</div>",
            cancelText : "取消",
            okText : "确认"
          });
          return promise.then(function(dataAndEvents) {
            if (dataAndEvents) {
              loading.show(true);
              result.post("/KEY452?orderNo=" + value.orderNo).success(function(r) {
                if (1 == r.statusCode) {
                  view.alert({
                    template : "<div class='tc'>删除成功</div>",
                    okText : "确定"
                  }).then(function() {
                    self.goBack();
                  });
                } else {
                  view.alert({
                    template : "<div class='tc'>" + r.content + "</div>",
                    okText : "确定"
                  });
                }
              }).finally(function() {
                loading.hide();
                $templateCache.put("storeListRefresh", true);
              });
            }
          }), true;
        };
      }
    }
    handler.show(scope);
  };
  loading.show(true);
  /**
   * @param {?} v
   * @return {?}
   修改使用小数
   */
  self.fixedInputNumber = function(v) {
    return UnitTools.getValidNum(v);
  };
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectSize = function(key) {
    var camelKey = self.selectedGood.seletedSizes.indexOf(key);
    if (camelKey > -1) {
      self.selectedGood.seletedSizes.splice(camelKey, 1);
    } else {
      self.selectedGood.seletedSizes.push(key);
    }
  };
  /**
   * @return {undefined}
   */
  self.selectAllSizes = function() {
    if (self.selectedGood.seletedSizes.length == self.currentSizes.length) {
      /** @type {Array} */
      self.selectedGood.seletedSizes = [];
    } else {
      var index;
      for (index in self.currentSizes) {
        if (self.selectedGood.seletedSizes.indexOf(self.currentSizes[index]) < 0) {
          self.selectedGood.seletedSizes.push(self.currentSizes[index]);
        }
      }
    }
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return result.postEncode("/KEY096", opt_attributes);
  };
  /**
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  self.searchGoods = function(dataAndEvents) {
    /** @type {number} */
    pageNum = 1;
    createDom({
      page : pageNum,
      searchKey : self.search.goodKey,
      orderNo : key
    }).success(function(info) {
      self.KEY288 = info.optionList;
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
      if (!dataAndEvents) {
        if (self.search.goodKey) {
          if (1 == self.KEY288.length) {
            if (window.cordova && (window.cordova.plugins && window.cordova.plugins.Keyboard)) {
              cordova.plugins.Keyboard.close();
              window.setTimeout(function() {
                self.KEY264(self.KEY288[0]);
              }, 100);
            } else {
              self.KEY264(self.KEY288[0]);
            }
            self.selectedGoodModal.show();
            /** @type {boolean} */
            self.search.focusGoodsInput = false;
            UnitTools.keyboardHide();
          } else {
            if (self.selectedGoodModal.isShown()) {
              self.selectedGoodModal.hide();
            }
          }
        }
      }
    }).finally(function() {
      that.scrollTop("saleGoodModalCtrlScroll");
    });
  };
  var HOP = ionic.debounce(self.searchGoods, 500);
  /**
   * @param {?} walkers
   * @return {undefined}
   */
  self.searchGoodsByKeyword = function(walkers) {
    HOP(walkers);
  };

  /**
   * 切换单位
   */
  self.selectUnit = function(unit) {
    var pos = self.selectedGood.selectedUnits.indexOf(unit);
    if (pos <= -1) {
      self.selectedGood.selectedUnits.splice(0, 1);
      self.selectedGood.selectedUnits.push(unit);
    }
  };

  /**
   * @param {?} _xhr
   * @param {boolean} dataAndEvents
   * @param {?} fn
   * @return {undefined}
   * 盘点单
   */
  self.KEY264 = function(_xhr, dataAndEvents, fn) {
    //选中商品对象
    self.selectedGood.good = _xhr;

    //辅助单位
    self.currentUnits = [];
    //基本单位
    self.currentUnits.push({
      id : 0,
      unitName : _xhr.unit ? _xhr.unit : "件",
      unitId : 0,
      priceRetail : _xhr.retailPriceArea,
      prepPrice1 : _xhr.tradePrice
    });
    //追加辅助单位
    if (_xhr.goodsUnitPriceList){
      for (var z = 0; z < _xhr.goodsUnitPriceList.length; z++) {
        self.currentUnits.push(_xhr.goodsUnitPriceList[z]);
      }
    }
    //选中的单位
    self.selectedGood.selectedUnits = [];
    if (self.currentUnits.length > 0){
      self.selectedGood.selectedUnits.push(self.currentUnits[0]);
    }

    self.currentColors = UnitTools.idStringToObjectArray(self.allColors, _xhr.colorIds, "id", ",");
    self.currentSizes = UnitTools.idStringToObjectArray(self.allSizes, _xhr.sizeIds, "id", ",");
    /** @type {Array} */
    //选中的颜色
    self.selectedGood.seletedColors = [];
    if (self.currentColors.length > 0) {
      self.selectedGood.seletedColors.push(_xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuColorId) ? UnitTools.fnCheckGtoreQty(self.currentColors, "id", _xhr.skuColorId) : self.currentColors[0]);
    } else {
      /** @type {Array} */
      self.selectedGood.seletedColors = [];
    }
    self.selectedGood.size = self.currentSizes.length > 0 && (_xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuSizeId)) ? UnitTools.fnCheckGtoreQty(self.currentSizes, "id", _xhr.skuSizeId) : self.currentSizes[0];
    //二/三维数组存储数量
    self.selectedGood.good.numArray = [];
    /** @type {Array} */
    self.selectedGood.good.batchNumArray = [];
    var chunk = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", _xhr.goodsSn);
    loading.show();
    fetch(key, self.selectedGood.good.goodsSn, self.storeOrder.storeDepot.val).then(function(packs) {
      loading.hide();
      self.selectedGood.skuStoreGood = packs[0].data;
      self.selectedGood.goodStore = packs[1].data;
      /** @type {number} */
      var b = 0;
      var a = self.currentColors.length;
      var unitsLength = self.currentUnits.length;
      for (;a > b;b++) {
        /** @type {string} */
        self.selectedGood.good.batchNumArray[self.currentColors[b].id] = 0;
        /** @type {Array} */
        self.selectedGood.good.numArray[self.currentColors[b].id] = [];
        /** @type {number} */
        var y = 0;
        var x = self.currentSizes.length;
        for (;x > y;y++) {
          var name = self.currentColors[b].id;
          var type = self.currentSizes[y].id;
          if (chunk) {
            if (unitsLength <= 1){
              //1购物车有该商品--没有辅助单位
              var options = UnitTools.getObjectByObject(self.selectedGood.skuStoreGood, {
                colorId : name,
                sizeId : type
              });
              var message = _(chunk.goods, name, type);
              if ("-" == message) {
                if (angular.isObject(options)) {
                  self.selectedGood.good.numArray[name][type] = options.skuStoreNum;
                  var unit = {
                    colorId : name,
                    sizeId : type,
                    colorName : self.currentColors[b].name,
                    sizeName : self.currentSizes[y].name,
                    quantity : options.skuStoreNum,
                    unit : self.selectedGood.good.unit,
                    number : self.getGoodStoreNum(self.currentColors[b], self.currentSizes[y])
                  };
                  self.upLoadGoodsList.goodsSn = _xhr.goodsSn;
                  chunk.goods.push(unit);
                  /** @type {number} */
                  self.finalTotalQuantity = self.finalTotalQuantity - unit.quantity;
                  self.upLoadGoodsList.goods.push(unit);
                } else {
                  /** @type {string} */
                  self.selectedGood.good.numArray[name][type] = "-";
                }
              } else {
                self.selectedGood.good.numArray[name][type] = message;
              }
            } else {
              //2购物车有该商品--有辅助单位
              self.selectedGood.good.numArray[name][type] = [];
              var m = 0;
              for(; unitsLength > m ; m++){
                var unitId = self.currentUnits[m].unitId;
                var options = UnitTools.getObjectByObject(self.selectedGood.skuStoreGood, {
                  colorId : name,
                  sizeId : type
                });
                var q = equalMultUnit(chunk.goods, name, type,unitId);
                if (q === "-"){
                  if (angular.isObject(options)) {
                    self.selectedGood.good.numArray[name][type][unitId] = options.skuStoreNum;
                    var unit = {
                      colorId : name,
                      sizeId : type,
                      colorName : self.currentColors[b].name,
                      sizeName : self.currentSizes[y].name,
                      quantity : options.skuStoreNum,
                      unit : self.selectedGood.good.unit,
                      unitId : unitId,
                      number : self.getGoodStoreNum(self.currentColors[b], self.currentSizes[y])
                    };
                    self.upLoadGoodsList.goodsSn = _xhr.goodsSn;
                    chunk.goods.push(unit);
                    /** @type {number} */
                    self.finalTotalQuantity = self.finalTotalQuantity - unit.quantity;
                    self.upLoadGoodsList.goods.push(unit);
                  } else {
                    self.selectedGood.good.numArray[name][type][unitId] = "-";
                  }
                } else {
                  self.selectedGood.good.numArray[name][type][unitId] = q;
                }
              }
            }
          } else {
            if (unitsLength <= 1){
              //3购物车没有该商品--没有辅助单位
              var options = UnitTools.getObjectByObject(self.selectedGood.skuStoreGood, {
                colorId : name,
                sizeId : type
              });
              if (angular.isObject(options)) {
                self.selectedGood.good.numArray[name][type] = options.skuStoreNum;
                chunk = {
                  goods : [],
                  goodName : self.selectedGood.good.name,
                  barCode : self.selectedGood.good.barCode,//条码
                  goodsSn : _xhr.goodsSn,
                  imagine : self.selectedGood.good.imagine
                };
                self.storeOrder.goodsGroup.push(chunk);
                var unit = {
                  colorId : name,
                  sizeId : type,
                  colorName : self.currentColors[b].name,
                  sizeName : self.currentSizes[y].name,
                  quantity : options.skuStoreNum,
                  unit : self.selectedGood.good.unit,
                  number : self.getGoodStoreNum(self.currentColors[b], self.currentSizes[y])
                };
                self.selectedGood.good.numArray[name][type] = unit.quantity;
                self.upLoadGoodsList.goodsSn = _xhr.goodsSn;
                chunk.goods.push(unit);
                /** @type {number} */
                self.finalTotalQuantity = self.finalTotalQuantity - unit.quantity;
                self.upLoadGoodsList.goods.push(unit);
              } else {
                /** @type {string} */
                self.selectedGood.good.numArray[name][type] = "-";
              }
            } else {
              //4购物车没有该商品--有辅助单位
              self.selectedGood.good.numArray[name][type] = [];
              var m = 0;
              for(; unitsLength > m ; m++) {
                var unitId = self.currentUnits[m].unitId;
                var options = UnitTools.getObjectByObject(self.selectedGood.skuStoreGood, {
                  colorId: name,
                  sizeId: type
                });
                if (angular.isObject(options)) {
                  self.selectedGood.good.numArray[name][type][unitId] = options.skuStoreNum;
                  chunk = {
                    goods : [],
                    goodName : self.selectedGood.good.name,
                    barCode : self.selectedGood.good.barCode,//条码
                    goodsSn : _xhr.goodsSn,
                    imagine : self.selectedGood.good.imagine
                  };
                  self.storeOrder.goodsGroup.push(chunk);
                  var unit = {
                    colorId : name,
                    sizeId : type,
                    colorName : self.currentColors[b].name,
                    sizeName : self.currentSizes[y].name,
                    quantity : options.skuStoreNum,
                    unit : self.selectedGood.good.unit,
                    unitId : unitId,
                    number : self.getGoodStoreNum(self.currentColors[b], self.currentSizes[y])
                  };
                  self.selectedGood.good.numArray[name][type][unitId] = unit.quantity;
                  self.upLoadGoodsList.goodsSn = _xhr.goodsSn;
                  chunk.goods.push(unit);
                  /** @type {number} */
                  self.finalTotalQuantity = self.finalTotalQuantity - unit.quantity;
                  self.upLoadGoodsList.goods.push(unit);
                } else {
                  /** @type {string} */
                  self.selectedGood.good.numArray[name][type][unitId] = "-";
                }
              }
            }

          }
        }
      }
      if (dataAndEvents) {
        self.addToGoodsGroup(self.selectedGood.seletedColors, self.selectedGood.size, 1, true);
        if ("function" == typeof fn) {
          fn();
        }
      }
      self.calcTotalAmount();
    }, function() {
      /** @type {number} */
      var i = 0;
      var l = self.currentColors.length;
      for (;l > i;i++) {
        /** @type {string} */
        self.selectedGood.good.batchNumArray[self.currentColors[i].id] = "-";
        /** @type {Array} */
        self.selectedGood.good.numArray[self.currentColors[i].id] = [];
        /** @type {number} */
        var b = 0;
        var a = self.currentSizes.length;
        for (;a > b;b++) {
          if (chunk) {
            var name = self.currentColors[i].id;
            var type = self.currentSizes[b].id;
            var val = _(chunk.goods, name, type);
            self.selectedGood.good.numArray[self.currentColors[i].id][self.currentSizes[b].id] = "-" == val ? "-" : val;
          } else {
            /** @type {string} */
            self.selectedGood.good.numArray[self.currentColors[i].id][self.currentSizes[b].id] = "-";
          }
        }
      }
      loading.hide();
      self.selectedGood.goodStore = void 0;
      UnitTools.toastShow("获取商品库存信息失败！");
    });
    that.resize("selectGoodForOrderMulScroll");
  };
  /**
   * @param {Element} model
   * @param {?} spy
   * @return {?}
   */
  self.getGoodStoreNum = function(model, spy) {
    var ex = UnitTools.fnCheckGtoreQty(self.selectedGood.goodStore, "serialNo", self.storeOrder.storeDepot.val + "-" + self.selectedGood.good.id + "-" + spy.id + "-" + model.id);
    if (self.selectedGood.selectedUnits[0].unitRate){
      var unitRate = self.selectedGood.selectedUnits[0].unitRate;
      return ex ? 0 == ex.number ? 0 : Math.floor(ex.number / unitRate).toFixed(1) : 0;
    } else {
      return ex ? 0 == ex.number ? 0 : ex.number : 0;
    }
  };
  /**
   * @param {string} body
   * @return {?}
   */
  self.getGoodsCount = function(body) {
    /** @type {number} */
    var params = 0;
    /** @type {boolean} */
    var parens = false;
    var data = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", body);
    if (data) {
      var items = data.goods;
      /** @type {number} */
      var i = 0;
      var ilen = items.length;
      for (;ilen > i;i++) {
        params += items[i].quantity;
        /** @type {boolean} */
        parens = true;
      }
    }
    return params ? params : parens ? 0 : "";
  };
  /**
   * @param {string} body
   * @return {?}
   */
  self.getGoodsSkuCount = function(body) {
    /** @type {number} */
    var m1 = 0;
    /** @type {number} */
    var c = 0;
    var data = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", body);
    if (data) {
      var items = data.goods;
      m1 = items.length;
      /** @type {number} */
      var i = 0;
      var ilen = items.length;
      for (;ilen > i;i++) {
        c += items[i].quantity;
      }
    }
    return m1 ? m1 + " 款 " + c + " 件" : "";
  };
  /**
   * @param {?} results
   * @param {?} str
   * @param {number} dataAndEvents
   * @param {boolean} deepDataAndEvents
   * @return {undefined}
   */
  self.addToGoodsGroup = function(results, str, dataAndEvents, deepDataAndEvents,units) {
    if (null != results && (0 != results.length && (null != str && !(deepDataAndEvents && (0 > dataAndEvents && ("-" == self.selectedGood.good.numArray[results[0].id][str.id] || self.selectedGood.good.numArray[results[0].id][str.id] < 0)))))) {
      var expectedOutput = self.selectedGood.good.goodsSn;

      //使用辅助单位的标志
      var useAidUnitFlag = false;
      if (units[0].unitId !== 0){
        useAidUnitFlag = true;
      }

      var range = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", expectedOutput);
      self.upLoadGoodsList.goodsSn = expectedOutput;
      if (!range) {
        range = {
          goods : [],
          goodName : self.selectedGood.good.name,
          barCode : self.selectedGood.good.barCode,//条码
          goodsSn : expectedOutput,
          imagine : self.selectedGood.good.imagine
        };
        self.storeOrder.goodsGroup.push(range);
      }
      /** @type {number} */
      var i = 0;
      var l = results.length;
      for (;l > i;i++) {
        var d = {
          colorId : results[i].id,
          sizeId : str.id,
          colorName : results[i].name,
          sizeName : str.name,
          quantity : dataAndEvents,
          unit : units[0].unitName,
          unitId : units[0].unitId,
          number : self.getGoodStoreNum(results[i], str)
        };
        /** @type {Array} */
        var a = range.goods;
        /** @type {boolean} */
        var g = false;
        /** @type {number} */
        var idx = 0;
        /** @type {number} */
        var al = a.length;
        for (;al > idx;idx++) {
          var data = a[idx];
          if (data.colorId == d.colorId && data.sizeId == d.sizeId && data.unitId == d.unitId) {
            if (deepDataAndEvents) {
              if (data.quantity + d.quantity < 0) {
                /** @type {string} */
                if (self.currentUnits.length <= 1){
                  self.selectedGood.good.numArray[results[i].id][str.id] = "-";
                } else {
                  self.selectedGood.good.numArray[results[i].id][str.id][d.unitId] = "-";
                }
                [{
                  goodsSn : expectedOutput,
                  colorId : data.colorId,
                  sizeId : data.sizeId,
                  number : self.fixedInputNumber(data.quantity),
                  beforeNumber : data.number
                }];
                range.goods.splice(idx, 1);
                if (0 == range.goods.length) {
                  UnitTools.removeByKey(self.storeOrder.goodsGroup, "goodsSn", expectedOutput);
                }
                /** @type {number} */
                var j = 0;
                var spaces = self.upLoadGoodsList.goods.length;
                for (;spaces > j;j++) {
                  if (self.upLoadGoodsList.goods[j].colorId == results[i].id && self.upLoadGoodsList.goods[j].sizeId == str.id) {
                    self.uploadDelGoodsList.goodsSn = expectedOutput;
                    self.uploadDelGoodsList.goods.push(self.upLoadGoodsList.goods[j]);
                    self.upLoadGoodsList.goods.splice(j, 1);
                    break;
                  }
                }
                break;
              }
              data.quantity += d.quantity;
              if (self.currentUnits.length <= 1){
                self.selectedGood.good.numArray[results[i].id][str.id] = data.quantity;
              } else {
                self.selectedGood.good.numArray[results[i].id][str.id][d.unitId] = data.quantity;
              }
            } else {
              data.quantity = d.quantity;
              if (self.currentUnits.length <= 1){
                self.selectedGood.good.numArray[results[i].id][str.id] = data.quantity;
              } else {
                self.selectedGood.good.numArray[results[i].id][str.id][d.unitId] = data.quantity;
              }
            }

            var $scope = "";
            if (self.currentUnits.length <= 1){
              $scope = UnitTools.getObjectByObject(self.upLoadGoodsList.goods, {
                colorId : d.colorId,
                sizeId : d.sizeId
              });
            } else {
              $scope = UnitTools.getObjectByObjectMultUnit(self.upLoadGoodsList.goods, {
                colorId : d.colorId,
                sizeId : d.sizeId,
                unitId : units[0].unitId
              });
            }
            if ($scope) {
              $scope.quantity = data.quantity;
            } else {
              self.upLoadGoodsList.goods.push(data);
            }
            /** @type {boolean} */
            g = true;
            break;
          }
        }
        if (!g) {
          if (d.quantity <= -1) {
            /** @type {string} */
            if (self.currentUnits.length <= 1){
              self.selectedGood.good.numArray[results[i].id][str.id] = "-";
            } else {
              self.selectedGood.good.numArray[results[i].id][str.id][units[0].unitId] = "-";
            }
          } else {
            if (self.currentUnits.length <= 1){
              self.selectedGood.good.numArray[results[i].id][str.id] = d.quantity;
            } else {
              self.selectedGood.good.numArray[results[i].id][str.id][units[0].unitId] = d.quantity;
            }
            range.goods.push(d);
            self.upLoadGoodsList.goods.push(d);
          }
        }
      }
      if (0 == range.goods.length) {
        UnitTools.removeByKey(self.storeOrder.goodsGroup, "goodsSn", expectedOutput);
      }
      self.setTotalAmount();
    }
  };
  /**
   * @param {Array} values
   * @param {number} dataAndEvents
   * @param {boolean} deepDataAndEvents
   * @return {?}
   */
  self.addToGoodsGroupBatch = function(values, dataAndEvents, deepDataAndEvents) {
    if (null != values && (0 != values.length && !(deepDataAndEvents && (0 > dataAndEvents && (self.selectedGood.good.batchNumArray[values[0].id] <= 0 || "-" == self.selectedGood.good.batchNumArray[values[0].id]))))) {
      var expectedOutput = self.selectedGood.good.goodsSn;
      var transaction = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", expectedOutput);
      self.upLoadGoodsList.goodsSn = expectedOutput;
      if (!transaction) {
        transaction = {
          goods : [],
          goodName : self.selectedGood.good.name,
          barCode : self.selectedGood.good.barCode,//条码
          goodsSn : expectedOutput,
          imagine : self.selectedGood.good.imagine
        };
        self.storeOrder.goodsGroup.push(transaction);
      }
      /** @type {number} */
      var a = 0;
      var valuesLen = values.length;
      for (;valuesLen > a;a++) {
        /** @type {number} */
        var index = 0;
        var startOffset = self.currentSizes.length;
        for (;startOffset > index;index++) {
          var prop = self.currentSizes[index];
          var item = {
            colorId : values[a].id,
            sizeId : prop.id,
            colorName : values[a].name,
            sizeName : prop.name,
            quantity : dataAndEvents,
            unit : self.selectedGood.good.unit,
            number : self.getGoodStoreNum(values[a], prop)
          };
          /** @type {Array} */
          var nodes = transaction.goods;
          /** @type {boolean} */
          var p = false;
          /** @type {number} */
          var i = 0;
          /** @type {number} */
          var len = nodes.length;
          for (;len > i;i++) {
            var current = nodes[i];
            if (current.colorId == item.colorId && current.sizeId == item.sizeId) {
              if (deepDataAndEvents) {
                if (current.quantity + item.quantity < 0) {
                  return self.selectedGood.good.batchNumArray[values[a].id] = 0, false;
                }
                current.quantity += item.quantity;
                self.selectedGood.good.numArray[values[a].id][prop.id] = current.quantity;
              } else {
                current.quantity = item.quantity;
                self.selectedGood.good.numArray[values[a].id][prop.id] = current.quantity;
              }
              var options = UnitTools.getObjectByObject(self.upLoadGoodsList.goods, {
                colorId : item.colorId,
                sizeId : item.sizeId
              });
              if (options) {
                options.quantity = current.quantity;
              } else {
                self.upLoadGoodsList.goods.push(current);
              }
              /** @type {boolean} */
              p = true;
              break;
            }
          }
          if (!p) {
            if (item.quantity >= 0) {
              self.selectedGood.good.numArray[values[a].id][prop.id] = deepDataAndEvents ? 1 : dataAndEvents;
              transaction.goods.push(item);
              self.upLoadGoodsList.goods.push(item);
            }
          }
        }
      }
      if (0 == transaction.goods.length) {
        UnitTools.removeByKey(self.storeOrder.goodsGroup, "goodsSn", expectedOutput);
      }
      if ("-" == self.selectedGood.good.batchNumArray[values[0].id]) {
        /** @type {number} */
        self.selectedGood.good.batchNumArray[values[0].id] = 0;
      } else {
        0;
      }
      self.selectedGood.good.batchNumArray[values[0].id] = UnitTools.accAdd(self.selectedGood.good.batchNumArray[values[0].id], dataAndEvents);
      self.setTotalAmount();
    }
  };
  /**
   * @param {Element} def
   * @return {?}
   */
  self.getColorNumber = function(def) {
    var b = self.selectedGood.good.goodsSn;
    var max = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", b);
    /** @type {number} */
    var message = 0;
    /** @type {boolean} */
    var expected = false;
    if (max) {
      var employees = max.goods;
      /** @type {number} */
      var i = 0;
      var l = employees.length;
      for (;l > i;i++) {
        var data = employees[i];
        if (data.colorId == def.id) {
          message += data.quantity;
          /** @type {boolean} */
          expected = true;
        }
      }
    }
    return message ? message : expected ? 0 : "";
  };
  /**
   * @param {Array} left
   * @param {?} s
   * @param {?} keepData
   * @return {?}
   */
  var _ = function(left, s, keepData) {
    /** @type {number} */
    var i = 0;
    var a = left.length;
    for (;a > i;i++) {
      if (left[i].colorId == s && left[i].sizeId == keepData) {
        return left[i].quantity;
      }
    }
    return "-";
  };

  var equalMultUnit = function(goods, colorId, sizeId,unitId) {
    /** @type {number} */
    var i = 0;
    var l = goods.length;
    for (;l > i;i++) {
      if (goods[i].colorId == colorId && goods[i].sizeId == sizeId && goods[i].unitId == unitId) {
        return goods[i].quantity;
      }
    }
    return 0;
  };
  /**
   * @return {undefined}
   */
  self.calcTotalAmount = function() {
    /** @type {number} */
    var i = 0;
    i = self.getGroupGoodsNum();
    self.finalTotalQuantity = i - self.totalQuantity + self.finalTotalQuantity;
    self.totalQuantity = i;
  };
  /**
   * @param {(Object|string)} dataAndEvents
   * @param {string} b
   * @return {undefined}
   */
  self.deletePurchaseGoods = function(dataAndEvents, b) {
    /** @type {boolean} */
    var r = false;
    /** @type {number} */
    var i = 0;
    var l = self.storeOrder.goodsGroup.length;
    for (;l > i;i++) {
      if (dataAndEvents == self.storeOrder.goodsGroup[i].goodsSn) {
        var a;
        for (a in self.storeOrder.goodsGroup[i].goods) {
          if (a == b) {
            if (self.codeArr.length > 0) {
              var todayMonth = self.storeOrder.goodsGroup[i].goods[a].colorId;
              var todayYear = self.storeOrder.goodsGroup[i].goods[a].sizeId;
            }
            self.deleteTempSku(self.storeOrder.goodsGroup[i].goods[a], self.storeOrder.goodsGroup[i].goodsSn);
            self.storeOrder.goodsGroup[i].goods.splice(a, 1);
            break;
          }
        }
        if (0 === self.storeOrder.goodsGroup[i].goods.length) {
          self.storeOrder.goodsGroup.splice(i, 1);
          /** @type {boolean} */
          r = true;
        }
        break;
      }
    }
    if (self.isGoodsGroupNull()) {
      /** @type {boolean} */
      self.storeOrder.showDelete = false;
    }
    self.calcTotalAmount();
    /** @type {number} */
    i = 0;
    for (;i < self.codeArr.length;i++) {
      if (self.codeArr[i].goodsSn == dataAndEvents && (self.codeArr[i].good.colorId == todayMonth && self.codeArr[i].good.sizeId == todayYear)) {
        self.scannedInTotal -= self.codeArr[i].scannedInQuantity;
        self.scannedOutTotal -= self.codeArr[i].scannedOutQuantity;
        self.codeArr.splice(i, 1);
        break;
      }
    }
  };
  /**
   * @param {string} keepData
   * @return {undefined}
   */
  self.searchGoodsByBarCode = function(keepData) {
    if (keepData) {
      nv.getGoodsByBarCode(keepData).then(function(data) {
        if ((data) && (data.id !== "")) {
          if (self.selectedGood.good != null && angular.isObject(self.selectedGood.good) && self.selectedGood.good.goodsSn == data.goodsSn) {
            if (self.currentColors.length > 0) {
              if (data.skuCount && (1 === data.skuCount && data.skuColorId)) {
                /** @type {Array} */
                self.selectedGood.seletedColors = [];
                self.selectedGood.seletedColors[0] = UnitTools.fnCheckGtoreQty(self.currentColors, "id", data.skuColorId);
              } else {
                /** @type {Array} */
                self.selectedGood.seletedColors = [];
                self.selectedGood.seletedColors[0] = self.currentColors[0];
              }
            } else {
              /** @type {Array} */
              self.selectedGood.seletedColors = [];
            }
            self.selectedGood.size = self.currentSizes.length > 0 ? data.skuCount && (1 === data.skuCount && data.skuSizeId) ? UnitTools.fnCheckGtoreQty(self.currentSizes, "id", data.skuSizeId) : self.currentSizes[0] : void 0;
            self.addToGoodsGroup(self.selectedGood.seletedColors, self.selectedGood.size, 1, true);
          } else {
            /** @type {Array} */
            self.KEY288 = [];
            self.KEY288[0] = data;
            /** @type {boolean} */
            self.loadMoreBtn = false;
            self.KEY264(data, true);
            /** @type {string} */
            self.search.goodKey = keepData;
          }
          //self.openSelectedGoodModal();//这行会扫码成功后还弹出编辑数量框
        } else {
          UnitTools.toastShow("找不到 " + keepData + " 的商品");
          view.alert({
            template : "<div class='tc'>"+"找不到" + keepData + "的商品"+"</div>",
            okText : "确定"
          });
        }
      }, function() {
        UnitTools.toastShow("获取商品信息失败");
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    createDom({
      page : ++pageNum,
      searchKey : self.search.goodKey,
      orderNo : key
    }).success(function(info) {
      self.KEY288 = self.KEY288.concat(info.optionList);
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      that.resize("saleGoodModalCtrlScroll");
    });
  };
  self.$on("modal.hidden", function() {
    if (self.upLoadGoodsList.goods.length > 0 && self.upLoadGoodsList.goodsSn.length > 0 || self.uploadDelGoodsList.goods.length > 0 && self.uploadDelGoodsList.goodsSn.length > 0) {
      /** @type {number} */
      var i = 0;
      for (;i < self.uploadDelGoodsList.goods.length;i++) {
        /** @type {number} */
        var conditionIndex = 0;
        for (;conditionIndex < self.upLoadGoodsList.goods.length;conditionIndex++) {
          if (self.uploadDelGoodsList.goods[i].sizeId == self.upLoadGoodsList.goods[conditionIndex].sizeId && self.uploadDelGoodsList.goods[i].colorId == self.upLoadGoodsList.goods[conditionIndex].colorId) {
            self.uploadDelGoodsList.goods.splice(i, 1);
            break;
          }
        }
      }
      self.realTimeSaveGoodsList(self.upLoadGoodsList, self.uploadDelGoodsList);
      self.upLoadGoodsList = {
        goodsSn : "",
        goods : []
      };
      self.uploadDelGoodsList = {
        goodsSn : "",
        goods : []
      };
    }
  });
  /** @type {Array} */
  self.codeArr = [];
  var config = {
    codeArr : []
  };
  /** @type {number} */
  self.scannedInTotal = 0;
  /** @type {number} */
  self.scannedOutTotal = 0;
  /** @type {number} */
  self.lastGoodIndex = -1;
  /**
   * @param {Object} data
   * @param {Function} fn
   * @return {undefined}
   */
  self.addToGoodsGroupForScan = function(data, fn) {
    /** @type {Object} */
    self.selectedGood.good = data;
    self.currentColors = UnitTools.idStringToObjectArray(self.allColors, data.colorIds, "id", ",");
    self.currentSizes = UnitTools.idStringToObjectArray(self.allSizes, data.sizeIds, "id", ",");
    var mod = UnitTools.fnCheckGtoreQty(self.currentColors, "id", data.skuColorId);
    var category = UnitTools.fnCheckGtoreQty(self.currentSizes, "id", data.skuSizeId);
    /** @type {Array} */
    self.selectedGood.seletedColors = [mod];
    var meta = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", data.goodsSn);
    if (!meta) {
      meta = {
        goods : [],
        goodName : data.name,
        goodsSn : data.goodsSn,
        imagine : data.imagine,
        barCode : data.skuBarCode
      };
      self.storeOrder.goodsGroup.push(meta);
    }
    var copies = UnitTools.getObjectByObject(meta.goods, {
      colorId : data.skuColorId,
      sizeId : data.skuSizeId
    });
    if (copies) {
      copies.quantity++;
      if ("function" == typeof fn) {
        fn();
      }
    } else {
      copies = {
        colorId : mod.id,
        sizeId : category.id,
        colorName : mod.name,
        sizeName : category.name,
        unit : data.unit,
        number : data.skuStoreNumber ? data.skuStoreNumber : 0
      };
      if (self.loadMoreStoreBtn) {
        result.postEncode("/KEY199", {
          goodsSn : data.goodsSn,
          storeOrderNo : key
        }).success(function(info) {
          var match = UnitTools.getObjectByObject(info, {
            colorId : data.skuColorId,
            sizeId : data.skuSizeId
          });
          copies.quantity = angular.isObject(match) ? match.skuStoreNum + 1 : 1;
          meta.goods.push(copies);
          if ("function" == typeof fn) {
            fn();
          }
        });
      } else {
        /** @type {number} */
        copies.quantity = 1;
        meta.goods.push(copies);
        if ("function" == typeof fn) {
          fn();
        }
      }
    }
  };
  /**
   * @param {string} year
   * @return {undefined}
   */
  self.getGoodsGroupStoreNumber = function(year) {
    /** @type {Array} */
    var new_val = [];
    /** @type {number} */
    var unlock = 0;
    var cnl = self.storeOrder.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      var goodsSn = self.storeOrder.goodsGroup[unlock].goodsSn;
      /** @type {number} */
      var j = 0;
      var spaces = self.storeOrder.goodsGroup[unlock].goods.length;
      for (;spaces > j;j++) {
        var block = self.storeOrder.goodsGroup[unlock].goods[j];
        var data = UnitTools.getPropertyObj(block, ["colorId", "sizeId"]);
        new_val.push(UnitTools.union({
          goodsSn : goodsSn
        }, UnitTools.union({
          storehouseId : year
        }, data)));
      }
    }
    result.postEncode("/KEY204", {
      goodsList : angular.toJson(new_val)
    }).success(function(source) {
      /** @type {number} */
      var unlock = 0;
      var cnl = self.storeOrder.goodsGroup.length;
      for (;cnl > unlock;unlock++) {
        var month = self.storeOrder.goodsGroup[unlock].goodsSn;
        /** @type {number} */
        var j = 0;
        var spaces = self.storeOrder.goodsGroup[unlock].goods.length;
        for (;spaces > j;j++) {
          var info = self.storeOrder.goodsGroup[unlock].goods[j];
          var name = UnitTools.fnCheckGtoreQty(source, "serialNo", year + "-" + month + "-" + info.colorId + "-" + info.sizeId);
          var index = name ? name.number : 0;
          self.storeOrder.goodsGroup[unlock].goods[j].number = index;
        }
      }
      self.calcTotalAmount();
    });
  };
  /**
   * @param {string} i
   * @return {?}
   */
  self.scanCallback = function(i) {
    if (self.selectedGoodModal && self.selectedGoodModal.isShown()) {
      return UnitTools.toastShow("请先关闭当前商品选择页面再进行扫码"), false;
    }
    if (self.modal) {
      if (self.modal.isShown()) {
        self.modal.hide();
      }
    }
    if (self.scanCodeListModal) {
      if (!self.scanCodeListModal.isShown()) {
        self.scanCodeListModal.show();
      }
    } else {
      $modal.fromTemplateUrl("scanCodeList.html", function(theTitle) {
        /** @type {number} */
        self.scanCodeListModal = theTitle;
        self.scanCodeListModal.show();
      }, {
        scope : self,
        hardwareBackButtonClose : false,
        animation : "slide-in-up"
      });
    }
    var response = UnitTools.fnCheckGtoreQty(self.codeArr, "code", i);
    if (response && (response.name || response.notFound)) {
      if (response.scannedInQuantity += 1, self.scannedInTotal++, response.name) {
        response.scannedOutQuantity = response.scannedOutQuantity ? response.scannedOutQuantity + 1 : 1;
        self.scannedOutTotal++;
        if (angular.isObject(response.good)) {
          response.good.quantity += 1;
          self.setTotalAmount();
        }
        var position = UnitTools.fnCheckGtoreQty(config.codeArr, "code", response.code);
        if (!position) {
          config.codeArr.push(response);
        }
        if (promote()) {
          exec(config.codeArr);
        }
      }
      /** @type {number} */
      var c = 0;
      for (;c < self.codeArr.length;c++) {
        if (self.codeArr[c].selected) {
          /** @type {boolean} */
          self.codeArr[c].selected = false;
          break;
        }
      }
      /** @type {number} */
      c = 0;
      for (;c < self.codeArr.length;c++) {
        if (i == self.codeArr[c].code) {
          /** @type {boolean} */
          self.codeArr[c].selected = true;
          f("codeClass", c);
          if (response.notFound) {
            navigator.notification.beep(1);
          }
          break;
        }
      }
    } else {
      if (response) {
        response.scannedInQuantity += 1;
        self.scannedInTotal++;
      } else {
        self.codeArr.push({
          code : i,
          scannedInQuantity : 1
        });
        self.scannedInTotal++;
        response = UnitTools.fnCheckGtoreQty(self.codeArr, "code", i);
      }
      nv.getGoodsByBarCode(i, true, self.storeOrder.storeDepot.val).then(function(data) {
        /**
         * @return {undefined}
         */
        function play() {
          if (response) {
            response.scannedOutQuantity = response.scannedOutQuantity ? response.scannedOutQuantity + 1 : 1;
            self.scannedOutTotal++;
            response.name = data.name;
            response.goodsSn = data.goodsSn;
            var cookies = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", data.goodsSn);
            if (cookies && cookies.goods) {
              var value = UnitTools.getObjectByObject(cookies.goods, {
                colorId : data.skuColorId,
                sizeId : data.skuSizeId
              });
              response.good = value;
            }
            if (response.scannedOutQuantity != response.scannedInQuantity) {
              self.scannedOutTotal += response.scannedInQuantity - response.scannedOutQuantity;
              response.good.quantity += response.scannedInQuantity - response.scannedOutQuantity;
              response.scannedOutQuantity = response.scannedInQuantity;
              self.setTotalAmount();
            }
            var position = UnitTools.fnCheckGtoreQty(config.codeArr, "code", response.code);
            if (!position) {
              config.codeArr.push(response);
            }
            if (promote()) {
              exec(config.codeArr);
            }
          }
        }
        if (data && data.skuBarCode == i) {
          self.addToGoodsGroupForScan(data, play);
        } else {
          if (data && data.barCode == i) {
            UnitTools.toastShow("暂不支持非单品条码盘点");
            if (response) {
              /** @type {boolean} */
              response.notFound = true;
            }
          } else {
            UnitTools.toastShow(i + "条码暂无商品信息");
            if (response) {
              /** @type {boolean} */
              response.notFound = true;
            }
          }
        }
        /** @type {number} */
        var c = 0;
        for (;c < self.codeArr.length;c++) {
          if (self.codeArr[c].selected) {
            /** @type {boolean} */
            self.codeArr[c].selected = false;
            break;
          }
        }
        /** @type {number} */
        c = 0;
        for (;c < self.codeArr.length;c++) {
          if (i == self.codeArr[c].code) {
            /** @type {boolean} */
            self.codeArr[c].selected = true;
            f("codeClass", c);
            if (data.skuBarCode != i) {
              navigator.notification.beep(1);
            }
            break;
          }
        }
      }, function() {
        UnitTools.toastShow("从服务器获取数据出现异常");
      });
    }
  };
  /**
   * @return {undefined}
   */
  self.finishScan = function() {
    self.upLoadGoodsList = {
      goodsSn : "",
      goods : []
    };
    exec(config.codeArr);
    self.scanCodeListModal.hide();
  };
  /**
   * @param {Function} dataAndEvents
   * @return {undefined}
   */
  self.getScanerCode = function(dataAndEvents) {
    if (dataAndEvents) {
      UnitTools.toastShow("此功能用于条码枪断开后重新连接");
    }
    $document.getScanerCode(function(callback) {
      if (callback) {
        if ("" != callback) {
          if (self.notStoreQueryModal.isShown()) {
            /** @type {string} */
            self.notStoreCondition.searchKey = callback;
            self.queryNotStoredSkuList();
          } else {
            if (self.storehousePopover.isShown()) {
              self.storehousePopover.hide();
            }
            if (self.notStoreQueryModal.isShown()) {
              self.notStoreQueryModal.hide();
            }
            self.getOrderNo();
            self.scanCallback(callback);
          }
        }
      }
    }, self.bluethoothScaner);
  };
  self.$on("$ionicView.beforeEnter", function() {
    self.getScanerCode();
  });
  self.$on("$ionicView.loaded", function() {
    resolve().then(function(packs) {
      /** @type {Array} */
      self.allDept = [];
      /** @type {number} */
      var dataIndex = 0;
      for (;dataIndex < packs[0].data.length;dataIndex++) {
        if ("1" == packs[0].data[dataIndex].status) {
          self.allDept.push(packs[0].data[dataIndex]);
        }
      }
      if (self.allSizes = packs[1].data.rows, self.allColors = packs[2].data.rows, self.selectedGood.good && angular.extend(self.selectedGood, {
        currentColors : UnitTools.idStringToObjectArray(self.allColors, self.selectedGood.good.colorIds, "id", ","),
        currentSizes : UnitTools.idStringToObjectArray(self.allSizes, self.selectedGood.good.sizeIds, "id", ",")
      }), key) {
        result.post("/KEY206?orderNo=" + key).success(function(event) {
          UnitTools.union(value, event.order);
          /** @type {boolean} */
          self.storeOrder.allStore = 1 == event.order.allStore ? true : false;
          self.status = event.order.status;
          self.storeOrder.remark = event.order.remark;
          /** @type {number} */
          var j = 0;
          var spaces = packs[0].data.length;
          for (;spaces > j;j++) {
            if (event.order.storehouseId == packs[0].data[j].val) {
              self.storeOrder.storeDepot = packs[0].data[j];
              break;
            }
          }
          if (null == self.storeOrder.storeDepot) {
            var obj = {
              text : event.order.storehouseName,
              name : event.order.storehouseName,
              id : event.order.storehouseId,
              val : event.order.storehouseId
            };
            self.storeOrder.storeDepot = obj;
            /** @type {boolean} */
            self.inComstore = false;
          }
          push(task).success(function(options) {
            self.getFinalData(options.rows, event.order.storehouseId, options.sumNumber, true);
            /** @type {boolean} */
            self.loadMoreStoreBtn = options.page < options.total;
          });
          self.searchGoods();
          if (!self.inComstore) {
            UnitTools.toastShow("您只有此单据的查看权限！");
          }
        });
      } else {
        if (c.goods && c.goods.goodsId) {
          $templateCache.put("goodListRefresh", true);
          var v = c.goods.goodsId;
          nv.getGoodsById(v).then(function(response) {
            if (response) {
              var data = response;
              if (data.storehouseId > 0) {
                /** @type {number} */
                var i = 0;
                var l = self.allDept.length;
                for (;l > i;i++) {
                  if (data.storehouseId == self.allDept[i].val) {
                    self.storeOrder.storeDepot = self.allDept[i];
                    break;
                  }
                }
              } else {
                self.storeOrder.storeDepot = self.allDept[0] ? self.allDept[0] : "";
              }
              UnitTools.union(value, {
                orderType : 2,
                storehouseId : self.storeOrder.storeDepot && self.storeOrder.storeDepot.val ? self.storeOrder.storeDepot.val : "",
                remark : self.storeOrder.remark,
                orderNo : key
              });
              result.postEncode("/KEY200", {
                storeOrder : angular.toJson(value)
              }).success(function(res) {
                if (1 == res.statusCode) {
                  value = res.object;
                  key = res.object.orderNo;
                  self.KEY264(data);
                  self.openSelectedGoodModal();
                  self.searchGoods();
                } else {
                  UnitTools.toastShow(res.content);
                }
              });
              loading.hide();
            } else {
              UnitTools.toastShow("找不到相关商品信息");
            }
          }, function() {
            UnitTools.toastShow("获取商品信息失败");
          });
        } else {
          if (c.goods && c.goods.order.orderFrom) {
            result.postEncode("/KEY405", {
              storeOrder : angular.toJson(c.goods.order)
            }).success(function(res) {
              if (1 == res.statusCode) {
                if (res.object.orderNo) {
                  result.post("/KEY206?orderNo=" + res.object.orderNo).success(function(event) {
                    UnitTools.union(value, event.order);
                    /** @type {boolean} */
                    self.storeOrder.allStore = 1 == event.order.allStore ? true : false;
                    self.status = event.order.status;
                    self.storeOrder.remark = event.order.remark;
                    /** @type {number} */
                    var j = 0;
                    var spaces = packs[0].data.length;
                    for (;spaces > j;j++) {
                      if (event.order.storehouseId == packs[0].data[j].val) {
                        self.storeOrder.storeDepot = packs[0].data[j];
                        break;
                      }
                    }
                    if (null == self.storeOrder.storeDepot) {
                      var obj = {
                        text : event.order.storehouseName,
                        name : event.order.storehouseName,
                        id : event.order.storehouseId,
                        val : event.order.storehouseId
                      };
                      self.storeOrder.storeDepot = obj;
                      /** @type {boolean} */
                      self.inComstore = false;
                    }
                    key = event.order.orderNo;
                    push(task).success(function(options) {
                      self.getFinalData(options.rows, event.order.storehouseId, options.sumNumber, true);
                      /** @type {boolean} */
                      self.loadMoreStoreBtn = options.page < options.total;
                    });
                    self.searchGoods();
                    if (!self.inComstore) {
                      UnitTools.toastShow("您只有此单据的查看权限！");
                    }
                    $templateCache.put("storeListRefresh", true);
                  });
                }
              } else {
                UnitTools.toastShow(res.content);
              }
            }).finally(function() {
              loading.hide();
            });
          } else {
            self.storeOrder.storeDepot = self.allDept[0];
            UnitTools.union(value, {
              orderType : 2,
              storehouseId : self.storeOrder.storeDepot && self.storeOrder.storeDepot.val ? self.storeOrder.storeDepot.val : "",
              remark : self.storeOrder.remark,
              orderNo : key
            });
            result.postEncode("/KEY200", {
              storeOrder : angular.toJson(value)
            }).success(function(res) {
              if (1 == res.statusCode) {
                value = res.object;
                key = res.object.orderNo;
                self.searchGoods();
              } else {
                UnitTools.toastShow(res.content);
              }
            });
            loading.hide();
          }
        }
      }
    }).finally(function() {
    });
  });
}]).controller("StoreGoodModalCtrl", ["$scope", "psisServices", "Tools", "lbScrollDelegate", "$state", "lruPersistCache", "$ionicModal", "$ionicPopup", "$http", "ServerConfig", function($scope, $http, store, parent, $state, $templateCache, $modal) {
  /** @type {number} */
  var page = 1;
  /** @type {string} */
  $scope.searchKey = "";
  /** @type {string} */
  $scope.focused_good = "centered_2";
  /**
   * @return {undefined}
   */
  $scope.goToAddGoods = function() {
    $scope.modal.hide();
    store.keyboardHide();
    $templateCache.put("needToAddGoodsFlag", true);
    $state.go("eventmenu.KEY291");
  };
  /**
   * @return {undefined}
   */
  $scope.openGoodImgModal = function() {
    if ($scope.KEY227) {
      $scope.KEY227.show();
    } else {
      $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY227.html", function($location) {
        $scope.KEY227 = $location;
        $scope.KEY227.show();
      }, {
        scope : $scope,
        animation : "slide-in-up"
      });
    }
  };
  /**
   * @param {Element} ignores
   * @param {?} event
   * @return {undefined}
   */
  $scope.showGoodImage = function(ignores, event) {
    if (event) {
      event.stopPropagation();
    }
    if (ignores.imagine) {
      $http.post("/KEY075?goodsId=" + ignores.id).success(function(results) {
        $scope.goodImgs = results.rows;
        $scope.openGoodImgModal();
        if (0 == $scope.goodImgs.length) {
          /** @type {Array} */
          $scope.goodImgs = [{
            url : "img/detailpic_no_s.png"
          }];
        }
      });
    }
  };
  $scope.$on("$destroy", function() {
    if ($scope.KEY227) {
      $scope.KEY227.remove();
    }
  });
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return $http.postEncode("/KEY233", opt_attributes);
  };
  /**
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  $scope.searchGoods = function(dataAndEvents) {
    /** @type {number} */
    page = 1;
    createDom({
      page : page,
      searchKey : $scope.searchKey
    }).success(function(info) {
      $scope.KEY288 = info.optionList;
      /** @type {boolean} */
      $scope.loadMoreBtn = info.currentPage < info.totalPage;
      if (!dataAndEvents) {
        if (1 == $scope.KEY288.length) {
          if (window.cordova && (window.cordova.plugins && window.cordova.plugins.Keyboard)) {
            cordova.plugins.Keyboard.close();
            window.setTimeout(function() {
              $scope.KEY264($scope.KEY288[0]);
            }, 100);
          } else {
            $scope.KEY264($scope.KEY288[0]);
          }
        }
      }
    }).finally(function() {
      parent.scrollTop("storeGoodModalCtrlScroll");
    });
  };
  var HOP = ionic.debounce($scope.searchGoods, 500);
  /**
   * @param {?} walkers
   * @return {undefined}
   */
  $scope.searchGoodsByKeyword = function(walkers) {
    HOP(walkers);
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    createDom({
      page : ++page,
      searchKey : $scope.searchKey
    }).success(function(info) {
      $scope.KEY288 = $scope.KEY288.concat(info.optionList);
      /** @type {boolean} */
      $scope.loadMoreBtn = info.currentPage < info.totalPage;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("saleGoodModalCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.goodComfirmSearch = function() {
    document.getElementById("searchGoodInput").blur();
    $scope.searchGoods();
  };
  /**
   * @return {undefined}
   */
  $scope.focusSearchInput = function() {
    document.getElementById("searchGoodInput").focus();
  };
  /**
   * @return {undefined}
   */
  $scope.clearSearch = function() {
    /** @type {string} */
    $scope.searchKey = "";
    /** @type {string} */
    $scope.focused_good = "centered_2";
    $scope.goodComfirmSearch();
  };
  /**
   * @return {undefined}
   */
  $scope.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(data) {
      if (!data.cancelled) {
        $scope.$apply(function() {
          $scope.searchKey = data.text;
          $scope.searchGoods();
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      store.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @param {?} _xhr
   * @return {undefined}
   */
  $scope.KEY264 = function(_xhr) {
    $scope.selectedGood.good = _xhr;
    angular.extend($scope.selectedGood, {
      currentColors : store.idStringToObjectArray($scope.allColors, _xhr.colorIds, "id", ","),
      currentSizes : store.idStringToObjectArray($scope.allSizes, _xhr.sizeIds, "id", ",")
    });
    $scope.selectedGood.color = $scope.selectedGood.currentColors.length > 0 ? _xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuColorId) ? store.fnCheckGtoreQty($scope.selectedGood.currentColors, "id", _xhr.skuColorId) : $scope.selectedGood.currentColors[0] : void 0;
    $scope.selectedGood.size = $scope.selectedGood.currentSizes.length > 0 ? _xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuSizeId) ? store.fnCheckGtoreQty($scope.selectedGood.currentSizes, "id", _xhr.skuSizeId) : $scope.selectedGood.currentSizes[0] : void 0;
    if ($state.includes("eventmenu.KEY277")) {
      $scope.selectedGood.quantity = void 0;
    } else {
      if ($state.includes("eventmenu.KEY137")) {
        $scope.selectedGood.transferNumber = void 0;
      } else {
        if ($state.includes("eventmenu.KEY189")) {
          $scope.selectedGood.color = void 0;
          $scope.selectedGood.size = void 0;
        } else {
          if ($state.includes("eventmenu.eshopOrderEdit")) {
            $scope.selectedGood.esGood.goodsMap = _xhr;
            if ($scope.selectedGood.esGood.eshopGoodsMapVO) {
              $scope.selectedGood.esGood.eshopGoodsMapVO.name = _xhr.name;
              $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsSn = _xhr.goodsSn;
              $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsColorName = $scope.findGoodData($scope.selectedGood.currentColors, $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsColorId) ? $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsColorName : "";
              $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsSizeName = $scope.findGoodData($scope.selectedGood.currentSizes, $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsSizeId) ? $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsSizeName : "";
            } else {
              $scope.selectedGood.esGood.eshopGoodsMapVO = {};
              $scope.selectedGood.esGood.eshopGoodsMapVO.name = _xhr.name;
              $scope.selectedGood.esGood.eshopGoodsMapVO.innerGoodsSn = _xhr.goodsSn;
              $scope.selectedGood.esGood.eshopGoodsMapVO.eshopId = $scope.selectedGood.id;
              $scope.selectedGood.esGood.eshopGoodsMapVO.thirdGoodsId = $scope.selectedGood.esGood.thirdGoodsId ? $scope.selectedGood.esGood.thirdGoodsId : "";
              $scope.selectedGood.esGood.eshopGoodsMapVO.thirdGoodsSkuid = $scope.selectedGood.esGood.thirdGoodsSkuid ? $scope.selectedGood.esGood.thirdGoodsSkuid : "";
            }
            $scope.modal.hide();
          }
        }
      }
    }
    if (!$state.includes("eventmenu.KEY137")) {
      $scope.modal.hide();
    }
    store.keyboardHide();
  };
  /**
   * @param {Array} employees
   * @param {(Object|string)} opt_id
   * @return {?}
   */
  $scope.findGoodData = function(employees, opt_id) {
    /** @type {number} */
    var i = 0;
    for (;i < employees.length;i++) {
      if (opt_id == employees[i].id) {
        return true;
      }
    }
    return false;
  };
  /**
   * @return {undefined}
   */
  $scope.closeModal = function() {
    $scope.modal.hide();
    store.keyboardHide();
  };
  if ($state.includes("eventmenu.KEY277") || $state.includes("eventmenu.KEY137")) {
    /**
     * @param {?} dataAndEvents
     * @return {undefined}
     */
    $scope.storeOrder.searchGoodsById = function(dataAndEvents) {
      if (null != dataAndEvents) {
        $http.postEncode("/KEY372", {
          goodsId : dataAndEvents
        }).success(function(dataAndEvents) {
          if (null != dataAndEvents) {
            /** @type {Array} */
            $scope.KEY288 = [];
            /** @type {string} */
            $scope.KEY288[0] = dataAndEvents;
            /** @type {boolean} */
            $scope.loadMoreBtn = false;
            $scope.KEY264($scope.KEY288[0]);
            $scope.searchKey = $scope.KEY288[0].goodsSn;
          }
        });
      }
    };
  }
  $scope.searchGoods();
}]).controller("StockSearchCtrl", ["$scope", "psisServices", "lbScrollDelegate", "lbSpinnerDialog", "$state", "Tools", "$ionicModal", "$ionicPopover", "lruPersistCache", "BTScanerService", "ServerConfig", "$q", "commonDataInterface", "$window", function(self, request, parent, loading, res, $, $modal, FB, $templateCache, $document, obj, $q, callback, $window) {
  /**
   * @param {Object} model
   * @return {undefined}
   */
  function init(model) {
    var data = {
      id : model.id,
      val : model.val,
      text : model.text,
      name : model.name
    };
    callback.saveOrUpdateUserConfig("goodsStoredList.depot", JSON.stringify(data), 3).then(function(event) {
      self.goodsStoredList.depot = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "goodsStoredList.depot");
      if (self.goodsStoredList.depot) {
        $.union(self.goodsStoredList.depot, event.object);
      } else {
        obj.userConfigData.push(event.object);
      }
      /** @type {*} */
      self.goodsStoredList.depotValue = JSON.parse(event.object.configValue);
    }, function() {
      console.log("保存记忆选项不成功！");
    });
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = request.httpCacheGet.get(request.httpCacheGet.ac.CATEGORYLIST);
    var getPromise3 = request.httpCacheGet.get(request.httpCacheGet.ac.STOREHOUSEAVAILABLE);
    var c = request.httpCacheGet.get(request.httpCacheGet.ac.BLANDLIST);
    return $q.all([request1, getPromise3, c]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  /** @type {boolean} */
  self.isLoading = true;
  /** @type {Array} */
  self.items = [];
  self.searchObj = {
    searchKey : ""
  };
  /** @type {string} */
  self.focused = "centered";
  self.queryCondition = {
    page : 1,
    existsNumber : 1,
    operator : 3,
    warnNumber : 0,
    storehouseMerge : true,
    sidx : "",
    sord : ""
  };
  self.filterObj = {
    existsNumber : true
  };
  self.goodsInfo = {};
  self.allCategoryList = {};
  $modal.fromTemplateUrl("listFilter.html", function(theTitle) {
    self.listFilterModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    self.storehousePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    self.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {Object} arg
   * @param {?} event
   * @return {undefined}
   */
  self.hideStorehousePopover = function(arg, event) {
    self.selectStorehouse(arg);
    self.filterAction(arg);
    self.storehousePopover.hide(event);
  };
  $modal.fromTemplateUrl("goodsCategoryQuery.html", function(theTitle) {
    self.goodsCategoryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsBlandQuery.html", function(theTitle) {
    self.goodsBlandModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.listFilterModal.remove();
    self.storehousePopover.remove();
    self.goodsCategoryModal.remove();
    self.goodsBlandModal.remove();
  });
  /**
   * @return {?}
   */
  var Step = function() {
    return request.postEncode("/KEY090", self.queryCondition);
  };
  /**
   * @param {?} opt_attributes
   * @return {undefined}
   */
  self.getStoreHouseSituation = function(opt_attributes) {
    request.post("/KEY091", opt_attributes).success(function(theTitle) {
      self.storeHouseSituation = theTitle;
    });
  };
  /**
   * @return {undefined}
   */
  self.goToStoreHouse = function() {
    if (self.GetOperatorEventLimit("KEY169")) {
      res.go("eventmenu.KEY177");
    }
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    if (self.searchObj.searchKey.length > 0) {
      self.queryCondition.barCode = self.searchObj.searchKey;
      self.queryCondition.goodsSn = self.searchObj.searchKey;
      self.queryCondition.goodsName = self.searchObj.searchKey;
      self.queryCondition.skuBarCode = self.searchObj.searchKey;
      self.queryCondition.skuSn = self.searchObj.searchKey;
    } else {
      delete self.queryCondition.barCode;
      delete self.queryCondition.goodsSn;
      delete self.queryCondition.goodsName;
      delete self.queryCondition.skuBarCode;
      delete self.queryCondition.skuSn;
      loading.show(true);
    }
    self.queryCondition.storehouseId = self.filterObj.saleDepot ? self.filterObj.saleDepot.val : "";
    self.queryCondition.categoryId = self.goodsInfo.category ? $.getCategoryChildIds(self.allCategoryList, self.goodsInfo.category.id) : "";
    self.queryCondition.blandId = self.filterObj.bland ? self.filterObj.bland.id : "";
    /** @type {number} */
    self.queryCondition.existsNumber = self.filterObj.existsNumber ? 1 : 0;
    self.queryCondition.minNumber = self.filterObj.minNumber || 0 === self.filterObj.minNumber ? self.filterObj.minNumber : "";
    self.queryCondition.maxNumber = self.filterObj.maxNumber || 0 === self.filterObj.maxNumber ? self.filterObj.maxNumber : "";
    if (self.filterObj.saleDepot) {
      delete self.queryCondition.storehouseMerge;
    } else {
      /** @type {boolean} */
      self.queryCondition.storehouseMerge = true;
    }
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
      parent.scrollTop("stockSearchCtrlScroll");
    });
    self.getStoreHouseSituation({
      storehouseId : self.queryCondition.storehouseId,
      categoryId : self.queryCondition.categoryId,
      barCode : self.queryCondition.barCode,
      goodsName : self.queryCondition.goodsName,
      goodsSn : self.queryCondition.goodsSn,
      skuBarCode : self.queryCondition.skuBarCode,
      skuSn : self.queryCondition.skuSn,
      storehouseMerge : self.queryCondition.storehouseMerge,
      operator : self.queryCondition.operator,
      blandId : self.queryCondition.blandId,
      existsNumber : self.queryCondition.existsNumber,
      listDataType : 1
    });
  };
  var throttledUpdate = ionic.debounce(self.getList, 500);
  /**
   * @return {undefined}
   */
  self.getGoodsByKeyword = function() {
    throttledUpdate();
  };
  /**
   * @param {string} id
   * @return {undefined}
   */
  self.getSortList = function(id) {
    /** @type {string} */
    self.queryCondition.sord = "" == id ? "" : self.queryCondition.sidx == id && "desc" == self.queryCondition.sord ? "asc" : "desc";
    /** @type {string} */
    self.queryCondition.sidx = id;
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("stockSearchCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.searchObj.searchKey = "";
    /** @type {string} */
    self.focused = "centered";
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.clearFilter = function() {
    /** @type {null} */
    self.goodsInfo.category = null;
    /** @type {null} */
    self.filterObj.bland = null;
    /** @type {string} */
    self.filterObj.minNumber = "";
    /** @type {string} */
    self.filterObj.maxNumber = "";
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      if (!result.cancelled) {
        /** @type {string} */
        self.focused = "text-left";
        self.searchObj.searchKey = result.text;
        self.getList();
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      $.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {undefined}
   */
  self.filterAction = function() {
    self.listFilterModal.hide();
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.goToStockWarnList = function() {
    res.go("eventmenu.KEY207", {
      saleDepot : self.filterObj.saleDepot,
      category : self.goodsInfo.category,
      bland : self.filterObj.bland,
      existsNumber : self.filterObj.existsNumber,
      minNumber : self.filterObj.minNumber,
      maxNumber : self.filterObj.maxNumber,
      searchKey : self.searchObj.searchKey
    });
  };
  /**
   * @param {?} e
   * @return {undefined}
   */
  self.goDetail = function(e) {
    res.go("eventmenu.KEY225", {
      code : e.goodsId,
      goodsSn : e.goodsSn,
      isFromStore : true
    });
  };
  /**
   * @param {Object} event
   * @return {undefined}
   */
  self.selectStorehouse = function(event) {
    if (event) {
      /** @type {Object} */
      self.filterObj.saleDepot = event;
      init(event);
    } else {
      /** @type {null} */
      self.filterObj.saleDepot = null;
      init({
        id : null,
        val : null,
        text : "合并仓库",
        name : "合并仓库"
      });
    }
  };
  loading.show();
  self.$on("$ionicView.loaded", function() {
    /** @type {boolean} */
    self.filterObj.showPrice = "false" == $window.localStorage.goodsStoredShowPrice ? false : true;
    /** @type {boolean} */
    self.filterObj.existsNumber = "false" == $window.localStorage.goodsStoredExistsNumber ? false : true;
    fetch().then(function(packs) {
      if (self.allCategoryList = packs[0].data.rows, self.categoryTree = $.treeForCategory(0, "", false, packs[0].data.rows).children, self.allDept = packs[1].data, self.goodsStoredList = {}, self.goodsStoredList.depot = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "goodsStoredList.depot"), self.goodsStoredList.depot && (self.goodsStoredList.depot.configValue && (self.goodsStoredList.depotValue =
      JSON.parse(self.goodsStoredList.depot.configValue))), self.goodsStoredList.depotValue && self.goodsStoredList.depotValue.id > 0) {
        /** @type {number} */
        var b = 0;
        var a = self.allDept.length;
        for (;a > b;b++) {
          if (self.goodsStoredList.depotValue.val == self.allDept[b].id) {
            self.filterObj.saleDepot = self.allDept[b];
            break;
          }
        }
      }
      self.arrBland = packs[2].data;
      loading.hide();
      self.getList();
    }, function() {
      loading.hide();
    });
  });
  self.$on("$ionicView.beforeLeave", function() {
    /** @type {string} */
    $window.localStorage.goodsStoredShowPrice = 0 == self.filterObj.showPrice ? "false" : "true";
    /** @type {string} */
    $window.localStorage.goodsStoredExistsNumber = 0 == self.filterObj.existsNumber ? "false" : "true";
  });
  self.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("stockSearchRefresh")) {
      self.getList();
      $templateCache.put("stockSearchRefresh", false);
    }
    $document.getScanerCode(function(dataAndEvents) {
      self.searchObj.searchKey = dataAndEvents;
      /** @type {string} */
      self.focused = "text-left";
      self.getList();
    }, self.bluethoothScaner);
  });
}]).controller("StockSearchDetailCtrl", ["$scope", "psisServices", "lbSpinnerDialog", "$stateParams", "$timeout", "$state", "lbScrollDelegate", "Tools", "lruPersistCache", "BTScanerService", "commonDataInterface","$ionicPopup", function(self, $http, loading, deepDataAndEvents, $sanitize, $state, widget, dataAndEvents, $templateCache, $document, values,FB) {
  var events = deepDataAndEvents.goods.goodsSn;
  self.goodsInfo = {};
  /**
   * @param {string} settings
   * @return {?}
   */
  self.parseToInt = function(settings) {
    return settings.number ? parseInt(settings.number) : 0;
  };
  /**
   * @param {string} err
   * @return {?}
   */
  self.filterNull = function(err) {
    return(self.setting.hideNull ? "" !== err.number : true) && (self.setting.hideZero ? "0" !== err.number : true);
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  self.goGoodsDetail = function(term) {
    $state.go("eventmenu.KEY291", {
      id : term
    });
  };
  /**
   * @return {undefined}
   */
  self.scrollContent = function() {
    widget.resize("stockSearchDetailCtrlScroll");
  };
  /**
   * @return {undefined}
   */
  self.toggleGoodsInfo = function() {
    if (void 0 == self.goodsInfo.id) {
      loading.show(true);
      $http.post("/KEY093?goodsSn=" + events).success(function(theTitle) {
        self.goodsInfo = theTitle;
        self.shownGoodsInfo = self.isGoodsInfoShown(self.goodsInfo) ? null : self.goodsInfo;
      }).finally(function() {
        loading.hide();
      });
    } else {
      self.shownGoodsInfo = self.isGoodsInfoShown(self.goodsInfo) ? null : self.goodsInfo;
    }
    self.scrollContent();
  };
  /**
   * @param {?} slide
   * @return {?}
   */
  self.isGoodsInfoShown = function(slide) {
    return self.shownGoodsInfo === slide;
  };
  /**
   * @return {undefined}
   */
  self.KEY189 = function() {
    $state.go("eventmenu.KEY189", {
      goods : deepDataAndEvents.goods
    });
  };
  /**
   * @return {undefined}
   */
  self.goToStoreEdit = function() {
    $state.go("eventmenu.KEY277", {
      timeStamp : dataAndEvents.getTimeStamp(),
      goods : deepDataAndEvents.goods
    });
  };
  /**
   * @return {undefined}
   */
  self.getStoreCountInfo = function() {
    loading.show(true);
    $http.postEncode("/KEY092", {
      goodsSn : events
    }).success(function(data) {
      $sanitize(function() {
        self.setting = {
          hideNull : true,
          mergeStore : true,
          hideZero : true
        };
        self.items = data;
      });
    }).finally(function() {
      loading.hide();
    });
  };
  self.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("stockSearchDetailRefresh")) {
      self.getStoreCountInfo();
      $templateCache.put("stockSearchDetailRefresh", false);
    }
    $document.getScanerCode(function(part) {
      if (part) {
        values.getGoodsByBarCode(part).then(function(elemData) {
          if (elemData && elemData.goodsSn) {
            events = elemData.goodsSn;
            self.getStoreCountInfo();
          } else {
            dataAndEvents.toastShow("找不到指定条码商品信息");
          }
        }, function() {
          dataAndEvents.toastShow("扫码获取商品信息失败");
        });
      } else {
        dataAndEvents.toastShow("找不到 " + part + " 的商品");
        FB.alert({
          template : "<div class='tc'>"+"找不到" + part + "的商品信息"+"</div>",
          okText : "确定"
        });
      }
    }, self.bluethoothScaner);
  });
  self.$on("$ionicView.loaded", function() {
    self.getStoreCountInfo();
  });
}]).controller("StoreHouseListCtrl", ["$scope", "$state", "psisServices", "lruPersistCache", "lbScrollDelegate", "lbSpinnerDialog", function($scope, $state, $cookieStore, $templateCache, parent) {
  /** @type {Array} */
  $scope.items = [];
  /** @type {boolean} */
  $scope.isLoading = true;
  $scope.queryCondition = {
    page : 1,
    status : 1
  };
  /**
   * @return {?}
   */
  var Step = function() {
    /** @type {string} */
    var suiteView = "/KEY182";
    return $cookieStore.postEncode(suiteView, $scope.queryCondition);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    /** @type {number} */
    $scope.queryCondition.page = 1;
    Step().success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      parent.scrollTop("storehouseListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    $scope.queryCondition.page++;
    Step().success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("storehouseListCtrlScroll");
    });
  };
  /**
   * @param {string} term
   * @return {undefined}
   */
  $scope.goStoreHouseEdit = function(term) {
    $state.go("eventmenu.KEY176", {
      id : term
    });
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("refreshStoreHouseList")) {
      $scope.getList();
      $templateCache.put("refreshStoreHouseList", false);
    }
  });
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
  });
}]).controller("StoreHouseEditCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "$ionicPopover", "$ionicModal", "$q", "$ionicPopup", "lbSpinnerDialog", "lruPersistCache", function($scope, session, $, app, dataAndEvents, $modal, deepDataAndEvents, _, loading, $templateCache) {
  var sid = session.id;
  $scope.viewTitle = sid ? $scope.NameConstant.KEY176 : $scope.NameConstant.STOREHOUSEADD;
  /** @type {number} */
  $scope.state = 0;
  $scope.storeHouse = {};
  /** @type {boolean} */
  $scope.storeHouse.statusSetting = false;
  $scope.storeHouseInfo = {
    administrator : {}
  };
  $scope.company = {};
  /** @type {Array} */
  $scope.company.userStoreItem = [];
  $scope.company.storeUser = {};
  $modal.fromTemplateUrl("html/PShopBaseInfo/KEY077.html", function($location) {
    $scope.comStoreModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  /**
   * @param {Object} config
   * @return {undefined}
   */
  $scope.selectComStore = function(config) {
    if ($scope.storeHouse.storeId == config.id) {
      /** @type {null} */
      $scope.storeHouse.storeId = null;
      /** @type {null} */
      $scope.company.storeUser.storeId = null;
    } else {
      $scope.storeHouse.storeId = config.id;
      $scope.company.storeUser.storeId = config.id;
      $scope.storeHouse.storeName = config.storeName;
    }
    $scope.comStoreModal.hide();
  };
  $modal.fromTemplateUrl("storeHouseAdmin.html", function($location) {
    /** @type {number} */
    $scope.storeHouseAdminModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  $scope.$on("$destroy", function() {
    $scope.storeHouseAdminModal.remove();
    $scope.comStoreModal.remove();
  });
  /**
   * @return {?}
   */
  $scope.saveStoreHouse = function() {
    return $scope.storeHouse.storehouseName ? app.isEmpty($scope.storeHouseInfo.administrator) ? (app.toastShow("需要选择仓库负责人", "short", "center"), console.log("需要选择仓库负责人"), false) : $scope.storeHouse.showOrder ? ($scope.storeHouse.administratorId = $scope.storeHouseInfo.administrator.val, $scope.storeHouse.status = 1 == $scope.storeHouse.statusSetting ?
    1 : 0, loading.show(true), void $.post("/KEY180", $scope.storeHouse).success(function(config) {
      /**
       * @return {undefined}
       */
      var done = function() {
        $templateCache.put("refreshStoreHouseList", true);
        $.httpCacheGet.remove($.httpCacheGet.ac.KEY177);
        $.httpCacheGet.remove($.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
        $.httpCacheGet.remove($.httpCacheGet.ac.STOREHOUSEAVAILABLE);
        app.union($scope.storeHouse, config.object);
        /** @type {number} */
        $scope.state = 1;
        $scope.viewTitle = $scope.NameConstant.KEY176;
        $scope.goBack();
      };
      if (1 == config.statusCode) {
        if (window.cordova && window.cordova.plugins) {
          app.showAlert("", done, "保存成功", "确定");
        } else {
          _.alert({
            template : "<div class='tc'>保存成功</div>",
            okText : "确定"
          }).then(done);
        }
      } else {
        if (2 == config.statusCode) {
          if (window.cordova && window.cordova.plugins) {
            app.showAlert("", null, "仓库名称重复", "确定");
          } else {
            _.alert({
              template : "<div class='tc'>仓库名称重复</div>",
              okText : "确定"
            });
          }
        } else {
          $scope.showMessage("保存失败，" + config.content);
        }
      }
    }).finally(function() {
      loading.hide();
    })) : (app.toastShow("请在排序栏输入整数", "short", "center"), console.log("请在排序栏输入整数"), false) : (app.toastShow("需要填写名称！", "short", "center"), console.log("需要填写名称！"), false);
  };
  /**
   * @return {undefined}
   */
  $scope.deleteStoreHouse = function() {
    var promise = _.confirm({
      template : "<div class='tc'>您确认要删除该仓库?</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show(true);
        $.post("/KEY181?id=" + $scope.storeHouse.id).success(function(r) {
          if (1 == r.statusCode) {
            _.alert({
              template : "<div class='tc'>删除成功</div>",
              okText : "确定"
            }).then(function() {
              $scope.goBack();
              $templateCache.put("refreshStoreHouseList", true);
              $.httpCacheGet.remove($.httpCacheGet.ac.KEY177);
              $.httpCacheGet.remove($.httpCacheGet.ac.STOREHOUSELISTBYCOMSTORE);
              $.httpCacheGet.remove($.httpCacheGet.ac.STOREHOUSEAVAILABLE);
            });
          } else {
            _.alert({
              template : "<div class='tc'>" + r.content + "</div>",
              okText : "确定"
            });
          }
        }).finally(function() {
          loading.hide();
        });
      }
    });
  };
  if (sid) {
    /** @type {number} */
    $scope.state = 1;
    loading.show(true);
    $.post("/KEY182?id=" + sid).success(function(res) {
      $scope.storeHouse = res.rows[0];
      /** @type {boolean} */
      $scope.storeHouse.statusSetting = 1 == $scope.storeHouse.status ? true : false;
      $scope.storeHouseInfo.administrator.val = res.rows[0].administratorId;
      $scope.storeHouseInfo.administrator.text = res.rows[0].administratorName;
      $scope.company.storeUser.storeId = $scope.storeHouse.storeId;
    }).finally(function() {
      loading.hide();
    });
  } else {
    /** @type {number} */
    $scope.storeHouse.showOrder = 100;
    /** @type {boolean} */
    $scope.storeHouse.statusSetting = true;
  }
}]).controller("StoreHouseAdminCtrl", ["$scope", "psisServices", "Tools", "lbScrollDelegate", function(data, newCanvas, dataAndEvents, parent) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  data.users = [];
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var callback = function(opt_attributes) {
    return newCanvas.postEncode("/KEY247", opt_attributes);
  };
  /**
   * @return {undefined}
   */
  var loaded = function() {
    /** @type {number} */
    page = 1;
    callback({
      page : page,
      status : 1
    }).success(function(info) {
      data.users = info.optionList;
      /** @type {boolean} */
      data.loadMoreBtn = info.currentPage < info.totalPage;
    }).finally(function() {
      parent.scrollTop("storeHouseAdminCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  data.getMore = function() {
    callback({
      page : ++page
    }).success(function(info) {
      data.users = data.users.concat(info.optionList);
      /** @type {boolean} */
      data.loadMoreBtn = info.currentPage < info.totalPage;
    }).finally(function() {
      parent.resize("storeHouseAdminCtrlScroll");
    });
  };
  /**
   * @param {Object} event
   * @return {undefined}
   */
  data.selectUser = function(event) {
    data.storeHouseInfo.administrator.val = event.val;
    data.storeHouseInfo.administrator.text = event.text;
    data.storeHouseAdminModal.hide();
  };
  loaded({
    page : page
  });
}]).controller("StoreTransferListCtrl", ["$scope", "$state", "psisServices", "$ionicModal", "$ionicPopover", "$cordovaDatePicker", "Tools", "$timeout", "lbSpinnerDialog", "lbScrollDelegate", "lruPersistCache", "BTScanerService", "$window", function($scope, $state, output, $modal, FB, scope, dataAndEvents, deepDataAndEvents, loading, parent, $templateCache, $cookieStore, $window) {
  /** @type {number} */
  var page = 1;
  /** @type {Array} */
  $scope.items = [];
  $scope.searchModel = {
    inStorehouse : {},
    outStorehouse : {},
    createTimeBegin : "",
    createTimeEnd : "",
    orderNo : "",
    status : 12
  };
  var character;
  var chr;
  if ($scope.searchModel.isShowPrintCounts = "false" != $window.localStorage.isShowPrintCounts_Transfer ? true : false, $scope.commonConfig) {
    var n = $scope.commonConfig.orderListDays;
    if (n) {
      character = (new Date).setDate((new Date).getDate() - n);
      /** @type {number} */
      chr = (new Date).getTime();
    }
    var isShowPrintCounts = $scope.commonConfig.isShowPrintCounts;
    if (0 == isShowPrintCounts) {
      /** @type {boolean} */
      $scope.searchModel.isShowPrintCounts = false;
    }
  }
  $scope.searchModel.createTimeBegin = character ? character : "";
  /** @type {(number|string)} */
  $scope.searchModel.createTimeEnd = chr ? chr : "";
  /** @type {boolean} */
  $scope.isLoading = true;
  /**
   * @return {?}
   */
  var init = function() {
    var attributes = {
      inStorehouseId : $scope.searchModel.inStorehouse ? $scope.searchModel.inStorehouse.val ? $scope.searchModel.inStorehouse.val : "" : null,
      outStorehouseId : $scope.searchModel.outStorehouse ? $scope.searchModel.outStorehouse.val ? $scope.searchModel.outStorehouse.val : "" : null,
      orderNo : $scope.searchModel.orderNo,
      status : $scope.searchModel.status,
      page : page
    };
    return $scope.searchModel.createTimeBegin ? attributes.createTimeBegin = dataAndEvents.transferGMTStringtoBJTime(dataAndEvents.getDayBeginStr($scope.searchModel.createTimeBegin)) : delete attributes.createTimeBegin, $scope.searchModel.createTimeEnd ? attributes.createTimeEnd = dataAndEvents.transferGMTStringtoBJTime(dataAndEvents.getOffsetDayBeginStr($scope.searchModel.createTimeEnd, 1)) : delete attributes.createTimeEnd, $scope.searchModel.isShowPrintCounts ?
    attributes.isShowPrintCounts = 1 : delete attributes.isShowPrintCounts, output.postEncode("/KEY216", attributes);
  };
  /**
   * @return {undefined}
   */
  $scope.getList = function() {
    /** @type {number} */
    page = 1;
    loading.show();
    init().success(function(data) {
      $scope.items = data.rows;
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      $scope.isLoading = false;
      loading.hide();
      parent.scrollTop("StoreTransferListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.getMore = function() {
    page++;
    init().success(function(options) {
      $scope.items = $scope.items.concat(options.rows);
      /** @type {boolean} */
      $scope.loadMoreBtn = options.page < options.total;
      $scope.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("StoreTransferListCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  $scope.doRefresh = function() {
    /** @type {number} */
    page = 1;
    loading.show(true);
    init().success(function(data) {
      $scope.items = data.rows;
      $scope.$broadcast("scroll.refreshComplete");
      /** @type {boolean} */
      $scope.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      loading.hide();
    });
  };
  $modal.fromTemplateUrl("storeTransferListQuery.html", function($location) {
    $scope.storeTransferListQueryModal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("inStorehousePopover.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.inStorehousePopover = $location;
  });
  FB.fromTemplateUrl("outStorehousePopover.html", {
    scope : $scope
  }).then(function($location) {
    /** @type {number} */
    $scope.outStorehousePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openInStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.inStorehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openOutStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.outStorehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.clearQueryCondition = function() {
    /** @type {string} */
    $scope.searchModel.orderNo = "";
    /** @type {null} */
    $scope.searchModel.createTimeBegin = null;
    /** @type {null} */
    $scope.searchModel.createTimeEnd = null;
    $scope.searchModel.inStorehouse = {};
    $scope.searchModel.outStorehouse = {};
  };
  $scope.$on("$destroy", function() {
    $scope.storeTransferListQueryModal.remove();
    $scope.inStorehousePopover.remove();
    $scope.outStorehousePopover.remove();
  });
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : $scope.searchModel.createTimeBegin ? new Date($scope.searchModel.createTimeBegin) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.searchModel.createTimeBegin = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : $scope.searchModel.createTimeEnd ? new Date($scope.searchModel.createTimeEnd) : new Date,
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(date1) {
      if (!isNaN(date1.getTime())) {
        $scope.searchModel.createTimeEnd = date1.getTime();
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.createNewOrder = function() {
    $state.go("eventmenu.KEY137", {
      timeStamp : dataAndEvents.getTimeStamp()
    });
  };
  /**
   * @param {?} dataAndEvents
   * @param {string} deepDataAndEvents
   * @return {undefined}
   */
  $scope.goStore = function(dataAndEvents, deepDataAndEvents) {
    if ("1" === deepDataAndEvents) {
      $state.go("eventmenu.KEY137", {
        orderNo : dataAndEvents
      });
    } else {
      $state.go("eventmenu.KEY096", {
        orderNo : dataAndEvents
      });
    }
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("storeTransferListRefresh")) {
      if ($templateCache.get("storeTransferListRefresh") === true) {
        $scope.getList();
        $templateCache.put("storeTransferListRefresh", false);
      }
    }
    $cookieStore.getScanerCode(function(fmt) {
      if (fmt) {
        console.log(fmt);
      }
    }, $scope.bluethoothScaner);
  });
  $scope.$on("$ionicView.beforeLeave", function() {
    /** @type {string} */
    $window.localStorage.isShowPrintCounts_Transfer = $scope.searchModel.isShowPrintCounts ? "true" : "false";
  });
  $scope.$on("$ionicView.loaded", function() {
    $scope.getList();
    output.httpCacheGet.get(output.httpCacheGet.ac.KEY177).success(function($location) {
      $scope.allDept = $location;
    });
  });
}]).controller("StoreTransferDetailCtrl", ["$scope", "$stateParams", "psisServices", "Tools", "lbSpinnerDialog", "$state", "$ionicPopover", "BluetoothPrintService", "$ionicPopup", "lruPersistCache", "BTScanerService", "$ionicModal", function(self, element, $http, unit, loading, ret, FB, targetClass, _, $templateCache, $document, $modal) {
  var className = element.orderNo;
  self.isUserAccAvailable = self.GetOperatorEventLimit("KEY057");
  self.isPrintAvailable = self.GetOperatorEventLimit("KEY052");
  self.isDestroyAvailable = self.GetOperatorEventLimit("KEY031");
  /**
   * @return {undefined}
   */
  self.createNewOrder = function() {
    self.viewReplace();
    ret.go("eventmenu.KEY137", {
      timeStamp : unit.getTimeStamp()
    });
  };
  FB.fromTemplateUrl("copyOperation.html", {
    scope : self
  }).then(function(theTitle) {
    self.copyOperationPopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openCopyOperationPopover = function(expectedNumberOfNonCommentArgs) {
    self.copyOperationPopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.copyForOrder = function(dataAndEvents) {
    self.viewReplace();
    /** @type {string} */
    var rreturn = "eventmenu.KEY284";
    switch(dataAndEvents) {
      case 0:
        /** @type {string} */
        rreturn = "eventmenu.KEY137";
        break;
      case 1:
        /** @type {string} */
        rreturn = "eventmenu.KEY284";
    }
    /** @type {string} */
    self.orderDetail.order.orderFrom = "KEY137";
    self.copyOrder = {
      order : self.orderDetail.order,
      goodsGroup : self.goodsGroup
    };
    ret.go(rreturn, {
      timeStamp : unit.getTimeStamp(),
      copyOrder : self.copyOrder
    });
  };
  /**
   * @return {undefined}
   */
  self.bluetooth = function() {
    targetClass.bluetooth(className, targetClass.orderType.transferOrder);
  };
  FB.fromTemplateUrl("KEY186.html", {
    scope : self
  }).then(function(theTitle) {
    self.orderOperationPopover = theTitle;
  });
  self.$on("$ionicView.beforeEnter", function() {
    $document.getScanerCode(function(fmt) {
      if (fmt) {
        console.log(fmt);
      }
    }, self.bluethoothScaner);
  });
  /**
   * @return {undefined}
   */
  self.openGoodImgModal = function() {
    $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY227.html", function(theTitle) {
      self.KEY227 = theTitle;
      self.KEY227.show();
    }, {
      scope : self,
      animation : "slide-in-up"
    });
  };
  /**
   * @param {?} dataAndEvents
   * @param {?} event
   * @return {undefined}
   */
  self.showGoodImage = function(dataAndEvents, event) {
    if (event) {
      event.stopPropagation();
    }
    if (dataAndEvents.goodsSn) {
      loading.show();
      $http.post("/KEY468?goodsSn=" + dataAndEvents.goodsSn).success(function(reply) {
        self.goodImgs = reply.rows;
        if (self.goodImgs.length > 0) {
          self.openGoodImgModal();
        } else {
          unit.toastShow("此商品暂无图片");
        }
      }).finally(function() {
        loading.hide();
      });
    }
  };
  self.$on("$destroy", function() {
    self.orderOperationPopover.remove();
    if (self.KEY227) {
      self.KEY227.remove();
    }
  });
  /**
   * @return {undefined}
   */
  self.destroyOrder = function() {
    /** @type {string} */
    var API_URL = "/KEY220?orderNo=";
    var promise = _.confirm({
      template : "<div class='tc'>单据撤销将还原调入、调出库存的库存，且撤销后不可恢复，是否确认撤销该单据？</div>",
      cancelText : "取消",
      okText : "确认"
    });
    promise.then(function(dataAndEvents) {
      if (dataAndEvents) {
        loading.show(true);
        $http.post(API_URL + className).success(function(r) {
          if (1 === r.statusCode) {
            /** @type {boolean} */
            self.isDestroy = true;
            /** @type {number} */
            self.orderDetail.order.status = 9;
            unit.toastShow("撤销成功！");
          } else {
            unit.toastShow("撤销异常！");
          }
        }).finally(function() {
          loading.hide();
          $templateCache.put("storeTransferListRefresh", true);
        });
      }
    });
  };
  loading.show(true);
  $http.post("/KEY219?orderNo=" + className).success(function(user) {
    self.orderDetail = user;
    /** @type {boolean} */
    self.isDestroy = 9 === self.orderDetail.order.status;
    /** @type {Array} */
    self.goodsGroup = [];
    /** @type {number} */
    var output = 0;
    user.orderGoods.forEach(function(data) {
      /** @type {boolean} */
      var s = false;
      data.quantity = data.transferNumber;
      /** @type {number} */
      var timeoutKey = 0;
      var cnl = self.goodsGroup.length;
      for (;cnl > timeoutKey;timeoutKey++) {
        var a = self.goodsGroup[timeoutKey].goodsSn;
        if (data.goodsSn == a) {
          /** @type {boolean} */
          s = true;
          self.goodsGroup[timeoutKey].goods.push(unit.getPropertyObj(data, ["colorId", "sizeId", "unit", "quantity", "colorName", "sizeName", "transferNumber", "inBeforeNumber", "outBeforeNumber"]));
        }
      }
      if (!s) {
        var meta = {};
        /** @type {Array} */
        meta.goods = [];
        meta.goods.push(unit.getPropertyObj(data, ["colorId", "sizeId", "unit", "quantity", "colorName", "sizeName", "transferNumber", "inBeforeNumber", "outBeforeNumber"]));
        meta.goodName = data.goodName;
        meta.goodsSn = data.goodsSn;
        meta.goodsId = data.goodId;
        self.goodsGroup.push(meta);
      }
      output = unit.accAdd(output, data.transferNumber);
    });
    self.totalQuantity = output;
  }).finally(function() {
    loading.hide();
  });
}]).controller("StoreTransferEditCtrl", ["$scope", "$stateParams", "$q", "$ionicModal", "$ionicPopup", "$state", "lbSpinnerDialog", "psisServices", "Tools", "$ionicPopover", "$ionicActionSheet", "lruPersistCache", "$ionicPlatform", "commonDataInterface", "BluetoothPrintService", "$cordovaDatePicker", "lbScrollDelegate", "BTScanerService", "ServerConfig", "$timeout", function(self, o, Q, $modal, _, $state, loading, db, UnitTools,
FB, handler, $templateCache, ignoreMethodDoesntExist, dataAndEvents, params, $scope, parent, $document, deepDataAndEvents, $sanitize) {
  /**
   * @param {?} _callback
   * @param {Text} context
   * @param {Text} selector
   * @return {?}
   */
  function then(_callback, context, selector) {
    var imageDfd = Q.defer();
    /** @type {Array} */
    var tests = [];
    if (!UnitTools.isEmpty(context)) {
      var test = db.postEncode("/KEY092", {
        goodsSn : _callback,
        storehouseId : context.val
      });
      tests.push(test);
    }
    if (!UnitTools.isEmpty(selector)) {
      var copies = db.postEncode("/KEY092", {
        goodsSn : _callback,
        storehouseId : selector.val
      });
      tests.push(copies);
    }
    return tests.length > 0 ? Q.all(tests).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }) : imageDfd.reject(), imageDfd.promise;
  }
  /**
   * @param {Object} model
   * @param {Object} prop
   * @return {?}
   */
  function init(model, prop) {
    if (self.storeOrder.inStoreDepot && (self.selectedGood.good && (model && prop))) {
      var ex = UnitTools.fnCheckGtoreQty(self.selectedGood.goodInStore, "serialNo", self.storeOrder.inStoreDepot.val + "-" + self.selectedGood.good.id + "-" + prop.id + "-" + model.id);
      return ex && ex.number ? ex.number : 0;
    }
    return 0;
  }
  /**
   * @param {Object} model
   * @param {Object} prop
   * @return {?}
   */
  function fn(model, prop) {
    if (self.storeOrder.outStoreDepot && (self.selectedGood.good && (model && prop))) {
      var ex = UnitTools.fnCheckGtoreQty(self.selectedGood.goodStore, "serialNo", self.storeOrder.outStoreDepot.val + "-" + self.selectedGood.good.id + "-" + prop.id + "-" + model.id);
      return ex && ex.number ? ex.number : 0;
    }
    return 0;
  }
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = Q.defer();
    var documentChain = db.httpCacheGet.get(db.httpCacheGet.ac.KEY177);
    var promise4 = db.httpCacheGet.get(db.httpCacheGet.ac.ALLSIZELIST);
    var promise3 = db.httpCacheGet.get(db.httpCacheGet.ac.ALLCOLORLIST);
    return Q.all([documentChain, promise4, promise3]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  var id = o.orderNo;
  var value = {
    status : 1
  };
  self.viewTitle = o.copyOrder ? "复制为调拨单" : self.NameConstant.KEY339;
  /** @type {number} */
  self.status = 0;
  self.storeOrder = {
    goodsGroup : [],
    showDelete : false
  };
  self.selectedGood = {};
  /** @type {number} */
  self.totalQuantity = 0;
  self.transferSaleOrder = {
    goodsGroup : {},
    order : {}
  };
  self.isUserAccAvailable = self.GetOperatorEventLimit("KEY095");
  self.storeTransferDraftAccAvailable = self.GetOperatorEventLimit("KEY017");
  self.storeTransferConfirmAccAvailable = self.GetOperatorEventLimit("KEY030");
  self.storeTransferDraftOrConfirmAccAvailable = self.GetOperatorEventLimit("KEY017") || self.GetOperatorEventLimit("KEY030");
  self.saleNegativeStore = deepDataAndEvents.companyConfigData.saleNegativeStore ? deepDataAndEvents.companyConfigData.saleNegativeStore : 1;
  self.search = {
    goodKey : ""
  };
  /** @type {boolean} */
  self.isOpenScroll = true;
  self.orderContent = {};
  /** @type {number} */
  var page = 1;
  /**
   * @return {undefined}
   */
  self.createNewOrder = function() {
    self.viewReplace();
    $state.go("eventmenu.KEY137", {
      orderNo : null,
      timeStamp : UnitTools.getTimeStamp()
    }, {
      reload : true
    });
  };
  /**
   * @param {Object} event
   * @return {undefined}
   */
  self.gobackToListAction = function(event) {
    if (event && (event.stopPropagation() && event.preventDefault()), "eventmenu.KEY137" == $state.current.name) {
      if (0 !== self.status || self.isGoodsGroupNull()) {
        (done || angular.noop)();
        self.goBack();
      } else {
        var promise = _.confirm({
          template : "<div class='tc'>确认要退出调拨?</div>",
          cancelText : "取消",
          okText : "继续退出"
        });
        promise.then(function(dataAndEvents) {
          if (dataAndEvents) {
            (done || angular.noop)();
            self.goBack();
          }
        });
      }
    } else {
      (done || angular.noop)();
      self.goBack();
    }
  };
  var done = ignoreMethodDoesntExist.registerBackButtonAction(function() {
    return self.gobackToListAction(), false;
  }, 140);
  /**
   * @return {?}
   */
  self.isGoodsGroupNull = function() {
    return UnitTools.isEmpty(self.storeOrder.goodsGroup);
  };
  $modal.fromTemplateUrl(self.platformIsPad ? "html/PRetailAndSellBill/KEY036.html" : "html/PRetailAndSellBill/KEY204.html", function(theTitle) {
    self.modal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {?}
   */
  self.modalOpen = function() {
    return UnitTools.isEmpty(self.storeOrder.outStoreDepot) ? window.cordova && window.cordova.plugins ? (UnitTools.showAlert("请选择调出仓库！", null), false) : (_.alert({
      template : "<div class='tc'>请选择调出仓库！</div>",
      okText : "确定"
    }), false) : void self.modal.show();
  };
  FB.fromTemplateUrl("inStorehousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.inStorehousePopover = theTitle;
  });
  FB.fromTemplateUrl("outStorehousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    /** @type {number} */
    self.outStorehousePopover = theTitle;
  });
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY147.html", function(theTitle) {
    self.selectedGoodListModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("html/PRetailAndSellBill/KEY093.html", function(theTitle) {
    self.selectedGoodModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.openSelectedGoodModal = function() {
    if (!self.modal.isShown()) {
      self.modal.show();
    }
    if (!self.selectedGoodModal.isShown()) {
      self.selectedGoodModal.show();
    }
  };
  /**
   * @return {undefined}
   */
  self.closeSelectedGoodModal = function() {
    self.selectedGoodModal.hide();
  };
  $modal.fromTemplateUrl("html/PWareBaseInfo/KEY076.html", function(theTitle) {
    /** @type {number} */
    self.goodsAddModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  /**
   * @return {undefined}
   */
  self.orderContent.closeGoodsAddModal = function() {
    self.goodsAddModal.hide();
  };
  self.$on("$destroy", function() {
    self.modal.remove();
    self.inStorehousePopover.remove();
    self.outStorehousePopover.remove();
    if (self.selectedGoodModal) {
      self.selectedGoodModal.remove();
    }
    self.selectedGoodListModal.remove();
    self.goodsAddModal.remove();
  });
  /**
   * @return {undefined}
   */
  self.orderContent.refreshCacheData = function() {
    if ($templateCache.get("needToAddGoodsFlag") === true) {
      $templateCache.put("needToAddGoodsFlag", false);
      $templateCache.put("refreshGoodColorFlag", false);
      $templateCache.put("refreshGoodSizeFlag", false);
      dataAndEvents.getAllColorSize().then(function(packs) {
        if (null != packs) {
          self.allColors = packs[0].data.rows;
          self.allSizes = packs[1].data.rows;
        }
      });
    }
  };
  /**
   * @param {Array} drop
   * @param {Function} unused
   * @return {undefined}
   */
  self.orderContent.addGoodsToGroup = function(drop, unused) {
    /** @type {number} */
    var count = 0;
    /** @type {number} */
    var i = 0;
    for (;i < drop.length;i++) {
      if ("" !== drop[i].quantity && void 0 !== drop[i].quantity) {
        count += drop[i].quantity;
        /** @type {number} */
        drop[i].inBeforeNumber = 0;
        /** @type {number} */
        drop[i].outBeforeNumber = 0;
      } else {
        drop.splice(i, 1);
        i -= 1;
      }
    }
    if (drop.length > 0) {
      if (!self.storeOrder.goodsGroup) {
        /** @type {Array} */
        self.storeOrder.goodsGroup = [];
      }
      var copies = {
        goods : drop,
        goodName : unused.name,
        goodsSn : unused.goodsSn
      };
      self.storeOrder.goodsGroup.push(copies);
      self.setTotalAmount();
    } else {
      self.search.goodKey = unused.goodsSn;
    }
    $sanitize(function() {
      self.searchGoods(true);
    });
  };
  /**
   * @param {?} v
   * @param {boolean} dataAndEvents
   * @return {?}
   */
  self.fixedInputNumber = function(v, dataAndEvents) {
    return UnitTools.getValidNum(v, dataAndEvents);
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      console.log("We got a barcode\nResult: " + result.text + "\nFormat: " + result.format + "\nCancelled: " + result.cancelled);
      if (!result.cancelled) {
        self.$apply(function() {
          self.searchGoodsByBarCode(result.text);
        });
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      UnitTools.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @param {?} opt_attributes
   * @return {?}
   */
  var createDom = function(opt_attributes) {
    return db.postEncode("/KEY233", opt_attributes);
  };
  /**
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  self.searchGoods = function(dataAndEvents) {
    /** @type {number} */
    page = 1;
    createDom({
      page : page,
      searchKey : self.search.goodKey
    }).success(function(info) {
      self.KEY288 = info.optionList;
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
      if (!dataAndEvents) {
        if (self.search.goodKey) {
          if (1 == self.KEY288.length) {
            if (window.cordova && (window.cordova.plugins && window.cordova.plugins.Keyboard)) {
              cordova.plugins.Keyboard.close();
              window.setTimeout(function() {
                self.KEY264(self.KEY288[0]);
              }, 100);
            } else {
              self.KEY264(self.KEY288[0]);
            }
            self.selectedGoodModal.show();
            /** @type {boolean} */
            self.search.focusGoodsInput = false;
            UnitTools.keyboardHide();
          }
        }
      }
    }).finally(function() {
      parent.scrollTop("saleGoodModalCtrlScroll");
    });
  };
  var HOP = ionic.debounce(self.searchGoods, 500);
  /**
   * @param {?} walkers
   * @return {undefined}
   */
  self.searchGoodsByKeyword = function(walkers) {
    HOP(walkers);
  };
  /**
   * @param {string} keepData
   * @return {undefined}
   */
  self.searchGoodsByBarCode = function(keepData) {
    if (keepData) {
      dataAndEvents.getGoodsByBarCode(keepData).then(function(data) {
        if (data) {
          if (self.selectedGood.good != null && angular.isObject(self.selectedGood.good) && self.selectedGood.good.goodsSn == data.goodsSn) {
            if (self.currentColors.length > 0) {
              if (data.skuCount && (1 === data.skuCount && data.skuColorId)) {
                /** @type {Array} */
                self.selectedGood.seletedColors = [];
                self.selectedGood.seletedColors[0] = UnitTools.fnCheckGtoreQty(self.currentColors, "id", data.skuColorId);
              } else {
                /** @type {Array} */
                self.selectedGood.seletedColors = [];
                self.selectedGood.seletedColors[0] = self.currentColors[0];
              }
            } else {
              /** @type {Array} */
              self.selectedGood.seletedColors = [];
            }
            self.selectedGood.size = self.currentSizes.length > 0 ? data.skuCount && (1 === data.skuCount && data.skuSizeId) ? UnitTools.fnCheckGtoreQty(self.currentSizes, "id", data.skuSizeId) : self.currentSizes[0] : void 0;
            self.addToGoodsGroup(self.selectedGood.seletedColors, self.selectedGood.size, 1, true);
          } else {
            /** @type {Array} */
            self.KEY288 = [];
            self.KEY288[0] = data;
            /** @type {boolean} */
            self.loadMoreBtn = false;
            self.KEY264(data, true);
            /** @type {string} */
            self.search.goodKey = keepData;
          }
          //self.openSelectedGoodModal();//这行会扫码成功后还弹出编辑数量框
        } else {
          UnitTools.toastShow("找不到 " + keepData + " 的商品");
          _.alert({
            template : "<div class='tc'>"+"找不到" + keepData + "的商品信息"+"</div>",
            okText : "确定"
          });
        }
      }, function() {
        UnitTools.toastShow("获取商品信息失败");
      });
    }
  };
  /**
   * @param {?} _xhr
   * @param {boolean} dataAndEvents
   * @return {undefined}
   */
  self.KEY264 = function(_xhr, dataAndEvents) {
    self.selectedGood.good = _xhr;
    self.currentColors = UnitTools.idStringToObjectArray(self.allColors, _xhr.colorIds, "id", ",");
    self.currentSizes = UnitTools.idStringToObjectArray(self.allSizes, _xhr.sizeIds, "id", ",");
    /** @type {Array} */
    self.selectedGood.seletedColors = [];
    /** @type {Array} */
    self.selectedGood.good.numArray = [];
    /** @type {Array} */
    self.selectedGood.good.batchNumArray = [];
    var child = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", _xhr.goodsSn);
    /** @type {number} */
    var count = 0;
    var thumbsCount = self.currentColors.length;
    for (;thumbsCount > count;count++) {
      /** @type {number} */
      self.selectedGood.good.batchNumArray[self.currentColors[count].id] = 0;
      /** @type {Array} */
      self.selectedGood.good.numArray[self.currentColors[count].id] = [];
      /** @type {number} */
      var b = 0;
      var a = self.currentSizes.length;
      for (;a > b;b++) {
        if (child) {
          var key = self.currentColors[count].id;
          var oldconfig = self.currentSizes[b].id;
          var v = equal(child.goods, key, oldconfig);
          self.selectedGood.good.numArray[self.currentColors[count].id][self.currentSizes[b].id] = v > 0 ? v : 0;
        } else {
          /** @type {number} */
          self.selectedGood.good.numArray[self.currentColors[count].id][self.currentSizes[b].id] = 0;
        }
      }
    }
    if (self.currentColors.length > 0) {
      self.selectedGood.seletedColors.push(_xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuColorId) ? UnitTools.fnCheckGtoreQty(self.currentColors, "id", _xhr.skuColorId) : self.currentColors[0]);
    } else {
      /** @type {Array} */
      self.selectedGood.seletedColors = [];
    }
    self.selectedGood.size = self.currentSizes.length > 0 && (_xhr.skuCount && (1 === _xhr.skuCount && _xhr.skuSizeId)) ? UnitTools.fnCheckGtoreQty(self.currentSizes, "id", _xhr.skuSizeId) : self.currentSizes[0];
    loading.show();
    then(_xhr.goodsSn, self.storeOrder.outStoreDepot, self.storeOrder.inStoreDepot).then(function(packs) {
      loading.hide();
      self.selectedGood.goodStore = packs[0].data;
      if (packs.length > 1) {
        self.selectedGood.goodInStore = packs[1].data;
      }
      if (dataAndEvents) {
        self.addToGoodsGroup(self.selectedGood.seletedColors, self.selectedGood.size, 1, true);
      }
    }, function() {
      loading.hide();
      self.selectedGood.goodStore = void 0;
      self.selectedGood.goodInStore = void 0;
      UnitTools.toastShow("获取商品库存信息失败！");
    });
    parent.resize("selectGoodForOrderMulScroll");
  };
  /**
   * @param {Element} model
   * @param {?} spy
   * @return {?}
   */
  self.getGoodStoreNum = function(model, spy) {
    var ex = UnitTools.fnCheckGtoreQty(self.selectedGood.goodStore, "serialNo", self.storeOrder.outStoreDepot.val + "-" + self.selectedGood.good.id + "-" + spy.id + "-" + model.id);
    return ex && ex.number ? ex.number : 0;
  };
  /**
   * @param {string} data
   * @return {?}
   */
  self.isAddToGoodGroup = function(data) {
    var queue = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", data);
    return queue ? true : false;
  };
  /**
   * @param {string} obj
   * @return {?}
   */
  self.getGoodsCount = function(obj) {
    /** @type {number} */
    var count = 0;
    var p = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", obj);
    if (p) {
      var pl = p.goods;
      /** @type {number} */
      var i = 0;
      var l = pl.length;
      for (;l > i;i++) {
        count += pl[i].quantity;
      }
    }
    return count ? count : "";
  };
  /**
   * @param {string} obj
   * @return {?}
   */
  self.getGoodsSkuCount = function(obj) {
    /** @type {number} */
    var x = 0;
    /** @type {number} */
    var y = 0;
    var p = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", obj);
    if (p) {
      var pl = p.goods;
      x = pl.length;
      /** @type {number} */
      var i = 0;
      var l = pl.length;
      for (;l > i;i++) {
        y += pl[i].quantity;
      }
    }
    return x ? x + " 款 " + y + " 件" : "";
  };
  /**
   * @param {?} data
   * @param {Object} i
   * @param {number} dataAndEvents
   * @param {boolean} deepDataAndEvents
   * @return {?}
   */
  self.addToGoodsGroup = function(data, i, dataAndEvents, deepDataAndEvents) {
    if (null != data && (0 != data.length && (null != i && !(deepDataAndEvents && (0 > dataAndEvents && self.selectedGood.good.numArray[data[0].id][i.id] <= 0))))) {
      /** @type {number} */
      var pos = 0;
      /** @type {number} */
      var j = 0;
      var jlen = self.storeOrder.goodsGroup.length;
      for (;jlen > j;j++) {
        pos += self.storeOrder.goodsGroup[j].goods.length;
      }
      var expectedOutput = self.selectedGood.good.goodsSn;
      var m = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", expectedOutput);
      if (m) {
        /** @type {number} */
        var name = 0;
        var i_max = data.length;
        for (;i_max > name;name++) {
          var f = UnitTools.getObjectByObject(m.goods, {
            colorId : data[name].id,
            sizeId : i.id
          });
          if (!f) {
            pos++;
          }
        }
      } else {
        m = {
          goods : [],
          goodName : self.selectedGood.good.name,
          barCode : self.selectedGood.good.barCode,//条码
          goodsSn : expectedOutput,
          imagine : self.selectedGood.good.imagine
        };
        self.storeOrder.goodsGroup.push(m);
        pos++;
      }
      if (pos > self.limitNum) {
        /** @type {string} */
        var speed = "单据中的单品条数已超出" + self.limitNum + "条的限制！";
        return UnitTools.toastShow(speed, "short", "center"), false;
      }
      /** @type {number} */
      name = 0;
      i_max = data.length;
      for (;i_max > name;name++) {
        var item = {
          colorId : data[name].id,
          sizeId : i.id,
          colorName : data[name].name,
          sizeName : i.name,
          quantity : dataAndEvents,
          inBeforeNumber : init(data[name], i),
          outBeforeNumber : fn(data[name], i)
        };

        /** @type {Array} */
        var nodes = m.goods;
        /** @type {boolean} */
        var S = false;
        /** @type {number} */
        j = 0;
        /** @type {number} */
        jlen = nodes.length;
        for (;jlen > j;j++) {
          var current = nodes[j];
          if (current.colorId == item.colorId && current.sizeId == item.sizeId) {
            if (deepDataAndEvents) {
              if (current.quantity + item.quantity < 0) {
                return false;
              }
              current.quantity += item.quantity;
              self.selectedGood.good.numArray[data[name].id][i.id] = current.quantity;
            } else {
              current.quantity = item.quantity;
              self.selectedGood.good.numArray[data[name].id][i.id] = current.quantity;
            }
            if (0 == current.quantity) {
              m.goods.splice(j, 1);
            }
            /** @type {boolean} */
            S = true;
            break;
          }
        }
        if (!S) {
          if (item.quantity > 0) {
            self.selectedGood.good.numArray[data[name].id][i.id] = item.quantity;
            m.goods.push(item);
          }
        }
      }
      if (0 == m.goods.length) {
        UnitTools.removeByKey(self.storeOrder.goodsGroup, "goodsSn", expectedOutput);
      }
      self.setTotalAmount();
    }
  };
  /**
   * @param {Array} models
   * @param {number} dataAndEvents
   * @param {boolean} deepDataAndEvents
   * @return {?}
   */
  self.addToGoodsGroupBatch = function(models, dataAndEvents, deepDataAndEvents) {
    if (null != models && (0 != models.length && !(deepDataAndEvents && (0 > dataAndEvents && self.selectedGood.good.batchNumArray[models[0].id] <= 0)))) {
      /** @type {number} */
      var pos = 0;
      /** @type {number} */
      var i = 0;
      var len = self.storeOrder.goodsGroup.length;
      for (;len > i;i++) {
        pos += self.storeOrder.goodsGroup[i].goods.length;
      }
      var data = self.selectedGood.good.goodsSn;
      var queue = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", data);
      if (queue) {
        /** @type {number} */
        var name = 0;
        var l = models.length;
        for (;l > name;name++) {
          /** @type {number} */
          i = 0;
          len = self.currentSizes.length;
          for (;len > i;i++) {
            var g = UnitTools.getObjectByObject(queue.goods, {
              colorId : models[name].id,
              sizeId : self.currentSizes[i].id
            });
            if (!g) {
              pos++;
            }
          }
        }
      } else {
        queue = {
          goods : [],
          goodName : self.selectedGood.good.name,
          barCode : self.selectedGood.good.barCode,//条码
          goodsSn : data,
          imagine : self.selectedGood.good.imagine
        };
        self.storeOrder.goodsGroup.push(queue);
        pos += self.currentSizes.length;
      }
      if (pos > self.limitNum) {
        /** @type {string} */
        var speed = "单据中的单品条数已超出" + self.limitNum + "条的限制！";
        return UnitTools.toastShow(speed, "short", "center"), false;
      }
      /** @type {number} */
      name = 0;
      l = models.length;
      for (;l > name;name++) {
        /** @type {number} */
        var strId = 0;
        var cnl = self.currentSizes.length;
        for (;cnl > strId;strId++) {
          var doc = self.currentSizes[strId];
          var b = {
            colorId : models[name].id,
            sizeId : doc.id,
            colorName : models[name].name,
            sizeName : doc.name,
            quantity : dataAndEvents,
            inBeforeNumber : init(models[name], doc),
            outBeforeNumber : fn(models[name], doc)
          };
          /** @type {Array} */
          var rawParams = queue.goods;
          /** @type {boolean} */
          var v = false;
          /** @type {number} */
          i = 0;
          /** @type {number} */
          len = rawParams.length;
          for (;len > i;i++) {
            var a = rawParams[i];
            if (a.colorId == b.colorId && a.sizeId == b.sizeId) {
              if (deepDataAndEvents) {
                if (a.quantity + b.quantity < 0) {
                  return self.selectedGood.good.batchNumArray[models[name].id] = 0, false;
                }
                a.quantity += b.quantity;
                self.selectedGood.good.numArray[models[name].id][doc.id] = a.quantity;
              } else {
                a.quantity = b.quantity;
                self.selectedGood.good.numArray[models[name].id][doc.id] = a.quantity;
              }
              if (0 == a.quantity) {
                queue.goods.splice(i, 1);
              }
              /** @type {boolean} */
              v = true;
              break;
            }
          }
          if (!v) {
            if (b.quantity > 0) {
              self.selectedGood.good.numArray[models[name].id][doc.id] = deepDataAndEvents ? 1 : dataAndEvents;
              queue.goods.push(b);
            }
          }
        }
      }
      if (0 == queue.goods.length) {
        UnitTools.removeByKey(self.storeOrder.goodsGroup, "goodsSn", data);
      }
      self.selectedGood.good.batchNumArray[models[0].id] = UnitTools.accAdd(self.selectedGood.good.batchNumArray[models[0].id], dataAndEvents);
      self.setTotalAmount();
    }
  };
  /**
   * @param {Element} def
   * @return {?}
   */
  self.getColorNumber = function(def) {
    var b = self.selectedGood.good.goodsSn;
    var max = UnitTools.fnCheckGtoreQty(self.storeOrder.goodsGroup, "goodsSn", b);
    /** @type {number} */
    var count = 0;
    if (max) {
      var employees = max.goods;
      /** @type {number} */
      var i = 0;
      var l = employees.length;
      for (;l > i;i++) {
        var data = employees[i];
        if (data.colorId == def.id) {
          count += data.quantity;
        }
      }
    }
    return count ? count : "";
  };
  /**
   * @param {Array} a
   * @param {?} keepData
   * @param {?} b
   * @return {?}
   */
  var equal = function(a, keepData, b) {
    /** @type {number} */
    var i = 0;
    var l = a.length;
    for (;l > i;i++) {
      if (a[i].colorId == keepData && a[i].sizeId == b) {
        return a[i].quantity;
      }
    }
    return 0;
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    createDom({
      page : ++page,
      searchKey : self.search.goodKey
    }).success(function(info) {
      self.KEY288 = self.KEY288.concat(info.optionList);
      /** @type {boolean} */
      self.loadMoreBtn = info.currentPage < info.totalPage;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("saleGoodModalCtrlScroll");
    });
  };
  /**
   * @param {string} key
   * @return {undefined}
   */
  self.selectSize = function(key) {
    var camelKey = self.selectedGood.seletedSizes.indexOf(key);
    if (camelKey > -1) {
      self.selectedGood.seletedSizes.splice(camelKey, 1);
    } else {
      self.selectedGood.seletedSizes.push(key);
    }
  };
  /**
   * @return {undefined}
   */
  self.selectAllSizes = function() {
    if (self.selectedGood.seletedSizes.length == self.currentSizes.length) {
      /** @type {Array} */
      self.selectedGood.seletedSizes = [];
    } else {
      var index;
      for (index in self.currentSizes) {
        if (self.selectedGood.seletedSizes.indexOf(self.currentSizes[index]) < 0) {
          self.selectedGood.seletedSizes.push(self.currentSizes[index]);
        }
      }
    }
  };
  self.$on("$ionicView.beforeEnter", function() {
    if ($templateCache.get("needToAddGoodsFlag") === true) {
      $templateCache.put("needToAddGoodsFlag", false);
      /**
       * @return {undefined}
       */
      var put = function() {
        if ($templateCache.get("addGoodsFlag") === true) {
          $templateCache.put("addGoodsFlag", false);
          var clonedContact = $templateCache.get("newGoodsObj");
          if (clonedContact) {
            if (clonedContact.id) {
              self.storeOrder.searchGoodsById(clonedContact.id);
              UnitTools.toastShow("成功添加 " + clonedContact.name);
              $templateCache.put("newGoodsObj", null);
            }
          }
        }
      };
      $templateCache.put("refreshGoodColorFlag", false);
      $templateCache.put("refreshGoodSizeFlag", false);
      dataAndEvents.getAllColorSize().then(function(packs) {
        if (null != packs) {
          self.allColors = packs[0].data.rows;
          self.allSizes = packs[1].data.rows;
        }
        put();
      }, function() {
        put();
      });
    }
    $document.getScanerCode(function(key) {
      self.searchGoodsByBarCode(key);
    }, self.bluethoothScaner);
  });
  /**
   * @param {?} timeoutKey
   * @return {undefined}
   */
  self.listItemDelete = function(timeoutKey) {
    delete self.storeOrder.goodsGroup[timeoutKey];
  };
  /**
   * @param {string} opt_attributes
   * @return {undefined}
   */
  self.deleteGoods = function(opt_attributes) {
    /** @type {number} */
    var otherwiseLineIndex = 0;
    var cnl = self.storeOrder.goodsGroup.length;
    for (;cnl > otherwiseLineIndex;otherwiseLineIndex++) {
      if (opt_attributes == self.storeOrder.goodsGroup[otherwiseLineIndex].goodsSn) {
        self.storeOrder.goodsGroup.splice(otherwiseLineIndex, 1);
        break;
      }
    }
    self.setTotalAmount();
    if (!self.platformIsPad) {
      self.selectedGood.good = {};
    }
  };
  /**
   * @param {(Object|string)} dataAndEvents
   * @param {string} last
   * @return {undefined}
   */
  self.deletePurchaseGoods = function(dataAndEvents, last) {
    /** @type {number} */
    var otherwiseLineIndex = 0;
    var cnl = self.storeOrder.goodsGroup.length;
    for (;cnl > otherwiseLineIndex;otherwiseLineIndex++) {
      if (dataAndEvents == self.storeOrder.goodsGroup[otherwiseLineIndex].goodsSn) {
        var i;
        for (i in self.storeOrder.goodsGroup[otherwiseLineIndex].goods) {
          if (i == last) {
            self.storeOrder.goodsGroup[otherwiseLineIndex].goods.splice(i, 1);
            break;
          }
        }
        if (0 === self.storeOrder.goodsGroup[otherwiseLineIndex].goods.length) {
          self.storeOrder.goodsGroup.splice(otherwiseLineIndex, 1);
          break;
        }
      }
    }
    if (self.isGoodsGroupNull()) {
      /** @type {boolean} */
      self.storeOrder.showDelete = false;
    }
    self.setTotalAmount();
    if (!self.platformIsPad) {
      self.selectedGood.good = {};
    }
  };
  /**
   * @return {undefined}
   */
  self.setTotalAmount = function() {
    /** @type {number} */
    var cssValue = 0;
    /** @type {number} */
    var unlock = 0;
    var cnl = self.storeOrder.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      /** @type {number} */
      var i = 0;
      var l = self.storeOrder.goodsGroup[unlock].goods.length;
      for (;l > i;i++) {
        self.storeOrder.goodsGroup[unlock].goods[i];
        if (self.storeOrder.goodsGroup[unlock].goods[i].quantity) {
          cssValue = UnitTools.accAdd(cssValue, self.storeOrder.goodsGroup[unlock].goods[i].quantity);
        }
      }
    }
    self.totalQuantity = cssValue;
  };
  /**
   * @param {?} dataAndEvents
   * @return {undefined}
   */
  self.clearSelectedGood = function(dataAndEvents) {
    if (angular.isObject(self.selectedGood.good)) {
      if (self.selectedGood.good.goodsSn == dataAndEvents) {
        self.selectedGood.good = {};
      }
    }
  };
  self.$watch("[storeOrder.inStoreDepot, storeOrder.outStoreDepot]", function(results, dataAndEvents) {
    if (!UnitTools.isEmpty(self.storeOrder.goodsGroup) && (results[0] && results[0] != dataAndEvents[0])) {
      /** @type {Array} */
      var new_val = [];
      /** @type {number} */
      var j = 0;
      var spaces = self.storeOrder.goodsGroup.length;
      for (;spaces > j;j++) {
        var goodsSn = self.storeOrder.goodsGroup[j].goodsSn;
        /** @type {number} */
        var i = 0;
        var ilen = self.storeOrder.goodsGroup[j].goods.length;
        for (;ilen > i;i++) {
          var elem = self.storeOrder.goodsGroup[j].goods[i];
          var queue = UnitTools.getPropertyObj(elem, ["colorId", "sizeId"]);
          new_val.push(UnitTools.union({
            goodsSn : goodsSn
          }, UnitTools.union({
            storehouseId : results[0].id
          }, queue)));
        }
      }
      db.postEncode("/KEY204", {
        goodsList : angular.toJson(new_val)
      }).success(function(path) {
        /** @type {number} */
        var unlock = 0;
        var cnl = self.storeOrder.goodsGroup.length;
        for (;cnl > unlock;unlock++) {
          var month = self.storeOrder.goodsGroup[unlock].goodsSn;
          /** @type {number} */
          var j = 0;
          var spaces = self.storeOrder.goodsGroup[unlock].goods.length;
          for (;spaces > j;j++) {
            var info = self.storeOrder.goodsGroup[unlock].goods[j];
            var match = UnitTools.fnCheckGtoreQty(path, "serialNo", results[0].id + "-" + month + "-" + info.colorId + "-" + info.sizeId);
            var count = match ? match.number : 0;
            self.storeOrder.goodsGroup[unlock].goods[j].inBeforeNumber = count;
          }
        }
        self.setTotalAmount();
      });
    }
    if (!UnitTools.isEmpty(self.storeOrder.goodsGroup) && (results[1] && results[1] != dataAndEvents[1])) {
      /** @type {Array} */
      new_val = [];
      /** @type {number} */
      j = 0;
      spaces = self.storeOrder.goodsGroup.length;
      for (;spaces > j;j++) {
        goodsSn = self.storeOrder.goodsGroup[j].goodsSn;
        /** @type {number} */
        i = 0;
        ilen = self.storeOrder.goodsGroup[j].goods.length;
        for (;ilen > i;i++) {
          elem = self.storeOrder.goodsGroup[j].goods[i];
          queue = UnitTools.getPropertyObj(elem, ["colorId", "sizeId"]);
          new_val.push(UnitTools.union({
            goodsSn : goodsSn
          }, UnitTools.union({
            storehouseId : results[1].id
          }, queue)));
        }
      }
      db.postEncode("/KEY204", {
        goodsList : angular.toJson(new_val)
      }).success(function(path) {
        /** @type {number} */
        var unlock = 0;
        var cnl = self.storeOrder.goodsGroup.length;
        for (;cnl > unlock;unlock++) {
          var month = self.storeOrder.goodsGroup[unlock].goodsSn;
          /** @type {number} */
          var j = 0;
          var spaces = self.storeOrder.goodsGroup[unlock].goods.length;
          for (;spaces > j;j++) {
            var info = self.storeOrder.goodsGroup[unlock].goods[j];
            var match = UnitTools.fnCheckGtoreQty(path, "serialNo", results[1].id + "-" + month + "-" + info.colorId + "-" + info.sizeId);
            var count = match ? match.number : 0;
            self.storeOrder.goodsGroup[unlock].goods[j].outBeforeNumber = count;
          }
        }
        self.setTotalAmount();
      });
    }
  }, true);
  /**
   * @return {undefined}
   */
  self.setBusinessTime = function() {
    if (window.cordova) {
      $scope.show({
        date : new Date(self.storeOrder.businessTime),
        mode : "date",
        doneButtonLabel : "确定",
        cancelButtonLabel : "取消",
        minDate : (new Date).setDate((new Date).getDate() - 90),
        maxDate : (new Date).setDate((new Date).getDate())
      }).then(function(date1) {
        if (!isNaN(date1.getTime())) {
          if (self.GetOperatorEventLimit("KEY257") || date1.getTime() >= UnitTools._stringToDate((new Date).toLocaleDateString()).getTime()) {
            self.storeOrder.businessTime = date1.getTime();
          } else {
            UnitTools.toastShow("没有补录权限，选择的日期必须为今天");
          }
        }
      });
    }
  };
  /**
   * @param {string} name
   * @return {?}
   */
  self.saveStore = function(name) {
    /**
     * @return {?}
     */
    function combine() {
      /** @type {Array} */
      var indents = [];
      /** @type {number} */
      var unlock = 0;
      var cnl = self.storeOrder.goodsGroup.length;
      for (;cnl > unlock;unlock++) {
        var goodsSn = self.storeOrder.goodsGroup[unlock].goodsSn;
        var dataName;
        for (dataName in self.storeOrder.goodsGroup[unlock].goods) {
          var data = self.storeOrder.goodsGroup[unlock].goods[dataName];
          indents.push({
            storehouseId : camelKey,
            goodsSn : goodsSn,
            colorId : data.colorId,
            sizeId : data.sizeId
          });
        }
      }
      return dataAndEvents.getGoodsListStoredCount(indents);
    }
    /**
     * @param {string} key
     * @param {string} id
     * @param {?} data
     * @param {?} className
     * @return {undefined}
     */
    function getObject(key, id, data, className) {
      var match = UnitTools.fnCheckGtoreQty(className, "serialNo", key + "-" + id + "-" + data.colorId + "-" + data.sizeId);
      var count = match ? match.number : 0;
      data.outBeforeNumber = count;
      if (data.quantity <= count) {
        /** @type {number} */
        data.isEnoughStore = 1;
        self.isShowInvalidStoreMsg = 0;
      }
      else if (data.sizeName=="赠送") {
        data.isEnoughStore = 1;       //赠送尺码不检测库存
      }
      else {
        /** @type {number} */
        data.isEnoughStore = 0;
        /** @type {number} */
        self.isShowInvalidStoreMsg = 1;
      }
    }
    /** @type {Array} */
    var new_val = [];
    /** @type {number} */
    var unlock = 0;
    var cnl = self.storeOrder.goodsGroup.length;
    for (;cnl > unlock;unlock++) {
      var j;
      for (j in self.storeOrder.goodsGroup[unlock].goods) {
        var data = self.storeOrder.goodsGroup[unlock].goods[j];
        if (null != data.quantity) {
          if (0 != data.quantity) {
            new_val.push({
              goodsSn : self.storeOrder.goodsGroup[unlock].goodsSn,
              colorId : data.colorId,
              sizeId : data.sizeId,
              transferNumber : data.quantity,
              outBeforeNumber : data.outBeforeNumber,
              inBeforeNumber : data.inBeforeNumber
            });
          }
        }
      }
    }
    if (UnitTools.isEmpty(self.storeOrder.outStoreDepot)) {
      return _.alert({
        template : "<div class='tc'>需要选择调出仓库</div>",
        okText : "确定"
      }), false;
    }
    if (UnitTools.isEmpty(self.storeOrder.inStoreDepot)) {
      return _.alert({
        template : "<div class='tc'>需要选择调入仓库</div>",
        okText : "确定"
      }), false;
    }
    if (self.storeOrder.inStoreDepot.val == self.storeOrder.outStoreDepot.val) {
      return _.alert({
        template : "<div class='tc'>调出仓库和调入仓库不可相同</div>",
        okText : "确定"
      }), false;
    }
    if (0 === new_val.length) {
      return _.alert({
        template : "<div class='tc'>调拨明细不能为空</div>",
        okText : "确定"
      }), false;
    }
    /** @type {number} */
    var pos = 0;
    /** @type {number} */
    j = 0;
    var spaces = self.storeOrder.goodsGroup.length;
    for (;spaces > j;j++) {
      pos += self.storeOrder.goodsGroup[j].goods.length;
    }
    if (pos > self.limitNum) {
      /** @type {string} */
      var speed = "当前选择的单品条数为" + pos + "，已超过限制条数" + self.limitNum + "，请修改后重新提交！";
      return UnitTools.toastShow(speed, "short", "center"), false;
    }
    if (self.storeOrder.businessTime) {
      /** @type {Date} */
      var d = new Date;
      /** @type {Date} */
      var midnight = new Date(self.storeOrder.businessTime);
      midnight.setHours(d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds());
      /** @type {number} */
      self.storeOrder.businessTime = midnight.getTime();
    }
    UnitTools.union(value, {
      inStorehouseId : self.storeOrder.inStoreDepot.val,
      outStorehouseId : self.storeOrder.outStoreDepot.val,
      businessTime : self.storeOrder.businessTime,
      remark : self.storeOrder.remark
    });
    /** @type {number} */
    self.isShowInvalidStoreMsg = 0;
    var camelKey = self.storeOrder.outStoreDepot.val;
    loading.show(true);
    combine().then(function(classToRemove) {
      /**
       * @return {undefined}
       */
      function next() {
        if ("draft" === name) {
          loading.show(true);
          db.postEncode("/KEY217", {
            storeTransferOrder : angular.toJson(value),
            goods : angular.toJson(new_val)
          }).success(function(config) {
            if (1 == config.statusCode) {
              UnitTools.toastShow("保存成功！");
              UnitTools.union(value, config.object);
              /** @type {number} */
              self.status = 1;
              self.storeOrder.orderNo = config.object.orderNo;
              self.storeOrder.businessTime = config.object.businessTime;
              /** @type {string} */
              self.transferSaleOrder.order.orderFrom = "KEY137";
              self.transferSaleOrder.goodsGroup = self.storeOrder.goodsGroup;
            } else {
              UnitTools.toastShow(config.content);
            }
          }).finally(function() {
            loading.hide();
            $templateCache.put("storeTransferListRefresh", true);
          });
        } else {
          if ("sell" === name) {
            self.viewReplace();
            $state.go("eventmenu.KEY284", {
              timeStamp : UnitTools.getTimeStamp(),
              copyOrder : o.copyOrder ? o.copyOrder : self.transferSaleOrder
            });
          } else {
            if ("commit" === name) {
              var promise = _.confirm({
                template : "<div class='tc'>确认提交调拨?</div>",
                cancelText : "取消",
                okText : "确认"
              });
              promise.then(function(dataAndEvents) {
                if (dataAndEvents) {
                  loading.show(true);
                  db.postEncode("/KEY218", {
                    storeTransferOrder : angular.toJson(value),
                    goods : angular.toJson(new_val)
                  }).success(function(res) {
                    if (1 == res.statusCode) {
                      UnitTools.toastShow("库存调拨成功！");
                      /** @type {Array} */
                      self.storeOrder.goodsGroup = [];
                      params.autoPrint(self.mainCompany.comName, res.object.orderNo, params.orderType.transferOrder);
                      self.viewReplace();
                      $state.go("eventmenu.KEY096", {
                        orderNo : res.object.orderNo
                      });
                      self.storeOrder.businessTime = res.object.businessTime;
                    } else {
                      UnitTools.toastShow(res.content);
                    }
                  }).finally(function() {
                    loading.hide();
                    $templateCache.put("storeTransferListRefresh", true);
                  });
                }
              });
            }
          }
        }
      }
      /** @type {number} */

      var unlock = 0;
      var cnl = self.storeOrder.goodsGroup.length;
      for (;cnl > unlock;unlock++) {
        var id = self.storeOrder.goodsGroup[unlock].goodsSn;
        var frontName;
        for (frontName in self.storeOrder.goodsGroup[unlock].goods) {
          var pdataCur = self.storeOrder.goodsGroup[unlock].goods[frontName];
          if (null != pdataCur.quantity) {
            getObject(camelKey, id, pdataCur, classToRemove);
          }
        }
      }
      if (loading.hide(), 1 === self.isShowInvalidStoreMsg) {
        if (2 == self.saleNegativeStore && "commit" === name) {
          _.alert({
            template : "<div class='tc'>调出仓库的商品库存不足，不允许调拨</div>",
            okText : "确定"
          });
        } else {
          var promise = _.confirm({
            template : "<div class='tc'>调出仓库的商品库存不足，是否继续?</div>",
            cancelText : "取消",
            okText : "继续保存"
          });
          promise.then(function(dataAndEvents) {
            if (dataAndEvents) {
              next();
            }
          });
        }
      } else {
        next();
      }
    });
  };
  /**
   * @param {number} dataAndEvents
   * @return {undefined}
   */
  self.showActionsheet = function(dataAndEvents) {
    var scope = {
      buttons : []
    };
    if (self.storeTransferDraftAccAvailable) {
      scope.buttons.push({
        text : '<i class="icon ion-ios-compose-outline assertive"></i> 草 稿'
      });
    }
    if (self.storeTransferDraftAccAvailable && value.orderNo || self.storeTransferDraftAccAvailable && o.copyOrder) {
      scope.buttons.push({
        text : '<i class="icon ion-ios-checkmark-outline assertive"></i>转销售单'
      });
    }
    if (self.storeTransferConfirmAccAvailable) {
      scope.buttons.push({
        text : '<i class="icon ion-ios-paper-outline assertive"></i> 调 拨'
      });
    }
    if (1 == dataAndEvents) {
      if (self.GetOperatorEventLimit("KEY052")) {
        scope.buttons.push({
          text : '<i class="icon ion-bluetooth assertive"></i> 蓝牙打印'
        });
      }
    }
    /**
     * @param {number} index
     * @return {?}
     */
    scope.buttonClicked = function(index) {
      return scope.buttons[index].text.indexOf("草 稿") > -1 ? self.saveStore("draft") : scope.buttons[index].text.indexOf("转销售单") > -1 ? self.saveStore("sell") : scope.buttons[index].text.indexOf("调 拨") > -1 ? self.saveStore("commit") : scope.buttons[index].text.indexOf("蓝牙打印") > -1 && params.bluetooth(value.orderNo, params.orderType.transferOrder),
      true;
    };
    if (1 == dataAndEvents) {
      if (self.GetOperatorEventLimit("KEY035")) {
        /** @type {string} */
        scope.destructiveText = '<i class="icon ion-ios-trash-outline assertive"></i> 删 除';
        /**
         * @return {?}
         */
        scope.destructiveButtonClicked = function() {
          var promise = _.confirm({
            template : "<div class='tc'>您确认要删除该调拨单?</div>",
            cancelText : "取消",
            okText : "确认"
          });
          return promise.then(function(dataAndEvents) {
            if (dataAndEvents) {
              loading.show(true);
              db.post("/KEY453?orderNo=" + value.orderNo).success(function(r) {
                if (1 == r.statusCode) {
                  _.alert({
                    template : "<div class='tc'>删除成功</div>",
                    okText : "确定"
                  }).then(function() {
                    $templateCache.put("storeTransferListRefresh", true);
                    self.goBack();
                  });
                } else {
                  _.alert({
                    template : "<div class='tc'>" + r.content + "</div>",
                    okText : "确定"
                  });
                }
              }).finally(function() {
                loading.hide();
              });
            }
          }), true;
        };
      }
    }
    handler.show(scope);
  };
  loading.show(true);
  self.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      /** @type {Array} */
      self.allDept = [];
      /** @type {number} */
      var j = 0;
      for (;j < packs[0].data.length;j++) {
        if ("1" == packs[0].data[j].status) {
          self.allDept.push(packs[0].data[j]);
        }
      }
      if (self.allSizes = packs[1].data.rows, self.allColors = packs[2].data.rows, self.selectedGood.good && angular.extend(self.selectedGood, {
        currentColors : UnitTools.idStringToObjectArray(self.allColors, self.selectedGood.good.colorIds, "id", ","),
        currentSizes : UnitTools.idStringToObjectArray(self.allSizes, self.selectedGood.good.sizeIds, "id", ",")
      }), id) {
        db.post("/KEY219?orderNo=" + id).success(function(event) {
          UnitTools.union(value, event.order);
          self.transferSaleOrder.order = event.order;
          /** @type {string} */
          self.transferSaleOrder.order.orderFrom = "KEY137";
          self.status = event.order.status;
          self.storeOrder.orderNo = event.order.orderNo;
          self.storeOrder.remark = event.order.remark;
          self.storeOrder.businessTime = null == event.order.businessTime ? UnitTools.getTimeStamp() : event.order.businessTime;
          /** @type {number} */
          var i = 0;
          var l = self.allDept.length;
          for (;l > i && (!self.storeOrder.inStoreDepot || !self.storeOrder.outStoreDepot);i++) {
            if (event.order.inStorehouseId == self.allDept[i].val) {
              self.storeOrder.inStoreDepot = self.allDept[i];
            }
            if (event.order.outStorehouseId == self.allDept[i].val) {
              self.storeOrder.outStoreDepot = self.allDept[i];
            }
          }
          /** @type {Array} */
          var new_val = [];
          event.orderGoods.forEach(function(item) {
            var attributes = UnitTools.getPropertyObj(item, ["goodsSn", "colorId", "sizeId"]);
            new_val.push(UnitTools.union({
              storehouseId : event.order.inStorehouseId
            }, attributes));
            new_val.push(UnitTools.union({
              storehouseId : event.order.outStorehouseId
            }, attributes));
          });
          db.postEncode("/KEY204", {
            goodsList : angular.toJson(new_val)
          }).success(function(path) {
            event.orderGoods.forEach(function(data) {
              var match = UnitTools.fnCheckGtoreQty(path, "serialNo", event.order.outStorehouseId + "-" + data.goodsSn + "-" + data.colorId + "-" + data.sizeId);
              var f = UnitTools.fnCheckGtoreQty(path, "serialNo", event.order.inStorehouseId + "-" + data.goodsSn + "-" + data.colorId + "-" + data.sizeId);
              var line = UnitTools.union({
                inBeforeNumber : f ? f.number : 0,
                outBeforeNumber : match ? match.number : 0
              }, UnitTools.getPropertyObj(data, ["goodsSn", "colorId", "sizeId", "colorName", "sizeName", "transferNumber", "unit"]));
              line.quantity = line.transferNumber;
              /** @type {boolean} */
              var i = false;
              /** @type {number} */
              var unlock = 0;
              var cnl = self.storeOrder.goodsGroup.length;
              for (;cnl > unlock;unlock++) {
                var a = self.storeOrder.goodsGroup[unlock].goodsSn;
                if (data.goodsSn == a) {
                  /** @type {boolean} */
                  i = true;
                  self.storeOrder.goodsGroup[unlock].goods.push(line);
                }
              }
              if (!i) {
                var meta = {};
                /** @type {Array} */
                meta.goods = [];
                meta.goods.push(line);
                meta.goodName = data.goodName;
                meta.goodsSn = data.goodsSn;
                self.storeOrder.goodsGroup.push(meta);
              }
            });
            self.transferSaleOrder.goodsGroup = self.storeOrder.goodsGroup;
            self.setTotalAmount();
            self.searchGoods();
          });
        }).finally(function() {
          loading.hide();
        });
      } else {
        if (o.copyOrder) {
          self.copyOrder = o.copyOrder;
          self.storeOrder.goodsGroup = self.copyOrder.goodsGroup;
          /** @type {number} */
          self.storeOrder.businessTime = (new Date).getTime();
          /** @type {number} */
          j = 0;
          /** @type {number} */
          var spaces = self.allDept.length;
          for (;spaces > j;j++) {
            if (self.copyOrder.order.inStorehouseId == self.allDept[j].val) {
              self.storeOrder.inStoreDepot = self.allDept[j];
              break;
            }
          }
          /** @type {number} */
          j = 0;
          /** @type {number} */
          spaces = self.allDept.length;
          for (;spaces > j;j++) {
            if (self.copyOrder.order.outStorehouseId == self.allDept[j].val) {
              self.storeOrder.outStoreDepot = self.allDept[j];
              break;
            }
          }
          self.setTotalAmount();
          loading.hide();
        } else {
          self.storeOrder.outStoreDepot = self.allDept[0];
          /** @type {number} */
          self.storeOrder.businessTime = (new Date).getTime();
          loading.hide();
        }
      }
      self.searchGoods();
    }, function() {
      loading.hide();
    });
  });
}]).controller("GoodStoreQueryCtrl", ["$scope", "$q", "$ionicModal", "$ionicPopup", "$state", "lbSpinnerDialog", "psisServices", "Tools", "$ionicPopover", "$cordovaDatePicker", "$stateParams", "BTScanerService", "commonDataInterface", "ServerConfig", function($scope, $q, $modal, dataAndEvents, $state, loading, field, _, FB, scope, $attrs, $cookieStore, values, obj) {
  /**
   * @return {?}
   */
  function fetch() {
    var imageDfd = $q.defer();
    var request1 = field.httpCacheGet.get(field.httpCacheGet.ac.KEY177);
    var getPromise3 = field.httpCacheGet.get(field.httpCacheGet.ac.ALLSIZELIST);
    var c = field.httpCacheGet.get(field.httpCacheGet.ac.ALLCOLORLIST);
    return $q.all([request1, getPromise3, c]).then(function(image) {
      imageDfd.resolve(image);
    }, function() {
      imageDfd.reject();
    }), imageDfd.promise;
  }
  $scope.selectedGood = {};
  $scope.queryCondition = {};
  $modal.fromTemplateUrl("html/PStorageStockBill/KEY006.html", function($location) {
    $scope.modal = $location;
  }, {
    scope : $scope,
    animation : "slide-in-up",
    focusFirstInput : true
  });
  /**
   * @return {undefined}
   */
  $scope.modalOpen = function() {
    $scope.modal.show().then(function() {
      _.keyboardShow();
    });
  };
  /**
   * @param {?} data
   * @return {undefined}
   */
  $scope.getGoodInfo = function(data) {
    $scope.selectedGood.good = data;
    $scope.selectedGood.good.name = data.goodsName;
    angular.extend($scope.selectedGood, {
      currentColors : _.idStringToObjectArray($scope.allColors, data.colorId, "id", ","),
      currentSizes : _.idStringToObjectArray($scope.allSizes, data.sizeId, "id", ",")
    });
  };
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : $scope
  }).then(function($location) {
    $scope.storehousePopover = $location;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  $scope.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    $scope.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @return {undefined}
   */
  $scope.hideStorehousePopover = function() {
    $scope.storehousePopover.hide();
  };
  $scope.$on("$destroy", function() {
    $scope.modal.remove();
    $scope.storehousePopover.remove();
  });
  var message = {};
  $scope.$watch("[queryCondition.storeDepot]", function(a, blobs) {
    if (a[0]) {
      if (blobs[0]) {
        if (a[0].val != blobs[0].val) {
          if (blobs[0].val > 0) {
            message = {
              id : $scope.queryCondition.storeDepot.id,
              val : $scope.queryCondition.storeDepot.val,
              text : $scope.queryCondition.storeDepot.text,
              name : $scope.queryCondition.storeDepot.name
            };
            values.saveOrUpdateUserConfig("goodsStoredRecordList.depot", JSON.stringify(message), 3).then(function(item) {
              $scope.goodsStoredRecordList.depot = _.fnCheckGtoreQty(obj.userConfigData, "configKey", "goodsStoredRecordList.depot");
              if ($scope.goodsStoredRecordList.depot) {
                _.union($scope.goodsStoredRecordList.depot, item.object);
              } else {
                obj.userConfigData.push(item.object);
              }
              /** @type {*} */
              $scope.goodsStoredRecordList.depotValue = JSON.parse(item.object.configValue);
            }, function() {
              console.log("保存记忆选项不成功！");
            });
          }
        }
      }
    }
  }, true);
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeBegin = function() {
    scope.show({
      date : new Date($scope.queryCondition.createTimeBegin),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(val2) {
      if (!isNaN(val2)) {
        $scope.queryCondition.createTimeBegin = val2;
      }
    });
  };
  /**
   * @return {undefined}
   */
  $scope.setCreateTimeEnd = function() {
    scope.show({
      date : new Date($scope.queryCondition.createTimeEnd),
      mode : "date",
      minDate : "",
      maxDate : "",
      doneButtonLabel : "确定",
      cancelButtonLabel : "取消"
    }).then(function(val2) {
      if (!isNaN(val2)) {
        $scope.queryCondition.createTimeEnd = val2;
      }
    });
  };
  /**
   * @return {?}
   */
  $scope.searchRecord = function() {
    if (null == $scope.selectedGood.good) {
      return _.toastShow("请选择商品！", "short", "center"), false;
    }
    var $stateParams = {
      storehouse : $scope.queryCondition.storeDepot,
      goodsName : $scope.selectedGood.good.name,
      goodsSn : $scope.selectedGood.good.goodsSn,
      colorId : $scope.selectedGood.color ? $scope.selectedGood.color.id : null,
      sizeId : $scope.selectedGood.size ? $scope.selectedGood.size.id : null,
      updateTimeBegin : $scope.queryCondition.createTimeBegin,
      updateTimeEnd : $scope.queryCondition.createTimeEnd
    };
    $state.go("eventmenu.KEY165", $stateParams);
  };
  loading.show(true);
  $scope.$on("$ionicView.beforeEnter", function() {
    $cookieStore.getScanerCode(function(part) {
      values.getGoodsByBarCode(part).then(function(dataAndEvents) {
        if (dataAndEvents) {
          $scope.selectedGood.good = dataAndEvents;
          $scope.searchRecord();
        } else {
          _.toastShow("找不到 " + part + " 的商品");
          dataAndEvents.alert({
            template : "<div class='tc'>"+"找不到" + part + "的商品信息"+"</div>",
            okText : "确定"
          });
        }
      }, function() {
        _.toastShow("扫码获取商品信息失败");
      });
    }, $scope.bluethoothScaner);
  });
  $scope.$on("$ionicView.loaded", function() {
    fetch().then(function(packs) {
      $scope.allDept = packs[0].data;
      $scope.allSizes = packs[1].data.rows;
      $scope.allColors = packs[2].data.rows;
      /** @type {Date} */
      var tempDate = new Date;
      if (tempDate.setMonth(tempDate.getMonth() - 1), $scope.queryCondition.createTimeBegin = tempDate, $scope.queryCondition.createTimeEnd = new Date, $attrs.goods && $scope.getGoodInfo($attrs.goods), $scope.goodsStoredRecordList = {}, $scope.goodsStoredRecordList.depot = _.fnCheckGtoreQty(obj.userConfigData, "configKey", "goodsStoredRecordList.depot"), $scope.goodsStoredRecordList.depot && ($scope.goodsStoredRecordList.depot.configValue &&
      ($scope.goodsStoredRecordList.depotValue = JSON.parse($scope.goodsStoredRecordList.depot.configValue))), $scope.queryCondition.storeDepot = $scope.allDept[0], $scope.goodsStoredRecordList.depotValue) {
        /** @type {number} */
        var i = 0;
        var l = $scope.allDept.length;
        for (;l > i;i++) {
          if ($scope.goodsStoredRecordList.depotValue.val == $scope.allDept[i].id) {
            $scope.queryCondition.storeDepot = $scope.allDept[i];
            break;
          }
        }
      }
      loading.hide();
    }, function() {
      loading.hide();
    });
  });
}]).controller("GoodStoreRecordCtrl", ["$scope", "psisServices", "$state", "$stateParams", "Tools", "lbSpinnerDialog", "pageDetail", "BalanceBusinessItem", "lruPersistCache", function(self, $http, deepDataAndEvents, userInfo, dataAndEvents, loading, message, result, $templateCache) {
  self.recordData = {
    storehouse : userInfo.storehouse,
    goodsName : userInfo.goodsName,
    goodsSn : userInfo.goodsSn,
    colorId : userInfo.colorId,
    sizeId : userInfo.sizeId,
    updateTimeBegin : userInfo.updateTimeBegin,
    updateTimeEnd : userInfo.updateTimeEnd
  };
  self.businessItems = result.getBusinessItem;
  /**
   * @return {undefined}
   */
  self.getList = function() {
    loading.show(true);
    var updateTimeBegin = dataAndEvents.getDayBegin(self.recordData.updateTimeBegin.getTime());
    var updateTimeEnd = dataAndEvents.getOffsetDayBegin(self.recordData.updateTimeEnd.getTime(), 1);
    var customer = {
      storehouseId : self.recordData.storehouse.val,
      goodsSn : self.recordData.goodsSn,
      colorId : self.recordData.colorId,
      sizeId : self.recordData.sizeId,
      updateTimeBegin : updateTimeBegin,
      updateTimeEnd : updateTimeEnd
    };
    $http.post("/KEY198", customer).success(function(r) {
      self.items = r.rows;
    }).finally(function() {
      loading.hide();
    });
  };
  self.$on("$ionicView.loaded", function() {
    self.getList();
  });
  self.$on("$ionicView.beforeEnter", function() {
    if (1 == $templateCache.get("goodsStoredRecordListRefresh")) {
      self.getList();
      $templateCache.put("goodsStoredRecordListRefresh", false);
    }
  });
  self.gotoDetail = message.gotoDetail;
}]).controller("StockWarnCtrl", ["$scope", "psisServices", "lbScrollDelegate", "lbSpinnerDialog", "$state", "Tools", "$ionicModal", "$ionicPopover", "lruPersistCache", "$stateParams", "commonDataInterface", "ServerConfig", function(self, game, parent, loading, dataAndEvents, $, $modal, FB, deepDataAndEvents, results, callback, obj) {
  /**
   * @param {Object} model
   * @return {undefined}
   */
  function init(model) {
    var data = {
      id : model.id,
      val : model.val,
      text : model.text,
      name : model.name
    };
    callback.saveOrUpdateUserConfig("goodsStoredList.depot", JSON.stringify(data), 3).then(function(event) {
      self.goodsStoredList.depot = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "goodsStoredList.depot");
      if (self.goodsStoredList.depot) {
        $.union(self.goodsStoredList.depot, event.object);
      } else {
        obj.userConfigData.push(event.object);
      }
      /** @type {*} */
      self.goodsStoredList.depotValue = JSON.parse(event.object.configValue);
    }, function() {
      console.log("保存记忆选项不成功！");
    });
  }
  /** @type {boolean} */
  self.isLoading = true;
  /** @type {Array} */
  self.items = [];
  self.searchObj = {
    searchKey : ""
  };
  /** @type {string} */
  self.focused = "centered";
  self.queryCondition = {
    page : 1,
    existsNumber : 1,
    operator : 3,
    warnNumber : 1,
    listDataType : 2,
    storehouseMerge : true,
    sidx : "number",
    sord : "asc"
  };
  self.filterObj = {
    existsNumber : true
  };
  self.goodsInfo = {};
  self.allCategoryList = {};
  $modal.fromTemplateUrl("listFilter.html", function(theTitle) {
    self.listFilterModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  FB.fromTemplateUrl("storehousePopover.html", {
    scope : self
  }).then(function(theTitle) {
    self.storehousePopover = theTitle;
  });
  /**
   * @param {boolean} expectedNumberOfNonCommentArgs
   * @return {undefined}
   */
  self.openStorehousePopover = function(expectedNumberOfNonCommentArgs) {
    self.storehousePopover.show(expectedNumberOfNonCommentArgs);
  };
  /**
   * @param {Object} arg
   * @param {?} event
   * @return {undefined}
   */
  self.hideStorehousePopover = function(arg, event) {
    self.selectStorehouse(arg);
    self.filterAction(arg);
    self.storehousePopover.hide(event);
  };
  $modal.fromTemplateUrl("goodsCategoryQuery.html", function(theTitle) {
    self.goodsCategoryModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  $modal.fromTemplateUrl("goodsBlandQuery.html", function(theTitle) {
    self.goodsBlandModal = theTitle;
  }, {
    scope : self,
    animation : "slide-in-up"
  });
  self.$on("$destroy", function() {
    self.listFilterModal.remove();
    self.storehousePopover.remove();
    self.goodsCategoryModal.remove();
    self.goodsBlandModal.remove();
  });
  /**
   * @param {Object} event
   * @return {undefined}
   */
  self.selectStorehouse = function(event) {
    if (event) {
      /** @type {Object} */
      self.filterObj.saleDepot = event;
      init(event);
    } else {
      /** @type {null} */
      self.filterObj.saleDepot = null;
      init({
        id : null,
        val : null,
        text : "合并仓库",
        name : "合并仓库"
      });
    }
  };
  self.$on("$ionicView.beforeEnter", function() {
    game.httpCacheGet.get(game.httpCacheGet.ac.BLANDLIST).success(function(theTitle) {
      self.arrBland = theTitle;
    });
  });
  self.$on("$ionicView.loaded", function() {
    game.httpCacheGet.get(game.httpCacheGet.ac.CATEGORYLIST).success(function(data) {
      self.allCategoryList = data.rows;
      self.categoryTree = $.treeForCategory(0, "", false, data.rows).children;
    });
    game.httpCacheGet.get(game.httpCacheGet.ac.STOREHOUSEAVAILABLE).success(function(theTitle) {
      if (self.allDept = theTitle, self.goodsStoredList = {}, self.goodsStoredList.depot = $.fnCheckGtoreQty(obj.userConfigData, "configKey", "goodsStoredList.depot"), self.goodsStoredList.depot && (self.goodsStoredList.depot.configValue && (self.goodsStoredList.depotValue = JSON.parse(self.goodsStoredList.depot.configValue))), self.goodsStoredList.depotValue && self.goodsStoredList.depotValue.id >
      0) {
        /** @type {number} */
        var b = 0;
        var a = self.allDept.length;
        for (;a > b;b++) {
          if (self.goodsStoredList.depotValue.val == self.allDept[b].id) {
            self.filterObj.saleDepot = self.allDept[b];
            break;
          }
        }
      }
      self.getList();
    });
  });
  /**
   * @return {?}
   */
  var Step = function() {
    return game.postEncode("/KEY098", self.queryCondition);
  };
  /**
   * @return {undefined}
   */
  self.getList = function() {
    /** @type {number} */
    self.queryCondition.page = 1;
    if (self.searchObj.searchKey) {
      self.queryCondition.barCode = self.searchObj.searchKey;
      self.queryCondition.goodsSn = self.searchObj.searchKey;
      self.queryCondition.goodsName = self.searchObj.searchKey;
      self.queryCondition.skuBarCode = self.searchObj.searchKey;
      self.queryCondition.skuSn = self.searchObj.searchKey;
    } else {
      delete self.queryCondition.barCode;
      delete self.queryCondition.goodsSn;
      delete self.queryCondition.goodsName;
      delete self.queryCondition.skuBarCode;
      delete self.queryCondition.skuSn;
      loading.show(true);
    }
    self.queryCondition.storehouseId = self.filterObj.saleDepot ? self.filterObj.saleDepot.val : "";
    self.queryCondition.categoryId = self.goodsInfo.category ? $.getCategoryChildIds(self.allCategoryList, self.goodsInfo.category.id) : "";
    self.queryCondition.blandId = self.filterObj.bland ? self.filterObj.bland.id : "";
    /** @type {number} */
    self.queryCondition.existsNumber = self.filterObj.existsNumber ? 1 : 0;
    self.queryCondition.minNumber = self.filterObj.minNumber || 0 === self.filterObj.minNumber ? self.filterObj.minNumber : "";
    self.queryCondition.maxNumber = self.filterObj.maxNumber || 0 === self.filterObj.maxNumber ? self.filterObj.maxNumber : "";
    if (self.filterObj.saleDepot) {
      delete self.queryCondition.storehouseMerge;
    } else {
      /** @type {boolean} */
      self.queryCondition.storehouseMerge = true;
    }
    Step().success(function(data) {
      self.items = data.rows;
      /** @type {boolean} */
      self.loadMoreBtn = data.page < data.total;
    }).finally(function() {
      /** @type {boolean} */
      self.isLoading = false;
      loading.hide();
      parent.scrollTop("stockSearchCtrlScroll");
    });
  };
  /**
   * @param {string} id
   * @return {undefined}
   */
  self.getSortList = function(id) {
    /** @type {string} */
    self.queryCondition.sord = "" == id ? "" : self.queryCondition.sidx == id && "desc" == self.queryCondition.sord ? "asc" : "desc";
    /** @type {string} */
    self.queryCondition.sidx = id;
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.getMore = function() {
    self.queryCondition.page++;
    Step().success(function(options) {
      self.items = self.items.concat(options.rows);
      /** @type {boolean} */
      self.loadMoreBtn = options.page < options.total;
      self.$broadcast("scroll.infiniteScrollComplete");
    }).finally(function() {
      parent.resize("stockSearchCtrlScroll");
    });
  };
  /**
   * @return {undefined}
   */
  self.clearSearch = function() {
    /** @type {string} */
    self.searchObj.searchKey = "";
    /** @type {string} */
    self.focused = "centered";
    self.getList();
  };
  /**
   * @return {undefined}
   */
  self.clearFilter = function() {
    /** @type {null} */
    self.goodsInfo.category = null;
    /** @type {null} */
    self.filterObj.bland = null;
    /** @type {string} */
    self.filterObj.minNumber = "";
    /** @type {string} */
    self.filterObj.maxNumber = "";
  };
  /**
   * @return {undefined}
   */
  self.scanCode = function() {
    cordova.plugins.barcodeScanner.scan(function(result) {
      if (!result.cancelled) {
        /** @type {string} */
        self.focused = "text-left";
        self.searchObj.searchKey = result.text;
        self.getList();
      }
    }, function(err) {
      console.error("Scanning failed: " + err);
      $.toastShow("二维码扫描失败！");
    });
  };
  /**
   * @return {undefined}
   */
  self.filterAction = function() {
    self.listFilterModal.hide();
    self.getList();
  };
  self.$on("$ionicView.loaded", function() {
    self.filterObj.saleDepot = results.saleDepot;
    self.goodsInfo.category = results.category;
    self.filterObj.bland = results.bland;
    self.filterObj.existsNumber = results.existsNumber;
    self.filterObj.minNumber = results.minNumber;
    self.filterObj.maxNumber = results.maxNumber;
    self.searchObj.searchKey = results.searchKey;
  });
}]);
